-- MySQL dump 10.13  Distrib 5.6.10, for linux-glibc2.5 (x86_64)
--
-- Host: localhost    Database: mysql
-- ------------------------------------------------------
-- Server version	5.6.10

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `mysql`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `mysql` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `mysql`;

--
-- Table structure for table `general_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `general_log` (
  `event_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `user_host` mediumtext NOT NULL,
  `thread_id` bigint(21) unsigned NOT NULL,
  `server_id` int(10) unsigned NOT NULL,
  `command_type` varchar(64) NOT NULL,
  `argument` mediumtext NOT NULL
) ENGINE=CSV DEFAULT CHARSET=utf8 COMMENT='General log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `slow_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `slow_log` (
  `start_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `user_host` mediumtext NOT NULL,
  `query_time` time NOT NULL,
  `lock_time` time NOT NULL,
  `rows_sent` int(11) NOT NULL,
  `rows_examined` int(11) NOT NULL,
  `db` varchar(512) NOT NULL,
  `last_insert_id` int(11) NOT NULL,
  `insert_id` int(11) NOT NULL,
  `server_id` int(10) unsigned NOT NULL,
  `sql_text` mediumtext NOT NULL,
  `thread_id` bigint(21) unsigned NOT NULL
) ENGINE=CSV DEFAULT CHARSET=utf8 COMMENT='Slow log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `columns_priv`
--

DROP TABLE IF EXISTS `columns_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `columns_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Column_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`Db`,`User`,`Table_name`,`Column_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Column privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `columns_priv`
--

LOCK TABLES `columns_priv` WRITE;
/*!40000 ALTER TABLE `columns_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `columns_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `db`
--

DROP TABLE IF EXISTS `db`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `db` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`Db`,`User`),
  KEY `User` (`User`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `db`
--

LOCK TABLES `db` WRITE;
/*!40000 ALTER TABLE `db` DISABLE KEYS */;
INSERT INTO `db` VALUES ('%','test','','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','N','N','Y','Y'),('%','test\\_%','','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','N','N','Y','Y'),('localhost','quartz','pentaho_user','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('localhost','hibernate','hibuser','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','foodmart','foodmart','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','sakila','sakila','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','sakila_dwh','sakila_dwh','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','pgn','pgn','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','chess','chess','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','test','chess','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('%','chess_dwh','chess_dwh','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y');
/*!40000 ALTER TABLE `db` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event`
--

DROP TABLE IF EXISTS `event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event` (
  `db` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `name` char(64) NOT NULL DEFAULT '',
  `body` longblob NOT NULL,
  `definer` char(77) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `execute_at` datetime DEFAULT NULL,
  `interval_value` int(11) DEFAULT NULL,
  `interval_field` enum('YEAR','QUARTER','MONTH','DAY','HOUR','MINUTE','WEEK','SECOND','MICROSECOND','YEAR_MONTH','DAY_HOUR','DAY_MINUTE','DAY_SECOND','HOUR_MINUTE','HOUR_SECOND','MINUTE_SECOND','DAY_MICROSECOND','HOUR_MICROSECOND','MINUTE_MICROSECOND','SECOND_MICROSECOND') DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_executed` datetime DEFAULT NULL,
  `starts` datetime DEFAULT NULL,
  `ends` datetime DEFAULT NULL,
  `status` enum('ENABLED','DISABLED','SLAVESIDE_DISABLED') NOT NULL DEFAULT 'ENABLED',
  `on_completion` enum('DROP','PRESERVE') NOT NULL DEFAULT 'DROP',
  `sql_mode` set('REAL_AS_FLOAT','PIPES_AS_CONCAT','ANSI_QUOTES','IGNORE_SPACE','NOT_USED','ONLY_FULL_GROUP_BY','NO_UNSIGNED_SUBTRACTION','NO_DIR_IN_CREATE','POSTGRESQL','ORACLE','MSSQL','DB2','MAXDB','NO_KEY_OPTIONS','NO_TABLE_OPTIONS','NO_FIELD_OPTIONS','MYSQL323','MYSQL40','ANSI','NO_AUTO_VALUE_ON_ZERO','NO_BACKSLASH_ESCAPES','STRICT_TRANS_TABLES','STRICT_ALL_TABLES','NO_ZERO_IN_DATE','NO_ZERO_DATE','INVALID_DATES','ERROR_FOR_DIVISION_BY_ZERO','TRADITIONAL','NO_AUTO_CREATE_USER','HIGH_NOT_PRECEDENCE','NO_ENGINE_SUBSTITUTION','PAD_CHAR_TO_FULL_LENGTH') NOT NULL DEFAULT '',
  `comment` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `originator` int(10) unsigned NOT NULL,
  `time_zone` char(64) CHARACTER SET latin1 NOT NULL DEFAULT 'SYSTEM',
  `character_set_client` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `collation_connection` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `db_collation` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `body_utf8` longblob,
  PRIMARY KEY (`db`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Events';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `event`
--

LOCK TABLES `event` WRITE;
/*!40000 ALTER TABLE `event` DISABLE KEYS */;
/*!40000 ALTER TABLE `event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `func`
--

DROP TABLE IF EXISTS `func`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `func` (
  `name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ret` tinyint(1) NOT NULL DEFAULT '0',
  `dl` char(128) COLLATE utf8_bin NOT NULL DEFAULT '',
  `type` enum('function','aggregate') CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='User defined functions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `func`
--

LOCK TABLES `func` WRITE;
/*!40000 ALTER TABLE `func` DISABLE KEYS */;
/*!40000 ALTER TABLE `func` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_category`
--

DROP TABLE IF EXISTS `help_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_category` (
  `help_category_id` smallint(5) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `parent_category_id` smallint(5) unsigned DEFAULT NULL,
  `url` char(128) NOT NULL,
  PRIMARY KEY (`help_category_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help categories';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_category`
--

LOCK TABLES `help_category` WRITE;
/*!40000 ALTER TABLE `help_category` DISABLE KEYS */;
INSERT INTO `help_category` VALUES (1,'Geographic',0,''),(2,'Polygon properties',33,''),(3,'WKT',33,''),(4,'Numeric Functions',37,''),(5,'Plugins',34,''),(6,'MBR',33,''),(7,'Control flow functions',37,''),(8,'Transactions',34,''),(9,'Help Metadata',34,''),(10,'Account Management',34,''),(11,'Point properties',33,''),(12,'Encryption Functions',37,''),(13,'LineString properties',33,''),(14,'Logical operators',37,''),(15,'Miscellaneous Functions',37,''),(16,'Functions and Modifiers for Use with GROUP BY',34,''),(17,'Information Functions',37,''),(18,'Comparison operators',37,''),(19,'Bit Functions',37,''),(20,'Table Maintenance',34,''),(21,'User-Defined Functions',34,''),(22,'Data Types',34,''),(23,'Compound Statements',34,''),(24,'Geometry constructors',33,''),(25,'GeometryCollection properties',1,''),(26,'Administration',34,''),(27,'Data Manipulation',34,''),(28,'Utility',34,''),(29,'Language Structure',34,''),(30,'Geometry relations',33,''),(31,'Date and Time Functions',37,''),(32,'WKB',33,''),(33,'Geographic Features',34,''),(34,'Contents',0,''),(35,'Geometry properties',33,''),(36,'String Functions',37,''),(37,'Functions',34,''),(38,'Data Definition',34,'');
/*!40000 ALTER TABLE `help_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_keyword`
--

DROP TABLE IF EXISTS `help_keyword`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_keyword` (
  `help_keyword_id` int(10) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  PRIMARY KEY (`help_keyword_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help keywords';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_keyword`
--

LOCK TABLES `help_keyword` WRITE;
/*!40000 ALTER TABLE `help_keyword` DISABLE KEYS */;
INSERT INTO `help_keyword` VALUES (0,'JOIN'),(1,'HOST'),(2,'REPEAT'),(3,'SERIALIZABLE'),(4,'REPLACE'),(5,'AT'),(6,'SCHEDULE'),(7,'RETURNS'),(8,'STARTS'),(9,'MASTER_SSL_CA'),(10,'NCHAR'),(11,'COLUMNS'),(12,'COMPLETION'),(13,'WORK'),(14,'DATETIME'),(15,'MODE'),(16,'OPEN'),(17,'INTEGER'),(18,'ESCAPE'),(19,'VALUE'),(20,'MASTER_SSL_VERIFY_SERVER_CERT'),(21,'SQL_BIG_RESULT'),(22,'DROP'),(23,'GEOMETRYCOLLECTIONFROMWKB'),(24,'EVENTS'),(25,'MONTH'),(26,'PROFILES'),(27,'DUPLICATE'),(28,'REPLICATION'),(29,'UNLOCK'),(30,'INNODB'),(31,'YEAR_MONTH'),(32,'SUBJECT'),(33,'PREPARE'),(34,'LOCK'),(35,'NDB'),(36,'CHECK'),(37,'FULL'),(38,'INT4'),(39,'BY'),(40,'NO'),(41,'MINUTE'),(42,'PARTITION'),(43,'DATA'),(44,'DAY'),(45,'SHARE'),(46,'REAL'),(47,'SEPARATOR'),(48,'MESSAGE_TEXT'),(49,'MASTER_HEARTBEAT_PERIOD'),(50,'DELETE'),(51,'ON'),(52,'COLUMN_NAME'),(53,'CONNECTION'),(54,'CLOSE'),(55,'X509'),(56,'USE'),(57,'SUBCLASS_ORIGIN'),(58,'WHERE'),(59,'PRIVILEGES'),(60,'SPATIAL'),(61,'EVENT'),(62,'SUPER'),(63,'SQL_BUFFER_RESULT'),(64,'IGNORE'),(65,'SHA2'),(66,'QUICK'),(67,'SIGNED'),(68,'OFFLINE'),(69,'SECURITY'),(70,'AUTOEXTEND_SIZE'),(71,'NDBCLUSTER'),(72,'POLYGONFROMWKB'),(73,'FALSE'),(74,'LEVEL'),(75,'FORCE'),(76,'BINARY'),(77,'TO'),(78,'CHANGE'),(79,'CURRENT_USER'),(80,'HOUR_MINUTE'),(81,'UPDATE'),(82,'PRESERVE'),(83,'TABLE_NAME'),(84,'INTO'),(85,'FEDERATED'),(86,'VARYING'),(87,'MAX_SIZE'),(88,'HOUR_SECOND'),(89,'VARIABLE'),(90,'ROLLBACK'),(91,'PROCEDURE'),(92,'TIMESTAMP'),(93,'IMPORT'),(94,'AGAINST'),(95,'CHECKSUM'),(96,'COUNT'),(97,'LONGBINARY'),(98,'THEN'),(99,'INSERT'),(100,'ENGINES'),(101,'HANDLER'),(102,'PORT'),(103,'DAY_SECOND'),(104,'EXISTS'),(105,'MUTEX'),(106,'HELP_DATE'),(107,'RELEASE'),(108,'BOOLEAN'),(109,'MOD'),(110,'DEFAULT'),(111,'TYPE'),(112,'NO_WRITE_TO_BINLOG'),(113,'OPTIMIZE'),(114,'SQLSTATE'),(115,'RESET'),(116,'CLASS_ORIGIN'),(117,'INSTALL'),(118,'ITERATE'),(119,'DO'),(120,'BIGINT'),(121,'SET'),(122,'ISSUER'),(123,'DATE'),(124,'STATUS'),(125,'FULLTEXT'),(126,'COMMENT'),(127,'MASTER_CONNECT_RETRY'),(128,'INNER'),(129,'RELAYLOG'),(130,'STOP'),(131,'MASTER_LOG_FILE'),(132,'MRG_MYISAM'),(133,'PRECISION'),(134,'REQUIRE'),(135,'TRAILING'),(136,'PARTITIONS'),(137,'LONG'),(138,'OPTION'),(139,'REORGANIZE'),(140,'ELSE'),(141,'DEALLOCATE'),(142,'IO_THREAD'),(143,'CASE'),(144,'CIPHER'),(145,'CONTINUE'),(146,'FROM'),(147,'READ'),(148,'LEFT'),(149,'ELSEIF'),(150,'MINUTE_SECOND'),(151,'COMPACT'),(152,'DEC'),(153,'FOR'),(154,'WARNINGS'),(155,'MIN_ROWS'),(156,'STRING'),(157,'CONDITION'),(158,'ENCLOSED'),(159,'FUNCTION'),(160,'AGGREGATE'),(161,'FIELDS'),(162,'INT3'),(163,'ARCHIVE'),(164,'AVG_ROW_LENGTH'),(165,'ADD'),(166,'KILL'),(167,'FLOAT4'),(168,'TABLESPACE'),(169,'VIEW'),(170,'REPEATABLE'),(171,'INFILE'),(172,'HELP_VERSION'),(173,'ORDER'),(174,'USING'),(175,'CONSTRAINT_CATALOG'),(176,'MIDDLEINT'),(177,'GRANT'),(178,'UNSIGNED'),(179,'DECIMAL'),(180,'GEOMETRYFROMTEXT'),(181,'INDEXES'),(182,'FOREIGN'),(183,'CACHE'),(184,'HOSTS'),(185,'MYSQL_ERRNO'),(186,'COMMIT'),(187,'SCHEMAS'),(188,'LEADING'),(189,'SNAPSHOT'),(190,'CONSTRAINT_NAME'),(191,'DECLARE'),(192,'LOAD'),(193,'SQL_CACHE'),(194,'CONVERT'),(195,'DYNAMIC'),(196,'COLLATE'),(197,'POLYGONFROMTEXT'),(198,'BYTE'),(199,'GLOBAL'),(200,'LINESTRINGFROMWKB'),(201,'WHEN'),(202,'HAVING'),(203,'AS'),(204,'STARTING'),(205,'RELOAD'),(206,'AUTOCOMMIT'),(207,'REVOKE'),(208,'GRANTS'),(209,'OUTER'),(210,'CURSOR_NAME'),(211,'FLOOR'),(212,'EXPLAIN'),(213,'WITH'),(214,'AFTER'),(215,'STD'),(216,'CSV'),(217,'DISABLE'),(218,'UNINSTALL'),(219,'OUTFILE'),(220,'LOW_PRIORITY'),(221,'FILE'),(222,'NODEGROUP'),(223,'SCHEMA'),(224,'SONAME'),(225,'POW'),(226,'DUAL'),(227,'MULTIPOINTFROMWKB'),(228,'INDEX'),(229,'MULTIPOINTFROMTEXT'),(230,'DEFINER'),(231,'MASTER_BIND'),(232,'REMOVE'),(233,'EXTENDED'),(234,'MULTILINESTRINGFROMWKB'),(235,'CROSS'),(236,'CONTRIBUTORS'),(237,'NATIONAL'),(238,'GROUP'),(239,'SHA'),(240,'ONLINE'),(241,'UNDO'),(242,'IGNORE_SERVER_IDS'),(243,'ZEROFILL'),(244,'CLIENT'),(245,'MASTER_PASSWORD'),(246,'OWNER'),(247,'RELAY_LOG_FILE'),(248,'TRUE'),(249,'CHARACTER'),(250,'MASTER_USER'),(251,'SCHEMA_NAME'),(252,'TABLE'),(253,'ENGINE'),(254,'INSERT_METHOD'),(255,'CASCADE'),(256,'RELAY_LOG_POS'),(257,'SQL_CALC_FOUND_ROWS'),(258,'UNION'),(259,'MYISAM'),(260,'LEAVE'),(261,'MODIFY'),(262,'MATCH'),(263,'MASTER_LOG_POS'),(264,'DISTINCTROW'),(265,'DESC'),(266,'TIME'),(267,'NUMERIC'),(268,'EXPANSION'),(269,'CODE'),(270,'CURSOR'),(271,'GEOMETRYCOLLECTIONFROMTEXT'),(272,'CHAIN'),(273,'LOGFILE'),(274,'FLUSH'),(275,'CREATE'),(276,'DESCRIBE'),(277,'EXTENT_SIZE'),(278,'MAX_UPDATES_PER_HOUR'),(279,'INT2'),(280,'PROCESSLIST'),(281,'ENDS'),(282,'LOGS'),(283,'DISCARD'),(284,'HEAP'),(285,'SOUNDS'),(286,'BETWEEN'),(287,'MULTILINESTRINGFROMTEXT'),(288,'REPAIR'),(289,'PACK_KEYS'),(290,'FAST'),(291,'VALUES'),(292,'CALL'),(293,'LOOP'),(294,'VARCHARACTER'),(295,'BEFORE'),(296,'TRUNCATE'),(297,'SHOW'),(298,'ALL'),(299,'REDUNDANT'),(300,'USER_RESOURCES'),(301,'PARTIAL'),(302,'BINLOG'),(303,'END'),(304,'SECOND'),(305,'AND'),(306,'FLOAT8'),(307,'PREV'),(308,'HOUR'),(309,'SELECT'),(310,'DATABASES'),(311,'OR'),(312,'IDENTIFIED'),(313,'WRAPPER'),(314,'MASTER_SSL_CIPHER'),(315,'SQL_SLAVE_SKIP_COUNTER'),(316,'BOTH'),(317,'BOOL'),(318,'YEAR'),(319,'MASTER_PORT'),(320,'CONCURRENT'),(321,'HELP'),(322,'UNIQUE'),(323,'TRIGGERS'),(324,'PROCESS'),(325,'OPTIONS'),(326,'RESIGNAL'),(327,'CONSISTENT'),(328,'MASTER_SSL'),(329,'DATE_ADD'),(330,'MAX_CONNECTIONS_PER_HOUR'),(331,'LIKE'),(332,'PLUGIN'),(333,'FETCH'),(334,'IN'),(335,'COLUMN'),(336,'DUMPFILE'),(337,'USAGE'),(338,'EXECUTE'),(339,'MEMORY'),(340,'CEIL'),(341,'QUERY'),(342,'MASTER_HOST'),(343,'LINES'),(344,'SQL_THREAD'),(345,'SERVER'),(346,'MAX_QUERIES_PER_HOUR'),(347,'MASTER_SSL_CERT'),(348,'MULTIPOLYGONFROMWKB'),(349,'TRANSACTION'),(350,'DAY_MINUTE'),(351,'STDDEV'),(352,'DATE_SUB'),(353,'REBUILD'),(354,'GEOMETRYFROMWKB'),(355,'INT1'),(356,'RENAME'),(357,'PARSER'),(358,'RIGHT'),(359,'ALTER'),(360,'MAX_ROWS'),(361,'SOCKET'),(362,'STRAIGHT_JOIN'),(363,'NATURAL'),(364,'VARIABLES'),(365,'ESCAPED'),(366,'SHA1'),(367,'KEY_BLOCK_SIZE'),(368,'PASSWORD'),(369,'OFFSET'),(370,'CHAR'),(371,'NEXT'),(372,'ERRORS'),(373,'SQL_LOG_BIN'),(374,'TEMPORARY'),(375,'COMMITTED'),(376,'SQL_SMALL_RESULT'),(377,'UPGRADE'),(378,'BEGIN'),(379,'DELAY_KEY_WRITE'),(380,'PROFILE'),(381,'MEDIUM'),(382,'INTERVAL'),(383,'SSL'),(384,'DAY_HOUR'),(385,'NAME'),(386,'REFERENCES'),(387,'AES_ENCRYPT'),(388,'STORAGE'),(389,'ISOLATION'),(390,'CEILING'),(391,'EVERY'),(392,'INT8'),(393,'AUTHORS'),(394,'RESTRICT'),(395,'UNCOMMITTED'),(396,'LINESTRINGFROMTEXT'),(397,'IS'),(398,'NOT'),(399,'ANALYSE'),(400,'DATAFILE'),(401,'DES_KEY_FILE'),(402,'SIGNAL'),(403,'COMPRESSED'),(404,'START'),(405,'PLUGINS'),(406,'SAVEPOINT'),(407,'IF'),(408,'ROWS'),(409,'PRIMARY'),(410,'PURGE'),(411,'LAST'),(412,'USER'),(413,'INNOBASE'),(414,'EXIT'),(415,'KEYS'),(416,'LIMIT'),(417,'KEY'),(418,'MERGE'),(419,'UNTIL'),(420,'SQL_NO_CACHE'),(421,'DELAYED'),(422,'CONSTRAINT_SCHEMA'),(423,'ANALYZE'),(424,'CONSTRAINT'),(425,'SERIAL'),(426,'ACTION'),(427,'WRITE'),(428,'INITIAL_SIZE'),(429,'SESSION'),(430,'DATABASE'),(431,'NULL'),(432,'POWER'),(433,'USE_FRM'),(434,'TERMINATED'),(435,'SLAVE'),(436,'NVARCHAR'),(437,'ASC'),(438,'RETURN'),(439,'OPTIONALLY'),(440,'ENABLE'),(441,'DIRECTORY'),(442,'MAX_USER_CONNECTIONS'),(443,'WHILE'),(444,'LOCAL'),(445,'DISTINCT'),(446,'AES_DECRYPT'),(447,'MASTER_SSL_KEY'),(448,'NONE'),(449,'TABLES'),(450,'<>'),(451,'RLIKE'),(452,'TRIGGER'),(453,'COLLATION'),(454,'SHUTDOWN'),(455,'HIGH_PRIORITY'),(456,'BTREE'),(457,'FIRST'),(458,'COALESCE'),(459,'WAIT'),(460,'CATALOG_NAME'),(461,'MASTER'),(462,'FIXED'),(463,'MULTIPOLYGONFROMTEXT'),(464,'ROW_FORMAT');
/*!40000 ALTER TABLE `help_keyword` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_relation`
--

DROP TABLE IF EXISTS `help_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_relation` (
  `help_topic_id` int(10) unsigned NOT NULL,
  `help_keyword_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`help_keyword_id`,`help_topic_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='keyword-topic relation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_relation`
--

LOCK TABLES `help_relation` WRITE;
/*!40000 ALTER TABLE `help_relation` DISABLE KEYS */;
INSERT INTO `help_relation` VALUES (1,0),(356,0),(473,1),(232,2),(447,3),(3,4),(130,4),(421,4),(89,5),(89,6),(406,6),(97,7),(89,8),(186,9),(430,10),(21,11),(347,11),(421,11),(463,11),(468,11),(89,12),(406,12),(146,13),(230,14),(88,15),(356,15),(18,16),(106,16),(134,16),(347,16),(97,17),(500,17),(380,18),(3,19),(104,19),(243,19),(374,19),(459,19),(186,20),(356,21),(9,22),(30,22),(34,22),(87,22),(187,22),(237,22),(263,22),(276,22),(300,22),(331,22),(405,22),(415,22),(416,22),(463,22),(478,22),(108,23),(122,24),(170,24),(424,24),(376,25),(82,26),(104,27),(199,28),(36,29),(347,30),(468,30),(376,31),(199,32),(35,33),(237,33),(36,34),(356,34),(468,35),(417,36),(463,36),(468,36),(21,37),(294,37),(347,37),(451,37),(468,37),(500,38),(48,39),(77,39),(83,39),(130,39),(199,39),(356,39),(361,39),(421,39),(463,39),(468,39),(468,40),(472,40),(376,41),(463,42),(468,42),(212,43),(421,43),(468,43),(473,43),(376,44),(356,45),(97,46),(314,46),(361,47),(374,48),(459,48),(186,49),(48,50),(468,50),(472,50),(1,51),(89,51),(406,51),(472,51),(374,52),(459,52),(176,53),(468,53),(51,54),(106,54),(199,55),(1,56),(55,56),(194,56),(374,57),(459,57),(48,58),(83,58),(106,58),(193,59),(199,59),(249,59),(210,60),(463,60),(89,61),(300,61),(358,61),(406,61),(199,62),(356,63),(1,64),(83,64),(104,64),(130,64),(356,64),(421,64),(463,64),(66,65),(48,66),(417,66),(466,66),(230,67),(87,68),(210,68),(463,68),(199,69),(194,70),(468,71),(91,72),(482,72),(385,73),(447,74),(1,75),(39,76),(230,76),(269,76),(186,77),(269,77),(460,77),(186,78),(463,78),(89,79),(406,79),(376,80),(83,81),(104,81),(356,81),(472,81),(89,82),(406,82),(374,83),(459,83),(3,84),(104,84),(304,84),(356,84),(468,85),(257,86),(194,87),(376,88),(129,89),(146,90),(460,90),(17,91),(185,91),(302,91),(328,91),(347,91),(356,91),(416,91),(439,91),(488,91),(99,92),(189,92),(421,93),(463,93),(88,94),(401,95),(468,95),(69,96),(330,96),(433,96),(285,97),(28,98),(57,98),(85,98),(104,99),(195,99),(301,99),(486,99),(282,100),(347,100),(106,101),(313,101),(473,102),(376,103),(9,104),(30,104),(89,104),(155,104),(187,104),(276,104),(300,104),(347,105),(365,105),(109,106),(146,107),(460,107),(24,108),(88,108),(113,109),(175,109),(3,110),(104,110),(155,110),(200,110),(212,110),(243,110),(463,110),(468,110),(463,111),(115,112),(326,112),(466,112),(470,112),(115,113),(463,113),(374,114),(459,114),(38,115),(119,115),(151,115),(264,115),(374,116),(459,116),(419,117),(124,118),(89,119),(125,119),(406,119),(496,119),(221,120),(3,121),(83,121),(104,121),(129,121),(130,121),(146,121),(155,121),(182,121),(212,121),(333,121),(347,121),(356,121),(374,121),(421,121),(459,121),(463,121),(468,121),(472,121),(477,121),(494,121),(199,122),(132,123),(230,123),(262,123),(376,123),(58,124),(137,124),(215,124),(223,124),(328,124),(336,124),(347,124),(365,124),(210,125),(463,125),(468,125),(89,126),(194,126),(210,126),(406,126),(468,126),(186,127),(1,128),(424,129),(52,130),(186,131),(468,132),(314,133),(199,134),(455,135),(255,136),(285,137),(199,138),(249,138),(463,139),(57,140),(85,140),(237,141),(52,142),(324,142),(57,143),(85,143),(199,144),(313,145),(48,146),(122,146),(347,146),(356,146),(424,146),(455,146),(36,147),(106,147),(447,147),(1,148),(28,149),(376,150),(468,151),(209,152),(180,153),(313,153),(347,153),(356,153),(420,153),(330,154),(347,154),(468,155),(97,156),(180,157),(421,158),(34,159),(68,159),(97,159),(211,159),(233,159),(302,159),(336,159),(347,159),(393,159),(405,159),(416,159),(97,160),(347,161),(421,161),(252,162),(468,163),(463,164),(468,164),(60,165),(194,165),(463,165),(478,165),(176,166),(168,167),(194,168),(415,168),(463,168),(478,168),(30,169),(159,169),(454,169),(447,170),(130,171),(421,171),(190,172),(48,173),(83,173),(356,173),(361,173),(463,173),(1,174),(48,174),(86,174),(374,175),(459,175),(252,176),(199,177),(249,177),(24,178),(128,178),(168,178),(209,178),(230,178),(314,178),(500,178),(97,179),(156,179),(230,179),(411,180),(347,181),(463,182),(468,182),(472,182),(473,182),(101,183),(151,183),(304,183),(145,184),(347,184),(374,185),(459,185),(146,186),(160,187),(347,187),(455,188),(146,189),(374,190),(459,190),(180,191),(200,191),(313,191),(420,191),(304,192),(421,192),(356,193),(230,194),(377,194),(468,195),(155,196),(212,196),(468,196),(395,197),(465,198),(129,199),(137,199),(182,199),(349,199),(447,199),(452,200),(57,201),(85,201),(356,202),(1,203),(36,203),(356,203),(421,204),(199,205),(146,206),(249,207),(192,208),(347,208),(1,209),(374,210),(459,210),(221,211),(255,212),(88,213),(199,213),(210,213),(463,213),(468,213),(463,214),(260,215),(421,216),(468,216),(89,217),(406,217),(463,217),(291,218),(356,219),(3,220),(36,220),(48,220),(83,220),(104,220),(130,220),(421,220),(199,221),(194,222),(155,223),(187,223),(212,223),(309,223),(347,223),(97,224),(277,225),(279,226),(464,227),(1,228),(60,228),(87,228),(101,228),(210,228),(304,228),(308,228),(347,228),(463,228),(468,228),(425,229),(89,230),(406,230),(186,231),(463,232),(255,233),(466,233),(272,234),(1,235),(7,236),(347,236),(257,237),(430,237),(194,238),(226,238),(356,238),(427,239),(87,240),(210,240),(463,240),(313,241),(186,242),(24,243),(128,243),(168,243),(209,243),(314,243),(500,243),(199,244),(186,245),(473,246),(186,247),(385,248),(130,249),(155,249),(212,249),(257,249),(333,249),(347,249),(356,249),(421,249),(430,249),(468,249),(186,250),(374,251),(459,251),(60,252),(110,252),(115,252),(215,252),(276,252),(278,252),(321,252),(347,252),(401,252),(417,252),(463,252),(466,252),(468,252),(470,252),(194,253),(347,253),(365,253),(415,253),(463,253),(468,253),(478,253),(468,254),(30,255),(276,255),(468,255),(472,255),(186,256),(356,257),(305,258),(468,259),(310,260),(463,261),(88,262),(186,263),(356,264),(329,265),(356,265),(361,265),(230,266),(315,266),(375,266),(209,267),(88,268),(68,269),(488,269),(420,270),(246,271),(146,272),(194,273),(226,273),(151,274),(326,274),(17,275),(22,275),(60,275),(77,275),(89,275),(97,275),(155,275),(194,275),(210,275),(211,275),(278,275),(302,275),(309,275),(347,275),(358,275),(393,275),(454,275),(468,275),(473,275),(329,276),(194,277),(199,278),(234,279),(347,280),(451,280),(89,281),(39,282),(269,282),(347,282),(463,283),(468,284),(378,285),(147,286),(107,287),(463,288),(466,288),(468,289),(417,290),(3,291),(104,291),(339,292),(344,293),(257,294),(269,295),(321,296),(463,296),(7,297),(10,297),(17,297),(21,297),(25,297),(33,297),(39,297),(58,297),(68,297),(69,297),(82,297),(122,297),(134,297),(137,297),(145,297),(160,297),(170,297),(192,297),(193,297),(215,297),(223,297),(278,297),(282,297),(294,297),(308,297),(309,297),(328,297),(330,297),(333,297),(336,297),(347,297),(349,297),(358,297),(365,297),(393,297),(424,297),(451,297),(487,297),(488,297),(492,297),(38,298),(199,298),(249,298),(305,298),(356,298),(468,299),(326,300),(468,301),(122,302),(350,302),(28,303),(57,303),(85,303),(232,303),(327,303),(344,303),(496,303),(376,304),(147,305),(316,305),(314,306),(106,307),(376,308),(3,309),(104,309),(255,309),(301,309),(356,309),(160,310),(347,310),(141,311),(77,312),(130,312),(199,312),(473,313),(186,314),(182,315),(455,316),(24,317),(111,317),(376,318),(186,319),(130,320),(421,320),(118,321),(390,321),(463,322),(25,323),(347,323),(199,324),(373,325),(473,325),(374,326),(146,327),(186,328),(376,329),(199,330),(347,331),(378,331),(291,332),(347,332),(419,332),(383,333),(88,334),(122,334),(356,334),(424,334),(463,335),(356,336),(199,337),(86,338),(199,338),(356,339),(397,340),(88,341),(151,341),(176,341),(186,342),(130,343),(421,343),(52,344),(324,344),(9,345),(373,345),(473,345),(199,346),(186,347),(123,348),(146,349),(447,349),(376,350),(407,351),(376,352),(463,353),(144,354),(24,355),(110,356),(222,356),(406,356),(463,356),(210,357),(463,357),(468,357),(1,358),(60,359),(159,359),(199,359),(212,359),(226,359),(233,359),(373,359),(406,359),(439,359),(463,359),(478,359),(468,360),(473,361),(1,362),(356,362),(1,363),(347,364),(349,364),(421,365),(427,366),(468,367),(77,368),(199,368),(473,368),(477,368),(356,369),(230,370),(465,370),(106,371),(69,372),(347,372),(494,373),(276,374),(447,375),(356,376),(212,377),(417,377),(146,378),(327,378),(468,379),(487,380),(417,381),(89,382),(376,382),(199,383),(376,384),(212,385),(199,386),(468,386),(472,386),(443,387),(282,388),(447,389),(448,390),(89,391),(128,392),(10,393),(347,393),(30,394),(276,394),(472,394),(447,395),(56,396),(84,397),(206,397),(368,397),(456,397),(84,398),(89,398),(155,398),(206,398),(312,398),(185,399),(194,400),(478,400),(326,401),(459,402),(468,403),(146,404),(324,404),(33,405),(460,406),(9,407),(28,407),(30,407),(89,407),(155,407),(187,407),(276,407),(300,407),(479,407),(130,408),(463,409),(269,410),(106,411),(77,412),(222,412),(331,412),(473,412),(468,413),(313,414),(308,415),(347,415),(463,415),(48,416),(83,416),(106,416),(122,416),(356,416),(424,416),(60,417),(104,417),(463,417),(468,417),(472,417),(468,418),(232,419),(356,420),(3,421),(104,421),(486,421),(374,422),(459,422),(463,423),(470,423),(463,424),(468,424),(243,425),(468,425),(468,426),(472,426),(36,427),(194,428),(478,428),(129,429),(137,429),(349,429),(447,429),(155,430),(187,430),(212,430),(309,430),(347,430),(473,430),(84,431),(368,431),(472,431),(483,432),(466,433),(421,434),(38,435),(52,435),(89,435),(145,435),(223,435),(324,435),(406,435),(257,436),(356,437),(361,437),(491,438),(421,439),(89,440),(406,440),(463,440),(212,441),(468,441),(199,442),(496,443),(36,444),(115,444),(130,444),(326,444),(421,444),(466,444),(470,444),(0,445),(96,445),(288,445),(305,445),(356,445),(361,445),(384,445),(433,445),(497,446),(186,447),(199,448),(36,449),(134,449),(294,449),(347,449),(495,450),(27,451),(22,452),(263,452),(347,452),(347,453),(492,453),(199,454),(104,455),(356,455),(210,456),(106,457),(463,457),(468,457),(463,458),(194,459),(478,459),(374,460),(459,460),(39,461),(58,461),(186,461),(264,461),(269,461),(209,462),(468,462),(201,463),(468,464);
/*!40000 ALTER TABLE `help_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_topic`
--

DROP TABLE IF EXISTS `help_topic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_topic` (
  `help_topic_id` int(10) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `help_category_id` smallint(5) unsigned NOT NULL,
  `description` text NOT NULL,
  `example` text NOT NULL,
  `url` char(128) NOT NULL,
  PRIMARY KEY (`help_topic_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help topics';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_topic`
--

LOCK TABLES `help_topic` WRITE;
/*!40000 ALTER TABLE `help_topic` DISABLE KEYS */;
INSERT INTO `help_topic` VALUES (0,'MIN',16,'Syntax:\nMIN([DISTINCT] expr)\n\nReturns the minimum value of expr. MIN() may take a string argument; in\nsuch cases, it returns the minimum string value. See\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-indexes.html. The DISTINCT\nkeyword can be used to find the minimum of the distinct values of expr,\nhowever, this produces the same result as omitting DISTINCT.\n\nMIN() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','mysql> SELECT student_name, MIN(test_score), MAX(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(1,'JOIN',27,'MySQL supports the following JOIN syntaxes for the table_references\npart of SELECT statements and multiple-table DELETE and UPDATE\nstatements:\n\ntable_references:\n    table_reference [, table_reference] ...\n\ntable_reference:\n    table_factor\n  | join_table\n\ntable_factor:\n    tbl_name [[AS] alias] [index_hint_list]\n  | table_subquery [AS] alias\n  | ( table_references )\n  | { OJ table_reference LEFT OUTER JOIN table_reference\n        ON conditional_expr }\n\njoin_table:\n    table_reference [INNER | CROSS] JOIN table_factor [join_condition]\n  | table_reference STRAIGHT_JOIN table_factor\n  | table_reference STRAIGHT_JOIN table_factor ON conditional_expr\n  | table_reference {LEFT|RIGHT} [OUTER] JOIN table_reference join_condition\n  | table_reference NATURAL [{LEFT|RIGHT} [OUTER]] JOIN table_factor\n\njoin_condition:\n    ON conditional_expr\n  | USING (column_list)\n\nindex_hint_list:\n    index_hint [, index_hint] ...\n\nindex_hint:\n    USE {INDEX|KEY}\n      [{FOR {JOIN|ORDER BY|GROUP BY}] ([index_list])\n  | IGNORE {INDEX|KEY}\n      [{FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n  | FORCE {INDEX|KEY}\n      [{FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n\nindex_list:\n    index_name [, index_name] ...\n\nA table reference is also known as a join expression.\n\nThe syntax of table_factor is extended in comparison with the SQL\nStandard. The latter accepts only table_reference, not a list of them\ninside a pair of parentheses.\n\nThis is a conservative extension if we consider each comma in a list of\ntable_reference items as equivalent to an inner join. For example:\n\nSELECT * FROM t1 LEFT JOIN (t2, t3, t4)\n                 ON (t2.a=t1.a AND t3.b=t1.b AND t4.c=t1.c)\n\nis equivalent to:\n\nSELECT * FROM t1 LEFT JOIN (t2 CROSS JOIN t3 CROSS JOIN t4)\n                 ON (t2.a=t1.a AND t3.b=t1.b AND t4.c=t1.c)\n\nIn MySQL, CROSS JOIN is a syntactic equivalent to INNER JOIN (they can\nreplace each other). In standard SQL, they are not equivalent. INNER\nJOIN is used with an ON clause, CROSS JOIN is used otherwise.\n\nIn general, parentheses can be ignored in join expressions containing\nonly inner join operations. MySQL also supports nested joins (see\nhttp://dev.mysql.com/doc/refman/5.5/en/nested-join-optimization.html).\n\nIndex hints can be specified to affect how the MySQL optimizer makes\nuse of indexes. For more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/index-hints.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/join.html\n\n','SELECT left_tbl.*\n  FROM left_tbl LEFT JOIN right_tbl ON left_tbl.id = right_tbl.id\n  WHERE right_tbl.id IS NULL;\n','http://dev.mysql.com/doc/refman/5.5/en/join.html'),(2,'HEX',36,'Syntax:\nHEX(str), HEX(N)\n\nFor a string argument str, HEX() returns a hexadecimal string\nrepresentation of str where each character in str is converted to two\nhexadecimal digits. The inverse of this operation is performed by the\nUNHEX() function.\n\nFor a numeric argument N, HEX() returns a hexadecimal string\nrepresentation of the value of N treated as a longlong (BIGINT) number.\nThis is equivalent to CONV(N,10,16). The inverse of this operation is\nperformed by CONV(HEX(N),16,10).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT 0x616263, HEX(\'abc\'), UNHEX(HEX(\'abc\'));\n        -> \'abc\', 616263, \'abc\'\nmysql> SELECT HEX(255), CONV(HEX(255),16,10);\n        -> \'FF\', 255\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(3,'REPLACE',27,'Syntax:\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name [(col_name,...)]\n    {VALUES | VALUE} ({expr | DEFAULT},...),(...),...\n\nOr:\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name\n    SET col_name={expr | DEFAULT}, ...\n\nOr:\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n\nREPLACE works exactly like INSERT, except that if an old row in the\ntable has the same value as a new row for a PRIMARY KEY or a UNIQUE\nindex, the old row is deleted before the new row is inserted. See [HELP\nINSERT].\n\nREPLACE is a MySQL extension to the SQL standard. It either inserts, or\ndeletes and inserts. For another MySQL extension to standard SQL---that\neither inserts or updates---see\nhttp://dev.mysql.com/doc/refman/5.5/en/insert-on-duplicate.html.\n\nNote that unless the table has a PRIMARY KEY or UNIQUE index, using a\nREPLACE statement makes no sense. It becomes equivalent to INSERT,\nbecause there is no index to be used to determine whether a new row\nduplicates another.\n\nValues for all columns are taken from the values specified in the\nREPLACE statement. Any missing columns are set to their default values,\njust as happens for INSERT. You cannot refer to values from the current\nrow and use them in the new row. If you use an assignment such as SET\ncol_name = col_name + 1, the reference to the column name on the right\nhand side is treated as DEFAULT(col_name), so the assignment is\nequivalent to SET col_name = DEFAULT(col_name) + 1.\n\nTo use REPLACE, you must have both the INSERT and DELETE privileges for\nthe table.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/replace.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/replace.html'),(4,'CONTAINS',30,'Contains(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 completely contains g2. This\ntests the opposite relationship as Within().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(5,'SRID',35,'SRID(g)\n\nReturns an integer indicating the Spatial Reference System ID for the\ngeometry value g.\n\nIn MySQL, the SRID value is just an integer associated with the\ngeometry value. All calculations are done assuming Euclidean (planar)\ngeometry.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT SRID(GeomFromText(\'LineString(1 1,2 2)\',101));\n+-----------------------------------------------+\n| SRID(GeomFromText(\'LineString(1 1,2 2)\',101)) |\n+-----------------------------------------------+\n|                                           101 |\n+-----------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(6,'CURRENT_TIMESTAMP',31,'Syntax:\nCURRENT_TIMESTAMP, CURRENT_TIMESTAMP()\n\nCURRENT_TIMESTAMP and CURRENT_TIMESTAMP() are synonyms for NOW().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(7,'SHOW CONTRIBUTORS',26,'Syntax:\nSHOW CONTRIBUTORS\n\nThe SHOW CONTRIBUTORS statement displays information about the people\nwho contribute to MySQL source or to causes that we support. For each\ncontributor, it displays Name, Location, and Comment values.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-contributors.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-contributors.html'),(8,'VARIANCE',16,'Syntax:\nVARIANCE(expr)\n\nReturns the population standard variance of expr. This is an extension\nto standard SQL. The standard SQL function VAR_POP() can be used\ninstead.\n\nVARIANCE() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(9,'DROP SERVER',38,'Syntax:\nDROP SERVER [ IF EXISTS ] server_name\n\nDrops the server definition for the server named server_name. The\ncorresponding row within the mysql.servers table will be deleted. This\nstatement requires the SUPER privilege.\n\nDropping a server for a table does not affect any FEDERATED tables that\nused this connection information when they were created. See [HELP\nCREATE SERVER].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-server.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-server.html'),(10,'SHOW AUTHORS',26,'Syntax:\nSHOW AUTHORS\n\nThe SHOW AUTHORS statement displays information about the people who\nwork on MySQL. For each author, it displays Name, Location, and Comment\nvalues.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-authors.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-authors.html'),(11,'VAR_SAMP',16,'Syntax:\nVAR_SAMP(expr)\n\nReturns the sample variance of expr. That is, the denominator is the\nnumber of rows minus one.\n\nVAR_SAMP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(12,'CONCAT',36,'Syntax:\nCONCAT(str1,str2,...)\n\nReturns the string that results from concatenating the arguments. May\nhave one or more arguments. If all arguments are nonbinary strings, the\nresult is a nonbinary string. If the arguments include any binary\nstrings, the result is a binary string. A numeric argument is converted\nto its equivalent binary string form; if you want to avoid that, you\ncan use an explicit type cast, as in this example:\n\nSELECT CONCAT(CAST(int_col AS CHAR), char_col);\n\nCONCAT() returns NULL if any argument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT CONCAT(\'My\', \'S\', \'QL\');\n        -> \'MySQL\'\nmysql> SELECT CONCAT(\'My\', NULL, \'QL\');\n        -> NULL\nmysql> SELECT CONCAT(14.3);\n        -> \'14.3\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(13,'GEOMETRY HIERARCHY',33,'Geometry is the base class. It is an abstract class. The instantiable\nsubclasses of Geometry are restricted to zero-, one-, and\ntwo-dimensional geometric objects that exist in two-dimensional\ncoordinate space. All instantiable geometry classes are defined so that\nvalid instances of a geometry class are topologically closed (that is,\nall defined geometries include their boundary).\n\nThe base Geometry class has subclasses for Point, Curve, Surface, and\nGeometryCollection:\n\no Point represents zero-dimensional objects.\n\no Curve represents one-dimensional objects, and has subclass\n  LineString, with sub-subclasses Line and LinearRing.\n\no Surface is designed for two-dimensional objects and has subclass\n  Polygon.\n\no GeometryCollection has specialized zero-, one-, and two-dimensional\n  collection classes named MultiPoint, MultiLineString, and\n  MultiPolygon for modeling geometries corresponding to collections of\n  Points, LineStrings, and Polygons, respectively. MultiCurve and\n  MultiSurface are introduced as abstract superclasses that generalize\n  the collection interfaces to handle Curves and Surfaces.\n\nGeometry, Curve, Surface, MultiCurve, and MultiSurface are defined as\nnoninstantiable classes. They define a common set of methods for their\nsubclasses and are included for extensibility.\n\nPoint, LineString, Polygon, GeometryCollection, MultiPoint,\nMultiLineString, and MultiPolygon are instantiable classes.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/gis-geometry-class-hierarchy.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/gis-geometry-class-hierarchy.html'),(14,'CHAR FUNCTION',36,'Syntax:\nCHAR(N,... [USING charset_name])\n\nCHAR() interprets each argument N as an integer and returns a string\nconsisting of the characters given by the code values of those\nintegers. NULL values are skipped.\nBy default, CHAR() returns a binary string. To produce a string in a\ngiven character set, use the optional USING clause:\n\nmysql> SELECT CHARSET(CHAR(0x65)), CHARSET(CHAR(0x65 USING utf8));\n+---------------------+--------------------------------+\n| CHARSET(CHAR(0x65)) | CHARSET(CHAR(0x65 USING utf8)) |\n+---------------------+--------------------------------+\n| binary              | utf8                           |\n+---------------------+--------------------------------+\n\nIf USING is given and the result string is illegal for the given\ncharacter set, a warning is issued. Also, if strict SQL mode is\nenabled, the result from CHAR() becomes NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT CHAR(77,121,83,81,\'76\');\n        -> \'MySQL\'\nmysql> SELECT CHAR(77,77.3,\'77.3\');\n        -> \'MMM\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(15,'DATETIME',22,'DATETIME\n\nA date and time combination. The supported range is \'1000-01-01\n00:00:00\' to \'9999-12-31 23:59:59\'. MySQL displays DATETIME values in\n\'YYYY-MM-DD HH:MM:SS\' format, but permits assignment of values to\nDATETIME columns using either strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html'),(16,'SHOW CREATE TRIGGER',26,'Syntax:\nSHOW CREATE TRIGGER trigger_name\n\nThis statement shows a CREATE TRIGGER statement that creates the given\ntrigger.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-trigger.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-create-trigger.html'),(17,'SHOW CREATE PROCEDURE',26,'Syntax:\nSHOW CREATE PROCEDURE proc_name\n\nThis statement is a MySQL extension. It returns the exact string that\ncan be used to re-create the named stored procedure. A similar\nstatement, SHOW CREATE FUNCTION, displays information about stored\nfunctions (see [HELP SHOW CREATE FUNCTION]).\n\nBoth statements require that you be the owner of the routine or have\nSELECT access to the mysql.proc table. If you do not have privileges\nfor the routine itself, the value displayed for the Create Procedure or\nCreate Function field will be NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-procedure.html\n\n','mysql> SHOW CREATE PROCEDURE test.simpleproc\\G\n*************************** 1. row ***************************\n           Procedure: simpleproc\n            sql_mode:\n    Create Procedure: CREATE PROCEDURE `simpleproc`(OUT param1 INT)\n                      BEGIN\n                      SELECT COUNT(*) INTO param1 FROM t;\n                      END\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\nmysql> SHOW CREATE FUNCTION test.hello\\G\n*************************** 1. row ***************************\n            Function: hello\n            sql_mode:\n     Create Function: CREATE FUNCTION `hello`(s CHAR(20))\n                      RETURNS CHAR(50)\n                      RETURN CONCAT(\'Hello, \',s,\'!\')\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','http://dev.mysql.com/doc/refman/5.5/en/show-create-procedure.html'),(18,'OPEN',23,'Syntax:\nOPEN cursor_name\n\nThis statement opens a previously declared cursor. For an example, see\nhttp://dev.mysql.com/doc/refman/5.5/en/cursors.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/open.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/open.html'),(19,'INTEGER',22,'INTEGER[(M)] [UNSIGNED] [ZEROFILL]\n\nThis type is a synonym for INT.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(20,'LOWER',36,'Syntax:\nLOWER(str)\n\nReturns the string str with all characters changed to lowercase\naccording to the current character set mapping. The default is latin1\n(cp1252 West European).\n\nmysql> SELECT LOWER(\'QUADRATICALLY\');\n        -> \'quadratically\'\n\nLOWER() (and UPPER()) are ineffective when applied to binary strings\n(BINARY, VARBINARY, BLOB). To perform lettercase conversion, convert\nthe string to a nonbinary string:\n\nmysql> SET @str = BINARY \'New York\';\nmysql> SELECT LOWER(@str), LOWER(CONVERT(@str USING latin1));\n+-------------+-----------------------------------+\n| LOWER(@str) | LOWER(CONVERT(@str USING latin1)) |\n+-------------+-----------------------------------+\n| New York    | new york                          |\n+-------------+-----------------------------------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(21,'SHOW COLUMNS',26,'Syntax:\nSHOW [FULL] COLUMNS {FROM | IN} tbl_name [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW COLUMNS displays information about the columns in a given table.\nIt also works for views. The LIKE clause, if present, indicates which\ncolumn names to match. The WHERE clause can be given to select rows\nusing more general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nSHOW COLUMNS displays information only for those columns for which you\nhave some privilege.\n\nmysql> SHOW COLUMNS FROM City;\n+------------+----------+------+-----+---------+----------------+\n| Field      | Type     | Null | Key | Default | Extra          |\n+------------+----------+------+-----+---------+----------------+\n| Id         | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name       | char(35) | NO   |     |         |                |\n| Country    | char(3)  | NO   | UNI |         |                |\n| District   | char(20) | YES  | MUL |         |                |\n| Population | int(11)  | NO   |     | 0       |                |\n+------------+----------+------+-----+---------+----------------+\n5 rows in set (0.00 sec)\n\nIf the data types differ from what you expect them to be based on a\nCREATE TABLE statement, note that MySQL sometimes changes data types\nwhen you create or alter a table. The conditions under which this\noccurs are described in\nhttp://dev.mysql.com/doc/refman/5.5/en/silent-column-changes.html.\n\nThe FULL keyword causes the output to include the column collation and\ncomments, as well as the privileges you have for each column.\n\nYou can use db_name.tbl_name as an alternative to the tbl_name FROM\ndb_name syntax. In other words, these two statements are equivalent:\n\nmysql> SHOW COLUMNS FROM mytable FROM mydb;\nmysql> SHOW COLUMNS FROM mydb.mytable;\n\nSHOW COLUMNS displays the following values for each table column:\n\nField indicates the column name.\n\nType indicates the column data type.\n\nCollation indicates the collation for nonbinary string columns, or NULL\nfor other columns. This value is displayed only if you use the FULL\nkeyword.\n\nThe Null field contains YES if NULL values can be stored in the column,\nNO if not.\n\nThe Key field indicates whether the column is indexed:\n\no If Key is empty, the column either is not indexed or is indexed only\n  as a secondary column in a multiple-column, nonunique index.\n\no If Key is PRI, the column is a PRIMARY KEY or is one of the columns\n  in a multiple-column PRIMARY KEY.\n\no If Key is UNI, the column is the first column of a UNIQUE index. (A\n  UNIQUE index permits multiple NULL values, but you can tell whether\n  the column permits NULL by checking the Null field.)\n\no If Key is MUL, the column is the first column of a nonunique index in\n  which multiple occurrences of a given value are permitted within the\n  column.\n\nIf more than one of the Key values applies to a given column of a\ntable, Key displays the one with the highest priority, in the order\nPRI, UNI, MUL.\n\nA UNIQUE index may be displayed as PRI if it cannot contain NULL values\nand there is no PRIMARY KEY in the table. A UNIQUE index may display as\nMUL if several columns form a composite UNIQUE index; although the\ncombination of the columns is unique, each column can still hold\nmultiple occurrences of a given value.\n\nThe Default field indicates the default value that is assigned to the\ncolumn.\n\nThe Extra field contains any additional information that is available\nabout a given column. The value is auto_increment if the column was\ncreated with the AUTO_INCREMENT keyword and empty otherwise.\n\nPrivileges indicates the privileges you have for the column. This value\nis displayed only if you use the FULL keyword.\n\nComment indicates any comment the column has. This value is displayed\nonly if you use the FULL keyword.\n\nSHOW FIELDS is a synonym for SHOW COLUMNS. You can also list a table\'s\ncolumns with the mysqlshow db_name tbl_name command.\n\nThe DESCRIBE statement provides information similar to SHOW COLUMNS.\nSee [HELP DESCRIBE].\n\nThe SHOW CREATE TABLE, SHOW TABLE STATUS, and SHOW INDEX statements\nalso provide information about tables. See [HELP SHOW].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-columns.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-columns.html'),(22,'CREATE TRIGGER',38,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    TRIGGER trigger_name trigger_time trigger_event\n    ON tbl_name FOR EACH ROW trigger_body\n\nThis statement creates a new trigger. A trigger is a named database\nobject that is associated with a table, and that activates when a\nparticular event occurs for the table. The trigger becomes associated\nwith the table named tbl_name, which must refer to a permanent table.\nYou cannot associate a trigger with a TEMPORARY table or a view.\n\nCREATE TRIGGER requires the TRIGGER privilege for the table associated\nwith the trigger. The statement might also require the SUPER privilege,\ndepending on the DEFINER value, as described later in this section. If\nbinary logging is enabled, CREATE TRIGGER might require the SUPER\nprivilege, as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-logging.html.\n\nThe DEFINER clause determines the security context to be used when\nchecking access privileges at trigger activation time. See later in\nthis section for more information.\n\ntrigger_time is the trigger action time. It can be BEFORE or AFTER to\nindicate that the trigger activates before or after each row to be\nmodified.\n\ntrigger_event indicates the kind of statement that activates the\ntrigger. The trigger_event can be one of the following:\n\no INSERT: The trigger is activated whenever a new row is inserted into\n  the table; for example, through INSERT, LOAD DATA, and REPLACE\n  statements.\n\no UPDATE: The trigger is activated whenever a row is modified; for\n  example, through UPDATE statements.\n\no DELETE: The trigger is activated whenever a row is deleted from the\n  table; for example, through DELETE and REPLACE statements. However,\n  DROP TABLE and TRUNCATE TABLE statements on the table do not activate\n  this trigger, because they do not use DELETE. Dropping a partition\n  does not activate DELETE triggers, either. See [HELP TRUNCATE TABLE].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-trigger.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-trigger.html'),(23,'MONTH',31,'Syntax:\nMONTH(date)\n\nReturns the month for date, in the range 1 to 12 for January to\nDecember, or 0 for dates such as \'0000-00-00\' or \'2008-00-00\' that have\na zero month part.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT MONTH(\'2008-02-03\');\n        -> 2\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(24,'TINYINT',22,'TINYINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA very small integer. The signed range is -128 to 127. The unsigned\nrange is 0 to 255.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(25,'SHOW TRIGGERS',26,'Syntax:\nSHOW TRIGGERS [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TRIGGERS lists the triggers currently defined for tables in a\ndatabase (the default database unless a FROM clause is given). This\nstatement returns results only for databases and tables for which you\nhave the TRIGGER privilege. The LIKE clause, if present, indicates\nwhich table names to match and causes the statement to display triggers\nfor those tables. The WHERE clause can be given to select rows using\nmore general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nFor the trigger ins_sum as defined in\nhttp://dev.mysql.com/doc/refman/5.5/en/triggers.html, the output of\nthis statement is as shown here:\n\nmysql> SHOW TRIGGERS LIKE \'acc%\'\\G\n*************************** 1. row ***************************\n             Trigger: ins_sum\n               Event: INSERT\n               Table: account\n           Statement: SET @sum = @sum + NEW.amount\n              Timing: BEFORE\n             Created: NULL\n            sql_mode:\n             Definer: myname@localhost\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\ncharacter_set_client is the session value of the character_set_client\nsystem variable when the trigger was created. collation_connection is\nthe session value of the collation_connection system variable when the\ntrigger was created. Database Collation is the collation of the\ndatabase with which the trigger is associated.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-triggers.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-triggers.html'),(26,'MASTER_POS_WAIT',15,'Syntax:\nMASTER_POS_WAIT(log_name,log_pos[,timeout])\n\nThis function is useful for control of master/slave synchronization. It\nblocks until the slave has read and applied all updates up to the\nspecified position in the master log. The return value is the number of\nlog events the slave had to wait for to advance to the specified\nposition. The function returns NULL if the slave SQL thread is not\nstarted, the slave\'s master information is not initialized, the\narguments are incorrect, or an error occurs. It returns -1 if the\ntimeout has been exceeded. If the slave SQL thread stops while\nMASTER_POS_WAIT() is waiting, the function returns NULL. If the slave\nis past the specified position, the function returns immediately.\n\nIf a timeout value is specified, MASTER_POS_WAIT() stops waiting when\ntimeout seconds have elapsed. timeout must be greater than 0; a zero or\nnegative timeout means no timeout.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(27,'REGEXP',36,'Syntax:\nexpr REGEXP pat, expr RLIKE pat\n\nPerforms a pattern match of a string expression expr against a pattern\npat. The pattern can be an extended regular expression. The syntax for\nregular expressions is discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/regexp.html. Returns 1 if expr\nmatches pat; otherwise it returns 0. If either expr or pat is NULL, the\nresult is NULL. RLIKE is a synonym for REGEXP, provided for mSQL\ncompatibility.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column.\n\n*Note*: Because MySQL uses the C escape syntax in strings (for example,\n\"\\n\" to represent the newline character), you must double any \"\\\" that\nyou use in your REGEXP strings.\n\nREGEXP is not case sensitive, except when used with binary strings.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/regexp.html\n\n','mysql> SELECT \'Monty!\' REGEXP \'.*\';\n        -> 1\nmysql> SELECT \'new*\\n*line\' REGEXP \'new\\\\*.\\\\*line\';\n        -> 1\nmysql> SELECT \'a\' REGEXP \'A\', \'a\' REGEXP BINARY \'A\';\n        -> 1  0\nmysql> SELECT \'a\' REGEXP \'^[a-d]\';\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/regexp.html'),(28,'IF STATEMENT',23,'Syntax:\nIF search_condition THEN statement_list\n    [ELSEIF search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND IF\n\nThe IF statement for stored programs implements a basic conditional\nconstruct.\n\n*Note*: There is also an IF() function, which differs from the IF\nstatement described here. See\nhttp://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html. The\nIF statement can have THEN, ELSE, and ELSEIF clauses, and it is\nterminated with END IF.\n\nIf the search_condition evaluates to true, the corresponding THEN or\nELSEIF clause statement_list executes. If no search_condition matches,\nthe ELSE clause statement_list executes.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/if-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/if-statement.html'),(29,'^',19,'Syntax:\n^\n\nBitwise XOR:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT 1 ^ 1;\n        -> 0\nmysql> SELECT 1 ^ 0;\n        -> 1\nmysql> SELECT 11 ^ 3;\n        -> 8\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(30,'DROP VIEW',38,'Syntax:\nDROP VIEW [IF EXISTS]\n    view_name [, view_name] ...\n    [RESTRICT | CASCADE]\n\nDROP VIEW removes one or more views. You must have the DROP privilege\nfor each view. If any of the views named in the argument list do not\nexist, MySQL returns an error indicating by name which nonexisting\nviews it was unable to drop, but it also drops all of the views in the\nlist that do exist.\n\nThe IF EXISTS clause prevents an error from occurring for views that\ndon\'t exist. When this clause is given, a NOTE is generated for each\nnonexistent view. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE, if given, are parsed and ignored.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-view.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-view.html'),(31,'WITHIN',30,'Within(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially within g2. This\ntests the opposite relationship as Contains().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(32,'WEEK',31,'Syntax:\nWEEK(date[,mode])\n\nThis function returns the week number for date. The two-argument form\nof WEEK() enables you to specify whether the week starts on Sunday or\nMonday and whether the return value should be in the range from 0 to 53\nor from 1 to 53. If the mode argument is omitted, the value of the\ndefault_week_format system variable is used. See\nhttp://dev.mysql.com/doc/refman/5.5/en/server-system-variables.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT WEEK(\'2008-02-20\');\n        -> 7\nmysql> SELECT WEEK(\'2008-02-20\',0);\n        -> 7\nmysql> SELECT WEEK(\'2008-02-20\',1);\n        -> 8\nmysql> SELECT WEEK(\'2008-12-31\',1);\n        -> 53\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(33,'SHOW PLUGINS',26,'Syntax:\nSHOW PLUGINS\n\nSHOW PLUGINS displays information about server plugins. Plugin\ninformation is also available in the INFORMATION_SCHEMA.PLUGINS table.\nSee http://dev.mysql.com/doc/refman/5.5/en/plugins-table.html.\n\nExample of SHOW PLUGINS output:\n\nmysql> SHOW PLUGINS\\G\n*************************** 1. row ***************************\n   Name: binlog\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 2. row ***************************\n   Name: CSV\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 3. row ***************************\n   Name: MEMORY\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 4. row ***************************\n   Name: MyISAM\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n...\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-plugins.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-plugins.html'),(34,'DROP FUNCTION UDF',21,'Syntax:\nDROP FUNCTION function_name\n\nThis statement drops the user-defined function (UDF) named\nfunction_name.\n\nTo drop a function, you must have the DELETE privilege for the mysql\ndatabase. This is because DROP FUNCTION removes a row from the\nmysql.func system table that records the function\'s name, type, and\nshared library name.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-function-udf.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-function-udf.html'),(35,'PREPARE',8,'Syntax:\nPREPARE stmt_name FROM preparable_stmt\n\nThe PREPARE statement prepares a statement and assigns it a name,\nstmt_name, by which to refer to the statement later. Statement names\nare not case sensitive. preparable_stmt is either a string literal or a\nuser variable that contains the text of the statement. The text must\nrepresent a single SQL statement, not multiple statements. Within the\nstatement, \"?\" characters can be used as parameter markers to indicate\nwhere data values are to be bound to the query later when you execute\nit. The \"?\" characters should not be enclosed within quotation marks,\neven if you intend to bind them to string values. Parameter markers can\nbe used only where data values should appear, not for SQL keywords,\nidentifiers, and so forth.\n\nIf a prepared statement with the given name already exists, it is\ndeallocated implicitly before the new statement is prepared. This means\nthat if the new statement contains an error and cannot be prepared, an\nerror is returned and no statement with the given name exists.\n\nA prepared statement is executed with EXECUTE and released with\nDEALLOCATE PREPARE.\n\nThe scope of a prepared statement is the session within which it is\ncreated. Other sessions cannot see it.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/prepare.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/prepare.html'),(36,'LOCK',8,'Syntax:\nLOCK TABLES\n    tbl_name [[AS] alias] lock_type\n    [, tbl_name [[AS] alias] lock_type] ...\n\nlock_type:\n    READ [LOCAL]\n  | [LOW_PRIORITY] WRITE\n\nUNLOCK TABLES\n\nMySQL enables client sessions to acquire table locks explicitly for the\npurpose of cooperating with other sessions for access to tables, or to\nprevent other sessions from modifying tables during periods when a\nsession requires exclusive access to them. A session can acquire or\nrelease locks only for itself. One session cannot acquire locks for\nanother session or release locks held by another session.\n\nLocks may be used to emulate transactions or to get more speed when\nupdating tables. This is explained in more detail later in this\nsection.\n\nLOCK TABLES explicitly acquires table locks for the current client\nsession. Table locks can be acquired for base tables or views. You must\nhave the LOCK TABLES privilege, and the SELECT privilege for each\nobject to be locked.\n\nFor view locking, LOCK TABLES adds all base tables used in the view to\nthe set of tables to be locked and locks them automatically. If you\nlock a table explicitly with LOCK TABLES, any tables used in triggers\nare also locked implicitly, as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/lock-tables-and-triggers.html.\n\nUNLOCK TABLES explicitly releases any table locks held by the current\nsession.\n\nAnother use for UNLOCK TABLES is to release the global read lock\nacquired with the FLUSH TABLES WITH READ LOCK statement, which enables\nyou to lock all tables in all databases. See [HELP FLUSH]. (This is a\nvery convenient way to get backups if you have a file system such as\nVeritas that can take snapshots in time.)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/lock-tables.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/lock-tables.html'),(37,'UPDATEXML',36,'Syntax:\nUpdateXML(xml_target, xpath_expr, new_xml)\n\nThis function replaces a single portion of a given fragment of XML\nmarkup xml_target with a new XML fragment new_xml, and then returns the\nchanged XML. The portion of xml_target that is replaced matches an\nXPath expression xpath_expr supplied by the user. If no expression\nmatching xpath_expr is found, or if multiple matches are found, the\nfunction returns the original xml_target XML fragment. All three\narguments should be strings.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/xml-functions.html\n\n','mysql> SELECT\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a\', \'<e>fff</e>\') AS val1,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/b\', \'<e>fff</e>\') AS val2,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'//b\', \'<e>fff</e>\') AS val3,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val4,\n    ->   UpdateXML(\'<a><d></d><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val5\n    -> \\G\n\n*************************** 1. row ***************************\nval1: <e>fff</e>\nval2: <a><b>ccc</b><d></d></a>\nval3: <a><e>fff</e><d></d></a>\nval4: <a><b>ccc</b><e>fff</e></a>\nval5: <a><d></d><b>ccc</b><d></d></a>\n','http://dev.mysql.com/doc/refman/5.5/en/xml-functions.html'),(38,'RESET SLAVE',8,'Syntax:\nRESET SLAVE [ALL]\n\nRESET SLAVE makes the slave forget its replication position in the\nmaster\'s binary log. This statement is meant to be used for a clean\nstart: It deletes the master.info and relay-log.info files, all the\nrelay log files, and starts a new relay log file. To use RESET SLAVE,\nthe slave replication threads must be stopped (use STOP SLAVE if\nnecessary).\n\n*Note*: All relay log files are deleted, even if they have not been\ncompletely executed by the slave SQL thread. (This is a condition\nlikely to exist on a replication slave if you have issued a STOP SLAVE\nstatement or if the slave is highly loaded.)\n\nIn MySQL 5.5 (unlike the case in MySQL 5.1 and earlier), RESET SLAVE\ndoes not change any replication connection parameters such as master\nhost, master port, master user, or master password, which are retained\nin memory. This means that START SLAVE can be issued without requiring\na CHANGE MASTER TO statement following RESET SLAVE.\n\nIn MySQL 5.5.16 and later, you can use RESET SLAVE ALL to reset these\nconnection parameters (Bug#11809016). Connection parameters are also\nreset if the slave mysqld is shut down.\n\nIf the slave SQL thread was in the middle of replicating temporary\ntables when it was stopped, and RESET SLAVE is issued, these replicated\ntemporary tables are deleted on the slave.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/reset-slave.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/reset-slave.html'),(39,'SHOW BINARY LOGS',26,'Syntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [HELP PURGE BINARY LOGS], that shows\nhow to determine which logs can be purged.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+\n| Log_name      | File_size |\n+---------------+-----------+\n| binlog.000015 |    724935 |\n| binlog.000016 |    733481 |\n+---------------+-----------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-binary-logs.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-binary-logs.html'),(40,'POLYGON',24,'Polygon(ls1,ls2,...)\n\nConstructs a Polygon value from a number of LineString or WKB\nLineString arguments. If any argument does not represent a LinearRing\n(that is, not a closed and simple LineString), the return value is\nNULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(41,'MINUTE',31,'Syntax:\nMINUTE(time)\n\nReturns the minute for time, in the range 0 to 59.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT MINUTE(\'2008-02-03 10:05:03\');\n        -> 5\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(42,'DAY',31,'Syntax:\nDAY(date)\n\nDAY() is a synonym for DAYOFMONTH().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(43,'MID',36,'Syntax:\nMID(str,pos,len)\n\nMID(str,pos,len) is a synonym for SUBSTRING(str,pos,len).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(44,'UUID',15,'Syntax:\nUUID()\n\nReturns a Universal Unique Identifier (UUID) generated according to\n\"DCE 1.1: Remote Procedure Call\" (Appendix A) CAE (Common Applications\nEnvironment) Specifications published by The Open Group in October 1997\n(Document Number C706,\nhttp://www.opengroup.org/public/pubs/catalog/c706.htm).\n\nA UUID is designed as a number that is globally unique in space and\ntime. Two calls to UUID() are expected to generate two different\nvalues, even if these calls are performed on two separate computers\nthat are not connected to each other.\n\nA UUID is a 128-bit number represented by a utf8 string of five\nhexadecimal numbers in aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee format:\n\no The first three numbers are generated from a timestamp.\n\no The fourth number preserves temporal uniqueness in case the timestamp\n  value loses monotonicity (for example, due to daylight saving time).\n\no The fifth number is an IEEE 802 node number that provides spatial\n  uniqueness. A random number is substituted if the latter is not\n  available (for example, because the host computer has no Ethernet\n  card, or we do not know how to find the hardware address of an\n  interface on your operating system). In this case, spatial uniqueness\n  cannot be guaranteed. Nevertheless, a collision should have very low\n  probability.\n\n  Currently, the MAC address of an interface is taken into account only\n  on FreeBSD and Linux. On other operating systems, MySQL uses a\n  randomly generated 48-bit number.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> SELECT UUID();\n        -> \'6ccd780c-baba-1026-9564-0040f4311e29\'\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(45,'LINESTRING',24,'LineString(pt1,pt2,...)\n\nConstructs a LineString value from a number of Point or WKB Point\narguments. If the number of arguments is less than two, the return\nvalue is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(46,'SLEEP',15,'Syntax:\nSLEEP(duration)\n\nSleeps (pauses) for the number of seconds given by the duration\nargument, then returns 0. If SLEEP() is interrupted, it returns 1. The\nduration may have a fractional part given in microseconds.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(47,'CONNECTION_ID',17,'Syntax:\nCONNECTION_ID()\n\nReturns the connection ID (thread ID) for the connection. Every\nconnection has an ID that is unique among the set of currently\nconnected clients.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT CONNECTION_ID();\n        -> 23786\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(48,'DELETE',27,'Syntax:\nSingle-table syntax:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE] FROM tbl_name\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nMultiple-table syntax:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    tbl_name[.*] [, tbl_name[.*]] ...\n    FROM table_references\n    [WHERE where_condition]\n\nOr:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    FROM tbl_name[.*] [, tbl_name[.*]] ...\n    USING table_references\n    [WHERE where_condition]\n\nFor the single-table syntax, the DELETE statement deletes rows from\ntbl_name and returns a count of the number of deleted rows. This count\ncan be obtained by calling the ROW_COUNT() function (see\nhttp://dev.mysql.com/doc/refman/5.5/en/information-functions.html). The\nWHERE clause, if given, specifies the conditions that identify which\nrows to delete. With no WHERE clause, all rows are deleted. If the\nORDER BY clause is specified, the rows are deleted in the order that is\nspecified. The LIMIT clause places a limit on the number of rows that\ncan be deleted.\n\nFor the multiple-table syntax, DELETE deletes from each tbl_name the\nrows that satisfy the conditions. In this case, ORDER BY and LIMIT\ncannot be used.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe deleted. It is specified as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/select.html.\n\nCurrently, you cannot delete from a table and select from the same\ntable in a subquery.\n\nYou need the DELETE privilege on a table to delete rows from it. You\nneed only the SELECT privilege for any columns that are only read, such\nas those named in the WHERE clause.\n\nAs stated, a DELETE statement with no WHERE clause deletes all rows. A\nfaster way to do this, when you do not need to know the number of\ndeleted rows, is to use TRUNCATE TABLE. However, within a transaction\nor if you have a lock on the table, TRUNCATE TABLE cannot be used\nwhereas DELETE can. See [HELP TRUNCATE TABLE], and [HELP LOCK].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/delete.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/delete.html'),(49,'ROUND',4,'Syntax:\nROUND(X), ROUND(X,D)\n\nRounds the argument X to D decimal places. The rounding algorithm\ndepends on the data type of X. D defaults to 0 if not specified. D can\nbe negative to cause D digits left of the decimal point of the value X\nto become zero.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT ROUND(-1.23);\n        -> -1\nmysql> SELECT ROUND(-1.58);\n        -> -2\nmysql> SELECT ROUND(1.58);\n        -> 2\nmysql> SELECT ROUND(1.298, 1);\n        -> 1.3\nmysql> SELECT ROUND(1.298, 0);\n        -> 1\nmysql> SELECT ROUND(23.298, -1);\n        -> 20\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(50,'NULLIF',7,'Syntax:\nNULLIF(expr1,expr2)\n\nReturns NULL if expr1 = expr2 is true, otherwise returns expr1. This is\nthe same as CASE WHEN expr1 = expr2 THEN NULL ELSE expr1 END.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html\n\n','mysql> SELECT NULLIF(1,1);\n        -> NULL\nmysql> SELECT NULLIF(1,2);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html'),(51,'CLOSE',23,'Syntax:\nCLOSE cursor_name\n\nThis statement closes a previously opened cursor. For an example, see\nhttp://dev.mysql.com/doc/refman/5.5/en/cursors.html.\n\nAn error occurs if the cursor is not open.\n\nIf not closed explicitly, a cursor is closed at the end of the BEGIN\n... END block in which it was declared.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/close.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/close.html'),(52,'STOP SLAVE',8,'Syntax:\nSTOP SLAVE [thread_type [, thread_type] ... ]\n\nthread_type: IO_THREAD | SQL_THREAD\n\nStops the slave threads. STOP SLAVE requires the SUPER privilege.\n\nLike START SLAVE, this statement may be used with the IO_THREAD and\nSQL_THREAD options to name the thread or threads to be stopped.\n\n*Note*: In MySQL 5.5, STOP SLAVE waits until the current replication\nevent group affecting one or more non-transactional tables has finished\nexecuting (if there is any such replication group), or until the user\nissues a KILL QUERY or KILL CONNECTION statement. (Bug #319, Bug\n#38205)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/stop-slave.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/stop-slave.html'),(53,'TIMEDIFF',31,'Syntax:\nTIMEDIFF(expr1,expr2)\n\nTIMEDIFF() returns expr1 - expr2 expressed as a time value. expr1 and\nexpr2 are time or date-and-time expressions, but both must be of the\nsame type.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIMEDIFF(\'2000:01:01 00:00:00\',\n    ->                 \'2000:01:01 00:00:00.000001\');\n        -> \'-00:00:00.000001\'\nmysql> SELECT TIMEDIFF(\'2008-12-31 23:59:59.000001\',\n    ->                 \'2008-12-30 01:01:01.000002\');\n        -> \'46:58:57.999999\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(54,'REPLACE FUNCTION',36,'Syntax:\nREPLACE(str,from_str,to_str)\n\nReturns the string str with all occurrences of the string from_str\nreplaced by the string to_str. REPLACE() performs a case-sensitive\nmatch when searching for from_str.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT REPLACE(\'www.mysql.com\', \'w\', \'Ww\');\n        -> \'WwWwWw.mysql.com\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(55,'USE',28,'Syntax:\nUSE db_name\n\nThe USE db_name statement tells MySQL to use the db_name database as\nthe default (current) database for subsequent statements. The database\nremains the default until the end of the session or another USE\nstatement is issued:\n\nUSE db1;\nSELECT COUNT(*) FROM mytable;   # selects from db1.mytable\nUSE db2;\nSELECT COUNT(*) FROM mytable;   # selects from db2.mytable\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/use.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/use.html'),(56,'LINEFROMTEXT',3,'LineFromText(wkt[,srid]), LineStringFromText(wkt[,srid])\n\nConstructs a LINESTRING value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(57,'CASE OPERATOR',7,'Syntax:\nCASE value WHEN [compare_value] THEN result [WHEN [compare_value] THEN\nresult ...] [ELSE result] END\n\nCASE WHEN [condition] THEN result [WHEN [condition] THEN result ...]\n[ELSE result] END\n\nThe first version returns the result where value=compare_value. The\nsecond version returns the result for the first condition that is true.\nIf there was no matching result value, the result after ELSE is\nreturned, or NULL if there is no ELSE part.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html\n\n','mysql> SELECT CASE 1 WHEN 1 THEN \'one\'\n    ->     WHEN 2 THEN \'two\' ELSE \'more\' END;\n        -> \'one\'\nmysql> SELECT CASE WHEN 1>0 THEN \'true\' ELSE \'false\' END;\n        -> \'true\'\nmysql> SELECT CASE BINARY \'B\'\n    ->     WHEN \'a\' THEN 1 WHEN \'b\' THEN 2 END;\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html'),(58,'SHOW MASTER STATUS',26,'Syntax:\nSHOW MASTER STATUS\n\nThis statement provides status information about the binary log files\nof the master. It requires either the SUPER or REPLICATION CLIENT\nprivilege.\n\nExample:\n\nmysql> SHOW MASTER STATUS;\n+---------------+----------+--------------+------------------+\n| File          | Position | Binlog_Do_DB | Binlog_Ignore_DB |\n+---------------+----------+--------------+------------------+\n| mysql-bin.003 | 73       | test         | manual,mysql     |\n+---------------+----------+--------------+------------------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-master-status.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-master-status.html'),(59,'ADDTIME',31,'Syntax:\nADDTIME(expr1,expr2)\n\nADDTIME() adds expr2 to expr1 and returns the result. expr1 is a time\nor datetime expression, and expr2 is a time expression.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT ADDTIME(\'2007-12-31 23:59:59.999999\', \'1 1:1:1.000002\');\n        -> \'2008-01-02 01:01:01.000001\'\nmysql> SELECT ADDTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'03:00:01.999997\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(60,'SPATIAL',33,'For MyISAM tables, MySQL can create spatial indexes using syntax\nsimilar to that for creating regular indexes, but extended with the\nSPATIAL keyword. Currently, columns in spatial indexes must be declared\nNOT NULL. The following examples demonstrate how to create spatial\nindexes:\n\no With CREATE TABLE:\n\nCREATE TABLE geom (g GEOMETRY NOT NULL, SPATIAL INDEX(g)) ENGINE=MyISAM;\n\no With ALTER TABLE:\n\nALTER TABLE geom ADD SPATIAL INDEX(g);\n\no With CREATE INDEX:\n\nCREATE SPATIAL INDEX sp_index ON geom (g);\n\nFor MyISAM tables, SPATIAL INDEX creates an R-tree index. For storage\nengines that support nonspatial indexing of spatial columns, the engine\ncreates a B-tree index. A B-tree index on spatial values will be useful\nfor exact-value lookups, but not for range scans.\n\nFor more information on indexing spatial columns, see [HELP CREATE\nINDEX].\n\nTo drop spatial indexes, use ALTER TABLE or DROP INDEX:\n\no With ALTER TABLE:\n\nALTER TABLE geom DROP INDEX g;\n\no With DROP INDEX:\n\nDROP INDEX sp_index ON geom;\n\nExample: Suppose that a table geom contains more than 32,000\ngeometries, which are stored in the column g of type GEOMETRY. The\ntable also has an AUTO_INCREMENT column fid for storing object ID\nvalues.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-indexes.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-indexes.html'),(61,'TO_SECONDS',31,'Syntax:\nTO_SECONDS(expr)\n\nGiven a date or datetime expr, returns a the number of seconds since\nthe year 0. If expr is not a valid date or datetime value, returns\nNULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TO_SECONDS(950501);\n        -> 62966505600\nmysql> SELECT TO_SECONDS(\'2009-11-29\');\n        -> 63426672000\nmysql> SELECT TO_SECONDS(\'2009-11-29 13:43:32\');\n        -> 63426721412\nmysql> SELECT TO_SECONDS( NOW() );\n        -> 63426721458\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(62,'TIMESTAMPDIFF',31,'Syntax:\nTIMESTAMPDIFF(unit,datetime_expr1,datetime_expr2)\n\nReturns datetime_expr2 - datetime_expr1, where datetime_expr1 and\ndatetime_expr2 are date or datetime expressions. One expression may be\na date and the other a datetime; a date value is treated as a datetime\nhaving the time part \'00:00:00\' where necessary. The unit for the\nresult (an integer) is given by the unit argument. The legal values for\nunit are the same as those listed in the description of the\nTIMESTAMPADD() function.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMPDIFF(MONTH,\'2003-02-01\',\'2003-05-01\');\n        -> 3\nmysql> SELECT TIMESTAMPDIFF(YEAR,\'2002-05-01\',\'2001-01-01\');\n        -> -1\nmysql> SELECT TIMESTAMPDIFF(MINUTE,\'2003-02-01\',\'2003-05-01 12:05:55\');\n        -> 128885\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(63,'UPPER',36,'Syntax:\nUPPER(str)\n\nReturns the string str with all characters changed to uppercase\naccording to the current character set mapping. The default is latin1\n(cp1252 West European).\n\nmysql> SELECT UPPER(\'Hej\');\n        -> \'HEJ\'\n\nSee the description of LOWER() for information that also applies to\nUPPER(), such as information about how to perform lettercase conversion\nof binary strings (BINARY, VARBINARY, BLOB) for which these functions\nare ineffective.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(64,'FROM_UNIXTIME',31,'Syntax:\nFROM_UNIXTIME(unix_timestamp), FROM_UNIXTIME(unix_timestamp,format)\n\nReturns a representation of the unix_timestamp argument as a value in\n\'YYYY-MM-DD HH:MM:SS\' or YYYYMMDDHHMMSS.uuuuuu format, depending on\nwhether the function is used in a string or numeric context. The value\nis expressed in the current time zone. unix_timestamp is an internal\ntimestamp value such as is produced by the UNIX_TIMESTAMP() function.\n\nIf format is given, the result is formatted according to the format\nstring, which is used the same way as listed in the entry for the\nDATE_FORMAT() function.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT FROM_UNIXTIME(1196440219);\n        -> \'2007-11-30 10:30:19\'\nmysql> SELECT FROM_UNIXTIME(1196440219) + 0;\n        -> 20071130103019.000000\nmysql> SELECT FROM_UNIXTIME(UNIX_TIMESTAMP(),\n    ->                      \'%Y %D %M %h:%i:%s %x\');\n        -> \'2007 30th November 10:30:59 2007\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(65,'MEDIUMBLOB',22,'MEDIUMBLOB\n\nA BLOB column with a maximum length of 16,777,215 (224 - 1) bytes. Each\nMEDIUMBLOB value is stored using a three-byte length prefix that\nindicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(66,'SHA2',12,'Syntax:\nSHA2(str, hash_length)\n\nCalculates the SHA-2 family of hash functions (SHA-224, SHA-256,\nSHA-384, and SHA-512). The first argument is the cleartext string to be\nhashed. The second argument indicates the desired bit length of the\nresult, which must have a value of 224, 256, 384, 512, or 0 (which is\nequivalent to 256). If either argument is NULL or the hash length is\nnot one of the permitted values, the return value is NULL. Otherwise,\nthe function result is a hash value containing the desired number of\nbits. See the notes at the beginning of this section about storing hash\nvalues efficiently.\n\nAs of MySQL 5.5.6, the return value is a nonbinary string in the\nconnection character set. Before 5.5.6, the return value is a binary\nstring; see the notes at the beginning of this section about using the\nvalue as a nonbinary string.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT SHA2(\'abc\', 224);\n        -> \'23097d223405d8228642a477bda255b32aadbce4bda0b3f7e36c9da7\'\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(67,'IFNULL',7,'Syntax:\nIFNULL(expr1,expr2)\n\nIf expr1 is not NULL, IFNULL() returns expr1; otherwise it returns\nexpr2. IFNULL() returns a numeric or string value, depending on the\ncontext in which it is used.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html\n\n','mysql> SELECT IFNULL(1,0);\n        -> 1\nmysql> SELECT IFNULL(NULL,10);\n        -> 10\nmysql> SELECT IFNULL(1/0,10);\n        -> 10\nmysql> SELECT IFNULL(1/0,\'yes\');\n        -> \'yes\'\n','http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html'),(68,'SHOW FUNCTION CODE',26,'Syntax:\nSHOW FUNCTION CODE func_name\n\nThis statement is similar to SHOW PROCEDURE CODE but for stored\nfunctions. See [HELP SHOW PROCEDURE CODE].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-function-code.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-function-code.html'),(69,'SHOW ERRORS',26,'Syntax:\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW COUNT(*) ERRORS\n\nThis statement is similar to SHOW WARNINGS, except that it displays\ninformation only for errors, rather than for errors, warnings, and\nnotes.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttp://dev.mysql.com/doc/refman/5.5/en/select.html.\n\nThe SHOW COUNT(*) ERRORS statement displays the number of errors. You\ncan also retrieve this number from the error_count variable:\n\nSHOW COUNT(*) ERRORS;\nSELECT @@error_count;\n\nSHOW ERRORS and error_count apply only to errors, not warnings or\nnotes. In other respects, they are similar to SHOW WARNINGS and\nwarning_count. In particular, SHOW ERRORS cannot display information\nfor more than max_error_count messages, and error_count can exceed the\nvalue of max_error_count if the number of errors exceeds\nmax_error_count.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-errors.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-errors.html'),(70,'LEAST',18,'Syntax:\nLEAST(value1,value2,...)\n\nWith two or more arguments, returns the smallest (minimum-valued)\nargument. The arguments are compared using the following rules:\n\no If any argument is NULL, the result is NULL. No comparison is needed.\n\no If the return value is used in an INTEGER context or all arguments\n  are integer-valued, they are compared as integers.\n\no If the return value is used in a REAL context or all arguments are\n  real-valued, they are compared as reals.\n\no If the arguments comprise a mix of numbers and strings, they are\n  compared as numbers.\n\no If any argument is a nonbinary (character) string, the arguments are\n  compared as nonbinary strings.\n\no In all other cases, the arguments are compared as binary strings.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT LEAST(2,0);\n        -> 0\nmysql> SELECT LEAST(34.0,3.0,5.0,767.0);\n        -> 3.0\nmysql> SELECT LEAST(\'B\',\'A\',\'C\');\n        -> \'A\'\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(71,'=',18,'=\n\nEqual:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 1 = 0;\n        -> 0\nmysql> SELECT \'0\' = 0;\n        -> 1\nmysql> SELECT \'0.0\' = 0;\n        -> 1\nmysql> SELECT \'0.01\' = 0;\n        -> 0\nmysql> SELECT \'.01\' = 0.01;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(72,'REVERSE',36,'Syntax:\nREVERSE(str)\n\nReturns the string str with the order of the characters reversed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT REVERSE(\'abc\');\n        -> \'cba\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(73,'ISNULL',18,'Syntax:\nISNULL(expr)\n\nIf expr is NULL, ISNULL() returns 1, otherwise it returns 0.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT ISNULL(1+1);\n        -> 0\nmysql> SELECT ISNULL(1/0);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(74,'BINARY',22,'BINARY(M)\n\nThe BINARY type is similar to the CHAR type, but stores binary byte\nstrings rather than nonbinary character strings. M represents the\ncolumn length in bytes.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(75,'BLOB DATA TYPE',22,'A BLOB is a binary large object that can hold a variable amount of\ndata. The four BLOB types are TINYBLOB, BLOB, MEDIUMBLOB, and LONGBLOB.\nThese differ only in the maximum length of the values they can hold.\nThe four TEXT types are TINYTEXT, TEXT, MEDIUMTEXT, and LONGTEXT. These\ncorrespond to the four BLOB types and have the same maximum lengths and\nstorage requirements. See\nhttp://dev.mysql.com/doc/refman/5.5/en/storage-requirements.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/blob.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/blob.html'),(76,'BOUNDARY',35,'Boundary(g)\n\nReturns a geometry that is the closure of the combinatorial boundary of\nthe geometry value g.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(77,'CREATE USER',10,'Syntax:\nCREATE USER user_specification\n    [, user_specification] ...\n\nuser_specification:\n    user\n    [\n        IDENTIFIED BY [PASSWORD] \'password\'\n      | IDENTIFIED WITH auth_plugin [AS \'auth_string\']\n    ]\n\nThe CREATE USER statement creates new MySQL accounts. To use it, you\nmust have the global CREATE USER privilege or the INSERT privilege for\nthe mysql database. For each account, CREATE USER creates a new row in\nthe mysql.user table and assigns the account no privileges. An error\noccurs if the account already exists.\n\nEach account name uses the format described in\nhttp://dev.mysql.com/doc/refman/5.5/en/account-names.html. For example:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nThe user specification may indicate how the user should authenticate\nwhen connecting to the server:\n\no To enable the user to connect with no password (which is insecure),\n  include no IDENTIFIED BY clause:\n\nCREATE USER \'jeffrey\'@\'localhost\';\n\n  In this case, the server uses built-in authentication and clients\n  must provide no password.\n\no To assign a password, use IDENTIFIED BY with the literal plaintext\n  password value:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\n\n  The server uses built-in authentication and clients must match the\n  given password.\n\no To avoid specifying the plaintext password if you know its hash value\n  (the value that PASSWORD() would return for the password), specify\n  the hash value preceded by the keyword PASSWORD:\n\nCREATE USER \'jeffrey\'@\'localhost\'\nIDENTIFIED BY PASSWORD \'*90E462C37378CED12064BB3388827D2BA3A9B689\';\n\n  The server uses built-in authentication and clients must match the\n  given password.\n\no To authenticate the account using a specific authentication plugin,\n  use IDENTIFIED WITH, where auth_plugin is the plugin name. It can be\n  an unquoted name or a quoted string literal. \'auth_string\' is an\n  optional quoted string literal to pass to the plugin. The plugin\n  interprets the meaning of the string, so its format is plugin\n  specific. Consult the documentation for a given plugin for\n  information about the authentication string values it accepts.\n\nCREATE USER \'jeffrey\'@\'localhost\'\nIDENTIFIED WITH my_auth_plugin;\n\n  For connections that use this account, the server invokes the named\n  plugin and clients must provide credentials as required for the\n  authentication method that the plugin implements. If the server\n  cannot find the plugin, either at account-creation time or connect\n  time, an error occurs. IDENTIFIED WITH can be used as of MySQL 5.5.7.\n\nThe IDENTIFIED BY and IDENTIFIED WITH clauses are mutually exclusive,\nso at most one of them can be specified for a given user.\n\nFor additional information about setting passwords, see\nhttp://dev.mysql.com/doc/refman/5.5/en/assigning-passwords.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-user.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-user.html'),(78,'POINT',24,'Point(x,y)\n\nConstructs a Point using its coordinates.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(79,'CURRENT_USER',17,'Syntax:\nCURRENT_USER, CURRENT_USER()\n\nReturns the user name and host name combination for the MySQL account\nthat the server used to authenticate the current client. This account\ndetermines your access privileges. The return value is a string in the\nutf8 character set.\n\nThe value of CURRENT_USER() can differ from the value of USER().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT USER();\n        -> \'davida@localhost\'\nmysql> SELECT * FROM mysql.user;\nERROR 1044: Access denied for user \'\'@\'localhost\' to\ndatabase \'mysql\'\nmysql> SELECT CURRENT_USER();\n        -> \'@localhost\'\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(80,'LCASE',36,'Syntax:\nLCASE(str)\n\nLCASE() is a synonym for LOWER().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(81,'<=',18,'Syntax:\n<=\n\nLess than or equal:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 0.1 <= 2;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(82,'SHOW PROFILES',26,'Syntax:\nSHOW PROFILE [type [, type] ... ]\n    [FOR QUERY n]\n    [LIMIT row_count [OFFSET offset]]\n\ntype:\n    ALL\n  | BLOCK IO\n  | CONTEXT SWITCHES\n  | CPU\n  | IPC\n  | MEMORY\n  | PAGE FAULTS\n  | SOURCE\n  | SWAPS\n\nThe SHOW PROFILES and SHOW PROFILE statements display profiling\ninformation that indicates resource usage for statements executed\nduring the course of the current session.\n\nProfiling is controlled by the profiling session variable, which has a\ndefault value of 0 (OFF). Profiling is enabled by setting profiling to\n1 or ON:\n\nmysql> SET profiling = 1;\n\nSHOW PROFILES displays a list of the most recent statements sent to the\nmaster. The size of the list is controlled by the\nprofiling_history_size session variable, which has a default value of\n15. The maximum value is 100. Setting the value to 0 has the practical\neffect of disabling profiling.\n\nAll statements are profiled except SHOW PROFILES and SHOW PROFILE, so\nyou will find neither of those statements in the profile list.\nMalformed statements are profiled. For example, SHOW PROFILING is an\nillegal statement, and a syntax error occurs if you try to execute it,\nbut it will show up in the profiling list.\n\nSHOW PROFILE displays detailed information about a single statement.\nWithout the FOR QUERY n clause, the output pertains to the most\nrecently executed statement. If FOR QUERY n is included, SHOW PROFILE\ndisplays information for statement n. The values of n correspond to the\nQuery_ID values displayed by SHOW PROFILES.\n\nThe LIMIT row_count clause may be given to limit the output to\nrow_count rows. If LIMIT is given, OFFSET offset may be added to begin\nthe output offset rows into the full set of rows.\n\nBy default, SHOW PROFILE displays Status and Duration columns. The\nStatus values are like the State values displayed by SHOW PROCESSLIST,\nalthough there might be some minor differences in interpretion for the\ntwo statements for some status values (see\nhttp://dev.mysql.com/doc/refman/5.5/en/thread-information.html).\n\nOptional type values may be specified to display specific additional\ntypes of information:\n\no ALL displays all information\n\no BLOCK IO displays counts for block input and output operations\n\no CONTEXT SWITCHES displays counts for voluntary and involuntary\n  context switches\n\no CPU displays user and system CPU usage times\n\no IPC displays counts for messages sent and received\n\no MEMORY is not currently implemented\n\no PAGE FAULTS displays counts for major and minor page faults\n\no SOURCE displays the names of functions from the source code, together\n  with the name and line number of the file in which the function\n  occurs\n\no SWAPS displays swap counts\n\nProfiling is enabled per session. When a session ends, its profiling\ninformation is lost.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-profiles.html\n\n','mysql> SELECT @@profiling;\n+-------------+\n| @@profiling |\n+-------------+\n|           0 |\n+-------------+\n1 row in set (0.00 sec)\n\nmysql> SET profiling = 1;\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> DROP TABLE IF EXISTS t1;\nQuery OK, 0 rows affected, 1 warning (0.00 sec)\n\nmysql> CREATE TABLE T1 (id INT);\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SHOW PROFILES;\n+----------+----------+--------------------------+\n| Query_ID | Duration | Query                    |\n+----------+----------+--------------------------+\n|        0 | 0.000088 | SET PROFILING = 1        |\n|        1 | 0.000136 | DROP TABLE IF EXISTS t1  |\n|        2 | 0.011947 | CREATE TABLE t1 (id INT) |\n+----------+----------+--------------------------+\n3 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE;\n+----------------------+----------+\n| Status               | Duration |\n+----------------------+----------+\n| checking permissions | 0.000040 |\n| creating table       | 0.000056 |\n| After create         | 0.011363 |\n| query end            | 0.000375 |\n| freeing items        | 0.000089 |\n| logging slow query   | 0.000019 |\n| cleaning up          | 0.000005 |\n+----------------------+----------+\n7 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE FOR QUERY 1;\n+--------------------+----------+\n| Status             | Duration |\n+--------------------+----------+\n| query end          | 0.000107 |\n| freeing items      | 0.000008 |\n| logging slow query | 0.000015 |\n| cleaning up        | 0.000006 |\n+--------------------+----------+\n4 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE CPU FOR QUERY 2;\n+----------------------+----------+----------+------------+\n| Status               | Duration | CPU_user | CPU_system |\n+----------------------+----------+----------+------------+\n| checking permissions | 0.000040 | 0.000038 |   0.000002 |\n| creating table       | 0.000056 | 0.000028 |   0.000028 |\n| After create         | 0.011363 | 0.000217 |   0.001571 |\n| query end            | 0.000375 | 0.000013 |   0.000028 |\n| freeing items        | 0.000089 | 0.000010 |   0.000014 |\n| logging slow query   | 0.000019 | 0.000009 |   0.000010 |\n| cleaning up          | 0.000005 | 0.000003 |   0.000002 |\n+----------------------+----------+----------+------------+\n7 rows in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/show-profiles.html'),(83,'UPDATE',27,'Syntax:\nSingle-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_reference\n    SET col_name1={expr1|DEFAULT} [, col_name2={expr2|DEFAULT}] ...\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nMultiple-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_references\n    SET col_name1={expr1|DEFAULT} [, col_name2={expr2|DEFAULT}] ...\n    [WHERE where_condition]\n\nFor the single-table syntax, the UPDATE statement updates columns of\nexisting rows in the named table with new values. The SET clause\nindicates which columns to modify and the values they should be given.\nEach value can be given as an expression, or the keyword DEFAULT to set\na column explicitly to its default value. The WHERE clause, if given,\nspecifies the conditions that identify which rows to update. With no\nWHERE clause, all rows are updated. If the ORDER BY clause is\nspecified, the rows are updated in the order that is specified. The\nLIMIT clause places a limit on the number of rows that can be updated.\n\nFor the multiple-table syntax, UPDATE updates rows in each table named\nin table_references that satisfy the conditions. In this case, ORDER BY\nand LIMIT cannot be used.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe updated. For expression syntax, see\nhttp://dev.mysql.com/doc/refman/5.5/en/expressions.html.\n\ntable_references and where_condition are is specified as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/select.html.\n\nYou need the UPDATE privilege only for columns referenced in an UPDATE\nthat are actually updated. You need only the SELECT privilege for any\ncolumns that are read but not modified.\n\nThe UPDATE statement supports the following modifiers:\n\no With the LOW_PRIORITY keyword, execution of the UPDATE is delayed\n  until no other clients are reading from the table. This affects only\n  storage engines that use only table-level locking (such as MyISAM,\n  MEMORY, and MERGE).\n\no With the IGNORE keyword, the update statement does not abort even if\n  errors occur during the update. Rows for which duplicate-key\n  conflicts occur are not updated. Rows for which columns are updated\n  to values that would cause data conversion errors are updated to the\n  closest valid values instead.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/update.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/update.html'),(84,'IS NOT NULL',18,'Syntax:\nIS NOT NULL\n\nTests whether a value is not NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NOT NULL, 0 IS NOT NULL, NULL IS NOT NULL;\n        -> 1, 1, 0\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(85,'CASE STATEMENT',23,'Syntax:\nCASE case_value\n    WHEN when_value THEN statement_list\n    [WHEN when_value THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nOr:\n\nCASE\n    WHEN search_condition THEN statement_list\n    [WHEN search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nThe CASE statement for stored programs implements a complex conditional\nconstruct.\n\n*Note*: There is also a CASE expression, which differs from the CASE\nstatement described here. See\nhttp://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html. The\nCASE statement cannot have an ELSE NULL clause, and it is terminated\nwith END CASE instead of END.\n\nFor the first syntax, case_value is an expression. This value is\ncompared to the when_value expression in each WHEN clause until one of\nthem is equal. When an equal when_value is found, the corresponding\nTHEN clause statement_list executes. If no when_value is equal, the\nELSE clause statement_list executes, if there is one.\n\nThis syntax cannot be used to test for equality with NULL because NULL\n= NULL is false. See\nhttp://dev.mysql.com/doc/refman/5.5/en/working-with-null.html.\n\nFor the second syntax, each WHEN clause search_condition expression is\nevaluated until one is true, at which point its corresponding THEN\nclause statement_list executes. If no search_condition is equal, the\nELSE clause statement_list executes, if there is one.\n\nIf no when_value or search_condition matches the value tested and the\nCASE statement contains no ELSE clause, a Case not found for CASE\nstatement error results.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nTo handle situations where no value is matched by any WHEN clause, use\nan ELSE containing an empty BEGIN ... END block, as shown in this\nexample. (The indentation used here in the ELSE clause is for purposes\nof clarity only, and is not otherwise significant.)\n\nDELIMITER |\n\nCREATE PROCEDURE p()\n  BEGIN\n    DECLARE v INT DEFAULT 1;\n\n    CASE v\n      WHEN 2 THEN SELECT v;\n      WHEN 3 THEN SELECT 0;\n      ELSE\n        BEGIN\n        END;\n    END CASE;\n  END;\n  |\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/case-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/case-statement.html'),(86,'EXECUTE STATEMENT',8,'Syntax:\nEXECUTE stmt_name\n    [USING @var_name [, @var_name] ...]\n\nAfter preparing a statement with PREPARE, you execute it with an\nEXECUTE statement that refers to the prepared statement name. If the\nprepared statement contains any parameter markers, you must supply a\nUSING clause that lists user variables containing the values to be\nbound to the parameters. Parameter values can be supplied only by user\nvariables, and the USING clause must name exactly as many variables as\nthe number of parameter markers in the statement.\n\nYou can execute a given prepared statement multiple times, passing\ndifferent variables to it or setting the variables to different values\nbefore each execution.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/execute.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/execute.html'),(87,'DROP INDEX',38,'Syntax:\nDROP [ONLINE|OFFLINE] INDEX index_name ON tbl_name\n\nDROP INDEX drops the index named index_name from the table tbl_name.\nThis statement is mapped to an ALTER TABLE statement to drop the index.\nSee [HELP ALTER TABLE].\n\nTo drop a primary key, the index name is always PRIMARY, which must be\nspecified as a quoted identifier because PRIMARY is a reserved word:\n\nDROP INDEX `PRIMARY` ON t;\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-index.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-index.html'),(88,'MATCH AGAINST',36,'Syntax:\nMATCH (col1,col2,...) AGAINST (expr [search_modifier])\n\nMySQL has support for full-text indexing and searching:\n\no A full-text index in MySQL is an index of type FULLTEXT.\n\no Full-text indexes can be used only with MyISAM tables, and can be\n  created only for CHAR, VARCHAR, or TEXT columns.\n\no A FULLTEXT index definition can be given in the CREATE TABLE\n  statement when a table is created, or added later using ALTER TABLE\n  or CREATE INDEX.\n\no For large data sets, it is much faster to load your data into a table\n  that has no FULLTEXT index and then create the index after that, than\n  to load data into a table that has an existing FULLTEXT index.\n\nFull-text searching is performed using MATCH() ... AGAINST syntax.\nMATCH() takes a comma-separated list that names the columns to be\nsearched. AGAINST takes a string to search for, and an optional\nmodifier that indicates what type of search to perform. The search\nstring must be a literal string, not a variable or a column name. There\nare three types of full-text searches:\n\no A natural language search interprets the search string as a phrase in\n  natural human language (a phrase in free text). There are no special\n  operators. The stopword list applies. In addition, words that are\n  present in 50% or more of the rows are considered common and do not\n  match.\n\n  Full-text searches are natural language searches if the IN NATURAL\n  LANGUAGE MODE modifier is given or if no modifier is given. For more\n  information, see\n  http://dev.mysql.com/doc/refman/5.5/en/fulltext-natural-language.html\n  .\n\no A boolean search interprets the search string using the rules of a\n  special query language. The string contains the words to search for.\n  It can also contain operators that specify requirements such that a\n  word must be present or absent in matching rows, or that it should be\n  weighted higher or lower than usual. Common words such as \"some\" or\n  \"then\" are stopwords and do not match if present in the search\n  string. The IN BOOLEAN MODE modifier specifies a boolean search. For\n  more information, see\n  http://dev.mysql.com/doc/refman/5.5/en/fulltext-boolean.html.\n\no A query expansion search is a modification of a natural language\n  search. The search string is used to perform a natural language\n  search. Then words from the most relevant rows returned by the search\n  are added to the search string and the search is done again. The\n  query returns the rows from the second search. The IN NATURAL\n  LANGUAGE MODE WITH QUERY EXPANSION or WITH QUERY EXPANSION modifier\n  specifies a query expansion search. For more information, see\n  http://dev.mysql.com/doc/refman/5.5/en/fulltext-query-expansion.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/fulltext-search.html\n\n','mysql> SELECT id, body, MATCH (title,body) AGAINST\n    -> (\'Security implications of running MySQL as root\'\n    -> IN NATURAL LANGUAGE MODE) AS score\n    -> FROM articles WHERE MATCH (title,body) AGAINST\n    -> (\'Security implications of running MySQL as root\'\n    -> IN NATURAL LANGUAGE MODE);\n+----+-------------------------------------+-----------------+\n| id | body                                | score           |\n+----+-------------------------------------+-----------------+\n|  4 | 1. Never run mysqld as root. 2. ... | 1.5219271183014 |\n|  6 | When configured properly, MySQL ... | 1.3114095926285 |\n+----+-------------------------------------+-----------------+\n2 rows in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/fulltext-search.html'),(89,'CREATE EVENT',38,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    EVENT\n    [IF NOT EXISTS]\n    event_name\n    ON SCHEDULE schedule\n    [ON COMPLETION [NOT] PRESERVE]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'comment\']\n    DO event_body;\n\nschedule:\n    AT timestamp [+ INTERVAL interval] ...\n  | EVERY interval\n    [STARTS timestamp [+ INTERVAL interval] ...]\n    [ENDS timestamp [+ INTERVAL interval] ...]\n\ninterval:\n    quantity {YEAR | QUARTER | MONTH | DAY | HOUR | MINUTE |\n              WEEK | SECOND | YEAR_MONTH | DAY_HOUR | DAY_MINUTE |\n              DAY_SECOND | HOUR_MINUTE | HOUR_SECOND | MINUTE_SECOND}\n\nThis statement creates and schedules a new event. The event will not\nrun unless the Event Scheduler is enabled. For information about\nchecking Event Scheduler status and enabling it if necessary, see\nhttp://dev.mysql.com/doc/refman/5.5/en/events-configuration.html.\n\nCREATE EVENT requires the EVENT privilege for the schema in which the\nevent is to be created. It might also require the SUPER privilege,\ndepending on the DEFINER value, as described later in this section.\n\nThe minimum requirements for a valid CREATE EVENT statement are as\nfollows:\n\no The keywords CREATE EVENT plus an event name, which uniquely\n  identifies the event in a database schema.\n\no An ON SCHEDULE clause, which determines when and how often the event\n  executes.\n\no A DO clause, which contains the SQL statement to be executed by an\n  event.\n\nThis is an example of a minimal CREATE EVENT statement:\n\nCREATE EVENT myevent\n    ON SCHEDULE AT CURRENT_TIMESTAMP + INTERVAL 1 HOUR\n    DO\n      UPDATE myschema.mytable SET mycol = mycol + 1;\n\nThe previous statement creates an event named myevent. This event\nexecutes once---one hour following its creation---by running an SQL\nstatement that increments the value of the myschema.mytable table\'s\nmycol column by 1.\n\nThe event_name must be a valid MySQL identifier with a maximum length\nof 64 characters. Event names are not case sensitive, so you cannot\nhave two events named myevent and MyEvent in the same schema. In\ngeneral, the rules governing event names are the same as those for\nnames of stored routines. See\nhttp://dev.mysql.com/doc/refman/5.5/en/identifiers.html.\n\nAn event is associated with a schema. If no schema is indicated as part\nof event_name, the default (current) schema is assumed. To create an\nevent in a specific schema, qualify the event name with a schema using\nschema_name.event_name syntax.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-event.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-event.html'),(90,'ABS',4,'Syntax:\nABS(X)\n\nReturns the absolute value of X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT ABS(2);\n        -> 2\nmysql> SELECT ABS(-32);\n        -> 32\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(91,'POLYFROMWKB',32,'PolyFromWKB(wkb[,srid]), PolygonFromWKB(wkb[,srid])\n\nConstructs a POLYGON value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(92,'NOT LIKE',36,'Syntax:\nexpr NOT LIKE pat [ESCAPE \'escape_char\']\n\nThis is the same as NOT (expr LIKE pat [ESCAPE \'escape_char\']).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-comparison-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-comparison-functions.html'),(93,'SPACE',36,'Syntax:\nSPACE(N)\n\nReturns a string consisting of N space characters.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT SPACE(6);\n        -> \'      \'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(94,'MBR DEFINITION',6,'Its MBR (Minimum Bounding Rectangle), or Envelope. This is the bounding\ngeometry, formed by the minimum and maximum (X,Y) coordinates:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/gis-class-geometry.html\n\n','((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n','http://dev.mysql.com/doc/refman/5.5/en/gis-class-geometry.html'),(95,'GEOMETRYCOLLECTION',24,'GeometryCollection(g1,g2,...)\n\nConstructs a GeometryCollection.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(96,'MAX',16,'Syntax:\nMAX([DISTINCT] expr)\n\nReturns the maximum value of expr. MAX() may take a string argument; in\nsuch cases, it returns the maximum string value. See\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-indexes.html. The DISTINCT\nkeyword can be used to find the maximum of the distinct values of expr,\nhowever, this produces the same result as omitting DISTINCT.\n\nMAX() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','mysql> SELECT student_name, MIN(test_score), MAX(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(97,'CREATE FUNCTION UDF',21,'Syntax:\nCREATE [AGGREGATE] FUNCTION function_name RETURNS {STRING|INTEGER|REAL|DECIMAL}\n    SONAME shared_library_name\n\nA user-defined function (UDF) is a way to extend MySQL with a new\nfunction that works like a native (built-in) MySQL function such as\nABS() or CONCAT().\n\nfunction_name is the name that should be used in SQL statements to\ninvoke the function. The RETURNS clause indicates the type of the\nfunction\'s return value. DECIMAL is a legal value after RETURNS, but\ncurrently DECIMAL functions return string values and should be written\nlike STRING functions.\n\nshared_library_name is the basename of the shared object file that\ncontains the code that implements the function. The file must be\nlocated in the plugin directory. This directory is given by the value\nof the plugin_dir system variable. For more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/udf-compiling.html.\n\nTo create a function, you must have the INSERT privilege for the mysql\ndatabase. This is necessary because CREATE FUNCTION adds a row to the\nmysql.func system table that records the function\'s name, type, and\nshared library name. If you do not have this table, you should run the\nmysql_upgrade command to create it. See\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-upgrade.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-function-udf.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-function-udf.html'),(98,'*',4,'Syntax:\n*\n\nMultiplication:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','mysql> SELECT 3*5;\n        -> 15\nmysql> SELECT 18014398509481984*18014398509481984.0;\n        -> 324518553658426726783156020576256.0\nmysql> SELECT 18014398509481984*18014398509481984;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(99,'TIMESTAMP',22,'TIMESTAMP\n\nA timestamp. The range is \'1970-01-01 00:00:01\' UTC to \'2038-01-19\n03:14:07\' UTC. TIMESTAMP values are stored as the number of seconds\nsince the epoch (\'1970-01-01 00:00:00\' UTC). A TIMESTAMP cannot\nrepresent the value \'1970-01-01 00:00:00\' because that is equivalent to\n0 seconds from the epoch and the value 0 is reserved for representing\n\'0000-00-00 00:00:00\', the \"zero\" TIMESTAMP value.\n\nMySQL displays TIMESTAMP values in \'YYYY-MM-DD HH:MM:SS\' format. To\nconvert the value to a number, add +0.\n\nA TIMESTAMP column is useful for recording the date and time of an\nINSERT or UPDATE operation. By default, the first TIMESTAMP column in a\ntable is automatically set to the date and time of the most recent\noperation if you do not assign it a value yourself. You can also set\nany TIMESTAMP column to the current date and time by assigning it a\nNULL value. The automatic initialization and update properties can be\nspecified using DEFAULT and ON UPDATE clauses, are described in\nhttp://dev.mysql.com/doc/refman/5.5/en/timestamp.html.\n\n*Note*: The TIMESTAMP format that was used prior to MySQL 4.1 is not\nsupported in MySQL 5.5; see MySQL 3.23, 4.0, 4.1 Reference Manual for\ninformation regarding the old format.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html'),(100,'DES_DECRYPT',12,'Syntax:\nDES_DECRYPT(crypt_str[,key_str])\n\nDecrypts a string encrypted with DES_ENCRYPT(). If an error occurs,\nthis function returns NULL.\n\nThis function works only if MySQL has been configured with SSL support.\nSee http://dev.mysql.com/doc/refman/5.5/en/secure-connections.html.\n\nIf no key_str argument is given, DES_DECRYPT() examines the first byte\nof the encrypted string to determine the DES key number that was used\nto encrypt the original string, and then reads the key from the DES key\nfile to decrypt the message. For this to work, the user must have the\nSUPER privilege. The key file can be specified with the --des-key-file\nserver option.\n\nIf you pass this function a key_str argument, that string is used as\nthe key for decrypting the message.\n\nIf the crypt_str argument does not appear to be an encrypted string,\nMySQL returns the given crypt_str.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(101,'CACHE INDEX',26,'Syntax:\nCACHE INDEX\n  tbl_index_list [, tbl_index_list] ...\n  [PARTITION (partition_list | ALL)]\n  IN key_cache_name\n\ntbl_index_list:\n  tbl_name [[INDEX|KEY] (index_name[, index_name] ...)]\n\npartition_list:\n  partition_name[, partition_name][, ...]\n\nThe CACHE INDEX statement assigns table indexes to a specific key\ncache. It is used only for MyISAM tables. After the indexes have been\nassigned, they can be preloaded into the cache if desired with LOAD\nINDEX INTO CACHE.\n\nThe following statement assigns indexes from the tables t1, t2, and t3\nto the key cache named hot_cache:\n\nmysql> CACHE INDEX t1, t2, t3 IN hot_cache;\n+---------+--------------------+----------+----------+\n| Table   | Op                 | Msg_type | Msg_text |\n+---------+--------------------+----------+----------+\n| test.t1 | assign_to_keycache | status   | OK       |\n| test.t2 | assign_to_keycache | status   | OK       |\n| test.t3 | assign_to_keycache | status   | OK       |\n+---------+--------------------+----------+----------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/cache-index.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/cache-index.html'),(102,'ENDPOINT',13,'EndPoint(ls)\n\nReturns the Point that is the endpoint of the LineString value ls.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(EndPoint(GeomFromText(@ls)));\n+-------------------------------------+\n| AsText(EndPoint(GeomFromText(@ls))) |\n+-------------------------------------+\n| POINT(3 3)                          |\n+-------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions'),(103,'COMPRESS',12,'Syntax:\nCOMPRESS(string_to_compress)\n\nCompresses a string and returns the result as a binary string. This\nfunction requires MySQL to have been compiled with a compression\nlibrary such as zlib. Otherwise, the return value is always NULL. The\ncompressed string can be uncompressed with UNCOMPRESS().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT LENGTH(COMPRESS(REPEAT(\'a\',1000)));\n        -> 21\nmysql> SELECT LENGTH(COMPRESS(\'\'));\n        -> 0\nmysql> SELECT LENGTH(COMPRESS(\'a\'));\n        -> 13\nmysql> SELECT LENGTH(COMPRESS(REPEAT(\'a\',16)));\n        -> 15\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(104,'INSERT',27,'Syntax:\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    {VALUES | VALUE} ({expr | DEFAULT},...),(...),...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nOr:\n\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    SET col_name={expr | DEFAULT}, ...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nOr:\n\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nINSERT inserts new rows into an existing table. The INSERT ... VALUES\nand INSERT ... SET forms of the statement insert rows based on\nexplicitly specified values. The INSERT ... SELECT form inserts rows\nselected from another table or tables. INSERT ... SELECT is discussed\nfurther in [HELP INSERT SELECT].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/insert.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/insert.html'),(105,'COUNT',16,'Syntax:\nCOUNT(expr)\n\nReturns a count of the number of non-NULL values of expr in the rows\nretrieved by a SELECT statement. The result is a BIGINT value.\n\nCOUNT() returns 0 if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','mysql> SELECT student.student_name,COUNT(*)\n    ->        FROM student,course\n    ->        WHERE student.student_id=course.student_id\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(106,'HANDLER',27,'Syntax:\nHANDLER tbl_name OPEN [ [AS] alias]\n\nHANDLER tbl_name READ index_name { = | <= | >= | < | > } (value1,value2,...)\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ index_name { FIRST | NEXT | PREV | LAST }\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ { FIRST | NEXT }\n    [ WHERE where_condition ] [LIMIT ... ]\n\nHANDLER tbl_name CLOSE\n\nThe HANDLER statement provides direct access to table storage engine\ninterfaces. It is available for MyISAM and InnoDB tables.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/handler.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/handler.html'),(107,'MLINEFROMTEXT',3,'MLineFromText(wkt[,srid]), MultiLineStringFromText(wkt[,srid])\n\nConstructs a MULTILINESTRING value using its WKT representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(108,'GEOMCOLLFROMWKB',32,'GeomCollFromWKB(wkb[,srid]), GeometryCollectionFromWKB(wkb[,srid])\n\nConstructs a GEOMETRYCOLLECTION value using its WKB representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(109,'HELP_DATE',9,'This help information was generated from the MySQL 5.5 Reference Manual\non: 2011-12-16\n','',''),(110,'RENAME TABLE',38,'Syntax:\nRENAME TABLE tbl_name TO new_tbl_name\n    [, tbl_name2 TO new_tbl_name2] ...\n\nThis statement renames one or more tables.\n\nThe rename operation is done atomically, which means that no other\nsession can access any of the tables while the rename is running. For\nexample, if you have an existing table old_table, you can create\nanother table new_table that has the same structure but is empty, and\nthen replace the existing table with the empty one as follows (assuming\nthat backup_table does not already exist):\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/rename-table.html\n\n','CREATE TABLE new_table (...);\nRENAME TABLE old_table TO backup_table, new_table TO old_table;\n','http://dev.mysql.com/doc/refman/5.5/en/rename-table.html'),(111,'BOOLEAN',22,'BOOL, BOOLEAN\n\nThese types are synonyms for TINYINT(1). A value of zero is considered\nfalse. Nonzero values are considered true:\n\nmysql> SELECT IF(0, \'true\', \'false\');\n+------------------------+\n| IF(0, \'true\', \'false\') |\n+------------------------+\n| false                  |\n+------------------------+\n\nmysql> SELECT IF(1, \'true\', \'false\');\n+------------------------+\n| IF(1, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nmysql> SELECT IF(2, \'true\', \'false\');\n+------------------------+\n| IF(2, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nHowever, the values TRUE and FALSE are merely aliases for 1 and 0,\nrespectively, as shown here:\n\nmysql> SELECT IF(0 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(0 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| true                           |\n+--------------------------------+\n\nmysql> SELECT IF(1 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(1 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| true                          |\n+-------------------------------+\n\nmysql> SELECT IF(2 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(2 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| false                         |\n+-------------------------------+\n\nmysql> SELECT IF(2 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(2 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| false                          |\n+--------------------------------+\n\nThe last two statements display the results shown because 2 is equal to\nneither 1 nor 0.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(112,'DEFAULT',15,'Syntax:\nDEFAULT(col_name)\n\nReturns the default value for a table column. An error results if the\ncolumn has no default value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> UPDATE t SET i = DEFAULT(i)+1 WHERE id < 100;\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(113,'MOD',4,'Syntax:\nMOD(N,M), N % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT MOD(234, 10);\n        -> 4\nmysql> SELECT 253 % 7;\n        -> 1\nmysql> SELECT MOD(29,9);\n        -> 2\nmysql> SELECT 29 MOD 9;\n        -> 2\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(114,'TINYTEXT',22,'TINYTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 255 (28 - 1) characters. The\neffective maximum length is less if the value contains multi-byte\ncharacters. Each TINYTEXT value is stored using a one-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(115,'OPTIMIZE TABLE',20,'Syntax:\nOPTIMIZE [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n\nOPTIMIZE TABLE should be used if you have deleted a large part of a\ntable or if you have made many changes to a table with variable-length\nrows (tables that have VARCHAR, VARBINARY, BLOB, or TEXT columns).\nDeleted rows are maintained in a linked list and subsequent INSERT\noperations reuse old row positions. You can use OPTIMIZE TABLE to\nreclaim the unused space and to defragment the data file. After\nextensive changes to a table, this statement may also improve\nperformance of statements that use the table, sometimes significantly.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nOPTIMIZE TABLE is supported for partitioned tables, and you can use\nALTER TABLE ... OPTIMIZE PARTITION to optimize one or more partitions;\nfor more information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/optimize-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/optimize-table.html'),(116,'DECODE',12,'Syntax:\nDECODE(crypt_str,pass_str)\n\nDecrypts the encrypted string crypt_str using pass_str as the password.\ncrypt_str should be a string returned from ENCODE().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(117,'<=>',18,'Syntax:\n<=>\n\nNULL-safe equal. This operator performs an equality comparison like the\n= operator, but returns 1 rather than NULL if both operands are NULL,\nand 0 rather than NULL if one operand is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 1 <=> 1, NULL <=> NULL, 1 <=> NULL;\n        -> 1, 1, 0\nmysql> SELECT 1 = 1, NULL = NULL, 1 = NULL;\n        -> 1, NULL, NULL\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(118,'HELP STATEMENT',28,'Syntax:\nHELP \'search_string\'\n\nThe HELP statement returns online information from the MySQL Reference\nmanual. Its proper operation requires that the help tables in the mysql\ndatabase be initialized with help topic information (see\nhttp://dev.mysql.com/doc/refman/5.5/en/server-side-help-support.html).\n\nThe HELP statement searches the help tables for the given search string\nand displays the result of the search. The search string is not case\nsensitive.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/help.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/help.html'),(119,'RESET',26,'Syntax:\nRESET reset_option [, reset_option] ...\n\nThe RESET statement is used to clear the state of various server\noperations. You must have the RELOAD privilege to execute RESET.\n\nRESET acts as a stronger version of the FLUSH statement. See [HELP\nFLUSH].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/reset.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/reset.html'),(120,'GET_LOCK',15,'Syntax:\nGET_LOCK(str,timeout)\n\nTries to obtain a lock with a name given by the string str, using a\ntimeout of timeout seconds. Returns 1 if the lock was obtained\nsuccessfully, 0 if the attempt timed out (for example, because another\nclient has previously locked the name), or NULL if an error occurred\n(such as running out of memory or the thread was killed with mysqladmin\nkill). If you have a lock obtained with GET_LOCK(), it is released when\nyou execute RELEASE_LOCK(), execute a new GET_LOCK(), or your\nconnection terminates (either normally or abnormally). Locks obtained\nwith GET_LOCK() do not interact with transactions. That is, committing\na transaction does not release any such locks obtained during the\ntransaction.\n\nThis function can be used to implement application locks or to simulate\nrecord locks. Names are locked on a server-wide basis. If a name has\nbeen locked by one client, GET_LOCK() blocks any request by another\nclient for a lock with the same name. This enables clients that agree\non a given lock name to use the name to perform cooperative advisory\nlocking. But be aware that it also enables a client that is not among\nthe set of cooperating clients to lock a name, either inadvertently or\ndeliberately, and thus prevent any of the cooperating clients from\nlocking that name. One way to reduce the likelihood of this is to use\nlock names that are database-specific or application-specific. For\nexample, use lock names of the form db_name.str or app_name.str.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> SELECT GET_LOCK(\'lock1\',10);\n        -> 1\nmysql> SELECT IS_FREE_LOCK(\'lock2\');\n        -> 1\nmysql> SELECT GET_LOCK(\'lock2\',10);\n        -> 1\nmysql> SELECT RELEASE_LOCK(\'lock2\');\n        -> 1\nmysql> SELECT RELEASE_LOCK(\'lock1\');\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(121,'UCASE',36,'Syntax:\nUCASE(str)\n\nUCASE() is a synonym for UPPER().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(122,'SHOW BINLOG EVENTS',26,'Syntax:\nSHOW BINLOG EVENTS\n   [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\n\nShows the events in the binary log. If you do not specify \'log_name\',\nthe first binary log is displayed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-binlog-events.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-binlog-events.html'),(123,'MPOLYFROMWKB',32,'MPolyFromWKB(wkb[,srid]), MultiPolygonFromWKB(wkb[,srid])\n\nConstructs a MULTIPOLYGON value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(124,'ITERATE',23,'Syntax:\nITERATE label\n\nITERATE can appear only within LOOP, REPEAT, and WHILE statements.\nITERATE means \"start the loop again.\"\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/iterate-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/iterate-statement.html'),(125,'DO',27,'Syntax:\nDO expr [, expr] ...\n\nDO executes the expressions but does not return any results. In most\nrespects, DO is shorthand for SELECT expr, ..., but has the advantage\nthat it is slightly faster when you do not care about the result.\n\nDO is useful primarily with functions that have side effects, such as\nRELEASE_LOCK().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/do.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/do.html'),(126,'CURTIME',31,'Syntax:\nCURTIME()\n\nReturns the current time as a value in \'HH:MM:SS\' or HHMMSS.uuuuuu\nformat, depending on whether the function is used in a string or\nnumeric context. The value is expressed in the current time zone.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT CURTIME();\n        -> \'23:50:26\'\nmysql> SELECT CURTIME() + 0;\n        -> 235026.000000\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(127,'CHAR_LENGTH',36,'Syntax:\nCHAR_LENGTH(str)\n\nReturns the length of the string str, measured in characters. A\nmulti-byte character counts as a single character. This means that for\na string containing five two-byte characters, LENGTH() returns 10,\nwhereas CHAR_LENGTH() returns 5.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(128,'BIGINT',22,'BIGINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA large integer. The signed range is -9223372036854775808 to\n9223372036854775807. The unsigned range is 0 to 18446744073709551615.\n\nSERIAL is an alias for BIGINT UNSIGNED NOT NULL AUTO_INCREMENT UNIQUE.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(129,'SET',26,'Syntax:\nSET variable_assignment [, variable_assignment] ...\n\nvariable_assignment:\n      user_var_name = expr\n    | [GLOBAL | SESSION] system_var_name = expr\n    | [@@global. | @@session. | @@]system_var_name = expr\n\nThe SET statement assigns values to different types of variables that\naffect the operation of the server or your client. Older versions of\nMySQL employed SET OPTION, but this syntax is deprecated in favor of\nSET without OPTION.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/set-option.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/set-option.html'),(130,'LOAD XML',27,'Syntax:\nLOAD XML [LOW_PRIORITY | CONCURRENT] [LOCAL] INFILE \'file_name\'\n[REPLACE | IGNORE]\nINTO TABLE [db_name.]tbl_name\n[CHARACTER SET charset_name]\n[ROWS IDENTIFIED BY \'<tagname>\']\n[IGNORE number [LINES | ROWS]]\n[(column_or_user_var,...)]\n[SET col_name = expr,...]\n\nThe LOAD XML statement reads data from an XML file into a table. The\nfile_name must be given as a literal string. The tagname in the\noptional ROWS IDENTIFIED BY clause must also be given as a literal\nstring, and must be surrounded by angle brackets (< and >).\n\nLOAD XML acts as the complement of running the mysql client in XML\noutput mode (that is, starting the client with the --xml option). To\nwrite data from a table to an XML file, use a command such as the\nfollowing one from the system shell:\n\nshell> mysql --xml -e \'SELECT * FROM mytable\' > file.xml\n\nTo read the file back into a table, use LOAD XML INFILE. By default,\nthe <row> element is considered to be the equivalent of a database\ntable row; this can be changed using the ROWS IDENTIFIED BY clause.\n\nThis statement supports three different XML formats:\n\no Column names as attributes and column values as attribute values:\n\n<row column1=\"value1\" column2=\"value2\" .../>\n\no Column names as tags and column values as the content of these tags:\n\n<row>\n  <column1>value1</column1>\n  <column2>value2</column2>\n</row>\n\no Column names are the name attributes of <field> tags, and values are\n  the contents of these tags:\n\n<row>\n  <field name=\'column1\'>value1</field>\n  <field name=\'column2\'>value2</field>\n</row>\n\n  This is the format used by other MySQL tools, such as mysqldump.\n\nAll 3 formats can be used in the same XML file; the import routine\nautomatically detects the format for each row and interprets it\ncorrectly. Tags are matched based on the tag or attribute name and the\ncolumn name.\n\nThe following clauses work essentially the same way for LOAD XML as\nthey do for LOAD DATA:\n\no LOW_PRIORITY or CONCURRENT\n\no LOCAL\n\no REPLACE or IGNORE\n\no CHARACTER SET\n\no (column_or_user_var,...)\n\no SET\n\nSee [HELP LOAD DATA], for more information about these clauses.\n\nThe IGNORE number LINES or IGNORE number ROWS clause causes the first\nnumber rows in the XML file to be skipped. It is analogous to the LOAD\nDATA statement\'s IGNORE ... LINES clause.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/load-xml.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/load-xml.html'),(131,'CONV',4,'Syntax:\nCONV(N,from_base,to_base)\n\nConverts numbers between different number bases. Returns a string\nrepresentation of the number N, converted from base from_base to base\nto_base. Returns NULL if any argument is NULL. The argument N is\ninterpreted as an integer, but may be specified as an integer or a\nstring. The minimum base is 2 and the maximum base is 36. If to_base is\na negative number, N is regarded as a signed number. Otherwise, N is\ntreated as unsigned. CONV() works with 64-bit precision.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT CONV(\'a\',16,2);\n        -> \'1010\'\nmysql> SELECT CONV(\'6E\',18,8);\n        -> \'172\'\nmysql> SELECT CONV(-17,10,-18);\n        -> \'-H\'\nmysql> SELECT CONV(10+\'10\'+\'10\'+0xa,10,10);\n        -> \'40\'\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(132,'DATE',22,'DATE\n\nA date. The supported range is \'1000-01-01\' to \'9999-12-31\'. MySQL\ndisplays DATE values in \'YYYY-MM-DD\' format, but permits assignment of\nvalues to DATE columns using either strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html'),(133,'ASSIGN-VALUE',14,'Syntax:\n:=\n\nAssignment operator. Causes the user variable on the left hand side of\nthe operator to take on the value to its right. The value on the right\nhand side may be a literal value, another variable storing a value, or\nany legal expression that yields a scalar value, including the result\nof a query (provided that this value is a scalar value). You can\nperform multiple assignments in the same SET statement. You can perform\nmultiple assignments in the same statement-\n\nUnlike =, the := operator is never interpreted as a comparison\noperator. This means you can use := in any valid SQL statement (not\njust in SET statements) to assign a value to a variable.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/assignment-operators.html\n\n','mysql> SELECT @var1, @var2;\n        -> NULL, NULL\nmysql> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nmysql> SELECT @var1, @var2;\n        -> 1, 1\n\nmysql> SELECT @var1:=COUNT(*) FROM t1;\n        -> 4\nmysql> SELECT @var1;\n        -> 4\n','http://dev.mysql.com/doc/refman/5.5/en/assignment-operators.html'),(134,'SHOW OPEN TABLES',26,'Syntax:\nSHOW OPEN TABLES [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW OPEN TABLES lists the non-TEMPORARY tables that are currently open\nin the table cache. See\nhttp://dev.mysql.com/doc/refman/5.5/en/table-cache.html. The FROM\nclause, if present, restricts the tables shown to those present in the\ndb_name database. The LIKE clause, if present, indicates which table\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-open-tables.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-open-tables.html'),(135,'EXTRACT',31,'Syntax:\nEXTRACT(unit FROM date)\n\nThe EXTRACT() function uses the same kinds of unit specifiers as\nDATE_ADD() or DATE_SUB(), but extracts parts from the date rather than\nperforming date arithmetic.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT EXTRACT(YEAR FROM \'2009-07-02\');\n       -> 2009\nmysql> SELECT EXTRACT(YEAR_MONTH FROM \'2009-07-02 01:02:03\');\n       -> 200907\nmysql> SELECT EXTRACT(DAY_MINUTE FROM \'2009-07-02 01:02:03\');\n       -> 20102\nmysql> SELECT EXTRACT(MICROSECOND\n    ->                FROM \'2003-01-02 10:30:00.000123\');\n        -> 123\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(136,'ENCRYPT',12,'Syntax:\nENCRYPT(str[,salt])\n\nEncrypts str using the Unix crypt() system call and returns a binary\nstring. The salt argument must be a string with at least two characters\nor the result will be NULL. If no salt argument is given, a random\nvalue is used.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT ENCRYPT(\'hello\');\n        -> \'VxuFAJXVARROc\'\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(137,'SHOW STATUS',26,'Syntax:\nSHOW [GLOBAL | SESSION] STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW STATUS provides server status information. This information also\ncan be obtained using the mysqladmin extended-status command. The LIKE\nclause, if present, indicates which variable names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in http://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\nThis statement does not require any privilege. It requires only the\nability to connect to the server.\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern:\n\nmysql> SHOW STATUS LIKE \'Key%\';\n+--------------------+----------+\n| Variable_name      | Value    |\n+--------------------+----------+\n| Key_blocks_used    | 14955    |\n| Key_read_requests  | 96854827 |\n| Key_reads          | 162040   |\n| Key_write_requests | 7589728  |\n| Key_writes         | 3813196  |\n+--------------------+----------+\n\nWith the GLOBAL modifier, SHOW STATUS displays the status values for\nall connections to MySQL. With SESSION, it displays the status values\nfor the current connection. If no modifier is present, the default is\nSESSION. LOCAL is a synonym for SESSION.\n\nSome status variables have only a global value. For these, you get the\nsame value for both GLOBAL and SESSION. The scope for each status\nvariable is listed at\nhttp://dev.mysql.com/doc/refman/5.5/en/server-status-variables.html.\n\nEach invocation of the SHOW STATUS statement uses an internal temporary\ntable and increments the global Created_tmp_tables value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-status.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-status.html'),(138,'EXTRACTVALUE',36,'Syntax:\nExtractValue(xml_frag, xpath_expr)\n\nExtractValue() takes two string arguments, a fragment of XML markup\nxml_frag and an XPath expression xpath_expr (also known as a locator);\nit returns the text (CDATA) of the first text node which is a child of\nthe element(s) matched by the XPath expression. It is the equivalent of\nperforming a match using the xpath_expr after appending /text(). In\nother words, ExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b\') and\nExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b/text()\') produce the same\nresult.\n\nIf multiple matches are found, the content of the first child text node\nof each matching element is returned (in the order matched) as a\nsingle, space-delimited string.\n\nIf no matching text node is found for the expression (including the\nimplicit /text())---for whatever reason, as long as xpath_expr is\nvalid, and xml_frag consists of elements which are properly nested and\nclosed---an empty string is returned. No distinction is made between a\nmatch on an empty element and no match at all. This is by design.\n\nIf you need to determine whether no matching element was found in\nxml_frag or such an element was found but contained no child text\nnodes, you should test the result of an expression that uses the XPath\ncount() function. For example, both of these statements return an empty\nstring, as shown here:\n\nmysql> SELECT ExtractValue(\'<a><b/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT ExtractValue(\'<a><c/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nHowever, you can determine whether there was actually a matching\nelement using the following:\n\nmysql> SELECT ExtractValue(\'<a><b/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 1                                   |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT ExtractValue(\'<a><c/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 0                                   |\n+-------------------------------------+\n1 row in set (0.01 sec)\n\n*Important*: ExtractValue() returns only CDATA, and does not return any\ntags that might be contained within a matching tag, nor any of their\ncontent (see the result returned as val1 in the following example).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/xml-functions.html\n\n','mysql> SELECT\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a\') AS val1,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a/b\') AS val2,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'//b\') AS val3,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/b\') AS val4,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b><b>eee</b></a>\', \'//b\') AS val5;\n\n+------+------+------+------+---------+\n| val1 | val2 | val3 | val4 | val5    |\n+------+------+------+------+---------+\n| ccc  | ddd  | ddd  |      | ddd eee |\n+------+------+------+------+---------+\n','http://dev.mysql.com/doc/refman/5.5/en/xml-functions.html'),(139,'OLD_PASSWORD',12,'Syntax:\nOLD_PASSWORD(str)\n\nOLD_PASSWORD() was added when the implementation of PASSWORD() was\nchanged in MySQL 4.1 to improve security. OLD_PASSWORD() returns the\nvalue of the pre-4.1 implementation of PASSWORD() as a string, and is\nintended to permit you to reset passwords for any pre-4.1 clients that\nneed to connect to your version 5.5 MySQL server without locking them\nout. See http://dev.mysql.com/doc/refman/5.5/en/password-hashing.html.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(140,'FORMAT',36,'Syntax:\nFORMAT(X,D[,locale])\n\nFormats the number X to a format like \'#,###,###.##\', rounded to D\ndecimal places, and returns the result as a string. If D is 0, the\nresult has no decimal point or fractional part.\n\nThe optional third parameter enables a locale to be specified to be\nused for the result number\'s decimal point, thousands separator, and\ngrouping between separators. Permissible locale values are the same as\nthe legal values for the lc_time_names system variable (see\nhttp://dev.mysql.com/doc/refman/5.5/en/locale-support.html). If no\nlocale is specified, the default is \'en_US\'.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT FORMAT(12332.123456, 4);\n        -> \'12,332.1235\'\nmysql> SELECT FORMAT(12332.1,4);\n        -> \'12,332.1000\'\nmysql> SELECT FORMAT(12332.2,0);\n        -> \'12,332\'\nmysql> SELECT FORMAT(12332.2,2,\'de_DE\');\n        -> \'12.332,20\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(141,'||',14,'Syntax:\nOR, ||\n\nLogical OR. When both operands are non-NULL, the result is 1 if any\noperand is nonzero, and 0 otherwise. With a NULL operand, the result is\n1 if the other operand is nonzero, and NULL otherwise. If both operands\nare NULL, the result is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html\n\n','mysql> SELECT 1 || 1;\n        -> 1\nmysql> SELECT 1 || 0;\n        -> 1\nmysql> SELECT 0 || 0;\n        -> 0\nmysql> SELECT 0 || NULL;\n        -> NULL\nmysql> SELECT 1 || NULL;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html'),(142,'BIT_LENGTH',36,'Syntax:\nBIT_LENGTH(str)\n\nReturns the length of the string str in bits.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT BIT_LENGTH(\'text\');\n        -> 32\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(143,'EXTERIORRING',2,'ExteriorRing(poly)\n\nReturns the exterior ring of the Polygon value poly as a LineString.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT AsText(ExteriorRing(GeomFromText(@poly)));\n+-------------------------------------------+\n| AsText(ExteriorRing(GeomFromText(@poly))) |\n+-------------------------------------------+\n| LINESTRING(0 0,0 3,3 3,3 0,0 0)           |\n+-------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions'),(144,'GEOMFROMWKB',32,'GeomFromWKB(wkb[,srid]), GeometryFromWKB(wkb[,srid])\n\nConstructs a geometry value of any type using its WKB representation\nand SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(145,'SHOW SLAVE HOSTS',26,'Syntax:\nSHOW SLAVE HOSTS\n\nDisplays a list of replication slaves currently registered with the\nmaster. (Before MySQL 5.5.3, only slaves started with the\n--report-host=host_name option are visible in this list.)\n\nThe list is displayed on any server (not just the master server). The\noutput looks like this:\n\nmysql> SHOW SLAVE HOSTS;\n+------------+-----------+------+-----------+\n| Server_id  | Host      | Port | Master_id |\n+------------+-----------+------+-----------+\n|  192168010 | iconnect2 | 3306 | 192168011 |\n| 1921680101 | athena    | 3306 | 192168011 |\n+------------+-----------+------+-----------+\n\no Server_id: The unique server ID of the slave server, as configured in\n  the server\'s option file, or on the command line with\n  --server-id=value.\n\no Host: The host name of the slave server, as configured in the\n  server\'s option file, or on the command line with\n  --report-host=host_name. Note that this can differ from the machine\n  name as configured in the operating system.\n\no Port: The port the slave server is listening on.\n\no Master_id: The unique server ID of the master server that the slave\n  server is replicating from.\n\nSome MySQL versions report another variable, Rpl_recovery_rank. This\nvariable was never used, and was removed in MySQL 5.5.3. (Bug #13963)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-slave-hosts.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-slave-hosts.html'),(146,'START TRANSACTION',8,'Syntax:\nSTART TRANSACTION [WITH CONSISTENT SNAPSHOT] | BEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN | [NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN | [NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThe START TRANSACTION or BEGIN statement begins a new transaction.\nCOMMIT commits the current transaction, making its changes permanent.\nROLLBACK rolls back the current transaction, canceling its changes. The\nSET autocommit statement disables or enables the default autocommit\nmode for the current session.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttp://dev.mysql.com/doc/refman/5.5/en/server-system-variables.html.\n\n*Note*: Within all stored programs (stored procedures and functions,\ntriggers, and events), the parser treats BEGIN [WORK] as the beginning\nof a BEGIN ... END block. Begin a transaction in this context with\nSTART TRANSACTION instead.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The RELEASE clause causes the\nserver to disconnect the current client session after terminating the\ncurrent transaction. Including the NO keyword suppresses CHAIN or\nRELEASE completion, which can be useful if the completion_type system\nvariable is set to cause chaining or release completion by default.\n\nBy default, MySQL runs with autocommit mode enabled. This means that as\nsoon as you execute a statement that updates (modifies) a table, MySQL\nstores the update on disk to make it permanent. To disable autocommit\nmode, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB or\nNDBCLUSTER) are not made permanent immediately. You must use COMMIT to\nstore your changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. If\nyou want to disable autocommit mode for each new connection, see the\ndescription of the autocommit system variable at\nhttp://dev.mysql.com/doc/refman/5.5/en/server-system-variables.html.\n\nTo disable autocommit mode for a single series of statements, use the\nSTART TRANSACTION statement:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/commit.html\n\n','START TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n','http://dev.mysql.com/doc/refman/5.5/en/commit.html'),(147,'BETWEEN AND',18,'Syntax:\nexpr BETWEEN min AND max\n\nIf expr is greater than or equal to min and expr is less than or equal\nto max, BETWEEN returns 1, otherwise it returns 0. This is equivalent\nto the expression (min <= expr AND expr <= max) if all the arguments\nare of the same type. Otherwise type conversion takes place according\nto the rules described in\nhttp://dev.mysql.com/doc/refman/5.5/en/type-conversion.html, but\napplied to all the three arguments.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 2 BETWEEN 1 AND 3, 2 BETWEEN 3 and 1;\n        -> 1, 0\nmysql> SELECT 1 BETWEEN 2 AND 3;\n        -> 0\nmysql> SELECT \'b\' BETWEEN \'a\' AND \'c\';\n        -> 1\nmysql> SELECT 2 BETWEEN 2 AND \'3\';\n        -> 1\nmysql> SELECT 2 BETWEEN 2 AND \'x-3\';\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(148,'MULTIPOLYGON',24,'MultiPolygon(poly1,poly2,...)\n\nConstructs a MultiPolygon value from a set of Polygon or WKB Polygon\narguments.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(149,'TIME_FORMAT',31,'Syntax:\nTIME_FORMAT(time,format)\n\nThis is used like the DATE_FORMAT() function, but the format string may\ncontain format specifiers only for hours, minutes, seconds, and\nmicroseconds. Other specifiers produce a NULL value or 0.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIME_FORMAT(\'100:00:00\', \'%H %k %h %I %l\');\n        -> \'100 100 04 04 4\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(150,'LEFT',36,'Syntax:\nLEFT(str,len)\n\nReturns the leftmost len characters from the string str, or NULL if any\nargument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT LEFT(\'foobarbar\', 5);\n        -> \'fooba\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(151,'FLUSH QUERY CACHE',26,'You can defragment the query cache to better utilize its memory with\nthe FLUSH QUERY CACHE statement. The statement does not remove any\nqueries from the cache.\n\nThe RESET QUERY CACHE statement removes all query results from the\nquery cache. The FLUSH TABLES statement also does this.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/query-cache-status-and-maintenance.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/query-cache-status-and-maintenance.html'),(152,'SET DATA TYPE',22,'SET(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA set. A string object that can have zero or more values, each of which\nmust be chosen from the list of values \'value1\', \'value2\', ... A SET\ncolumn can have a maximum of 64 members. SET values are represented\ninternally as integers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(153,'RAND',4,'Syntax:\nRAND(), RAND(N)\n\nReturns a random floating-point value v in the range 0 <= v < 1.0. If a\nconstant integer argument N is specified, it is used as the seed value,\nwhich produces a repeatable sequence of column values. In the following\nexample, note that the sequences of values produced by RAND(3) is the\nsame both places where it occurs.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> CREATE TABLE t (i INT);\nQuery OK, 0 rows affected (0.42 sec)\n\nmysql> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nmysql> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.61914388706828 |\n|    2 | 0.93845168309142 |\n|    3 | 0.83482678498591 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.35877890638893 |\n|    2 | 0.28941420772058 |\n|    3 | 0.37073435016976 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.01 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(154,'RPAD',36,'Syntax:\nRPAD(str,len,padstr)\n\nReturns the string str, right-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT RPAD(\'hi\',5,\'?\');\n        -> \'hi???\'\nmysql> SELECT RPAD(\'hi\',1,\'?\');\n        -> \'h\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(155,'CREATE DATABASE',38,'Syntax:\nCREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n    [create_specification] ...\n\ncreate_specification:\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n\nCREATE DATABASE creates a database with the given name. To use this\nstatement, you need the CREATE privilege for the database. CREATE\nSCHEMA is a synonym for CREATE DATABASE.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-database.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-database.html'),(156,'DEC',22,'DEC[(M[,D])] [UNSIGNED] [ZEROFILL], NUMERIC[(M[,D])] [UNSIGNED]\n[ZEROFILL], FIXED[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nThese types are synonyms for DECIMAL. The FIXED synonym is available\nfor compatibility with other database systems.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(157,'VAR_POP',16,'Syntax:\nVAR_POP(expr)\n\nReturns the population standard variance of expr. It considers rows as\nthe whole population, not as a sample, so it has the number of rows as\nthe denominator. You can also use VARIANCE(), which is equivalent but\nis not standard SQL.\n\nVAR_POP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(158,'ELT',36,'Syntax:\nELT(N,str1,str2,str3,...)\n\nReturns str1 if N = 1, str2 if N = 2, and so on. Returns NULL if N is\nless than 1 or greater than the number of arguments. ELT() is the\ncomplement of FIELD().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT ELT(1, \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> \'ej\'\nmysql> SELECT ELT(4, \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> \'foo\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(159,'ALTER VIEW',38,'Syntax:\nALTER\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = { user | CURRENT_USER }]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThis statement changes the definition of a view, which must exist. The\nsyntax is similar to that for CREATE VIEW and the effect is the same as\nfor CREATE OR REPLACE VIEW. See [HELP CREATE VIEW]. This statement\nrequires the CREATE VIEW and DROP privileges for the view, and some\nprivilege for each column referred to in the SELECT statement. ALTER\nVIEW is permitted only to the definer or users with the SUPER\nprivilege.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-view.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-view.html'),(160,'SHOW DATABASES',26,'Syntax:\nSHOW {DATABASES | SCHEMAS}\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW DATABASES lists the databases on the MySQL server host. SHOW\nSCHEMAS is a synonym for SHOW DATABASES. The LIKE clause, if present,\nindicates which database names to match. The WHERE clause can be given\nto select rows using more general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nYou see only those databases for which you have some kind of privilege,\nunless you have the global SHOW DATABASES privilege. You can also get\nthis list using the mysqlshow command.\n\nIf the server was started with the --skip-show-database option, you\ncannot use this statement at all unless you have the SHOW DATABASES\nprivilege.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-databases.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-databases.html'),(161,'~',19,'Syntax:\n~\n\nInvert all bits.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT 5 & ~1;\n        -> 4\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(162,'TEXT',22,'TEXT[(M)] [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 65,535 (216 - 1) characters. The\neffective maximum length is less if the value contains multi-byte\ncharacters. Each TEXT value is stored using a two-byte length prefix\nthat indicates the number of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest TEXT type large enough to hold\nvalues M characters long.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(163,'CONCAT_WS',36,'Syntax:\nCONCAT_WS(separator,str1,str2,...)\n\nCONCAT_WS() stands for Concatenate With Separator and is a special form\nof CONCAT(). The first argument is the separator for the rest of the\narguments. The separator is added between the strings to be\nconcatenated. The separator can be a string, as can the rest of the\narguments. If the separator is NULL, the result is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT CONCAT_WS(\',\',\'First name\',\'Second name\',\'Last Name\');\n        -> \'First name,Second name,Last Name\'\nmysql> SELECT CONCAT_WS(\',\',\'First name\',NULL,\'Last Name\');\n        -> \'First name,Last Name\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(164,'ROW_COUNT',17,'Syntax:\nROW_COUNT()\n\nBefore MySQL 5.5.5, ROW_COUNT() returns the number of rows changed,\ndeleted, or inserted by the last statement if it was an UPDATE, DELETE,\nor INSERT. For other statements, the value may not be meaningful.\n\nAs of MySQL 5.5.5, ROW_COUNT() returns a value as follows:\n\no DDL statements: 0. This applies to statements such as CREATE TABLE or\n  DROP TABLE.\n\no DML statements other than SELECT: The number of affected rows. This\n  applies to statements such as UPDATE, INSERT, or DELETE (as before),\n  but now also to statements such as ALTER TABLE and LOAD DATA INFILE.\n\no SELECT: -1 if the statement returns a result set, or the number of\n  rows \"affected\" if it does not. For example, for SELECT * FROM t1,\n  ROW_COUNT() returns -1. For SELECT * FROM t1 INTO OUTFILE\n  \'file_name\', ROW_COUNT() returns the number of rows written to the\n  file.\n\no SIGNAL statements: 0.\n\nFor UPDATE statements, the affected-rows value by default is the number\nof rows actually changed. If you specify the CLIENT_FOUND_ROWS flag to\nmysql_real_connect() when connecting to mysqld, the affected-rows value\nis the number of rows \"found\"; that is, matched by the WHERE clause.\n\nFor REPLACE statements, the affected-rows value is 2 if the new row\nreplaced an old row, because in this case, one row was inserted after\nthe duplicate was deleted.\n\nFor INSERT ... ON DUPLICATE KEY UPDATE statements, the affected-rows\nvalue is 1 if the row is inserted as a new row and 2 if an existing row\nis updated.\n\nThe ROW_COUNT() value is similar to the value from the\nmysql_affected_rows() C API function and the row count that the mysql\nclient displays following statement execution.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nmysql> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           3 |\n+-------------+\n1 row in set (0.00 sec)\n\nmysql> DELETE FROM t WHERE i IN(1,2);\nQuery OK, 2 rows affected (0.00 sec)\n\nmysql> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           2 |\n+-------------+\n1 row in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(165,'ASIN',4,'Syntax:\nASIN(X)\n\nReturns the arc sine of X, that is, the value whose sine is X. Returns\nNULL if X is not in the range -1 to 1.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT ASIN(0.2);\n        -> 0.20135792079033\nmysql> SELECT ASIN(\'foo\');\n\n+-------------+\n| ASIN(\'foo\') |\n+-------------+\n|           0 |\n+-------------+\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS;\n+---------+------+-----------------------------------------+\n| Level   | Code | Message                                 |\n+---------+------+-----------------------------------------+\n| Warning | 1292 | Truncated incorrect DOUBLE value: \'foo\' |\n+---------+------+-----------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(166,'SIGN',4,'Syntax:\nSIGN(X)\n\nReturns the sign of the argument as -1, 0, or 1, depending on whether X\nis negative, zero, or positive.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT SIGN(-32);\n        -> -1\nmysql> SELECT SIGN(0);\n        -> 0\nmysql> SELECT SIGN(234);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(167,'SEC_TO_TIME',31,'Syntax:\nSEC_TO_TIME(seconds)\n\nReturns the seconds argument, converted to hours, minutes, and seconds,\nas a TIME value. The range of the result is constrained to that of the\nTIME data type. A warning occurs if the argument corresponds to a value\noutside that range.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT SEC_TO_TIME(2378);\n        -> \'00:39:38\'\nmysql> SELECT SEC_TO_TIME(2378) + 0;\n        -> 3938\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(168,'FLOAT',22,'FLOAT[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA small (single-precision) floating-point number. Permissible values\nare -3.402823466E+38 to -1.175494351E-38, 0, and 1.175494351E-38 to\n3.402823466E+38. These are the theoretical limits, based on the IEEE\nstandard. The actual range might be slightly smaller depending on your\nhardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A single-precision floating-point\nnumber is accurate to approximately 7 decimal places.\n\nUNSIGNED, if specified, disallows negative values.\n\nUsing FLOAT might give you some unexpected problems because all\ncalculations in MySQL are done with double precision. See\nhttp://dev.mysql.com/doc/refman/5.5/en/no-matching-rows.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(169,'LOCATE',36,'Syntax:\nLOCATE(substr,str), LOCATE(substr,str,pos)\n\nThe first syntax returns the position of the first occurrence of\nsubstring substr in string str. The second syntax returns the position\nof the first occurrence of substring substr in string str, starting at\nposition pos. Returns 0 if substr is not in str.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT LOCATE(\'bar\', \'foobarbar\');\n        -> 4\nmysql> SELECT LOCATE(\'xbar\', \'foobar\');\n        -> 0\nmysql> SELECT LOCATE(\'bar\', \'foobarbar\', 5);\n        -> 7\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(170,'SHOW EVENTS',26,'Syntax:\nSHOW EVENTS [{FROM | IN} schema_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nIn its simplest form, SHOW EVENTS lists all of the events in the\ncurrent schema:\n\nmysql> SELECT CURRENT_USER(), SCHEMA();\n+----------------+----------+\n| CURRENT_USER() | SCHEMA() |\n+----------------+----------+\n| jon@ghidora    | myschema |\n+----------------+----------+\n1 row in set (0.00 sec)\n\nmysql> SHOW EVENTS\\G\n*************************** 1. row ***************************\n                  Db: myschema\n                Name: e_daily\n             Definer: jon@ghidora\n           Time zone: SYSTEM\n                Type: RECURRING\n          Execute at: NULL\n      Interval value: 10\n      Interval field: SECOND\n              Starts: 2006-02-09 10:41:23\n                Ends: NULL\n              Status: ENABLED\n          Originator: 0\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\nTo see events for a specific schema, use the FROM clause. For example,\nto see events for the test schema, use the following statement:\n\nSHOW EVENTS FROM test;\n\nThe LIKE clause, if present, indicates which event names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-events.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-events.html'),(171,'CHARSET',17,'Syntax:\nCHARSET(str)\n\nReturns the character set of the string argument.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT CHARSET(\'abc\');\n        -> \'latin1\'\nmysql> SELECT CHARSET(CONVERT(\'abc\' USING utf8));\n        -> \'utf8\'\nmysql> SELECT CHARSET(USER());\n        -> \'utf8\'\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(172,'SUBDATE',31,'Syntax:\nSUBDATE(date,INTERVAL expr unit), SUBDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, SUBDATE()\nis a synonym for DATE_SUB(). For information on the INTERVAL unit\nargument, see the discussion for DATE_ADD().\n\nmysql> SELECT DATE_SUB(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\nmysql> SELECT SUBDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\n\nThe second form enables the use of an integer value for days. In such\ncases, it is interpreted as the number of days to be subtracted from\nthe date or datetime expression expr.\n\nmysql> SELECT SUBDATE(\'2008-01-02 12:00:00\', 31);\n        -> \'2007-12-02 12:00:00\'\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(173,'DAYOFYEAR',31,'Syntax:\nDAYOFYEAR(date)\n\nReturns the day of the year for date, in the range 1 to 366.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFYEAR(\'2007-02-03\');\n        -> 34\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(174,'LONGTEXT',22,'LONGTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 4,294,967,295 or 4GB (232 - 1)\ncharacters. The effective maximum length is less if the value contains\nmulti-byte characters. The effective maximum length of LONGTEXT columns\nalso depends on the configured maximum packet size in the client/server\nprotocol and available memory. Each LONGTEXT value is stored using a\nfour-byte length prefix that indicates the number of bytes in the\nvalue.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(175,'%',4,'Syntax:\nN % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M. For more\ninformation, see the description for the MOD() function in\nhttp://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(176,'KILL',26,'Syntax:\nKILL [CONNECTION | QUERY] thread_id\n\nEach connection to mysqld runs in a separate thread. You can see which\nthreads are running with the SHOW PROCESSLIST statement and kill a\nthread with the KILL thread_id statement.\n\nKILL permits an optional CONNECTION or QUERY modifier:\n\no KILL CONNECTION is the same as KILL with no modifier: It terminates\n  the connection associated with the given thread_id.\n\no KILL QUERY terminates the statement that the connection is currently\n  executing, but leaves the connection itself intact.\n\nIf you have the PROCESS privilege, you can see all threads. If you have\nthe SUPER privilege, you can kill all threads and statements.\nOtherwise, you can see and kill only your own threads and statements.\n\nYou can also use the mysqladmin processlist and mysqladmin kill\ncommands to examine and kill threads.\n\n*Note*: You cannot use KILL with the Embedded MySQL Server library\nbecause the embedded server merely runs inside the threads of the host\napplication. It does not create any connection threads of its own.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/kill.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/kill.html'),(177,'DISJOINT',30,'Disjoint(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially disjoint from (does\nnot intersect) g2.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(178,'ASTEXT',3,'AsText(g), AsWKT(g)\n\nConverts a value in internal geometry format to its WKT representation\nand returns the string result.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-to-convert-geometries-between-formats.html\n\n','mysql> SET @g = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(GeomFromText(@g));\n+--------------------------+\n| AsText(GeomFromText(@g)) |\n+--------------------------+\n| LINESTRING(1 1,2 2,3 3)  |\n+--------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/functions-to-convert-geometries-between-formats.html'),(179,'LPAD',36,'Syntax:\nLPAD(str,len,padstr)\n\nReturns the string str, left-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT LPAD(\'hi\',4,\'??\');\n        -> \'??hi\'\nmysql> SELECT LPAD(\'hi\',1,\'??\');\n        -> \'h\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(180,'DECLARE CONDITION',23,'Syntax:\nDECLARE condition_name CONDITION FOR condition_value\n\ncondition_value:\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n\nThe DECLARE ... CONDITION statement declares a named error condition,\nassociating a name with a condition that needs specific handling. The\nname can be referred to in a subsequent DECLARE ... HANDLER statement\n(see [HELP DECLARE HANDLER]).\n\nCondition declarations must appear before cursor or handler\ndeclarations.\n\nThe condition_value for DECLARE ... CONDITION can be a MySQL error code\n(a number) or an SQLSTATE value (a 5-character string literal). You\nshould not use MySQL error code 0 or SQLSTATE values that begin with\n\'00\', because those indicate success rather than an error condition.\nFor a list of MySQL error codes and SQLSTATE values, see\nhttp://dev.mysql.com/doc/refman/5.5/en/error-messages-server.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/declare-condition.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/declare-condition.html'),(181,'OVERLAPS',30,'Overlaps(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially overlaps g2. The term\nspatially overlaps is used if two geometries intersect and their\nintersection results in a geometry of the same dimension but not equal\nto either of the given geometries.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(182,'SET GLOBAL SQL_SLAVE_SKIP_COUNTER',8,'Syntax:\nSET GLOBAL sql_slave_skip_counter = N\n\nThis statement skips the next N events from the master. This is useful\nfor recovering from replication stops caused by a statement.\n\nThis statement is valid only when the slave threads are not running.\nOtherwise, it produces an error.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/set-global-sql-slave-skip-counter.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/set-global-sql-slave-skip-counter.html'),(183,'NUMGEOMETRIES',25,'NumGeometries(gc)\n\nReturns the number of geometries in the GeometryCollection value gc.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#geometrycollection-property-functions\n\n','mysql> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nmysql> SELECT NumGeometries(GeomFromText(@gc));\n+----------------------------------+\n| NumGeometries(GeomFromText(@gc)) |\n+----------------------------------+\n|                                2 |\n+----------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#geometrycollection-property-functions'),(184,'MONTHNAME',31,'Syntax:\nMONTHNAME(date)\n\nReturns the full name of the month for date. The language used for the\nname is controlled by the value of the lc_time_names system variable\n(http://dev.mysql.com/doc/refman/5.5/en/locale-support.html).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT MONTHNAME(\'2008-02-03\');\n        -> \'February\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(185,'PROCEDURE ANALYSE',37,'Syntax:\nANALYSE([max_elements[,max_memory]])\n\nANALYSE() is defined in the sql/sql_analyse.cc source file, which\nserves as an example of how to create a procedure for use with the\nPROCEDURE clause of SELECT statements. ANALYSE() is built in and is\navailable by default; other procedures can be created using the format\ndemonstrated in the source file.\n\nANALYSE() examines the result from a query and returns an analysis of\nthe results that suggests optimal data types for each column that may\nhelp reduce table sizes. To obtain this analysis, append PROCEDURE\nANALYSE to the end of a SELECT statement:\n\nSELECT ... FROM ... WHERE ... PROCEDURE ANALYSE([max_elements,[max_memory]])\n\nFor example:\n\nSELECT col1, col2 FROM table1 PROCEDURE ANALYSE(10, 2000);\n\nThe results show some statistics for the values returned by the query,\nand propose an optimal data type for the columns. This can be helpful\nfor checking your existing tables, or after importing new data. You may\nneed to try different settings for the arguments so that PROCEDURE\nANALYSE() does not suggest the ENUM data type when it is not\nappropriate.\n\nThe arguments are optional and are used as follows:\n\no max_elements (default 256) is the maximum number of distinct values\n  that ANALYSE() notices per column. This is used by ANALYSE() to check\n  whether the optimal data type should be of type ENUM; if there are\n  more than max_elements distinct values, then ENUM is not a suggested\n  type.\n\no max_memory (default 8192) is the maximum amount of memory that\n  ANALYSE() should allocate per column while trying to find all\n  distinct values.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/procedure-analyse.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/procedure-analyse.html'),(186,'CHANGE MASTER TO',8,'Syntax:\nCHANGE MASTER TO option [, option] ...\n\noption:\n    MASTER_BIND = \'interface_name\'\n  | MASTER_HOST = \'host_name\'\n  | MASTER_USER = \'user_name\'\n  | MASTER_PASSWORD = \'password\'\n  | MASTER_PORT = port_num\n  | MASTER_CONNECT_RETRY = interval\n  | MASTER_HEARTBEAT_PERIOD = interval\n  | MASTER_LOG_FILE = \'master_log_name\'\n  | MASTER_LOG_POS = master_log_pos\n  | RELAY_LOG_FILE = \'relay_log_name\'\n  | RELAY_LOG_POS = relay_log_pos\n  | MASTER_SSL = {0|1}\n  | MASTER_SSL_CA = \'ca_file_name\'\n  | MASTER_SSL_CAPATH = \'ca_directory_name\'\n  | MASTER_SSL_CERT = \'cert_file_name\'\n  | MASTER_SSL_KEY = \'key_file_name\'\n  | MASTER_SSL_CIPHER = \'cipher_list\'\n  | MASTER_SSL_VERIFY_SERVER_CERT = {0|1}\n  | IGNORE_SERVER_IDS = (server_id_list)\n\nserver_id_list:\n    [server_id [, server_id] ... ]\n\nCHANGE MASTER TO changes the parameters that the slave server uses for\nconnecting to the master server, for reading the master binary log, and\nreading the slave relay log. It also updates the contents of the\nmaster.info and relay-log.info files. To use CHANGE MASTER TO, the\nslave replication threads must be stopped (use STOP SLAVE if\nnecessary).\n\nOptions not specified retain their value, except as indicated in the\nfollowing discussion. Thus, in most cases, there is no need to specify\noptions that do not change. For example, if the password to connect to\nyour MySQL master has changed, you just need to issue these statements\nto tell the slave about the new password:\n\nSTOP SLAVE; -- if replication was running\nCHANGE MASTER TO MASTER_PASSWORD=\'new3cret\';\nSTART SLAVE; -- if you want to restart replication\n\nMASTER_HOST, MASTER_USER, MASTER_PASSWORD, and MASTER_PORT provide\ninformation to the slave about how to connect to its master:\n\no MASTER_HOST and MASTER_PORT are the host name (or IP address) of the\n  master host and its TCP/IP port.\n\n  *Note*: Replication cannot use Unix socket files. You must be able to\n  connect to the master MySQL server using TCP/IP.\n\n  If you specify the MASTER_HOST or MASTER_PORT option, the slave\n  assumes that the master server is different from before (even if the\n  option value is the same as its current value.) In this case, the old\n  values for the master binary log file name and position are\n  considered no longer applicable, so if you do not specify\n  MASTER_LOG_FILE and MASTER_LOG_POS in the statement,\n  MASTER_LOG_FILE=\'\' and MASTER_LOG_POS=4 are silently appended to it.\n\n  Setting MASTER_HOST=\'\' (that is, setting its value explicitly to an\n  empty string) is not the same as not setting MASTER_HOST at all.\n  Beginning with MySQL 5.5, trying to set MASTER_HOST to an empty\n  string fails with an error. Previously, setting MASTER_HOST to an\n  empty string caused START SLAVE subsequently to fail. (Bug #28796)\n\no MASTER_USER and MASTER_PASSWORD are the user name and password of the\n  account to use for connecting to the master.\n\n  The text of a running CHANGE MASTER TO statement, including values\n  for MASTER_USER and MASTER_PASSWORD, can be seen in the output of a\n  concurrent SHOW PROCESSLIST statement.\n\nThe MASTER_SSL_xxx options provide information about using SSL for the\nconnection. They correspond to the --ssl-xxx options described in\nhttp://dev.mysql.com/doc/refman/5.5/en/ssl-options.html, and\nhttp://dev.mysql.com/doc/refman/5.5/en/replication-solutions-ssl.html.\nThese options can be changed even on slaves that are compiled without\nSSL support. They are saved to the master.info file, but are ignored if\nthe slave does not have SSL support enabled.\n\nMASTER_CONNECT_RETRY specifies how many seconds to wait between connect\nretries. The default is 60. The number of reconnection attempts is\nlimited by the --master-retry-count server option; for more\ninformation, see\nhttp://dev.mysql.com/doc/refman/5.5/en/replication-options.html.\n\nThe MASTER_BIND option is available in MySQL Cluster NDB 7.2 and later,\nbut is not supported in mainline MySQL 5.5.\n\nMASTER_BIND is for use on replication slaves having multiple network\ninterfaces, and determines which of the slave\'s network interfaces is\nchosen for connecting to the master.\n\nMASTER_HEARTBEAT_PERIOD sets the interval in seconds between\nreplication heartbeats. Whenever the master\'s binary log is updated\nwith an event, the waiting period for the next heartbeat is reset.\ninterval is a decimal value having the range 0 to 4294967 seconds and a\nresolution in milliseconds; the smallest nonzero value is 0.001.\nHeartbeats are sent by the master only if there are no unsent events in\nthe binary log file for a period longer than interval.\n\nSetting interval to 0 disables heartbeats altogether. The default value\nfor interval is equal to the value of slave_net_timeout divided by 2.\n\nSetting @@global.slave_net_timeout to a value less than that of the\ncurrent heartbeat interval results in a warning being issued. The\neffect of issuing RESET SLAVE on the heartbeat interval is to reset it\nto the default value.\n\nMASTER_LOG_FILE and MASTER_LOG_POS are the coordinates at which the\nslave I/O thread should begin reading from the master the next time the\nthread starts. RELAY_LOG_FILE and RELAY_LOG_POS are the coordinates at\nwhich the slave SQL thread should begin reading from the relay log the\nnext time the thread starts. If you specify either of MASTER_LOG_FILE\nor MASTER_LOG_POS, you cannot specify RELAY_LOG_FILE or RELAY_LOG_POS.\nIf neither of MASTER_LOG_FILE or MASTER_LOG_POS is specified, the slave\nuses the last coordinates of the slave SQL thread before CHANGE MASTER\nTO was issued. This ensures that there is no discontinuity in\nreplication, even if the slave SQL thread was late compared to the\nslave I/O thread, when you merely want to change, say, the password to\nuse.\n\nCHANGE MASTER TO deletes all relay log files and starts a new one,\nunless you specify RELAY_LOG_FILE or RELAY_LOG_POS. In that case, relay\nlog files are kept; the relay_log_purge global variable is set silently\nto 0.\n\nPrior to MySQL 5.5, RELAY_LOG_FILE required an absolute path. In MySQL\n5.5, the path can be relative, and uses the same basename as\nMASTER_LOG_FILE. (Bug #12190)\n\nIGNORE_SERVER_IDS was added in MySQL 5.5. This option takes a\ncomma-separated list of 0 or more server IDs. Events originating from\nthe corresponding servers are ignored, with the exception of log\nrotation and deletion events, which are still recorded in the relay\nlog.\n\nIn circular replication, the originating server normally acts as the\nterminator of its own events, so that they are not applied more than\nonce. Thus, this option is useful in circular replication when one of\nthe servers in the circle is removed. Suppose that you have a circular\nreplication setup with 4 servers, having server IDs 1, 2, 3, and 4, and\nserver 3 fails. When bridging the gap by starting replication from\nserver 2 to server 4, you can include IGNORE_SERVER_IDS = (3) in the\nCHANGE MASTER TO statement that you issue on server 4 to tell it to use\nserver 2 as its master instead of server 3. Doing so causes it to\nignore and not to propagate any statements that originated with the\nserver that is no longer in use.\n\nIf a CHANGE MASTER TO statement is issued without any IGNORE_SERVER_IDS\noption, any existing list is preserved; RESET SLAVE also has no effect\non the server ID list. To clear the list of ignored servers, it is\nnecessary to use the option with an empty list:\n\nCHANGE MASTER TO IGNORE_SERVER_IDS = ();\n\nIf IGNORE_SERVER_IDS contains the server\'s own ID and the server was\nstarted with the --replicate-same-server-id option enabled, an error\nresults.\n\nAlso beginning with MySQL 5.5, the master.info file and the output of\nSHOW SLAVE STATUS are extended to provide the list of servers that are\ncurrently ignored. For more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/slave-logs-status.html, and\n[HELP SHOW SLAVE STATUS].\n\nBeginning with MySQL 5.5.5, invoking CHANGE MASTER TO causes the\nprevious values for MASTER_HOST, MASTER_PORT, MASTER_LOG_FILE, and\nMASTER_LOG_POS to be written to the error log, along with other\ninformation about the slave\'s state prior to execution.\n\nCHANGE MASTER TO is useful for setting up a slave when you have the\nsnapshot of the master and have recorded the master binary log\ncoordinates corresponding to the time of the snapshot. After loading\nthe snapshot into the slave to synchronize it to the slave, you can run\nCHANGE MASTER TO MASTER_LOG_FILE=\'log_name\', MASTER_LOG_POS=log_pos on\nthe slave to specify the coordinates at which the slave should begin\nreading the master binary log.\n\nThe following example changes the master server the slave uses and\nestablishes the master binary log coordinates from which the slave\nbegins reading. This is used when you want to set up the slave to\nreplicate the master:\n\nCHANGE MASTER TO\n  MASTER_HOST=\'master2.mycompany.com\',\n  MASTER_USER=\'replication\',\n  MASTER_PASSWORD=\'bigs3cret\',\n  MASTER_PORT=3306,\n  MASTER_LOG_FILE=\'master2-bin.001\',\n  MASTER_LOG_POS=4,\n  MASTER_CONNECT_RETRY=10;\n\nThe next example shows an operation that is less frequently employed.\nIt is used when the slave has relay log files that you want it to\nexecute again for some reason. To do this, the master need not be\nreachable. You need only use CHANGE MASTER TO and start the SQL thread\n(START SLAVE SQL_THREAD):\n\nCHANGE MASTER TO\n  RELAY_LOG_FILE=\'slave-relay-bin.006\',\n  RELAY_LOG_POS=4025;\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/change-master-to.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/change-master-to.html'),(187,'DROP DATABASE',38,'Syntax:\nDROP {DATABASE | SCHEMA} [IF EXISTS] db_name\n\nDROP DATABASE drops all tables in the database and deletes the\ndatabase. Be very careful with this statement! To use DROP DATABASE,\nyou need the DROP privilege on the database. DROP SCHEMA is a synonym\nfor DROP DATABASE.\n\n*Important*: When a database is dropped, user privileges on the\ndatabase are not automatically dropped. See [HELP GRANT].\n\nIF EXISTS is used to prevent an error from occurring if the database\ndoes not exist.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-database.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-database.html'),(188,'MBREQUAL',6,'MBREqual(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 are the same.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(189,'TIMESTAMP FUNCTION',31,'Syntax:\nTIMESTAMP(expr), TIMESTAMP(expr1,expr2)\n\nWith a single argument, this function returns the date or datetime\nexpression expr as a datetime value. With two arguments, it adds the\ntime expression expr2 to the date or datetime expression expr1 and\nreturns the result as a datetime value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMP(\'2003-12-31\');\n        -> \'2003-12-31 00:00:00\'\nmysql> SELECT TIMESTAMP(\'2003-12-31 12:00:00\',\'12:00:00\');\n        -> \'2004-01-01 00:00:00\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(190,'HELP_VERSION',9,'This help information was generated from the MySQL 5.5 Reference Manual\non: 2011-12-16 (revision: 28425)\n\nThis information applies to MySQL 5.5 through 5.5.20.\n','',''),(191,'CHARACTER_LENGTH',36,'Syntax:\nCHARACTER_LENGTH(str)\n\nCHARACTER_LENGTH() is a synonym for CHAR_LENGTH().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(192,'SHOW GRANTS',26,'Syntax:\nSHOW GRANTS [FOR user]\n\nThis statement lists the GRANT statement or statements that must be\nissued to duplicate the privileges that are granted to a MySQL user\naccount. The account is named using the same format as for the GRANT\nstatement; for example, \'jeffrey\'@\'localhost\'. If you specify only the\nuser name part of the account name, a host name part of \'%\' is used.\nFor additional information about specifying account names, see [HELP\nGRANT].\n\nmysql> SHOW GRANTS FOR \'root\'@\'localhost\';\n+---------------------------------------------------------------------+\n| Grants for root@localhost                                           |\n+---------------------------------------------------------------------+\n| GRANT ALL PRIVILEGES ON *.* TO \'root\'@\'localhost\' WITH GRANT OPTION |\n+---------------------------------------------------------------------+\n\nTo list the privileges granted to the account that you are using to\nconnect to the server, you can use any of the following statements:\n\nSHOW GRANTS;\nSHOW GRANTS FOR CURRENT_USER;\nSHOW GRANTS FOR CURRENT_USER();\n\nIf SHOW GRANTS FOR CURRENT_USER (or any of the equivalent syntaxes) is\nused in DEFINER context, such as within a stored procedure that is\ndefined with SQL SECURITY DEFINER), the grants displayed are those of\nthe definer and not the invoker.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-grants.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-grants.html'),(193,'SHOW PRIVILEGES',26,'Syntax:\nSHOW PRIVILEGES\n\nSHOW PRIVILEGES shows the list of system privileges that the MySQL\nserver supports. The exact list of privileges depends on the version of\nyour server.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-privileges.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-privileges.html'),(194,'CREATE TABLESPACE',38,'Syntax:\nCREATE TABLESPACE tablespace_name\n    ADD DATAFILE \'file_name\'\n    USE LOGFILE GROUP logfile_group\n    [EXTENT_SIZE [=] extent_size]\n    [INITIAL_SIZE [=] initial_size]\n    [AUTOEXTEND_SIZE [=] autoextend_size]\n    [MAX_SIZE [=] max_size]\n    [NODEGROUP [=] nodegroup_id]\n    [WAIT]\n    [COMMENT [=] comment_text]\n    ENGINE [=] engine_name\n\nThis statement is used to create a tablespace, which can contain one or\nmore data files, providing storage space for tables. One data file is\ncreated and added to the tablespace using this statement. Additional\ndata files may be added to the tablespace by using the ALTER TABLESPACE\nstatement (see [HELP ALTER TABLESPACE]). For rules covering the naming\nof tablespaces, see\nhttp://dev.mysql.com/doc/refman/5.5/en/identifiers.html.\n\n*Note*: All MySQL Cluster Disk Data objects share the same namespace.\nThis means that each Disk Data object must be uniquely named (and not\nmerely each Disk Data object of a given type). For example, you cannot\nhave a tablespace and a log file group with the same name, or a\ntablespace and a data file with the same name.\n\nA log file group of one or more UNDO log files must be assigned to the\ntablespace to be created with the USE LOGFILE GROUP clause.\nlogfile_group must be an existing log file group created with CREATE\nLOGFILE GROUP (see\nhttp://dev.mysql.com/doc/refman/5.5/en/create-logfile-group.html).\nMultiple tablespaces may use the same log file group for UNDO logging.\n\nThe EXTENT_SIZE sets the size, in bytes, of the extents used by any\nfiles belonging to the tablespace. The default value is 1M. The minimum\nsize is 32K, and theoretical maximum is 2G, although the practical\nmaximum size depends on a number of factors. In most cases, changing\nthe extent size does not have any measurable effect on performance, and\nthe default value is recommended for all but the most unusual\nsituations.\n\nAn extent is a unit of disk space allocation. One extent is filled with\nas much data as that extent can contain before another extent is used.\nIn theory, up to 65,535 (64K) extents may used per data file; however,\nthe recommended maximum is 32,768 (32K). The recommended maximum size\nfor a single data file is 32G---that is, 32K extents x 1 MB per extent.\nIn addition, once an extent is allocated to a given partition, it\ncannot be used to store data from a different partition; an extent\ncannot store data from more than one partition. This means, for example\nthat a tablespace having a single datafile whose INITIAL_SIZE is 256 MB\nand whose EXTENT_SIZE is 128M has just two extents, and so can be used\nto store data from at most two different disk data table partitions.\n\nYou can see how many extents remain free in a given data file by\nquerying the INFORMATION_SCHEMA.FILES table, and so derive an estimate\nfor how much space remains free in the file. For further discussion and\nexamples, see http://dev.mysql.com/doc/refman/5.5/en/files-table.html.\n\nThe INITIAL_SIZE parameter sets the data file\'s total size in bytes.\nOnce the file has been created, its size cannot be changed; however,\nyou can add more data files to the tablespace using ALTER TABLESPACE\n... ADD DATAFILE. See [HELP ALTER TABLESPACE].\n\nINITIAL_SIZE is optional; its default value is 128M.\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is 4G.\n(Bug #29186)\n\nWhen setting EXTENT_SIZE or INITIAL_SIZE (either or both), you may\noptionally follow the number with a one-letter abbreviation for an\norder of magnitude, similar to those used in my.cnf. Generally, this is\none of the letters M (for megabytes) or G (for gigabytes).\n\nINITIAL_SIZE, EXTENT_SIZE, and UNDO_BUFFER_SIZE are subject to rounding\nas follows:\n\no EXTENT_SIZE and UNDO_BUFFER_SIZE are each rounded up to the nearest\n  whole multiple of 32K.\n\no INITIAL_SIZE is rounded down to the nearest whole multiple of 32K.\n\n  For data files, INITIAL_SIZE is subject to further rounding; the\n  result just obtained is rounded up to the nearest whole multiple of\n  EXTENT_SIZE (after any rounding).\n\nThe rounding just described is done explicitly, and a warning is issued\nby the MySQL Server when any such rounding is performed. The rounded\nvalues are also used by the NDB kernel for calculating\nINFORMATION_SCHEMA.FILES column values and other purposes. However, to\navoid an unexpected result, we suggest that you always use whole\nmultiples of 32K in specifying these options.\n\nAUTOEXTEND_SIZE, MAX_SIZE, NODEGROUP, WAIT, and COMMENT are parsed but\nignored, and so currently have no effect. These options are intended\nfor future expansion.\n\nThe ENGINE parameter determines the storage engine which uses this\ntablespace, with engine_name being the name of the storage engine.\nCurrently, engine_name must be one of the values NDB or NDBCLUSTER.\n\nWhen CREATE TABLESPACE is used with ENGINE = NDB, a tablespace and\nassociated data file are created on each Cluster data node. You can\nverify that the data files were created and obtain information about\nthem by querying the INFORMATION_SCHEMA.FILES table. For example:\n\nmysql> SELECT LOGFILE_GROUP_NAME, FILE_NAME, EXTRA\n    -> FROM INFORMATION_SCHEMA.FILES\n    -> WHERE TABLESPACE_NAME = \'newts\' AND FILE_TYPE = \'DATAFILE\';\n+--------------------+-------------+----------------+\n| LOGFILE_GROUP_NAME | FILE_NAME   | EXTRA          |\n+--------------------+-------------+----------------+\n| lg_3               | newdata.dat | CLUSTER_NODE=3 |\n| lg_3               | newdata.dat | CLUSTER_NODE=4 |\n+--------------------+-------------+----------------+\n2 rows in set (0.01 sec)\n\n(See http://dev.mysql.com/doc/refman/5.5/en/files-table.html.)\n\nCREATE TABLESPACE is useful only with Disk Data storage for MySQL\nCluster. See\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-cluster-disk-data.html.\n\nTo drop a primary key, the index name is always PRIMARY, which must be\nspecified as a quoted identifier because PRIMARY is a reserved word:\n\nDROP INDEX `PRIMARY` ON t;\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-tablespace.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-tablespace.html'),(195,'INSERT FUNCTION',36,'Syntax:\nINSERT(str,pos,len,newstr)\n\nReturns the string str, with the substring beginning at position pos\nand len characters long replaced by the string newstr. Returns the\noriginal string if pos is not within the length of the string. Replaces\nthe rest of the string from position pos if len is not within the\nlength of the rest of the string. Returns NULL if any argument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT INSERT(\'Quadratic\', 3, 4, \'What\');\n        -> \'QuWhattic\'\nmysql> SELECT INSERT(\'Quadratic\', -1, 4, \'What\');\n        -> \'Quadratic\'\nmysql> SELECT INSERT(\'Quadratic\', 3, 100, \'What\');\n        -> \'QuWhat\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(196,'CRC32',4,'Syntax:\nCRC32(expr)\n\nComputes a cyclic redundancy check value and returns a 32-bit unsigned\nvalue. The result is NULL if the argument is NULL. The argument is\nexpected to be a string and (if possible) is treated as one if it is\nnot.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT CRC32(\'MySQL\');\n        -> 3259397556\nmysql> SELECT CRC32(\'mysql\');\n        -> 2501908538\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(197,'XOR',14,'Syntax:\nXOR\n\nLogical XOR. Returns NULL if either operand is NULL. For non-NULL\noperands, evaluates to 1 if an odd number of operands is nonzero,\notherwise 0 is returned.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html\n\n','mysql> SELECT 1 XOR 1;\n        -> 0\nmysql> SELECT 1 XOR 0;\n        -> 1\nmysql> SELECT 1 XOR NULL;\n        -> NULL\nmysql> SELECT 1 XOR 1 XOR 1;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html'),(198,'STARTPOINT',13,'StartPoint(ls)\n\nReturns the Point that is the start point of the LineString value ls.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(StartPoint(GeomFromText(@ls)));\n+---------------------------------------+\n| AsText(StartPoint(GeomFromText(@ls))) |\n+---------------------------------------+\n| POINT(1 1)                            |\n+---------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions'),(199,'GRANT',10,'Syntax:\nGRANT\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    TO user_specification [, user_specification] ...\n    [REQUIRE {NONE | ssl_option [[AND] ssl_option] ...}]\n    [WITH with_option ...]\n\nGRANT PROXY ON user_specification\n    TO user_specification [, user_specification] ...\n    [WITH GRANT OPTION]\n\nobject_type:\n    TABLE\n  | FUNCTION\n  | PROCEDURE\n\npriv_level:\n    *\n  | *.*\n  | db_name.*\n  | db_name.tbl_name\n  | tbl_name\n  | db_name.routine_name\n\nuser_specification:\n    user\n    [\n        IDENTIFIED BY [PASSWORD] \'password\'\n      | IDENTIFIED WITH auth_plugin [AS \'auth_string\']\n    ]\n\nssl_option:\n    SSL\n  | X509\n  | CIPHER \'cipher\'\n  | ISSUER \'issuer\'\n  | SUBJECT \'subject\'\n\nwith_option:\n    GRANT OPTION\n  | MAX_QUERIES_PER_HOUR count\n  | MAX_UPDATES_PER_HOUR count\n  | MAX_CONNECTIONS_PER_HOUR count\n  | MAX_USER_CONNECTIONS count\n\nThe GRANT statement grants privileges to MySQL user accounts. GRANT\nalso serves to specify other account characteristics such as use of\nsecure connections and limits on access to server resources. To use\nGRANT, you must have the GRANT OPTION privilege, and you must have the\nprivileges that you are granting.\n\nNormally, a database administrator first uses CREATE USER to create an\naccount, then GRANT to define its privileges and characteristics. For\nexample:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\nGRANT ALL ON db1.* TO \'jeffrey\'@\'localhost\';\nGRANT SELECT ON db2.invoice TO \'jeffrey\'@\'localhost\';\nGRANT USAGE ON *.* TO \'jeffrey\'@\'localhost\' WITH MAX_QUERIES_PER_HOUR 90;\n\nHowever, if an account named in a GRANT statement does not already\nexist, GRANT may create it under the conditions described later in the\ndiscussion of the NO_AUTO_CREATE_USER SQL mode.\n\nThe REVOKE statement is related to GRANT and enables administrators to\nremove account privileges. See [HELP REVOKE].\n\nTo determine what privileges an account has, use SHOW GRANTS. See [HELP\nSHOW GRANTS].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/grant.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/grant.html'),(200,'DECLARE VARIABLE',23,'Syntax:\nDECLARE var_name [, var_name] ... type [DEFAULT value]\n\nThis statement declares local variables within stored programs. To\nprovide a default value for a variable, include a DEFAULT clause. The\nvalue can be specified as an expression; it need not be a constant. If\nthe DEFAULT clause is missing, the initial value is NULL.\n\nLocal variables are treated like stored routine parameters with respect\nto data type and overflow checking. See [HELP CREATE PROCEDURE].\n\nVariable declarations must appear before cursor or handler\ndeclarations.\n\nLocal variable names are not case sensitive. Permissible characters and\nquoting rules are the same as for other identifiers, as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/identifiers.html.\n\nThe scope of a local variable is the BEGIN ... END block within which\nit is declared. The variable can be referred to in blocks nested within\nthe declaring block, except those blocks that declare a variable with\nthe same name.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/declare-local-variable.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/declare-local-variable.html'),(201,'MPOLYFROMTEXT',3,'MPolyFromText(wkt[,srid]), MultiPolygonFromText(wkt[,srid])\n\nConstructs a MULTIPOLYGON value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(202,'MBRINTERSECTS',6,'MBRIntersects(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 intersect.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(203,'BIT_OR',16,'Syntax:\nBIT_OR(expr)\n\nReturns the bitwise OR of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(204,'YEARWEEK',31,'Syntax:\nYEARWEEK(date), YEARWEEK(date,mode)\n\nReturns year and week for a date. The mode argument works exactly like\nthe mode argument to WEEK(). The year in the result may be different\nfrom the year in the date argument for the first and the last week of\nthe year.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT YEARWEEK(\'1987-01-01\');\n        -> 198653\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(205,'NOT BETWEEN',18,'Syntax:\nexpr NOT BETWEEN min AND max\n\nThis is the same as NOT (expr BETWEEN min AND max).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(206,'IS NOT',18,'Syntax:\nIS NOT boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NOT UNKNOWN, 0 IS NOT UNKNOWN, NULL IS NOT UNKNOWN;\n        -> 1, 1, 0\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(207,'LOG10',4,'Syntax:\nLOG10(X)\n\nReturns the base-10 logarithm of X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT LOG10(2);\n        -> 0.30102999566398\nmysql> SELECT LOG10(100);\n        -> 2\nmysql> SELECT LOG10(-100);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(208,'SQRT',4,'Syntax:\nSQRT(X)\n\nReturns the square root of a nonnegative number X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT SQRT(4);\n        -> 2\nmysql> SELECT SQRT(20);\n        -> 4.4721359549996\nmysql> SELECT SQRT(-16);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(209,'DECIMAL',22,'DECIMAL[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nA packed \"exact\" fixed-point number. M is the total number of digits\n(the precision) and D is the number of digits after the decimal point\n(the scale). The decimal point and (for negative numbers) the \"-\" sign\nare not counted in M. If D is 0, values have no decimal point or\nfractional part. The maximum number of digits (M) for DECIMAL is 65.\nThe maximum number of supported decimals (D) is 30. If D is omitted,\nthe default is 0. If M is omitted, the default is 10.\n\nUNSIGNED, if specified, disallows negative values.\n\nAll basic calculations (+, -, *, /) with DECIMAL columns are done with\na precision of 65 digits.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(210,'CREATE INDEX',38,'Syntax:\nCREATE [ONLINE|OFFLINE] [UNIQUE|FULLTEXT|SPATIAL] INDEX index_name\n    [index_type]\n    ON tbl_name (index_col_name,...)\n    [index_option] ...\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n\nCREATE INDEX is mapped to an ALTER TABLE statement to create indexes.\nSee [HELP ALTER TABLE]. CREATE INDEX cannot be used to create a PRIMARY\nKEY; use ALTER TABLE instead. For more information about indexes, see\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-indexes.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-index.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-index.html'),(211,'CREATE FUNCTION',38,'The CREATE FUNCTION statement is used to create stored functions and\nuser-defined functions (UDFs):\n\no For information about creating stored functions, see [HELP CREATE\n  PROCEDURE].\n\no For information about creating user-defined functions, see [HELP\n  CREATE FUNCTION UDF].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-function.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-function.html'),(212,'ALTER DATABASE',38,'Syntax:\nALTER {DATABASE | SCHEMA} [db_name]\n    alter_specification ...\nALTER {DATABASE | SCHEMA} db_name\n    UPGRADE DATA DIRECTORY NAME\n\nalter_specification:\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n\nALTER DATABASE enables you to change the overall characteristics of a\ndatabase. These characteristics are stored in the db.opt file in the\ndatabase directory. To use ALTER DATABASE, you need the ALTER privilege\non the database. ALTER SCHEMA is a synonym for ALTER DATABASE.\n\nThe database name can be omitted from the first syntax, in which case\nthe statement applies to the default database.\n\nNational Language Characteristics\n\nThe CHARACTER SET clause changes the default database character set.\nThe COLLATE clause changes the default database collation.\nhttp://dev.mysql.com/doc/refman/5.5/en/charset.html, discusses\ncharacter set and collation names.\n\nYou can see what character sets and collations are available using,\nrespectively, the SHOW CHARACTER SET and SHOW COLLATION statements. See\n[HELP SHOW CHARACTER SET], and [HELP SHOW COLLATION], for more\ninformation.\n\nIf you change the default character set or collation for a database,\nstored routines that use the database defaults must be dropped and\nrecreated so that they use the new defaults. (In a stored routine,\nvariables with character data types use the database defaults if the\ncharacter set or collation are not specified explicitly. See [HELP\nCREATE PROCEDURE].)\n\nUpgrading from Versions Older than MySQL 5.1\n\nThe syntax that includes the UPGRADE DATA DIRECTORY NAME clause updates\nthe name of the directory associated with the database to use the\nencoding implemented in MySQL 5.1 for mapping database names to\ndatabase directory names (see\nhttp://dev.mysql.com/doc/refman/5.5/en/identifier-mapping.html). This\nclause is for use under these conditions:\n\no It is intended when upgrading MySQL to 5.1 or later from older\n  versions.\n\no It is intended to update a database directory name to the current\n  encoding format if the name contains special characters that need\n  encoding.\n\no The statement is used by mysqlcheck (as invoked by mysql_upgrade).\n\nFor example, if a database in MySQL 5.0 has the name a-b-c, the name\ncontains instances of the - (dash) character. In MySQL 5.0, the\ndatabase directory is also named a-b-c, which is not necessarily safe\nfor all file systems. In MySQL 5.1 and later, the same database name is\nencoded as a@002db@002dc to produce a file system-neutral directory\nname.\n\nWhen a MySQL installation is upgraded to MySQL 5.1 or later from an\nolder version,the server displays a name such as a-b-c (which is in the\nold format) as #mysql50#a-b-c, and you must refer to the name using the\n#mysql50# prefix. Use UPGRADE DATA DIRECTORY NAME in this case to\nexplicitly tell the server to re-encode the database directory name to\nthe current encoding format:\n\nALTER DATABASE `#mysql50#a-b-c` UPGRADE DATA DIRECTORY NAME;\n\nAfter executing this statement, you can refer to the database as a-b-c\nwithout the special #mysql50# prefix.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-database.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-database.html'),(213,'GEOMETRYN',25,'GeometryN(gc,N)\n\nReturns the N-th geometry in the GeometryCollection value gc.\nGeometries are numbered beginning with 1.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#geometrycollection-property-functions\n\n','mysql> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nmysql> SELECT AsText(GeometryN(GeomFromText(@gc),1));\n+----------------------------------------+\n| AsText(GeometryN(GeomFromText(@gc),1)) |\n+----------------------------------------+\n| POINT(1 1)                             |\n+----------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#geometrycollection-property-functions'),(214,'<<',19,'Syntax:\n<<\n\nShifts a longlong (BIGINT) number to the left.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT 1 << 2;\n        -> 4\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(215,'SHOW TABLE STATUS',26,'Syntax:\nSHOW TABLE STATUS [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLE STATUS works likes SHOW TABLES, but provides a lot of\ninformation about each non-TEMPORARY table. You can also get this list\nusing the mysqlshow --status db_name command. The LIKE clause, if\npresent, indicates which table names to match. The WHERE clause can be\ngiven to select rows using more general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-table-status.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-table-status.html'),(216,'MD5',12,'Syntax:\nMD5(str)\n\nCalculates an MD5 128-bit checksum for the string. The value is\nreturned as a string of 32 hex digits, or NULL if the argument was\nNULL. The return value can, for example, be used as a hash key. See the\nnotes at the beginning of this section about storing hash values\nefficiently.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring; see the notes at the beginning of this section about using the\nvalue as a nonbinary string.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT MD5(\'testing\');\n        -> \'ae2b1fca515949e5d54fb22b8ed95575\'\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(217,'<',18,'Syntax:\n<\n\nLess than:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 2 < 2;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(218,'UNIX_TIMESTAMP',31,'Syntax:\nUNIX_TIMESTAMP(), UNIX_TIMESTAMP(date)\n\nIf called with no argument, returns a Unix timestamp (seconds since\n\'1970-01-01 00:00:00\' UTC) as an unsigned integer. If UNIX_TIMESTAMP()\nis called with a date argument, it returns the value of the argument as\nseconds since \'1970-01-01 00:00:00\' UTC. date may be a DATE string, a\nDATETIME string, a TIMESTAMP, or a number in the format YYMMDD or\nYYYYMMDD. The server interprets date as a value in the current time\nzone and converts it to an internal value in UTC. Clients can set their\ntime zone as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/time-zone-support.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT UNIX_TIMESTAMP();\n        -> 1196440210\nmysql> SELECT UNIX_TIMESTAMP(\'2007-11-30 10:30:19\');\n        -> 1196440219\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(219,'DAYOFMONTH',31,'Syntax:\nDAYOFMONTH(date)\n\nReturns the day of the month for date, in the range 1 to 31, or 0 for\ndates such as \'0000-00-00\' or \'2008-00-00\' that have a zero day part.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFMONTH(\'2007-02-03\');\n        -> 3\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(220,'ASCII',36,'Syntax:\nASCII(str)\n\nReturns the numeric value of the leftmost character of the string str.\nReturns 0 if str is the empty string. Returns NULL if str is NULL.\nASCII() works for 8-bit characters.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT ASCII(\'2\');\n        -> 50\nmysql> SELECT ASCII(2);\n        -> 50\nmysql> SELECT ASCII(\'dx\');\n        -> 100\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(221,'DIV',4,'Syntax:\nDIV\n\nInteger division. Similar to FLOOR(), but is safe with BIGINT values.\n\nAs of MySQL 5.5.3, if either operand has a noninteger type, the\noperands are converted to DECIMAL and divided using DECIMAL arithmetic\nbefore converting the result to BIGINT. If the result exceeds BIGINT\nrange, an error occurs. Before MySQL 5.5.3, incorrect results may occur\nfor noninteger operands that exceed BIGINT range.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','mysql> SELECT 5 DIV 2;\n        -> 2\n','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(222,'RENAME USER',10,'Syntax:\nRENAME USER old_user TO new_user\n    [, old_user TO new_user] ...\n\nThe RENAME USER statement renames existing MySQL accounts. To use it,\nyou must have the global CREATE USER privilege or the UPDATE privilege\nfor the mysql database. An error occurs if any old account does not\nexist or any new account exists. Each account name uses the format\ndescribed in http://dev.mysql.com/doc/refman/5.5/en/account-names.html.\nFor example:\n\nRENAME USER \'jeffrey\'@\'localhost\' TO \'jeff\'@\'127.0.0.1\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nRENAME USER causes the privileges held by the old user to be those held\nby the new user. However, RENAME USER does not automatically drop or\ninvalidate databases or objects within them that the old user created.\nThis includes stored programs or views for which the DEFINER attribute\nnames the old user. Attempts to access such objects may produce an\nerror if they execute in definer security context. (For information\nabout security context, see\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-security.html.)\n\nThe privilege changes take effect as indicated in\nhttp://dev.mysql.com/doc/refman/5.5/en/privilege-changes.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/rename-user.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/rename-user.html'),(223,'SHOW SLAVE STATUS',26,'Syntax:\nSHOW SLAVE STATUS\n\nThis statement provides status information on essential parameters of\nthe slave threads. It requires either the SUPER or REPLICATION CLIENT\nprivilege.\n\nIf you issue this statement using the mysql client, you can use a \\G\nstatement terminator rather than a semicolon to obtain a more readable\nvertical layout:\n\nmysql> SHOW SLAVE STATUS\\G\n*************************** 1. row ***************************\n               Slave_IO_State: Waiting for master to send event\n                  Master_Host: localhost\n                  Master_User: root\n                  Master_Port: 3306\n                Connect_Retry: 3\n              Master_Log_File: gbichot-bin.005\n          Read_Master_Log_Pos: 79\n               Relay_Log_File: gbichot-relay-bin.005\n                Relay_Log_Pos: 548\n        Relay_Master_Log_File: gbichot-bin.005\n             Slave_IO_Running: Yes\n            Slave_SQL_Running: Yes\n              Replicate_Do_DB:\n          Replicate_Ignore_DB:\n           Replicate_Do_Table:\n       Replicate_Ignore_Table:\n      Replicate_Wild_Do_Table:\n  Replicate_Wild_Ignore_Table:\n                   Last_Errno: 0\n                   Last_Error:\n                 Skip_Counter: 0\n          Exec_Master_Log_Pos: 79\n              Relay_Log_Space: 552\n              Until_Condition: None\n               Until_Log_File:\n                Until_Log_Pos: 0\n           Master_SSL_Allowed: No\n           Master_SSL_CA_File:\n           Master_SSL_CA_Path:\n              Master_SSL_Cert:\n            Master_SSL_Cipher:\n               Master_SSL_Key:\n        Seconds_Behind_Master: 8\nMaster_SSL_Verify_Server_Cert: No\n                Last_IO_Errno: 0\n                Last_IO_Error:\n               Last_SQL_Errno: 0\n               Last_SQL_Error:\n  Replicate_Ignore_Server_Ids: 0\n             Master_Server_Id: 1\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-slave-status.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-slave-status.html'),(224,'GEOMETRY',33,'MySQL provides a standard way of creating spatial columns for geometry\ntypes, for example, with CREATE TABLE or ALTER TABLE. Currently,\nspatial columns are supported for MyISAM, InnoDB, NDB, and ARCHIVE\ntables. See also the annotations about spatial indexes under [HELP\nSPATIAL].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-columns.html\n\n','CREATE TABLE geom (g GEOMETRY);\n','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-columns.html'),(225,'NUMPOINTS',13,'NumPoints(ls)\n\nReturns the number of Point objects in the LineString value ls.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT NumPoints(GeomFromText(@ls));\n+------------------------------+\n| NumPoints(GeomFromText(@ls)) |\n+------------------------------+\n|                            3 |\n+------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions'),(226,'ALTER LOGFILE GROUP',38,'Syntax:\nALTER LOGFILE GROUP logfile_group\n    ADD UNDOFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement adds an UNDO file named \'file_name\' to an existing log\nfile group logfile_group. An ALTER LOGFILE GROUP statement has one and\nonly one ADD UNDOFILE clause. No DROP UNDOFILE clause is currently\nsupported.\n\n*Note*: All MySQL Cluster Disk Data objects share the same namespace.\nThis means that each Disk Data object must be uniquely named (and not\nmerely each Disk Data object of a given type). For example, you cannot\nhave a tablespace and an undo log file with the same name, or an undo\nlog file and a data file with the same name.\n\nThe optional INITIAL_SIZE parameter sets the UNDO file\'s initial size\nin bytes; if not specified, the initial size default to 128M (128\nmegabytes). You may optionally follow size with a one-letter\nabbreviation for an order of magnitude, similar to those used in\nmy.cnf. Generally, this is one of the letters M (for megabytes) or G\n(for gigabytes).\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is 4G.\n(Bug #29186)\n\nThe minimum permitted value for INITIAL_SIZE is 1M. (Bug #29574)\n\n*Note*: WAIT is parsed but otherwise ignored. This keyword currently\nhas no effect, and is intended for future expansion.\n\nThe ENGINE parameter (required) determines the storage engine which is\nused by this log file group, with engine_name being the name of the\nstorage engine. Currently, the only accepted values for engine_name are\n\"NDBCLUSTER\" and \"NDB\". The two values are equivalent.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-logfile-group.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-logfile-group.html'),(227,'&',19,'Syntax:\n&\n\nBitwise AND:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT 29 & 15;\n        -> 13\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(228,'LOCALTIMESTAMP',31,'Syntax:\nLOCALTIMESTAMP, LOCALTIMESTAMP()\n\nLOCALTIMESTAMP and LOCALTIMESTAMP() are synonyms for NOW().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(229,'ASSIGN-EQUAL',14,'Syntax:\n=\n\nThis operator is used to perform value assignments in two cases,\ndescribed in the next two paragraphs.\n\nWithin a SET statement, = is treated as an assignment operator that\ncauses the user variable on the left hand side of the operator to take\non the value to its right. (In other words, when used in a SET\nstatement, = is treated identically to :=.) The value on the right hand\nside may be a literal value, another variable storing a value, or any\nlegal expression that yields a scalar value, including the result of a\nquery (provided that this value is a scalar value). You can perform\nmultiple assignments in the same SET statement.\n\nIn the SET clause of an UPDATE statement, = also acts as an assignment\noperator; in this case, however, it causes the column named on the left\nhand side of the operator to assume the value given to the right,\nprovided any WHERE conditions that are part of the UPDATE are met. You\ncan make multiple assignments in the same SET clause of an UPDATE\nstatement.\n\nIn any other context, = is treated as a comparison operator.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/assignment-operators.html\n\n','mysql> SELECT @var1, @var2;\n        -> NULL, NULL\nmysql> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nmysql> SELECT @var1, @var2;\n        -> 1, 1\n','http://dev.mysql.com/doc/refman/5.5/en/assignment-operators.html'),(230,'CONVERT',36,'Syntax:\nCONVERT(expr,type), CONVERT(expr USING transcoding_name)\n\nThe CONVERT() and CAST() functions take a value of one type and produce\na value of another type.\n\nThe type can be one of the following values:\n\no BINARY[(N)]\n\no CHAR[(N)]\n\no DATE\n\no DATETIME\n\no DECIMAL[(M[,D])]\n\no SIGNED [INTEGER]\n\no TIME\n\no UNSIGNED [INTEGER]\n\nBINARY produces a string with the BINARY data type. See\nhttp://dev.mysql.com/doc/refman/5.5/en/binary-varbinary.html for a\ndescription of how this affects comparisons. If the optional length N\nis given, BINARY(N) causes the cast to use no more than N bytes of the\nargument. Values shorter than N bytes are padded with 0x00 bytes to a\nlength of N.\n\nCHAR(N) causes the cast to use no more than N characters of the\nargument.\n\nCAST() and CONVERT(... USING ...) are standard SQL syntax. The\nnon-USING form of CONVERT() is ODBC syntax.\n\nCONVERT() with USING is used to convert data between different\ncharacter sets. In MySQL, transcoding names are the same as the\ncorresponding character set names. For example, this statement converts\nthe string \'abc\' in the default character set to the corresponding\nstring in the utf8 character set:\n\nSELECT CONVERT(\'abc\' USING utf8);\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/cast-functions.html\n\n','SELECT enum_col FROM tbl_name ORDER BY CAST(enum_col AS CHAR);\n','http://dev.mysql.com/doc/refman/5.5/en/cast-functions.html'),(231,'ADDDATE',31,'Syntax:\nADDDATE(date,INTERVAL expr unit), ADDDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, ADDDATE()\nis a synonym for DATE_ADD(). The related function SUBDATE() is a\nsynonym for DATE_SUB(). For information on the INTERVAL unit argument,\nsee the discussion for DATE_ADD().\n\nmysql> SELECT DATE_ADD(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\nmysql> SELECT ADDDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\n\nWhen invoked with the days form of the second argument, MySQL treats it\nas an integer number of days to be added to expr.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT ADDDATE(\'2008-01-02\', 31);\n        -> \'2008-02-02\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(232,'REPEAT LOOP',23,'Syntax:\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\nThe statement list within a REPEAT statement is repeated until the\nsearch_condition expression is true. Thus, a REPEAT always enters the\nloop at least once. statement_list consists of one or more statements,\neach terminated by a semicolon (;) statement delimiter.\n\nA REPEAT statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/repeat-statement.html\n\n','mysql> delimiter //\n\nmysql> CREATE PROCEDURE dorepeat(p1 INT)\n    -> BEGIN\n    ->   SET @x = 0;\n    ->   REPEAT\n    ->     SET @x = @x + 1;\n    ->   UNTIL @x > p1 END REPEAT;\n    -> END\n    -> //\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> CALL dorepeat(1000)//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @x//\n+------+\n| @x   |\n+------+\n| 1001 |\n+------+\n1 row in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/repeat-statement.html'),(233,'ALTER FUNCTION',38,'Syntax:\nALTER FUNCTION func_name [characteristic ...]\n\ncharacteristic:\n    { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n  | COMMENT \'string\'\n\nThis statement can be used to change the characteristics of a stored\nfunction. More than one change may be specified in an ALTER FUNCTION\nstatement. However, you cannot change the parameters or body of a\nstored function using this statement; to make such changes, you must\ndrop and re-create the function using DROP FUNCTION and CREATE\nFUNCTION.\n\nYou must have the ALTER ROUTINE privilege for the function. (That\nprivilege is granted automatically to the function creator.) If binary\nlogging is enabled, the ALTER FUNCTION statement might also require the\nSUPER privilege, as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-logging.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-function.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-function.html'),(234,'SMALLINT',22,'SMALLINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA small integer. The signed range is -32768 to 32767. The unsigned\nrange is 0 to 65535.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(235,'DOUBLE PRECISION',22,'DOUBLE PRECISION[(M,D)] [UNSIGNED] [ZEROFILL], REAL[(M,D)] [UNSIGNED]\n[ZEROFILL]\n\nThese types are synonyms for DOUBLE. Exception: If the REAL_AS_FLOAT\nSQL mode is enabled, REAL is a synonym for FLOAT rather than DOUBLE.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(236,'ORD',36,'Syntax:\nORD(str)\n\nIf the leftmost character of the string str is a multi-byte character,\nreturns the code for that character, calculated from the numeric values\nof its constituent bytes using this formula:\n\n  (1st byte code)\n+ (2nd byte code * 256)\n+ (3rd byte code * 2562) ...\n\nIf the leftmost character is not a multi-byte character, ORD() returns\nthe same value as the ASCII() function.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT ORD(\'2\');\n        -> 50\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(237,'DEALLOCATE PREPARE',8,'Syntax:\n{DEALLOCATE | DROP} PREPARE stmt_name\n\nTo deallocate a prepared statement produced with PREPARE, use a\nDEALLOCATE PREPARE statement that refers to the prepared statement\nname. Attempting to execute a prepared statement after deallocating it\nresults in an error.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/deallocate-prepare.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/deallocate-prepare.html'),(238,'ENVELOPE',35,'Envelope(g)\n\nReturns the Minimum Bounding Rectangle (MBR) for the geometry value g.\nThe result is returned as a Polygon value.\n\nThe polygon is defined by the corner points of the bounding box:\n\nPOLYGON((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT AsText(Envelope(GeomFromText(\'LineString(1 1,2 2)\')));\n+-------------------------------------------------------+\n| AsText(Envelope(GeomFromText(\'LineString(1 1,2 2)\'))) |\n+-------------------------------------------------------+\n| POLYGON((1 1,2 1,2 2,1 2,1 1))                        |\n+-------------------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(239,'IS_FREE_LOCK',15,'Syntax:\nIS_FREE_LOCK(str)\n\nChecks whether the lock named str is free to use (that is, not locked).\nReturns 1 if the lock is free (no one is using the lock), 0 if the lock\nis in use, and NULL if an error occurs (such as an incorrect argument).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(240,'TOUCHES',30,'Touches(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially touches g2. Two\ngeometries spatially touch if the interiors of the geometries do not\nintersect, but the boundary of one of the geometries intersects either\nthe boundary or the interior of the other.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(241,'INET_ATON',15,'Syntax:\nINET_ATON(expr)\n\nGiven the dotted-quad representation of an IPv4 network address as a\nstring, returns an integer that represents the numeric value of the\naddress in network byte order (big endian). INET_ATON() returns NULL if\nit does not understand its argument.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> SELECT INET_ATON(\'10.0.5.9\');\n        -> 167773449\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(242,'UNCOMPRESS',12,'Syntax:\nUNCOMPRESS(string_to_uncompress)\n\nUncompresses a string compressed by the COMPRESS() function. If the\nargument is not a compressed value, the result is NULL. This function\nrequires MySQL to have been compiled with a compression library such as\nzlib. Otherwise, the return value is always NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT UNCOMPRESS(COMPRESS(\'any string\'));\n        -> \'any string\'\nmysql> SELECT UNCOMPRESS(\'any string\');\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(243,'AUTO_INCREMENT',22,'The AUTO_INCREMENT attribute can be used to generate a unique identity\nfor new rows:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/example-auto-increment.html\n\n','CREATE TABLE animals (\n     id MEDIUMINT NOT NULL AUTO_INCREMENT,\n     name CHAR(30) NOT NULL,\n     PRIMARY KEY (id)\n) ENGINE=MyISAM;\n\nINSERT INTO animals (name) VALUES\n    (\'dog\'),(\'cat\'),(\'penguin\'),\n    (\'lax\'),(\'whale\'),(\'ostrich\');\n\nSELECT * FROM animals;\n','http://dev.mysql.com/doc/refman/5.5/en/example-auto-increment.html'),(244,'ISSIMPLE',35,'IsSimple(g)\n\nCurrently, this function is a placeholder and should not be used. If\nimplemented, its behavior will be as described in the next paragraph.\n\nReturns 1 if the geometry value g has no anomalous geometric points,\nsuch as self-intersection or self-tangency. IsSimple() returns 0 if the\nargument is not simple, and -1 if it is NULL.\n\nThe description of each instantiable geometric class given earlier in\nthe chapter includes the specific conditions that cause an instance of\nthat class to be classified as not simple. (See [HELP Geometry\nhierarchy].)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(245,'- BINARY',4,'Syntax:\n-\n\nSubtraction:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','mysql> SELECT 3-5;\n        -> -2\n','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(246,'GEOMCOLLFROMTEXT',3,'GeomCollFromText(wkt[,srid]), GeometryCollectionFromText(wkt[,srid])\n\nConstructs a GEOMETRYCOLLECTION value using its WKT representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(247,'WKT DEFINITION',3,'The Well-Known Text (WKT) representation of Geometry is designed to\nexchange geometry data in ASCII form. For a Backus-Naur grammar that\nspecifies the formal production rules for writing WKT values, see the\nOpenGIS specification document referenced in\nhttp://dev.mysql.com/doc/refman/5.5/en/spatial-extensions.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/gis-wkt-format.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/gis-wkt-format.html'),(248,'CURRENT_TIME',31,'Syntax:\nCURRENT_TIME, CURRENT_TIME()\n\nCURRENT_TIME and CURRENT_TIME() are synonyms for CURTIME().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(249,'REVOKE',10,'Syntax:\nREVOKE\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    FROM user [, user] ...\n\nREVOKE ALL PRIVILEGES, GRANT OPTION\n    FROM user [, user] ...\n\nREVOKE PROXY ON user\n    FROM user [, user] ...\n\nThe REVOKE statement enables system administrators to revoke privileges\nfrom MySQL accounts. Each account name uses the format described in\nhttp://dev.mysql.com/doc/refman/5.5/en/account-names.html. For example:\n\nREVOKE INSERT ON *.* FROM \'jeffrey\'@\'localhost\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nFor details on the levels at which privileges exist, the permissible\npriv_type and priv_level values, and the syntax for specifying users\nand passwords, see [HELP GRANT]\n\nTo use the first REVOKE syntax, you must have the GRANT OPTION\nprivilege, and you must have the privileges that you are revoking.\n\nTo revoke all privileges, use the second syntax, which drops all\nglobal, database, table, column, and routine privileges for the named\nuser or users:\n\nREVOKE ALL PRIVILEGES, GRANT OPTION FROM user [, user] ...\n\nTo use this REVOKE syntax, you must have the global CREATE USER\nprivilege or the UPDATE privilege for the mysql database.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/revoke.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/revoke.html'),(250,'LAST_INSERT_ID',17,'Syntax:\nLAST_INSERT_ID(), LAST_INSERT_ID(expr)\n\nLAST_INSERT_ID() (with no argument) returns the first automatically\ngenerated value successfully inserted for an AUTO_INCREMENT column as a\nresult of the most recently executed INSERT statement. The value of\nLAST_INSERT_ID() remains unchanged if no rows are successfully\ninserted.\n\nFor example, after inserting a row that generates an AUTO_INCREMENT\nvalue, you can get the value like this:\n\nmysql> SELECT LAST_INSERT_ID();\n        -> 195\n\nThe currently executing statement does not affect the value of\nLAST_INSERT_ID(). Suppose that you generate an AUTO_INCREMENT value\nwith one statement, and then refer to LAST_INSERT_ID() in a\nmultiple-row INSERT statement that inserts rows into a table with its\nown AUTO_INCREMENT column. The value of LAST_INSERT_ID() will remain\nstable in the second statement; its value for the second and later rows\nis not affected by the earlier row insertions. (However, if you mix\nreferences to LAST_INSERT_ID() and LAST_INSERT_ID(expr), the effect is\nundefined.)\n\nIf the previous statement returned an error, the value of\nLAST_INSERT_ID() is undefined. For transactional tables, if the\nstatement is rolled back due to an error, the value of LAST_INSERT_ID()\nis left undefined. For manual ROLLBACK, the value of LAST_INSERT_ID()\nis not restored to that before the transaction; it remains as it was at\nthe point of the ROLLBACK.\n\nWithin the body of a stored routine (procedure or function) or a\ntrigger, the value of LAST_INSERT_ID() changes the same way as for\nstatements executed outside the body of these kinds of objects. The\neffect of a stored routine or trigger upon the value of\nLAST_INSERT_ID() that is seen by following statements depends on the\nkind of routine:\n\no If a stored procedure executes statements that change the value of\n  LAST_INSERT_ID(), the changed value is seen by statements that follow\n  the procedure call.\n\no For stored functions and triggers that change the value, the value is\n  restored when the function or trigger ends, so following statements\n  will not see a changed value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(251,'LAST_DAY',31,'Syntax:\nLAST_DAY(date)\n\nTakes a date or datetime value and returns the corresponding value for\nthe last day of the month. Returns NULL if the argument is invalid.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT LAST_DAY(\'2003-02-05\');\n        -> \'2003-02-28\'\nmysql> SELECT LAST_DAY(\'2004-02-05\');\n        -> \'2004-02-29\'\nmysql> SELECT LAST_DAY(\'2004-01-01 01:01:01\');\n        -> \'2004-01-31\'\nmysql> SELECT LAST_DAY(\'2003-03-32\');\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(252,'MEDIUMINT',22,'MEDIUMINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA medium-sized integer. The signed range is -8388608 to 8388607. The\nunsigned range is 0 to 16777215.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(253,'FLOOR',4,'Syntax:\nFLOOR(X)\n\nReturns the largest integer value not greater than X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT FLOOR(1.23);\n        -> 1\nmysql> SELECT FLOOR(-1.23);\n        -> -2\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(254,'RTRIM',36,'Syntax:\nRTRIM(str)\n\nReturns the string str with trailing space characters removed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT RTRIM(\'barbar   \');\n        -> \'barbar\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(255,'EXPLAIN',28,'Syntax:\nEXPLAIN [EXTENDED | PARTITIONS] SELECT select_options\n\nOr:\n\nEXPLAIN tbl_name\n\nThe EXPLAIN statement can be used either as a way to obtain information\nabout how MySQL executes a statement, or as a synonym for DESCRIBE:\n\no When you precede a SELECT statement with the keyword EXPLAIN, MySQL\n  displays information from the optimizer about the query execution\n  plan. That is, MySQL explains how it would process the statement,\n  including information about how tables are joined and in which order.\n  EXPLAIN EXTENDED can be used to provide additional information.\n\n  For information about using EXPLAIN and EXPLAIN EXTENDED to obtain\n  query execution plan information, see\n  http://dev.mysql.com/doc/refman/5.5/en/using-explain.html.\n\no EXPLAIN PARTITIONS is useful only when examining queries involving\n  partitioned tables. For details, see\n  http://dev.mysql.com/doc/refman/5.5/en/partitioning-info.html.\n\no EXPLAIN tbl_name is synonymous with DESCRIBE tbl_name or SHOW COLUMNS\n  FROM tbl_name. For information about DESCRIBE and SHOW COLUMNS, see\n  [HELP DESCRIBE], and [HELP SHOW COLUMNS].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/explain.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/explain.html'),(256,'DEGREES',4,'Syntax:\nDEGREES(X)\n\nReturns the argument X, converted from radians to degrees.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT DEGREES(PI());\n        -> 180\nmysql> SELECT DEGREES(PI() / 2);\n        -> 90\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(257,'VARCHAR',22,'[NATIONAL] VARCHAR(M) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA variable-length string. M represents the maximum column length in\ncharacters. The range of M is 0 to 65,535. The effective maximum length\nof a VARCHAR is subject to the maximum row size (65,535 bytes, which is\nshared among all columns) and the character set used. For example, utf8\ncharacters can require up to three bytes per character, so a VARCHAR\ncolumn that uses the utf8 character set can be declared to be a maximum\nof 21,844 characters. See\nhttp://dev.mysql.com/doc/refman/5.5/en/column-count-limit.html.\n\nMySQL stores VARCHAR values as a one-byte or two-byte length prefix\nplus data. The length prefix indicates the number of bytes in the\nvalue. A VARCHAR column uses one length byte if values require no more\nthan 255 bytes, two length bytes if values may require more than 255\nbytes.\n\n*Note*: MySQL 5.5 follows the standard SQL specification, and does not\nremove trailing spaces from VARCHAR values.\n\nVARCHAR is shorthand for CHARACTER VARYING. NATIONAL VARCHAR is the\nstandard SQL way to define that a VARCHAR column should use some\npredefined character set. MySQL 4.1 and up uses utf8 as this predefined\ncharacter set.\nhttp://dev.mysql.com/doc/refman/5.5/en/charset-national.html. NVARCHAR\nis shorthand for NATIONAL VARCHAR.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(258,'UNHEX',36,'Syntax:\n\nUNHEX(str)\n\nFor a string argument str, UNHEX(str) performs the inverse operation of\nHEX(str). That is, it interprets each pair of characters in the\nargument as a hexadecimal number and converts it to the character\nrepresented by the number. The return value is a binary string.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT UNHEX(\'4D7953514C\');\n        -> \'MySQL\'\nmysql> SELECT 0x4D7953514C;\n        -> \'MySQL\'\nmysql> SELECT UNHEX(HEX(\'string\'));\n        -> \'string\'\nmysql> SELECT HEX(UNHEX(\'1267\'));\n        -> \'1267\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(259,'- UNARY',4,'Syntax:\n-\n\nUnary minus. This operator changes the sign of the operand.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','mysql> SELECT - 2;\n        -> -2\n','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(260,'STD',16,'Syntax:\nSTD(expr)\n\nReturns the population standard deviation of expr. This is an extension\nto standard SQL. The standard SQL function STDDEV_POP() can be used\ninstead.\n\nThis function returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(261,'COS',4,'Syntax:\nCOS(X)\n\nReturns the cosine of X, where X is given in radians.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT COS(PI());\n        -> -1\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(262,'DATE FUNCTION',31,'Syntax:\nDATE(expr)\n\nExtracts the date part of the date or datetime expression expr.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DATE(\'2003-12-31 01:02:03\');\n        -> \'2003-12-31\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(263,'DROP TRIGGER',38,'Syntax:\nDROP TRIGGER [IF EXISTS] [schema_name.]trigger_name\n\nThis statement drops a trigger. The schema (database) name is optional.\nIf the schema is omitted, the trigger is dropped from the default\nschema. DROP TRIGGER requires the TRIGGER privilege for the table\nassociated with the trigger.\n\nUse IF EXISTS to prevent an error from occurring for a trigger that\ndoes not exist. A NOTE is generated for a nonexistent trigger when\nusing IF EXISTS. See [HELP SHOW WARNINGS].\n\nTriggers for a table are also dropped if you drop the table.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-trigger.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-trigger.html'),(264,'RESET MASTER',8,'Syntax:\nRESET MASTER\n\nDeletes all binary log files listed in the index file, resets the\nbinary log index file to be empty, and creates a new binary log file.\nThis statement is intended to be used only when the master is started\nfor the first time.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/reset-master.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/reset-master.html'),(265,'TAN',4,'Syntax:\nTAN(X)\n\nReturns the tangent of X, where X is given in radians.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT TAN(PI());\n        -> -1.2246063538224e-16\nmysql> SELECT TAN(PI()+1);\n        -> 1.5574077246549\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(266,'PI',4,'Syntax:\nPI()\n\nReturns the value of π (pi). The default number of decimal places\ndisplayed is seven, but MySQL uses the full double-precision value\ninternally.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT PI();\n        -> 3.141593\nmysql> SELECT PI()+0.000000000000000000;\n        -> 3.141592653589793116\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(267,'WEEKOFYEAR',31,'Syntax:\nWEEKOFYEAR(date)\n\nReturns the calendar week of the date as a number in the range from 1\nto 53. WEEKOFYEAR() is a compatibility function that is equivalent to\nWEEK(date,3).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT WEEKOFYEAR(\'2008-02-20\');\n        -> 8\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(268,'/',4,'Syntax:\n/\n\nDivision:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','mysql> SELECT 3/5;\n        -> 0.60\n','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(269,'PURGE BINARY LOGS',8,'Syntax:\nPURGE { BINARY | MASTER } LOGS\n    { TO \'log_name\' | BEFORE datetime_expr }\n\nThe binary log is a set of files that contain information about data\nmodifications made by the MySQL server. The log consists of a set of\nbinary log files, plus an index file (see\nhttp://dev.mysql.com/doc/refman/5.5/en/binary-log.html).\n\nThe PURGE BINARY LOGS statement deletes all the binary log files listed\nin the log index file prior to the specified log file name or date.\nBINARY and MASTER are synonyms. Deleted log files also are removed from\nthe list recorded in the index file, so that the given log file becomes\nthe first in the list.\n\nThis statement has no effect if the server was not started with the\n--log-bin option to enable binary logging.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/purge-binary-logs.html\n\n','PURGE BINARY LOGS TO \'mysql-bin.010\';\nPURGE BINARY LOGS BEFORE \'2008-04-02 22:46:26\';\n','http://dev.mysql.com/doc/refman/5.5/en/purge-binary-logs.html'),(270,'STDDEV_SAMP',16,'Syntax:\nSTDDEV_SAMP(expr)\n\nReturns the sample standard deviation of expr (the square root of\nVAR_SAMP().\n\nSTDDEV_SAMP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(271,'SCHEMA',17,'Syntax:\nSCHEMA()\n\nThis function is a synonym for DATABASE().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(272,'MLINEFROMWKB',32,'MLineFromWKB(wkb[,srid]), MultiLineStringFromWKB(wkb[,srid])\n\nConstructs a MULTILINESTRING value using its WKB representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(273,'LOG2',4,'Syntax:\nLOG2(X)\n\nReturns the base-2 logarithm of X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT LOG2(65536);\n        -> 16\nmysql> SELECT LOG2(-100);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(274,'SUBTIME',31,'Syntax:\nSUBTIME(expr1,expr2)\n\nSUBTIME() returns expr1 - expr2 expressed as a value in the same format\nas expr1. expr1 is a time or datetime expression, and expr2 is a time\nexpression.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT SUBTIME(\'2007-12-31 23:59:59.999999\',\'1 1:1:1.000002\');\n        -> \'2007-12-30 22:58:58.999997\'\nmysql> SELECT SUBTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'-00:59:59.999999\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(275,'UNCOMPRESSED_LENGTH',12,'Syntax:\nUNCOMPRESSED_LENGTH(compressed_string)\n\nReturns the length that the compressed string had before being\ncompressed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT UNCOMPRESSED_LENGTH(COMPRESS(REPEAT(\'a\',30)));\n        -> 30\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(276,'DROP TABLE',38,'Syntax:\nDROP [TEMPORARY] TABLE [IF EXISTS]\n    tbl_name [, tbl_name] ...\n    [RESTRICT | CASCADE]\n\nDROP TABLE removes one or more tables. You must have the DROP privilege\nfor each table. All table data and the table definition are removed, so\nbe careful with this statement! If any of the tables named in the\nargument list do not exist, MySQL returns an error indicating by name\nwhich nonexisting tables it was unable to drop, but it also drops all\nof the tables in the list that do exist.\n\n*Important*: When a table is dropped, user privileges on the table are\nnot automatically dropped. See [HELP GRANT].\n\nNote that for a partitioned table, DROP TABLE permanently removes the\ntable definition, all of its partitions, and all of the data which was\nstored in those partitions. It also removes the partitioning definition\n(.par) file associated with the dropped table.\n\nUse IF EXISTS to prevent an error from occurring for tables that do not\nexist. A NOTE is generated for each nonexistent table when using IF\nEXISTS. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE are permitted to make porting easier. In MySQL\n5.5, they do nothing.\n\n*Note*: DROP TABLE automatically commits the current active\ntransaction, unless you use the TEMPORARY keyword.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-table.html'),(277,'POW',4,'Syntax:\nPOW(X,Y)\n\nReturns the value of X raised to the power of Y.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT POW(2,2);\n        -> 4\nmysql> SELECT POW(2,-2);\n        -> 0.25\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(278,'SHOW CREATE TABLE',26,'Syntax:\nSHOW CREATE TABLE tbl_name\n\nShows the CREATE TABLE statement that creates the given table. To use\nthis statement, you must have some privilege for the table. This\nstatement also works with views.\nSHOW CREATE TABLE quotes table and column names according to the value\nof the sql_quote_show_create option. See\nhttp://dev.mysql.com/doc/refman/5.5/en/server-system-variables.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-table.html\n\n','mysql> SHOW CREATE TABLE t\\G\n*************************** 1. row ***************************\n       Table: t\nCreate Table: CREATE TABLE t (\n  id INT(11) default NULL auto_increment,\n  s char(60) default NULL,\n  PRIMARY KEY (id)\n) ENGINE=MyISAM\n','http://dev.mysql.com/doc/refman/5.5/en/show-create-table.html'),(279,'DUAL',27,'You are permitted to specify DUAL as a dummy table name in situations\nwhere no tables are referenced:\n\nmysql> SELECT 1 + 1 FROM DUAL;\n        -> 2\n\nDUAL is purely for the convenience of people who require that all\nSELECT statements should have FROM and possibly other clauses. MySQL\nmay ignore the clauses. MySQL does not require FROM DUAL if no tables\nare referenced.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/select.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/select.html'),(280,'INSTR',36,'Syntax:\nINSTR(str,substr)\n\nReturns the position of the first occurrence of substring substr in\nstring str. This is the same as the two-argument form of LOCATE(),\nexcept that the order of the arguments is reversed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT INSTR(\'foobarbar\', \'bar\');\n        -> 4\nmysql> SELECT INSTR(\'xbar\', \'foobar\');\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(281,'NOW',31,'Syntax:\nNOW()\n\nReturns the current date and time as a value in \'YYYY-MM-DD HH:MM:SS\'\nor YYYYMMDDHHMMSS.uuuuuu format, depending on whether the function is\nused in a string or numeric context. The value is expressed in the\ncurrent time zone.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT NOW();\n        -> \'2007-12-15 23:50:26\'\nmysql> SELECT NOW() + 0;\n        -> 20071215235026.000000\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(282,'SHOW ENGINES',26,'Syntax:\nSHOW [STORAGE] ENGINES\n\nSHOW ENGINES displays status information about the server\'s storage\nengines. This is particularly useful for checking whether a storage\nengine is supported, or to see what the default engine is.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-engines.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-engines.html'),(283,'>=',18,'Syntax:\n>=\n\nGreater than or equal:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 2 >= 2;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(284,'EXP',4,'Syntax:\nEXP(X)\n\nReturns the value of e (the base of natural logarithms) raised to the\npower of X. The inverse of this function is LOG() (using a single\nargument only) or LN().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT EXP(2);\n        -> 7.3890560989307\nmysql> SELECT EXP(-2);\n        -> 0.13533528323661\nmysql> SELECT EXP(0);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(285,'LONGBLOB',22,'LONGBLOB\n\nA BLOB column with a maximum length of 4,294,967,295 or 4GB (232 - 1)\nbytes. The effective maximum length of LONGBLOB columns depends on the\nconfigured maximum packet size in the client/server protocol and\navailable memory. Each LONGBLOB value is stored using a four-byte\nlength prefix that indicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(286,'POINTN',13,'PointN(ls,N)\n\nReturns the N-th Point in the Linestring value ls. Points are numbered\nbeginning with 1.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(PointN(GeomFromText(@ls),2));\n+-------------------------------------+\n| AsText(PointN(GeomFromText(@ls),2)) |\n+-------------------------------------+\n| POINT(2 2)                          |\n+-------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions'),(287,'YEAR DATA TYPE',22,'YEAR[(2|4)]\n\nA year in two-digit or four-digit format. The default is four-digit\nformat. In four-digit format, the permissible values are 1901 to 2155,\nand 0000. In two-digit format, the permissible values are 70 to 69,\nrepresenting years from 1970 to 2069. MySQL displays YEAR values in\nYYYY format, but permits assignment of values to YEAR columns using\neither strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html'),(288,'SUM',16,'Syntax:\nSUM([DISTINCT] expr)\n\nReturns the sum of expr. If the return set has no rows, SUM() returns\nNULL. The DISTINCT keyword can be used to sum only the distinct values\nof expr.\n\nSUM() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(289,'OCT',4,'Syntax:\nOCT(N)\n\nReturns a string representation of the octal value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,8). Returns\nNULL if N is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT OCT(12);\n        -> \'14\'\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(290,'SYSDATE',31,'Syntax:\nSYSDATE()\n\nReturns the current date and time as a value in \'YYYY-MM-DD HH:MM:SS\'\nor YYYYMMDDHHMMSS.uuuuuu format, depending on whether the function is\nused in a string or numeric context.\n\nSYSDATE() returns the time at which it executes. This differs from the\nbehavior for NOW(), which returns a constant time that indicates the\ntime at which the statement began to execute. (Within a stored function\nor trigger, NOW() returns the time at which the function or triggering\nstatement began to execute.)\n\nmysql> SELECT NOW(), SLEEP(2), NOW();\n+---------------------+----------+---------------------+\n| NOW()               | SLEEP(2) | NOW()               |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:36 |        0 | 2006-04-12 13:47:36 |\n+---------------------+----------+---------------------+\n\nmysql> SELECT SYSDATE(), SLEEP(2), SYSDATE();\n+---------------------+----------+---------------------+\n| SYSDATE()           | SLEEP(2) | SYSDATE()           |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:44 |        0 | 2006-04-12 13:47:46 |\n+---------------------+----------+---------------------+\n\nIn addition, the SET TIMESTAMP statement affects the value returned by\nNOW() but not by SYSDATE(). This means that timestamp settings in the\nbinary log have no effect on invocations of SYSDATE().\n\nBecause SYSDATE() can return different values even within the same\nstatement, and is not affected by SET TIMESTAMP, it is nondeterministic\nand therefore unsafe for replication if statement-based binary logging\nis used. If that is a problem, you can use row-based logging.\n\nAlternatively, you can use the --sysdate-is-now option to cause\nSYSDATE() to be an alias for NOW(). This works if the option is used on\nboth the master and the slave.\n\nThe nondeterministic nature of SYSDATE() also means that indexes cannot\nbe used for evaluating expressions that refer to it.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(291,'UNINSTALL PLUGIN',5,'Syntax:\nUNINSTALL PLUGIN plugin_name\n\nThis statement removes an installed server plugin. It requires the\nDELETE privilege for the mysql.plugin table.\n\nplugin_name must be the name of some plugin that is listed in the\nmysql.plugin table. The server executes the plugin\'s deinitialization\nfunction and removes the row for the plugin from the mysql.plugin\ntable, so that subsequent server restarts will not load and initialize\nthe plugin. UNINSTALL PLUGIN does not remove the plugin\'s shared\nlibrary file.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/uninstall-plugin.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/uninstall-plugin.html'),(292,'ASBINARY',32,'AsBinary(g), AsWKB(g)\n\nConverts a value in internal geometry format to its WKB representation\nand returns the binary result.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-to-convert-geometries-between-formats.html\n\n','SELECT AsBinary(g) FROM geom;\n','http://dev.mysql.com/doc/refman/5.5/en/functions-to-convert-geometries-between-formats.html'),(293,'REPEAT FUNCTION',36,'Syntax:\nREPEAT(str,count)\n\nReturns a string consisting of the string str repeated count times. If\ncount is less than 1, returns an empty string. Returns NULL if str or\ncount are NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT REPEAT(\'MySQL\', 3);\n        -> \'MySQLMySQLMySQL\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(294,'SHOW TABLES',26,'Syntax:\nSHOW [FULL] TABLES [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLES lists the non-TEMPORARY tables in a given database. You can\nalso get this list using the mysqlshow db_name command. The LIKE\nclause, if present, indicates which table names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in http://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nThis statement also lists any views in the database. The FULL modifier\nis supported such that SHOW FULL TABLES displays a second output\ncolumn. Values for the second column are BASE TABLE for a table and\nVIEW for a view.\n\nIf you have no privileges for a base table or view, it does not show up\nin the output from SHOW TABLES or mysqlshow db_name.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-tables.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-tables.html'),(295,'MAKEDATE',31,'Syntax:\nMAKEDATE(year,dayofyear)\n\nReturns a date, given year and day-of-year values. dayofyear must be\ngreater than 0 or the result is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT MAKEDATE(2011,31), MAKEDATE(2011,32);\n        -> \'2011-01-31\', \'2011-02-01\'\nmysql> SELECT MAKEDATE(2011,365), MAKEDATE(2014,365);\n        -> \'2011-12-31\', \'2014-12-31\'\nmysql> SELECT MAKEDATE(2011,0);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(296,'BINARY OPERATOR',36,'Syntax:\nBINARY\n\nThe BINARY operator casts the string following it to a binary string.\nThis is an easy way to force a column comparison to be done byte by\nbyte rather than character by character. This causes the comparison to\nbe case sensitive even if the column is not defined as BINARY or BLOB.\nBINARY also causes trailing spaces to be significant.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/cast-functions.html\n\n','mysql> SELECT \'a\' = \'A\';\n        -> 1\nmysql> SELECT BINARY \'a\' = \'A\';\n        -> 0\nmysql> SELECT \'a\' = \'a \';\n        -> 1\nmysql> SELECT BINARY \'a\' = \'a \';\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/cast-functions.html'),(297,'MBROVERLAPS',6,'MBROverlaps(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 overlap. The term spatially overlaps is\nused if two geometries intersect and their intersection results in a\ngeometry of the same dimension but not equal to either of the given\ngeometries.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(298,'SOUNDEX',36,'Syntax:\nSOUNDEX(str)\n\nReturns a soundex string from str. Two strings that sound almost the\nsame should have identical soundex strings. A standard soundex string\nis four characters long, but the SOUNDEX() function returns an\narbitrarily long string. You can use SUBSTRING() on the result to get a\nstandard soundex string. All nonalphabetic characters in str are\nignored. All international alphabetic characters outside the A-Z range\nare treated as vowels.\n\n*Important*: When using SOUNDEX(), you should be aware of the following\nlimitations:\n\no This function, as currently implemented, is intended to work well\n  with strings that are in the English language only. Strings in other\n  languages may not produce reliable results.\n\no This function is not guaranteed to provide consistent results with\n  strings that use multi-byte character sets, including utf-8.\n\n  We hope to remove these limitations in a future release. See Bug\n  #22638 for more information.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT SOUNDEX(\'Hello\');\n        -> \'H400\'\nmysql> SELECT SOUNDEX(\'Quadratically\');\n        -> \'Q36324\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(299,'MBRTOUCHES',6,'MBRTouches(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 touch. Two geometries spatially touch if\nthe interiors of the geometries do not intersect, but the boundary of\none of the geometries intersects either the boundary or the interior of\nthe other.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(300,'DROP EVENT',38,'Syntax:\nDROP EVENT [IF EXISTS] event_name\n\nThis statement drops the event named event_name. The event immediately\nceases being active, and is deleted completely from the server.\n\nIf the event does not exist, the error ERROR 1517 (HY000): Unknown\nevent \'event_name\' results. You can override this and cause the\nstatement to generate a warning for nonexistent events instead using IF\nEXISTS.\n\nThis statement requires the EVENT privilege for the schema to which the\nevent to be dropped belongs.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-event.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-event.html'),(301,'INSERT SELECT',27,'Syntax:\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n    [ ON DUPLICATE KEY UPDATE col_name=expr, ... ]\n\nWith INSERT ... SELECT, you can quickly insert many rows into a table\nfrom one or many tables. For example:\n\nINSERT INTO tbl_temp2 (fld_id)\n  SELECT tbl_temp1.fld_order_id\n  FROM tbl_temp1 WHERE tbl_temp1.fld_order_id > 100;\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/insert-select.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/insert-select.html'),(302,'CREATE PROCEDURE',38,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    PROCEDURE sp_name ([proc_parameter[,...]])\n    [characteristic ...] routine_body\n\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    FUNCTION sp_name ([func_parameter[,...]])\n    RETURNS type\n    [characteristic ...] routine_body\n\nproc_parameter:\n    [ IN | OUT | INOUT ] param_name type\n\nfunc_parameter:\n    param_name type\n\ntype:\n    Any valid MySQL data type\n\ncharacteristic:\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | [NOT] DETERMINISTIC\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nroutine_body:\n    Valid SQL routine statement\n\nThese statements create stored routines. By default, a routine is\nassociated with the default database. To associate the routine\nexplicitly with a given database, specify the name as db_name.sp_name\nwhen you create it.\n\nThe CREATE FUNCTION statement is also used in MySQL to support UDFs\n(user-defined functions). See\nhttp://dev.mysql.com/doc/refman/5.5/en/adding-functions.html. A UDF can\nbe regarded as an external stored function. Stored functions share\ntheir namespace with UDFs. See\nhttp://dev.mysql.com/doc/refman/5.5/en/function-resolution.html, for\nthe rules describing how the server interprets references to different\nkinds of functions.\n\nTo invoke a stored procedure, use the CALL statement (see [HELP CALL]).\nTo invoke a stored function, refer to it in an expression. The function\nreturns a value during expression evaluation.\n\nCREATE PROCEDURE and CREATE FUNCTION require the CREATE ROUTINE\nprivilege. They might also require the SUPER privilege, depending on\nthe DEFINER value, as described later in this section. If binary\nlogging is enabled, CREATE FUNCTION might require the SUPER privilege,\nas described in\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-logging.html.\n\nBy default, MySQL automatically grants the ALTER ROUTINE and EXECUTE\nprivileges to the routine creator. This behavior can be changed by\ndisabling the automatic_sp_privileges system variable. See\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-routines-privileges.html.\n\nThe DEFINER and SQL SECURITY clauses specify the security context to be\nused when checking access privileges at routine execution time, as\ndescribed later in this section.\n\nIf the routine name is the same as the name of a built-in SQL function,\na syntax error occurs unless you use a space between the name and the\nfollowing parenthesis when defining the routine or invoking it later.\nFor this reason, avoid using the names of existing SQL functions for\nyour own stored routines.\n\nThe IGNORE_SPACE SQL mode applies to built-in functions, not to stored\nroutines. It is always permissible to have spaces after a stored\nroutine name, regardless of whether IGNORE_SPACE is enabled.\n\nThe parameter list enclosed within parentheses must always be present.\nIf there are no parameters, an empty parameter list of () should be\nused. Parameter names are not case sensitive.\n\nEach parameter is an IN parameter by default. To specify otherwise for\na parameter, use the keyword OUT or INOUT before the parameter name.\n\n*Note*: Specifying a parameter as IN, OUT, or INOUT is valid only for a\nPROCEDURE. For a FUNCTION, parameters are always regarded as IN\nparameters.\n\nAn IN parameter passes a value into a procedure. The procedure might\nmodify the value, but the modification is not visible to the caller\nwhen the procedure returns. An OUT parameter passes a value from the\nprocedure back to the caller. Its initial value is NULL within the\nprocedure, and its value is visible to the caller when the procedure\nreturns. An INOUT parameter is initialized by the caller, can be\nmodified by the procedure, and any change made by the procedure is\nvisible to the caller when the procedure returns.\n\nFor each OUT or INOUT parameter, pass a user-defined variable in the\nCALL statement that invokes the procedure so that you can obtain its\nvalue when the procedure returns. If you are calling the procedure from\nwithin another stored procedure or function, you can also pass a\nroutine parameter or local routine variable as an IN or INOUT\nparameter.\n\nThe following example shows a simple stored procedure that uses an OUT\nparameter:\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE simpleproc (OUT param1 INT)\n    -> BEGIN\n    ->   SELECT COUNT(*) INTO param1 FROM t;\n    -> END//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> delimiter ;\n\nmysql> CALL simpleproc(@a);\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @a;\n+------+\n| @a   |\n+------+\n| 3    |\n+------+\n1 row in set (0.00 sec)\n\nThe example uses the mysql client delimiter command to change the\nstatement delimiter from ; to // while the procedure is being defined.\nThis enables the ; delimiter used in the procedure body to be passed\nthrough to the server rather than being interpreted by mysql itself.\nSee\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-defining.html.\n\nThe RETURNS clause may be specified only for a FUNCTION, for which it\nis mandatory. It indicates the return type of the function, and the\nfunction body must contain a RETURN value statement. If the RETURN\nstatement returns a value of a different type, the value is coerced to\nthe proper type. For example, if a function specifies an ENUM or SET\nvalue in the RETURNS clause, but the RETURN statement returns an\ninteger, the value returned from the function is the string for the\ncorresponding ENUM member of set of SET members.\n\nThe following example function takes a parameter, performs an operation\nusing an SQL function, and returns the result. In this case, it is\nunnecessary to use delimiter because the function definition contains\nno internal ; statement delimiters:\n\nmysql> CREATE FUNCTION hello (s CHAR(20))\nmysql> RETURNS CHAR(50) DETERMINISTIC\n    -> RETURN CONCAT(\'Hello, \',s,\'!\');\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT hello(\'world\');\n+----------------+\n| hello(\'world\') |\n+----------------+\n| Hello, world!  |\n+----------------+\n1 row in set (0.00 sec)\n\nParameter types and function return types can be declared to use any\nvalid data type, except that the COLLATE attribute cannot be used prior\nto MySQL 5.5.3. As of 5.5.3, COLLATE can be used if preceded by the\nCHARACTER SET attribute.\n\nThe routine_body consists of a valid SQL routine statement. This can be\na simple statement such as SELECT or INSERT, or a compound statement\nwritten using BEGIN and END. Compound statements can contain\ndeclarations, loops, and other control structure statements. The syntax\nfor these statements is described in\nhttp://dev.mysql.com/doc/refman/5.5/en/sql-syntax-compound-statements.h\ntml.\n\nMySQL permits routines to contain DDL statements, such as CREATE and\nDROP. MySQL also permits stored procedures (but not stored functions)\nto contain SQL transaction statements such as COMMIT. Stored functions\nmay not contain statements that perform explicit or implicit commit or\nrollback. Support for these statements is not required by the SQL\nstandard, which states that each DBMS vendor may decide whether to\npermit them.\n\nStatements that return a result set can be used within a stored\nprocedure but not within a stored function. This prohibition includes\nSELECT statements that do not have an INTO var_list clause and other\nstatements such as SHOW, EXPLAIN, and CHECK TABLE. For statements that\ncan be determined at function definition time to return a result set, a\nNot allowed to return a result set from a function error occurs\n(ER_SP_NO_RETSET). For statements that can be determined only at\nruntime to return a result set, a PROCEDURE %s can\'t return a result\nset in the given context error occurs (ER_SP_BADSELECT).\n\nUSE statements within stored routines are not permitted. When a routine\nis invoked, an implicit USE db_name is performed (and undone when the\nroutine terminates). The causes the routine to have the given default\ndatabase while it executes. References to objects in databases other\nthan the routine default database should be qualified with the\nappropriate database name.\n\nFor additional information about statements that are not permitted in\nstored routines, see\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-program-restrictions.html\n.\n\nFor information about invoking stored procedures from within programs\nwritten in a language that has a MySQL interface, see [HELP CALL].\n\nMySQL stores the sql_mode system variable setting that is in effect at\nthe time a routine is created, and always executes the routine with\nthis setting in force, regardless of the server SQL mode in effect when\nthe routine is invoked.\n\nThe switch from the SQL mode of the invoker to that of the routine\noccurs after evaluation of arguments and assignment of the resulting\nvalues to routine parameters. If you define a routine in strict SQL\nmode but invoke it in nonstrict mode, assignment of arguments to\nroutine parameters does not take place in strict mode. If you require\nthat expressions passed to a routine be assigned in strict SQL mode,\nyou should invoke the routine with strict mode in effect.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-procedure.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-procedure.html'),(303,'VARBINARY',22,'VARBINARY(M)\n\nThe VARBINARY type is similar to the VARCHAR type, but stores binary\nbyte strings rather than nonbinary character strings. M represents the\nmaximum column length in bytes.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(304,'LOAD INDEX',26,'Syntax:\nLOAD INDEX INTO CACHE\n  tbl_index_list [, tbl_index_list] ...\n\ntbl_index_list:\n  tbl_name\n    [PARTITION (partition_list | ALL)]\n    [[INDEX|KEY] (index_name[, index_name] ...)]\n    [IGNORE LEAVES]\n\npartition_list:\n    partition_name[, partition_name][, ...]\n\nThe LOAD INDEX INTO CACHE statement preloads a table index into the key\ncache to which it has been assigned by an explicit CACHE INDEX\nstatement, or into the default key cache otherwise.\n\nLOAD INDEX INTO CACHE is used only for MyISAM tables. In MySQL 5.5, it\nis also supported for partitioned MyISAM tables; in addition, indexes\non partitioned tables can be preloaded for one, several, or all\npartitions.\n\nThe IGNORE LEAVES modifier causes only blocks for the nonleaf nodes of\nthe index to be preloaded.\n\nIGNORE LEAVES is also supported for partitioned MyISAM tables.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/load-index.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/load-index.html'),(305,'UNION',27,'Syntax:\nSELECT ...\nUNION [ALL | DISTINCT] SELECT ...\n[UNION [ALL | DISTINCT] SELECT ...]\n\nUNION is used to combine the result from multiple SELECT statements\ninto a single result set.\n\nThe column names from the first SELECT statement are used as the column\nnames for the results returned. Selected columns listed in\ncorresponding positions of each SELECT statement should have the same\ndata type. (For example, the first column selected by the first\nstatement should have the same type as the first column selected by the\nother statements.)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/union.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/union.html'),(306,'TO_DAYS',31,'Syntax:\nTO_DAYS(date)\n\nGiven a date date, returns a day number (the number of days since year\n0).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TO_DAYS(950501);\n        -> 728779\nmysql> SELECT TO_DAYS(\'2007-10-07\');\n        -> 733321\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(307,'NOT REGEXP',36,'Syntax:\nexpr NOT REGEXP pat, expr NOT RLIKE pat\n\nThis is the same as NOT (expr REGEXP pat).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/regexp.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/regexp.html'),(308,'SHOW INDEX',26,'Syntax:\nSHOW {INDEX | INDEXES | KEYS}\n    {FROM | IN} tbl_name\n    [{FROM | IN} db_name]\n    [WHERE expr]\n\nSHOW INDEX returns table index information. The format resembles that\nof the SQLStatistics call in ODBC. This statement requires some\nprivilege for any column in the table.\nYou can use db_name.tbl_name as an alternative to the tbl_name FROM\ndb_name syntax. These two statements are equivalent:\n\nSHOW INDEX FROM mytable FROM mydb;\nSHOW INDEX FROM mydb.mytable;\n\nThe WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nYou can also list a table\'s indexes with the mysqlshow -k db_name\ntbl_name command.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-index.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-index.html'),(309,'SHOW CREATE DATABASE',26,'Syntax:\nSHOW CREATE {DATABASE | SCHEMA} db_name\n\nShows the CREATE DATABASE statement that creates the given database.\nSHOW CREATE SCHEMA is a synonym for SHOW CREATE DATABASE.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-database.html\n\n','mysql> SHOW CREATE DATABASE test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test`\n                 /*!40100 DEFAULT CHARACTER SET latin1 */\n\nmysql> SHOW CREATE SCHEMA test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test`\n                 /*!40100 DEFAULT CHARACTER SET latin1 */\n','http://dev.mysql.com/doc/refman/5.5/en/show-create-database.html'),(310,'LEAVE',23,'Syntax:\nLEAVE label\n\nThis statement is used to exit the flow control construct that has the\ngiven label. If the label is for the outermost stored program block,\nLEAVE exits the program.\n\nLEAVE can be used within BEGIN ... END or loop constructs (LOOP,\nREPEAT, WHILE).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/leave-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/leave-statement.html'),(311,'NOT IN',18,'Syntax:\nexpr NOT IN (value,...)\n\nThis is the same as NOT (expr IN (value,...)).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(312,'!',14,'Syntax:\nNOT, !\n\nLogical NOT. Evaluates to 1 if the operand is 0, to 0 if the operand is\nnonzero, and NOT NULL returns NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html\n\n','mysql> SELECT NOT 10;\n        -> 0\nmysql> SELECT NOT 0;\n        -> 1\nmysql> SELECT NOT NULL;\n        -> NULL\nmysql> SELECT ! (1+1);\n        -> 0\nmysql> SELECT ! 1+1;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html'),(313,'DECLARE HANDLER',23,'Syntax:\nDECLARE handler_action HANDLER\n    FOR condition_value [, condition_value] ...\n    statement\n\nhandler_action:\n    CONTINUE\n  | EXIT\n  | UNDO\n\ncondition_value:\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n  | SQLWARNING\n  | NOT FOUND\n  | SQLEXCEPTION\n\nThe DECLARE ... HANDLER statement specifies a handler that may deal\nwith one or more conditions. If one of these conditions occurs, the\nspecified statement executes. statement can be a simple statement such\nas SET var_name = value, or a compound statement written using BEGIN\nand END (see [HELP BEGIN END]).\n\nHandler declarations must appear after variable or condition\ndeclarations.\n\nThe handler_action value indicates what action the handler takes after\nexecution of the handler statement:\n\no CONTINUE: Execution of the current program continues.\n\no EXIT: Execution terminates for the BEGIN ... END compound statement\n  in which the handler is declared. This is true even if the condition\n  occurs in an inner block.\n\no UNDO: Not supported.\n\nThe condition_value for DECLARE ... HANDLER indicates the specific\ncondition or class of conditions that activates the handler:\n\no A MySQL error code (a number) or an SQLSTATE value (a 5-character\n  string literal). You should not use MySQL error code 0 or SQLSTATE\n  values that begin with \'00\', because those indicate success rather\n  than an error condition. For a list of MySQL error codes and SQLSTATE\n  values, see\n  http://dev.mysql.com/doc/refman/5.5/en/error-messages-server.html.\n\no A condition name previously specified with DECLARE ... CONDITION. A\n  condition name can be associated with a MySQL error code or SQLSTATE\n  value. See [HELP DECLARE CONDITION].\n\no SQLWARNING is shorthand for the class of SQLSTATE values that begin\n  with \'01\'.\n\no NOT FOUND is shorthand for the class of SQLSTATE values that begin\n  with \'02\'. This is relevant within the context of cursors and is used\n  to control what happens when a cursor reaches the end of a data set.\n  If no more rows are available, a No Data condition occurs with\n  SQLSTATE value \'02000\'. To detect this condition, you can set up a\n  handler for it (or for a NOT FOUND condition). For an example, see\n  http://dev.mysql.com/doc/refman/5.5/en/cursors.html. This condition\n  also occurs for SELECT ... INTO var_list statements that retrieve no\n  rows.\n\no SQLEXCEPTION is shorthand for the class of SQLSTATE values that do\n  not begin with \'00\', \'01\', or \'02\'.\n\nIf a condition occurs for which no handler has been declared, the\naction taken depends on the class of the condition:\n\no For SQLEXCEPTION conditions, the stored program terminates at the\n  statement that raised the condition, as if there were an EXIT\n  handler. If the program was called by another stored program, the\n  caller handles the condition using the handler selection rules\n  applied to its own handlers.\n\no For SQLWARNING conditions, the program continues executing, as if\n  there were a CONTINUE handler.\n\no For NOT FOUND conditions, if the condition was raised normally, the\n  action is CONTINUE. If it was raised by SIGNAL or RESIGNAL, the\n  action is EXIT.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/declare-handler.html\n\n','mysql> CREATE TABLE test.t (s1 INT, PRIMARY KEY (s1));\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE handlerdemo ()\n    -> BEGIN\n    ->   DECLARE CONTINUE HANDLER FOR SQLSTATE \'23000\' SET @x2 = 1;\n    ->   SET @x = 1;\n    ->   INSERT INTO test.t VALUES (1);\n    ->   SET @x = 2;\n    ->   INSERT INTO test.t VALUES (1);\n    ->   SET @x = 3;\n    -> END;\n    -> //\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> CALL handlerdemo()//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @x//\n    +------+\n    | @x   |\n    +------+\n    | 3    |\n    +------+\n    1 row in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/declare-handler.html'),(314,'DOUBLE',22,'DOUBLE[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA normal-size (double-precision) floating-point number. Permissible\nvalues are -1.7976931348623157E+308 to -2.2250738585072014E-308, 0, and\n2.2250738585072014E-308 to 1.7976931348623157E+308. These are the\ntheoretical limits, based on the IEEE standard. The actual range might\nbe slightly smaller depending on your hardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A double-precision floating-point\nnumber is accurate to approximately 15 decimal places.\n\nUNSIGNED, if specified, disallows negative values.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(315,'TIME',22,'TIME\n\nA time. The range is \'-838:59:59\' to \'838:59:59\'. MySQL displays TIME\nvalues in \'HH:MM:SS\' format, but permits assignment of values to TIME\ncolumns using either strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-type-overview.html'),(316,'&&',14,'Syntax:\nAND, &&\n\nLogical AND. Evaluates to 1 if all operands are nonzero and not NULL,\nto 0 if one or more operands are 0, otherwise NULL is returned.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html\n\n','mysql> SELECT 1 && 1;\n        -> 1\nmysql> SELECT 1 && 0;\n        -> 0\nmysql> SELECT 1 && NULL;\n        -> NULL\nmysql> SELECT 0 && NULL;\n        -> 0\nmysql> SELECT NULL && 0;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/logical-operators.html'),(317,'X',11,'X(p)\n\nReturns the X-coordinate value for the Point object p as a\ndouble-precision number.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#point-property-functions\n\n','mysql> SELECT X(POINT(56.7, 53.34));\n+-----------------------+\n| X(POINT(56.7, 53.34)) |\n+-----------------------+\n|                  56.7 |\n+-----------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#point-property-functions'),(318,'SYSTEM_USER',17,'Syntax:\nSYSTEM_USER()\n\nSYSTEM_USER() is a synonym for USER().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(319,'FOUND_ROWS',17,'Syntax:\nFOUND_ROWS()\n\nA SELECT statement may include a LIMIT clause to restrict the number of\nrows the server returns to the client. In some cases, it is desirable\nto know how many rows the statement would have returned without the\nLIMIT, but without running the statement again. To obtain this row\ncount, include a SQL_CALC_FOUND_ROWS option in the SELECT statement,\nand then invoke FOUND_ROWS() afterward:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT SQL_CALC_FOUND_ROWS * FROM tbl_name\n    -> WHERE id > 100 LIMIT 10;\nmysql> SELECT FOUND_ROWS();\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(320,'CROSSES',30,'Crosses(g1,g2)\n\nReturns 1 if g1 spatially crosses g2. Returns NULL if g1 is a Polygon\nor a MultiPolygon, or if g2 is a Point or a MultiPoint. Otherwise,\nreturns 0.\n\nThe term spatially crosses denotes a spatial relation between two given\ngeometries that has the following properties:\n\no The two geometries intersect\n\no Their intersection results in a geometry that has a dimension that is\n  one less than the maximum dimension of the two given geometries\n\no Their intersection is not equal to either of the two given geometries\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(321,'TRUNCATE TABLE',38,'Syntax:\nTRUNCATE [TABLE] tbl_name\n\nTRUNCATE TABLE empties a table completely. It requires the DROP\nprivilege.\n\nLogically, TRUNCATE TABLE is similar to a DELETE statement that deletes\nall rows, or a sequence of DROP TABLE and CREATE TABLE statements. To\nachieve high performance, it bypasses the DML method of deleting data.\nThus, it cannot be rolled back, it does not cause ON DELETE triggers to\nfire, and it cannot be performed for InnoDB tables with parent-child\nforeign key relationships.\n\nAlthough TRUNCATE TABLE is similar to DELETE, it is classified as a DDL\nstatement rather than a DML statement. It differs from DELETE in the\nfollowing ways in MySQL 5.5:\n\no Truncate operations drop and re-create the table, which is much\n  faster than deleting rows one by one, particularly for large tables.\n\no Truncate operations cause an implicit commit, and so cannot be rolled\n  back.\n\no Truncation operations cannot be performed if the session holds an\n  active table lock.\n\no TRUNCATE TABLE fails for an InnoDB table if there are any FOREIGN KEY\n  constraints from other tables that reference the table. Foreign key\n  constraints between columns of the same table are allowed.\n\no Truncation operations do not return a meaningful value for the number\n  of deleted rows. The usual result is \"0 rows affected,\" which should\n  be interpreted as \"no information.\"\n\no As long as the table format file tbl_name.frm is valid, the table can\n  be re-created as an empty table with TRUNCATE TABLE, even if the data\n  or index files have become corrupted.\n\no Any AUTO_INCREMENT value is reset to its start value. This is true\n  even for MyISAM and InnoDB, which normally do not reuse sequence\n  values.\n\no When used with partitioned tables, TRUNCATE TABLE preserves the\n  partitioning; that is, the data and index files are dropped and\n  re-created, while the partition definitions (.par) file is\n  unaffected.\n\no The TRUNCATE TABLE statement does not invoke ON DELETE triggers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/truncate-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/truncate-table.html'),(322,'BIT_XOR',16,'Syntax:\nBIT_XOR(expr)\n\nReturns the bitwise XOR of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(323,'CURRENT_DATE',31,'Syntax:\nCURRENT_DATE, CURRENT_DATE()\n\nCURRENT_DATE and CURRENT_DATE() are synonyms for CURDATE().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(324,'START SLAVE',8,'Syntax:\nSTART SLAVE [thread_type [, thread_type] ... ]\nSTART SLAVE [SQL_THREAD] UNTIL\n    MASTER_LOG_FILE = \'log_name\', MASTER_LOG_POS = log_pos\nSTART SLAVE [SQL_THREAD] UNTIL\n    RELAY_LOG_FILE = \'log_name\', RELAY_LOG_POS = log_pos\n\nthread_type: IO_THREAD | SQL_THREAD\n\nSTART SLAVE with no thread_type options starts both of the slave\nthreads. The I/O thread reads events from the master server and stores\nthem in the relay log. The SQL thread reads events from the relay log\nand executes them. START SLAVE requires the SUPER privilege.\n\nIf START SLAVE succeeds in starting the slave threads, it returns\nwithout any error. However, even in that case, it might be that the\nslave threads start and then later stop (for example, because they do\nnot manage to connect to the master or read its binary log, or some\nother problem). START SLAVE does not warn you about this. You must\ncheck the slave\'s error log for error messages generated by the slave\nthreads, or check that they are running satisfactorily with SHOW SLAVE\nSTATUS.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/start-slave.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/start-slave.html'),(325,'AREA',2,'Area(poly)\n\nReturns as a double-precision number the area of the Polygon value\npoly, as measured in its spatial reference system.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly = \'Polygon((0 0,0 3,3 0,0 0),(1 1,1 2,2 1,1 1))\';\nmysql> SELECT Area(GeomFromText(@poly));\n+---------------------------+\n| Area(GeomFromText(@poly)) |\n+---------------------------+\n|                         4 |\n+---------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions'),(326,'FLUSH',26,'Syntax:\nFLUSH [NO_WRITE_TO_BINLOG | LOCAL]\n    flush_option [, flush_option] ...\n\nThe FLUSH statement clears or reloads various internal caches used by\nMySQL. Some variants acquire locks. To execute FLUSH, you must have the\nRELOAD privilege. Specific flush options might require additional\nprivileges, as described later.\n\nBy default, FLUSH statements are written to the binary log so that they\nwill be replicated to replication slaves. Logging can be suppressed\nwith the optional NO_WRITE_TO_BINLOG keyword or its alias LOCAL.\n\n*Note*: FLUSH LOGS, FLUSH MASTER, FLUSH SLAVE, and FLUSH TABLES WITH\nREAD LOCK (with or without a table list) are not written to the binary\nlog in any case because they would cause problems if replicated to a\nslave.\n\nThe RESET statement is similar to FLUSH. See [HELP RESET], for\ninformation about using the RESET statement with replication.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/flush.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/flush.html'),(327,'BEGIN END',23,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\nBEGIN ... END syntax is used for writing compound statements, which can\nappear within stored programs (stored procedures and functions,\ntriggers, and events). A compound statement can contain multiple\nstatements, enclosed by the BEGIN and END keywords. statement_list\nrepresents a list of one or more statements, each terminated by a\nsemicolon (;) statement delimiter. The statement_list itself is\noptional, so the empty compound statement (BEGIN END) is legal.\n\nBEGIN ... END blocks can be nested.\n\nUse of multiple statements requires that a client is able to send\nstatement strings containing the ; statement delimiter. In the mysql\ncommand-line client, this is handled with the delimiter command.\nChanging the ; end-of-statement delimiter (for example, to //) permit ;\nto be used in a program body. For an example, see\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-defining.html.\n\nA BEGIN ... END block can be labeled. See [HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/begin-end.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/begin-end.html'),(328,'SHOW PROCEDURE STATUS',26,'Syntax:\nSHOW PROCEDURE STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is a MySQL extension. It returns characteristics of a\nstored procedure, such as the database, name, type, creator, creation\nand modification dates, and character set information. A similar\nstatement, SHOW FUNCTION STATUS, displays information about stored\nfunctions (see [HELP SHOW FUNCTION STATUS]).\n\nThe LIKE clause, if present, indicates which procedure or function\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-procedure-status.html\n\n','mysql> SHOW PROCEDURE STATUS LIKE \'sp1\'\\G\n*************************** 1. row ***************************\n                  Db: test\n                Name: sp1\n                Type: PROCEDURE\n             Definer: testuser@localhost\n            Modified: 2004-08-03 15:29:37\n             Created: 2004-08-03 15:29:37\n       Security_type: DEFINER\n             Comment:\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','http://dev.mysql.com/doc/refman/5.5/en/show-procedure-status.html'),(329,'DESCRIBE',28,'Syntax:\n{DESCRIBE | DESC} tbl_name [col_name | wild]\n\nDESCRIBE provides information about the columns in a table. It is a\nshortcut for SHOW COLUMNS FROM. These statements also display\ninformation for views. (See [HELP SHOW COLUMNS].)\n\ncol_name can be a column name, or a string containing the SQL \"%\" and\n\"_\" wildcard characters to obtain output only for the columns with\nnames matching the string. There is no need to enclose the string\nwithin quotation marks unless it contains spaces or other special\ncharacters.\n\nmysql> DESCRIBE City;\n+------------+----------+------+-----+---------+----------------+\n| Field      | Type     | Null | Key | Default | Extra          |\n+------------+----------+------+-----+---------+----------------+\n| Id         | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name       | char(35) | NO   |     |         |                |\n| Country    | char(3)  | NO   | UNI |         |                |\n| District   | char(20) | YES  | MUL |         |                |\n| Population | int(11)  | NO   |     | 0       |                |\n+------------+----------+------+-----+---------+----------------+\n5 rows in set (0.00 sec)\n\nThe description for SHOW COLUMNS provides more information about the\noutput columns (see [HELP SHOW COLUMNS]).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/describe.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/describe.html'),(330,'SHOW WARNINGS',26,'Syntax:\nSHOW WARNINGS [LIMIT [offset,] row_count]\nSHOW COUNT(*) WARNINGS\n\nSHOW WARNINGS shows information about the conditions (errors, warnings,\nand notes) that resulted from the last statement in the current session\nthat generated messages. It shows nothing if the last statement used a\ntable and generated no messages. (That is, a statement that uses a\ntable but generates no messages clears the message list.) Statements\nthat do not use tables and do not generate messages have no effect on\nthe message list.\n\nWarnings are generated for DML statements such as INSERT, UPDATE, and\nLOAD DATA INFILE as well as DDL statements such as CREATE TABLE and\nALTER TABLE.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttp://dev.mysql.com/doc/refman/5.5/en/select.html.\n\nA related statement, SHOW ERRORS, shows only the error conditions (it\nexcludes warnings and notes). See [HELP SHOW ERRORS].\n\nThe SHOW COUNT(*) WARNINGS statement displays the total number of\nerrors, warnings, and notes. You can also retrieve this number from the\nwarning_count system variable:\n\nSHOW COUNT(*) WARNINGS;\nSELECT @@warning_count;\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-warnings.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-warnings.html'),(331,'DROP USER',10,'Syntax:\nDROP USER user [, user] ...\n\nThe DROP USER statement removes one or more MySQL accounts and their\nprivileges. It removes privilege rows for the account from all grant\ntables. To use this statement, you must have the global CREATE USER\nprivilege or the DELETE privilege for the mysql database. Each account\nname uses the format described in\nhttp://dev.mysql.com/doc/refman/5.5/en/account-names.html. For example:\n\nDROP USER \'jeffrey\'@\'localhost\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-user.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-user.html'),(332,'STDDEV_POP',16,'Syntax:\nSTDDEV_POP(expr)\n\nReturns the population standard deviation of expr (the square root of\nVAR_POP()). You can also use STD() or STDDEV(), which are equivalent\nbut not standard SQL.\n\nSTDDEV_POP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(333,'SHOW CHARACTER SET',26,'Syntax:\nSHOW CHARACTER SET\n    [LIKE \'pattern\' | WHERE expr]\n\nThe SHOW CHARACTER SET statement shows all available character sets.\nThe LIKE clause, if present, indicates which character set names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html. For example:\n\nmysql> SHOW CHARACTER SET LIKE \'latin%\';\n+---------+-----------------------------+-------------------+--------+\n| Charset | Description                 | Default collation | Maxlen |\n+---------+-----------------------------+-------------------+--------+\n| latin1  | cp1252 West European        | latin1_swedish_ci |      1 |\n| latin2  | ISO 8859-2 Central European | latin2_general_ci |      1 |\n| latin5  | ISO 8859-9 Turkish          | latin5_turkish_ci |      1 |\n| latin7  | ISO 8859-13 Baltic          | latin7_general_ci |      1 |\n+---------+-----------------------------+-------------------+--------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-character-set.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-character-set.html'),(334,'SUBSTRING',36,'Syntax:\nSUBSTRING(str,pos), SUBSTRING(str FROM pos), SUBSTRING(str,pos,len),\nSUBSTRING(str FROM pos FOR len)\n\nThe forms without a len argument return a substring from string str\nstarting at position pos. The forms with a len argument return a\nsubstring len characters long from string str, starting at position\npos. The forms that use FROM are standard SQL syntax. It is also\npossible to use a negative value for pos. In this case, the beginning\nof the substring is pos characters from the end of the string, rather\nthan the beginning. A negative value may be used for pos in any of the\nforms of this function.\n\nFor all forms of SUBSTRING(), the position of the first character in\nthe string from which the substring is to be extracted is reckoned as\n1.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT SUBSTRING(\'Quadratically\',5);\n        -> \'ratically\'\nmysql> SELECT SUBSTRING(\'foobarbar\' FROM 4);\n        -> \'barbar\'\nmysql> SELECT SUBSTRING(\'Quadratically\',5,6);\n        -> \'ratica\'\nmysql> SELECT SUBSTRING(\'Sakila\', -3);\n        -> \'ila\'\nmysql> SELECT SUBSTRING(\'Sakila\', -5, 3);\n        -> \'aki\'\nmysql> SELECT SUBSTRING(\'Sakila\' FROM -4 FOR 2);\n        -> \'ki\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(335,'ISEMPTY',35,'IsEmpty(g)\n\nReturns 1 if the geometry value g is the empty geometry, 0 if it is not\nempty, and -1 if the argument is NULL. If the geometry is empty, it\nrepresents the empty point set.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(336,'SHOW FUNCTION STATUS',26,'Syntax:\nSHOW FUNCTION STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is similar to SHOW PROCEDURE STATUS but for stored\nfunctions. See [HELP SHOW PROCEDURE STATUS].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-function-status.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-function-status.html'),(337,'LTRIM',36,'Syntax:\nLTRIM(str)\n\nReturns the string str with leading space characters removed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT LTRIM(\'  barbar\');\n        -> \'barbar\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(338,'INTERSECTS',30,'Intersects(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially intersects g2.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(339,'CALL',27,'Syntax:\nCALL sp_name([parameter[,...]])\nCALL sp_name[()]\n\nThe CALL statement invokes a stored procedure that was defined\npreviously with CREATE PROCEDURE.\n\nStored procedures that take no arguments can be invoked without\nparentheses. That is, CALL p() and CALL p are equivalent.\n\nCALL can pass back values to its caller using parameters that are\ndeclared as OUT or INOUT parameters. When the procedure returns, a\nclient program can also obtain the number of rows affected for the\nfinal statement executed within the routine: At the SQL level, call the\nROW_COUNT() function; from the C API, call the mysql_affected_rows()\nfunction.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/call.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/call.html'),(340,'MBRDISJOINT',6,'MBRDisjoint(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 are disjoint (do not intersect).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(341,'VALUES',15,'Syntax:\nVALUES(col_name)\n\nIn an INSERT ... ON DUPLICATE KEY UPDATE statement, you can use the\nVALUES(col_name) function in the UPDATE clause to refer to column\nvalues from the INSERT portion of the statement. In other words,\nVALUES(col_name) in the UPDATE clause refers to the value of col_name\nthat would be inserted, had no duplicate-key conflict occurred. This\nfunction is especially useful in multiple-row inserts. The VALUES()\nfunction is meaningful only in the ON DUPLICATE KEY UPDATE clause of\nINSERT statements and returns NULL otherwise. See\nhttp://dev.mysql.com/doc/refman/5.5/en/insert-on-duplicate.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> INSERT INTO table (a,b,c) VALUES (1,2,3),(4,5,6)\n    -> ON DUPLICATE KEY UPDATE c=VALUES(a)+VALUES(b);\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(342,'SUBSTRING_INDEX',36,'Syntax:\nSUBSTRING_INDEX(str,delim,count)\n\nReturns the substring from string str before count occurrences of the\ndelimiter delim. If count is positive, everything to the left of the\nfinal delimiter (counting from the left) is returned. If count is\nnegative, everything to the right of the final delimiter (counting from\nthe right) is returned. SUBSTRING_INDEX() performs a case-sensitive\nmatch when searching for delim.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT SUBSTRING_INDEX(\'www.mysql.com\', \'.\', 2);\n        -> \'www.mysql\'\nmysql> SELECT SUBSTRING_INDEX(\'www.mysql.com\', \'.\', -2);\n        -> \'mysql.com\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(343,'ENCODE',12,'Syntax:\nENCODE(str,pass_str)\n\nEncrypt str using pass_str as the password. To decrypt the result, use\nDECODE().\n\nThe result is a binary string of the same length as str.\n\nThe strength of the encryption is based on how good the random\ngenerator is. It should suffice for short strings.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(344,'LOOP',23,'Syntax:\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\nLOOP implements a simple loop construct, enabling repeated execution of\nthe statement list, which consists of one or more statements, each\nterminated by a semicolon (;) statement delimiter. The statements\nwithin the loop are repeated until the loop is terminated. Usually,\nthis is accomplished with a LEAVE statement. Within a stored function,\nRETURN can also be used, which exits the function entirely.\n\nNeglecting to include a loop-termination statement results in an\ninfinite loop.\n\nA LOOP statement can be labeled. For the rules regarding label use, see\n[HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/loop-statement.html\n\n','CREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN\n      ITERATE label1;\n    END IF;\n    LEAVE label1;\n  END LOOP label1;\n  SET @x = p1;\nEND;\n','http://dev.mysql.com/doc/refman/5.5/en/loop-statement.html'),(345,'TRUNCATE',4,'Syntax:\nTRUNCATE(X,D)\n\nReturns the number X, truncated to D decimal places. If D is 0, the\nresult has no decimal point or fractional part. D can be negative to\ncause D digits left of the decimal point of the value X to become zero.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT TRUNCATE(1.223,1);\n        -> 1.2\nmysql> SELECT TRUNCATE(1.999,1);\n        -> 1.9\nmysql> SELECT TRUNCATE(1.999,0);\n        -> 1\nmysql> SELECT TRUNCATE(-1.999,1);\n        -> -1.9\nmysql> SELECT TRUNCATE(122,-2);\n       -> 100\nmysql> SELECT TRUNCATE(10.28*100,0);\n       -> 1028\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(346,'TIMESTAMPADD',31,'Syntax:\nTIMESTAMPADD(unit,interval,datetime_expr)\n\nAdds the integer expression interval to the date or datetime expression\ndatetime_expr. The unit for interval is given by the unit argument,\nwhich should be one of the following values: MICROSECOND\n(microseconds), SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or\nYEAR.\n\nIt is possible to use FRAC_SECOND in place of MICROSECOND, but\nFRAC_SECOND is deprecated. FRAC_SECOND was removed in MySQL 5.5.3.\n\nThe unit value may be specified using one of keywords as shown, or with\na prefix of SQL_TSI_. For example, DAY and SQL_TSI_DAY both are legal.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMPADD(MINUTE,1,\'2003-01-02\');\n        -> \'2003-01-02 00:01:00\'\nmysql> SELECT TIMESTAMPADD(WEEK,1,\'2003-01-02\');\n        -> \'2003-01-09\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(347,'SHOW',26,'SHOW has many forms that provide information about databases, tables,\ncolumns, or status information about the server. This section describes\nthose following:\n\nSHOW AUTHORS\nSHOW {BINARY | MASTER} LOGS\nSHOW BINLOG EVENTS [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\nSHOW CHARACTER SET [like_or_where]\nSHOW COLLATION [like_or_where]\nSHOW [FULL] COLUMNS FROM tbl_name [FROM db_name] [like_or_where]\nSHOW CONTRIBUTORS\nSHOW CREATE DATABASE db_name\nSHOW CREATE EVENT event_name\nSHOW CREATE FUNCTION func_name\nSHOW CREATE PROCEDURE proc_name\nSHOW CREATE TABLE tbl_name\nSHOW CREATE TRIGGER trigger_name\nSHOW CREATE VIEW view_name\nSHOW DATABASES [like_or_where]\nSHOW ENGINE engine_name {STATUS | MUTEX}\nSHOW [STORAGE] ENGINES\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW EVENTS\nSHOW FUNCTION CODE func_name\nSHOW FUNCTION STATUS [like_or_where]\nSHOW GRANTS FOR user\nSHOW INDEX FROM tbl_name [FROM db_name]\nSHOW MASTER STATUS\nSHOW OPEN TABLES [FROM db_name] [like_or_where]\nSHOW PLUGINS\nSHOW PROCEDURE CODE proc_name\nSHOW PROCEDURE STATUS [like_or_where]\nSHOW PRIVILEGES\nSHOW [FULL] PROCESSLIST\nSHOW PROFILE [types] [FOR QUERY n] [OFFSET n] [LIMIT n]\nSHOW PROFILES\nSHOW SLAVE HOSTS\nSHOW SLAVE STATUS\nSHOW [GLOBAL | SESSION] STATUS [like_or_where]\nSHOW TABLE STATUS [FROM db_name] [like_or_where]\nSHOW [FULL] TABLES [FROM db_name] [like_or_where]\nSHOW TRIGGERS [FROM db_name] [like_or_where]\nSHOW [GLOBAL | SESSION] VARIABLES [like_or_where]\nSHOW WARNINGS [LIMIT [offset,] row_count]\n\nlike_or_where:\n    LIKE \'pattern\'\n  | WHERE expr\n\nIf the syntax for a given SHOW statement includes a LIKE \'pattern\'\npart, \'pattern\' is a string that can contain the SQL \"%\" and \"_\"\nwildcard characters. The pattern is useful for restricting statement\noutput to matching values.\n\nSeveral SHOW statements also accept a WHERE clause that provides more\nflexibility in specifying which rows to display. See\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show.html'),(348,'GREATEST',18,'Syntax:\nGREATEST(value1,value2,...)\n\nWith two or more arguments, returns the largest (maximum-valued)\nargument. The arguments are compared using the same rules as for\nLEAST().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT GREATEST(2,0);\n        -> 2\nmysql> SELECT GREATEST(34.0,3.0,5.0,767.0);\n        -> 767.0\nmysql> SELECT GREATEST(\'B\',\'A\',\'C\');\n        -> \'C\'\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(349,'SHOW VARIABLES',26,'Syntax:\nSHOW [GLOBAL | SESSION] VARIABLES\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW VARIABLES shows the values of MySQL system variables. This\ninformation also can be obtained using the mysqladmin variables\ncommand. The LIKE clause, if present, indicates which variable names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html. This\nstatement does not require any privilege. It requires only the ability\nto connect to the server.\n\nWith the GLOBAL modifier, SHOW VARIABLES displays the values that are\nused for new connections to MySQL. As of MySQL 5.5.3, if a variable has\nno global value, no value is displayed. Before 5.5.3, the session value\nis displayed. With SESSION, SHOW VARIABLES displays the values that are\nin effect for the current connection. If no modifier is present, the\ndefault is SESSION. LOCAL is a synonym for SESSION.\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern. To obtain the row for a\nspecific variable, use a LIKE clause as shown:\n\nSHOW VARIABLES LIKE \'max_join_size\';\nSHOW SESSION VARIABLES LIKE \'max_join_size\';\n\nTo get a list of variables whose name match a pattern, use the \"%\"\nwildcard character in a LIKE clause:\n\nSHOW VARIABLES LIKE \'%size%\';\nSHOW GLOBAL VARIABLES LIKE \'%size%\';\n\nWildcard characters can be used in any position within the pattern to\nbe matched. Strictly speaking, because \"_\" is a wildcard that matches\nany single character, you should escape it as \"\\_\" to match it\nliterally. In practice, this is rarely necessary.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-variables.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-variables.html'),(350,'BINLOG',26,'Syntax:\nBINLOG \'str\'\n\nBINLOG is an internal-use statement. It is generated by the mysqlbinlog\nprogram as the printable representation of certain events in binary log\nfiles. (See http://dev.mysql.com/doc/refman/5.5/en/mysqlbinlog.html.)\nThe \'str\' value is a base 64-encoded string the that server decodes to\ndetermine the data change indicated by the corresponding event. This\nstatement requires the SUPER privilege.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/binlog.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/binlog.html'),(351,'BIT_AND',16,'Syntax:\nBIT_AND(expr)\n\nReturns the bitwise AND of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(352,'SECOND',31,'Syntax:\nSECOND(time)\n\nReturns the second for time, in the range 0 to 59.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT SECOND(\'10:05:03\');\n        -> 3\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(353,'ATAN2',4,'Syntax:\nATAN(Y,X), ATAN2(Y,X)\n\nReturns the arc tangent of the two variables X and Y. It is similar to\ncalculating the arc tangent of Y / X, except that the signs of both\narguments are used to determine the quadrant of the result.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT ATAN(-2,2);\n        -> -0.78539816339745\nmysql> SELECT ATAN2(PI(),0);\n        -> 1.5707963267949\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(354,'MBRCONTAINS',6,'MBRContains(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangle of g1\ncontains the Minimum Bounding Rectangle of g2. This tests the opposite\nrelationship as MBRWithin().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','mysql> SET @g1 = GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = GeomFromText(\'Point(1 1)\');\nmysql> SELECT MBRContains(@g1,@g2), MBRContains(@g2,@g1);\n----------------------+----------------------+\n| MBRContains(@g1,@g2) | MBRContains(@g2,@g1) |\n+----------------------+----------------------+\n|                    1 |                    0 |\n+----------------------+----------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(355,'HOUR',31,'Syntax:\nHOUR(time)\n\nReturns the hour for time. The range of the return value is 0 to 23 for\ntime-of-day values. However, the range of TIME values actually is much\nlarger, so HOUR can return values greater than 23.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT HOUR(\'10:05:03\');\n        -> 10\nmysql> SELECT HOUR(\'272:59:59\');\n        -> 272\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(356,'SELECT',27,'Syntax:\nSELECT\n    [ALL | DISTINCT | DISTINCTROW ]\n      [HIGH_PRIORITY]\n      [STRAIGHT_JOIN]\n      [SQL_SMALL_RESULT] [SQL_BIG_RESULT] [SQL_BUFFER_RESULT]\n      [SQL_CACHE | SQL_NO_CACHE] [SQL_CALC_FOUND_ROWS]\n    select_expr [, select_expr ...]\n    [FROM table_references\n    [WHERE where_condition]\n    [GROUP BY {col_name | expr | position}\n      [ASC | DESC], ... [WITH ROLLUP]]\n    [HAVING where_condition]\n    [ORDER BY {col_name | expr | position}\n      [ASC | DESC], ...]\n    [LIMIT {[offset,] row_count | row_count OFFSET offset}]\n    [PROCEDURE procedure_name(argument_list)]\n    [INTO OUTFILE \'file_name\'\n        [CHARACTER SET charset_name]\n        export_options\n      | INTO DUMPFILE \'file_name\'\n      | INTO var_name [, var_name]]\n    [FOR UPDATE | LOCK IN SHARE MODE]]\n\nSELECT is used to retrieve rows selected from one or more tables, and\ncan include UNION statements and subqueries. See [HELP UNION], and\nhttp://dev.mysql.com/doc/refman/5.5/en/subqueries.html.\n\nThe most commonly used clauses of SELECT statements are these:\n\no Each select_expr indicates a column that you want to retrieve. There\n  must be at least one select_expr.\n\no table_references indicates the table or tables from which to retrieve\n  rows. Its syntax is described in [HELP JOIN].\n\no The WHERE clause, if given, indicates the condition or conditions\n  that rows must satisfy to be selected. where_condition is an\n  expression that evaluates to true for each row to be selected. The\n  statement selects all rows if there is no WHERE clause.\n\n  In the WHERE expression, you can use any of the functions and\n  operators that MySQL supports, except for aggregate (summary)\n  functions. See\n  http://dev.mysql.com/doc/refman/5.5/en/expressions.html, and\n  http://dev.mysql.com/doc/refman/5.5/en/functions.html.\n\nSELECT can also be used to retrieve rows computed without reference to\nany table.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/select.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/select.html'),(357,'COT',4,'Syntax:\nCOT(X)\n\nReturns the cotangent of X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT COT(12);\n        -> -1.5726734063977\nmysql> SELECT COT(0);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(358,'SHOW CREATE EVENT',26,'Syntax:\nSHOW CREATE EVENT event_name\n\nThis statement displays the CREATE EVENT statement needed to re-create\na given event. For example (using the same event e_daily defined and\nthen altered in [HELP SHOW EVENTS]):\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-event.html\n\n','mysql> SHOW CREATE EVENT test.e_daily\\G\n*************************** 1. row ***************************\n               Event: e_daily\n            sql_mode:\n           time_zone: SYSTEM\n        Create Event: CREATE EVENT `e_daily`\n                        ON SCHEDULE EVERY 1 DAY\n                        STARTS CURRENT_TIMESTAMP + INTERVAL 6 HOUR\n                        ON COMPLETION NOT PRESERVE\n                        ENABLE\n                        COMMENT \'Saves total number of sessions then\n                                clears the table each day\'\n                        DO BEGIN\n                          INSERT INTO site_activity.totals (time, total)\n                            SELECT CURRENT_TIMESTAMP, COUNT(*)\n                            FROM site_activity.sessions;\n                          DELETE FROM site_activity.sessions;\n                        END\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','http://dev.mysql.com/doc/refman/5.5/en/show-create-event.html'),(359,'LOAD_FILE',36,'Syntax:\nLOAD_FILE(file_name)\n\nReads the file and returns the file contents as a string. To use this\nfunction, the file must be located on the server host, you must specify\nthe full path name to the file, and you must have the FILE privilege.\nThe file must be readable by all and its size less than\nmax_allowed_packet bytes. If the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory.\n\nIf the file does not exist or cannot be read because one of the\npreceding conditions is not satisfied, the function returns NULL.\n\nThe character_set_filesystem system variable controls interpretation of\nfile names that are given as literal strings.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> UPDATE t\n            SET blob_col=LOAD_FILE(\'/tmp/picture\')\n            WHERE id=1;\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(360,'POINTFROMTEXT',3,'PointFromText(wkt[,srid])\n\nConstructs a POINT value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(361,'GROUP_CONCAT',16,'Syntax:\nGROUP_CONCAT(expr)\n\nThis function returns a string result with the concatenated non-NULL\nvalues from a group. It returns NULL if there are no non-NULL values.\nThe full syntax is as follows:\n\nGROUP_CONCAT([DISTINCT] expr [,expr ...]\n             [ORDER BY {unsigned_integer | col_name | expr}\n                 [ASC | DESC] [,col_name ...]]\n             [SEPARATOR str_val])\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','mysql> SELECT student_name,\n    ->     GROUP_CONCAT(test_score)\n    ->     FROM student\n    ->     GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(362,'DATE_FORMAT',31,'Syntax:\nDATE_FORMAT(date,format)\n\nFormats the date value according to the format string.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_FORMAT(\'2009-10-04 22:23:00\', \'%W %M %Y\');\n        -> \'Sunday October 2009\'\nmysql> SELECT DATE_FORMAT(\'2007-10-04 22:23:00\', \'%H:%i:%s\');\n        -> \'22:23:00\'\nmysql> SELECT DATE_FORMAT(\'1900-10-04 22:23:00\',\n    ->                 \'%D %y %a %d %m %b %j\');\n        -> \'4th 00 Thu 04 10 Oct 277\'\nmysql> SELECT DATE_FORMAT(\'1997-10-04 22:23:00\',\n    ->                 \'%H %k %I %r %T %S %w\');\n        -> \'22 22 10 10:23:00 PM 22:23:00 00 6\'\nmysql> SELECT DATE_FORMAT(\'1999-01-01\', \'%X %V\');\n        -> \'1998 52\'\nmysql> SELECT DATE_FORMAT(\'2006-06-00\', \'%d\');\n        -> \'00\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(363,'BENCHMARK',17,'Syntax:\nBENCHMARK(count,expr)\n\nThe BENCHMARK() function executes the expression expr repeatedly count\ntimes. It may be used to time how quickly MySQL processes the\nexpression. The result value is always 0. The intended use is from\nwithin the mysql client, which reports query execution times:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT BENCHMARK(1000000,ENCODE(\'hello\',\'goodbye\'));\n+----------------------------------------------+\n| BENCHMARK(1000000,ENCODE(\'hello\',\'goodbye\')) |\n+----------------------------------------------+\n|                                            0 |\n+----------------------------------------------+\n1 row in set (4.74 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(364,'YEAR',31,'Syntax:\nYEAR(date)\n\nReturns the year for date, in the range 1000 to 9999, or 0 for the\n\"zero\" date.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT YEAR(\'1987-01-01\');\n        -> 1987\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(365,'SHOW ENGINE',26,'Syntax:\nSHOW ENGINE engine_name {STATUS | MUTEX}\n\nSHOW ENGINE displays operational information about a storage engine.\nThe following statements currently are supported:\n\nSHOW ENGINE INNODB STATUS\nSHOW ENGINE INNODB MUTEX\nSHOW ENGINE {NDB | NDBCLUSTER} STATUS\nSHOW ENGINE PERFORMANCE_SCHEMA STATUS\n\nSHOW ENGINE INNODB STATUS displays extensive information from the\nstandard InnoDB Monitor about the state of the InnoDB storage engine.\nFor information about the standard monitor and other InnoDB Monitors\nthat provide information about InnoDB processing, see\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-monitors.html.\n\nSHOW ENGINE INNODB MUTEX displays InnoDB mutex statistics. The\nstatement displays the following fields:\n\no Type\n\n  Always InnoDB.\n\no Name\n\n  The source file where the mutex is implemented, and the line number\n  in the file where the mutex is created. The line number may change\n  depending on your version of MySQL.\n\no Status\n\n  The mutex status. This field displays several values if UNIV_DEBUG\n  was defined at MySQL compilation time (for example, in include/univ.i\n  in the InnoDB part of the MySQL source tree). If UNIV_DEBUG was not\n  defined, the statement displays only the os_waits value. In the\n  latter case (without UNIV_DEBUG), the information on which the output\n  is based is insufficient to distinguish regular mutexes and mutexes\n  that protect rw-locks (which permit multiple readers or a single\n  writer). Consequently, the output may appear to contain multiple rows\n  for the same mutex.\n\n  o count indicates how many times the mutex was requested.\n\n  o spin_waits indicates how many times the spinlock had to run.\n\n  o spin_rounds indicates the number of spinlock rounds. (spin_rounds\n    divided by spin_waits provides the average round count.)\n\n  o os_waits indicates the number of operating system waits. This\n    occurs when the spinlock did not work (the mutex was not locked\n    during the spinlock and it was necessary to yield to the operating\n    system and wait).\n\n  o os_yields indicates the number of times a the thread trying to lock\n    a mutex gave up its timeslice and yielded to the operating system\n    (on the presumption that permitting other threads to run will free\n    the mutex so that it can be locked).\n\n  o os_wait_times indicates the amount of time (in ms) spent in\n    operating system waits, if the timed_mutexes system variable is 1\n    (ON). If timed_mutexes is 0 (OFF), timing is disabled, so\n    os_wait_times is 0. timed_mutexes is off by default.\n\nInformation from this statement can be used to diagnose system\nproblems. For example, large values of spin_waits and spin_rounds may\nindicate scalability problems.\n\nUse SHOW ENGINE PERFORMANCE_SCHEMA STATUS to inspect the internal\noperation of the Performance Schema code:\n\nmysql> SHOW ENGINE PERFORMANCE_SCHEMA STATUS\\G\n...\n*************************** 3. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.row_size\nStatus: 76\n*************************** 4. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.row_count\nStatus: 10000\n*************************** 5. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.memory\nStatus: 760000\n...\n*************************** 57. row ***************************\n  Type: performance_schema\n  Name: performance_schema.memory\nStatus: 26459600\n...\n\nThe intent of this statement is to help the DBA to understand the\neffects that different options have on memory requirements.\n\nName values consist of two parts, which name an internal buffer and an\nattribute of the buffer, respectively:\n\no Internal buffers that are exposed as a table in the\n  performance_schema database are named after the table. Examples:\n  events_waits_history.row_size, mutex_instances.row_count.\n\no Internal buffers that are not exposed as a table are named within\n  parentheses. Examples: (pfs_cond_class).row_size,\n  (pfs_mutex_class).memory.\n\no Values that apply to the Performance Schema as a whole begin with\n  performance_schema. Example: performance_schema.memory.\n\nAttributes have these meanings:\n\no row_size cannot be changed. It is the size of the internal record\n  used by the implementation.\n\no row_count can be changed depending on the configuration options.\n\no For a table, tbl_name.memory is the product of row_size multiplied by\n  row_count. For the Performance Schema as a whole,\n  performance_schema.memory is the sum of all the memory used (the sum\n  of all other memory values).\n\nIn some cases, there is a direct relationship between a configuration\nparameter and a SHOW ENGINE value. For example,\nevents_waits_history_long.row_count corresponds to\nperformance_schema_events_waits_history_long_size. In other cases, the\nrelationship is more complex. For example,\nevents_waits_history.row_count corresponds to\nperformance_schema_events_waits_history_size (the number of rows per\nthread) multiplied by performance_schema_max_thread_instances ( the\nnumber of threads).\n\nIf the server has the NDBCLUSTER storage engine enabled, SHOW ENGINE\nNDB STATUS displays cluster status information such as the number of\nconnected data nodes, the cluster connectstring, and cluster binlog\nepochs, as well as counts of various Cluster API objects created by the\nMySQL Server when connected to the cluster. Sample output from this\nstatement is shown here:\n\nmysql> SHOW ENGINE NDB STATUS;\n+------------+-----------------------+--------------------------------------------------+\n| Type       | Name                  | Status                                           |\n+------------+-----------------------+--------------------------------------------------+\n| ndbcluster | connection            | cluster_node_id=7,\n  connected_host=192.168.0.103, connected_port=1186, number_of_data_nodes=4,\n  number_of_ready_data_nodes=3, connect_count=0                                         |\n| ndbcluster | NdbTransaction        | created=6, free=0, sizeof=212                    |\n| ndbcluster | NdbOperation          | created=8, free=8, sizeof=660                    |\n| ndbcluster | NdbIndexScanOperation | created=1, free=1, sizeof=744                    |\n| ndbcluster | NdbIndexOperation     | created=0, free=0, sizeof=664                    |\n| ndbcluster | NdbRecAttr            | created=1285, free=1285, sizeof=60               |\n| ndbcluster | NdbApiSignal          | created=16, free=16, sizeof=136                  |\n| ndbcluster | NdbLabel              | created=0, free=0, sizeof=196                    |\n| ndbcluster | NdbBranch             | created=0, free=0, sizeof=24                     |\n| ndbcluster | NdbSubroutine         | created=0, free=0, sizeof=68                     |\n| ndbcluster | NdbCall               | created=0, free=0, sizeof=16                     |\n| ndbcluster | NdbBlob               | created=1, free=1, sizeof=264                    |\n| ndbcluster | NdbReceiver           | created=4, free=0, sizeof=68                     |\n| ndbcluster | binlog                | latest_epoch=155467, latest_trans_epoch=148126,\n  latest_received_binlog_epoch=0, latest_handled_binlog_epoch=0,\n  latest_applied_binlog_epoch=0                                                         |\n+------------+-----------------------+--------------------------------------------------+\n\nThe rows with connection and binlog in the Name column were added to\nthe output of this statement in MySQL 5.1. The Status column in each of\nthese rows provides information about the MySQL server\'s connection to\nthe cluster and about the cluster binary log\'s status, respectively.\nThe Status information is in the form of comma-delimited set of\nname/value pairs.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-engine.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-engine.html'),(366,'NAME_CONST',15,'Syntax:\nNAME_CONST(name,value)\n\nReturns the given value. When used to produce a result set column,\nNAME_CONST() causes the column to have the given name. The arguments\nshould be constants.\n\nmysql> SELECT NAME_CONST(\'myname\', 14);\n+--------+\n| myname |\n+--------+\n|     14 |\n+--------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(367,'RELEASE_LOCK',15,'Syntax:\nRELEASE_LOCK(str)\n\nReleases the lock named by the string str that was obtained with\nGET_LOCK(). Returns 1 if the lock was released, 0 if the lock was not\nestablished by this thread (in which case the lock is not released),\nand NULL if the named lock did not exist. The lock does not exist if it\nwas never obtained by a call to GET_LOCK() or if it has previously been\nreleased.\n\nThe DO statement is convenient to use with RELEASE_LOCK(). See [HELP\nDO].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(368,'IS NULL',18,'Syntax:\nIS NULL\n\nTests whether a value is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NULL, 0 IS NULL, NULL IS NULL;\n        -> 0, 0, 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(369,'CONVERT_TZ',31,'Syntax:\nCONVERT_TZ(dt,from_tz,to_tz)\n\nCONVERT_TZ() converts a datetime value dt from the time zone given by\nfrom_tz to the time zone given by to_tz and returns the resulting\nvalue. Time zones are specified as described in\nhttp://dev.mysql.com/doc/refman/5.5/en/time-zone-support.html. This\nfunction returns NULL if the arguments are invalid.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'GMT\',\'MET\');\n        -> \'2004-01-01 13:00:00\'\nmysql> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'+00:00\',\'+10:00\');\n        -> \'2004-01-01 22:00:00\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(370,'TIME_TO_SEC',31,'Syntax:\nTIME_TO_SEC(time)\n\nReturns the time argument, converted to seconds.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIME_TO_SEC(\'22:23:00\');\n        -> 80580\nmysql> SELECT TIME_TO_SEC(\'00:39:38\');\n        -> 2378\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(371,'WEEKDAY',31,'Syntax:\nWEEKDAY(date)\n\nReturns the weekday index for date (0 = Monday, 1 = Tuesday, ... 6 =\nSunday).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT WEEKDAY(\'2008-02-03 22:23:00\');\n        -> 6\nmysql> SELECT WEEKDAY(\'2007-11-06\');\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(372,'EXPORT_SET',36,'Syntax:\nEXPORT_SET(bits,on,off[,separator[,number_of_bits]])\n\nReturns a string such that for every bit set in the value bits, you get\nan on string and for every bit not set in the value, you get an off\nstring. Bits in bits are examined from right to left (from low-order to\nhigh-order bits). Strings are added to the result from left to right,\nseparated by the separator string (the default being the comma\ncharacter \",\"). The number of bits examined is given by number_of_bits,\nwhich has a default of 64 if not specified. number_of_bits is silently\nclipped to 64 if larger than 64. It is treated as an unsigned integer,\nso a value of -1 is effectively the same as 64.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT EXPORT_SET(5,\'Y\',\'N\',\',\',4);\n        -> \'Y,N,Y,N\'\nmysql> SELECT EXPORT_SET(6,\'1\',\'0\',\',\',10);\n        -> \'0,1,1,0,0,0,0,0,0,0\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(373,'ALTER SERVER',38,'Syntax:\nALTER SERVER  server_name\n    OPTIONS (option [, option] ...)\n\nAlters the server information for server_name, adjusting any of the\noptions allowed in the CREATE SERVER statement. See [HELP CREATE\nSERVER]. The corresponding fields in the mysql.servers table are\nupdated accordingly. This statement requires the SUPER privilege.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-server.html\n\n','ALTER SERVER s OPTIONS (USER \'sally\');\n','http://dev.mysql.com/doc/refman/5.5/en/alter-server.html'),(374,'RESIGNAL',23,'Syntax:\nRESIGNAL [condition_value]\n    [SET signal_information_item\n    [, signal_information_item] ...]\n\ncondition_value:\n    SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n\nsignal_information_item:\n    condition_information_item_name = simple_value_specification\n\ncondition_information_item_name:\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n\ncondition_name, simple_value_specification:\n    (see following discussion)\n\nRESIGNAL passes on the error condition information that is available\nduring execution of a condition handler within a compound statement\ninside a stored procedure or function, trigger, or event. RESIGNAL may\nchange some or all information before passing it on.\n\nRESIGNAL makes it possible to both handle an error and return the error\ninformation. Otherwise, by executing an SQL statement within the\nhandler, information that caused the handler\'s activation is destroyed.\nRESIGNAL also can make some procedures shorter if a given handler can\nhandle part of a situation, then pass the condition \"up the line\" to\nanother handler.\n\nNo special privileges are required to execute the RESIGNAL statement.\n\nUnless otherwise indicated, the definitions and rules for\ncondition_value and signal_information_item are the same for the\nRESIGNAL statement as for SIGNAL (see [HELP SIGNAL]).\n\nThe RESIGNAL statement takes condition_value and SET clauses, both of\nwhich are optional. This leads to several possible uses:\n\no RESIGNAL alone:\n\nRESIGNAL;\n\no RESIGNAL with new signal information:\n\nRESIGNAL SET signal_information_item [, signal_information_item] ...;\n\no RESIGNAL with a condition value and possibly new signal information:\n\nRESIGNAL condition_value\n    [SET signal_information_item [, signal_information_item] ...];\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/resignal.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/resignal.html'),(375,'TIME FUNCTION',31,'Syntax:\nTIME(expr)\n\nExtracts the time part of the time or datetime expression expr and\nreturns it as a string.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT TIME(\'2003-12-31 01:02:03\');\n        -> \'01:02:03\'\nmysql> SELECT TIME(\'2003-12-31 01:02:03.000123\');\n        -> \'01:02:03.000123\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(376,'DATE_ADD',31,'Syntax:\nDATE_ADD(date,INTERVAL expr unit), DATE_SUB(date,INTERVAL expr unit)\n\nThese functions perform date arithmetic. The date argument specifies\nthe starting date or datetime value. expr is an expression specifying\nthe interval value to be added or subtracted from the starting date.\nexpr is a string; it may start with a \"-\" for negative intervals. unit\nis a keyword indicating the units in which the expression should be\ninterpreted.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT \'2008-12-31 23:59:59\' + INTERVAL 1 SECOND;\n        -> \'2009-01-01 00:00:00\'\nmysql> SELECT INTERVAL 1 DAY + \'2008-12-31\';\n        -> \'2009-01-01\'\nmysql> SELECT \'2005-01-01\' - INTERVAL 1 SECOND;\n        -> \'2004-12-31 23:59:59\'\nmysql> SELECT DATE_ADD(\'2000-12-31 23:59:59\',\n    ->                 INTERVAL 1 SECOND);\n        -> \'2001-01-01 00:00:00\'\nmysql> SELECT DATE_ADD(\'2010-12-31 23:59:59\',\n    ->                 INTERVAL 1 DAY);\n        -> \'2011-01-01 23:59:59\'\nmysql> SELECT DATE_ADD(\'2100-12-31 23:59:59\',\n    ->                 INTERVAL \'1:1\' MINUTE_SECOND);\n        -> \'2101-01-01 00:01:00\'\nmysql> SELECT DATE_SUB(\'2005-01-01 00:00:00\',\n    ->                 INTERVAL \'1 1:1:1\' DAY_SECOND);\n        -> \'2004-12-30 22:58:59\'\nmysql> SELECT DATE_ADD(\'1900-01-01 00:00:00\',\n    ->                 INTERVAL \'-1 10\' DAY_HOUR);\n        -> \'1899-12-30 14:00:00\'\nmysql> SELECT DATE_SUB(\'1998-01-02\', INTERVAL 31 DAY);\n        -> \'1997-12-02\'\nmysql> SELECT DATE_ADD(\'1992-12-31 23:59:59.000002\',\n    ->            INTERVAL \'1.999999\' SECOND_MICROSECOND);\n        -> \'1993-01-01 00:00:01.000001\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(377,'CAST',36,'Syntax:\nCAST(expr AS type)\n\nThe CAST() function takes a value of one type and produce a value of\nanother type, similar to CONVERT(). See the description of CONVERT()\nfor more information.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/cast-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/cast-functions.html'),(378,'SOUNDS LIKE',36,'Syntax:\nexpr1 SOUNDS LIKE expr2\n\nThis is the same as SOUNDEX(expr1) = SOUNDEX(expr2).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(379,'PERIOD_DIFF',31,'Syntax:\nPERIOD_DIFF(P1,P2)\n\nReturns the number of months between periods P1 and P2. P1 and P2\nshould be in the format YYMM or YYYYMM. Note that the period arguments\nP1 and P2 are not date values.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT PERIOD_DIFF(200802,200703);\n        -> 11\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(380,'LIKE',36,'Syntax:\nexpr LIKE pat [ESCAPE \'escape_char\']\n\nPattern matching using SQL simple regular expression comparison.\nReturns 1 (TRUE) or 0 (FALSE). If either expr or pat is NULL, the\nresult is NULL.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-comparison-functions.html\n\n','mysql> SELECT \'David!\' LIKE \'David_\';\n        -> 1\nmysql> SELECT \'David!\' LIKE \'%D%v%\';\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/string-comparison-functions.html'),(381,'MULTIPOINT',24,'MultiPoint(pt1,pt2,...)\n\nConstructs a MultiPoint value using Point or WKB Point arguments.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(382,'>>',19,'Syntax:\n>>\n\nShifts a longlong (BIGINT) number to the right.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT 4 >> 2;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(383,'FETCH',23,'Syntax:\nFETCH cursor_name INTO var_name [, var_name] ...\n\nThis statement fetches the next row for the SELECT statement associated\nwith the specified cursor (which must be open), and advances the cursor\npointer. If a row exists, the fetched columns are stored in the named\nvariables. The number of columns retrieved by the SELECT statement must\nmatch the number of output variables specified in the FETCH statement.\n\nIf no more rows are available, a No Data condition occurs with SQLSTATE\nvalue \'02000\'. To detect this condition, you can set up a handler for\nit (or for a NOT FOUND condition). For an example, see\nhttp://dev.mysql.com/doc/refman/5.5/en/cursors.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/fetch.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/fetch.html'),(384,'AVG',16,'Syntax:\nAVG([DISTINCT] expr)\n\nReturns the average value of expr. The DISTINCT option can be used to\nreturn the average of the distinct values of expr.\n\nAVG() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','mysql> SELECT student_name, AVG(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(385,'TRUE FALSE',29,'The constants TRUE and FALSE evaluate to 1 and 0, respectively. The\nconstant names can be written in any lettercase.\n\nmysql> SELECT TRUE, true, FALSE, false;\n        -> 1, 1, 0, 0\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/boolean-literals.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/boolean-literals.html'),(386,'MBRWITHIN',6,'MBRWithin(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangle of g1\nis within the Minimum Bounding Rectangle of g2. This tests the opposite\nrelationship as MBRContains().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','mysql> SET @g1 = GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = GeomFromText(\'Polygon((0 0,0 5,5 5,5 0,0 0))\');\nmysql> SELECT MBRWithin(@g1,@g2), MBRWithin(@g2,@g1);\n+--------------------+--------------------+\n| MBRWithin(@g1,@g2) | MBRWithin(@g2,@g1) |\n+--------------------+--------------------+\n|                  1 |                  0 |\n+--------------------+--------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(387,'SESSION_USER',17,'Syntax:\nSESSION_USER()\n\nSESSION_USER() is a synonym for USER().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(388,'IN',18,'Syntax:\nexpr IN (value,...)\n\nReturns 1 if expr is equal to any of the values in the IN list, else\nreturns 0. If all values are constants, they are evaluated according to\nthe type of expr and sorted. The search for the item then is done using\na binary search. This means IN is very quick if the IN value list\nconsists entirely of constants. Otherwise, type conversion takes place\naccording to the rules described in\nhttp://dev.mysql.com/doc/refman/5.5/en/type-conversion.html, but\napplied to all the arguments.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 2 IN (0,3,5,7);\n        -> 0\nmysql> SELECT \'wefwf\' IN (\'wee\',\'wefwf\',\'weg\');\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(389,'QUOTE',36,'Syntax:\nQUOTE(str)\n\nQuotes a string to produce a result that can be used as a properly\nescaped data value in an SQL statement. The string is returned enclosed\nby single quotation marks and with each instance of backslash (\"\\\"),\nsingle quote (\"\'\"), ASCII NUL, and Control+Z preceded by a backslash.\nIf the argument is NULL, the return value is the word \"NULL\" without\nenclosing single quotation marks.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT QUOTE(\'Don\\\'t!\');\n        -> \'Don\\\'t!\'\nmysql> SELECT QUOTE(NULL);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(390,'HELP COMMAND',26,'Syntax:\nmysql> help search_string\n\nIf you provide an argument to the help command, mysql uses it as a\nsearch string to access server-side help from the contents of the MySQL\nReference Manual. The proper operation of this command requires that\nthe help tables in the mysql database be initialized with help topic\ninformation (see\nhttp://dev.mysql.com/doc/refman/5.5/en/server-side-help-support.html).\n\nIf there is no match for the search string, the search fails:\n\nmysql> help me\n\nNothing found\nPlease try to run \'help contents\' for a list of all accessible topics\n\nUse help contents to see a list of the help categories:\n\nmysql> help contents\nYou asked for help about help category: \"Contents\"\nFor more information, type \'help <item>\', where <item> is one of the\nfollowing categories:\n   Account Management\n   Administration\n   Data Definition\n   Data Manipulation\n   Data Types\n   Functions\n   Functions and Modifiers for Use with GROUP BY\n   Geographic Features\n   Language Structure\n   Plugins\n   Storage Engines\n   Stored Routines\n   Table Maintenance\n   Transactions\n   Triggers\n\nIf the search string matches multiple items, mysql shows a list of\nmatching topics:\n\nmysql> help logs\nMany help items for your request exist.\nTo make a more specific request, please type \'help <item>\',\nwhere <item> is one of the following topics:\n   SHOW\n   SHOW BINARY LOGS\n   SHOW ENGINE\n   SHOW LOGS\n\nUse a topic as the search string to see the help entry for that topic:\n\nmysql> help show binary logs\nName: \'SHOW BINARY LOGS\'\nDescription:\nSyntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [purge-binary-logs], that shows how\nto determine which logs can be purged.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+\n| Log_name      | File_size |\n+---------------+-----------+\n| binlog.000015 |    724935 |\n| binlog.000016 |    733481 |\n+---------------+-----------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mysql-server-side-help.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/mysql-server-side-help.html'),(391,'QUARTER',31,'Syntax:\nQUARTER(date)\n\nReturns the quarter of the year for date, in the range 1 to 4.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT QUARTER(\'2008-04-01\');\n        -> 2\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(392,'POSITION',36,'Syntax:\nPOSITION(substr IN str)\n\nPOSITION(substr IN str) is a synonym for LOCATE(substr,str).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(393,'SHOW CREATE FUNCTION',26,'Syntax:\nSHOW CREATE FUNCTION func_name\n\nThis statement is similar to SHOW CREATE PROCEDURE but for stored\nfunctions. See [HELP SHOW CREATE PROCEDURE].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-function.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-create-function.html'),(394,'IS_USED_LOCK',15,'Syntax:\nIS_USED_LOCK(str)\n\nChecks whether the lock named str is in use (that is, locked). If so,\nit returns the connection identifier of the client that holds the lock.\nOtherwise, it returns NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(395,'POLYFROMTEXT',3,'PolyFromText(wkt[,srid]), PolygonFromText(wkt[,srid])\n\nConstructs a POLYGON value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(396,'DES_ENCRYPT',12,'Syntax:\nDES_ENCRYPT(str[,{key_num|key_str}])\n\nEncrypts the string with the given key using the Triple-DES algorithm.\n\nThis function works only if MySQL has been configured with SSL support.\nSee http://dev.mysql.com/doc/refman/5.5/en/secure-connections.html.\n\nThe encryption key to use is chosen based on the second argument to\nDES_ENCRYPT(), if one was given. With no argument, the first key from\nthe DES key file is used. With a key_num argument, the given key number\n(0 to 9) from the DES key file is used. With a key_str argument, the\ngiven key string is used to encrypt str.\n\nThe key file can be specified with the --des-key-file server option.\n\nThe return string is a binary string where the first character is\nCHAR(128 | key_num). If an error occurs, DES_ENCRYPT() returns NULL.\n\nThe 128 is added to make it easier to recognize an encrypted key. If\nyou use a string key, key_num is 127.\n\nThe string length for the result is given by this formula:\n\nnew_len = orig_len + (8 - (orig_len % 8)) + 1\n\nEach line in the DES key file has the following format:\n\nkey_num des_key_str\n\nEach key_num value must be a number in the range from 0 to 9. Lines in\nthe file may be in any order. des_key_str is the string that is used to\nencrypt the message. There should be at least one space between the\nnumber and the key. The first key is the default key that is used if\nyou do not specify any key argument to DES_ENCRYPT().\n\nYou can tell MySQL to read new key values from the key file with the\nFLUSH DES_KEY_FILE statement. This requires the RELOAD privilege.\n\nOne benefit of having a set of default keys is that it gives\napplications a way to check for the existence of encrypted column\nvalues, without giving the end user the right to decrypt those values.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT customer_address FROM customer_table \n     > WHERE crypted_credit_card = DES_ENCRYPT(\'credit_card_number\');\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(397,'CEIL',4,'Syntax:\nCEIL(X)\n\nCEIL() is a synonym for CEILING().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(398,'LENGTH',36,'Syntax:\nLENGTH(str)\n\nReturns the length of the string str, measured in bytes. A multi-byte\ncharacter counts as multiple bytes. This means that for a string\ncontaining five two-byte characters, LENGTH() returns 10, whereas\nCHAR_LENGTH() returns 5.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT LENGTH(\'text\');\n        -> 4\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(399,'STR_TO_DATE',31,'Syntax:\nSTR_TO_DATE(str,format)\n\nThis is the inverse of the DATE_FORMAT() function. It takes a string\nstr and a format string format. STR_TO_DATE() returns a DATETIME value\nif the format string contains both date and time parts, or a DATE or\nTIME value if the string contains only date or time parts. If the date,\ntime, or datetime value extracted from str is illegal, STR_TO_DATE()\nreturns NULL and produces a warning.\n\nThe server scans str attempting to match format to it. The format\nstring can contain literal characters and format specifiers beginning\nwith %. Literal characters in format must match literally in str.\nFormat specifiers in format must match a date or time part in str. For\nthe specifiers that can be used in format, see the DATE_FORMAT()\nfunction description.\n\nmysql> SELECT STR_TO_DATE(\'01,5,2013\',\'%d,%m,%Y\');\n        -> \'2013-05-01\'\nmysql> SELECT STR_TO_DATE(\'May 1, 2013\',\'%M %d,%Y\');\n        -> \'2013-05-01\'\n\nScanning starts at the beginning of str and fails if format is found\nnot to match. Extra characters at the end of str are ignored.\n\nmysql> SELECT STR_TO_DATE(\'a09:30:17\',\'a%h:%i:%s\');\n        -> \'09:30:17\'\nmysql> SELECT STR_TO_DATE(\'a09:30:17\',\'%h:%i:%s\');\n        -> NULL\nmysql> SELECT STR_TO_DATE(\'09:30:17a\',\'%h:%i:%s\');\n        -> \'09:30:17\'\n\nUnspecified date or time parts have a value of 0, so incompletely\nspecified values in str produce a result with some or all parts set to\n0:\n\nmysql> SELECT STR_TO_DATE(\'abc\',\'abc\');\n        -> \'0000-00-00\'\nmysql> SELECT STR_TO_DATE(\'9\',\'%m\');\n        -> \'0000-09-00\'\nmysql> SELECT STR_TO_DATE(\'9\',\'%s\');\n        -> \'00:00:09\'\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(400,'Y',11,'Y(p)\n\nReturns the Y-coordinate value for the Point object p as a\ndouble-precision number.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#point-property-functions\n\n','mysql> SELECT Y(POINT(56.7, 53.34));\n+-----------------------+\n| Y(POINT(56.7, 53.34)) |\n+-----------------------+\n|                 53.34 |\n+-----------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#point-property-functions'),(401,'CHECKSUM TABLE',20,'Syntax:\nCHECKSUM TABLE tbl_name [, tbl_name] ... [ QUICK | EXTENDED ]\n\nCHECKSUM TABLE reports a table checksum. This statement requires the\nSELECT privilege for the table.\n\nWith QUICK, the live table checksum is reported if it is available, or\nNULL otherwise. This is very fast. A live checksum is enabled by\nspecifying the CHECKSUM=1 table option when you create the table;\ncurrently, this is supported only for MyISAM tables. See [HELP CREATE\nTABLE].\n\nWith EXTENDED, the entire table is read row by row and the checksum is\ncalculated. This can be very slow for large tables.\n\nIf neither QUICK nor EXTENDED is specified, MySQL returns a live\nchecksum if the table storage engine supports it and scans the table\notherwise.\n\nFor a nonexistent table, CHECKSUM TABLE returns NULL and generates a\nwarning.\n\nIn MySQL 5.5, CHECKSUM TABLE returns 0 for partitioned tables unless\nyou include the EXTENDED option. This issue is resolved in MySQL 5.6.\n(Bug#11933226, Bug#60681)\n\nThe checksum value depends on the table row format. If the row format\nchanges, the checksum also changes. For example, the storage format for\nVARCHAR changed between MySQL 4.1 and 5.0, so if a 4.1 table is\nupgraded to MySQL 5.0, the checksum value may change.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/checksum-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/checksum-table.html'),(402,'NUMINTERIORRINGS',2,'NumInteriorRings(poly)\n\nReturns the number of interior rings in the Polygon value poly.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT NumInteriorRings(GeomFromText(@poly));\n+---------------------------------------+\n| NumInteriorRings(GeomFromText(@poly)) |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions'),(403,'INTERIORRINGN',2,'InteriorRingN(poly,N)\n\nReturns the N-th interior ring for the Polygon value poly as a\nLineString. Rings are numbered beginning with 1.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT AsText(InteriorRingN(GeomFromText(@poly),1));\n+----------------------------------------------+\n| AsText(InteriorRingN(GeomFromText(@poly),1)) |\n+----------------------------------------------+\n| LINESTRING(1 1,1 2,2 2,2 1,1 1)              |\n+----------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#polygon-property-functions'),(404,'UTC_TIME',31,'Syntax:\nUTC_TIME, UTC_TIME()\n\nReturns the current UTC time as a value in \'HH:MM:SS\' or HHMMSS.uuuuuu\nformat, depending on whether the function is used in a string or\nnumeric context.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_TIME(), UTC_TIME() + 0;\n        -> \'18:07:53\', 180753.000000\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(405,'DROP FUNCTION',38,'The DROP FUNCTION statement is used to drop stored functions and\nuser-defined functions (UDFs):\n\no For information about dropping stored functions, see [HELP DROP\n  PROCEDURE].\n\no For information about dropping user-defined functions, see [HELP DROP\n  FUNCTION UDF].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-function.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-function.html'),(406,'ALTER EVENT',38,'Syntax:\nALTER\n    [DEFINER = { user | CURRENT_USER }]\n    EVENT event_name\n    [ON SCHEDULE schedule]\n    [ON COMPLETION [NOT] PRESERVE]\n    [RENAME TO new_event_name]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'comment\']\n    [DO event_body]\n\nThe ALTER EVENT statement changes one or more of the characteristics of\nan existing event without the need to drop and recreate it. The syntax\nfor each of the DEFINER, ON SCHEDULE, ON COMPLETION, COMMENT, ENABLE /\nDISABLE, and DO clauses is exactly the same as when used with CREATE\nEVENT. (See [HELP CREATE EVENT].)\n\nAny user can alter an event defined on a database for which that user\nhas the EVENT privilege. When a user executes a successful ALTER EVENT\nstatement, that user becomes the definer for the affected event.\n\nALTER EVENT works only with an existing event:\n\nmysql> ALTER EVENT no_such_event \n     >     ON SCHEDULE \n     >       EVERY \'2:3\' DAY_HOUR;\nERROR 1517 (HY000): Unknown event \'no_such_event\'\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-event.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-event.html'),(407,'STDDEV',16,'Syntax:\nSTDDEV(expr)\n\nReturns the population standard deviation of expr. This function is\nprovided for compatibility with Oracle. The standard SQL function\nSTDDEV_POP() can be used instead.\n\nThis function returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(408,'DATE_SUB',31,'Syntax:\nDATE_SUB(date,INTERVAL expr unit)\n\nSee the description for DATE_ADD().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(409,'PERIOD_ADD',31,'Syntax:\nPERIOD_ADD(P,N)\n\nAdds N months to period P (in the format YYMM or YYYYMM). Returns a\nvalue in the format YYYYMM. Note that the period argument P is not a\ndate value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT PERIOD_ADD(200801,2);\n        -> 200803\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(410,'|',19,'Syntax:\n|\n\nBitwise OR:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT 29 | 15;\n        -> 31\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(411,'GEOMFROMTEXT',3,'GeomFromText(wkt[,srid]), GeometryFromText(wkt[,srid])\n\nConstructs a geometry value of any type using its WKT representation\nand SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(412,'UUID_SHORT',15,'Syntax:\nUUID_SHORT()\n\nReturns a \"short\" universal identifier as a 64-bit unsigned integer\n(rather than a string-form 128-bit identifier as returned by the UUID()\nfunction).\n\nThe value of UUID_SHORT() is guaranteed to be unique if the following\nconditions hold:\n\no The server_id of the current host is unique among your set of master\n  and slave servers\n\no server_id is between 0 and 255\n\no You do not set back your system time for your server between mysqld\n  restarts\n\no You do not invoke UUID_SHORT() on average more than 16 million times\n  per second between mysqld restarts\n\nThe UUID_SHORT() return value is constructed this way:\n\n  (server_id & 255) << 56\n+ (server_startup_time_in_seconds << 24)\n+ incremented_variable++;\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> SELECT UUID_SHORT();\n        -> 92395783831158784\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(413,'RIGHT',36,'Syntax:\nRIGHT(str,len)\n\nReturns the rightmost len characters from the string str, or NULL if\nany argument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT RIGHT(\'foobarbar\', 4);\n        -> \'rbar\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(414,'DATEDIFF',31,'Syntax:\nDATEDIFF(expr1,expr2)\n\nDATEDIFF() returns expr1 - expr2 expressed as a value in days from one\ndate to the other. expr1 and expr2 are date or date-and-time\nexpressions. Only the date parts of the values are used in the\ncalculation.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DATEDIFF(\'2007-12-31 23:59:59\',\'2007-12-30\');\n        -> 1\nmysql> SELECT DATEDIFF(\'2010-11-30 23:59:59\',\'2010-12-31\');\n        -> -31\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(415,'DROP TABLESPACE',38,'Syntax:\nDROP TABLESPACE tablespace_name\n    ENGINE [=] engine_name\n\nThis statement drops a tablespace that was previously created using\nCREATE TABLESPACE (see [HELP CREATE TABLESPACE]).\n\n*Important*: The tablespace to be dropped must not contain any data\nfiles; in other words, before you can drop a tablespace, you must first\ndrop each of its data files using ALTER TABLESPACE ... DROP DATAFILE\n(see [HELP ALTER TABLESPACE]).\n\nThe ENGINE clause (required) specifies the storage engine used by the\ntablespace. Currently, the only accepted values for engine_name are NDB\nand NDBCLUSTER.\n\nDROP TABLESPACE is useful only with Disk Data storage for MySQL\nCluster. See\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-cluster-disk-data.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-tablespace.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-tablespace.html'),(416,'DROP PROCEDURE',38,'Syntax:\nDROP {PROCEDURE | FUNCTION} [IF EXISTS] sp_name\n\nThis statement is used to drop a stored procedure or function. That is,\nthe specified routine is removed from the server. You must have the\nALTER ROUTINE privilege for the routine. (If the\nautomatic_sp_privileges system variable is enabled, that privilege and\nEXECUTE are granted automatically to the routine creator when the\nroutine is created and dropped from the creator when the routine is\ndropped. See\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-routines-privileges.html.\n)\n\nThe IF EXISTS clause is a MySQL extension. It prevents an error from\noccurring if the procedure or function does not exist. A warning is\nproduced that can be viewed with SHOW WARNINGS.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/drop-procedure.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/drop-procedure.html'),(417,'CHECK TABLE',20,'Syntax:\nCHECK TABLE tbl_name [, tbl_name] ... [option] ...\n\noption = {FOR UPGRADE | QUICK | FAST | MEDIUM | EXTENDED | CHANGED}\n\nCHECK TABLE checks a table or tables for errors. CHECK TABLE works for\nMyISAM, InnoDB, ARCHIVE, and CSV tables. For MyISAM tables, the key\nstatistics are updated as well.\n\nTo check a table, you must have some privilege for it.\n\nCHECK TABLE can also check views for problems, such as tables that are\nreferenced in the view definition that no longer exist.\n\nCHECK TABLE is supported for partitioned tables, and you can use ALTER\nTABLE ... CHECK PARTITION to check one or more partitions; for more\ninformation, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/check-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/check-table.html'),(418,'BIN',36,'Syntax:\nBIN(N)\n\nReturns a string representation of the binary value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,2). Returns\nNULL if N is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT BIN(12);\n        -> \'1100\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(419,'INSTALL PLUGIN',5,'Syntax:\nINSTALL PLUGIN plugin_name SONAME \'shared_library_name\'\n\nThis statement installs a server plugin. It requires the INSERT\nprivilege for the mysql.plugin table.\n\nplugin_name is the name of the plugin as defined in the plugin\ndescriptor structure contained in the library file (see\nhttp://dev.mysql.com/doc/refman/5.5/en/plugin-data-structures.html).\nPlugin names are not case sensitive. For maximal compatibility, plugin\nnames should be limited to ASCII letters, digits, and underscore\nbecause they are used in C source files, shell command lines, M4 and\nBourne shell scripts, and SQL environments.\n\nshared_library_name is the name of the shared library that contains the\nplugin code. The name includes the file name extension (for example,\nlibmyplugin.so, libmyplugin.dll, or libmyplugin.dylib).\n\nThe shared library must be located in the plugin directory (the\ndirectory named by the plugin_dir system variable). The library must be\nin the plugin directory itself, not in a subdirectory. By default,\nplugin_dir is the plugin directory under the directory named by the\npkglibdir configuration variable, but it can be changed by setting the\nvalue of plugin_dir at server startup. For example, set its value in a\nmy.cnf file:\n\n[mysqld]\nplugin_dir=/path/to/plugin/directory\n\nIf the value of plugin_dir is a relative path name, it is taken to be\nrelative to the MySQL base directory (the value of the basedir system\nvariable).\n\nINSTALL PLUGIN loads and initializes the plugin code to make the plugin\navailable for use. A plugin is initialized by executing its\ninitialization function, which handles any setup that the plugin must\nperform before it can be used. When the server shuts down, it executes\nthe deinitialization function for each plugin that is loaded so that\nthe plugin has a change to perform any final cleanup.\n\nINSTALL PLUGIN also registers the plugin by adding a line that\nindicates the plugin name and library file name to the mysql.plugin\ntable. At server startup, the server loads and initializes any plugin\nthat is listed in the mysql.plugin table. This means that a plugin is\ninstalled with INSTALL PLUGIN only once, not every time the server\nstarts. Plugin loading at startup does not occur if the server is\nstarted with the --skip-grant-tables option.\n\nA plugin library can contain multiple plugins. For each of them to be\ninstalled, use a separate INSTALL PLUGIN statement. Each statement\nnames a different plugin, but all of them specify the same library\nname.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/install-plugin.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/install-plugin.html'),(420,'DECLARE CURSOR',23,'Syntax:\nDECLARE cursor_name CURSOR FOR select_statement\n\nThis statement declares a cursor and associates it with a SELECT\nstatement that retrieves the rows to be traversed by the cursor. To\nfetch the rows later, use a FETCH statement. The number of columns\nretrieved by the SELECT statement must match the number of output\nvariables specified in the FETCH statement.\n\nThe SELECT statement cannot have an INTO clause.\n\nCursor declarations must appear before handler declarations and after\nvariable and condition declarations.\n\nA stored program may contain multiple cursor declarations, but each\ncursor declared in a given block must have a unique name. For an\nexample, see http://dev.mysql.com/doc/refman/5.5/en/cursors.html.\n\nFor information available through SHOW statements, it is possible in\nmany cases to obtain equivalent information by using a cursor with an\nINFORMATION_SCHEMA table.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/declare-cursor.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/declare-cursor.html'),(421,'LOAD DATA',27,'Syntax:\nLOAD DATA [LOW_PRIORITY | CONCURRENT] [LOCAL] INFILE \'file_name\'\n    [REPLACE | IGNORE]\n    INTO TABLE tbl_name\n    [CHARACTER SET charset_name]\n    [{FIELDS | COLUMNS}\n        [TERMINATED BY \'string\']\n        [[OPTIONALLY] ENCLOSED BY \'char\']\n        [ESCAPED BY \'char\']\n    ]\n    [LINES\n        [STARTING BY \'string\']\n        [TERMINATED BY \'string\']\n    ]\n    [IGNORE number LINES]\n    [(col_name_or_user_var,...)]\n    [SET col_name = expr,...]\n\nThe LOAD DATA INFILE statement reads rows from a text file into a table\nat a very high speed. The file name must be given as a literal string.\n\nLOAD DATA INFILE is the complement of SELECT ... INTO OUTFILE. (See\nhttp://dev.mysql.com/doc/refman/5.5/en/select.html.) To write data from\na table to a file, use SELECT ... INTO OUTFILE. To read the file back\ninto a table, use LOAD DATA INFILE. The syntax of the FIELDS and LINES\nclauses is the same for both statements. Both clauses are optional, but\nFIELDS must precede LINES if both are specified.\n\nFor more information about the efficiency of INSERT versus LOAD DATA\nINFILE and speeding up LOAD DATA INFILE, see\nhttp://dev.mysql.com/doc/refman/5.5/en/insert-speed.html.\n\nThe character set indicated by the character_set_database system\nvariable is used to interpret the information in the file. SET NAMES\nand the setting of character_set_client do not affect interpretation of\ninput. If the contents of the input file use a character set that\ndiffers from the default, it is usually preferable to specify the\ncharacter set of the file by using the CHARACTER SET clause. A\ncharacter set of binary specifies \"no conversion.\"\n\nLOAD DATA INFILE interprets all fields in the file as having the same\ncharacter set, regardless of the data types of the columns into which\nfield values are loaded. For proper interpretation of file contents,\nyou must ensure that it was written with the correct character set. For\nexample, if you write a data file with mysqldump -T or by issuing a\nSELECT ... INTO OUTFILE statement in mysql, be sure to use a\n--default-character-set option with mysqldump or mysql so that output\nis written in the character set to be used when the file is loaded with\nLOAD DATA INFILE.\n\n*Note*: It is not possible to load data files that use the ucs2, utf16,\nor utf32 character set.\n\nThe character_set_filesystem system variable controls the\ninterpretation of the file name.\n\nYou can also load data files by using the mysqlimport utility; it\noperates by sending a LOAD DATA INFILE statement to the server. The\n--local option causes mysqlimport to read data files from the client\nhost. You can specify the --compress option to get better performance\nover slow networks if the client and server support the compressed\nprotocol. See http://dev.mysql.com/doc/refman/5.5/en/mysqlimport.html.\n\nIf you use LOW_PRIORITY, execution of the LOAD DATA statement is\ndelayed until no other clients are reading from the table. This affects\nonly storage engines that use only table-level locking (such as MyISAM,\nMEMORY, and MERGE).\n\nIf you specify CONCURRENT with a MyISAM table that satisfies the\ncondition for concurrent inserts (that is, it contains no free blocks\nin the middle), other threads can retrieve data from the table while\nLOAD DATA is executing. Using this option affects the performance of\nLOAD DATA a bit, even if no other thread is using the table at the same\ntime.\n\nPrior to MySQL 5.5.1, CONCURRENT was not replicated when using\nstatement-based replication (see Bug #34628). However, it is replicated\nwhen using row-based replication, regardless of the version. See\nhttp://dev.mysql.com/doc/refman/5.5/en/replication-features-load-data.h\ntml, for more information.\n\nThe LOCAL keyword, if specified, is interpreted with respect to the\nclient end of the connection:\n\no If LOCAL is specified, the file is read by the client program on the\n  client host and sent to the server. The file can be given as a full\n  path name to specify its exact location. If given as a relative path\n  name, the name is interpreted relative to the directory in which the\n  client program was started.\n\n  When using LOCAL with LOAD DATA, a copy of the file is created in the\n  server\'s temporary directory. This is not the directory determined by\n  the value of tmpdir or slave_load_tmpdir, but rather the operating\n  system\'s temporary directory, and is not configurable in the MySQL\n  Server. (Typically the system temporary directory is /tmp on Linux\n  systems and C:\\WINDOWS\\TEMP on Windows.) Lack of sufficient space for\n  the copy in this directory can cause the LOAD DATA LOCAL statement to\n  fail.\n\no If LOCAL is not specified, the file must be located on the server\n  host and is read directly by the server. The server uses the\n  following rules to locate the file:\n\n  o If the file name is an absolute path name, the server uses it as\n    given.\n\n  o If the file name is a relative path name with one or more leading\n    components, the server searches for the file relative to the\n    server\'s data directory.\n\n  o If a file name with no leading components is given, the server\n    looks for the file in the database directory of the default\n    database.\n\nNote that, in the non-LOCAL case, these rules mean that a file named as\n./myfile.txt is read from the server\'s data directory, whereas the file\nnamed as myfile.txt is read from the database directory of the default\ndatabase. For example, if db1 is the default database, the following\nLOAD DATA statement reads the file data.txt from the database directory\nfor db1, even though the statement explicitly loads the file into a\ntable in the db2 database:\n\nLOAD DATA INFILE \'data.txt\' INTO TABLE db2.my_table;\n\nWindows path names are specified using forward slashes rather than\nbackslashes. If you do use backslashes, you must double them.\n\nFor security reasons, when reading text files located on the server,\nthe files must either reside in the database directory or be readable\nby all. Also, to use LOAD DATA INFILE on server files, you must have\nthe FILE privilege. See\nhttp://dev.mysql.com/doc/refman/5.5/en/privileges-provided.html. For\nnon-LOCAL load operations, if the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/load-data.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/load-data.html'),(422,'MULTILINESTRING',24,'MultiLineString(ls1,ls2,...)\n\nConstructs a MultiLineString value using LineString or WKB LineString\narguments.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-mysql-specific-functions'),(423,'LOCALTIME',31,'Syntax:\nLOCALTIME, LOCALTIME()\n\nLOCALTIME and LOCALTIME() are synonyms for NOW().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(424,'SHOW RELAYLOG EVENTS',26,'Syntax:\nSHOW RELAYLOG EVENTS\n   [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\n\nShows the events in the relay log of a replication slave. If you do not\nspecify \'log_name\', the first relay log is displayed. This statement\nhas no effect on the master.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-relaylog-events.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-relaylog-events.html'),(425,'MPOINTFROMTEXT',3,'MPointFromText(wkt[,srid]), MultiPointFromText(wkt[,srid])\n\nConstructs a MULTIPOINT value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkt-functions'),(426,'BLOB',22,'BLOB[(M)]\n\nA BLOB column with a maximum length of 65,535 (216 - 1) bytes. Each\nBLOB value is stored using a two-byte length prefix that indicates the\nnumber of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest BLOB type large enough to hold\nvalues M bytes long.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(427,'SHA1',12,'Syntax:\nSHA1(str), SHA(str)\n\nCalculates an SHA-1 160-bit checksum for the string, as described in\nRFC 3174 (Secure Hash Algorithm). The value is returned as a string of\n40 hex digits, or NULL if the argument was NULL. One of the possible\nuses for this function is as a hash key. See the notes at the beginning\nof this section about storing hash values efficiently. You can also use\nSHA1() as a cryptographic function for storing passwords. SHA() is\nsynonymous with SHA1().\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring; see the notes at the beginning of this section about using the\nvalue as a nonbinary string.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT SHA1(\'abc\');\n        -> \'a9993e364706816aba3e25717850c26c9cd0d89d\'\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(428,'SUBSTR',36,'Syntax:\nSUBSTR(str,pos), SUBSTR(str FROM pos), SUBSTR(str,pos,len), SUBSTR(str\nFROM pos FOR len)\n\nSUBSTR() is a synonym for SUBSTRING().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(429,'PASSWORD',12,'Syntax:\nPASSWORD(str)\n\nCalculates and returns a password string from the plaintext password\nstr and returns a string, or NULL if the argument was NULL. This is the\nfunction that is used for encrypting MySQL passwords for storage in the\nPassword column of the user grant table.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','mysql> SELECT PASSWORD(\'badpwd\');\n        -> \'*AAB3E285149C0135D51A520E1940DD3263DC008C\'\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(430,'CHAR',22,'[NATIONAL] CHAR[(M)] [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA fixed-length string that is always right-padded with spaces to the\nspecified length when stored. M represents the column length in\ncharacters. The range of M is 0 to 255. If M is omitted, the length is\n1.\n\n*Note*: Trailing spaces are removed when CHAR values are retrieved\nunless the PAD_CHAR_TO_FULL_LENGTH SQL mode is enabled.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(431,'UTC_DATE',31,'Syntax:\nUTC_DATE, UTC_DATE()\n\nReturns the current UTC date as a value in \'YYYY-MM-DD\' or YYYYMMDD\nformat, depending on whether the function is used in a string or\nnumeric context.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_DATE(), UTC_DATE() + 0;\n        -> \'2003-08-14\', 20030814\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(432,'DIMENSION',35,'Dimension(g)\n\nReturns the inherent dimension of the geometry value g. The result can\nbe -1, 0, 1, or 2. The meaning of these values is given in\nhttp://dev.mysql.com/doc/refman/5.5/en/gis-class-geometry.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT Dimension(GeomFromText(\'LineString(1 1,2 2)\'));\n+------------------------------------------------+\n| Dimension(GeomFromText(\'LineString(1 1,2 2)\')) |\n+------------------------------------------------+\n|                                              1 |\n+------------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(433,'COUNT DISTINCT',16,'Syntax:\nCOUNT(DISTINCT expr,[expr...])\n\nReturns a count of the number of rows with different non-NULL expr\nvalues.\n\nCOUNT(DISTINCT) returns 0 if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html\n\n','mysql> SELECT COUNT(DISTINCT results) FROM student;\n','http://dev.mysql.com/doc/refman/5.5/en/group-by-functions.html'),(434,'BIT',22,'BIT[(M)]\n\nA bit-field type. M indicates the number of bits per value, from 1 to\n64. The default is 1 if M is omitted.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(435,'EQUALS',30,'Equals(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially equal to g2.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.5/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(436,'SHOW CREATE VIEW',26,'Syntax:\nSHOW CREATE VIEW view_name\n\nThis statement shows a CREATE VIEW statement that creates the given\nview.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-create-view.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-create-view.html'),(437,'INTERVAL',18,'Syntax:\nINTERVAL(N,N1,N2,N3,...)\n\nReturns 0 if N < N1, 1 if N < N2 and so on or -1 if N is NULL. All\narguments are treated as integers. It is required that N1 < N2 < N3 <\n... < Nn for this function to work correctly. This is because a binary\nsearch is used (very fast).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT INTERVAL(23, 1, 15, 17, 30, 44, 200);\n        -> 3\nmysql> SELECT INTERVAL(10, 1, 10, 100, 1000);\n        -> 2\nmysql> SELECT INTERVAL(22, 23, 30, 44, 200);\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(438,'FROM_DAYS',31,'Syntax:\nFROM_DAYS(N)\n\nGiven a day number N, returns a DATE value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT FROM_DAYS(730669);\n        -> \'2007-07-03\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(439,'ALTER PROCEDURE',38,'Syntax:\nALTER PROCEDURE proc_name [characteristic ...]\n\ncharacteristic:\n    COMMENT \'string\'\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nThis statement can be used to change the characteristics of a stored\nprocedure. More than one change may be specified in an ALTER PROCEDURE\nstatement. However, you cannot change the parameters or body of a\nstored procedure using this statement; to make such changes, you must\ndrop and re-create the procedure using DROP PROCEDURE and CREATE\nPROCEDURE.\n\nYou must have the ALTER ROUTINE privilege for the procedure. By\ndefault, that privilege is granted automatically to the procedure\ncreator. This behavior can be changed by disabling the\nautomatic_sp_privileges system variable. See\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-routines-privileges.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-procedure.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-procedure.html'),(440,'BIT_COUNT',19,'Syntax:\nBIT_COUNT(N)\n\nReturns the number of bits that are set in the argument N.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html\n\n','mysql> SELECT BIT_COUNT(29), BIT_COUNT(b\'101010\');\n        -> 4, 3\n','http://dev.mysql.com/doc/refman/5.5/en/bit-functions.html'),(441,'OCTET_LENGTH',36,'Syntax:\nOCTET_LENGTH(str)\n\nOCTET_LENGTH() is a synonym for LENGTH().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(442,'UTC_TIMESTAMP',31,'Syntax:\nUTC_TIMESTAMP, UTC_TIMESTAMP()\n\nReturns the current UTC date and time as a value in \'YYYY-MM-DD\nHH:MM:SS\' or YYYYMMDDHHMMSS.uuuuuu format, depending on whether the\nfunction is used in a string or numeric context.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_TIMESTAMP(), UTC_TIMESTAMP() + 0;\n        -> \'2003-08-14 18:08:04\', 20030814180804.000000\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(443,'AES_ENCRYPT',12,'Syntax:\nAES_ENCRYPT(str,key_str)\n\nAES_ENCRYPT() and AES_DECRYPT() enable encryption and decryption of\ndata using the official AES (Advanced Encryption Standard) algorithm,\npreviously known as \"Rijndael.\" Encoding with a 128-bit key length is\nused, but you can extend it up to 256 bits by modifying the source. We\nchose 128 bits because it is much faster and it is secure enough for\nmost purposes.\n\nAES_ENCRYPT() encrypts a string and returns a binary string.\nAES_DECRYPT() decrypts the encrypted string and returns the original\nstring. The input arguments may be any length. If either argument is\nNULL, the result of this function is also NULL.\n\nBecause AES is a block-level algorithm, padding is used to encode\nuneven length strings and so the result string length may be calculated\nusing this formula:\n\n16 * (trunc(string_length / 16) + 1)\n\nIf AES_DECRYPT() detects invalid data or incorrect padding, it returns\nNULL. However, it is possible for AES_DECRYPT() to return a non-NULL\nvalue (possibly garbage) if the input data or the key is invalid.\n\nYou can use the AES functions to store data in an encrypted form by\nmodifying your queries:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','INSERT INTO t VALUES (1,AES_ENCRYPT(\'text\',\'password\'));\n','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(444,'+',4,'Syntax:\n+\n\nAddition:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html\n\n','mysql> SELECT 3+5;\n        -> 8\n','http://dev.mysql.com/doc/refman/5.5/en/arithmetic-functions.html'),(445,'INET_NTOA',15,'Syntax:\nINET_NTOA(expr)\n\nGiven a numeric IPv4 network address in network byte order, returns the\ndotted-quad representation of the address as a string. INET_NTOA()\nreturns NULL if it does not understand its argument.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html\n\n','mysql> SELECT INET_NTOA(167773449);\n        -> \'10.0.5.9\'\n','http://dev.mysql.com/doc/refman/5.5/en/miscellaneous-functions.html'),(446,'ACOS',4,'Syntax:\nACOS(X)\n\nReturns the arc cosine of X, that is, the value whose cosine is X.\nReturns NULL if X is not in the range -1 to 1.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT ACOS(1);\n        -> 0\nmysql> SELECT ACOS(1.0001);\n        -> NULL\nmysql> SELECT ACOS(0);\n        -> 1.5707963267949\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(447,'ISOLATION',8,'Syntax:\nSET [GLOBAL | SESSION] TRANSACTION ISOLATION LEVEL\n  {\n       READ UNCOMMITTED\n     | READ COMMITTED\n     | REPEATABLE READ\n     | SERIALIZABLE\n   }\n\nThis statement sets the transaction isolation level globally, for the\ncurrent session, or for the next transaction:\n\no With the GLOBAL keyword, the statement sets the default transaction\n  level globally for all subsequent sessions. Existing sessions are\n  unaffected.\n\no With the SESSION keyword, the statement sets the default transaction\n  level for all subsequent transactions performed within the current\n  session.\n\no Without any SESSION or GLOBAL keyword, the statement sets the\n  isolation level for the next (not started) transaction performed\n  within the current session.\n\nA change to the global default isolation level requires the SUPER\nprivilege. Any session is free to change its session isolation level\n(even in the middle of a transaction), or the isolation level for its\nnext transaction.\n\nSET TRANSACTION ISOLATION LEVEL without GLOBAL or SESSION is not\npermitted while there is an active transaction:\n\nmysql> START TRANSACTION;\nQuery OK, 0 rows affected (0.02 sec)\n\nmysql> SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;\nERROR 1568 (25001): Transaction isolation level can\'t be changed\nwhile a transaction is in progress\n\nTo set the global default isolation level at server startup, use the\n--transaction-isolation=level option to mysqld on the command line or\nin an option file. Values of level for this option use dashes rather\nthan spaces, so the permissible values are READ-UNCOMMITTED,\nREAD-COMMITTED, REPEATABLE-READ, or SERIALIZABLE. For example, to set\nthe default isolation level to REPEATABLE READ, use these lines in the\n[mysqld] section of an option file:\n\n[mysqld]\ntransaction-isolation = REPEATABLE-READ\n\nTo determine the global and session transaction isolation levels at\nruntime, check the value of the tx_isolation system variable:\n\nSELECT @@GLOBAL.tx_isolation, @@tx_isolation;\n\nInnoDB supports each of the transaction isolation levels described here\nusing different locking strategies. The default level is REPEATABLE\nREAD. For additional information about InnoDB record-level locks and\nhow it uses them to execute various types of statements, see\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-record-level-locks.html,\nand http://dev.mysql.com/doc/refman/5.5/en/innodb-locks-set.html.\n\nThe following list describes how MySQL supports the different\ntransaction levels:\n\no READ UNCOMMITTED\n\n  SELECT statements are performed in a nonlocking fashion, but a\n  possible earlier version of a row might be used. Thus, using this\n  isolation level, such reads are not consistent. This is also called a\n  \"dirty read.\" Otherwise, this isolation level works like READ\n  COMMITTED.\n\no READ COMMITTED\n\n  A somewhat Oracle-like isolation level with respect to consistent\n  (nonlocking) reads: Each consistent read, even within the same\n  transaction, sets and reads its own fresh snapshot. See\n  http://dev.mysql.com/doc/refman/5.5/en/innodb-consistent-read.html.\n\n  For locking reads (SELECT with FOR UPDATE or LOCK IN SHARE MODE),\n  InnoDB locks only index records, not the gaps before them, and thus\n  permits the free insertion of new records next to locked records. For\n  UPDATE and DELETE statements, locking depends on whether the\n  statement uses a unique index with a unique search condition (such as\n  WHERE id = 100), or a range-type search condition (such as WHERE id >\n  100). For a unique index with a unique search condition, InnoDB locks\n  only the index record found, not the gap before it. For range-type\n  searches, InnoDB locks the index range scanned, using gap locks or\n  next-key (gap plus index-record) locks to block insertions by other\n  sessions into the gaps covered by the range. This is necessary\n  because \"phantom rows\" must be blocked for MySQL replication and\n  recovery to work.\n\n  *Note*: In MySQL 5.5, if the READ COMMITTED isolation level is used\n  or the innodb_locks_unsafe_for_binlog system variable is enabled,\n  there is no InnoDB gap locking except for foreign-key constraint\n  checking and duplicate-key checking. Also, record locks for\n  nonmatching rows are released after MySQL has evaluated the WHERE\n  condition. If you use READ COMMITTED or enable\n  innodb_locks_unsafe_for_binlog, you must use row-based binary\n  logging.\n\no REPEATABLE READ\n\n  This is the default isolation level for InnoDB. For consistent reads,\n  there is an important difference from the READ COMMITTED isolation\n  level: All consistent reads within the same transaction read the\n  snapshot established by the first read. This convention means that if\n  you issue several plain (nonlocking) SELECT statements within the\n  same transaction, these SELECT statements are consistent also with\n  respect to each other. See\n  http://dev.mysql.com/doc/refman/5.5/en/innodb-consistent-read.html.\n\n  For locking reads (SELECT with FOR UPDATE or LOCK IN SHARE MODE),\n  UPDATE, and DELETE statements, locking depends on whether the\n  statement uses a unique index with a unique search condition, or a\n  range-type search condition. For a unique index with a unique search\n  condition, InnoDB locks only the index record found, not the gap\n  before it. For other search conditions, InnoDB locks the index range\n  scanned, using gap locks or next-key (gap plus index-record) locks to\n  block insertions by other sessions into the gaps covered by the\n  range.\n\no SERIALIZABLE\n\n  This level is like REPEATABLE READ, but InnoDB implicitly converts\n  all plain SELECT statements to SELECT ... LOCK IN SHARE MODE if\n  autocommit is disabled. If autocommit is enabled, the SELECT is its\n  own transaction. It therefore is known to be read only and can be\n  serialized if performed as a consistent (nonlocking) read and need\n  not block for other transactions. (This means that to force a plain\n  SELECT to block if other transactions have modified the selected\n  rows, you should disable autocommit.)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/set-transaction.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/set-transaction.html'),(448,'CEILING',4,'Syntax:\nCEILING(X)\n\nReturns the smallest integer value not less than X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT CEILING(1.23);\n        -> 2\nmysql> SELECT CEILING(-1.23);\n        -> -1\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(449,'SIN',4,'Syntax:\nSIN(X)\n\nReturns the sine of X, where X is given in radians.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT SIN(PI());\n        -> 1.2246063538224e-16\nmysql> SELECT ROUND(SIN(PI()));\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(450,'DAYOFWEEK',31,'Syntax:\nDAYOFWEEK(date)\n\nReturns the weekday index for date (1 = Sunday, 2 = Monday, ..., 7 =\nSaturday). These index values correspond to the ODBC standard.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFWEEK(\'2007-02-03\');\n        -> 7\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(451,'SHOW PROCESSLIST',26,'Syntax:\nSHOW [FULL] PROCESSLIST\n\nSHOW PROCESSLIST shows you which threads are running. You can also get\nthis information from the INFORMATION_SCHEMA PROCESSLIST table or the\nmysqladmin processlist command. If you have the PROCESS privilege, you\ncan see all threads. Otherwise, you can see only your own threads (that\nis, threads associated with the MySQL account that you are using). If\nyou do not use the FULL keyword, only the first 100 characters of each\nstatement are shown in the Info field.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-processlist.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-processlist.html'),(452,'LINEFROMWKB',32,'LineFromWKB(wkb[,srid]), LineStringFromWKB(wkb[,srid])\n\nConstructs a LINESTRING value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(453,'GEOMETRYTYPE',35,'GeometryType(g)\n\nReturns as a string the name of the geometry type of which the geometry\ninstance g is a member. The name corresponds to one of the instantiable\nGeometry subclasses.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT GeometryType(GeomFromText(\'POINT(1 1)\'));\n+------------------------------------------+\n| GeometryType(GeomFromText(\'POINT(1 1)\')) |\n+------------------------------------------+\n| POINT                                    |\n+------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#general-geometry-property-functions'),(454,'CREATE VIEW',38,'Syntax:\nCREATE\n    [OR REPLACE]\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = { user | CURRENT_USER }]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThe CREATE VIEW statement creates a new view, or replaces an existing\none if the OR REPLACE clause is given. If the view does not exist,\nCREATE OR REPLACE VIEW is the same as CREATE VIEW. If the view does\nexist, CREATE OR REPLACE VIEW is the same as ALTER VIEW.\n\nThe select_statement is a SELECT statement that provides the definition\nof the view. (When you select from the view, you select in effect using\nthe SELECT statement.) select_statement can select from base tables or\nother views.\n\nThe view definition is \"frozen\" at creation time, so changes to the\nunderlying tables afterward do not affect the view definition. For\nexample, if a view is defined as SELECT * on a table, new columns added\nto the table later do not become part of the view.\n\nThe ALGORITHM clause affects how MySQL processes the view. The DEFINER\nand SQL SECURITY clauses specify the security context to be used when\nchecking access privileges at view invocation time. The WITH CHECK\nOPTION clause can be given to constrain inserts or updates to rows in\ntables referenced by the view. These clauses are described later in\nthis section.\n\nThe CREATE VIEW statement requires the CREATE VIEW privilege for the\nview, and some privilege for each column selected by the SELECT\nstatement. For columns used elsewhere in the SELECT statement you must\nhave the SELECT privilege. If the OR REPLACE clause is present, you\nmust also have the DROP privilege for the view. CREATE VIEW might also\nrequire the SUPER privilege, depending on the DEFINER value, as\ndescribed later in this section.\n\nWhen a view is referenced, privilege checking occurs as described later\nin this section.\n\nA view belongs to a database. By default, a new view is created in the\ndefault database. To create the view explicitly in a given database,\nspecify the name as db_name.view_name when you create it:\n\nmysql> CREATE VIEW test.v AS SELECT * FROM t;\n\nWithin a database, base tables and views share the same namespace, so a\nbase table and a view cannot have the same name.\n\nColumns retrieved by the SELECT statement can be simple references to\ntable columns. They can also be expressions that use functions,\nconstant values, operators, and so forth.\n\nViews must have unique column names with no duplicates, just like base\ntables. By default, the names of the columns retrieved by the SELECT\nstatement are used for the view column names. To define explicit names\nfor the view columns, the optional column_list clause can be given as a\nlist of comma-separated identifiers. The number of names in column_list\nmust be the same as the number of columns retrieved by the SELECT\nstatement.\n\nUnqualified table or view names in the SELECT statement are interpreted\nwith respect to the default database. A view can refer to tables or\nviews in other databases by qualifying the table or view name with the\nproper database name.\n\nA view can be created from many kinds of SELECT statements. It can\nrefer to base tables or other views. It can use joins, UNION, and\nsubqueries. The SELECT need not even refer to any tables. The following\nexample defines a view that selects two columns from another table, as\nwell as an expression calculated from those columns:\n\nmysql> CREATE TABLE t (qty INT, price INT);\nmysql> INSERT INTO t VALUES(3, 50);\nmysql> CREATE VIEW v AS SELECT qty, price, qty*price AS value FROM t;\nmysql> SELECT * FROM v;\n+------+-------+-------+\n| qty  | price | value |\n+------+-------+-------+\n|    3 |    50 |   150 |\n+------+-------+-------+\n\nA view definition is subject to the following restrictions:\n\no The SELECT statement cannot contain a subquery in the FROM clause.\n\no The SELECT statement cannot refer to system or user variables.\n\no Within a stored program, the definition cannot refer to program\n  parameters or local variables.\n\no The SELECT statement cannot refer to prepared statement parameters.\n\no Any table or view referred to in the definition must exist. However,\n  after a view has been created, it is possible to drop a table or view\n  that the definition refers to. In this case, use of the view results\n  in an error. To check a view definition for problems of this kind,\n  use the CHECK TABLE statement.\n\no The definition cannot refer to a TEMPORARY table, and you cannot\n  create a TEMPORARY view.\n\no Any tables named in the view definition must exist at definition\n  time.\n\no You cannot associate a trigger with a view.\n\no Aliases for column names in the SELECT statement are checked against\n  the maximum column length of 64 characters (not the maximum alias\n  length of 256 characters).\n\nORDER BY is permitted in a view definition, but it is ignored if you\nselect from a view using a statement that has its own ORDER BY.\n\nFor other options or clauses in the definition, they are added to the\noptions or clauses of the statement that references the view, but the\neffect is undefined. For example, if a view definition includes a LIMIT\nclause, and you select from the view using a statement that has its own\nLIMIT clause, it is undefined which limit applies. This same principle\napplies to options such as ALL, DISTINCT, or SQL_SMALL_RESULT that\nfollow the SELECT keyword, and to clauses such as INTO, FOR UPDATE,\nLOCK IN SHARE MODE, and PROCEDURE.\n\nIf you create a view and then change the query processing environment\nby changing system variables, that may affect the results that you get\nfrom the view:\n\nmysql> CREATE VIEW v (mycol) AS SELECT \'abc\';\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SET sql_mode = \'\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| mycol |\n+-------+\n1 row in set (0.01 sec)\n\nmysql> SET sql_mode = \'ANSI_QUOTES\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| abc   |\n+-------+\n1 row in set (0.00 sec)\n\nThe DEFINER and SQL SECURITY clauses determine which MySQL account to\nuse when checking access privileges for the view when a statement is\nexecuted that references the view. The legal SQL SECURITY\ncharacteristic values are DEFINER and INVOKER. These indicate that the\nrequired privileges must be held by the user who defined or invoked the\nview, respectively. The default SQL SECURITY value is DEFINER.\n\nIf a user value is given for the DEFINER clause, it should be a MySQL\naccount specified as \'user_name\'@\'host_name\' (the same format used in\nthe GRANT statement), CURRENT_USER, or CURRENT_USER(). The default\nDEFINER value is the user who executes the CREATE VIEW statement. This\nis the same as specifying DEFINER = CURRENT_USER explicitly.\n\nIf you specify the DEFINER clause, these rules determine the legal\nDEFINER user values:\n\no If you do not have the SUPER privilege, the only legal user value is\n  your own account, either specified literally or by using\n  CURRENT_USER. You cannot set the definer to some other account.\n\no If you have the SUPER privilege, you can specify any syntactically\n  legal account name. If the account does not actually exist, a warning\n  is generated.\n\no Although it is possible to create a view with a nonexistent DEFINER\n  account, an error occurs when the view is referenced if the SQL\n  SECURITY value is DEFINER but the definer account does not exist.\n\nFor more information about view security, see\nhttp://dev.mysql.com/doc/refman/5.5/en/stored-programs-security.html.\n\nWithin a view definition, CURRENT_USER returns the view\'s DEFINER value\nby default. For views defined with the SQL SECURITY INVOKER\ncharacteristic, CURRENT_USER returns the account for the view\'s\ninvoker. For information about user auditing within views, see\nhttp://dev.mysql.com/doc/refman/5.5/en/account-activity-auditing.html.\n\nWithin a stored routine that is defined with the SQL SECURITY DEFINER\ncharacteristic, CURRENT_USER returns the routine\'s DEFINER value. This\nalso affects a view defined within such a routine, if the view\ndefinition contains a DEFINER value of CURRENT_USER.\n\nView privileges are checked like this:\n\no At view definition time, the view creator must have the privileges\n  needed to use the top-level objects accessed by the view. For\n  example, if the view definition refers to table columns, the creator\n  must have some privilege for each column in the select list of the\n  definition, and the SELECT privilege for each column used elsewhere\n  in the definition. If the definition refers to a stored function,\n  only the privileges needed to invoke the function can be checked. The\n  privileges required at function invocation time can be checked only\n  as it executes: For different invocations, different execution paths\n  within the function might be taken.\n\no The user who references a view must have appropriate privileges to\n  access it (SELECT to select from it, INSERT to insert into it, and so\n  forth.)\n\no When a view has been referenced, privileges for objects accessed by\n  the view are checked against the privileges held by the view DEFINER\n  account or invoker, depending on whether the SQL SECURITY\n  characteristic is DEFINER or INVOKER, respectively.\n\no If reference to a view causes execution of a stored function,\n  privilege checking for statements executed within the function depend\n  on whether the function SQL SECURITY characteristic is DEFINER or\n  INVOKER. If the security characteristic is DEFINER, the function runs\n  with the privileges of the DEFINER account. If the characteristic is\n  INVOKER, the function runs with the privileges determined by the\n  view\'s SQL SECURITY characteristic.\n\nExample: A view might depend on a stored function, and that function\nmight invoke other stored routines. For example, the following view\ninvokes a stored function f():\n\nCREATE VIEW v AS SELECT * FROM t WHERE t.id = f(t.name);\n\nSuppose that f() contains a statement such as this:\n\nIF name IS NULL then\n  CALL p1();\nELSE\n  CALL p2();\nEND IF;\n\nThe privileges required for executing statements within f() need to be\nchecked when f() executes. This might mean that privileges are needed\nfor p1() or p2(), depending on the execution path within f(). Those\nprivileges must be checked at runtime, and the user who must possess\nthe privileges is determined by the SQL SECURITY values of the view v\nand the function f().\n\nThe DEFINER and SQL SECURITY clauses for views are extensions to\nstandard SQL. In standard SQL, views are handled using the rules for\nSQL SECURITY DEFINER. The standard says that the definer of the view,\nwhich is the same as the owner of the view\'s schema, gets applicable\nprivileges on the view (for example, SELECT) and may grant them. MySQL\nhas no concept of a schema \"owner\", so MySQL adds a clause to identify\nthe definer. The DEFINER clause is an extension where the intent is to\nhave what the standard has; that is, a permanent record of who defined\nthe view. This is why the default DEFINER value is the account of the\nview creator.\n\nThe optional ALGORITHM clause is a MySQL extension to standard SQL. It\naffects how MySQL processes the view. ALGORITHM takes three values:\nMERGE, TEMPTABLE, or UNDEFINED. The default algorithm is UNDEFINED if\nno ALGORITHM clause is present. For more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/view-algorithms.html.\n\nSome views are updatable. That is, you can use them in statements such\nas UPDATE, DELETE, or INSERT to update the contents of the underlying\ntable. For a view to be updatable, there must be a one-to-one\nrelationship between the rows in the view and the rows in the\nunderlying table. There are also certain other constructs that make a\nview nonupdatable.\n\nThe WITH CHECK OPTION clause can be given for an updatable view to\nprevent inserts or updates to rows except those for which the WHERE\nclause in the select_statement is true.\n\nIn a WITH CHECK OPTION clause for an updatable view, the LOCAL and\nCASCADED keywords determine the scope of check testing when the view is\ndefined in terms of another view. The LOCAL keyword restricts the CHECK\nOPTION only to the view being defined. CASCADED causes the checks for\nunderlying views to be evaluated as well. When neither keyword is\ngiven, the default is CASCADED.\n\nFor more information about updatable views and the WITH CHECK OPTION\nclause, see\nhttp://dev.mysql.com/doc/refman/5.5/en/view-updatability.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-view.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-view.html'),(455,'TRIM',36,'Syntax:\nTRIM([{BOTH | LEADING | TRAILING} [remstr] FROM] str), TRIM([remstr\nFROM] str)\n\nReturns the string str with all remstr prefixes or suffixes removed. If\nnone of the specifiers BOTH, LEADING, or TRAILING is given, BOTH is\nassumed. remstr is optional and, if not specified, spaces are removed.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT TRIM(\'  bar   \');\n        -> \'bar\'\nmysql> SELECT TRIM(LEADING \'x\' FROM \'xxxbarxxx\');\n        -> \'barxxx\'\nmysql> SELECT TRIM(BOTH \'x\' FROM \'xxxbarxxx\');\n        -> \'bar\'\nmysql> SELECT TRIM(TRAILING \'xyz\' FROM \'barxxyz\');\n        -> \'barx\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(456,'IS',18,'Syntax:\nIS boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 1 IS TRUE, 0 IS FALSE, NULL IS UNKNOWN;\n        -> 1, 1, 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(457,'GET_FORMAT',31,'Syntax:\nGET_FORMAT({DATE|TIME|DATETIME}, {\'EUR\'|\'USA\'|\'JIS\'|\'ISO\'|\'INTERNAL\'})\n\nReturns a format string. This function is useful in combination with\nthe DATE_FORMAT() and the STR_TO_DATE() functions.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_FORMAT(\'2003-10-03\',GET_FORMAT(DATE,\'EUR\'));\n        -> \'03.10.2003\'\nmysql> SELECT STR_TO_DATE(\'10.31.2003\',GET_FORMAT(DATE,\'USA\'));\n        -> \'2003-10-31\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(458,'TINYBLOB',22,'TINYBLOB\n\nA BLOB column with a maximum length of 255 (28 - 1) bytes. Each\nTINYBLOB value is stored using a one-byte length prefix that indicates\nthe number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(459,'SIGNAL',23,'Syntax:\nSIGNAL condition_value\n    [SET signal_information_item\n    [, signal_information_item] ...]\n\ncondition_value:\n    SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n\nsignal_information_item:\n    condition_information_item_name = simple_value_specification\n\ncondition_information_item_name:\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n\ncondition_name, simple_value_specification:\n    (see following discussion)\n\nSIGNAL is the way to \"return\" an error. SIGNAL provides error\ninformation to a handler, to an outer portion of the application, or to\nthe client. Also, it provides control over the error\'s characteristics\n(error number, SQLSTATE value, message). Without SIGNAL, it is\nnecessary to resort to workarounds such as deliberately referring to a\nnonexistent table to cause a routine to return an error.\n\nNo special privileges are required to execute the SIGNAL statement.\n\nThe condition_value in a SIGNAL statement indicates the error value to\nbe returned. It can be an SQLSTATE value (a 5-character string literal)\nor a condition_name that refers to a named condition previously defined\nwith DECLARE ... CONDITION (see [HELP DECLARE CONDITION]).\n\nAn SQLSTATE value can indicate errors, warnings, or \"not found.\" The\nfirst two characters of the value indicate its error class, as\ndiscussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/signal.html#signal-condition-inf\normation-items. Some signal values cause statement termination; see\nhttp://dev.mysql.com/doc/refman/5.5/en/signal.html#signal-effects.\n\nThe SQLSTATE value for a SIGNAL statement should not start with \'00\'\nbecause such values indicate success and are not valid for signaling an\nerror. This is true whether the SQLSTATE value is specified directly in\nthe SIGNAL statement or in a named condition referred to in the\nstatement. If the value is invalid, a Bad SQLSTATE error occurs.\n\nTo signal a generic SQLSTATE value, use \'45000\', which means \"unhandled\nuser-defined exception.\"\n\nThe SIGNAL statement optionally includes a SET clause that contains\nmultiple signal items, in a comma-separated list of\ncondition_information_item_name = simple_value_specification\nassignments.\n\nEach condition_information_item_name may be specified only once in the\nSET clause. Otherwise, a Duplicate condition information item error\noccurs.\n\nValid simple_value_specification designators can be specified using\nstored procedure or function parameters, stored program local variables\ndeclared with DECLARE, user-defined variables, system variables, or\nliterals. A character literal may include a _charset introducer.\n\nFor information about permissible condition_information_item_name\nvalues, see\nhttp://dev.mysql.com/doc/refman/5.5/en/signal.html#signal-condition-inf\normation-items.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/signal.html\n\n','CREATE PROCEDURE p (pval INT)\nBEGIN\n  DECLARE specialty CONDITION FOR SQLSTATE \'45000\';\n  IF pval = 0 THEN\n    SIGNAL SQLSTATE \'01000\';\n  ELSEIF pval = 1 THEN\n    SIGNAL SQLSTATE \'45000\'\n      SET MESSAGE_TEXT = \'An error occurred\';\n  ELSEIF pval = 2 THEN\n    SIGNAL specialty\n      SET MESSAGE_TEXT = \'An error occurred\';\n  ELSE\n    SIGNAL SQLSTATE \'01000\'\n      SET MESSAGE_TEXT = \'A warning occurred\', MYSQL_ERRNO = 1000;\n    SIGNAL SQLSTATE \'45000\'\n      SET MESSAGE_TEXT = \'An error occurred\', MYSQL_ERRNO = 1001;\n  END IF;\nEND;\n','http://dev.mysql.com/doc/refman/5.5/en/signal.html'),(460,'SAVEPOINT',8,'Syntax:\nSAVEPOINT identifier\nROLLBACK [WORK] TO [SAVEPOINT] identifier\nRELEASE SAVEPOINT identifier\n\nInnoDB supports the SQL statements SAVEPOINT, ROLLBACK TO SAVEPOINT,\nRELEASE SAVEPOINT and the optional WORK keyword for ROLLBACK.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/savepoint.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/savepoint.html'),(461,'USER',17,'Syntax:\nUSER()\n\nReturns the current MySQL user name and host name as a string in the\nutf8 character set.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT USER();\n        -> \'davida@localhost\'\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(462,'LABELS',23,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nLabels are permitted for BEGIN ... END blocks and for the LOOP, REPEAT,\nand WHILE statements. Label use for those statements follows these\nrules:\n\no begin_label must be followed by a colon.\n\no begin_label can be given without end_label. If end_label is present,\n  it must be the same as begin_label.\n\no end_label cannot be given without begin_label.\n\no Labels at the same nesting level must be distinct.\n\no Labels can be up to 16 characters long.\n\nTo refer to a label within the labeled construct, use an ITERATE or\nLEAVE statement. The following example uses those statements to\ncontinue iterating or terminate the loop:\n\nCREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN ITERATE label1; END IF;\n    LEAVE label1;\n  END LOOP label1;\nEND;\n\nThe scope of a block label does not include the code for handlers\ndeclared within the block. For details, see [HELP DECLARE HANDLER].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/statement-labels.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/statement-labels.html'),(463,'ALTER TABLE',38,'Syntax:\nALTER [ONLINE | OFFLINE] [IGNORE] TABLE tbl_name\n    [alter_specification [, alter_specification] ...]\n    [partition_options]\n\nALTER [ONLINE | OFFLINE] [IGNORE] TABLE tbl_name\n    partition_options\n\nalter_specification:\n    table_options\n  | ADD [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name ]\n  | ADD [COLUMN] (col_name column_definition,...)\n  | ADD {INDEX|KEY} [index_name]\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]] PRIMARY KEY\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]]\n        UNIQUE [INDEX|KEY] [index_name]\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD FULLTEXT [INDEX|KEY] [index_name]\n        (index_col_name,...) [index_option] ...\n  | ADD SPATIAL [INDEX|KEY] [index_name]\n        (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]]\n        FOREIGN KEY [index_name] (index_col_name,...)\n        reference_definition\n  | ALTER [COLUMN] col_name {SET DEFAULT literal | DROP DEFAULT}\n  | CHANGE [COLUMN] old_col_name new_col_name column_definition\n        [FIRST|AFTER col_name]\n  | MODIFY [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name]\n  | DROP [COLUMN] col_name\n  | DROP PRIMARY KEY\n  | DROP {INDEX|KEY} index_name\n  | DROP FOREIGN KEY fk_symbol\n  | DISABLE KEYS\n  | ENABLE KEYS\n  | RENAME [TO] new_tbl_name\n  | ORDER BY col_name [, col_name] ...\n  | CONVERT TO CHARACTER SET charset_name [COLLATE collation_name]\n  | [DEFAULT] CHARACTER SET [=] charset_name [COLLATE [=] collation_name]\n  | DISCARD TABLESPACE\n  | IMPORT TABLESPACE\n  | FORCE\n  | ADD PARTITION (partition_definition)\n  | DROP PARTITION partition_names\n  | TRUNCATE PARTITION {partition_names | ALL }\n  | COALESCE PARTITION number\n  | REORGANIZE PARTITION partition_names INTO (partition_definitions)\n  | ANALYZE PARTITION  {partition_names | ALL }\n  | CHECK PARTITION  {partition_names | ALL }\n  | OPTIMIZE PARTITION  {partition_names | ALL }\n  | REBUILD PARTITION  {partition_names | ALL }\n  | REPAIR PARTITION  {partition_names | ALL }\n  | PARTITION BY partitioning_expression\n  | REMOVE PARTITIONING\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n\ntable_options:\n    table_option [[,] table_option] ...  (see CREATE TABLE options)\n\npartition_options:\n    (see CREATE TABLE options)\n\nALTER TABLE changes the structure of a table. For example, you can add\nor delete columns, create or destroy indexes, change the type of\nexisting columns, or rename columns or the table itself. You can also\nchange characteristics such as the storage engine used for the table or\nthe table comment.\n\nPartitioning-related clauses for ALTER TABLE can be used with\npartitioned tables for repartitioning, for adding, dropping, merging,\nand splitting partitions, and for performing partitioning maintenance.\nFor more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/alter-table-partition-operations\n.html.\n\nFollowing the table name, specify the alterations to be made. If none\nare given, ALTER TABLE does nothing.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-table.html'),(464,'MPOINTFROMWKB',32,'MPointFromWKB(wkb[,srid]), MultiPointFromWKB(wkb[,srid])\n\nConstructs a MULTIPOINT value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(465,'CHAR BYTE',22,'The CHAR BYTE data type is an alias for the BINARY data type. This is a\ncompatibility feature.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(466,'REPAIR TABLE',20,'Syntax:\nREPAIR [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n    [QUICK] [EXTENDED] [USE_FRM]\n\nREPAIR TABLE repairs a possibly corrupted table. By default, it has the\nsame effect as myisamchk --recover tbl_name. REPAIR TABLE works for\nMyISAM, ARCHIVE, and CSV tables. See\nhttp://dev.mysql.com/doc/refman/5.5/en/myisam-storage-engine.html, and\nhttp://dev.mysql.com/doc/refman/5.5/en/archive-storage-engine.html, and\nhttp://dev.mysql.com/doc/refman/5.5/en/csv-storage-engine.html\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nREPAIR TABLE is supported for partitioned tables. However, the USE_FRM\noption cannot be used with this statement on a partitioned table.\n\nYou can use ALTER TABLE ... REPAIR PARTITION to repair one or more\npartitions; for more information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/repair-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/repair-table.html'),(467,'MERGE',38,'The MERGE storage engine, also known as the MRG_MyISAM engine, is a\ncollection of identical MyISAM tables that can be used as one.\n\"Identical\" means that all tables have identical column and index\ninformation. You cannot merge MyISAM tables in which the columns are\nlisted in a different order, do not have exactly the same columns, or\nhave the indexes in different order. However, any or all of the MyISAM\ntables can be compressed with myisampack. See\nhttp://dev.mysql.com/doc/refman/5.5/en/myisampack.html. Differences in\ntable options such as AVG_ROW_LENGTH, MAX_ROWS, or PACK_KEYS do not\nmatter.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/merge-storage-engine.html\n\n','mysql> CREATE TABLE t1 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nmysql> CREATE TABLE t2 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nmysql> INSERT INTO t1 (message) VALUES (\'Testing\'),(\'table\'),(\'t1\');\nmysql> INSERT INTO t2 (message) VALUES (\'Testing\'),(\'table\'),(\'t2\');\nmysql> CREATE TABLE total (\n    ->    a INT NOT NULL AUTO_INCREMENT,\n    ->    message CHAR(20), INDEX(a))\n    ->    ENGINE=MERGE UNION=(t1,t2) INSERT_METHOD=LAST;\n','http://dev.mysql.com/doc/refman/5.5/en/merge-storage-engine.html'),(468,'CREATE TABLE',38,'Syntax:\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    (create_definition,...)\n    [table_options]\n    [partition_options]\n\nOr:\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    [(create_definition,...)]\n    [table_options]\n    [partition_options]\n    select_statement\n\nOr:\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    { LIKE old_tbl_name | (LIKE old_tbl_name) }\n\ncreate_definition:\n    col_name column_definition\n  | [CONSTRAINT [symbol]] PRIMARY KEY [index_type] (index_col_name,...)\n      [index_option] ...\n  | {INDEX|KEY} [index_name] [index_type] (index_col_name,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] UNIQUE [INDEX|KEY]\n      [index_name] [index_type] (index_col_name,...)\n      [index_option] ...\n  | {FULLTEXT|SPATIAL} [INDEX|KEY] [index_name] (index_col_name,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] FOREIGN KEY\n      [index_name] (index_col_name,...) reference_definition\n  | CHECK (expr)\n\ncolumn_definition:\n    data_type [NOT NULL | NULL] [DEFAULT default_value]\n      [AUTO_INCREMENT] [UNIQUE [KEY] | [PRIMARY] KEY]\n      [COMMENT \'string\']\n      [COLUMN_FORMAT {FIXED|DYNAMIC|DEFAULT}]\n      [STORAGE {DISK|MEMORY|DEFAULT}]\n      [reference_definition]\n\ndata_type:\n    BIT[(length)]\n  | TINYINT[(length)] [UNSIGNED] [ZEROFILL]\n  | SMALLINT[(length)] [UNSIGNED] [ZEROFILL]\n  | MEDIUMINT[(length)] [UNSIGNED] [ZEROFILL]\n  | INT[(length)] [UNSIGNED] [ZEROFILL]\n  | INTEGER[(length)] [UNSIGNED] [ZEROFILL]\n  | BIGINT[(length)] [UNSIGNED] [ZEROFILL]\n  | REAL[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | DOUBLE[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | FLOAT[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | DECIMAL[(length[,decimals])] [UNSIGNED] [ZEROFILL]\n  | NUMERIC[(length[,decimals])] [UNSIGNED] [ZEROFILL]\n  | DATE\n  | TIME\n  | TIMESTAMP\n  | DATETIME\n  | YEAR\n  | CHAR[(length)]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | VARCHAR(length)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | BINARY[(length)]\n  | VARBINARY(length)\n  | TINYBLOB\n  | BLOB\n  | MEDIUMBLOB\n  | LONGBLOB\n  | TINYTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | TEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | MEDIUMTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | LONGTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | ENUM(value1,value2,value3,...)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | SET(value1,value2,value3,...)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | spatial_type\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n\nreference_definition:\n    REFERENCES tbl_name (index_col_name,...)\n      [MATCH FULL | MATCH PARTIAL | MATCH SIMPLE]\n      [ON DELETE reference_option]\n      [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION\n\ntable_options:\n    table_option [[,] table_option] ...\n\ntable_option:\n    ENGINE [=] engine_name\n  | AUTO_INCREMENT [=] value\n  | AVG_ROW_LENGTH [=] value\n  | [DEFAULT] CHARACTER SET [=] charset_name\n  | CHECKSUM [=] {0 | 1}\n  | [DEFAULT] COLLATE [=] collation_name\n  | COMMENT [=] \'string\'\n  | CONNECTION [=] \'connect_string\'\n  | DATA DIRECTORY [=] \'absolute path to directory\'\n  | DELAY_KEY_WRITE [=] {0 | 1}\n  | INDEX DIRECTORY [=] \'absolute path to directory\'\n  | INSERT_METHOD [=] { NO | FIRST | LAST }\n  | KEY_BLOCK_SIZE [=] value\n  | MAX_ROWS [=] value\n  | MIN_ROWS [=] value\n  | PACK_KEYS [=] {0 | 1 | DEFAULT}\n  | PASSWORD [=] \'string\'\n  | ROW_FORMAT [=] {DEFAULT|DYNAMIC|FIXED|COMPRESSED|REDUNDANT|COMPACT}\n  | TABLESPACE tablespace_name [STORAGE {DISK|MEMORY|DEFAULT}]\n  | UNION [=] (tbl_name[,tbl_name]...)\n\npartition_options:\n    PARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY(column_list)\n        | RANGE{(expr) | COLUMNS(column_list)}\n        | LIST{(expr) | COLUMNS(column_list)} }\n    [PARTITIONS num]\n    [SUBPARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY(column_list) }\n      [SUBPARTITIONS num]\n    ]\n    [(partition_definition [, partition_definition] ...)]\n\npartition_definition:\n    PARTITION partition_name\n        [VALUES \n            {LESS THAN {(expr | value_list) | MAXVALUE} \n            | \n            IN (value_list)}]\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'comment_text\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [NODEGROUP [=] node_group_id]\n        [(subpartition_definition [, subpartition_definition] ...)]\n\nsubpartition_definition:\n    SUBPARTITION logical_name\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'comment_text\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [NODEGROUP [=] node_group_id]\n\nselect_statement:\n    [IGNORE | REPLACE] [AS] SELECT ...   (Some legal select statement)\n\nCREATE TABLE creates a table with the given name. You must have the\nCREATE privilege for the table.\n\nRules for permissible table names are given in\nhttp://dev.mysql.com/doc/refman/5.5/en/identifiers.html. By default,\nthe table is created in the default database, using the InnoDB storage\nengine. An error occurs if the table exists, if there is no default\ndatabase, or if the database does not exist.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/create-table.html'),(469,'>',18,'Syntax:\n>\n\nGreater than:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT 2 > 2;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(470,'ANALYZE TABLE',20,'Syntax:\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n\nANALYZE TABLE analyzes and stores the key distribution for a table.\nDuring the analysis, the table is locked with a read lock for MyISAM\nand InnoDB. This statement works with MyISAM, InnoDB, and NDB tables.\nFor MyISAM tables, this statement is equivalent to using myisamchk\n--analyze.\n\nFor more information on how the analysis works within InnoDB, see\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-restrictions.html.\n\nMySQL uses the stored key distribution to decide the order in which\ntables should be joined when you perform a join on something other than\na constant. In addition, key distributions can be used when deciding\nwhich indexes to use for a specific table within a query.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nANALYZE TABLE is supported for partitioned tables, and you can use\nALTER TABLE ... ANALYZE PARTITION to analyze one or more partitions;\nfor more information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/analyze-table.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/analyze-table.html'),(471,'MICROSECOND',31,'Syntax:\nMICROSECOND(expr)\n\nReturns the microseconds from the time or datetime expression expr as a\nnumber in the range from 0 to 999999.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT MICROSECOND(\'12:00:00.123456\');\n        -> 123456\nmysql> SELECT MICROSECOND(\'2009-12-31 23:59:59.000010\');\n        -> 10\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(472,'CONSTRAINT',38,'InnoDB supports foreign key constraints. The syntax for a foreign key\nconstraint definition in InnoDB looks like this:\n\n[CONSTRAINT [symbol]] FOREIGN KEY\n    [index_name] (index_col_name, ...)\n    REFERENCES tbl_name (index_col_name,...)\n    [ON DELETE reference_option]\n    [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/innodb-foreign-key-constraints.html\n\n','CREATE TABLE product (category INT NOT NULL, id INT NOT NULL,\n                      price DECIMAL,\n                      PRIMARY KEY(category, id)) ENGINE=INNODB;\nCREATE TABLE customer (id INT NOT NULL,\n                       PRIMARY KEY (id)) ENGINE=INNODB;\nCREATE TABLE product_order (no INT NOT NULL AUTO_INCREMENT,\n                            product_category INT NOT NULL,\n                            product_id INT NOT NULL,\n                            customer_id INT NOT NULL,\n                            PRIMARY KEY(no),\n                            INDEX (product_category, product_id),\n                            FOREIGN KEY (product_category, product_id)\n                              REFERENCES product(category, id)\n                              ON UPDATE CASCADE ON DELETE RESTRICT,\n                            INDEX (customer_id),\n                            FOREIGN KEY (customer_id)\n                              REFERENCES customer(id)) ENGINE=INNODB;\n','http://dev.mysql.com/doc/refman/5.5/en/innodb-foreign-key-constraints.html'),(473,'CREATE SERVER',38,'Syntax:\nCREATE SERVER server_name\n    FOREIGN DATA WRAPPER wrapper_name\n    OPTIONS (option [, option] ...)\n\noption:\n  { HOST character-literal\n  | DATABASE character-literal\n  | USER character-literal\n  | PASSWORD character-literal\n  | SOCKET character-literal\n  | OWNER character-literal\n  | PORT numeric-literal }\n\nThis statement creates the definition of a server for use with the\nFEDERATED storage engine. The CREATE SERVER statement creates a new row\nwithin the servers table within the mysql database. This statement\nrequires the SUPER privilege.\n\nThe server_name should be a unique reference to the server. Server\ndefinitions are global within the scope of the server, it is not\npossible to qualify the server definition to a specific database.\nserver_name has a maximum length of 64 characters (names longer than 64\ncharacters are silently truncated), and is case insensitive. You may\nspecify the name as a quoted string.\n\nThe wrapper_name should be mysql, and may be quoted with single\nquotation marks. Other values for wrapper_name are not currently\nsupported.\n\nFor each option you must specify either a character literal or numeric\nliteral. Character literals are UTF-8, support a maximum length of 64\ncharacters and default to a blank (empty) string. String literals are\nsilently truncated to 64 characters. Numeric literals must be a number\nbetween 0 and 9999, default value is 0.\n\n*Note*: Note that the OWNER option is currently not applied, and has no\neffect on the ownership or operation of the server connection that is\ncreated.\n\nThe CREATE SERVER statement creates an entry in the mysql.servers table\nthat can later be used with the CREATE TABLE statement when creating a\nFEDERATED table. The options that you specify will be used to populate\nthe columns in the mysql.servers table. The table columns are\nServer_name, Host, Db, Username, Password, Port and Socket.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/create-server.html\n\n','CREATE SERVER s\nFOREIGN DATA WRAPPER mysql\nOPTIONS (USER \'Remote\', HOST \'192.168.1.106\', DATABASE \'test\');\n','http://dev.mysql.com/doc/refman/5.5/en/create-server.html'),(474,'FIELD',36,'Syntax:\nFIELD(str,str1,str2,str3,...)\n\nReturns the index (position) of str in the str1, str2, str3, ... list.\nReturns 0 if str is not found.\n\nIf all arguments to FIELD() are strings, all arguments are compared as\nstrings. If all arguments are numbers, they are compared as numbers.\nOtherwise, the arguments are compared as double.\n\nIf str is NULL, the return value is 0 because NULL fails equality\ncomparison with any value. FIELD() is the complement of ELT().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT FIELD(\'ej\', \'Hej\', \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> 2\nmysql> SELECT FIELD(\'fo\', \'Hej\', \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(475,'MAKETIME',31,'Syntax:\nMAKETIME(hour,minute,second)\n\nReturns a time value calculated from the hour, minute, and second\narguments.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT MAKETIME(12,15,30);\n        -> \'12:15:30\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(476,'CURDATE',31,'Syntax:\nCURDATE()\n\nReturns the current date as a value in \'YYYY-MM-DD\' or YYYYMMDD format,\ndepending on whether the function is used in a string or numeric\ncontext.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT CURDATE();\n        -> \'2008-06-13\'\nmysql> SELECT CURDATE() + 0;\n        -> 20080613\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(477,'SET PASSWORD',10,'Syntax:\nSET PASSWORD [FOR user] =\n    {\n        PASSWORD(\'some password\')\n      | OLD_PASSWORD(\'some password\')\n      | \'encrypted password\'\n    }\n\nThe SET PASSWORD statement assigns a password to an existing MySQL user\naccount.\n\nIf the password is specified using the PASSWORD() or OLD_PASSWORD()\nfunction, the literal text of the password should be given. If the\npassword is specified without using either function, the password\nshould be the already-encrypted password value as returned by\nPASSWORD().\n\nWith no FOR clause, this statement sets the password for the current\nuser. Any client that has connected to the server using a nonanonymous\naccount can change the password for that account.\n\nIn MySQL 5.1 and later, when the read_only system variable is enabled,\nthe SUPER privilege is required to use SET PASSWORD.\n\nWith a FOR clause, this statement sets the password for a specific\naccount on the current server host. Only clients that have the UPDATE\nprivilege for the mysql database can do this. The user value should be\ngiven in user_name@host_name format, where user_name and host_name are\nexactly as they are listed in the User and Host columns of the\nmysql.user table entry. For example, if you had an entry with User and\nHost column values of \'bob\' and \'%.loc.gov\', you would write the\nstatement like this:\n\nSET PASSWORD FOR \'bob\'@\'%.loc.gov\' = PASSWORD(\'newpass\');\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/set-password.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/set-password.html'),(478,'ALTER TABLESPACE',38,'Syntax:\nALTER TABLESPACE tablespace_name\n    {ADD|DROP} DATAFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement can be used either to add a new data file, or to drop a\ndata file from a tablespace.\n\nThe ADD DATAFILE variant enables you to specify an initial size using\nan INITIAL_SIZE clause, where size is measured in bytes; the default\nvalue is 128M (128 megabytes). You may optionally follow this integer\nvalue with a one-letter abbreviation for an order of magnitude, similar\nto those used in my.cnf. Generally, this is one of the letters M (for\nmegabytes) or G (for gigabytes).\n\n*Note*: All MySQL Cluster Disk Data objects share the same namespace.\nThis means that each Disk Data object must be uniquely named (and not\nmerely each Disk Data object of a given type). For example, you cannot\nhave a tablespace and an data file with the same name, or an undo log\nfile and a tablespace with the same name.\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is 4G.\n(Bug #29186)\n\nINITIAL_SIZE is rounded, explicitly, as for CREATE TABLESPACE.\n\nOnce a data file has been created, its size cannot be changed; however,\nyou can add more data files to the tablespace using additional ALTER\nTABLESPACE ... ADD DATAFILE statements.\n\nUsing DROP DATAFILE with ALTER TABLESPACE drops the data file\n\'file_name\' from the tablespace. This file must already have been added\nto the tablespace using CREATE TABLESPACE or ALTER TABLESPACE;\notherwise an error will result.\n\nBoth ALTER TABLESPACE ... ADD DATAFILE and ALTER TABLESPACE ... DROP\nDATAFILE require an ENGINE clause which specifies the storage engine\nused by the tablespace. Currently, the only accepted values for\nengine_name are NDB and NDBCLUSTER.\n\nWAIT is parsed but otherwise ignored, and so has no effect in MySQL\n5.5. It is intended for future expansion.\n\nWhen ALTER TABLESPACE ... ADD DATAFILE is used with ENGINE = NDB, a\ndata file is created on each Cluster data node. You can verify that the\ndata files were created and obtain information about them by querying\nthe INFORMATION_SCHEMA.FILES table. For example, the following query\nshows all data files belonging to the tablespace named newts:\n\nmysql> SELECT LOGFILE_GROUP_NAME, FILE_NAME, EXTRA\n    -> FROM INFORMATION_SCHEMA.FILES\n    -> WHERE TABLESPACE_NAME = \'newts\' AND FILE_TYPE = \'DATAFILE\';\n+--------------------+--------------+----------------+\n| LOGFILE_GROUP_NAME | FILE_NAME    | EXTRA          |\n+--------------------+--------------+----------------+\n| lg_3               | newdata.dat  | CLUSTER_NODE=3 |\n| lg_3               | newdata.dat  | CLUSTER_NODE=4 |\n| lg_3               | newdata2.dat | CLUSTER_NODE=3 |\n| lg_3               | newdata2.dat | CLUSTER_NODE=4 |\n+--------------------+--------------+----------------+\n2 rows in set (0.03 sec)\n\nSee http://dev.mysql.com/doc/refman/5.5/en/files-table.html.\n\nALTER TABLESPACE is useful only with Disk Data storage for MySQL\nCluster. See\nhttp://dev.mysql.com/doc/refman/5.5/en/mysql-cluster-disk-data.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/alter-tablespace.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/alter-tablespace.html'),(479,'IF FUNCTION',7,'Syntax:\nIF(expr1,expr2,expr3)\n\nIf expr1 is TRUE (expr1 <> 0 and expr1 <> NULL) then IF() returns\nexpr2; otherwise it returns expr3. IF() returns a numeric or string\nvalue, depending on the context in which it is used.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html\n\n','mysql> SELECT IF(1>2,2,3);\n        -> 3\nmysql> SELECT IF(1<2,\'yes\',\'no\');\n        -> \'yes\'\nmysql> SELECT IF(STRCMP(\'test\',\'test1\'),\'no\',\'yes\');\n        -> \'no\'\n','http://dev.mysql.com/doc/refman/5.5/en/control-flow-functions.html'),(480,'ENUM',22,'ENUM(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nAn enumeration. A string object that can have only one value, chosen\nfrom the list of values \'value1\', \'value2\', ..., NULL or the special \'\'\nerror value. An ENUM column can have a maximum of 65,535 distinct\nvalues. ENUM values are represented internally as integers.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(481,'DATABASE',17,'Syntax:\nDATABASE()\n\nReturns the default (current) database name as a string in the utf8\ncharacter set. If there is no default database, DATABASE() returns\nNULL. Within a stored routine, the default database is the database\nthat the routine is associated with, which is not necessarily the same\nas the database that is the default in the calling context.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT DATABASE();\n        -> \'test\'\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(482,'POINTFROMWKB',32,'PointFromWKB(wkb[,srid])\n\nConstructs a POINT value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.5/en/creating-spatial-values.html#gis-wkb-functions'),(483,'POWER',4,'Syntax:\nPOWER(X,Y)\n\nThis is a synonym for POW().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(484,'ATAN',4,'Syntax:\nATAN(X)\n\nReturns the arc tangent of X, that is, the value whose tangent is X.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT ATAN(2);\n        -> 1.1071487177941\nmysql> SELECT ATAN(-2);\n        -> -1.1071487177941\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(485,'STRCMP',36,'Syntax:\nSTRCMP(expr1,expr2)\n\nSTRCMP() returns 0 if the strings are the same, -1 if the first\nargument is smaller than the second according to the current sort\norder, and 1 otherwise.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-comparison-functions.html\n\n','mysql> SELECT STRCMP(\'text\', \'text2\');\n        -> -1\nmysql> SELECT STRCMP(\'text2\', \'text\');\n        -> 1\nmysql> SELECT STRCMP(\'text\', \'text\');\n        -> 0\n','http://dev.mysql.com/doc/refman/5.5/en/string-comparison-functions.html'),(486,'INSERT DELAYED',27,'Syntax:\nINSERT DELAYED ...\n\nThe DELAYED option for the INSERT statement is a MySQL extension to\nstandard SQL that is very useful if you have clients that cannot or\nneed not wait for the INSERT to complete. This is a common situation\nwhen you use MySQL for logging and you also periodically run SELECT and\nUPDATE statements that take a long time to complete.\n\nWhen a client uses INSERT DELAYED, it gets an okay from the server at\nonce, and the row is queued to be inserted when the table is not in use\nby any other thread.\n\nAnother major benefit of using INSERT DELAYED is that inserts from many\nclients are bundled together and written in one block. This is much\nfaster than performing many separate inserts.\n\nNote that INSERT DELAYED is slower than a normal INSERT if the table is\nnot otherwise in use. There is also the additional overhead for the\nserver to handle a separate thread for each table for which there are\ndelayed rows. This means that you should use INSERT DELAYED only when\nyou are really sure that you need it.\n\nThe queued rows are held only in memory until they are inserted into\nthe table. This means that if you terminate mysqld forcibly (for\nexample, with kill -9) or if mysqld dies unexpectedly, any queued rows\nthat have not been written to disk are lost.\n\nThere are some constraints on the use of DELAYED:\n\no INSERT DELAYED works only with MyISAM, MEMORY, ARCHIVE, and BLACKHOLE\n  tables. For engines that do not support DELAYED, an error occurs.\n\no An error occurs for INSERT DELAYED if used with a table that has been\n  locked with LOCK TABLES because the insert must be handled by a\n  separate thread, not by the session that holds the lock.\n\no For MyISAM tables, if there are no free blocks in the middle of the\n  data file, concurrent SELECT and INSERT statements are supported.\n  Under these circumstances, you very seldom need to use INSERT DELAYED\n  with MyISAM.\n\no INSERT DELAYED should be used only for INSERT statements that specify\n  value lists. The server ignores DELAYED for INSERT ... SELECT or\n  INSERT ... ON DUPLICATE KEY UPDATE statements.\n\no Because the INSERT DELAYED statement returns immediately, before the\n  rows are inserted, you cannot use LAST_INSERT_ID() to get the\n  AUTO_INCREMENT value that the statement might generate.\n\no DELAYED rows are not visible to SELECT statements until they actually\n  have been inserted.\n\no Prior to MySQL 5.5.7, INSERT DELAYED was treated as a normal INSERT\n  if the statement inserted multiple rows, binary logging was enabled,\n  and the global logging format was statement-based (that is, whenever\n  binlog_format was set to STATEMENT). Beginning with MySQL 5.5.7,\n  INSERT DELAYED is always handled as a simple INSERT (that is, without\n  the DELAYED option) whenever the value of binlog_format is STATEMENT\n  or MIXED. (In the latter case, the statement no longer triggers a\n  switch to row-based logging, and so is logged using the\n  statement-based format.)\n\n  This does not apply when using row-based binary logging mode\n  (binlog_format set to ROW), in which INSERT DELAYED statements are\n  always executed using the DELAYED option as specified, and logged as\n  row-update events.\n\no DELAYED is ignored on slave replication servers, so that INSERT\n  DELAYED is treated as a normal INSERT on slaves. This is because\n  DELAYED could cause the slave to have different data than the master.\n\no Pending INSERT DELAYED statements are lost if a table is write locked\n  and ALTER TABLE is used to modify the table structure.\n\no INSERT DELAYED is not supported for views.\n\no INSERT DELAYED is not supported for partitioned tables.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/insert-delayed.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/insert-delayed.html'),(487,'SHOW PROFILE',26,'Syntax:\nSHOW PROFILES\n\nThe SHOW PROFILE statement display profiling information that indicates\nresource usage for statements executed during the course of the current\nsession. It is used together with SHOW PROFILES; see [HELP SHOW\nPROFILES].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-profile.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-profile.html'),(488,'SHOW PROCEDURE CODE',26,'Syntax:\nSHOW PROCEDURE CODE proc_name\n\nThis statement is a MySQL extension that is available only for servers\nthat have been built with debugging support. It displays a\nrepresentation of the internal implementation of the named stored\nprocedure. A similar statement, SHOW FUNCTION CODE, displays\ninformation about stored functions (see [HELP SHOW FUNCTION CODE]).\n\nBoth statements require that you be the owner of the routine or have\nSELECT access to the mysql.proc table.\n\nIf the named routine is available, each statement produces a result\nset. Each row in the result set corresponds to one \"instruction\" in the\nroutine. The first column is Pos, which is an ordinal number beginning\nwith 0. The second column is Instruction, which contains an SQL\nstatement (usually changed from the original source), or a directive\nwhich has meaning only to the stored-routine handler.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-procedure-code.html\n\n','mysql> DELIMITER //\nmysql> CREATE PROCEDURE p1 ()\n    -> BEGIN\n    ->   DECLARE fanta INT DEFAULT 55;\n    ->   DROP TABLE t2;\n    ->   LOOP\n    ->     INSERT INTO t3 VALUES (fanta);\n    ->     END LOOP;\n    ->   END//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SHOW PROCEDURE CODE p1//\n+-----+----------------------------------------+\n| Pos | Instruction                            |\n+-----+----------------------------------------+\n|   0 | set fanta@0 55                         |\n|   1 | stmt 9 \"DROP TABLE t2\"                 |\n|   2 | stmt 5 \"INSERT INTO t3 VALUES (fanta)\" |\n|   3 | jump 2                                 |\n+-----+----------------------------------------+\n4 rows in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.5/en/show-procedure-code.html'),(489,'MEDIUMTEXT',22,'MEDIUMTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 16,777,215 (224 - 1) characters.\nThe effective maximum length is less if the value contains multi-byte\ncharacters. Each MEDIUMTEXT value is stored using a three-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/string-type-overview.html'),(490,'LN',4,'Syntax:\nLN(X)\n\nReturns the natural logarithm of X; that is, the base-e logarithm of X.\nIf X is less than or equal to 0, then NULL is returned.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT LN(2);\n        -> 0.69314718055995\nmysql> SELECT LN(-2);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(491,'RETURN',23,'Syntax:\nRETURN expr\n\nThe RETURN statement terminates execution of a stored function and\nreturns the value expr to the function caller. There must be at least\none RETURN statement in a stored function. There may be more than one\nif the function has multiple exit points.\n\nThis statement is not used in stored procedures, triggers, or events.\nThe LEAVE statement can be used to exit a stored program of those\ntypes.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/return.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/return.html'),(492,'SHOW COLLATION',26,'Syntax:\nSHOW COLLATION\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement lists collations supported by the server. By default,\nthe output from SHOW COLLATION includes all available collations. The\nLIKE clause, if present, indicates which collation names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttp://dev.mysql.com/doc/refman/5.5/en/extended-show.html. For example:\n\nmysql> SHOW COLLATION LIKE \'latin1%\';\n+-------------------+---------+----+---------+----------+---------+\n| Collation         | Charset | Id | Default | Compiled | Sortlen |\n+-------------------+---------+----+---------+----------+---------+\n| latin1_german1_ci | latin1  |  5 |         |          |       0 |\n| latin1_swedish_ci | latin1  |  8 | Yes     | Yes      |       0 |\n| latin1_danish_ci  | latin1  | 15 |         |          |       0 |\n| latin1_german2_ci | latin1  | 31 |         | Yes      |       2 |\n| latin1_bin        | latin1  | 47 |         | Yes      |       0 |\n| latin1_general_ci | latin1  | 48 |         |          |       0 |\n| latin1_general_cs | latin1  | 49 |         |          |       0 |\n| latin1_spanish_ci | latin1  | 94 |         |          |       0 |\n+-------------------+---------+----+---------+----------+---------+\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/show-collation.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/show-collation.html'),(493,'LOG',4,'Syntax:\nLOG(X), LOG(B,X)\n\nIf called with one parameter, this function returns the natural\nlogarithm of X. If X is less than or equal to 0, then NULL is returned.\n\nThe inverse of this function (when called with a single argument) is\nthe EXP() function.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT LOG(2);\n        -> 0.69314718055995\nmysql> SELECT LOG(-2);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(494,'SET SQL_LOG_BIN',8,'Syntax:\nSET sql_log_bin = {0|1}\n\nDisables or enables binary logging for the current session (sql_log_bin\nis a session variable) if the client has the SUPER privilege. The\nstatement fails with an error if the client does not have that\nprivilege.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/set-sql-log-bin.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/set-sql-log-bin.html'),(495,'!=',18,'Syntax:\n<>, !=\n\nNot equal:\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT \'.01\' <> \'0.01\';\n        -> 1\nmysql> SELECT .01 <> \'0.01\';\n        -> 0\nmysql> SELECT \'zapp\' <> \'zappp\';\n        -> 1\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(496,'WHILE',23,'Syntax:\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nThe statement list within a WHILE statement is repeated as long as the\nsearch_condition expression is true. statement_list consists of one or\nmore SQL statements, each terminated by a semicolon (;) statement\ndelimiter.\n\nA WHILE statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/while-statement.html\n\n','CREATE PROCEDURE dowhile()\nBEGIN\n  DECLARE v1 INT DEFAULT 5;\n\n  WHILE v1 > 0 DO\n    ...\n    SET v1 = v1 - 1;\n  END WHILE;\nEND;\n','http://dev.mysql.com/doc/refman/5.5/en/while-statement.html'),(497,'AES_DECRYPT',12,'Syntax:\nAES_DECRYPT(crypt_str,key_str)\n\nThis function decrypts data using the official AES (Advanced Encryption\nStandard) algorithm. For more information, see the description of\nAES_ENCRYPT().\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/encryption-functions.html'),(498,'DAYNAME',31,'Syntax:\nDAYNAME(date)\n\nReturns the name of the weekday for date. The language used for the\nname is controlled by the value of the lc_time_names system variable\n(http://dev.mysql.com/doc/refman/5.5/en/locale-support.html).\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html\n\n','mysql> SELECT DAYNAME(\'2007-02-03\');\n        -> \'Saturday\'\n','http://dev.mysql.com/doc/refman/5.5/en/date-and-time-functions.html'),(499,'COERCIBILITY',17,'Syntax:\nCOERCIBILITY(str)\n\nReturns the collation coercibility value of the string argument.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT COERCIBILITY(\'abc\' COLLATE latin1_swedish_ci);\n        -> 0\nmysql> SELECT COERCIBILITY(USER());\n        -> 3\nmysql> SELECT COERCIBILITY(\'abc\');\n        -> 4\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(500,'INT',22,'INT[(M)] [UNSIGNED] [ZEROFILL]\n\nA normal-size integer. The signed range is -2147483648 to 2147483647.\nThe unsigned range is 0 to 4294967295.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.5/en/numeric-type-overview.html'),(501,'GLENGTH',13,'GLength(ls)\n\nReturns as a double-precision number the length of the LineString value\nls in its associated spatial reference.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT GLength(GeomFromText(@ls));\n+----------------------------+\n| GLength(GeomFromText(@ls)) |\n+----------------------------+\n|            2.8284271247462 |\n+----------------------------+\n','http://dev.mysql.com/doc/refman/5.5/en/geometry-property-functions.html#linestring-property-functions'),(502,'RADIANS',4,'Syntax:\nRADIANS(X)\n\nReturns the argument X, converted from degrees to radians. (Note that\nπ radians equals 180 degrees.)\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html\n\n','mysql> SELECT RADIANS(90);\n        -> 1.5707963267949\n','http://dev.mysql.com/doc/refman/5.5/en/mathematical-functions.html'),(503,'COLLATION',17,'Syntax:\nCOLLATION(str)\n\nReturns the collation of the string argument.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT COLLATION(\'abc\');\n        -> \'latin1_swedish_ci\'\nmysql> SELECT COLLATION(_utf8\'abc\');\n        -> \'utf8_general_ci\'\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(504,'COALESCE',18,'Syntax:\nCOALESCE(value,...)\n\nReturns the first non-NULL value in the list, or NULL if there are no\nnon-NULL values.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html\n\n','mysql> SELECT COALESCE(NULL,1);\n        -> 1\nmysql> SELECT COALESCE(NULL,NULL,NULL);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.5/en/comparison-operators.html'),(505,'VERSION',17,'Syntax:\nVERSION()\n\nReturns a string that indicates the MySQL server version. The string\nuses the utf8 character set. The value might have a suffix in addition\nto the version number. See the description of the version system\nvariable in\nhttp://dev.mysql.com/doc/refman/5.5/en/server-system-variables.html.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/information-functions.html\n\n','mysql> SELECT VERSION();\n        -> \'5.5.20-standard\'\n','http://dev.mysql.com/doc/refman/5.5/en/information-functions.html'),(506,'MAKE_SET',36,'Syntax:\nMAKE_SET(bits,str1,str2,...)\n\nReturns a set value (a string containing substrings separated by \",\"\ncharacters) consisting of the strings that have the corresponding bit\nin bits set. str1 corresponds to bit 0, str2 to bit 1, and so on. NULL\nvalues in str1, str2, ... are not appended to the result.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT MAKE_SET(1,\'a\',\'b\',\'c\');\n        -> \'a\'\nmysql> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',\'world\');\n        -> \'hello,world\'\nmysql> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',NULL,\'world\');\n        -> \'hello\'\nmysql> SELECT MAKE_SET(0,\'a\',\'b\',\'c\');\n        -> \'\'\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html'),(507,'FIND_IN_SET',36,'Syntax:\nFIND_IN_SET(str,strlist)\n\nReturns a value in the range of 1 to N if the string str is in the\nstring list strlist consisting of N substrings. A string list is a\nstring composed of substrings separated by \",\" characters. If the first\nargument is a constant string and the second is a column of type SET,\nthe FIND_IN_SET() function is optimized to use bit arithmetic. Returns\n0 if str is not in strlist or if strlist is the empty string. Returns\nNULL if either argument is NULL. This function does not work properly\nif the first argument contains a comma (\",\") character.\n\nURL: http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\n\n','mysql> SELECT FIND_IN_SET(\'b\',\'a,b,c,d\');\n        -> 2\n','http://dev.mysql.com/doc/refman/5.5/en/string-functions.html');
/*!40000 ALTER TABLE `help_topic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `host`
--

DROP TABLE IF EXISTS `host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `host` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`Db`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Host privileges;  Merged with database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `host`
--

LOCK TABLES `host` WRITE;
/*!40000 ALTER TABLE `host` DISABLE KEYS */;
/*!40000 ALTER TABLE `host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `innodb_index_stats`
--

DROP TABLE IF EXISTS `innodb_index_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `innodb_index_stats` (
  `database_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `index_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `stat_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `stat_value` bigint(20) unsigned NOT NULL,
  `sample_size` bigint(20) unsigned DEFAULT NULL,
  `stat_description` varchar(1024) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`database_name`,`table_name`,`index_name`,`stat_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin STATS_PERSISTENT=0;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `innodb_index_stats`
--

LOCK TABLES `innodb_index_stats` WRITE;
/*!40000 ALTER TABLE `innodb_index_stats` DISABLE KEYS */;
INSERT INTO `innodb_index_stats` VALUES ('chess_dwh','dim_opening_closure','PRIMARY','2013-02-14 22:15:23','n_diff_pfx01',2013,24,'opening_key_parent'),('chess_dwh','dim_opening_closure','PRIMARY','2013-02-14 22:15:23','n_diff_pfx02',15126,24,'opening_key_parent,opening_key'),('chess_dwh','dim_opening_closure','PRIMARY','2013-02-14 22:15:23','n_leaf_pages',24,NULL,'Number of leaf pages in the index'),('chess_dwh','dim_opening_closure','PRIMARY','2013-02-14 22:15:23','size',25,NULL,'Number of pages in the index'),('chess_dwh','dim_opening_closure','opening_key','2013-02-14 22:15:23','n_diff_pfx01',2013,13,'opening_key'),('chess_dwh','dim_opening_closure','opening_key','2013-02-14 22:15:23','n_diff_pfx02',15126,13,'opening_key,opening_key_parent'),('chess_dwh','dim_opening_closure','opening_key','2013-02-14 22:15:23','n_leaf_pages',13,NULL,'Number of leaf pages in the index'),('chess_dwh','dim_opening_closure','opening_key','2013-02-14 22:15:23','size',14,NULL,'Number of pages in the index'),('common_schema','_known_thread_states','PRIMARY','2013-02-14 22:16:10','n_diff_pfx01',19,1,'state'),('common_schema','_known_thread_states','PRIMARY','2013-02-14 22:16:10','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('common_schema','_known_thread_states','PRIMARY','2013-02-14 22:16:10','size',1,NULL,'Number of pages in the index'),('common_schema','_known_thread_states','state_type','2013-02-14 22:16:10','n_diff_pfx01',2,1,'state_type'),('common_schema','_known_thread_states','state_type','2013-02-14 22:16:10','n_diff_pfx02',19,1,'state_type,state'),('common_schema','_known_thread_states','state_type','2013-02-14 22:16:10','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('common_schema','_known_thread_states','state_type','2013-02-14 22:16:10','size',1,NULL,'Number of pages in the index'),('common_schema','_named_scripts','PRIMARY','2013-02-14 22:15:47','n_diff_pfx01',2,1,'script_name'),('common_schema','_named_scripts','PRIMARY','2013-02-14 22:15:47','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('common_schema','_named_scripts','PRIMARY','2013-02-14 22:15:47','size',1,NULL,'Number of pages in the index'),('common_schema','_script_statements','PRIMARY','2013-02-14 22:15:52','n_diff_pfx01',48,1,'statement'),('common_schema','_script_statements','PRIMARY','2013-02-14 22:15:52','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('common_schema','_script_statements','PRIMARY','2013-02-14 22:15:52','size',1,NULL,'Number of pages in the index'),('common_schema','benford_values','PRIMARY','2013-02-14 22:15:53','n_diff_pfx01',90,1,'leading_digits'),('common_schema','benford_values','PRIMARY','2013-02-14 22:15:53','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('common_schema','benford_values','PRIMARY','2013-02-14 22:15:53','size',1,NULL,'Number of pages in the index'),('common_schema','help_content','PRIMARY','2013-02-14 22:16:04','n_diff_pfx01',44,10,'topic'),('common_schema','help_content','PRIMARY','2013-02-14 22:16:04','n_leaf_pages',15,NULL,'Number of leaf pages in the index'),('common_schema','help_content','PRIMARY','2013-02-14 22:16:04','size',16,NULL,'Number of pages in the index'),('common_schema','metadata','PRIMARY','2013-02-14 22:16:07','n_diff_pfx01',17,1,'attribute_name'),('common_schema','metadata','PRIMARY','2013-02-14 22:16:07','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('common_schema','metadata','PRIMARY','2013-02-14 22:16:07','size',1,NULL,'Number of pages in the index'),('common_schema','numbers','PRIMARY','2013-02-14 22:16:09','n_diff_pfx01',4096,7,'n'),('common_schema','numbers','PRIMARY','2013-02-14 22:16:09','n_leaf_pages',7,NULL,'Number of leaf pages in the index'),('common_schema','numbers','PRIMARY','2013-02-14 22:16:09','size',8,NULL,'Number of pages in the index'),('hibernate','AUTHORITIES','PRIMARY','2013-02-14 22:16:11','n_diff_pfx01',8,1,'AUTHORITY'),('hibernate','AUTHORITIES','PRIMARY','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','AUTHORITIES','PRIMARY','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','BDPARAMS','FK61733C48FA34BFDC','2013-02-14 22:16:08','n_diff_pfx01',0,1,'ITEMID'),('hibernate','BDPARAMS','FK61733C48FA34BFDC','2013-02-14 22:16:08','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','BDPARAMS','FK61733C48FA34BFDC','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','BDPARAMS','FK61733C48FA34BFDC','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','BDPARAMS','PRIMARY','2013-02-14 22:16:08','n_diff_pfx01',0,1,'ITEMID'),('hibernate','BDPARAMS','PRIMARY','2013-02-14 22:16:08','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','BDPARAMS','PRIMARY','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','BDPARAMS','PRIMARY','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','BGCONTENTID','PRIMARY','2013-02-14 22:16:08','n_diff_pfx01',0,1,'BGCONTID'),('hibernate','BGCONTENTID','PRIMARY','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','BGCONTENTID','PRIMARY','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','COMPONENTS','PRIMARY','2013-02-14 22:16:08','n_diff_pfx01',0,1,'hbm_id'),('hibernate','COMPONENTS','PRIMARY','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','COMPONENTS','PRIMARY','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','CONTENTITEM','FK692B5EEC44F32395','2013-02-14 22:16:08','n_diff_pfx01',0,1,'parent_id'),('hibernate','CONTENTITEM','FK692B5EEC44F32395','2013-02-14 22:16:08','n_diff_pfx02',0,1,'parent_id,CONTITEMID'),('hibernate','CONTENTITEM','FK692B5EEC44F32395','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTENTITEM','FK692B5EEC44F32395','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','CONTENTITEM','PATH','2013-02-14 22:16:08','n_diff_pfx01',0,1,'PATH'),('hibernate','CONTENTITEM','PATH','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTENTITEM','PATH','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','CONTENTITEM','PRIMARY','2013-02-14 22:16:08','n_diff_pfx01',0,1,'CONTITEMID'),('hibernate','CONTENTITEM','PRIMARY','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTENTITEM','PRIMARY','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','CONTENTLOCATION','DIRPATH','2013-02-14 22:16:08','n_diff_pfx01',0,1,'DIRPATH'),('hibernate','CONTENTLOCATION','DIRPATH','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTENTLOCATION','DIRPATH','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','CONTENTLOCATION','PRIMARY','2013-02-14 22:16:08','n_diff_pfx01',0,1,'CONTENTID'),('hibernate','CONTENTLOCATION','PRIMARY','2013-02-14 22:16:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTENTLOCATION','PRIMARY','2013-02-14 22:16:08','size',1,NULL,'Number of pages in the index'),('hibernate','CONTITEMFILE','FK7FC3F44164D906F3','2013-02-14 22:16:09','n_diff_pfx01',0,1,'parent_id'),('hibernate','CONTITEMFILE','FK7FC3F44164D906F3','2013-02-14 22:16:09','n_diff_pfx02',0,1,'parent_id,CONTIFILEID'),('hibernate','CONTITEMFILE','FK7FC3F44164D906F3','2013-02-14 22:16:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTITEMFILE','FK7FC3F44164D906F3','2013-02-14 22:16:09','size',1,NULL,'Number of pages in the index'),('hibernate','CONTITEMFILE','PRIMARY','2013-02-14 22:16:09','n_diff_pfx01',0,1,'CONTIFILEID'),('hibernate','CONTITEMFILE','PRIMARY','2013-02-14 22:16:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CONTITEMFILE','PRIMARY','2013-02-14 22:16:09','size',1,NULL,'Number of pages in the index'),('hibernate','CPLXPARAMS','FKD6D6E97FFA34BFDC','2013-02-14 22:16:09','n_diff_pfx01',0,1,'ITEMID'),('hibernate','CPLXPARAMS','FKD6D6E97FFA34BFDC','2013-02-14 22:16:09','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','CPLXPARAMS','FKD6D6E97FFA34BFDC','2013-02-14 22:16:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CPLXPARAMS','FKD6D6E97FFA34BFDC','2013-02-14 22:16:09','size',1,NULL,'Number of pages in the index'),('hibernate','CPLXPARAMS','PRIMARY','2013-02-14 22:16:09','n_diff_pfx01',0,1,'ITEMID'),('hibernate','CPLXPARAMS','PRIMARY','2013-02-14 22:16:09','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','CPLXPARAMS','PRIMARY','2013-02-14 22:16:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','CPLXPARAMS','PRIMARY','2013-02-14 22:16:09','size',1,NULL,'Number of pages in the index'),('hibernate','DATASOURCE','PRIMARY','2013-02-14 22:16:12','n_diff_pfx01',3,1,'NAME'),('hibernate','DATASOURCE','PRIMARY','2013-02-14 22:16:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','DATASOURCE','PRIMARY','2013-02-14 22:16:12','size',1,NULL,'Number of pages in the index'),('hibernate','DTPARAMS','FK7F994A16FA34BFDC','2013-02-14 22:16:09','n_diff_pfx01',0,1,'ITEMID'),('hibernate','DTPARAMS','FK7F994A16FA34BFDC','2013-02-14 22:16:09','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','DTPARAMS','FK7F994A16FA34BFDC','2013-02-14 22:16:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','DTPARAMS','FK7F994A16FA34BFDC','2013-02-14 22:16:09','size',1,NULL,'Number of pages in the index'),('hibernate','DTPARAMS','PRIMARY','2013-02-14 22:16:09','n_diff_pfx01',0,1,'ITEMID'),('hibernate','DTPARAMS','PRIMARY','2013-02-14 22:16:09','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','DTPARAMS','PRIMARY','2013-02-14 22:16:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','DTPARAMS','PRIMARY','2013-02-14 22:16:09','size',1,NULL,'Number of pages in the index'),('hibernate','GRANTED_AUTHORITIES','FK7471775D41B6DA97','2013-02-14 22:16:18','n_diff_pfx01',7,1,'AUTHORITY'),('hibernate','GRANTED_AUTHORITIES','FK7471775D41B6DA97','2013-02-14 22:16:18','n_diff_pfx02',13,1,'AUTHORITY,USERNAME'),('hibernate','GRANTED_AUTHORITIES','FK7471775D41B6DA97','2013-02-14 22:16:18','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','GRANTED_AUTHORITIES','FK7471775D41B6DA97','2013-02-14 22:16:18','size',1,NULL,'Number of pages in the index'),('hibernate','GRANTED_AUTHORITIES','FK7471775DD9EDC77F','2013-02-14 22:16:18','n_diff_pfx01',5,1,'USERNAME'),('hibernate','GRANTED_AUTHORITIES','FK7471775DD9EDC77F','2013-02-14 22:16:18','n_diff_pfx02',13,1,'USERNAME,AUTHORITY'),('hibernate','GRANTED_AUTHORITIES','FK7471775DD9EDC77F','2013-02-14 22:16:18','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','GRANTED_AUTHORITIES','FK7471775DD9EDC77F','2013-02-14 22:16:18','size',1,NULL,'Number of pages in the index'),('hibernate','GRANTED_AUTHORITIES','PRIMARY','2013-02-14 22:16:18','n_diff_pfx01',5,1,'USERNAME'),('hibernate','GRANTED_AUTHORITIES','PRIMARY','2013-02-14 22:16:18','n_diff_pfx02',13,1,'USERNAME,AUTHORITY'),('hibernate','GRANTED_AUTHORITIES','PRIMARY','2013-02-14 22:16:18','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','GRANTED_AUTHORITIES','PRIMARY','2013-02-14 22:16:18','size',1,NULL,'Number of pages in the index'),('hibernate','INSTANCES','PRIMARY','2013-02-14 22:16:10','n_diff_pfx01',0,1,'hbm_id'),('hibernate','INSTANCES','PRIMARY','2013-02-14 22:16:10','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','INSTANCES','PRIMARY','2013-02-14 22:16:10','size',1,NULL,'Number of pages in the index'),('hibernate','INSTANCE_END','PRIMARY','2013-02-14 22:16:10','n_diff_pfx01',0,1,'hbm_id'),('hibernate','INSTANCE_END','PRIMARY','2013-02-14 22:16:10','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','INSTANCE_END','PRIMARY','2013-02-14 22:16:10','size',1,NULL,'Number of pages in the index'),('hibernate','LNGPARAMS','FKE304FCCBFA34BFDC','2013-02-14 22:16:11','n_diff_pfx01',0,1,'ITEMID'),('hibernate','LNGPARAMS','FKE304FCCBFA34BFDC','2013-02-14 22:16:11','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','LNGPARAMS','FKE304FCCBFA34BFDC','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','LNGPARAMS','FKE304FCCBFA34BFDC','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','LNGPARAMS','PRIMARY','2013-02-14 22:16:11','n_diff_pfx01',0,1,'ITEMID'),('hibernate','LNGPARAMS','PRIMARY','2013-02-14 22:16:11','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','LNGPARAMS','PRIMARY','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','LNGPARAMS','PRIMARY','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','LSPARAMS','FK89BC75CDFA34BFDC','2013-02-14 22:16:11','n_diff_pfx01',0,1,'ITEMID'),('hibernate','LSPARAMS','FK89BC75CDFA34BFDC','2013-02-14 22:16:11','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','LSPARAMS','FK89BC75CDFA34BFDC','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','LSPARAMS','FK89BC75CDFA34BFDC','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','LSPARAMS','PRIMARY','2013-02-14 22:16:11','n_diff_pfx01',0,1,'ITEMID'),('hibernate','LSPARAMS','PRIMARY','2013-02-14 22:16:11','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','LSPARAMS','PRIMARY','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','LSPARAMS','PRIMARY','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','PARAMTYPESMAP','FKD3EDA1B0FA34BFDC','2013-02-14 22:16:11','n_diff_pfx01',0,1,'ITEMID'),('hibernate','PARAMTYPESMAP','FKD3EDA1B0FA34BFDC','2013-02-14 22:16:11','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','PARAMTYPESMAP','FKD3EDA1B0FA34BFDC','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PARAMTYPESMAP','FKD3EDA1B0FA34BFDC','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','PARAMTYPESMAP','PRIMARY','2013-02-14 22:16:11','n_diff_pfx01',0,1,'ITEMID'),('hibernate','PARAMTYPESMAP','PRIMARY','2013-02-14 22:16:11','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','PARAMTYPESMAP','PRIMARY','2013-02-14 22:16:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PARAMTYPESMAP','PRIMARY','2013-02-14 22:16:11','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_ACLS_LIST','FKB65646C2B23C5D30','2013-02-14 22:16:24','n_diff_pfx01',112,2,'ACL_ID'),('hibernate','PRO_ACLS_LIST','FKB65646C2B23C5D30','2013-02-14 22:16:24','n_diff_pfx02',439,2,'ACL_ID,ACL_POSITION'),('hibernate','PRO_ACLS_LIST','FKB65646C2B23C5D30','2013-02-14 22:16:24','n_leaf_pages',2,NULL,'Number of leaf pages in the index'),('hibernate','PRO_ACLS_LIST','FKB65646C2B23C5D30','2013-02-14 22:16:24','size',3,NULL,'Number of pages in the index'),('hibernate','PRO_ACLS_LIST','PRIMARY','2013-02-14 22:16:24','n_diff_pfx01',112,3,'ACL_ID'),('hibernate','PRO_ACLS_LIST','PRIMARY','2013-02-14 22:16:24','n_diff_pfx02',439,3,'ACL_ID,ACL_POSITION'),('hibernate','PRO_ACLS_LIST','PRIMARY','2013-02-14 22:16:24','n_leaf_pages',3,NULL,'Number of leaf pages in the index'),('hibernate','PRO_ACLS_LIST','PRIMARY','2013-02-14 22:16:24','size',4,NULL,'Number of pages in the index'),('hibernate','PRO_AUDIT','PRIMARY','2013-02-14 22:16:24','n_diff_pfx01',60248,20,'audit_id'),('hibernate','PRO_AUDIT','PRIMARY','2013-02-14 22:16:24','n_leaf_pages',845,NULL,'Number of leaf pages in the index'),('hibernate','PRO_AUDIT','PRIMARY','2013-02-14 22:16:24','size',867,NULL,'Number of pages in the index'),('hibernate','PRO_AUDIT_TRANSFORM_TRACKER','PRIMARY','2013-02-14 22:16:17','n_diff_pfx01',0,1,'tracker_id'),('hibernate','PRO_AUDIT_TRANSFORM_TRACKER','PRIMARY','2013-02-14 22:16:17','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_AUDIT_TRANSFORM_TRACKER','PRIMARY','2013-02-14 22:16:17','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_FILES','FK94A87E2569FABF5E','2013-02-14 22:16:34','n_diff_pfx01',109,13,'CHILD_ID'),('hibernate','PRO_FILES','FK94A87E2569FABF5E','2013-02-14 22:16:34','n_diff_pfx02',1378,13,'CHILD_ID,FILE_ID'),('hibernate','PRO_FILES','FK94A87E2569FABF5E','2013-02-14 22:16:34','n_leaf_pages',13,NULL,'Number of leaf pages in the index'),('hibernate','PRO_FILES','FK94A87E2569FABF5E','2013-02-14 22:16:34','size',14,NULL,'Number of pages in the index'),('hibernate','PRO_FILES','FK94A87E25CBBBB0EA','2013-02-14 22:16:34','n_diff_pfx01',109,13,'parent'),('hibernate','PRO_FILES','FK94A87E25CBBBB0EA','2013-02-14 22:16:34','n_diff_pfx02',1378,13,'parent,FILE_ID'),('hibernate','PRO_FILES','FK94A87E25CBBBB0EA','2013-02-14 22:16:34','n_leaf_pages',13,NULL,'Number of leaf pages in the index'),('hibernate','PRO_FILES','FK94A87E25CBBBB0EA','2013-02-14 22:16:34','size',14,NULL,'Number of pages in the index'),('hibernate','PRO_FILES','PRIMARY','2013-02-14 22:16:34','n_diff_pfx01',3369,20,'FILE_ID'),('hibernate','PRO_FILES','PRIMARY','2013-02-14 22:16:34','n_leaf_pages',468,NULL,'Number of leaf pages in the index'),('hibernate','PRO_FILES','PRIMARY','2013-02-14 22:16:34','size',545,NULL,'Number of pages in the index'),('hibernate','PRO_FILES','fullPath','2013-02-14 22:16:34','n_diff_pfx01',1378,16,'fullPath'),('hibernate','PRO_FILES','fullPath','2013-02-14 22:16:34','n_leaf_pages',16,NULL,'Number of leaf pages in the index'),('hibernate','PRO_FILES','fullPath','2013-02-14 22:16:34','size',17,NULL,'Number of pages in the index'),('hibernate','PRO_SCHEDULE','PRIMARY','2013-02-14 22:16:21','n_diff_pfx01',0,1,'SCHEDULEID'),('hibernate','PRO_SCHEDULE','PRIMARY','2013-02-14 22:16:21','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SCHEDULE','PRIMARY','2013-02-14 22:16:21','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONTENT','PRIMARY','2013-02-14 22:16:22','n_diff_pfx01',0,1,'SUBCONTID'),('hibernate','PRO_SUBCONTENT','PRIMARY','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONTENT','PRIMARY','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONTENT','SUBCONTACTREF','2013-02-14 22:16:22','n_diff_pfx01',0,1,'SUBCONTACTREF'),('hibernate','PRO_SUBCONTENT','SUBCONTACTREF','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONTENT','SUBCONTACTREF','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONTPARMS','FKF3CE4C47846761A','2013-02-14 22:16:22','n_diff_pfx01',0,1,'ITEMID'),('hibernate','PRO_SUBCONTPARMS','FKF3CE4C47846761A','2013-02-14 22:16:22','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','PRO_SUBCONTPARMS','FKF3CE4C47846761A','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONTPARMS','FKF3CE4C47846761A','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONTPARMS','PRIMARY','2013-02-14 22:16:22','n_diff_pfx01',0,1,'ITEMID'),('hibernate','PRO_SUBCONTPARMS','PRIMARY','2013-02-14 22:16:22','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','PRO_SUBCONTPARMS','PRIMARY','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONTPARMS','PRIMARY','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD62593BC9E','2013-02-14 22:16:22','n_diff_pfx01',0,1,'SCHEDULEID'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD62593BC9E','2013-02-14 22:16:22','n_diff_pfx02',0,1,'SCHEDULEID,SCHEDID'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD62593BC9E','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD62593BC9E','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD69E226721','2013-02-14 22:16:22','n_diff_pfx01',0,1,'elt'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD69E226721','2013-02-14 22:16:22','n_diff_pfx02',0,1,'elt,SCHEDULEID'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD69E226721','2013-02-14 22:16:22','n_diff_pfx03',0,1,'elt,SCHEDULEID,SCHEDID'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD69E226721','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONT_SCHEDLIST','FKF0D3FBD69E226721','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBCONT_SCHEDLIST','PRIMARY','2013-02-14 22:16:22','n_diff_pfx01',0,1,'SCHEDULEID'),('hibernate','PRO_SUBCONT_SCHEDLIST','PRIMARY','2013-02-14 22:16:22','n_diff_pfx02',0,1,'SCHEDULEID,SCHEDID'),('hibernate','PRO_SUBCONT_SCHEDLIST','PRIMARY','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBCONT_SCHEDLIST','PRIMARY','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBSCRIBE','FK5E7511F89D8AC376','2013-02-14 22:16:22','n_diff_pfx01',0,1,'SUBSCR_CONTID'),('hibernate','PRO_SUBSCRIBE','FK5E7511F89D8AC376','2013-02-14 22:16:22','n_diff_pfx02',0,1,'SUBSCR_CONTID,SUBSCRID'),('hibernate','PRO_SUBSCRIBE','FK5E7511F89D8AC376','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBSCRIBE','FK5E7511F89D8AC376','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBSCRIBE','PRIMARY','2013-02-14 22:16:22','n_diff_pfx01',0,1,'SUBSCRID'),('hibernate','PRO_SUBSCRIBE','PRIMARY','2013-02-14 22:16:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBSCRIBE','PRIMARY','2013-02-14 22:16:22','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBSCRPARMS','FK95DADE9355DC7DE8','2013-02-14 22:16:23','n_diff_pfx01',0,1,'ITEMID'),('hibernate','PRO_SUBSCRPARMS','FK95DADE9355DC7DE8','2013-02-14 22:16:23','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','PRO_SUBSCRPARMS','FK95DADE9355DC7DE8','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBSCRPARMS','FK95DADE9355DC7DE8','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBSCRPARMS','PRIMARY','2013-02-14 22:16:23','n_diff_pfx01',0,1,'ITEMID'),('hibernate','PRO_SUBSCRPARMS','PRIMARY','2013-02-14 22:16:23','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','PRO_SUBSCRPARMS','PRIMARY','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBSCRPARMS','PRIMARY','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B7329C46C','2013-02-14 22:16:23','n_diff_pfx01',0,1,'SCHEDULEID'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B7329C46C','2013-02-14 22:16:23','n_diff_pfx02',0,1,'SCHEDULEID,SCHEDID'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B7329C46C','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B7329C46C','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B9E226721','2013-02-14 22:16:23','n_diff_pfx01',0,1,'elt'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B9E226721','2013-02-14 22:16:23','n_diff_pfx02',0,1,'elt,SCHEDULEID'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B9E226721','2013-02-14 22:16:23','n_diff_pfx03',0,1,'elt,SCHEDULEID,SCHEDID'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B9E226721','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBS_SCHEDLIST','FK2A8C749B9E226721','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','PRO_SUBS_SCHEDLIST','PRIMARY','2013-02-14 22:16:23','n_diff_pfx01',0,1,'SCHEDULEID'),('hibernate','PRO_SUBS_SCHEDLIST','PRIMARY','2013-02-14 22:16:23','n_diff_pfx02',0,1,'SCHEDULEID,SCHEDID'),('hibernate','PRO_SUBS_SCHEDLIST','PRIMARY','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','PRO_SUBS_SCHEDLIST','PRIMARY','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','RTELEMENT','PRIMARY','2013-02-14 22:16:23','n_diff_pfx01',0,1,'INSTANCEID'),('hibernate','RTELEMENT','PRIMARY','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','RTELEMENT','PRIMARY','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','SESSIONS','PRIMARY','2013-02-14 22:16:23','n_diff_pfx01',0,1,'hbm_id'),('hibernate','SESSIONS','PRIMARY','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','SESSIONS','PRIMARY','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','SSPARAMS','FK60E4AFE6FA34BFDC','2013-02-14 22:16:23','n_diff_pfx01',0,1,'ITEMID'),('hibernate','SSPARAMS','FK60E4AFE6FA34BFDC','2013-02-14 22:16:23','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','SSPARAMS','FK60E4AFE6FA34BFDC','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','SSPARAMS','FK60E4AFE6FA34BFDC','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','SSPARAMS','PRIMARY','2013-02-14 22:16:23','n_diff_pfx01',0,1,'ITEMID'),('hibernate','SSPARAMS','PRIMARY','2013-02-14 22:16:23','n_diff_pfx02',0,1,'ITEMID,PARAMKEY'),('hibernate','SSPARAMS','PRIMARY','2013-02-14 22:16:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','SSPARAMS','PRIMARY','2013-02-14 22:16:23','size',1,NULL,'Number of pages in the index'),('hibernate','USERS','PRIMARY','2013-02-14 22:16:44','n_diff_pfx01',5,1,'USERNAME'),('hibernate','USERS','PRIMARY','2013-02-14 22:16:44','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','USERS','PRIMARY','2013-02-14 22:16:44','size',1,NULL,'Number of pages in the index'),('hibernate','USER_SETTINGS','PRIMARY','2013-02-14 22:16:54','n_diff_pfx01',3,1,'USER_SETTINGS_ID'),('hibernate','USER_SETTINGS','PRIMARY','2013-02-14 22:16:54','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','USER_SETTINGS','PRIMARY','2013-02-14 22:16:54','size',1,NULL,'Number of pages in the index'),('hibernate','cdf_storage','PRIMARY','2013-02-14 22:16:24','n_diff_pfx01',0,1,'storageid'),('hibernate','cdf_storage','PRIMARY','2013-02-14 22:16:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('hibernate','cdf_storage','PRIMARY','2013-02-14 22:16:24','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_BLOB_TRIGGERS','PRIMARY','2013-02-14 22:21:21','n_diff_pfx01',0,1,'TRIGGER_NAME'),('quartz','QRTZ_BLOB_TRIGGERS','PRIMARY','2013-02-14 22:21:21','n_diff_pfx02',0,1,'TRIGGER_NAME,TRIGGER_GROUP'),('quartz','QRTZ_BLOB_TRIGGERS','PRIMARY','2013-02-14 22:21:21','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_BLOB_TRIGGERS','PRIMARY','2013-02-14 22:21:21','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_CALENDARS','PRIMARY','2013-02-14 22:21:22','n_diff_pfx01',0,1,'CALENDAR_NAME'),('quartz','QRTZ_CALENDARS','PRIMARY','2013-02-14 22:21:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_CALENDARS','PRIMARY','2013-02-14 22:21:22','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_CRON_TRIGGERS','PRIMARY','2013-02-14 22:21:22','n_diff_pfx01',0,1,'TRIGGER_NAME'),('quartz','QRTZ_CRON_TRIGGERS','PRIMARY','2013-02-14 22:21:22','n_diff_pfx02',0,1,'TRIGGER_NAME,TRIGGER_GROUP'),('quartz','QRTZ_CRON_TRIGGERS','PRIMARY','2013-02-14 22:21:22','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_CRON_TRIGGERS','PRIMARY','2013-02-14 22:21:22','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_FIRED_TRIGGERS','PRIMARY','2013-02-14 22:21:23','n_diff_pfx01',0,1,'ENTRY_ID'),('quartz','QRTZ_FIRED_TRIGGERS','PRIMARY','2013-02-14 22:21:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_FIRED_TRIGGERS','PRIMARY','2013-02-14 22:21:23','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_JOB_DETAILS','PRIMARY','2013-02-14 22:21:23','n_diff_pfx01',0,1,'JOB_NAME'),('quartz','QRTZ_JOB_DETAILS','PRIMARY','2013-02-14 22:21:23','n_diff_pfx02',0,1,'JOB_NAME,JOB_GROUP'),('quartz','QRTZ_JOB_DETAILS','PRIMARY','2013-02-14 22:21:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_JOB_DETAILS','PRIMARY','2013-02-14 22:21:23','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_JOB_LISTENERS','PRIMARY','2013-02-14 22:21:23','n_diff_pfx01',0,1,'JOB_NAME'),('quartz','QRTZ_JOB_LISTENERS','PRIMARY','2013-02-14 22:21:23','n_diff_pfx02',0,1,'JOB_NAME,JOB_GROUP'),('quartz','QRTZ_JOB_LISTENERS','PRIMARY','2013-02-14 22:21:23','n_diff_pfx03',0,1,'JOB_NAME,JOB_GROUP,JOB_LISTENER'),('quartz','QRTZ_JOB_LISTENERS','PRIMARY','2013-02-14 22:21:23','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_JOB_LISTENERS','PRIMARY','2013-02-14 22:21:23','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_LOCKS','PRIMARY','2013-02-14 22:21:43','n_diff_pfx01',5,1,'LOCK_NAME'),('quartz','QRTZ_LOCKS','PRIMARY','2013-02-14 22:21:43','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_LOCKS','PRIMARY','2013-02-14 22:21:43','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_PAUSED_TRIGGER_GRPS','PRIMARY','2013-02-14 22:21:24','n_diff_pfx01',0,1,'TRIGGER_GROUP'),('quartz','QRTZ_PAUSED_TRIGGER_GRPS','PRIMARY','2013-02-14 22:21:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_PAUSED_TRIGGER_GRPS','PRIMARY','2013-02-14 22:21:24','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_SCHEDULER_STATE','PRIMARY','2013-02-14 22:21:24','n_diff_pfx01',0,1,'INSTANCE_NAME'),('quartz','QRTZ_SCHEDULER_STATE','PRIMARY','2013-02-14 22:21:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_SCHEDULER_STATE','PRIMARY','2013-02-14 22:21:24','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_SIMPLE_TRIGGERS','PRIMARY','2013-02-14 22:21:24','n_diff_pfx01',0,1,'TRIGGER_NAME'),('quartz','QRTZ_SIMPLE_TRIGGERS','PRIMARY','2013-02-14 22:21:24','n_diff_pfx02',0,1,'TRIGGER_NAME,TRIGGER_GROUP'),('quartz','QRTZ_SIMPLE_TRIGGERS','PRIMARY','2013-02-14 22:21:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_SIMPLE_TRIGGERS','PRIMARY','2013-02-14 22:21:24','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_TRIGGERS','JOB_NAME','2013-02-14 22:21:24','n_diff_pfx01',0,1,'JOB_NAME'),('quartz','QRTZ_TRIGGERS','JOB_NAME','2013-02-14 22:21:24','n_diff_pfx02',0,1,'JOB_NAME,JOB_GROUP'),('quartz','QRTZ_TRIGGERS','JOB_NAME','2013-02-14 22:21:24','n_diff_pfx03',0,1,'JOB_NAME,JOB_GROUP,TRIGGER_NAME'),('quartz','QRTZ_TRIGGERS','JOB_NAME','2013-02-14 22:21:24','n_diff_pfx04',0,1,'JOB_NAME,JOB_GROUP,TRIGGER_NAME,TRIGGER_GROUP'),('quartz','QRTZ_TRIGGERS','JOB_NAME','2013-02-14 22:21:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_TRIGGERS','JOB_NAME','2013-02-14 22:21:24','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_TRIGGERS','PRIMARY','2013-02-14 22:21:24','n_diff_pfx01',0,1,'TRIGGER_NAME'),('quartz','QRTZ_TRIGGERS','PRIMARY','2013-02-14 22:21:24','n_diff_pfx02',0,1,'TRIGGER_NAME,TRIGGER_GROUP'),('quartz','QRTZ_TRIGGERS','PRIMARY','2013-02-14 22:21:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_TRIGGERS','PRIMARY','2013-02-14 22:21:24','size',1,NULL,'Number of pages in the index'),('quartz','QRTZ_TRIGGER_LISTENERS','PRIMARY','2013-02-14 22:21:25','n_diff_pfx01',0,1,'TRIGGER_NAME'),('quartz','QRTZ_TRIGGER_LISTENERS','PRIMARY','2013-02-14 22:21:25','n_diff_pfx02',0,1,'TRIGGER_NAME,TRIGGER_GROUP'),('quartz','QRTZ_TRIGGER_LISTENERS','PRIMARY','2013-02-14 22:21:25','n_diff_pfx03',0,1,'TRIGGER_NAME,TRIGGER_GROUP,TRIGGER_LISTENER'),('quartz','QRTZ_TRIGGER_LISTENERS','PRIMARY','2013-02-14 22:21:25','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('quartz','QRTZ_TRIGGER_LISTENERS','PRIMARY','2013-02-14 22:21:25','size',1,NULL,'Number of pages in the index'),('sakila','actor','PRIMARY','2013-02-14 22:21:26','n_diff_pfx01',200,1,'actor_id'),('sakila','actor','PRIMARY','2013-02-14 22:21:26','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','actor','PRIMARY','2013-02-14 22:21:26','size',1,NULL,'Number of pages in the index'),('sakila','actor','idx_actor_last_name','2013-02-14 22:21:26','n_diff_pfx01',121,1,'last_name'),('sakila','actor','idx_actor_last_name','2013-02-14 22:21:26','n_diff_pfx02',200,1,'last_name,actor_id'),('sakila','actor','idx_actor_last_name','2013-02-14 22:21:26','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','actor','idx_actor_last_name','2013-02-14 22:21:26','size',1,NULL,'Number of pages in the index'),('sakila','address','PRIMARY','2013-02-14 22:21:27','n_diff_pfx01',603,4,'address_id'),('sakila','address','PRIMARY','2013-02-14 22:21:27','n_leaf_pages',4,NULL,'Number of leaf pages in the index'),('sakila','address','PRIMARY','2013-02-14 22:21:27','size',5,NULL,'Number of pages in the index'),('sakila','address','idx_fk_city_id','2013-02-14 22:21:27','n_diff_pfx01',599,1,'city_id'),('sakila','address','idx_fk_city_id','2013-02-14 22:21:27','n_diff_pfx02',603,1,'city_id,address_id'),('sakila','address','idx_fk_city_id','2013-02-14 22:21:27','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','address','idx_fk_city_id','2013-02-14 22:21:27','size',1,NULL,'Number of pages in the index'),('sakila','category','PRIMARY','2013-02-14 22:21:27','n_diff_pfx01',16,1,'category_id'),('sakila','category','PRIMARY','2013-02-14 22:21:27','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','category','PRIMARY','2013-02-14 22:21:27','size',1,NULL,'Number of pages in the index'),('sakila','city','PRIMARY','2013-02-14 22:21:28','n_diff_pfx01',600,2,'city_id'),('sakila','city','PRIMARY','2013-02-14 22:21:28','n_leaf_pages',2,NULL,'Number of leaf pages in the index'),('sakila','city','PRIMARY','2013-02-14 22:21:28','size',3,NULL,'Number of pages in the index'),('sakila','city','idx_fk_country_id','2013-02-14 22:21:28','n_diff_pfx01',109,1,'country_id'),('sakila','city','idx_fk_country_id','2013-02-14 22:21:28','n_diff_pfx02',600,1,'country_id,city_id'),('sakila','city','idx_fk_country_id','2013-02-14 22:21:28','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','city','idx_fk_country_id','2013-02-14 22:21:28','size',1,NULL,'Number of pages in the index'),('sakila','country','PRIMARY','2013-02-14 22:21:29','n_diff_pfx01',109,1,'country_id'),('sakila','country','PRIMARY','2013-02-14 22:21:29','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','country','PRIMARY','2013-02-14 22:21:29','size',1,NULL,'Number of pages in the index'),('sakila','customer','PRIMARY','2013-02-14 22:21:31','n_diff_pfx01',599,4,'customer_id'),('sakila','customer','PRIMARY','2013-02-14 22:21:31','n_leaf_pages',4,NULL,'Number of leaf pages in the index'),('sakila','customer','PRIMARY','2013-02-14 22:21:31','size',5,NULL,'Number of pages in the index'),('sakila','customer','idx_fk_address_id','2013-02-14 22:21:31','n_diff_pfx01',599,1,'address_id'),('sakila','customer','idx_fk_address_id','2013-02-14 22:21:31','n_diff_pfx02',599,1,'address_id,customer_id'),('sakila','customer','idx_fk_address_id','2013-02-14 22:21:31','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','customer','idx_fk_address_id','2013-02-14 22:21:31','size',1,NULL,'Number of pages in the index'),('sakila','customer','idx_fk_store_id','2013-02-14 22:21:31','n_diff_pfx01',2,1,'store_id'),('sakila','customer','idx_fk_store_id','2013-02-14 22:21:31','n_diff_pfx02',599,1,'store_id,customer_id'),('sakila','customer','idx_fk_store_id','2013-02-14 22:21:31','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','customer','idx_fk_store_id','2013-02-14 22:21:31','size',1,NULL,'Number of pages in the index'),('sakila','customer','idx_last_name','2013-02-14 22:21:31','n_diff_pfx01',599,1,'last_name'),('sakila','customer','idx_last_name','2013-02-14 22:21:31','n_diff_pfx02',599,1,'last_name,customer_id'),('sakila','customer','idx_last_name','2013-02-14 22:21:31','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','customer','idx_last_name','2013-02-14 22:21:31','size',1,NULL,'Number of pages in the index'),('sakila','film','PRIMARY','2013-02-14 22:21:33','n_diff_pfx01',1000,11,'film_id'),('sakila','film','PRIMARY','2013-02-14 22:21:33','n_leaf_pages',11,NULL,'Number of leaf pages in the index'),('sakila','film','PRIMARY','2013-02-14 22:21:33','size',12,NULL,'Number of pages in the index'),('sakila','film','idx_fk_language_id','2013-02-14 22:21:33','n_diff_pfx01',1,1,'language_id'),('sakila','film','idx_fk_language_id','2013-02-14 22:21:33','n_diff_pfx02',1000,1,'language_id,film_id'),('sakila','film','idx_fk_language_id','2013-02-14 22:21:33','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','film','idx_fk_language_id','2013-02-14 22:21:33','size',1,NULL,'Number of pages in the index'),('sakila','film','idx_fk_original_language_id','2013-02-14 22:21:33','n_diff_pfx01',1,1,'original_language_id'),('sakila','film','idx_fk_original_language_id','2013-02-14 22:21:33','n_diff_pfx02',1000,1,'original_language_id,film_id'),('sakila','film','idx_fk_original_language_id','2013-02-14 22:21:33','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','film','idx_fk_original_language_id','2013-02-14 22:21:33','size',1,NULL,'Number of pages in the index'),('sakila','film','idx_title','2013-02-14 22:21:33','n_diff_pfx01',1000,2,'title'),('sakila','film','idx_title','2013-02-14 22:21:33','n_diff_pfx02',1000,2,'title,film_id'),('sakila','film','idx_title','2013-02-14 22:21:33','n_leaf_pages',2,NULL,'Number of leaf pages in the index'),('sakila','film','idx_title','2013-02-14 22:21:33','size',3,NULL,'Number of pages in the index'),('sakila','film_actor','PRIMARY','2013-02-14 22:21:34','n_diff_pfx01',200,11,'actor_id'),('sakila','film_actor','PRIMARY','2013-02-14 22:21:34','n_diff_pfx02',5462,11,'actor_id,film_id'),('sakila','film_actor','PRIMARY','2013-02-14 22:21:34','n_leaf_pages',11,NULL,'Number of leaf pages in the index'),('sakila','film_actor','PRIMARY','2013-02-14 22:21:34','size',12,NULL,'Number of pages in the index'),('sakila','film_actor','idx_fk_film_id','2013-02-14 22:21:34','n_diff_pfx01',997,4,'film_id'),('sakila','film_actor','idx_fk_film_id','2013-02-14 22:21:34','n_diff_pfx02',5462,4,'film_id,actor_id'),('sakila','film_actor','idx_fk_film_id','2013-02-14 22:21:34','n_leaf_pages',4,NULL,'Number of leaf pages in the index'),('sakila','film_actor','idx_fk_film_id','2013-02-14 22:21:34','size',5,NULL,'Number of pages in the index'),('sakila','film_category','PRIMARY','2013-02-14 22:21:39','n_diff_pfx01',1000,3,'film_id'),('sakila','film_category','PRIMARY','2013-02-14 22:21:39','n_diff_pfx02',1000,3,'film_id,category_id'),('sakila','film_category','PRIMARY','2013-02-14 22:21:39','n_leaf_pages',3,NULL,'Number of leaf pages in the index'),('sakila','film_category','PRIMARY','2013-02-14 22:21:39','size',4,NULL,'Number of pages in the index'),('sakila','film_category','fk_film_category_category','2013-02-14 22:21:39','n_diff_pfx01',16,1,'category_id'),('sakila','film_category','fk_film_category_category','2013-02-14 22:21:39','n_diff_pfx02',1000,1,'category_id,film_id'),('sakila','film_category','fk_film_category_category','2013-02-14 22:21:39','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','film_category','fk_film_category_category','2013-02-14 22:21:39','size',1,NULL,'Number of pages in the index'),('sakila','inventory','PRIMARY','2013-02-14 22:21:43','n_diff_pfx01',4581,10,'inventory_id'),('sakila','inventory','PRIMARY','2013-02-14 22:21:43','n_leaf_pages',10,NULL,'Number of leaf pages in the index'),('sakila','inventory','PRIMARY','2013-02-14 22:21:43','size',11,NULL,'Number of pages in the index'),('sakila','inventory','idx_fk_film_id','2013-02-14 22:21:43','n_diff_pfx01',958,4,'film_id'),('sakila','inventory','idx_fk_film_id','2013-02-14 22:21:43','n_diff_pfx02',4581,4,'film_id,inventory_id'),('sakila','inventory','idx_fk_film_id','2013-02-14 22:21:43','n_leaf_pages',4,NULL,'Number of leaf pages in the index'),('sakila','inventory','idx_fk_film_id','2013-02-14 22:21:43','size',5,NULL,'Number of pages in the index'),('sakila','inventory','idx_store_id_film_id','2013-02-14 22:21:43','n_diff_pfx01',2,6,'store_id'),('sakila','inventory','idx_store_id_film_id','2013-02-14 22:21:43','n_diff_pfx02',1521,6,'store_id,film_id'),('sakila','inventory','idx_store_id_film_id','2013-02-14 22:21:43','n_diff_pfx03',4581,6,'store_id,film_id,inventory_id'),('sakila','inventory','idx_store_id_film_id','2013-02-14 22:21:43','n_leaf_pages',6,NULL,'Number of leaf pages in the index'),('sakila','inventory','idx_store_id_film_id','2013-02-14 22:21:43','size',7,NULL,'Number of pages in the index'),('sakila','language','PRIMARY','2013-02-14 22:21:44','n_diff_pfx01',6,1,'language_id'),('sakila','language','PRIMARY','2013-02-14 22:21:44','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','language','PRIMARY','2013-02-14 22:21:44','size',1,NULL,'Number of pages in the index'),('sakila','payment','PRIMARY','2013-02-14 22:21:45','n_diff_pfx01',16086,20,'payment_id'),('sakila','payment','PRIMARY','2013-02-14 22:21:45','n_leaf_pages',44,NULL,'Number of leaf pages in the index'),('sakila','payment','PRIMARY','2013-02-14 22:21:45','size',97,NULL,'Number of pages in the index'),('sakila','payment','fk_payment_rental','2013-02-14 22:21:45','n_diff_pfx01',16045,16,'rental_id'),('sakila','payment','fk_payment_rental','2013-02-14 22:21:45','n_diff_pfx02',16049,16,'rental_id,payment_id'),('sakila','payment','fk_payment_rental','2013-02-14 22:21:45','n_leaf_pages',16,NULL,'Number of leaf pages in the index'),('sakila','payment','fk_payment_rental','2013-02-14 22:21:45','size',17,NULL,'Number of pages in the index'),('sakila','payment','idx_fk_customer_id','2013-02-14 22:21:45','n_diff_pfx01',599,10,'customer_id'),('sakila','payment','idx_fk_customer_id','2013-02-14 22:21:45','n_diff_pfx02',16049,10,'customer_id,payment_id'),('sakila','payment','idx_fk_customer_id','2013-02-14 22:21:45','n_leaf_pages',10,NULL,'Number of leaf pages in the index'),('sakila','payment','idx_fk_customer_id','2013-02-14 22:21:45','size',11,NULL,'Number of pages in the index'),('sakila','payment','idx_fk_staff_id','2013-02-14 22:21:45','n_diff_pfx01',2,10,'staff_id'),('sakila','payment','idx_fk_staff_id','2013-02-14 22:21:45','n_diff_pfx02',16049,10,'staff_id,payment_id'),('sakila','payment','idx_fk_staff_id','2013-02-14 22:21:45','n_leaf_pages',10,NULL,'Number of leaf pages in the index'),('sakila','payment','idx_fk_staff_id','2013-02-14 22:21:45','size',11,NULL,'Number of pages in the index'),('sakila','rental','PRIMARY','2013-02-14 22:21:46','n_diff_pfx01',16008,20,'rental_id'),('sakila','rental','PRIMARY','2013-02-14 22:21:46','n_leaf_pages',47,NULL,'Number of leaf pages in the index'),('sakila','rental','PRIMARY','2013-02-14 22:21:46','size',97,NULL,'Number of pages in the index'),('sakila','rental','idx_fk_customer_id','2013-02-14 22:21:46','n_diff_pfx01',599,16,'customer_id'),('sakila','rental','idx_fk_customer_id','2013-02-14 22:21:46','n_diff_pfx02',16044,16,'customer_id,rental_id'),('sakila','rental','idx_fk_customer_id','2013-02-14 22:21:46','n_leaf_pages',16,NULL,'Number of leaf pages in the index'),('sakila','rental','idx_fk_customer_id','2013-02-14 22:21:46','size',17,NULL,'Number of pages in the index'),('sakila','rental','idx_fk_inventory_id','2013-02-14 22:21:46','n_diff_pfx01',4580,16,'inventory_id'),('sakila','rental','idx_fk_inventory_id','2013-02-14 22:21:46','n_diff_pfx02',16044,16,'inventory_id,rental_id'),('sakila','rental','idx_fk_inventory_id','2013-02-14 22:21:46','n_leaf_pages',16,NULL,'Number of leaf pages in the index'),('sakila','rental','idx_fk_inventory_id','2013-02-14 22:21:46','size',17,NULL,'Number of pages in the index'),('sakila','rental','idx_fk_staff_id','2013-02-14 22:21:46','n_diff_pfx01',2,13,'staff_id'),('sakila','rental','idx_fk_staff_id','2013-02-14 22:21:46','n_diff_pfx02',16044,13,'staff_id,rental_id'),('sakila','rental','idx_fk_staff_id','2013-02-14 22:21:46','n_leaf_pages',13,NULL,'Number of leaf pages in the index'),('sakila','rental','idx_fk_staff_id','2013-02-14 22:21:46','size',14,NULL,'Number of pages in the index'),('sakila','rental','rental_date','2013-02-14 22:21:46','n_diff_pfx01',15815,24,'rental_date'),('sakila','rental','rental_date','2013-02-14 22:21:46','n_diff_pfx02',16044,24,'rental_date,inventory_id'),('sakila','rental','rental_date','2013-02-14 22:21:46','n_diff_pfx03',16044,24,'rental_date,inventory_id,customer_id'),('sakila','rental','rental_date','2013-02-14 22:21:46','n_leaf_pages',24,NULL,'Number of leaf pages in the index'),('sakila','rental','rental_date','2013-02-14 22:21:46','size',25,NULL,'Number of pages in the index'),('sakila','staff','PRIMARY','2013-02-14 22:21:46','n_diff_pfx01',2,1,'staff_id'),('sakila','staff','PRIMARY','2013-02-14 22:21:46','n_leaf_pages',3,NULL,'Number of leaf pages in the index'),('sakila','staff','PRIMARY','2013-02-14 22:21:46','size',4,NULL,'Number of pages in the index'),('sakila','staff','idx_fk_address_id','2013-02-14 22:21:46','n_diff_pfx01',2,1,'address_id'),('sakila','staff','idx_fk_address_id','2013-02-14 22:21:46','n_diff_pfx02',2,1,'address_id,staff_id'),('sakila','staff','idx_fk_address_id','2013-02-14 22:21:46','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','staff','idx_fk_address_id','2013-02-14 22:21:46','size',1,NULL,'Number of pages in the index'),('sakila','staff','idx_fk_store_id','2013-02-14 22:21:46','n_diff_pfx01',2,1,'store_id'),('sakila','staff','idx_fk_store_id','2013-02-14 22:21:46','n_diff_pfx02',2,1,'store_id,staff_id'),('sakila','staff','idx_fk_store_id','2013-02-14 22:21:46','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','staff','idx_fk_store_id','2013-02-14 22:21:46','size',1,NULL,'Number of pages in the index'),('sakila','store','PRIMARY','2013-02-14 22:21:47','n_diff_pfx01',2,1,'store_id'),('sakila','store','PRIMARY','2013-02-14 22:21:47','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','store','PRIMARY','2013-02-14 22:21:47','size',1,NULL,'Number of pages in the index'),('sakila','store','idx_fk_address_id','2013-02-14 22:21:47','n_diff_pfx01',2,1,'address_id'),('sakila','store','idx_fk_address_id','2013-02-14 22:21:47','n_diff_pfx02',2,1,'address_id,store_id'),('sakila','store','idx_fk_address_id','2013-02-14 22:21:47','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','store','idx_fk_address_id','2013-02-14 22:21:47','size',1,NULL,'Number of pages in the index'),('sakila','store','idx_unique_manager','2013-02-14 22:21:47','n_diff_pfx01',2,1,'manager_staff_id'),('sakila','store','idx_unique_manager','2013-02-14 22:21:47','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','store','idx_unique_manager','2013-02-14 22:21:47','size',1,NULL,'Number of pages in the index'),('sakila','test','PRIMARY','2013-02-14 22:21:44','n_diff_pfx01',0,1,'id'),('sakila','test','PRIMARY','2013-02-14 22:21:44','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','test','PRIMARY','2013-02-14 22:21:44','size',1,NULL,'Number of pages in the index'),('sakila','test','description','2013-02-14 22:21:44','n_diff_pfx01',0,1,'description'),('sakila','test','description','2013-02-14 22:21:44','n_diff_pfx02',0,1,'description,id'),('sakila','test','description','2013-02-14 22:21:44','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','test','description','2013-02-14 22:21:44','size',1,NULL,'Number of pages in the index'),('sakila','test','name','2013-02-14 22:21:44','n_diff_pfx01',0,1,'name'),('sakila','test','name','2013-02-14 22:21:44','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila','test','name','2013-02-14 22:21:44','size',1,NULL,'Number of pages in the index'),('sakila_dwh','dim_customer','PRIMARY','2013-02-14 22:21:52','n_diff_pfx01',600,7,'customer_key'),('sakila_dwh','dim_customer','PRIMARY','2013-02-14 22:21:52','n_leaf_pages',7,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_customer','PRIMARY','2013-02-14 22:21:52','size',8,NULL,'Number of pages in the index'),('sakila_dwh','dim_customer','customer_id','2013-02-14 22:21:52','n_diff_pfx01',600,1,'customer_id'),('sakila_dwh','dim_customer','customer_id','2013-02-14 22:21:52','n_diff_pfx02',600,1,'customer_id,customer_key'),('sakila_dwh','dim_customer','customer_id','2013-02-14 22:21:52','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_customer','customer_id','2013-02-14 22:21:52','size',1,NULL,'Number of pages in the index'),('sakila_dwh','dim_film','PRIMARY','2013-02-14 22:21:55','n_diff_pfx01',1000,15,'film_key'),('sakila_dwh','dim_film','PRIMARY','2013-02-14 22:21:55','n_leaf_pages',15,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_film','PRIMARY','2013-02-14 22:21:55','size',16,NULL,'Number of pages in the index'),('sakila_dwh','dim_staff','PRIMARY','2013-02-14 22:22:02','n_diff_pfx01',3,1,'staff_key'),('sakila_dwh','dim_staff','PRIMARY','2013-02-14 22:22:02','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_staff','PRIMARY','2013-02-14 22:22:02','size',1,NULL,'Number of pages in the index'),('sakila_dwh','dim_staff','staff_id','2013-02-14 22:22:02','n_diff_pfx01',3,1,'staff_id'),('sakila_dwh','dim_staff','staff_id','2013-02-14 22:22:02','n_diff_pfx02',3,1,'staff_id,staff_key'),('sakila_dwh','dim_staff','staff_id','2013-02-14 22:22:02','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_staff','staff_id','2013-02-14 22:22:02','size',1,NULL,'Number of pages in the index'),('sakila_dwh','dim_store','PRIMARY','2013-02-14 22:22:02','n_diff_pfx01',3,1,'store_key'),('sakila_dwh','dim_store','PRIMARY','2013-02-14 22:22:02','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_store','PRIMARY','2013-02-14 22:22:02','size',1,NULL,'Number of pages in the index'),('sakila_dwh','dim_store','store_id','2013-02-14 22:22:02','n_diff_pfx01',3,1,'store_id'),('sakila_dwh','dim_store','store_id','2013-02-14 22:22:02','n_diff_pfx02',3,1,'store_id,store_key'),('sakila_dwh','dim_store','store_id','2013-02-14 22:22:02','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_store','store_id','2013-02-14 22:22:02','size',1,NULL,'Number of pages in the index'),('sakila_dwh','dim_time','PRIMARY','2013-02-14 22:22:03','n_diff_pfx01',86760,20,'time_key'),('sakila_dwh','dim_time','PRIMARY','2013-02-14 22:22:03','n_leaf_pages',180,NULL,'Number of leaf pages in the index'),('sakila_dwh','dim_time','PRIMARY','2013-02-14 22:22:03','size',225,NULL,'Number of pages in the index'),('sakila_dwh','fact_rental','PRIMARY','2013-02-14 22:22:03','n_diff_pfx01',15763,20,'rental_id'),('sakila_dwh','fact_rental','PRIMARY','2013-02-14 22:22:03','n_leaf_pages',55,NULL,'Number of leaf pages in the index'),('sakila_dwh','fact_rental','PRIMARY','2013-02-14 22:22:03','size',97,NULL,'Number of pages in the index'),('simulate_activity','t','GEN_CLUST_INDEX','2013-02-14 22:21:55','n_diff_pfx01',0,1,'DB_ROW_ID'),('simulate_activity','t','GEN_CLUST_INDEX','2013-02-14 22:21:55','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('simulate_activity','t','GEN_CLUST_INDEX','2013-02-14 22:21:55','size',1,NULL,'Number of pages in the index'),('sp500','sp500','PRIMARY','2013-02-14 22:22:03','n_diff_pfx01',246,20,'date'),('sp500','sp500','PRIMARY','2013-02-14 22:22:03','n_diff_pfx02',122400,20,'date,ticker'),('sp500','sp500','PRIMARY','2013-02-14 22:22:03','n_leaf_pages',408,NULL,'Number of leaf pages in the index'),('sp500','sp500','PRIMARY','2013-02-14 22:22:03','size',417,NULL,'Number of pages in the index'),('sp500','sp500','ticker','2013-02-14 22:22:03','n_diff_pfx01',551,20,'ticker'),('sp500','sp500','ticker','2013-02-14 22:22:03','n_diff_pfx02',124076,20,'ticker,date'),('sp500','sp500','ticker','2013-02-14 22:22:03','n_leaf_pages',145,NULL,'Number of leaf pages in the index'),('sp500','sp500','ticker','2013-02-14 22:22:03','size',225,NULL,'Number of pages in the index'),('test','bla','PRIMARY','2013-02-14 22:22:01','n_diff_pfx01',0,1,'id'),('test','bla','PRIMARY','2013-02-14 22:22:01','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','bla','PRIMARY','2013-02-14 22:22:01','size',1,NULL,'Number of pages in the index'),('test','foo','GEN_CLUST_INDEX','2013-02-14 22:22:04','n_diff_pfx01',3,1,'DB_ROW_ID'),('test','foo','GEN_CLUST_INDEX','2013-02-14 22:22:04','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','foo','GEN_CLUST_INDEX','2013-02-14 22:22:04','size',1,NULL,'Number of pages in the index'),('test','income_education','GEN_CLUST_INDEX','2013-02-14 22:22:04','n_diff_pfx01',10,1,'DB_ROW_ID'),('test','income_education','GEN_CLUST_INDEX','2013-02-14 22:22:04','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','income_education','GEN_CLUST_INDEX','2013-02-14 22:22:04','size',1,NULL,'Number of pages in the index'),('test','mytable','GEN_CLUST_INDEX','2013-02-14 22:22:05','n_diff_pfx01',2,1,'DB_ROW_ID'),('test','mytable','GEN_CLUST_INDEX','2013-02-14 22:22:05','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','mytable','GEN_CLUST_INDEX','2013-02-14 22:22:05','size',1,NULL,'Number of pages in the index'),('test','status','PRIMARY','2013-02-14 22:22:06','n_diff_pfx01',2,1,'id'),('test','status','PRIMARY','2013-02-14 22:22:06','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','status','PRIMARY','2013-02-14 22:22:06','size',1,NULL,'Number of pages in the index'),('test','t1','GEN_CLUST_INDEX','2013-02-14 22:22:06','n_diff_pfx01',4,1,'DB_ROW_ID'),('test','t1','GEN_CLUST_INDEX','2013-02-14 22:22:06','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','t1','GEN_CLUST_INDEX','2013-02-14 22:22:06','size',1,NULL,'Number of pages in the index'),('test','t2','GEN_CLUST_INDEX','2013-02-14 22:22:08','n_diff_pfx01',3,1,'DB_ROW_ID'),('test','t2','GEN_CLUST_INDEX','2013-02-14 22:22:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','t2','GEN_CLUST_INDEX','2013-02-14 22:22:08','size',1,NULL,'Number of pages in the index'),('test','t3','GEN_CLUST_INDEX','2013-02-14 22:22:09','n_diff_pfx01',3,1,'DB_ROW_ID'),('test','t3','GEN_CLUST_INDEX','2013-02-14 22:22:09','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','t3','GEN_CLUST_INDEX','2013-02-14 22:22:09','size',1,NULL,'Number of pages in the index'),('test','t_innodb','GEN_CLUST_INDEX','2013-02-14 22:22:12','n_diff_pfx01',16,1,'DB_ROW_ID'),('test','t_innodb','GEN_CLUST_INDEX','2013-02-14 22:22:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','t_innodb','GEN_CLUST_INDEX','2013-02-14 22:22:12','size',1,NULL,'Number of pages in the index'),('test','t_opening_relationship_tmp','PRIMARY','2013-02-14 22:22:12','n_diff_pfx01',2013,5,'descendant_id'),('test','t_opening_relationship_tmp','PRIMARY','2013-02-14 22:22:12','n_leaf_pages',5,NULL,'Number of leaf pages in the index'),('test','t_opening_relationship_tmp','PRIMARY','2013-02-14 22:22:12','size',6,NULL,'Number of pages in the index'),('test','t_opening_tmp','PRIMARY','2013-02-14 22:22:22','n_diff_pfx01',2013,15,'opening_key'),('test','t_opening_tmp','PRIMARY','2013-02-14 22:22:22','n_leaf_pages',15,NULL,'Number of leaf pages in the index'),('test','t_opening_tmp','PRIMARY','2013-02-14 22:22:22','size',16,NULL,'Number of pages in the index'),('test','t_opening_tmp','score','2013-02-14 22:22:22','n_diff_pfx01',2013,12,'score'),('test','t_opening_tmp','score','2013-02-14 22:22:22','n_diff_pfx02',2013,12,'score,opening_key'),('test','t_opening_tmp','score','2013-02-14 22:22:22','n_leaf_pages',12,NULL,'Number of leaf pages in the index'),('test','t_opening_tmp','score','2013-02-14 22:22:22','size',13,NULL,'Number of pages in the index'),('test','tmean','GEN_CLUST_INDEX','2013-02-14 22:22:32','n_diff_pfx01',16,1,'DB_ROW_ID'),('test','tmean','GEN_CLUST_INDEX','2013-02-14 22:22:32','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','tmean','GEN_CLUST_INDEX','2013-02-14 22:22:32','size',1,NULL,'Number of pages in the index'),('test','ts','PRIMARY','2013-02-14 22:22:08','n_diff_pfx01',0,1,'id'),('test','ts','PRIMARY','2013-02-14 22:22:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','ts','PRIMARY','2013-02-14 22:22:08','size',1,NULL,'Number of pages in the index'),('test','utf8','PRIMARY','2013-02-14 22:22:08','n_diff_pfx01',0,1,'name'),('test','utf8','PRIMARY','2013-02-14 22:22:08','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('test','utf8','PRIMARY','2013-02-14 22:22:08','size',1,NULL,'Number of pages in the index'),('world','City','CountryCode','2013-02-14 22:22:43','n_diff_pfx01',232,7,'CountryCode'),('world','City','CountryCode','2013-02-14 22:22:43','n_diff_pfx02',4079,7,'CountryCode,ID'),('world','City','CountryCode','2013-02-14 22:22:43','n_leaf_pages',7,NULL,'Number of leaf pages in the index'),('world','City','CountryCode','2013-02-14 22:22:43','size',8,NULL,'Number of pages in the index'),('world','City','PRIMARY','2013-02-14 22:22:43','n_diff_pfx01',4188,20,'ID'),('world','City','PRIMARY','2013-02-14 22:22:43','n_leaf_pages',24,NULL,'Number of leaf pages in the index'),('world','City','PRIMARY','2013-02-14 22:22:43','size',25,NULL,'Number of pages in the index'),('world','Country','PRIMARY','2013-02-14 22:22:53','n_diff_pfx01',239,5,'Code'),('world','Country','PRIMARY','2013-02-14 22:22:53','n_leaf_pages',5,NULL,'Number of leaf pages in the index'),('world','Country','PRIMARY','2013-02-14 22:22:53','size',6,NULL,'Number of pages in the index'),('world','CountryLanguage','CountryCode','2013-02-14 22:23:03','n_diff_pfx01',233,3,'CountryCode'),('world','CountryLanguage','CountryCode','2013-02-14 22:23:03','n_diff_pfx02',984,3,'CountryCode,Language'),('world','CountryLanguage','CountryCode','2013-02-14 22:23:03','n_leaf_pages',3,NULL,'Number of leaf pages in the index'),('world','CountryLanguage','CountryCode','2013-02-14 22:23:03','size',4,NULL,'Number of pages in the index'),('world','CountryLanguage','PRIMARY','2013-02-14 22:23:03','n_diff_pfx01',233,5,'CountryCode'),('world','CountryLanguage','PRIMARY','2013-02-14 22:23:03','n_diff_pfx02',984,5,'CountryCode,Language'),('world','CountryLanguage','PRIMARY','2013-02-14 22:23:03','n_leaf_pages',5,NULL,'Number of leaf pages in the index'),('world','CountryLanguage','PRIMARY','2013-02-14 22:23:03','size',6,NULL,'Number of pages in the index');
/*!40000 ALTER TABLE `innodb_index_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `innodb_table_stats`
--

DROP TABLE IF EXISTS `innodb_table_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `innodb_table_stats` (
  `database_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `n_rows` bigint(20) unsigned NOT NULL,
  `clustered_index_size` bigint(20) unsigned NOT NULL,
  `sum_of_other_index_sizes` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`database_name`,`table_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin STATS_PERSISTENT=0;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `innodb_table_stats`
--

LOCK TABLES `innodb_table_stats` WRITE;
/*!40000 ALTER TABLE `innodb_table_stats` DISABLE KEYS */;
INSERT INTO `innodb_table_stats` VALUES ('chess_dwh','dim_opening_closure','2013-02-14 22:15:23',15126,25,14),('common_schema','_known_thread_states','2013-02-14 22:16:10',19,1,1),('common_schema','_named_scripts','2013-02-14 22:15:47',2,1,0),('common_schema','_script_statements','2013-02-14 22:15:52',48,1,0),('common_schema','benford_values','2013-02-14 22:15:53',90,1,0),('common_schema','help_content','2013-02-14 22:16:04',44,16,0),('common_schema','metadata','2013-02-14 22:16:07',17,1,0),('common_schema','numbers','2013-02-14 22:16:09',4096,8,0),('hibernate','AUTHORITIES','2013-02-14 22:16:11',8,1,0),('hibernate','BDPARAMS','2013-02-14 22:16:08',0,1,1),('hibernate','BGCONTENTID','2013-02-14 22:16:08',0,1,0),('hibernate','COMPONENTS','2013-02-14 22:16:08',0,1,0),('hibernate','CONTENTITEM','2013-02-14 22:16:08',0,1,2),('hibernate','CONTENTLOCATION','2013-02-14 22:16:08',0,1,1),('hibernate','CONTITEMFILE','2013-02-14 22:16:09',0,1,1),('hibernate','CPLXPARAMS','2013-02-14 22:16:09',0,1,1),('hibernate','DATASOURCE','2013-02-14 22:16:12',3,1,0),('hibernate','DTPARAMS','2013-02-14 22:16:09',0,1,1),('hibernate','GRANTED_AUTHORITIES','2013-02-14 22:16:18',13,1,2),('hibernate','INSTANCES','2013-02-14 22:16:10',0,1,0),('hibernate','INSTANCE_END','2013-02-14 22:16:10',0,1,0),('hibernate','LNGPARAMS','2013-02-14 22:16:11',0,1,1),('hibernate','LSPARAMS','2013-02-14 22:16:11',0,1,1),('hibernate','PARAMTYPESMAP','2013-02-14 22:16:11',0,1,1),('hibernate','PRO_ACLS_LIST','2013-02-14 22:16:24',439,4,3),('hibernate','PRO_AUDIT','2013-02-14 22:16:24',60248,867,0),('hibernate','PRO_AUDIT_TRANSFORM_TRACKER','2013-02-14 22:16:17',0,1,0),('hibernate','PRO_FILES','2013-02-14 22:16:34',3369,545,45),('hibernate','PRO_SCHEDULE','2013-02-14 22:16:21',0,1,0),('hibernate','PRO_SUBCONTENT','2013-02-14 22:16:22',0,1,1),('hibernate','PRO_SUBCONTPARMS','2013-02-14 22:16:22',0,1,1),('hibernate','PRO_SUBCONT_SCHEDLIST','2013-02-14 22:16:22',0,1,2),('hibernate','PRO_SUBSCRIBE','2013-02-14 22:16:22',0,1,1),('hibernate','PRO_SUBSCRPARMS','2013-02-14 22:16:23',0,1,1),('hibernate','PRO_SUBS_SCHEDLIST','2013-02-14 22:16:23',0,1,2),('hibernate','RTELEMENT','2013-02-14 22:16:23',0,1,0),('hibernate','SESSIONS','2013-02-14 22:16:23',0,1,0),('hibernate','SSPARAMS','2013-02-14 22:16:23',0,1,1),('hibernate','USERS','2013-02-14 22:16:44',5,1,0),('hibernate','USER_SETTINGS','2013-02-14 22:16:54',3,1,0),('hibernate','cdf_storage','2013-02-14 22:16:24',0,1,0),('quartz','QRTZ_BLOB_TRIGGERS','2013-02-14 22:21:21',0,1,0),('quartz','QRTZ_CALENDARS','2013-02-14 22:21:22',0,1,0),('quartz','QRTZ_CRON_TRIGGERS','2013-02-14 22:21:22',0,1,0),('quartz','QRTZ_FIRED_TRIGGERS','2013-02-14 22:21:23',0,1,0),('quartz','QRTZ_JOB_DETAILS','2013-02-14 22:21:23',0,1,0),('quartz','QRTZ_JOB_LISTENERS','2013-02-14 22:21:23',0,1,0),('quartz','QRTZ_LOCKS','2013-02-14 22:21:43',5,1,0),('quartz','QRTZ_PAUSED_TRIGGER_GRPS','2013-02-14 22:21:24',0,1,0),('quartz','QRTZ_SCHEDULER_STATE','2013-02-14 22:21:24',0,1,0),('quartz','QRTZ_SIMPLE_TRIGGERS','2013-02-14 22:21:24',0,1,0),('quartz','QRTZ_TRIGGERS','2013-02-14 22:21:24',0,1,1),('quartz','QRTZ_TRIGGER_LISTENERS','2013-02-14 22:21:25',0,1,0),('sakila','actor','2013-02-14 22:21:26',200,1,1),('sakila','address','2013-02-14 22:21:27',603,5,1),('sakila','category','2013-02-14 22:21:27',16,1,0),('sakila','city','2013-02-14 22:21:28',600,3,1),('sakila','country','2013-02-14 22:21:29',109,1,0),('sakila','customer','2013-02-14 22:21:31',599,5,3),('sakila','film','2013-02-14 22:21:33',1000,12,5),('sakila','film_actor','2013-02-14 22:21:34',5462,12,5),('sakila','film_category','2013-02-14 22:21:39',1000,4,1),('sakila','inventory','2013-02-14 22:21:43',4581,11,12),('sakila','language','2013-02-14 22:21:44',6,1,0),('sakila','payment','2013-02-14 22:21:45',16086,97,39),('sakila','rental','2013-02-14 22:21:46',16008,97,73),('sakila','staff','2013-02-14 22:21:46',2,4,2),('sakila','store','2013-02-14 22:21:47',2,1,2),('sakila','test','2013-02-14 22:21:44',0,1,2),('sakila_dwh','dim_customer','2013-02-14 22:21:52',600,8,1),('sakila_dwh','dim_film','2013-02-14 22:21:55',1000,16,0),('sakila_dwh','dim_staff','2013-02-14 22:22:02',3,1,1),('sakila_dwh','dim_store','2013-02-14 22:22:02',3,1,1),('sakila_dwh','dim_time','2013-02-14 22:22:03',86760,225,0),('sakila_dwh','fact_rental','2013-02-14 22:22:03',15763,97,0),('simulate_activity','t','2013-02-14 22:21:55',0,1,0),('sp500','sp500','2013-02-14 22:22:03',122400,417,225),('test','bla','2013-02-14 22:22:01',0,1,0),('test','foo','2013-02-14 22:22:04',3,1,0),('test','income_education','2013-02-14 22:22:04',10,1,0),('test','mytable','2013-02-14 22:22:05',2,1,0),('test','status','2013-02-14 22:22:06',2,1,0),('test','t1','2013-02-14 22:22:06',4,1,0),('test','t2','2013-02-14 22:22:08',3,1,0),('test','t3','2013-02-14 22:22:09',3,1,0),('test','t_innodb','2013-02-14 22:22:12',16,1,0),('test','t_opening_relationship_tmp','2013-02-14 22:22:12',2013,6,0),('test','t_opening_tmp','2013-02-14 22:22:22',2013,16,13),('test','tmean','2013-02-14 22:22:32',16,1,0),('test','ts','2013-02-14 22:22:08',0,1,0),('test','utf8','2013-02-14 22:22:08',0,1,0),('world','City','2013-02-14 22:22:43',4188,25,8),('world','Country','2013-02-14 22:22:53',239,6,0),('world','CountryLanguage','2013-02-14 22:23:03',984,6,4);
/*!40000 ALTER TABLE `innodb_table_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ndb_binlog_index`
--

DROP TABLE IF EXISTS `ndb_binlog_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ndb_binlog_index` (
  `Position` bigint(20) unsigned NOT NULL,
  `File` varchar(255) NOT NULL,
  `epoch` bigint(20) unsigned NOT NULL,
  `inserts` bigint(20) unsigned NOT NULL,
  `updates` bigint(20) unsigned NOT NULL,
  `deletes` bigint(20) unsigned NOT NULL,
  `schemaops` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`epoch`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ndb_binlog_index`
--

LOCK TABLES `ndb_binlog_index` WRITE;
/*!40000 ALTER TABLE `ndb_binlog_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `ndb_binlog_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plugin`
--

DROP TABLE IF EXISTS `plugin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plugin` (
  `name` varchar(64) NOT NULL DEFAULT '',
  `dl` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='MySQL plugins';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plugin`
--

LOCK TABLES `plugin` WRITE;
/*!40000 ALTER TABLE `plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `plugin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proc`
--

DROP TABLE IF EXISTS `proc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proc` (
  `db` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `name` char(64) NOT NULL DEFAULT '',
  `type` enum('FUNCTION','PROCEDURE') NOT NULL,
  `specific_name` char(64) NOT NULL DEFAULT '',
  `language` enum('SQL') NOT NULL DEFAULT 'SQL',
  `sql_data_access` enum('CONTAINS_SQL','NO_SQL','READS_SQL_DATA','MODIFIES_SQL_DATA') NOT NULL DEFAULT 'CONTAINS_SQL',
  `is_deterministic` enum('YES','NO') NOT NULL DEFAULT 'NO',
  `security_type` enum('INVOKER','DEFINER') NOT NULL DEFAULT 'DEFINER',
  `param_list` blob NOT NULL,
  `returns` longblob NOT NULL,
  `body` longblob NOT NULL,
  `definer` char(77) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `sql_mode` set('REAL_AS_FLOAT','PIPES_AS_CONCAT','ANSI_QUOTES','IGNORE_SPACE','NOT_USED','ONLY_FULL_GROUP_BY','NO_UNSIGNED_SUBTRACTION','NO_DIR_IN_CREATE','POSTGRESQL','ORACLE','MSSQL','DB2','MAXDB','NO_KEY_OPTIONS','NO_TABLE_OPTIONS','NO_FIELD_OPTIONS','MYSQL323','MYSQL40','ANSI','NO_AUTO_VALUE_ON_ZERO','NO_BACKSLASH_ESCAPES','STRICT_TRANS_TABLES','STRICT_ALL_TABLES','NO_ZERO_IN_DATE','NO_ZERO_DATE','INVALID_DATES','ERROR_FOR_DIVISION_BY_ZERO','TRADITIONAL','NO_AUTO_CREATE_USER','HIGH_NOT_PRECEDENCE','NO_ENGINE_SUBSTITUTION','PAD_CHAR_TO_FULL_LENGTH') NOT NULL DEFAULT '',
  `comment` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `character_set_client` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `collation_connection` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `db_collation` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `body_utf8` longblob,
  PRIMARY KEY (`db`,`name`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stored Procedures';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proc`
--

LOCK TABLES `proc` WRITE;
/*!40000 ALTER TABLE `proc` DISABLE KEYS */;
INSERT INTO `proc` VALUES ('sakila','rewards_report','PROCEDURE','rewards_report','SQL','READS_SQL_DATA','NO','DEFINER','\n    IN min_monthly_purchases TINYINT UNSIGNED\n    , IN min_dollar_amount_purchased DECIMAL(10,2) UNSIGNED\n    , OUT count_rewardees INT\n','','proc: BEGIN\n\n    DECLARE last_month_start DATE;\n    DECLARE last_month_end DATE;\n\n    \n    IF min_monthly_purchases = 0 THEN\n        SELECT \'Minimum monthly purchases parameter must be > 0\';\n        LEAVE proc;\n    END IF;\n    IF min_dollar_amount_purchased = 0.00 THEN\n        SELECT \'Minimum monthly dollar amount purchased parameter must be > $0.00\';\n        LEAVE proc;\n    END IF;\n\n    \n    SET last_month_start = DATE_SUB(CURRENT_DATE(), INTERVAL 1 MONTH);\n    SET last_month_start = STR_TO_DATE(CONCAT(YEAR(last_month_start),\'-\',MONTH(last_month_start),\'-01\'),\'%Y-%m-%d\');\n    SET last_month_end = LAST_DAY(last_month_start);\n\n    \n    CREATE TEMPORARY TABLE tmpCustomer (customer_id SMALLINT UNSIGNED NOT NULL PRIMARY KEY);\n\n    \n    INSERT INTO tmpCustomer (customer_id)\n    SELECT p.customer_id\n    FROM payment AS p\n    WHERE DATE(p.payment_date) BETWEEN last_month_start AND last_month_end\n    GROUP BY customer_id\n    HAVING SUM(p.amount) > min_dollar_amount_purchased\n    AND COUNT(customer_id) > min_monthly_purchases;\n\n    \n    SELECT COUNT(*) FROM tmpCustomer INTO count_rewardees;\n\n    \n    SELECT c.*\n    FROM tmpCustomer AS t\n    INNER JOIN customer AS c ON t.customer_id = c.customer_id;\n\n    \n    DROP TABLE tmpCustomer;\nEND','root@%','2013-02-14 22:21:44','2013-02-14 22:21:44','STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','Provides a customizable report on best customers','utf8','utf8_general_ci','latin1_swedish_ci','proc: BEGIN\n\n    DECLARE last_month_start DATE;\n    DECLARE last_month_end DATE;\n\n    \n    IF min_monthly_purchases = 0 THEN\n        SELECT \'Minimum monthly purchases parameter must be > 0\';\n        LEAVE proc;\n    END IF;\n    IF min_dollar_amount_purchased = 0.00 THEN\n        SELECT \'Minimum monthly dollar amount purchased parameter must be > $0.00\';\n        LEAVE proc;\n    END IF;\n\n    \n    SET last_month_start = DATE_SUB(CURRENT_DATE(), INTERVAL 1 MONTH);\n    SET last_month_start = STR_TO_DATE(CONCAT(YEAR(last_month_start),\'-\',MONTH(last_month_start),\'-01\'),\'%Y-%m-%d\');\n    SET last_month_end = LAST_DAY(last_month_start);\n\n    \n    CREATE TEMPORARY TABLE tmpCustomer (customer_id SMALLINT UNSIGNED NOT NULL PRIMARY KEY);\n\n    \n    INSERT INTO tmpCustomer (customer_id)\n    SELECT p.customer_id\n    FROM payment AS p\n    WHERE DATE(p.payment_date) BETWEEN last_month_start AND last_month_end\n    GROUP BY customer_id\n    HAVING SUM(p.amount) > min_dollar_amount_purchased\n    AND COUNT(customer_id) > min_monthly_purchases;\n\n    \n    SELECT COUNT(*) FROM tmpCustomer INTO count_rewardees;\n\n    \n    SELECT c.*\n    FROM tmpCustomer AS t\n    INNER JOIN customer AS c ON t.customer_id = c.customer_id;\n\n    \n    DROP TABLE tmpCustomer;\nEND'),('sakila','get_customer_balance','FUNCTION','get_customer_balance','SQL','READS_SQL_DATA','YES','DEFINER','p_customer_id INT, p_effective_date DATETIME','decimal(5,2)','BEGIN\n\n       \n       \n       \n       \n       \n       \n\n  DECLARE v_rentfees DECIMAL(5,2); \n  DECLARE v_overfees INTEGER;      \n  DECLARE v_payments DECIMAL(5,2); \n\n  SELECT IFNULL(SUM(film.rental_rate),0) INTO v_rentfees\n    FROM film, inventory, rental\n    WHERE film.film_id = inventory.film_id\n      AND inventory.inventory_id = rental.inventory_id\n      AND rental.rental_date <= p_effective_date\n      AND rental.customer_id = p_customer_id;\n\n  SELECT IFNULL(SUM(IF((TO_DAYS(rental.return_date) - TO_DAYS(rental.rental_date)) > film.rental_duration,\n        ((TO_DAYS(rental.return_date) - TO_DAYS(rental.rental_date)) - film.rental_duration),0)),0) INTO v_overfees\n    FROM rental, inventory, film\n    WHERE film.film_id = inventory.film_id\n      AND inventory.inventory_id = rental.inventory_id\n      AND rental.rental_date <= p_effective_date\n      AND rental.customer_id = p_customer_id;\n\n\n  SELECT IFNULL(SUM(payment.amount),0) INTO v_payments\n    FROM payment\n\n    WHERE payment.payment_date <= p_effective_date\n    AND payment.customer_id = p_customer_id;\n\n  RETURN v_rentfees + v_overfees - v_payments;\nEND','root@%','2013-02-14 22:21:44','2013-02-14 22:21:44','STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','','utf8','utf8_general_ci','latin1_swedish_ci','BEGIN\n\n       \n       \n       \n       \n       \n       \n\n  DECLARE v_rentfees DECIMAL(5,2); \n  DECLARE v_overfees INTEGER;      \n  DECLARE v_payments DECIMAL(5,2); \n\n  SELECT IFNULL(SUM(film.rental_rate),0) INTO v_rentfees\n    FROM film, inventory, rental\n    WHERE film.film_id = inventory.film_id\n      AND inventory.inventory_id = rental.inventory_id\n      AND rental.rental_date <= p_effective_date\n      AND rental.customer_id = p_customer_id;\n\n  SELECT IFNULL(SUM(IF((TO_DAYS(rental.return_date) - TO_DAYS(rental.rental_date)) > film.rental_duration,\n        ((TO_DAYS(rental.return_date) - TO_DAYS(rental.rental_date)) - film.rental_duration),0)),0) INTO v_overfees\n    FROM rental, inventory, film\n    WHERE film.film_id = inventory.film_id\n      AND inventory.inventory_id = rental.inventory_id\n      AND rental.rental_date <= p_effective_date\n      AND rental.customer_id = p_customer_id;\n\n\n  SELECT IFNULL(SUM(payment.amount),0) INTO v_payments\n    FROM payment\n\n    WHERE payment.payment_date <= p_effective_date\n    AND payment.customer_id = p_customer_id;\n\n  RETURN v_rentfees + v_overfees - v_payments;\nEND'),('sakila','film_in_stock','PROCEDURE','film_in_stock','SQL','READS_SQL_DATA','NO','DEFINER','IN p_film_id INT, IN p_store_id INT, OUT p_film_count INT','','BEGIN\n     SELECT inventory_id\n     FROM inventory\n     WHERE film_id = p_film_id\n     AND store_id = p_store_id\n     AND inventory_in_stock(inventory_id);\n\n     SELECT FOUND_ROWS() INTO p_film_count;\nEND','root@%','2013-02-14 22:21:44','2013-02-14 22:21:44','STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','','utf8','utf8_general_ci','latin1_swedish_ci','BEGIN\n     SELECT inventory_id\n     FROM inventory\n     WHERE film_id = p_film_id\n     AND store_id = p_store_id\n     AND inventory_in_stock(inventory_id);\n\n     SELECT FOUND_ROWS() INTO p_film_count;\nEND'),('sakila','film_not_in_stock','PROCEDURE','film_not_in_stock','SQL','READS_SQL_DATA','NO','DEFINER','IN p_film_id INT, IN p_store_id INT, OUT p_film_count INT','','BEGIN\n     SELECT inventory_id\n     FROM inventory\n     WHERE film_id = p_film_id\n     AND store_id = p_store_id\n     AND NOT inventory_in_stock(inventory_id);\n\n     SELECT FOUND_ROWS() INTO p_film_count;\nEND','root@%','2013-02-14 22:21:44','2013-02-14 22:21:44','STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','','utf8','utf8_general_ci','latin1_swedish_ci','BEGIN\n     SELECT inventory_id\n     FROM inventory\n     WHERE film_id = p_film_id\n     AND store_id = p_store_id\n     AND NOT inventory_in_stock(inventory_id);\n\n     SELECT FOUND_ROWS() INTO p_film_count;\nEND'),('sakila','inventory_held_by_customer','FUNCTION','inventory_held_by_customer','SQL','READS_SQL_DATA','NO','DEFINER','p_inventory_id INT','int(11)','BEGIN\n  DECLARE v_customer_id INT;\n  DECLARE EXIT HANDLER FOR NOT FOUND RETURN NULL;\n\n  SELECT customer_id INTO v_customer_id\n  FROM rental\n  WHERE return_date IS NULL\n  AND inventory_id = p_inventory_id;\n\n  RETURN v_customer_id;\nEND','root@%','2013-02-14 22:21:44','2013-02-14 22:21:44','STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','','utf8','utf8_general_ci','latin1_swedish_ci','BEGIN\n  DECLARE v_customer_id INT;\n  DECLARE EXIT HANDLER FOR NOT FOUND RETURN NULL;\n\n  SELECT customer_id INTO v_customer_id\n  FROM rental\n  WHERE return_date IS NULL\n  AND inventory_id = p_inventory_id;\n\n  RETURN v_customer_id;\nEND'),('sakila','inventory_in_stock','FUNCTION','inventory_in_stock','SQL','READS_SQL_DATA','NO','DEFINER','p_inventory_id INT','tinyint(1)','BEGIN\n    DECLARE v_rentals INT;\n    DECLARE v_out     INT;\n\n    \n    \n\n    SELECT COUNT(*) INTO v_rentals\n    FROM rental\n    WHERE inventory_id = p_inventory_id;\n\n    IF v_rentals = 0 THEN\n      RETURN TRUE;\n    END IF;\n\n    SELECT COUNT(rental_id) INTO v_out\n    FROM inventory LEFT JOIN rental USING(inventory_id)\n    WHERE inventory.inventory_id = p_inventory_id\n    AND rental.return_date IS NULL;\n\n    IF v_out > 0 THEN\n      RETURN FALSE;\n    ELSE\n      RETURN TRUE;\n    END IF;\nEND','root@%','2013-02-14 22:21:44','2013-02-14 22:21:44','STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','','utf8','utf8_general_ci','latin1_swedish_ci','BEGIN\n    DECLARE v_rentals INT;\n    DECLARE v_out     INT;\n\n    \n    \n\n    SELECT COUNT(*) INTO v_rentals\n    FROM rental\n    WHERE inventory_id = p_inventory_id;\n\n    IF v_rentals = 0 THEN\n      RETURN TRUE;\n    END IF;\n\n    SELECT COUNT(rental_id) INTO v_out\n    FROM inventory LEFT JOIN rental USING(inventory_id)\n    WHERE inventory.inventory_id = p_inventory_id\n    AND rental.return_date IS NULL;\n\n    IF v_out > 0 THEN\n      RETURN FALSE;\n    ELSE\n      RETURN TRUE;\n    END IF;\nEND'),('common_schema','get_event_dependencies','PROCEDURE','get_event_dependencies','SQL','READS_SQL_DATA','YES','DEFINER','\n    IN p_event_schema VARCHAR(64) CHARSET utf8 \n,   IN p_event_name VARCHAR(64) CHARSET utf8\n','','begin\n    declare v_event_definition longtext charset utf8;\n    declare exit handler for not found\n        select concat(\'Event `\', p_event_schema, \'`.`\', p_event_name, \'` not found.\') error\n    ; \n    \n    select  body\n    into    v_event_definition\n    from    mysql.event\n    where   db      = p_event_schema\n    and     name    = p_event_name;\n\n    call get_sql_dependencies(v_event_definition, p_event_schema);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n    declare v_event_definition longtext charset utf8;\n    declare exit handler for not found\n        select concat(\'Event `\', p_event_schema, \'`.`\', p_event_name, \'` not found.\') error\n    ; \n    \n    select  body\n    into    v_event_definition\n    from    mysql.event\n    where   db      = p_event_schema\n    and     name    = p_event_name;\n\n    call get_sql_dependencies(v_event_definition, p_event_schema);\nend'),('common_schema','get_routine_dependencies','PROCEDURE','get_routine_dependencies','SQL','READS_SQL_DATA','YES','DEFINER','\n    IN p_routine_schema VARCHAR(64) CHARSET utf8 \n,   IN p_routine_name VARCHAR(64) CHARSET utf8\n','','begin\n    declare v_routine_definition longtext charset utf8;\n    declare exit handler for not found\n        select concat(\'Routine `\', p_routine_schema, \'`.`\', p_routine_name, \'` not found.\') error\n    ; \n    \n    select  body\n    into    v_routine_definition\n    from    mysql.proc\n    where   db      = p_routine_schema\n    and     name    = p_routine_name;\n\n    call get_sql_dependencies(v_routine_definition, p_routine_schema);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n    declare v_routine_definition longtext charset utf8;\n    declare exit handler for not found\n        select concat(\'Routine `\', p_routine_schema, \'`.`\', p_routine_name, \'` not found.\') error\n    ; \n    \n    select  body\n    into    v_routine_definition\n    from    mysql.proc\n    where   db      = p_routine_schema\n    and     name    = p_routine_name;\n\n    call get_sql_dependencies(v_routine_definition, p_routine_schema);\nend'),('common_schema','get_sql_dependencies','PROCEDURE','get_sql_dependencies','SQL','CONTAINS_SQL','YES','DEFINER','\n    IN p_sql               TEXT charset utf8\n,   IN p_default_schema    VARCHAR(64) charset utf8\n','','my_main: begin\n	call _get_sql_dependencies_internal(p_sql, p_default_schema, 1, @_common_schema_result_success);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','my_main: begin\n	call _get_sql_dependencies_internal(p_sql, p_default_schema, 1, @_common_schema_result_success);\nend'),('common_schema','eval','PROCEDURE','eval','SQL','MODIFIES_SQL_DATA','NO','INVOKER','sql_query TEXT CHARSET utf8','','begin\n  DROP TEMPORARY TABLE IF EXISTS _tmp_eval_queries;\n  CREATE TEMPORARY TABLE _tmp_eval_queries (query TEXT CHARSET utf8);\n  set @q := CONCAT(\'INSERT INTO _tmp_eval_queries \', sql_query);  \n  call exec_single(@q);\n  \n  begin	\n    declare current_query TEXT CHARSET utf8 DEFAULT NULL;\n    declare done INT DEFAULT 0;\n    declare eval_cursor cursor for SELECT query FROM _tmp_eval_queries;\n    declare continue handler for NOT FOUND SET done = 1;\n    \n    open eval_cursor;\n    read_loop: loop\n      fetch eval_cursor into current_query;\n      if done then\n        leave read_loop;\n      end if;\n      set @execute_query := current_query;\n      call exec(@execute_query);\n    end loop;\n\n    close eval_cursor;\n  end;\n  \n  DROP TEMPORARY TABLE IF EXISTS _tmp_eval_queries;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Evaluates queries resulting from given query','utf8','utf8_general_ci','utf8_general_ci','begin\n  DROP TEMPORARY TABLE IF EXISTS _tmp_eval_queries;\n  CREATE TEMPORARY TABLE _tmp_eval_queries (query TEXT CHARSET utf8);\n  set @q := CONCAT(\'INSERT INTO _tmp_eval_queries \', sql_query);  \n  call exec_single(@q);\n  \n  begin	\n    declare current_query TEXT CHARSET utf8 DEFAULT NULL;\n    declare done INT DEFAULT 0;\n    declare eval_cursor cursor for SELECT query FROM _tmp_eval_queries;\n    declare continue handler for NOT FOUND SET done = 1;\n    \n    open eval_cursor;\n    read_loop: loop\n      fetch eval_cursor into current_query;\n      if done then\n        leave read_loop;\n      end if;\n      set @execute_query := current_query;\n      call exec(@execute_query);\n    end loop;\n\n    close eval_cursor;\n  end;\n  \n  DROP TEMPORARY TABLE IF EXISTS _tmp_eval_queries;\nend'),('common_schema','exec_single','PROCEDURE','exec_single','SQL','MODIFIES_SQL_DATA','NO','INVOKER','IN execute_query TEXT CHARSET utf8','','_proc_body: begin\n  set @_execute_query := trim_wspace(execute_query);\n  if CHAR_LENGTH(@_execute_query) = 0 then\n    \n    \n    leave _proc_body;\n  end if;\n\n  set @common_schema_rowcount := NULL;\n  \n  if @common_schema_dryrun IS TRUE then\n    SELECT @_execute_query AS \'exec_single: @common_schema_dryrun\';\n  else\n    if @common_schema_verbose IS TRUE then\n	  SELECT @_execute_query AS \'exec_single: @common_schema_verbose\';\n    end if;\n  \n    PREPARE st FROM @_execute_query;\n    EXECUTE st;\n    set @common_schema_rowcount := ROW_COUNT(), @common_schema_found_rows := FOUND_ROWS();\n    DEALLOCATE PREPARE st;    \n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','_proc_body: begin\n  set @_execute_query := trim_wspace(execute_query);\n  if CHAR_LENGTH(@_execute_query) = 0 then\n    \n    \n    leave _proc_body;\n  end if;\n\n  set @common_schema_rowcount := NULL;\n  \n  if @common_schema_dryrun IS TRUE then\n    SELECT @_execute_query AS \'exec_single: @common_schema_dryrun\';\n  else\n    if @common_schema_verbose IS TRUE then\n	  SELECT @_execute_query AS \'exec_single: @common_schema_verbose\';\n    end if;\n  \n    PREPARE st FROM @_execute_query;\n    EXECUTE st;\n    set @common_schema_rowcount := ROW_COUNT(), @common_schema_found_rows := FOUND_ROWS();\n    DEALLOCATE PREPARE st;    \n  end if;\nend'),('common_schema','foreach','PROCEDURE','foreach','SQL','MODIFIES_SQL_DATA','NO','INVOKER','collection TEXT CHARSET utf8, execute_queries TEXT CHARSET utf8','','main_body: begin  \n  if collection IS NULL then\n    leave main_body;\n  end if;\n  if execute_queries IS NULL then\n    leave main_body;\n  end if;\n  \n  call _foreach(collection, execute_queries, NULL, NULL, NULL, @_common_schema_dummy, NULL, NULL, NULL, @_common_schema_dummy);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Invoke queries per element of given collection','utf8','utf8_general_ci','utf8_general_ci','main_body: begin  \n  if collection IS NULL then\n    leave main_body;\n  end if;\n  if execute_queries IS NULL then\n    leave main_body;\n  end if;\n  \n  call _foreach(collection, execute_queries, NULL, NULL, NULL, @_common_schema_dummy, NULL, NULL, NULL, @_common_schema_dummy);\nend'),('common_schema','_foreach','PROCEDURE','_foreach','SQL','MODIFIES_SQL_DATA','NO','INVOKER','\n   collection TEXT CHARSET utf8, \n   execute_queries TEXT CHARSET utf8,\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expect_single tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   in   variables_array_id int unsigned,\n   in depth int unsigned,\n   in should_execute_statement tinyint unsigned,\n   out iteration_count bigint unsigned\n','','main_body: begin\n  \n  declare sql_query_num_columns TINYINT UNSIGNED DEFAULT 9;\n  \n  declare iteration_number INT UNSIGNED DEFAULT 0;\n  \n  set @__group_concat_max_len := @@group_concat_max_len;\n  set @@group_concat_max_len := 32 * 1024 * 1024;\n  \n  \n  if collection = \'schema\' then\n    set collection := \'schema ~ /.*/\';\n  end if;\n  if collection RLIKE \'^schema[ ]+like[ ]+[^ ]+[ ]*$\' then\n    begin\n	  \n	  declare like_expression TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \' like \', 2)));\n	  set collection := CONCAT(\'schema ~ /\', like_to_rlike(like_expression), \'/\');\n    end;\n  end if;\n  if collection RLIKE \'^schema[ ]*~[ ]*[^ ]+[ ]*$\' then\n    begin\n	  \n	  \n	  \n	  declare re TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \'~\', 2)));\n	  set collection := CONCAT(\n	    \'SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME RLIKE \',\n	    \'\'\'\', re, \'\'\'\');\n      set execute_queries := REPLACE(execute_queries, \'${schema}\', \'${1}\');\n	end;\n  end if;\n  if collection RLIKE \'^table[ ]+in[ ]+[^ ]+[ ]*$\' then\n    begin\n	  declare db TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \' in \', 2)));\n	  set collection := CONCAT(\n	    \'SELECT TABLE_NAME, TABLE_SCHEMA, ENGINE, CREATE_OPTIONS FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA=\',\n	    \'\'\'\', db, \'\'\' AND TABLE_TYPE=\'\'BASE TABLE\'\'\');\n      set execute_queries := REPLACE(execute_queries, \'${table}\', \'${1}\');\n      set execute_queries := REPLACE(execute_queries, \'${schema}\', \'${2}\');\n      set execute_queries := REPLACE(execute_queries, \'${engine}\', \'${3}\');\n      set execute_queries := REPLACE(execute_queries, \'${create_options}\', \'${4}\');\n	end;\n  end if;\n  if collection RLIKE \'^table[ ]+like[ ]+[^ ]+[ ]*$\' then\n    begin\n	  \n	  declare like_expression TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \' like \', 2)));\n	  set collection := CONCAT(\'table ~ /\', like_to_rlike(like_expression), \'/\');\n    end;\n  end if;\n\n  \n  \n  \n  if collection RLIKE \'^table[ ]*~[ ]*[^ ]+[ ]*$\' then\n    begin\n	  \n	  \n      \n      \n	  \n      declare current_db TEXT CHARSET utf8 DEFAULT NULL;\n      declare re TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \'~\', 2)));\n      declare count_tables SMALLINT UNSIGNED DEFAULT 0;\n      declare table_name TEXT CHARSET utf8 DEFAULT NULL;\n      declare table_engine TEXT CHARSET utf8 DEFAULT NULL;\n      declare table_create_options TEXT CHARSET utf8 DEFAULT NULL;\n      declare tables_details TEXT CHARSET utf8 DEFAULT NULL;\n      declare table_details TEXT CHARSET utf8 DEFAULT NULL;\n      declare done INT DEFAULT 0;\n      declare table_counter INT UNSIGNED DEFAULT 1;\n      declare db_cursor cursor for SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA;\n      declare continue handler for NOT FOUND set done = 1;\n	  \n	  open db_cursor;\n      db_loop: loop\n        fetch db_cursor into current_db; \n        if done then\n          leave db_loop;\n        end if;\n\n        set @_foreach_tables_query:= CONCAT(\n          \'SELECT GROUP_CONCAT(TABLE_NAME, \'\'\\\\0\\\\b\'\', ENGINE, \'\'\\\\0\\\\b\'\', CREATE_OPTIONS SEPARATOR \'\'\\\\n\\\\b\'\') FROM INFORMATION_SCHEMA.TABLES \',\n          \'WHERE TABLE_SCHEMA = \'\'\',current_db,\'\'\' AND TABLE_NAME RLIKE \'\'\',re,\'\'\' AND TABLE_TYPE=\'\'BASE TABLE\'\' \',\n          \'INTO @_common_schema_foreach_tables_details\');\n        call exec(@_foreach_tables_query);\n        set tables_details := @_common_schema_foreach_tables_details;\n\n        set count_tables := get_num_tokens(tables_details, \'\\n\\b\');\n        set iteration_number := 1;\n        while iteration_number <= count_tables do\n          set table_details := split_token(tables_details, \'\\n\\b\', iteration_number);\n          \n          set table_name := split_token(table_details, \'\\0\\b\', 1);\n          set table_engine := split_token(table_details, \'\\0\\b\', 2);\n          set table_create_options := split_token(table_details, \'\\0\\b\', 3);\n          \n          set @_foreach_exec_query := execute_queries;\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${table}\', \'${1}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', table_name);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${schema}\', \'${2}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${2}\', current_db);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${engine}\', \'${3}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${3}\', table_engine);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${create_options}\', \'${4}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${4}\', table_create_options);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', table_counter);\n          set\n            @_query_script_input_col1 := table_name, \n            @_query_script_input_col2 := current_db,\n            @_query_script_input_col3 := table_engine,\n            @_query_script_input_col4 := table_create_options;\n\n          call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n          if @_common_schema_script_break_type IS NOT NULL then\n            if @_common_schema_script_break_type = \'break\' then\n              set @_common_schema_script_break_type := NULL;\n            end if;\n            leave main_body;\n          end if;\n          set iteration_number := iteration_number + 1;\n          set table_counter := table_counter + 1;\n        end while;\n      end loop;\n      close db_cursor;\n	end;\n  elseif _is_select_query(collection) then\n    \n	\n	\n    DROP TEMPORARY TABLE IF EXISTS _tmp_foreach;\n    \n    set @_foreach_iterate_query := collection;\n    call _wrap_select_list_columns(@_foreach_iterate_query, sql_query_num_columns, @common_schema_error);\n    set @_foreach_iterate_query := CONCAT(\'CREATE TEMPORARY TABLE _tmp_foreach \', @_foreach_iterate_query);\n\n    PREPARE st FROM @_foreach_iterate_query;\n    EXECUTE st;\n    DEALLOCATE PREPARE st;\n    \n    \n    begin	\n      declare foreach_col1, foreach_col2, foreach_col3, foreach_col4, foreach_col5, foreach_col6, foreach_col7, foreach_col8, foreach_col9 VARCHAR(4096) CHARSET utf8;\n      declare done INT DEFAULT 0;\n      declare query_cursor cursor for SELECT * FROM _tmp_foreach;\n      declare continue handler for NOT FOUND set done = 1;\n      \n      set iteration_number := 1;\n      open query_cursor;\n      read_loop: loop\n        fetch query_cursor into foreach_col1, foreach_col2, foreach_col3, foreach_col4, foreach_col5, foreach_col6, foreach_col7, foreach_col8, foreach_col9;\n        if done then\n          leave read_loop;\n        end if;\n        set\n          @_query_script_input_col1 := foreach_col1, \n          @_query_script_input_col2 := foreach_col2, \n          @_query_script_input_col3 := foreach_col3, \n          @_query_script_input_col4 := foreach_col4, \n          @_query_script_input_col5 := foreach_col5, \n          @_query_script_input_col6 := foreach_col6, \n          @_query_script_input_col7 := foreach_col7, \n          @_query_script_input_col8 := foreach_col8, \n          @_query_script_input_col9 := foreach_col9;\n\n        \n        \n        set @_foreach_exec_query := execute_queries;\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', IFNULL(foreach_col1, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${2}\', IFNULL(foreach_col2, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${3}\', IFNULL(foreach_col3, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${4}\', IFNULL(foreach_col4, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${5}\', IFNULL(foreach_col5, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${6}\', IFNULL(foreach_col6, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${7}\', IFNULL(foreach_col7, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${8}\', IFNULL(foreach_col8, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${9}\', IFNULL(foreach_col9, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', iteration_number);\n\n        call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n        if @_common_schema_script_break_type IS NOT NULL then\n          if @_common_schema_script_break_type = \'break\' then\n            set @_common_schema_script_break_type := NULL;\n          end if;\n          leave main_body;\n        end if;\n        \n        set iteration_number := iteration_number + 1; \n      end loop;\n      close query_cursor;\n    end; \n    \n    DROP TEMPORARY TABLE IF EXISTS _tmp_foreach;\n  elseif collection RLIKE \'^-?[0-9]+:-?[0-9]+,-?[0-9]+:-?[0-9]+$\' then\n    begin\n	  \n      \n      \n      declare first_start_index int signed default NULL;\n      declare first_end_index int signed default NULL;\n      declare second_start_index int signed default NULL;\n      declare second_end_index int signed default NULL;\n      declare first_loop_index int signed default NULL;\n      declare second_loop_index int signed default NULL;\n      \n      set @_foreach_first_range := split_token(collection, \',\', 1);\n      set @_foreach_second_range := split_token(collection, \',\', 2);\n\n      set first_start_index := CAST(split_token(@_foreach_first_range, \':\', 1) AS SIGNED INTEGER);\n      set first_end_index := CAST(split_token(@_foreach_first_range, \':\', 2) AS SIGNED INTEGER);\n      set second_start_index := CAST(split_token(@_foreach_second_range, \':\', 1) AS SIGNED INTEGER);\n      set second_end_index := CAST(split_token(@_foreach_second_range, \':\', 2) AS SIGNED INTEGER);\n\n      set iteration_number := 1;\n      set first_loop_index := first_start_index;\n      while first_loop_index <= first_end_index do\n        set second_loop_index := second_start_index;\n        while second_loop_index <= second_end_index do\n          set @_foreach_exec_query := execute_queries;\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', first_loop_index);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${2}\', second_loop_index);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', iteration_number);\n          set\n            @_query_script_input_col1 := first_loop_index, \n            @_query_script_input_col2 := second_loop_index;\n        \n          call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n          if @_common_schema_script_break_type IS NOT NULL then\n            if @_common_schema_script_break_type = \'break\' then\n              set @_common_schema_script_break_type := NULL;\n            end if;\n            leave main_body;\n          end if;\n\n          set iteration_number := iteration_number + 1;\n          set second_loop_index := second_loop_index + 1;\n        end WHILE;\n        set first_loop_index := first_loop_index + 1;\n      end while;\n    end;\n  elseif collection RLIKE \'^-?[0-9]+:-?[0-9]+$\' then\n    begin\n	  \n      \n      \n      declare _foreach_start_index INT SIGNED DEFAULT CAST(split_token(collection, \':\', 1) AS SIGNED INTEGER);\n      declare _foreach_end_index INT SIGNED DEFAULT CAST(split_token(collection, \':\', 2) AS SIGNED INTEGER);\n      declare _foreach_loop_index INT SIGNED DEFAULT NULL;\n      \n      set iteration_number := 1;\n      set _foreach_loop_index := _foreach_start_index;\n      while _foreach_loop_index <= _foreach_end_index do\n        set @_foreach_exec_query := execute_queries;\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', _foreach_loop_index);\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', iteration_number);\n        set\n          @_query_script_input_col1 := _foreach_loop_index;\n      \n        call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n        if @_common_schema_script_break_type IS NOT NULL then\n          if @_common_schema_script_break_type = \'break\' then\n            set @_common_schema_script_break_type := NULL;\n          end if;\n          leave main_body;\n        end if;\n\n        set iteration_number := iteration_number + 1;\n        set _foreach_loop_index := _foreach_loop_index + 1;\n      end while;\n    end;\n  elseif collection RLIKE \'^{.*}$\' then\n    begin\n	  \n      \n      \n      declare _foreach_iterate_tokens TEXT CHARSET utf8 DEFAULT \'\';\n      declare _foreach_num_tokens INT UNSIGNED DEFAULT 0;\n      declare _foreach_token TEXT CHARSET utf8;\n      declare _foreach_token_delimiter TEXT CHARSET utf8;\n      declare _foreach_row_number INT UNSIGNED DEFAULT 1;\n      \n      set _foreach_iterate_tokens := _retokenized_text(unwrap(collection), \' ,\', \'\"\'\'`\', TRUE, \'skip\');\n      set _foreach_num_tokens := @common_schema_retokenized_count;\n      set _foreach_token_delimiter := @common_schema_retokenized_delimiter;\n      \n      set iteration_number := 1;\n      constant_tokens_loop: while iteration_number <= _foreach_num_tokens do\n        set _foreach_token := split_token(_foreach_iterate_tokens, _foreach_token_delimiter, iteration_number);\n        set _foreach_token := unquote(_foreach_token);\n        set iteration_number := iteration_number + 1;\n\n        set @_foreach_exec_query := execute_queries;\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', _foreach_token);\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', _foreach_row_number);\n        set\n          @_query_script_input_col1 := _foreach_token;\n      \n        call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n        if @_common_schema_script_break_type IS NOT NULL then\n          if @_common_schema_script_break_type = \'break\' then\n            set @_common_schema_script_break_type := NULL;\n          end if;\n          leave main_body;\n        end if;\n\n        set _foreach_row_number := _foreach_row_number + 1;\n      end while;\n    end;\n  else\n    call throw(CONCAT(\'foreach(): unrecognized collection format: \\\"\', collection, \'\\\"\'));\n  end if;    \n  set iteration_count = GREATEST(iteration_number - 1, 0);\n  set @@group_concat_max_len := @__group_concat_max_len;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Invoke queries per element of given collection','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  \n  declare sql_query_num_columns TINYINT UNSIGNED DEFAULT 9;\n  \n  declare iteration_number INT UNSIGNED DEFAULT 0;\n  \n  set @__group_concat_max_len := @@group_concat_max_len;\n  set @@group_concat_max_len := 32 * 1024 * 1024;\n  \n  \n  if collection = \'schema\' then\n    set collection := \'schema ~ /.*/\';\n  end if;\n  if collection RLIKE \'^schema[ ]+like[ ]+[^ ]+[ ]*$\' then\n    begin\n	  \n	  declare like_expression TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \' like \', 2)));\n	  set collection := CONCAT(\'schema ~ /\', like_to_rlike(like_expression), \'/\');\n    end;\n  end if;\n  if collection RLIKE \'^schema[ ]*~[ ]*[^ ]+[ ]*$\' then\n    begin\n	  \n	  \n	  \n	  declare re TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \'~\', 2)));\n	  set collection := CONCAT(\n	    \'SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME RLIKE \',\n	    \'\'\', re, \'\'\');\n      set execute_queries := REPLACE(execute_queries, \'${schema}\', \'${1}\');\n	end;\n  end if;\n  if collection RLIKE \'^table[ ]+in[ ]+[^ ]+[ ]*$\' then\n    begin\n	  declare db TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \' in \', 2)));\n	  set collection := CONCAT(\n	    \'SELECT TABLE_NAME, TABLE_SCHEMA, ENGINE, CREATE_OPTIONS FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA=\',\n	    \'\'\', db, \'\' AND TABLE_TYPE=\'BASE TABLE\'\');\n      set execute_queries := REPLACE(execute_queries, \'${table}\', \'${1}\');\n      set execute_queries := REPLACE(execute_queries, \'${schema}\', \'${2}\');\n      set execute_queries := REPLACE(execute_queries, \'${engine}\', \'${3}\');\n      set execute_queries := REPLACE(execute_queries, \'${create_options}\', \'${4}\');\n	end;\n  end if;\n  if collection RLIKE \'^table[ ]+like[ ]+[^ ]+[ ]*$\' then\n    begin\n	  \n	  declare like_expression TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \' like \', 2)));\n	  set collection := CONCAT(\'table ~ /\', like_to_rlike(like_expression), \'/\');\n    end;\n  end if;\n\n  \n  \n  \n  if collection RLIKE \'^table[ ]*~[ ]*[^ ]+[ ]*$\' then\n    begin\n	  \n	  \n      \n      \n	  \n      declare current_db TEXT CHARSET utf8 DEFAULT NULL;\n      declare re TEXT CHARSET utf8 DEFAULT unquote(trim_wspace(split_token(collection, \'~\', 2)));\n      declare count_tables SMALLINT UNSIGNED DEFAULT 0;\n      declare table_name TEXT CHARSET utf8 DEFAULT NULL;\n      declare table_engine TEXT CHARSET utf8 DEFAULT NULL;\n      declare table_create_options TEXT CHARSET utf8 DEFAULT NULL;\n      declare tables_details TEXT CHARSET utf8 DEFAULT NULL;\n      declare table_details TEXT CHARSET utf8 DEFAULT NULL;\n      declare done INT DEFAULT 0;\n      declare table_counter INT UNSIGNED DEFAULT 1;\n      declare db_cursor cursor for SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA;\n      declare continue handler for NOT FOUND set done = 1;\n	  \n	  open db_cursor;\n      db_loop: loop\n        fetch db_cursor into current_db; \n        if done then\n          leave db_loop;\n        end if;\n\n        set @_foreach_tables_query:= CONCAT(\n          \'SELECT GROUP_CONCAT(TABLE_NAME, \'\\0\\b\', ENGINE, \'\\0\\b\', CREATE_OPTIONS SEPARATOR \'\\n\\b\') FROM INFORMATION_SCHEMA.TABLES \',\n          \'WHERE TABLE_SCHEMA = \'\',current_db,\'\' AND TABLE_NAME RLIKE \'\',re,\'\' AND TABLE_TYPE=\'BASE TABLE\' \',\n          \'INTO @_common_schema_foreach_tables_details\');\n        call exec(@_foreach_tables_query);\n        set tables_details := @_common_schema_foreach_tables_details;\n\n        set count_tables := get_num_tokens(tables_details, \'\n\');\n        set iteration_number := 1;\n        while iteration_number <= count_tables do\n          set table_details := split_token(tables_details, \'\n\', iteration_number);\n          \n          set table_name := split_token(table_details, \'\0\', 1);\n          set table_engine := split_token(table_details, \'\0\', 2);\n          set table_create_options := split_token(table_details, \'\0\', 3);\n          \n          set @_foreach_exec_query := execute_queries;\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${table}\', \'${1}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', table_name);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${schema}\', \'${2}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${2}\', current_db);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${engine}\', \'${3}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${3}\', table_engine);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${create_options}\', \'${4}\');\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${4}\', table_create_options);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', table_counter);\n          set\n            @_query_script_input_col1 := table_name, \n            @_query_script_input_col2 := current_db,\n            @_query_script_input_col3 := table_engine,\n            @_query_script_input_col4 := table_create_options;\n\n          call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n          if @_common_schema_script_break_type IS NOT NULL then\n            if @_common_schema_script_break_type = \'break\' then\n              set @_common_schema_script_break_type := NULL;\n            end if;\n            leave main_body;\n          end if;\n          set iteration_number := iteration_number + 1;\n          set table_counter := table_counter + 1;\n        end while;\n      end loop;\n      close db_cursor;\n	end;\n  elseif _is_select_query(collection) then\n    \n	\n	\n    DROP TEMPORARY TABLE IF EXISTS _tmp_foreach;\n    \n    set @_foreach_iterate_query := collection;\n    call _wrap_select_list_columns(@_foreach_iterate_query, sql_query_num_columns, @common_schema_error);\n    set @_foreach_iterate_query := CONCAT(\'CREATE TEMPORARY TABLE _tmp_foreach \', @_foreach_iterate_query);\n\n    PREPARE st FROM @_foreach_iterate_query;\n    EXECUTE st;\n    DEALLOCATE PREPARE st;\n    \n    \n    begin	\n      declare foreach_col1, foreach_col2, foreach_col3, foreach_col4, foreach_col5, foreach_col6, foreach_col7, foreach_col8, foreach_col9 VARCHAR(4096) CHARSET utf8;\n      declare done INT DEFAULT 0;\n      declare query_cursor cursor for SELECT * FROM _tmp_foreach;\n      declare continue handler for NOT FOUND set done = 1;\n      \n      set iteration_number := 1;\n      open query_cursor;\n      read_loop: loop\n        fetch query_cursor into foreach_col1, foreach_col2, foreach_col3, foreach_col4, foreach_col5, foreach_col6, foreach_col7, foreach_col8, foreach_col9;\n        if done then\n          leave read_loop;\n        end if;\n        set\n          @_query_script_input_col1 := foreach_col1, \n          @_query_script_input_col2 := foreach_col2, \n          @_query_script_input_col3 := foreach_col3, \n          @_query_script_input_col4 := foreach_col4, \n          @_query_script_input_col5 := foreach_col5, \n          @_query_script_input_col6 := foreach_col6, \n          @_query_script_input_col7 := foreach_col7, \n          @_query_script_input_col8 := foreach_col8, \n          @_query_script_input_col9 := foreach_col9;\n\n        \n        \n        set @_foreach_exec_query := execute_queries;\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', IFNULL(foreach_col1, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${2}\', IFNULL(foreach_col2, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${3}\', IFNULL(foreach_col3, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${4}\', IFNULL(foreach_col4, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${5}\', IFNULL(foreach_col5, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${6}\', IFNULL(foreach_col6, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${7}\', IFNULL(foreach_col7, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${8}\', IFNULL(foreach_col8, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${9}\', IFNULL(foreach_col9, \'NULL\'));\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', iteration_number);\n\n        call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n        if @_common_schema_script_break_type IS NOT NULL then\n          if @_common_schema_script_break_type = \'break\' then\n            set @_common_schema_script_break_type := NULL;\n          end if;\n          leave main_body;\n        end if;\n        \n        set iteration_number := iteration_number + 1; \n      end loop;\n      close query_cursor;\n    end; \n    \n    DROP TEMPORARY TABLE IF EXISTS _tmp_foreach;\n  elseif collection RLIKE \'^-?[0-9]+:-?[0-9]+,-?[0-9]+:-?[0-9]+$\' then\n    begin\n	  \n      \n      \n      declare first_start_index int signed default NULL;\n      declare first_end_index int signed default NULL;\n      declare second_start_index int signed default NULL;\n      declare second_end_index int signed default NULL;\n      declare first_loop_index int signed default NULL;\n      declare second_loop_index int signed default NULL;\n      \n      set @_foreach_first_range := split_token(collection, \',\', 1);\n      set @_foreach_second_range := split_token(collection, \',\', 2);\n\n      set first_start_index := CAST(split_token(@_foreach_first_range, \':\', 1) AS SIGNED INTEGER);\n      set first_end_index := CAST(split_token(@_foreach_first_range, \':\', 2) AS SIGNED INTEGER);\n      set second_start_index := CAST(split_token(@_foreach_second_range, \':\', 1) AS SIGNED INTEGER);\n      set second_end_index := CAST(split_token(@_foreach_second_range, \':\', 2) AS SIGNED INTEGER);\n\n      set iteration_number := 1;\n      set first_loop_index := first_start_index;\n      while first_loop_index <= first_end_index do\n        set second_loop_index := second_start_index;\n        while second_loop_index <= second_end_index do\n          set @_foreach_exec_query := execute_queries;\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', first_loop_index);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${2}\', second_loop_index);\n          set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', iteration_number);\n          set\n            @_query_script_input_col1 := first_loop_index, \n            @_query_script_input_col2 := second_loop_index;\n        \n          call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n          if @_common_schema_script_break_type IS NOT NULL then\n            if @_common_schema_script_break_type = \'break\' then\n              set @_common_schema_script_break_type := NULL;\n            end if;\n            leave main_body;\n          end if;\n\n          set iteration_number := iteration_number + 1;\n          set second_loop_index := second_loop_index + 1;\n        end WHILE;\n        set first_loop_index := first_loop_index + 1;\n      end while;\n    end;\n  elseif collection RLIKE \'^-?[0-9]+:-?[0-9]+$\' then\n    begin\n	  \n      \n      \n      declare _foreach_start_index INT SIGNED DEFAULT CAST(split_token(collection, \':\', 1) AS SIGNED INTEGER);\n      declare _foreach_end_index INT SIGNED DEFAULT CAST(split_token(collection, \':\', 2) AS SIGNED INTEGER);\n      declare _foreach_loop_index INT SIGNED DEFAULT NULL;\n      \n      set iteration_number := 1;\n      set _foreach_loop_index := _foreach_start_index;\n      while _foreach_loop_index <= _foreach_end_index do\n        set @_foreach_exec_query := execute_queries;\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', _foreach_loop_index);\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', iteration_number);\n        set\n          @_query_script_input_col1 := _foreach_loop_index;\n      \n        call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n        if @_common_schema_script_break_type IS NOT NULL then\n          if @_common_schema_script_break_type = \'break\' then\n            set @_common_schema_script_break_type := NULL;\n          end if;\n          leave main_body;\n        end if;\n\n        set iteration_number := iteration_number + 1;\n        set _foreach_loop_index := _foreach_loop_index + 1;\n      end while;\n    end;\n  elseif collection RLIKE \'^{.*}$\' then\n    begin\n	  \n      \n      \n      declare _foreach_iterate_tokens TEXT CHARSET utf8 DEFAULT \'\';\n      declare _foreach_num_tokens INT UNSIGNED DEFAULT 0;\n      declare _foreach_token TEXT CHARSET utf8;\n      declare _foreach_token_delimiter TEXT CHARSET utf8;\n      declare _foreach_row_number INT UNSIGNED DEFAULT 1;\n      \n      set _foreach_iterate_tokens := _retokenized_text(unwrap(collection), \' ,\', \'\"\'`\', TRUE, \'skip\');\n      set _foreach_num_tokens := @common_schema_retokenized_count;\n      set _foreach_token_delimiter := @common_schema_retokenized_delimiter;\n      \n      set iteration_number := 1;\n      constant_tokens_loop: while iteration_number <= _foreach_num_tokens do\n        set _foreach_token := split_token(_foreach_iterate_tokens, _foreach_token_delimiter, iteration_number);\n        set _foreach_token := unquote(_foreach_token);\n        set iteration_number := iteration_number + 1;\n\n        set @_foreach_exec_query := execute_queries;\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${1}\', _foreach_token);\n        set @_foreach_exec_query := REPLACE(@_foreach_exec_query, \'${NR}\', _foreach_row_number);\n        set\n          @_query_script_input_col1 := _foreach_token;\n      \n        call _run_foreach_step(@_foreach_exec_query, id_from, id_to, expect_single, consumed_to_id, variables_array_id, depth, should_execute_statement);\n        if @_common_schema_script_break_type IS NOT NULL then\n          if @_common_schema_script_break_type = \'break\' then\n            set @_common_schema_script_break_type := NULL;\n          end if;\n          leave main_body;\n        end if;\n\n        set _foreach_row_number := _foreach_row_number + 1;\n      end while;\n    end;\n  else\n    call throw(CONCAT(\'foreach(): unrecognized collection format: \"\', collection, \'\"\'));\n  end if;    \n  set iteration_count = GREATEST(iteration_number - 1, 0);\n  set @@group_concat_max_len := @__group_concat_max_len;\nend'),('common_schema','_get_sql_token','PROCEDURE','_get_sql_token','SQL','NO_SQL','YES','INVOKER','\n    in      p_text      text charset utf8\n,   inout   p_from      int unsigned\n,   inout   p_level     int\n,   out     p_token     text charset utf8\n,   in      allow_script_tokens int\n\n,   inout   p_state     enum(\n                            \'alpha\'\n                        ,   \'alphanum\'\n                        ,   \'and\'\n                        ,   \'assign\'\n                        ,   \'bitwise and\'\n                        ,   \'bitwise or\'\n                        ,   \'bitwise not\'\n                        ,   \'bitwise xor\'\n                        ,   \'colon\'\n                        ,   \'comma\'                        \n                        ,   \'conditional comment\'\n                        ,   \'decimal\'\n                        ,   \'delimiter\'\n                        ,   \'divide\'\n                        ,   \'dot\'\n                        ,   \'equals\'\n                        ,   \'error\'\n                        ,   \'greater than\'\n                        ,   \'greater than or equals\'\n                        ,   \'integer\'\n                        ,   \'left braces\'\n                        ,   \'left parenthesis\'\n                        ,   \'left shift\'\n                        ,   \'less than\'\n                        ,   \'less than or equals\'\n                        ,   \'minus\'\n                        ,   \'modulo\'\n                        ,   \'multi line comment\'\n                        ,   \'multiply\'\n                        ,   \'negate\'\n                        ,   \'not equals\'\n                        ,   \'null safe equals\'\n                        ,   \'or\'\n                        ,   \'plus\'\n                        ,   \'quoted identifier\'\n                        ,   \'right braces\'\n                        ,   \'right parenthesis\'\n                        ,   \'right shift\'\n                        ,   \'single line comment\'\n                        ,   \'start\'\n                        ,   \'statement delimiter\'\n                        ,   \'string\'\n                        ,   \'system variable\'\n                        ,   \'user-defined variable\'\n                        ,   \'query_script variable\'\n                        ,	\'expanded query_script variable\'\n                        ,   \'whitespace\'\n                        ,   \'not\'\n                        )               \n','','begin    \n    declare v_length int unsigned default character_length(p_text);\n    declare v_no_ansi_quotes        bool default find_in_set(\'ANSI_QUOTES\', @@sql_mode) = FALSE;\n    declare v_char, v_lookahead, v_quote_char    char(1) charset utf8;\n    declare v_from int unsigned;\n\n    if p_from is null then\n        set p_from = 1;\n    end if;\n    if p_level is null then\n        set p_level = 0;\n    end if;\n    if p_state = \'right parenthesis\' then\n        set p_level = p_level - 1;\n    end if;\n    if p_state = \'right braces\' and allow_script_tokens then\n        set p_level = p_level - 1;\n    end if;\n    set v_from = p_from;\n    \n    set p_token = \'\'\n    ,   p_state = \'start\';\n    my_loop: while v_from <= v_length do\n        set v_char = substr(p_text, v_from, 1)\n        ,   v_lookahead = substr(p_text, v_from+1, 1)\n        ;\n        state_case: begin case p_state\n            when \'error\' then \n                set p_from = v_length;\n                leave state_case;            \n            when \'start\' then\n                case\n                    when v_char between \'0\' and \'9\' then \n                        set p_state = \'integer\';\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        set p_state = \'alpha\';                        \n                    when v_char = \' \' then \n                        set p_state = \'whitespace\'\n                        ,   v_from = v_length - character_length(ltrim(substring(p_text, v_from)))\n                        ;\n                        leave state_case;\n                    when v_char in (\'\\t\', \'\\n\', \'\\r\') then \n                        set p_state = \'whitespace\';\n                    when v_char = \'\'\'\' or v_no_ansi_quotes and v_char = \'\"\' then\n                        set p_state = \'string\', v_quote_char = v_char;\n                    when v_char = \'`\' or v_no_ansi_quotes = FALSE and v_char = \'\"\' then\n                        set p_state = \'quoted identifier\', v_quote_char = v_char;\n                    when v_char = \'@\' then\n                        if v_lookahead = \'@\' then\n                            set p_state = \'system variable\', v_from = v_from + 1;\n                        else\n                            set p_state = \'user-defined variable\';\n                        end if;\n                    when v_char = \'$\' and allow_script_tokens then\n                        set p_state = \'query_script variable\';\n                    when v_char = \'.\' then\n                        if substr(p_text, v_from + 1, 1) between \'0\' and \'9\' then\n                            set p_state = \'decimal\', v_from = v_from + 1;\n                        else\n                            set p_state = \'dot\', v_from = v_from + 1;\n                            leave my_loop;\n                        end if;\n                    when v_char = \';\' then\n                        set p_state = \'statement delimiter\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \',\' then\n                        set p_state = \'comma\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'=\' then\n                        set p_state = \'equals\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'*\' then\n                        set p_state = \'multiply\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'%\' then\n                        set p_state = \'modulo\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'/\' then\n                        if v_lookahead = \'*\' then\n                            set v_from = locate(\'*/\', p_text, p_from + 2);\n                            if v_from then\n                                set p_state = if (substr(p_text, p_from + 2, 1) = \'!\', \'conditional comment\', \'multi line comment\')\n                                ,   v_from = v_from + 2\n                                ;\n                                leave my_loop;\n                            else\n                                set p_state = \'error\';\n                            end if;\n                        else\n                            set p_state = \'divide\', v_from = v_from + 1;\n                            leave my_loop;\n                        end if;\n                    when v_char = \'-\' then\n                        case \n                            when v_lookahead = \'-\' and substr(p_text, v_from + 2, 1) = \' \' then\n                                set p_state = \'single line comment\'\n                                ,   v_from = locate(\'\\n\', p_text, p_from)\n                                ;\n                                if not v_from then\n                                    set v_from = v_length;\n                                end if;\n                                set v_from = v_from + 1;\n                                leave my_loop;\n                            else\n                                set p_state = \'minus\', v_from = v_from + 1;\n                                leave my_loop;\n                        end case;\n                    when v_char = \'#\' then\n                        set p_state = \'single line comment\'\n                        ,   v_from = locate(\'\\n\', p_text, p_from)\n                        ;\n                        if not v_from then\n                            set v_from = v_length;\n                        end if;\n                        set v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'+\' then\n                        set p_state = \'plus\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'<\' then \n                        set p_state = \'less than\';\n                    when v_char = \'>\' then \n                        set p_state = \'greater than\';\n                    when v_char = \':\' then \n                        if v_lookahead = \'=\' then\n                            set p_state = \'assign\', v_from = v_from + 2;\n                            leave my_loop;\n                        elseif v_lookahead = \'$\' and allow_script_tokens then\n                            set p_state = \'expanded query_script variable\';\n                        else\n                            set p_state = \'colon\', v_from = v_from + 1;\n                            leave my_loop;\n                        end if;\n                    when v_char = \'{\' and allow_script_tokens then \n                        set p_state = \'left braces\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \'}\' and allow_script_tokens then \n                        set p_state = \'right braces\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'(\' then \n                        set p_state = \'left parenthesis\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \')\' then \n                        set p_state = \'right parenthesis\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'^\' then \n                        set p_state = \'bitwise xor\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'~\' then \n                        set p_state = \'bitwise not\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'!\' then\n                        if v_lookahead = \'=\' then\n                            set p_state = \'not equals\', v_from = v_from + 2;\n                        else\n                            set p_state = \'not\', v_from = v_from + 1;\n                        end if;\n                        leave my_loop;\n                    when v_char = \'|\' then\n                        if v_lookahead = \'|\' then\n                            set p_state = \'or\', v_from = v_from + 2;\n                        else\n                            set p_state = \'bitwise or\', v_from = v_from + 1;\n                        end if;\n                        leave my_loop;\n                    when v_char = \'&\' then\n                        if v_lookahead = \'&\' then\n                            set p_state = \'and\', v_from = v_from + 2;\n                        else\n                            set p_state = \'bitwise and\', v_from = v_from + 1;\n                        end if;\n                        leave my_loop;\n                    else \n                        set p_state = \'error\';\n                end case;\n            when \'less than\' then\n                case v_char \n                    when \'=\' then \n                        set p_state = \'less than or equals\';\n                        leave state_case;\n                    when \'>\' then \n                        set p_state = \'not equals\';\n                    when \'<\' then \n                        set p_state = \'left shift\';\n                    else\n                        do null;\n                end case;\n                leave my_loop;\n            when \'less than or equals\' then\n                if v_char = \'>\' then \n                    set p_state = \'null safe equals\'\n                    ,   v_from = v_from + 1\n                    ;\n                end if;\n                leave my_loop;\n            when \'greater than\' then\n                case v_char \n                    when \'=\' then \n                        set p_state = \'greater than or equals\';\n                    when \'>\' then \n                        set p_state = \'right shift\';\n                    else\n                        set p_state = \'error\';\n                end case;\n                leave my_loop;\n            when \'multi line comment\' then\n                if v_char = \'*\' and v_lookahead = \'/\' then\n                    set v_from = v_from + 2;\n                    leave my_loop;\n                end if;\n            when \'alpha\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        leave state_case;\n                    when v_char between \'0\' and \'9\' \n                    or   v_char = \'$\' then \n                        set p_state = \'alphanum\';\n                    else\n                        leave my_loop;\n                end case;\n            when \'alphanum\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\'\n                    or   v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'integer\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    when v_char = \'.\' then \n                        set p_state = \'decimal\';\n                    else\n                        leave my_loop;                        \n                end case;\n            when \'decimal\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'whitespace\' then\n                if v_char not in (\'\\t\', \'\\n\', \'\\r\') then\n                    leave my_loop;                        \n                end if;\n            when \'string\' then\n                set v_from = locate(v_quote_char, p_text, v_from);\n                if v_from then\n                    if substr(p_text, v_from + 1, 1) = v_quote_char then\n                        set v_from = v_from + 1;\n                    elseif substr(p_text, v_from - 1, 1) != \'\\\\\' then\n                        set v_from = v_from + 1;\n                        leave my_loop;\n                    end if;\n                else\n                    set p_state = \'error\';\n                    leave my_loop;\n                end if;\n            when \'quoted identifier\' then\n                if v_char != v_quote_char then \n                    leave state_case;\n                else\n                    set v_from = v_from + 1;\n                    leave my_loop;                \n                end if;\n            when \'user-defined variable\' then\n                if v_char in (\';\', \',\', \' \', \'\\t\', \'\\n\', \'\\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\') then\n                    leave my_loop;\n                end if;\n            when \'query_script variable\' then\n                if v_char in (\';\', \',\', \' \', \'\\t\', \'\\n\', \'\\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\', \'.\') then\n                    leave my_loop;\n                end if;\n            when \'expanded query_script variable\' then\n                if v_char in (\';\', \',\', \' \', \'\\t\', \'\\n\', \'\\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\', \'.\') then\n                    leave my_loop;\n                end if;\n            when \'system variable\' then\n                if v_char in (\';\', \',\', \' \', \'\\t\', \'\\n\', \'\\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\') then\n                    leave my_loop;\n                end if;\n            else\n                leave my_loop;            \n        end case; end state_case;\n        set v_from = v_from + 1;\n    end while my_loop;\n    set p_token = substr(p_text, p_from, v_from - p_from) collate utf8_general_ci;\n    set p_from = v_from;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads a token according to lexical rules for SQL','utf8','utf8_general_ci','utf8_general_ci','begin    \n    declare v_length int unsigned default character_length(p_text);\n    declare v_no_ansi_quotes        bool default find_in_set(\'ANSI_QUOTES\', @@sql_mode) = FALSE;\n    declare v_char, v_lookahead, v_quote_char    char(1) charset utf8;\n    declare v_from int unsigned;\n\n    if p_from is null then\n        set p_from = 1;\n    end if;\n    if p_level is null then\n        set p_level = 0;\n    end if;\n    if p_state = \'right parenthesis\' then\n        set p_level = p_level - 1;\n    end if;\n    if p_state = \'right braces\' and allow_script_tokens then\n        set p_level = p_level - 1;\n    end if;\n    set v_from = p_from;\n    \n    set p_token = \'\'\n    ,   p_state = \'start\';\n    my_loop: while v_from <= v_length do\n        set v_char = substr(p_text, v_from, 1)\n        ,   v_lookahead = substr(p_text, v_from+1, 1)\n        ;\n        state_case: begin case p_state\n            when \'error\' then \n                set p_from = v_length;\n                leave state_case;            \n            when \'start\' then\n                case\n                    when v_char between \'0\' and \'9\' then \n                        set p_state = \'integer\';\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        set p_state = \'alpha\';                        \n                    when v_char = \' \' then \n                        set p_state = \'whitespace\'\n                        ,   v_from = v_length - character_length(ltrim(substring(p_text, v_from)))\n                        ;\n                        leave state_case;\n                    when v_char in (\'	\', \'\n\', \'\r\') then \n                        set p_state = \'whitespace\';\n                    when v_char = \'\'\' or v_no_ansi_quotes and v_char = \'\"\' then\n                        set p_state = \'string\', v_quote_char = v_char;\n                    when v_char = \'`\' or v_no_ansi_quotes = FALSE and v_char = \'\"\' then\n                        set p_state = \'quoted identifier\', v_quote_char = v_char;\n                    when v_char = \'@\' then\n                        if v_lookahead = \'@\' then\n                            set p_state = \'system variable\', v_from = v_from + 1;\n                        else\n                            set p_state = \'user-defined variable\';\n                        end if;\n                    when v_char = \'$\' and allow_script_tokens then\n                        set p_state = \'query_script variable\';\n                    when v_char = \'.\' then\n                        if substr(p_text, v_from + 1, 1) between \'0\' and \'9\' then\n                            set p_state = \'decimal\', v_from = v_from + 1;\n                        else\n                            set p_state = \'dot\', v_from = v_from + 1;\n                            leave my_loop;\n                        end if;\n                    when v_char = \';\' then\n                        set p_state = \'statement delimiter\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \',\' then\n                        set p_state = \'comma\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'=\' then\n                        set p_state = \'equals\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'*\' then\n                        set p_state = \'multiply\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'%\' then\n                        set p_state = \'modulo\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'/\' then\n                        if v_lookahead = \'*\' then\n                            set v_from = locate(\'*/\', p_text, p_from + 2);\n                            if v_from then\n                                set p_state = if (substr(p_text, p_from + 2, 1) = \'!\', \'conditional comment\', \'multi line comment\')\n                                ,   v_from = v_from + 2\n                                ;\n                                leave my_loop;\n                            else\n                                set p_state = \'error\';\n                            end if;\n                        else\n                            set p_state = \'divide\', v_from = v_from + 1;\n                            leave my_loop;\n                        end if;\n                    when v_char = \'-\' then\n                        case \n                            when v_lookahead = \'-\' and substr(p_text, v_from + 2, 1) = \' \' then\n                                set p_state = \'single line comment\'\n                                ,   v_from = locate(\'\n\', p_text, p_from)\n                                ;\n                                if not v_from then\n                                    set v_from = v_length;\n                                end if;\n                                set v_from = v_from + 1;\n                                leave my_loop;\n                            else\n                                set p_state = \'minus\', v_from = v_from + 1;\n                                leave my_loop;\n                        end case;\n                    when v_char = \'#\' then\n                        set p_state = \'single line comment\'\n                        ,   v_from = locate(\'\n\', p_text, p_from)\n                        ;\n                        if not v_from then\n                            set v_from = v_length;\n                        end if;\n                        set v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'+\' then\n                        set p_state = \'plus\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'<\' then \n                        set p_state = \'less than\';\n                    when v_char = \'>\' then \n                        set p_state = \'greater than\';\n                    when v_char = \':\' then \n                        if v_lookahead = \'=\' then\n                            set p_state = \'assign\', v_from = v_from + 2;\n                            leave my_loop;\n                        elseif v_lookahead = \'$\' and allow_script_tokens then\n                            set p_state = \'expanded query_script variable\';\n                        else\n                            set p_state = \'colon\', v_from = v_from + 1;\n                            leave my_loop;\n                        end if;\n                    when v_char = \'{\' and allow_script_tokens then \n                        set p_state = \'left braces\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \'}\' and allow_script_tokens then \n                        set p_state = \'right braces\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'(\' then \n                        set p_state = \'left parenthesis\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \')\' then \n                        set p_state = \'right parenthesis\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'^\' then \n                        set p_state = \'bitwise xor\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'~\' then \n                        set p_state = \'bitwise not\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'!\' then\n                        if v_lookahead = \'=\' then\n                            set p_state = \'not equals\', v_from = v_from + 2;\n                        else\n                            set p_state = \'not\', v_from = v_from + 1;\n                        end if;\n                        leave my_loop;\n                    when v_char = \'|\' then\n                        if v_lookahead = \'|\' then\n                            set p_state = \'or\', v_from = v_from + 2;\n                        else\n                            set p_state = \'bitwise or\', v_from = v_from + 1;\n                        end if;\n                        leave my_loop;\n                    when v_char = \'&\' then\n                        if v_lookahead = \'&\' then\n                            set p_state = \'and\', v_from = v_from + 2;\n                        else\n                            set p_state = \'bitwise and\', v_from = v_from + 1;\n                        end if;\n                        leave my_loop;\n                    else \n                        set p_state = \'error\';\n                end case;\n            when \'less than\' then\n                case v_char \n                    when \'=\' then \n                        set p_state = \'less than or equals\';\n                        leave state_case;\n                    when \'>\' then \n                        set p_state = \'not equals\';\n                    when \'<\' then \n                        set p_state = \'left shift\';\n                    else\n                        do null;\n                end case;\n                leave my_loop;\n            when \'less than or equals\' then\n                if v_char = \'>\' then \n                    set p_state = \'null safe equals\'\n                    ,   v_from = v_from + 1\n                    ;\n                end if;\n                leave my_loop;\n            when \'greater than\' then\n                case v_char \n                    when \'=\' then \n                        set p_state = \'greater than or equals\';\n                    when \'>\' then \n                        set p_state = \'right shift\';\n                    else\n                        set p_state = \'error\';\n                end case;\n                leave my_loop;\n            when \'multi line comment\' then\n                if v_char = \'*\' and v_lookahead = \'/\' then\n                    set v_from = v_from + 2;\n                    leave my_loop;\n                end if;\n            when \'alpha\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        leave state_case;\n                    when v_char between \'0\' and \'9\' \n                    or   v_char = \'$\' then \n                        set p_state = \'alphanum\';\n                    else\n                        leave my_loop;\n                end case;\n            when \'alphanum\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\'\n                    or   v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'integer\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    when v_char = \'.\' then \n                        set p_state = \'decimal\';\n                    else\n                        leave my_loop;                        \n                end case;\n            when \'decimal\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'whitespace\' then\n                if v_char not in (\'	\', \'\n\', \'\r\') then\n                    leave my_loop;                        \n                end if;\n            when \'string\' then\n                set v_from = locate(v_quote_char, p_text, v_from);\n                if v_from then\n                    if substr(p_text, v_from + 1, 1) = v_quote_char then\n                        set v_from = v_from + 1;\n                    elseif substr(p_text, v_from - 1, 1) != \'\\\' then\n                        set v_from = v_from + 1;\n                        leave my_loop;\n                    end if;\n                else\n                    set p_state = \'error\';\n                    leave my_loop;\n                end if;\n            when \'quoted identifier\' then\n                if v_char != v_quote_char then \n                    leave state_case;\n                else\n                    set v_from = v_from + 1;\n                    leave my_loop;                \n                end if;\n            when \'user-defined variable\' then\n                if v_char in (\';\', \',\', \' \', \'	\', \'\n\', \'\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\') then\n                    leave my_loop;\n                end if;\n            when \'query_script variable\' then\n                if v_char in (\';\', \',\', \' \', \'	\', \'\n\', \'\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\', \'.\') then\n                    leave my_loop;\n                end if;\n            when \'expanded query_script variable\' then\n                if v_char in (\';\', \',\', \' \', \'	\', \'\n\', \'\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\', \'.\') then\n                    leave my_loop;\n                end if;\n            when \'system variable\' then\n                if v_char in (\';\', \',\', \' \', \'	\', \'\n\', \'\r\', \'!\', \'~\', \'^\', \'%\', \'>\', \'<\', \':\', \'=\', \'+\', \'-\', \'&\', \'*\', \'|\', \'(\', \')\') then\n                    leave my_loop;\n                elseif allow_script_tokens and v_char in (\'{\', \'}\') then\n                    leave my_loop;\n                end if;\n            else\n                leave my_loop;            \n        end case; end state_case;\n        set v_from = v_from + 1;\n    end while my_loop;\n    set p_token = substr(p_text, p_from, v_from - p_from) collate utf8_general_ci;\n    set p_from = v_from;\nend'),('common_schema','_requalify_grantee_term','FUNCTION','_requalify_grantee_term','SQL','NO_SQL','YES','INVOKER','grantee_term TINYTEXT CHARSET utf8','tinytext CHARSET utf8','BEGIN\n  declare tokens_delimiter VARCHAR(64) CHARSET ascii DEFAULT NULL;\n  declare num_tokens INT UNSIGNED DEFAULT 0;\n\n  set grantee_term := _retokenized_text(grantee_term, \'@\', \'\'\'\', TRUE, \'error\');\n  set tokens_delimiter := @common_schema_retokenized_delimiter;\n  set num_tokens := @common_schema_retokenized_count;\n  \n  if num_tokens = 1 then\n    return unquote(grantee_term);\n  end if;\n  if num_tokens = 2 then\n    return mysql_grantee(unquote(SUBSTRING_INDEX(grantee_term, tokens_delimiter, 1)), unquote(SUBSTRING_INDEX(grantee_term, tokens_delimiter, -1)));\n  end if;\n  return null;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Requalify grantee input','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  declare tokens_delimiter VARCHAR(64) CHARSET ascii DEFAULT NULL;\n  declare num_tokens INT UNSIGNED DEFAULT 0;\n\n  set grantee_term := _retokenized_text(grantee_term, \'@\', \'\'\', TRUE, \'error\');\n  set tokens_delimiter := @common_schema_retokenized_delimiter;\n  set num_tokens := @common_schema_retokenized_count;\n  \n  if num_tokens = 1 then\n    return unquote(grantee_term);\n  end if;\n  if num_tokens = 2 then\n    return mysql_grantee(unquote(SUBSTRING_INDEX(grantee_term, tokens_delimiter, 1)), unquote(SUBSTRING_INDEX(grantee_term, tokens_delimiter, -1)));\n  end if;\n  return null;\nEND'),('common_schema','killall','PROCEDURE','killall','SQL','READS_SQL_DATA','NO','INVOKER','IN grantee_term TINYTEXT CHARSET utf8','','begin\n  set grantee_term := _requalify_grantee_term(grantee_term);\n  \n  begin\n    declare kill_process_id bigint unsigned default null;\n    declare done tinyint default 0;\n    declare killall_cursor cursor for \n      select \n        id \n      from \n        _processlist_grantees_exploded \n      where \n        grantee_term in (grantee, unqualified_grantee, grantee_host, grantee_user, qualified_user_host, unqualified_user_host, hostname, user)\n        and id != CONNECTION_ID()\n      ;\n    declare continue handler for NOT FOUND set done = 1;\n    declare continue handler for 1094 begin end; \n  \n    \n    \n    \n    \n    open killall_cursor;\n    read_loop: loop\n      fetch killall_cursor into kill_process_id;\n      if done then\n        leave read_loop;\n      end if;\n      kill kill_process_id;\n    end loop;\n\n    close killall_cursor;\n  end;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Kills connections based on grantee term','utf8','utf8_general_ci','utf8_general_ci','begin\n  set grantee_term := _requalify_grantee_term(grantee_term);\n  \n  begin\n    declare kill_process_id bigint unsigned default null;\n    declare done tinyint default 0;\n    declare killall_cursor cursor for \n      select \n        id \n      from \n        _processlist_grantees_exploded \n      where \n        grantee_term in (grantee, unqualified_grantee, grantee_host, grantee_user, qualified_user_host, unqualified_user_host, hostname, user)\n        and id != CONNECTION_ID()\n      ;\n    declare continue handler for NOT FOUND set done = 1;\n    declare continue handler for 1094 begin end; \n  \n    \n    \n    \n    \n    open killall_cursor;\n    read_loop: loop\n      fetch killall_cursor into kill_process_id;\n      if done then\n        leave read_loop;\n      end if;\n      kill kill_process_id;\n    end loop;\n\n    close killall_cursor;\n  end;\nend'),('common_schema','security_audit','PROCEDURE','security_audit','SQL','READS_SQL_DATA','NO','INVOKER','','','begin\n  call _run_named_script(\'security_audit\');\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Kills connections based on grantee term','utf8','utf8_general_ci','utf8_general_ci','begin\n  call _run_named_script(\'security_audit\');\nend'),('common_schema','table_exists','FUNCTION','table_exists','SQL','READS_SQL_DATA','YES','INVOKER','\n  lookup_table_schema varchar(64) charset utf8, \n  lookup_table_name varchar(64) charset utf8','tinyint(3) unsigned','BEGIN\n  return (select count(*) from INFORMATION_SCHEMA.TABLES \n    where TABLE_SCHEMA = lookup_table_schema AND TABLE_NAME = lookup_table_name);\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Check if specified table exists','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  return (select count(*) from INFORMATION_SCHEMA.TABLES \n    where TABLE_SCHEMA = lookup_table_schema AND TABLE_NAME = lookup_table_name);\nEND'),('common_schema','_consume_expression','PROCEDURE','_consume_expression','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   require_parenthesis tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   out  expression text charset utf8,\n   out  expression_statement text charset utf8,\n   in   should_execute_statement tinyint unsigned\n','','main_body: begin\n    declare first_state text;\n    declare expression_level int unsigned;\n    declare id_end_expression int unsigned; \n    declare expanded_variables TEXT CHARSET utf8;\n    declare expanded_variables_found tinyint unsigned;\n    \n    set expression_statement := NULL ;\n    \n    call _skip_spaces(id_from, id_to);\n    SELECT level, state FROM _sql_tokens WHERE id = id_from INTO expression_level, first_state;\n\n    if (first_state = \'left parenthesis\') then\n      SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right parenthesis\' AND level = expression_level INTO id_end_expression;\n  	  if id_end_expression IS NULL then\n	    call _throw_script_error(id_from, \'Unmatched \"(\" parenthesis\');\n	  end if;\n	  set id_from := id_from + 1;\n      call _skip_spaces(id_from, id_to);\n      \n      call _expand_statement_variables(id_from, id_end_expression-1, expression, expanded_variables_found, should_execute_statement);\n      \n      \n      \n      SELECT token FROM _sql_tokens WHERE id = id_from AND state = \'alpha\' INTO expression_statement;\n      if ((expression is NULL) or (trim_wspace(expression) = \'\')) and (should_execute_statement or not expanded_variables_found) then\n        call _throw_script_error(id_from, \'Found empty expression\');\n      end if;\n      \n      set consumed_to_id := id_end_expression;\n    else\n      if require_parenthesis then\n        call _throw_script_error(id_from, \'Expected \"(\" on expression\');\n      end if;\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads expression','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare first_state text;\n    declare expression_level int unsigned;\n    declare id_end_expression int unsigned; \n    declare expanded_variables TEXT CHARSET utf8;\n    declare expanded_variables_found tinyint unsigned;\n    \n    set expression_statement := NULL ;\n    \n    call _skip_spaces(id_from, id_to);\n    SELECT level, state FROM _sql_tokens WHERE id = id_from INTO expression_level, first_state;\n\n    if (first_state = \'left parenthesis\') then\n      SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right parenthesis\' AND level = expression_level INTO id_end_expression;\n  	  if id_end_expression IS NULL then\n	    call _throw_script_error(id_from, \'Unmatched \"(\" parenthesis\');\n	  end if;\n	  set id_from := id_from + 1;\n      call _skip_spaces(id_from, id_to);\n      \n      call _expand_statement_variables(id_from, id_end_expression-1, expression, expanded_variables_found, should_execute_statement);\n      \n      \n      \n      SELECT token FROM _sql_tokens WHERE id = id_from AND state = \'alpha\' INTO expression_statement;\n      if ((expression is NULL) or (trim_wspace(expression) = \'\')) and (should_execute_statement or not expanded_variables_found) then\n        call _throw_script_error(id_from, \'Found empty expression\');\n      end if;\n      \n      set consumed_to_id := id_end_expression;\n    else\n      if require_parenthesis then\n        call _throw_script_error(id_from, \'Expected \"(\" on expression\');\n      end if;\n    end if;\nend'),('common_schema','_consume_foreach_expression','PROCEDURE','_consume_foreach_expression','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   out  consumed_to_id int unsigned,\n   in   depth int unsigned,\n   out  collection text charset utf8,\n   out  variables_array_id int unsigned,\n   out  variables_delaration_id int unsigned,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n    declare first_state text;\n    declare expression_level int unsigned;\n    declare id_end_expression int unsigned default NULL; \n    declare id_end_variables_definition int unsigned default NULL; \n    \n    call _skip_spaces(id_from, id_to);\n    SELECT level, state FROM _sql_tokens WHERE id = id_from INTO expression_level, first_state;\n\n    if (first_state != \'left parenthesis\') then\n      call _throw_script_error(id_from, \'Expected \"(\" on foreach expression\');\n    end if;\n    \n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right parenthesis\' AND level = expression_level INTO id_end_expression;\n  	if id_end_expression IS NULL then\n	  call _throw_script_error(id_from, \'Unmatched \"(\" parenthesis\');\n	end if;\n	\n	\n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'colon\' AND level = expression_level INTO id_end_variables_definition;\n  	if id_end_variables_definition IS NULL then\n	  call _throw_script_error(id_from, \'foreach: expected \":\" as in (variables : collection)\');\n	end if;\n	\n    set id_from := id_from + 1;\n	\n	\n    call _expect_dynamic_states_list(id_from, id_end_variables_definition-1, \'query_script variable\', variables_array_id);\n	set variables_delaration_id := id_from;\n	call _declare_local_variables(id_from, id_to, id_end_variables_definition, depth, variables_array_id);\n		\n    \n	set id_from := id_end_variables_definition + 1;\n    call _skip_spaces(id_from, id_to);\n\n    call _expand_statement_variables(id_from, id_end_expression-1, collection, @_common_schema_dummy, should_execute_statement);\n    \n\n    set consumed_to_id := id_end_expression;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads foreach() expression','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare first_state text;\n    declare expression_level int unsigned;\n    declare id_end_expression int unsigned default NULL; \n    declare id_end_variables_definition int unsigned default NULL; \n    \n    call _skip_spaces(id_from, id_to);\n    SELECT level, state FROM _sql_tokens WHERE id = id_from INTO expression_level, first_state;\n\n    if (first_state != \'left parenthesis\') then\n      call _throw_script_error(id_from, \'Expected \"(\" on foreach expression\');\n    end if;\n    \n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right parenthesis\' AND level = expression_level INTO id_end_expression;\n  	if id_end_expression IS NULL then\n	  call _throw_script_error(id_from, \'Unmatched \"(\" parenthesis\');\n	end if;\n	\n	\n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'colon\' AND level = expression_level INTO id_end_variables_definition;\n  	if id_end_variables_definition IS NULL then\n	  call _throw_script_error(id_from, \'foreach: expected \":\" as in (variables : collection)\');\n	end if;\n	\n    set id_from := id_from + 1;\n	\n	\n    call _expect_dynamic_states_list(id_from, id_end_variables_definition-1, \'query_script variable\', variables_array_id);\n	set variables_delaration_id := id_from;\n	call _declare_local_variables(id_from, id_to, id_end_variables_definition, depth, variables_array_id);\n		\n    \n	set id_from := id_end_variables_definition + 1;\n    call _skip_spaces(id_from, id_to);\n\n    call _expand_statement_variables(id_from, id_end_expression-1, collection, @_common_schema_dummy, should_execute_statement);\n    \n\n    set consumed_to_id := id_end_expression;\nend'),('common_schema','_consume_script_statement','PROCEDURE','_consume_script_statement','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   statement_id_from      int unsigned,\n   in   statement_id_to      int unsigned,\n   in   depth int unsigned,\n   in   script_statement text charset utf8,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare tokens_array_id int unsigned;\n  declare tokens_array_element text charset utf8;\n  declare matched_token text charset utf8;\n  declare statement_arguments text charset utf8;\n  declare expanded_variables_found tinyint unsigned;\n  \n  call _expand_statement_variables(id_from+1, statement_id_to, statement_arguments, expanded_variables_found, should_execute_statement);\n  \n  set tokens_array_id := NULL;\n  \n  case script_statement\n	when \'start\' then begin\n	    call _expect_token(statement_id_from, statement_id_to, \'transaction\', false, @_common_schema_dummy, @_common_schema_dummy);\n        if should_execute_statement then\n          start transaction;\n        end if;\n	  end;\n	when \'begin\' then begin\n		call _expect_nothing(statement_id_from, statement_id_to);\n        if should_execute_statement then\n          start transaction;\n        end if;\n	  end;\n	when \'commit\' then begin\n		call _expect_nothing(statement_id_from, statement_id_to);\n        if should_execute_statement then\n          commit;\n        end if;\n	  end;\n	when \'rollback\' then begin\n		call _expect_nothing(statement_id_from, statement_id_to);\n        if should_execute_statement then\n          rollback;\n        end if;\n	  end;\n	when \'echo\' then begin\n        if should_execute_statement then\n          select trim_wspace(statement_arguments) as echo;\n        end if;\n	  end;\n	when \'eval\' then begin\n        if should_execute_statement then\n          call eval(statement_arguments);\n        end if;\n	  end;\n	when \'pass\' then begin\n	    call _expect_nothing(statement_id_from, statement_id_to);\n	  end;\n	when \'sleep\' then begin\n	    call _expect_state(statement_id_from, statement_id_to, \'integer|decimal|user-defined variable|query_script variable\', false, @_common_schema_dummy, matched_token);\n	    \n        if should_execute_statement then\n          call exec(CONCAT(\'SET @_common_schema_intermediate_var := \', statement_arguments));\n          DO SLEEP(CAST(trim_wspace(@_common_schema_intermediate_var) AS DECIMAL(64, 2)));\n        end if;\n	  end;\n	when \'throttle\' then begin\n	    call _expect_state(statement_id_from, statement_id_to, \'integer|decimal|user-defined variable|query_script variable\', false, @_common_schema_dummy, matched_token);\n	    \n        if should_execute_statement then\n          call exec(CONCAT(\'SET @_common_schema_intermediate_var := \', statement_arguments));\n          call _throttle_script(CAST(trim_wspace(@_common_schema_intermediate_var) AS DECIMAL(64, 2)));\n        end if;\n	  end;\n    when \'throw\' then begin\n	    call _expect_state(statement_id_from, statement_id_to, \'string|user-defined variable|query_script variable\', false, @_common_schema_dummy, matched_token);\n        if should_execute_statement then\n          call exec(CONCAT(\'SET @_common_schema_intermediate_var := \', statement_arguments));\n          call throw(@_common_schema_intermediate_var);\n        end if;\n	  end;\n    when \'var\' then begin\n	    call _peek_states_list(statement_id_from, statement_id_to, \'query_script variable,assign\', true, true, false, @_common_schema_dummy, @_common_schema_peek_to_id);\n	    if @_common_schema_peek_to_id > 0 then\n	      \n	      call _declare_and_assign_local_variable(id_from, id_to, statement_id_from, @_common_schema_peek_to_id, statement_id_to, depth, should_execute_statement);\n	    else\n          call _expect_dynamic_states_list(statement_id_from, statement_id_to, \'query_script variable\', tokens_array_id);\n          call _declare_local_variables(id_from, id_to, statement_id_to, depth, tokens_array_id);\n	    end if;\n	  end;\n    when \'input\' then begin\n	    if @_common_schema_script_loop_nesting_level > 0 then\n          call _throw_script_error(id_from, CONCAT(\'Invalid loop nesting level for INPUT: \', @_common_schema_script_loop_nesting_level));\n	    end if;\n	    call _expect_dynamic_states_list(statement_id_from, statement_id_to, \'query_script variable\', tokens_array_id);\n		call _declare_local_variables(id_from, id_to, statement_id_to, depth, tokens_array_id);\n        if should_execute_statement then\n          call _assign_input_local_variables(tokens_array_id);\n        end if;\n	  end;\n	when \'report\' then begin\n        if should_execute_statement then\n          call _script_report(statement_arguments);\n        end if;\n	  end;\n    else begin \n	    \n	    call _throw_script_error(id_from, CONCAT(\'Unknown script statement: \"\', script_statement, \'\"\'));\n	  end;\n  end case;\n  if tokens_array_id is not null then\n    call _drop_array(tokens_array_id);\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads script statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare tokens_array_id int unsigned;\n  declare tokens_array_element text charset utf8;\n  declare matched_token text charset utf8;\n  declare statement_arguments text charset utf8;\n  declare expanded_variables_found tinyint unsigned;\n  \n  call _expand_statement_variables(id_from+1, statement_id_to, statement_arguments, expanded_variables_found, should_execute_statement);\n  \n  set tokens_array_id := NULL;\n  \n  case script_statement\n	when \'start\' then begin\n	    call _expect_token(statement_id_from, statement_id_to, \'transaction\', false, @_common_schema_dummy, @_common_schema_dummy);\n        if should_execute_statement then\n          start transaction;\n        end if;\n	  end;\n	when \'begin\' then begin\n		call _expect_nothing(statement_id_from, statement_id_to);\n        if should_execute_statement then\n          start transaction;\n        end if;\n	  end;\n	when \'commit\' then begin\n		call _expect_nothing(statement_id_from, statement_id_to);\n        if should_execute_statement then\n          commit;\n        end if;\n	  end;\n	when \'rollback\' then begin\n		call _expect_nothing(statement_id_from, statement_id_to);\n        if should_execute_statement then\n          rollback;\n        end if;\n	  end;\n	when \'echo\' then begin\n        if should_execute_statement then\n          select trim_wspace(statement_arguments) as echo;\n        end if;\n	  end;\n	when \'eval\' then begin\n        if should_execute_statement then\n          call eval(statement_arguments);\n        end if;\n	  end;\n	when \'pass\' then begin\n	    call _expect_nothing(statement_id_from, statement_id_to);\n	  end;\n	when \'sleep\' then begin\n	    call _expect_state(statement_id_from, statement_id_to, \'integer|decimal|user-defined variable|query_script variable\', false, @_common_schema_dummy, matched_token);\n	    \n        if should_execute_statement then\n          call exec(CONCAT(\'SET @_common_schema_intermediate_var := \', statement_arguments));\n          DO SLEEP(CAST(trim_wspace(@_common_schema_intermediate_var) AS DECIMAL(64, 2)));\n        end if;\n	  end;\n	when \'throttle\' then begin\n	    call _expect_state(statement_id_from, statement_id_to, \'integer|decimal|user-defined variable|query_script variable\', false, @_common_schema_dummy, matched_token);\n	    \n        if should_execute_statement then\n          call exec(CONCAT(\'SET @_common_schema_intermediate_var := \', statement_arguments));\n          call _throttle_script(CAST(trim_wspace(@_common_schema_intermediate_var) AS DECIMAL(64, 2)));\n        end if;\n	  end;\n    when \'throw\' then begin\n	    call _expect_state(statement_id_from, statement_id_to, \'string|user-defined variable|query_script variable\', false, @_common_schema_dummy, matched_token);\n        if should_execute_statement then\n          call exec(CONCAT(\'SET @_common_schema_intermediate_var := \', statement_arguments));\n          call throw(@_common_schema_intermediate_var);\n        end if;\n	  end;\n    when \'var\' then begin\n	    call _peek_states_list(statement_id_from, statement_id_to, \'query_script variable,assign\', true, true, false, @_common_schema_dummy, @_common_schema_peek_to_id);\n	    if @_common_schema_peek_to_id > 0 then\n	      \n	      call _declare_and_assign_local_variable(id_from, id_to, statement_id_from, @_common_schema_peek_to_id, statement_id_to, depth, should_execute_statement);\n	    else\n          call _expect_dynamic_states_list(statement_id_from, statement_id_to, \'query_script variable\', tokens_array_id);\n          call _declare_local_variables(id_from, id_to, statement_id_to, depth, tokens_array_id);\n	    end if;\n	  end;\n    when \'input\' then begin\n	    if @_common_schema_script_loop_nesting_level > 0 then\n          call _throw_script_error(id_from, CONCAT(\'Invalid loop nesting level for INPUT: \', @_common_schema_script_loop_nesting_level));\n	    end if;\n	    call _expect_dynamic_states_list(statement_id_from, statement_id_to, \'query_script variable\', tokens_array_id);\n		call _declare_local_variables(id_from, id_to, statement_id_to, depth, tokens_array_id);\n        if should_execute_statement then\n          call _assign_input_local_variables(tokens_array_id);\n        end if;\n	  end;\n	when \'report\' then begin\n        if should_execute_statement then\n          call _script_report(statement_arguments);\n        end if;\n	  end;\n    else begin \n	    \n	    call _throw_script_error(id_from, CONCAT(\'Unknown script statement: \"\', script_statement, \'\"\'));\n	  end;\n  end case;\n  if tokens_array_id is not null then\n    call _drop_array(tokens_array_id);\n  end if;\nend'),('common_schema','_consume_split_statement','PROCEDURE','_consume_split_statement','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   out  consumed_to_id int unsigned,\n   in   depth int unsigned,\n   out  split_table_schema tinytext charset utf8,\n   out  split_table_name tinytext charset utf8,\n   out  split_injected_action_statement text charset utf8,\n   out  split_injected_text tinytext charset utf8,\n   out	split_options varchar(2048) charset utf8,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n    declare first_state text;\n    declare expression_level int unsigned;\n    declare id_end_action_statement int unsigned default NULL; \n    declare id_end_split_table_declaration int unsigned default NULL; \n    declare query_type_supported tinyint unsigned;\n    declare tables_found varchar(32) charset ascii;\n    declare colon_exists tinyint unsigned default false;\n    declare found_explicit_table tinyint unsigned;\n    declare found_any_params tinyint unsigned;\n    declare found_possible_statement tinyint unsigned;\n    \n    call _skip_spaces(id_from, id_to);\n    SELECT level, state FROM _sql_tokens WHERE id = id_from INTO expression_level, first_state;\n\n    \n    if (first_state != \'left parenthesis\') then\n      call _throw_script_error(id_from, \'Expected \"(\" on split expression\');\n    end if;\n    \n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right parenthesis\' AND level = expression_level INTO id_end_action_statement;\n  	if id_end_action_statement IS NULL then\n	  call _throw_script_error(id_from, \'Unmatched \"(\" parenthesis\');\n	end if;\n	\n	\n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'colon\' AND level = expression_level INTO id_end_split_table_declaration;\n    set colon_exists := (id_end_split_table_declaration IS NOT NULL);\n  	if id_end_split_table_declaration IS NULL then\n  	  set id_end_split_table_declaration := id_end_action_statement;\n	end if;\n	\n    set id_from := id_from + 1;\n	\n    set split_injected_text := \'[:_query_script_split_injected_placeholder:]\';\n	\n    set found_possible_statement := true;\n    if colon_exists then\n      call _consume_split_statement_params(id_from, id_end_split_table_declaration-1, should_execute_statement, split_table_schema, split_table_name, split_options, found_explicit_table, found_any_params);\n      if not found_any_params then\n        call _throw_script_error(id_from, \'split: must indicate table or options before colon; otherwise drop colon\');\n      end if;\n\n      \n      set id_from := id_end_split_table_declaration + 1;\n      call _skip_spaces(id_from, id_to);\n    else\n      \n      call _consume_split_statement_params(id_from, id_end_split_table_declaration-1, should_execute_statement, split_table_schema, split_table_name, split_options, found_explicit_table, found_any_params);\n      if found_any_params then\n        \n        set found_possible_statement := false;\n      end if;\n    end if;\n    \n    if not (found_possible_statement or found_explicit_table) then\n      call _throw_script_error(id_from, \'split: no statement nor table provided. Provide at least either one\');\n    end if;\n    \n    if found_possible_statement then\n      if not found_explicit_table then\n        call _skip_spaces(id_from, id_end_action_statement - 1);\n        call _get_split_query_single_table(id_from, id_end_action_statement - 1, query_type_supported, tables_found, split_table_schema, split_table_name);\n        call _expand_single_variable(id_from, id_end_action_statement - 1, split_table_schema, should_execute_statement);\n        call _expand_single_variable(id_from, id_end_action_statement - 1, split_table_name, should_execute_statement);\n        if should_execute_statement and ((split_table_schema is null) or (split_table_name is null)) then\n          \n          call _throw_script_error(id_from, \'split() cannot deduce split table name. Please specify explicitly\');\n        end if;\n      end if;\n      call _inject_split_where_token(id_from, id_end_action_statement - 1, split_injected_text, should_execute_statement, split_injected_action_statement);\n    else\n      set split_injected_action_statement := CONCAT(\'SELECT COUNT(NULL) FROM \', mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \' WHERE \', split_injected_text, \' INTO @_common_schema_dummy\');\n    end if;\n    \n    set consumed_to_id := id_end_action_statement;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads split() expression','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare first_state text;\n    declare expression_level int unsigned;\n    declare id_end_action_statement int unsigned default NULL; \n    declare id_end_split_table_declaration int unsigned default NULL; \n    declare query_type_supported tinyint unsigned;\n    declare tables_found varchar(32) charset ascii;\n    declare colon_exists tinyint unsigned default false;\n    declare found_explicit_table tinyint unsigned;\n    declare found_any_params tinyint unsigned;\n    declare found_possible_statement tinyint unsigned;\n    \n    call _skip_spaces(id_from, id_to);\n    SELECT level, state FROM _sql_tokens WHERE id = id_from INTO expression_level, first_state;\n\n    \n    if (first_state != \'left parenthesis\') then\n      call _throw_script_error(id_from, \'Expected \"(\" on split expression\');\n    end if;\n    \n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right parenthesis\' AND level = expression_level INTO id_end_action_statement;\n  	if id_end_action_statement IS NULL then\n	  call _throw_script_error(id_from, \'Unmatched \"(\" parenthesis\');\n	end if;\n	\n	\n    SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'colon\' AND level = expression_level INTO id_end_split_table_declaration;\n    set colon_exists := (id_end_split_table_declaration IS NOT NULL);\n  	if id_end_split_table_declaration IS NULL then\n  	  set id_end_split_table_declaration := id_end_action_statement;\n	end if;\n	\n    set id_from := id_from + 1;\n	\n    set split_injected_text := \'[:_query_script_split_injected_placeholder:]\';\n	\n    set found_possible_statement := true;\n    if colon_exists then\n      call _consume_split_statement_params(id_from, id_end_split_table_declaration-1, should_execute_statement, split_table_schema, split_table_name, split_options, found_explicit_table, found_any_params);\n      if not found_any_params then\n        call _throw_script_error(id_from, \'split: must indicate table or options before colon; otherwise drop colon\');\n      end if;\n\n      \n      set id_from := id_end_split_table_declaration + 1;\n      call _skip_spaces(id_from, id_to);\n    else\n      \n      call _consume_split_statement_params(id_from, id_end_split_table_declaration-1, should_execute_statement, split_table_schema, split_table_name, split_options, found_explicit_table, found_any_params);\n      if found_any_params then\n        \n        set found_possible_statement := false;\n      end if;\n    end if;\n    \n    if not (found_possible_statement or found_explicit_table) then\n      call _throw_script_error(id_from, \'split: no statement nor table provided. Provide at least either one\');\n    end if;\n    \n    if found_possible_statement then\n      if not found_explicit_table then\n        call _skip_spaces(id_from, id_end_action_statement - 1);\n        call _get_split_query_single_table(id_from, id_end_action_statement - 1, query_type_supported, tables_found, split_table_schema, split_table_name);\n        call _expand_single_variable(id_from, id_end_action_statement - 1, split_table_schema, should_execute_statement);\n        call _expand_single_variable(id_from, id_end_action_statement - 1, split_table_name, should_execute_statement);\n        if should_execute_statement and ((split_table_schema is null) or (split_table_name is null)) then\n          \n          call _throw_script_error(id_from, \'split() cannot deduce split table name. Please specify explicitly\');\n        end if;\n      end if;\n      call _inject_split_where_token(id_from, id_end_action_statement - 1, split_injected_text, should_execute_statement, split_injected_action_statement);\n    else\n      set split_injected_action_statement := CONCAT(\'SELECT COUNT(NULL) FROM \', mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \' WHERE \', split_injected_text, \' INTO @_common_schema_dummy\');\n    end if;\n    \n    set consumed_to_id := id_end_action_statement;\nend'),('common_schema','_consume_split_statement_params','PROCEDURE','_consume_split_statement_params','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   should_execute_statement tinyint unsigned,\n   out  split_table_schema tinytext charset utf8,\n   out  split_table_name tinytext charset utf8,\n   out  split_options varchar(2048) charset utf8,\n   out  found_explicit_table tinyint unsigned,\n   out  found_any_params tinyint unsigned\n','','main_body: begin\n    declare expanded_statement mediumtext charset utf8;\n    declare options_value mediumtext charset utf8;\n    \n    call _skip_spaces(id_from, id_to);\n\n    set split_table_schema := null;\n    set split_table_name := null;\n    set split_options := null;\n    set found_explicit_table := false;\n\n    call _expand_statement_variables(id_from, id_to, expanded_statement, @_common_schema_dummy, should_execute_statement);\n    \n    if _is_options_format(expanded_statement) then\n      set split_options := expanded_statement;\n      set options_value := get_option(split_options, \'table\');\n      if options_value is not null then\n        if get_num_tokens(options_value, \'.\') = 2 then\n          set split_table_schema := unquote(split_token(options_value, \'.\', 1));\n          set split_table_name := unquote(split_token(options_value, \'.\', 2));\n          set found_explicit_table := true;\n        else\n          call _throw_script_error(id_from, \'\'\'table\'\' option in split(): expected format schema_name.table_name\');\n        end if;\n      end if;\n    else\n      begin\n        \n        declare peek_match_to int unsigned default NULL; \n        declare table_array_id varchar(16);\n        \n        call _create_array(table_array_id);\n        call _peek_states_list(id_from, id_to, \'alpha|alphanum|quoted identifier|expanded query_script variable,dot,alpha|alphanum|quoted identifier|expanded query_script variable\', false, false, true, table_array_id, peek_match_to);\n        if peek_match_to > 0 then\n          \n          call _get_array_element(table_array_id, \'1\', split_table_schema);		\n          call _get_array_element(table_array_id, \'3\', split_table_name);\n          call _expand_single_variable(id_from, id_to, split_table_schema, should_execute_statement);\n          call _expand_single_variable(id_from, id_to, split_table_name, should_execute_statement);\n          set split_table_schema := unquote(split_table_schema);\n          set split_table_name := unquote(split_table_name);\n\n          set found_explicit_table := true;\n        end if;\n        call _drop_array(table_array_id);\n      end;\n    end if;\n    set found_any_params := (split_options is not null) or (found_explicit_table);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads split() parameters','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare expanded_statement mediumtext charset utf8;\n    declare options_value mediumtext charset utf8;\n    \n    call _skip_spaces(id_from, id_to);\n\n    set split_table_schema := null;\n    set split_table_name := null;\n    set split_options := null;\n    set found_explicit_table := false;\n\n    call _expand_statement_variables(id_from, id_to, expanded_statement, @_common_schema_dummy, should_execute_statement);\n    \n    if _is_options_format(expanded_statement) then\n      set split_options := expanded_statement;\n      set options_value := get_option(split_options, \'table\');\n      if options_value is not null then\n        if get_num_tokens(options_value, \'.\') = 2 then\n          set split_table_schema := unquote(split_token(options_value, \'.\', 1));\n          set split_table_name := unquote(split_token(options_value, \'.\', 2));\n          set found_explicit_table := true;\n        else\n          call _throw_script_error(id_from, \'\'table\' option in split(): expected format schema_name.table_name\');\n        end if;\n      end if;\n    else\n      begin\n        \n        declare peek_match_to int unsigned default NULL; \n        declare table_array_id varchar(16);\n        \n        call _create_array(table_array_id);\n        call _peek_states_list(id_from, id_to, \'alpha|alphanum|quoted identifier|expanded query_script variable,dot,alpha|alphanum|quoted identifier|expanded query_script variable\', false, false, true, table_array_id, peek_match_to);\n        if peek_match_to > 0 then\n          \n          call _get_array_element(table_array_id, \'1\', split_table_schema);		\n          call _get_array_element(table_array_id, \'3\', split_table_name);\n          call _expand_single_variable(id_from, id_to, split_table_schema, should_execute_statement);\n          call _expand_single_variable(id_from, id_to, split_table_name, should_execute_statement);\n          set split_table_schema := unquote(split_table_schema);\n          set split_table_name := unquote(split_table_name);\n\n          set found_explicit_table := true;\n        end if;\n        call _drop_array(table_array_id);\n      end;\n    end if;\n    set found_any_params := (split_options is not null) or (found_explicit_table);\nend'),('common_schema','get_view_dependencies','PROCEDURE','get_view_dependencies','SQL','READS_SQL_DATA','YES','DEFINER','\n    IN p_table_schema VARCHAR(64) CHARSET utf8\n,   IN p_table_name VARCHAR(64) CHARSET utf8\n','','begin\n    declare v_view_definition longtext charset utf8;\n    declare exit handler for not found\n        select concat(\'View `\', p_table_schema, \'`.`\', p_table_name, \'` not found.\') error\n    ; \n    \n    select  view_definition\n    into    v_view_definition\n    from    information_schema.views\n    where   table_schema = p_table_schema\n    and     table_name = p_table_name;\n\n    call get_sql_dependencies(v_view_definition, p_table_schema);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n    declare v_view_definition longtext charset utf8;\n    declare exit handler for not found\n        select concat(\'View `\', p_table_schema, \'`.`\', p_table_name, \'` not found.\') error\n    ; \n    \n    select  view_definition\n    into    v_view_definition\n    from    information_schema.views\n    where   table_schema = p_table_schema\n    and     table_name = p_table_name;\n\n    call get_sql_dependencies(v_view_definition, p_table_schema);\nend'),('common_schema','$','PROCEDURE','$','SQL','MODIFIES_SQL_DATA','NO','INVOKER','collection TEXT CHARSET utf8, execute_queries TEXT CHARSET utf8','','begin\n  call foreach(collection, execute_queries);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Invoke queries per element of given collection','utf8','utf8_general_ci','utf8_general_ci','begin\n  call foreach(collection, execute_queries);\nend'),('common_schema','_is_select_query','FUNCTION','_is_select_query','SQL','NO_SQL','YES','INVOKER','input LONGTEXT CHARSET utf8','tinyint(3) unsigned','BEGIN\n  RETURN (LOCATE(\'select\', LOWER(trim_wspace(input))) = 1);\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns 1 when given input starts with SELECT','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN (LOCATE(\'select\', LOWER(trim_wspace(input))) = 1);\nEND'),('common_schema','crc64','FUNCTION','crc64','SQL','NO_SQL','YES','INVOKER','data LONGTEXT CHARSET utf8','bigint(20) unsigned','BEGIN\n  RETURN CONV(LEFT(MD5(data), 16), 16, 10);\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return a 64 bit CRC of given input, as unsigned big integer','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN CONV(LEFT(MD5(data), 16), 16, 10);\nEND'),('common_schema','exec','PROCEDURE','exec','SQL','MODIFIES_SQL_DATA','NO','INVOKER','IN execute_queries TEXT CHARSET utf8','','begin\n  declare num_query_tokens, queries_loop_counter INT UNSIGNED DEFAULT 0;\n  declare single_query TEXT CHARSET utf8; \n  \n  \n  set execute_queries := _retokenized_queries(execute_queries);\n  set num_query_tokens := @common_schema_retokenized_count;\n  set queries_loop_counter := 0;\n  while queries_loop_counter < num_query_tokens do\n    set single_query := split_token(execute_queries, @common_schema_retokenized_delimiter, queries_loop_counter + 1);\n    call exec_single(single_query);\n    set queries_loop_counter := queries_loop_counter + 1;\n  end while;    \nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare num_query_tokens, queries_loop_counter INT UNSIGNED DEFAULT 0;\n  declare single_query TEXT CHARSET utf8; \n  \n  \n  set execute_queries := _retokenized_queries(execute_queries);\n  set num_query_tokens := @common_schema_retokenized_count;\n  set queries_loop_counter := 0;\n  while queries_loop_counter < num_query_tokens do\n    set single_query := split_token(execute_queries, @common_schema_retokenized_delimiter, queries_loop_counter + 1);\n    call exec_single(single_query);\n    set queries_loop_counter := queries_loop_counter + 1;\n  end while;    \nend'),('common_schema','exec_file','PROCEDURE','exec_file','SQL','MODIFIES_SQL_DATA','NO','INVOKER','IN file_name TEXT CHARSET utf8','','begin\n  call exec(LOAD_FILE(file_name));	\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Executes queries from given file','utf8','utf8_general_ci','utf8_general_ci','begin\n  call exec(LOAD_FILE(file_name));	\nend'),('common_schema','repeat_exec','PROCEDURE','repeat_exec','SQL','MODIFIES_SQL_DATA','NO','INVOKER','interval_seconds DOUBLE, execute_queries TEXT CHARSET utf8, stop_condition TEXT CHARSET utf8','','_proc_body: begin\n  declare repeat_complete TINYINT UNSIGNED DEFAULT 0;\n  declare num_iterations INT UNSIGNED DEFAULT 0;\n  declare stop_iterations INT UNSIGNED DEFAULT NULL;\n  declare stop_seconds INT UNSIGNED DEFAULT NULL;\n  declare start_timestamp TIMESTAMP DEFAULT NOW();\n  declare stop_condition_type enum(\'invalid\', \'no_limit\', \'no_affected\', \'iterations\', \'time\', \'query\') DEFAULT \'invalid\';\n  \n  if stop_condition IS NULL then\n    set stop_condition_type := \'no_limit\';\n  elseif stop_condition = \'0\' then\n    set stop_condition_type := \'no_affected\';\n  elseif stop_condition rlike \'^[0-9]+$\' then\n    set stop_iterations := CAST(stop_condition AS UNSIGNED INTEGER);\n    set stop_condition_type := \'iterations\';\n  elseif CHAR_LENGTH(stop_condition) <= 16 then\n    \n    set stop_seconds := shorttime_to_seconds(stop_condition);\n    if stop_seconds IS NOT NULL then\n      set stop_condition_type := \'time\';\n    end if;\n  elseif _is_select_query(stop_condition) then\n    set stop_condition_type := \'query\';\n    set @repeat_exec_stop_condition_query := CONCAT(\'SELECT (\', stop_condition, \') INTO @repeat_exec_query_condition\');\n  end if;\n\n  if stop_condition_type = \'invalid\' then\n    \n    \n    set @common_schema_error := \'repeat_exec: invalid stop_condition\';\n    leave _proc_body;\n  end if;\n  \n  repeat\n    set num_iterations := num_iterations + 1;\n    set @_execute_queries := REPLACE(execute_queries, \'${NR}\', num_iterations);\n    call exec(@_execute_queries);\n    \n    if stop_condition_type = \'no_limit\' then\n      \n      set repeat_complete := 0;\n    elseif stop_condition_type = \'no_affected\' then\n      if @common_schema_rowcount = 0 then\n        set repeat_complete := 1;\n      end if;\n    elseif stop_condition_type = \'time\' then\n      if TIMESTAMPDIFF(SECOND, start_timestamp, SYSDATE()) >= stop_seconds then \n	    set repeat_complete := 1;\n	  end if;\n    elseif stop_condition_type = \'iterations\' then\n      if num_iterations >= stop_iterations then\n        set repeat_complete := 1;\n      end if;\n    elseif stop_condition_type = \'query\' then\n      PREPARE st FROM @repeat_exec_stop_condition_query;\n      EXECUTE st;\n      DEALLOCATE PREPARE st;\n      if @repeat_exec_query_condition then\n        set repeat_complete := 1;\n      end if;\n    end if;\n    \n    if repeat_complete = 0 then\n      if IFNULL(interval_seconds, 0) > 0 then\n        DO SLEEP(interval_seconds);\n      end if;\n    end if;\n  until repeat_complete\n  end repeat;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','_proc_body: begin\n  declare repeat_complete TINYINT UNSIGNED DEFAULT 0;\n  declare num_iterations INT UNSIGNED DEFAULT 0;\n  declare stop_iterations INT UNSIGNED DEFAULT NULL;\n  declare stop_seconds INT UNSIGNED DEFAULT NULL;\n  declare start_timestamp TIMESTAMP DEFAULT NOW();\n  declare stop_condition_type enum(\'invalid\', \'no_limit\', \'no_affected\', \'iterations\', \'time\', \'query\') DEFAULT \'invalid\';\n  \n  if stop_condition IS NULL then\n    set stop_condition_type := \'no_limit\';\n  elseif stop_condition = \'0\' then\n    set stop_condition_type := \'no_affected\';\n  elseif stop_condition rlike \'^[0-9]+$\' then\n    set stop_iterations := CAST(stop_condition AS UNSIGNED INTEGER);\n    set stop_condition_type := \'iterations\';\n  elseif CHAR_LENGTH(stop_condition) <= 16 then\n    \n    set stop_seconds := shorttime_to_seconds(stop_condition);\n    if stop_seconds IS NOT NULL then\n      set stop_condition_type := \'time\';\n    end if;\n  elseif _is_select_query(stop_condition) then\n    set stop_condition_type := \'query\';\n    set @repeat_exec_stop_condition_query := CONCAT(\'SELECT (\', stop_condition, \') INTO @repeat_exec_query_condition\');\n  end if;\n\n  if stop_condition_type = \'invalid\' then\n    \n    \n    set @common_schema_error := \'repeat_exec: invalid stop_condition\';\n    leave _proc_body;\n  end if;\n  \n  repeat\n    set num_iterations := num_iterations + 1;\n    set @_execute_queries := REPLACE(execute_queries, \'${NR}\', num_iterations);\n    call exec(@_execute_queries);\n    \n    if stop_condition_type = \'no_limit\' then\n      \n      set repeat_complete := 0;\n    elseif stop_condition_type = \'no_affected\' then\n      if @common_schema_rowcount = 0 then\n        set repeat_complete := 1;\n      end if;\n    elseif stop_condition_type = \'time\' then\n      if TIMESTAMPDIFF(SECOND, start_timestamp, SYSDATE()) >= stop_seconds then \n	    set repeat_complete := 1;\n	  end if;\n    elseif stop_condition_type = \'iterations\' then\n      if num_iterations >= stop_iterations then\n        set repeat_complete := 1;\n      end if;\n    elseif stop_condition_type = \'query\' then\n      PREPARE st FROM @repeat_exec_stop_condition_query;\n      EXECUTE st;\n      DEALLOCATE PREPARE st;\n      if @repeat_exec_query_condition then\n        set repeat_complete := 1;\n      end if;\n    end if;\n    \n    if repeat_complete = 0 then\n      if IFNULL(interval_seconds, 0) > 0 then\n        DO SLEEP(interval_seconds);\n      end if;\n    end if;\n  until repeat_complete\n  end repeat;\nend'),('common_schema','shorttime_to_seconds','FUNCTION','shorttime_to_seconds','SQL','NO_SQL','YES','INVOKER','shorttime VARCHAR(16) CHARSET ascii','int(10) unsigned','begin\n  declare numeric_value INT UNSIGNED DEFAULT NULL;\n  \n  if shorttime is NULL then\n    return NULL;\n  end if;\n  if not shorttime rlike \'^[0-9]+[smh]$\' then\n    return NULL;\n  end if;\n\n  set numeric_value := CAST(LEFT(shorttime, CHAR_LENGTH(shorttime) - 1) AS UNSIGNED);\n  case RIGHT(shorttime, 1)\n    when \'s\' then set numeric_value := numeric_value*1;\n    when \'m\' then set numeric_value := numeric_value*60;\n    when \'h\' then set numeric_value := numeric_value*60*60;\n  end case;\n  return numeric_value;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return a 64 bit CRC of given input, as unsigned big integer','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare numeric_value INT UNSIGNED DEFAULT NULL;\n  \n  if shorttime is NULL then\n    return NULL;\n  end if;\n  if not shorttime rlike \'^[0-9]+[smh]$\' then\n    return NULL;\n  end if;\n\n  set numeric_value := CAST(LEFT(shorttime, CHAR_LENGTH(shorttime) - 1) AS UNSIGNED);\n  case RIGHT(shorttime, 1)\n    when \'s\' then set numeric_value := numeric_value*1;\n    when \'m\' then set numeric_value := numeric_value*60;\n    when \'h\' then set numeric_value := numeric_value*60*60;\n  end case;\n  return numeric_value;\nend'),('common_schema','throw','PROCEDURE','throw','SQL','NO_SQL','YES','INVOKER','error_message VARCHAR(1024) CHARSET utf8','','begin\n  declare error_statement VARCHAR(1500) CHARSET utf8;\n\n  set @common_schema_error := error_message;\n  set error_statement := CONCAT(\'SELECT error FROM error.`\', error_message, \'`\');\n  call exec_single(error_statement);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Raise an error','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare error_statement VARCHAR(1500) CHARSET utf8;\n\n  set @common_schema_error := error_message;\n  set error_statement := CONCAT(\'SELECT error FROM error.`\', error_message, \'`\');\n  call exec_single(error_statement);\nend'),('common_schema','_retokenized_queries','FUNCTION','_retokenized_queries','SQL','NO_SQL','YES','INVOKER','queries TEXT CHARSET utf8','text CHARSET utf8','begin\n  declare quoting_characters VARCHAR(5) CHARSET ascii DEFAULT \'`\'\'\';\n\n  if not find_in_set(\'ANSI_QUOTES\', @@sql_mode) then\n    set quoting_characters := CONCAT(quoting_characters, \'\"\');\n  end if;\n\n  return _retokenized_text(queries, \';\', quoting_characters, TRUE, \'skip\');\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Retokenizes input queries with special token','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare quoting_characters VARCHAR(5) CHARSET ascii DEFAULT \'`\'\';\n\n  if not find_in_set(\'ANSI_QUOTES\', @@sql_mode) then\n    set quoting_characters := CONCAT(quoting_characters, \'\"\');\n  end if;\n\n  return _retokenized_text(queries, \';\', quoting_characters, TRUE, \'skip\');\nend'),('common_schema','_retokenized_text','FUNCTION','_retokenized_text','SQL','NO_SQL','YES','INVOKER','\n  input_text TEXT CHARSET utf8, \n  delimiters VARCHAR(16) CHARSET utf8, \n  quoting_characters VARCHAR(16) CHARSET utf8,\n  trim_tokens BOOL,\n  empty_tokens_behavior enum(\'allow\', \'skip\', \'error\')\n','text CHARSET utf8','begin\n  declare current_pos INT UNSIGNED DEFAULT 1;\n  declare token_start_pos INT UNSIGNED DEFAULT 1;\n  declare terminating_quote_found BOOL DEFAULT FALSE;\n  declare terminating_quote_pos INT UNSIGNED DEFAULT 0;\n  declare terminating_quote_escape_char CHAR(1) CHARSET utf8;\n  declare current_char VARCHAR(1) CHARSET utf8;\n  declare quoting_char VARCHAR(1) CHARSET utf8;\n  declare current_token TEXT CHARSET utf8 DEFAULT \'\';\n  declare result_text TEXT CHARSET utf8 DEFAULT \'\';\n  declare delimiter_template VARCHAR(64) CHARSET ascii DEFAULT \'\\0[\\n}\\b+-\\t|%&{])/\\r~:;&\"%`@>?=<_common_schema_unlikely_token_\';\n  declare internal_delimiter_length TINYINT UNSIGNED DEFAULT 0;\n  declare internal_delimiter VARCHAR(64) CHARSET utf8 DEFAULT \'\';\n  \n  \n  set @common_schema_retokenized_delimiter := NULL;\n  set @common_schema_retokenized_count := NULL;\n\n  \n  \n  \n  _evaluate_internal_delimiter_loop: while internal_delimiter_length < CHAR_LENGTH(delimiter_template) do\n  	set internal_delimiter_length := internal_delimiter_length + 1;\n  	set internal_delimiter := LEFT(delimiter_template, internal_delimiter_length);\n  	if LOCATE(internal_delimiter, input_text) = 0 then\n  	  leave _evaluate_internal_delimiter_loop;\n  	end if;\n  end while;\n\n  while current_pos <= CHAR_LENGTH(input_text) + 1 do\n    if current_pos = CHAR_LENGTH(input_text) + 1 then\n      \n      \n      set current_char := LEFT(delimiters, 1);\n    else\n      set current_char := SUBSTRING(input_text, current_pos, 1);\n    end if;\n    if LOCATE(current_char, quoting_characters) > 0 then\n      \n      set quoting_char := current_char;\n      set terminating_quote_found := false;\n      while not terminating_quote_found do\n        set terminating_quote_pos := LOCATE(quoting_char, input_text, current_pos + 1);\n        if terminating_quote_pos = 0 then\n          \n          return NULL;\n        end if;\n        if terminating_quote_pos = current_pos + 1 then\n          \n          set terminating_quote_found := true;\n        else\n          \n          \n          set terminating_quote_escape_char := SUBSTRING(input_text, terminating_quote_pos - 1, 1);\n          if (terminating_quote_escape_char = quoting_char) or (terminating_quote_escape_char = \'\\\\\') then\n            \n            \n            set terminating_quote_found := false;        \n          else\n            set terminating_quote_found := true;            \n          end if;\n        end if;\n        set current_pos := terminating_quote_pos;\n      end while;\n    elseif LOCATE(current_char, delimiters) > 0 then\n      \n      set current_token := SUBSTRING(input_text, token_start_pos, current_pos - token_start_pos);\n      if trim_tokens then\n        set current_token := trim_wspace(current_token);\n      end if;\n      \n      if ((CHAR_LENGTH(current_token) = 0) and (empty_tokens_behavior = \'error\')) then\n        \n        return NULL;\n      end if;\n      if ((CHAR_LENGTH(current_token) > 0) or (empty_tokens_behavior = \'allow\')) then\n        \n        if CHAR_LENGTH(result_text) > 0 then\n          set result_text := CONCAT(result_text, internal_delimiter);\n        end if;\n        \n        set result_text := CONCAT(result_text, current_token);\n        set @common_schema_retokenized_count := 1 + IFNULL(@common_schema_retokenized_count, 0);\n      end if;\n      set token_start_pos := current_pos + 1;\n    end if;\n    set current_pos := current_pos + 1;\n  end while;\n  \n  \n  \n  \n  set @common_schema_retokenized_delimiter := internal_delimiter;\n  return result_text;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Retokenizes input_text with special token','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare current_pos INT UNSIGNED DEFAULT 1;\n  declare token_start_pos INT UNSIGNED DEFAULT 1;\n  declare terminating_quote_found BOOL DEFAULT FALSE;\n  declare terminating_quote_pos INT UNSIGNED DEFAULT 0;\n  declare terminating_quote_escape_char CHAR(1) CHARSET utf8;\n  declare current_char VARCHAR(1) CHARSET utf8;\n  declare quoting_char VARCHAR(1) CHARSET utf8;\n  declare current_token TEXT CHARSET utf8 DEFAULT \'\';\n  declare result_text TEXT CHARSET utf8 DEFAULT \'\';\n  declare delimiter_template VARCHAR(64) CHARSET ascii DEFAULT \'\0[\n}+-	|%&{])/\r~:;&\"%`@>?=<_common_schema_unlikely_token_\';\n  declare internal_delimiter_length TINYINT UNSIGNED DEFAULT 0;\n  declare internal_delimiter VARCHAR(64) CHARSET utf8 DEFAULT \'\';\n  \n  \n  set @common_schema_retokenized_delimiter := NULL;\n  set @common_schema_retokenized_count := NULL;\n\n  \n  \n  \n  _evaluate_internal_delimiter_loop: while internal_delimiter_length < CHAR_LENGTH(delimiter_template) do\n  	set internal_delimiter_length := internal_delimiter_length + 1;\n  	set internal_delimiter := LEFT(delimiter_template, internal_delimiter_length);\n  	if LOCATE(internal_delimiter, input_text) = 0 then\n  	  leave _evaluate_internal_delimiter_loop;\n  	end if;\n  end while;\n\n  while current_pos <= CHAR_LENGTH(input_text) + 1 do\n    if current_pos = CHAR_LENGTH(input_text) + 1 then\n      \n      \n      set current_char := LEFT(delimiters, 1);\n    else\n      set current_char := SUBSTRING(input_text, current_pos, 1);\n    end if;\n    if LOCATE(current_char, quoting_characters) > 0 then\n      \n      set quoting_char := current_char;\n      set terminating_quote_found := false;\n      while not terminating_quote_found do\n        set terminating_quote_pos := LOCATE(quoting_char, input_text, current_pos + 1);\n        if terminating_quote_pos = 0 then\n          \n          return NULL;\n        end if;\n        if terminating_quote_pos = current_pos + 1 then\n          \n          set terminating_quote_found := true;\n        else\n          \n          \n          set terminating_quote_escape_char := SUBSTRING(input_text, terminating_quote_pos - 1, 1);\n          if (terminating_quote_escape_char = quoting_char) or (terminating_quote_escape_char = \'\\\') then\n            \n            \n            set terminating_quote_found := false;        \n          else\n            set terminating_quote_found := true;            \n          end if;\n        end if;\n        set current_pos := terminating_quote_pos;\n      end while;\n    elseif LOCATE(current_char, delimiters) > 0 then\n      \n      set current_token := SUBSTRING(input_text, token_start_pos, current_pos - token_start_pos);\n      if trim_tokens then\n        set current_token := trim_wspace(current_token);\n      end if;\n      \n      if ((CHAR_LENGTH(current_token) = 0) and (empty_tokens_behavior = \'error\')) then\n        \n        return NULL;\n      end if;\n      if ((CHAR_LENGTH(current_token) > 0) or (empty_tokens_behavior = \'allow\')) then\n        \n        if CHAR_LENGTH(result_text) > 0 then\n          set result_text := CONCAT(result_text, internal_delimiter);\n        end if;\n        \n        set result_text := CONCAT(result_text, current_token);\n        set @common_schema_retokenized_count := 1 + IFNULL(@common_schema_retokenized_count, 0);\n      end if;\n      set token_start_pos := current_pos + 1;\n    end if;\n    set current_pos := current_pos + 1;\n  end while;\n  \n  \n  \n  \n  set @common_schema_retokenized_delimiter := internal_delimiter;\n  return result_text;\nend'),('common_schema','_run_foreach_step','PROCEDURE','_run_foreach_step','SQL','MODIFIES_SQL_DATA','NO','INVOKER','\n   execute_query TEXT CHARSET utf8,\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expect_single tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   in   variables_array_id int unsigned,\n   in depth int unsigned,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n  if execute_query IS NOT NULL then\n    call run(execute_query);\n  elseif id_from IS NOT NULL then\n    call _assign_input_local_variables(variables_array_id);\n    call _consume_statement(id_from, id_to, expect_single, consumed_to_id, depth, should_execute_statement);\n  else\n    \n    call throw(\'_run_foreach_step(): neither queries nor script position provided\');\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Invoke queries/statement per foreach step','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  if execute_query IS NOT NULL then\n    call run(execute_query);\n  elseif id_from IS NOT NULL then\n    call _assign_input_local_variables(variables_array_id);\n    call _consume_statement(id_from, id_to, expect_single, consumed_to_id, depth, should_execute_statement);\n  else\n    \n    call throw(\'_run_foreach_step(): neither queries nor script position provided\');\n  end if;\nend'),('common_schema','_wrap_select_list_columns','PROCEDURE','_wrap_select_list_columns','SQL','CONTAINS_SQL','NO','DEFINER','\n    inout p_text        text    \n,   in p_column_count   int     \n,   out p_error         text    \n','','my_proc: begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text charset utf8;\n    declare v_level int unsigned;\n    declare v_state varchar(32);\n    declare v_whitespace varchar(1) default \'\';\n    declare v_done bool default FALSE;\n    declare v_statement text;\n    declare v_expression text default \'\';\n    declare v_column_number int unsigned default 0;\n    declare v_prev_tokens text default \'\';\n    declare v_token_separator char(1) default \'~\';\n    declare v_token_separator_esc char(1) default \'_\';\n    declare v_handle text;\n    declare v_substr_length int unsigned default 0;\n    set @_wrap_select_num_original_columns := 0;\n    \n    my_main: begin\n    \n    my_loop: repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, FALSE, v_state);\n        case \n            when v_state in (\'whitespace\', \'single line comment\', \'multi line comment\', \'conditional comment\') then\n                iterate my_loop;\n            when v_state = \'alpha\' and v_token = \'select\' then\n                set v_statement = substr(p_text, 1, v_from);\n                leave my_loop;\n            else \n                set p_error = \'No Select found\';\n                leave my_proc;\n        end case;\n    until \n        v_old_from = v_from\n    end repeat;\n    \n    \n    columns_loop: repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, FALSE, v_state);\n        if v_state = \'error\' then\n            set p_error = \'Tokenizer returned error state\';\n            leave my_main;\n        elseif (v_column_number = 0) and ((v_state, v_token) = (\'alpha\', \'distinct\')) then\n            set v_statement = concat(v_statement, \'distinct \');\n        elseif (v_column_number < p_column_count) or (p_column_count = 0)  then\n            if  v_level = 0 and (\n                (v_state, v_token) in (\n                    (\'alpha\', \'from\')\n                ,   (\'comma\', \',\')\n                ) \n                or v_old_from = v_from\n            ) then\n                \n                \n                if v_token = \'from\' \n                and substr(v_prev_tokens, character_length(v_prev_tokens) + 1 - character_length(v_token_separator)) = v_token_separator then\n                    set v_prev_tokens = substr(v_prev_tokens, 1, character_length(v_prev_tokens) - character_length(v_token_separator));\n                end if;\n                \n                if character_length(v_prev_tokens) - character_length(replace(v_prev_tokens, v_token_separator, \'\')) > 1 then\n                    \n                    set v_handle = substring_index(substring_index(v_prev_tokens, v_token_separator, -2), v_token_separator, 1)\n                    \n                    ,   v_substr_length = character_length(v_expression)\n                    \n                    ,   v_substr_length = v_substr_length - case \n                            when UPPER(v_handle) = \'AS\' then    \n                                2 + character_length(substring_index(v_expression, v_handle, -1))\n                            when coalesce(v_handle, \'\') not in (  \n                                \'\', \'AND\', \'BINARY\', \'COLLATE\', \'DIV\', \'ESCAPE\', \'IS\', \'LIKE\', \'MOD\', \'NOT\', \'OR\', \'REGEXP\', \'RLIKE\', \'XOR\'\n                            ,   \'+\', \'-\', \'/\', \'*\', \'%\'\n                            ,   \'||\', \'&&\', \'!\' \n                            ,   \'<\', \'<=\', \'=>\', \'>\', \'<=>\', \'=\', \'!=\', \':=\'\n                            ,   \'|\', \'&\', \'~\', \'^\', \'<<\', \'>>\'\n                            ,   \'.\'\n                            ) and not (   \n                                    v_handle = \'_bin\' \n                                or  v_handle LIKE \'_%\'\n                                and exists (\n                                    select  null \n                                    from    information_schema.character_sets \n                                    where   character_set_name = substring(v_handle, 2)\n                                )\n                            ) then\n                                1+character_length(substring_index(v_prev_tokens, v_token_separator, -1))\n                            else 0\n                        end\n                    \n                    ,   v_expression = substring(v_expression, 1, v_substr_length)\n                    ;\n                end if;\n                \n                set v_statement = concat(\n                        v_statement\n                    ,   if (v_column_number, \', \', \'\')\n                    ,   TRIM(v_expression)\n                    ,   \' AS col\', v_column_number + 1  \n                    )\n                ,   v_column_number = v_column_number + 1\n                ,   v_expression = \'\'\n                ,   v_prev_tokens = \'\'\n                ;\n            else\n                set v_expression = concat(v_expression, v_token);\n                set v_prev_tokens = concat(\n                    v_prev_tokens\n                ,   if( v_level != 0\n                    or  v_state not in (\n                            \'whitespace\'\n                        ,   \'multi line comment\'\n                        ,   \'single line comment\'\n                        )\n                    ,   concat(\n                            if(v_level, \'\', v_token_separator)\n                        ,   replace(v_token, v_token_separator, v_token_separator_esc)\n                        )\n                    ,   \'\'\n                    )\n                );\n            end if;            \n        end if;\n    until \n        v_old_from = v_from or v_token = \'from\'\n    end repeat;\n\n    \n    set @_wrap_select_num_original_columns := v_column_number;\n    while v_column_number < p_column_count do\n        set v_column_number = v_column_number + 1\n        ,   v_statement = concat(v_statement, \', NULL as col\', v_column_number)\n        ;\n    end while;\n\n    end my_main;\n    \n    set p_text= concat(\n                    v_statement\n                ,   if(v_token = \'from\', \' from\', \'\')\n                ,   substr(p_text, v_from)\n                );\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','my_proc: begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text charset utf8;\n    declare v_level int unsigned;\n    declare v_state varchar(32);\n    declare v_whitespace varchar(1) default \'\';\n    declare v_done bool default FALSE;\n    declare v_statement text;\n    declare v_expression text default \'\';\n    declare v_column_number int unsigned default 0;\n    declare v_prev_tokens text default \'\';\n    declare v_token_separator char(1) default \'~\';\n    declare v_token_separator_esc char(1) default \'_\';\n    declare v_handle text;\n    declare v_substr_length int unsigned default 0;\n    set @_wrap_select_num_original_columns := 0;\n    \n    my_main: begin\n    \n    my_loop: repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, FALSE, v_state);\n        case \n            when v_state in (\'whitespace\', \'single line comment\', \'multi line comment\', \'conditional comment\') then\n                iterate my_loop;\n            when v_state = \'alpha\' and v_token = \'select\' then\n                set v_statement = substr(p_text, 1, v_from);\n                leave my_loop;\n            else \n                set p_error = \'No Select found\';\n                leave my_proc;\n        end case;\n    until \n        v_old_from = v_from\n    end repeat;\n    \n    \n    columns_loop: repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, FALSE, v_state);\n        if v_state = \'error\' then\n            set p_error = \'Tokenizer returned error state\';\n            leave my_main;\n        elseif (v_column_number = 0) and ((v_state, v_token) = (\'alpha\', \'distinct\')) then\n            set v_statement = concat(v_statement, \'distinct \');\n        elseif (v_column_number < p_column_count) or (p_column_count = 0)  then\n            if  v_level = 0 and (\n                (v_state, v_token) in (\n                    (\'alpha\', \'from\')\n                ,   (\'comma\', \',\')\n                ) \n                or v_old_from = v_from\n            ) then\n                \n                \n                if v_token = \'from\' \n                and substr(v_prev_tokens, character_length(v_prev_tokens) + 1 - character_length(v_token_separator)) = v_token_separator then\n                    set v_prev_tokens = substr(v_prev_tokens, 1, character_length(v_prev_tokens) - character_length(v_token_separator));\n                end if;\n                \n                if character_length(v_prev_tokens) - character_length(replace(v_prev_tokens, v_token_separator, \'\')) > 1 then\n                    \n                    set v_handle = substring_index(substring_index(v_prev_tokens, v_token_separator, -2), v_token_separator, 1)\n                    \n                    ,   v_substr_length = character_length(v_expression)\n                    \n                    ,   v_substr_length = v_substr_length - case \n                            when UPPER(v_handle) = \'AS\' then    \n                                2 + character_length(substring_index(v_expression, v_handle, -1))\n                            when coalesce(v_handle, \'\') not in (  \n                                \'\', \'AND\', \'BINARY\', \'COLLATE\', \'DIV\', \'ESCAPE\', \'IS\', \'LIKE\', \'MOD\', \'NOT\', \'OR\', \'REGEXP\', \'RLIKE\', \'XOR\'\n                            ,   \'+\', \'-\', \'/\', \'*\', \'%\'\n                            ,   \'||\', \'&&\', \'!\' \n                            ,   \'<\', \'<=\', \'=>\', \'>\', \'<=>\', \'=\', \'!=\', \':=\'\n                            ,   \'|\', \'&\', \'~\', \'^\', \'<<\', \'>>\'\n                            ,   \'.\'\n                            ) and not (   \n                                    v_handle = \'_bin\' \n                                or  v_handle LIKE \'_%\'\n                                and exists (\n                                    select  null \n                                    from    information_schema.character_sets \n                                    where   character_set_name = substring(v_handle, 2)\n                                )\n                            ) then\n                                1+character_length(substring_index(v_prev_tokens, v_token_separator, -1))\n                            else 0\n                        end\n                    \n                    ,   v_expression = substring(v_expression, 1, v_substr_length)\n                    ;\n                end if;\n                \n                set v_statement = concat(\n                        v_statement\n                    ,   if (v_column_number, \', \', \'\')\n                    ,   TRIM(v_expression)\n                    ,   \' AS col\', v_column_number + 1  \n                    )\n                ,   v_column_number = v_column_number + 1\n                ,   v_expression = \'\'\n                ,   v_prev_tokens = \'\'\n                ;\n            else\n                set v_expression = concat(v_expression, v_token);\n                set v_prev_tokens = concat(\n                    v_prev_tokens\n                ,   if( v_level != 0\n                    or  v_state not in (\n                            \'whitespace\'\n                        ,   \'multi line comment\'\n                        ,   \'single line comment\'\n                        )\n                    ,   concat(\n                            if(v_level, \'\', v_token_separator)\n                        ,   replace(v_token, v_token_separator, v_token_separator_esc)\n                        )\n                    ,   \'\'\n                    )\n                );\n            end if;            \n        end if;\n    until \n        v_old_from = v_from or v_token = \'from\'\n    end repeat;\n\n    \n    set @_wrap_select_num_original_columns := v_column_number;\n    while v_column_number < p_column_count do\n        set v_column_number = v_column_number + 1\n        ,   v_statement = concat(v_statement, \', NULL as col\', v_column_number)\n        ;\n    end while;\n\n    end my_main;\n    \n    set p_text= concat(\n                    v_statement\n                ,   if(v_token = \'from\', \' from\', \'\')\n                ,   substr(p_text, v_from)\n                );\nend'),('common_schema','help','PROCEDURE','help','SQL','READS_SQL_DATA','NO','INVOKER','expression TINYTEXT CHARSET utf8','','begin\n  set expression := REPLACE(expression, \'()\', \'\');\n  set expression := REPLACE(expression, \';\', \'\');\n  set expression := trim_wspace(expression);\n  set expression := REPLACE(expression, \' \', \'%\');\n  SELECT \n    split_token(help_message, \'\\n\', n) AS help\n  FROM (\n    SELECT help_message FROM (\n      SELECT 1 AS order_column, help_message FROM help_content WHERE topic LIKE CONCAT(\'%\', expression, \'%\')\n      UNION ALL\n      SELECT 2, help_message FROM help_content WHERE LEFT(help_message, 256) LIKE CONCAT(\'%\', expression, \'%\')\n      UNION ALL\n      SELECT 3, help_message FROM help_content WHERE help_message LIKE CONCAT(\'%\', expression, \'%\')\n      UNION ALL\n      SELECT 4, CONCAT(\'No help topics found for \"\', expression, \'\".\')\n    ) select_all \n    ORDER BY order_column ASC \n    LIMIT 1\n  ) select_single,\n  numbers\n  WHERE \n    numbers.n BETWEEN 1 AND get_num_tokens(help_message, \'\\n\')\n  ORDER BY n ASC;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Inline help','utf8','utf8_general_ci','utf8_general_ci','begin\n  set expression := REPLACE(expression, \'()\', \'\');\n  set expression := REPLACE(expression, \';\', \'\');\n  set expression := trim_wspace(expression);\n  set expression := REPLACE(expression, \' \', \'%\');\n  SELECT \n    split_token(help_message, \'\n\', n) AS help\n  FROM (\n    SELECT help_message FROM (\n      SELECT 1 AS order_column, help_message FROM help_content WHERE topic LIKE CONCAT(\'%\', expression, \'%\')\n      UNION ALL\n      SELECT 2, help_message FROM help_content WHERE LEFT(help_message, 256) LIKE CONCAT(\'%\', expression, \'%\')\n      UNION ALL\n      SELECT 3, help_message FROM help_content WHERE help_message LIKE CONCAT(\'%\', expression, \'%\')\n      UNION ALL\n      SELECT 4, CONCAT(\'No help topics found for \"\', expression, \'\".\')\n    ) select_all \n    ORDER BY order_column ASC \n    LIMIT 1\n  ) select_single,\n  numbers\n  WHERE \n    numbers.n BETWEEN 1 AND get_num_tokens(help_message, \'\n\')\n  ORDER BY n ASC;\nend'),('common_schema','match_grantee','FUNCTION','match_grantee','SQL','READS_SQL_DATA','YES','INVOKER','connection_user char(16) CHARSET utf8, connection_host char(70) CHARSET utf8','varchar(100) CHARSET utf8','BEGIN\n  DECLARE grantee_user char(16) CHARSET utf8 DEFAULT NULL;\n  DECLARE grantee_host char(60) CHARSET utf8 DEFAULT NULL;\n\n  SELECT\n    MAX(user), MAX(host)\n  FROM (\n    SELECT\n      user, host\n    FROM\n      mysql.user\n    WHERE\n      connection_user RLIKE\n        CONCAT(\'^\',\n          REPLACE(\n            user,\n            \'%\', \'.*\'),\n          \'$\')\n      AND SUBSTRING_INDEX(connection_host, \':\', 1) RLIKE\n        CONCAT(\'^\',\n          REPLACE(\n          REPLACE(\n            host,\n            \'.\', \'\\\\.\'),\n            \'%\', \'.*\'),\n          \'$\')\n    ORDER BY\n      CHAR_LENGTH(host) - CHAR_LENGTH(REPLACE(host, \'%\', \'\')) ASC,\n      CHAR_LENGTH(host) - CHAR_LENGTH(REPLACE(host, \'.\', \'\')) DESC,\n      host ASC,\n      CHAR_LENGTH(user) - CHAR_LENGTH(REPLACE(user, \'%\', \'\')) ASC,\n      user ASC\n    LIMIT 1\n  ) select_matching_account\n  INTO \n    grantee_user, grantee_host;\n    \n    \n  RETURN CONCAT(\'\'\'\', grantee_user, \'\'\'@\'\'\', grantee_host, \'\'\'\');\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Match an account based on user+host','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  DECLARE grantee_user char(16) CHARSET utf8 DEFAULT NULL;\n  DECLARE grantee_host char(60) CHARSET utf8 DEFAULT NULL;\n\n  SELECT\n    MAX(user), MAX(host)\n  FROM (\n    SELECT\n      user, host\n    FROM\n      mysql.user\n    WHERE\n      connection_user RLIKE\n        CONCAT(\'^\',\n          REPLACE(\n            user,\n            \'%\', \'.*\'),\n          \'$\')\n      AND SUBSTRING_INDEX(connection_host, \':\', 1) RLIKE\n        CONCAT(\'^\',\n          REPLACE(\n          REPLACE(\n            host,\n            \'.\', \'\\.\'),\n            \'%\', \'.*\'),\n          \'$\')\n    ORDER BY\n      CHAR_LENGTH(host) - CHAR_LENGTH(REPLACE(host, \'%\', \'\')) ASC,\n      CHAR_LENGTH(host) - CHAR_LENGTH(REPLACE(host, \'.\', \'\')) DESC,\n      host ASC,\n      CHAR_LENGTH(user) - CHAR_LENGTH(REPLACE(user, \'%\', \'\')) ASC,\n      user ASC\n    LIMIT 1\n  ) select_matching_account\n  INTO \n    grantee_user, grantee_host;\n    \n    \n  RETURN CONCAT(\'\'\', grantee_user, \'\'@\'\', grantee_host, \'\'\');\nEND'),('common_schema','mysql_grantee','FUNCTION','mysql_grantee','SQL','NO_SQL','YES','INVOKER','mysql_user char(16) CHARSET utf8, mysql_host char(60) CHARSET utf8','varchar(100) CHARSET utf8','BEGIN\n  RETURN CONCAT(\'\'\'\', mysql_user, \'\'\'@\'\'\', mysql_host, \'\'\'\');\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return a qualified MySQL grantee name','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN CONCAT(\'\'\', mysql_user, \'\'@\'\', mysql_host, \'\'\');\nEND'),('common_schema','query_laptime','FUNCTION','query_laptime','SQL','NO_SQL','YES','INVOKER','','double','begin\n  declare time_right_now TIMESTAMP;\n  declare query_time_now TIMESTAMP;\n  declare time_diff DOUBLE;\n  \n  set time_right_now := SYSDATE();	\n  set query_time_now := NOW();	\n  \n  \n  \n  \n  if @_common_schema_laptime_lap_start is null then\n    set @_common_schema_laptime_lap_start := query_time_now;\n  else\n    set @_common_schema_laptime_lap_start := GREATEST(@_common_schema_laptime_lap_start, query_time_now);\n  end if;\n  set time_diff := TIMESTAMPDIFF(MICROSECOND, @_common_schema_laptime_lap_start, time_right_now) / 1000000.0;\n  set @_common_schema_laptime_lap_start := time_right_now;\n  \n  return time_diff;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return current query runtime','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare time_right_now TIMESTAMP;\n  declare query_time_now TIMESTAMP;\n  declare time_diff DOUBLE;\n  \n  set time_right_now := SYSDATE();	\n  set query_time_now := NOW();	\n  \n  \n  \n  \n  if @_common_schema_laptime_lap_start is null then\n    set @_common_schema_laptime_lap_start := query_time_now;\n  else\n    set @_common_schema_laptime_lap_start := GREATEST(@_common_schema_laptime_lap_start, query_time_now);\n  end if;\n  set time_diff := TIMESTAMPDIFF(MICROSECOND, @_common_schema_laptime_lap_start, time_right_now) / 1000000.0;\n  set @_common_schema_laptime_lap_start := time_right_now;\n  \n  return time_diff;\nend'),('common_schema','query_runtime','FUNCTION','query_runtime','SQL','READS_SQL_DATA','YES','INVOKER','','double','BEGIN\n  return TIMESTAMPDIFF(MICROSECOND, NOW(), SYSDATE()) / 1000000.0;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return current query runtime','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  return TIMESTAMPDIFF(MICROSECOND, NOW(), SYSDATE()) / 1000000.0;\nEND'),('common_schema','session_unique_id','FUNCTION','session_unique_id','SQL','NO_SQL','YES','INVOKER','','int(10) unsigned','BEGIN\n  set @_common_schema_session_unique_id := IFNULL(@_common_schema_session_unique_id, 0) + 1;\n  return @_common_schema_session_unique_id;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns unique ID within this session','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  set @_common_schema_session_unique_id := IFNULL(@_common_schema_session_unique_id, 0) + 1;\n  return @_common_schema_session_unique_id;\nEND'),('common_schema','this_query','FUNCTION','this_query','SQL','READS_SQL_DATA','YES','INVOKER','','longtext CHARSET utf8','BEGIN\n  return (SELECT INFO FROM INFORMATION_SCHEMA.PROCESSLIST WHERE ID = CONNECTION_ID());\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return current query','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  return (SELECT INFO FROM INFORMATION_SCHEMA.PROCESSLIST WHERE ID = CONNECTION_ID());\nEND'),('common_schema','throttle','FUNCTION','throttle','SQL','NO_SQL','YES','INVOKER','throttle_ratio DOUBLE','double','begin\n  set @_common_schema_throttle_counter := IFNULL(@_common_schema_throttle_counter, 0) + 1;\n  \n  if @_common_schema_throttle_counter % 1000 = 0 then\n    set @_common_schema_throttle_counter := 0;\n    set @_common_schema_throttle_sysdate := SYSDATE();\n    \n    \n    \n    \n    set @_common_schema_throttle_chunk_start := IFNULL(@_common_schema_throttle_chunk_start, NOW());\n    set @_common_schema_throttle_chunk_start := GREATEST(@_common_schema_throttle_chunk_start, NOW());\n    set @_common_schema_throttle_timediff := TIMESTAMPDIFF(SECOND, @_common_schema_throttle_chunk_start, @_common_schema_throttle_sysdate);\n    set @_common_schema_throttle_sleep_time := @_common_schema_throttle_timediff * throttle_ratio;\n    \n    if @_common_schema_throttle_sleep_time > 0 then\n      DO SLEEP(@_common_schema_throttle_sleep_time);\n      set @_common_schema_throttle_chunk_start := SYSDATE();\n      return @_common_schema_throttle_sleep_time;\n    end if;\n  end if;\n  \n  return 0;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  set @_common_schema_throttle_counter := IFNULL(@_common_schema_throttle_counter, 0) + 1;\n  \n  if @_common_schema_throttle_counter % 1000 = 0 then\n    set @_common_schema_throttle_counter := 0;\n    set @_common_schema_throttle_sysdate := SYSDATE();\n    \n    \n    \n    \n    set @_common_schema_throttle_chunk_start := IFNULL(@_common_schema_throttle_chunk_start, NOW());\n    set @_common_schema_throttle_chunk_start := GREATEST(@_common_schema_throttle_chunk_start, NOW());\n    set @_common_schema_throttle_timediff := TIMESTAMPDIFF(SECOND, @_common_schema_throttle_chunk_start, @_common_schema_throttle_sysdate);\n    set @_common_schema_throttle_sleep_time := @_common_schema_throttle_timediff * throttle_ratio;\n    \n    if @_common_schema_throttle_sleep_time > 0 then\n      DO SLEEP(@_common_schema_throttle_sleep_time);\n      set @_common_schema_throttle_chunk_start := SYSDATE();\n      return @_common_schema_throttle_sleep_time;\n    end if;\n  end if;\n  \n  return 0;\nend'),('common_schema','_assign_input_local_variables','PROCEDURE','_assign_input_local_variables','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   variables_array_id int unsigned\n','','main_body: begin\n  declare num_variables int unsigned;\n  declare variable_index int unsigned default 0;\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare reset_query text charset ascii;\n  \n  call _get_array_size(variables_array_id, num_variables);\n  set variable_index := 1;\n  while variable_index <= num_variables do\n    call _get_array_element(variables_array_id, variable_index, local_variable);\n    SELECT mapped_user_defined_variable_name FROM _qs_variables WHERE variable_name = local_variable INTO user_defined_variable_name;\n    \n    set reset_query := CONCAT(\'SET \', user_defined_variable_name, \' := @_query_script_input_col\', variable_index);\n    call exec_single(reset_query);\n    \n    set variable_index := variable_index + 1;\n  end while;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Declares local variables','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare num_variables int unsigned;\n  declare variable_index int unsigned default 0;\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare reset_query text charset ascii;\n  \n  call _get_array_size(variables_array_id, num_variables);\n  set variable_index := 1;\n  while variable_index <= num_variables do\n    call _get_array_element(variables_array_id, variable_index, local_variable);\n    SELECT mapped_user_defined_variable_name FROM _qs_variables WHERE variable_name = local_variable INTO user_defined_variable_name;\n    \n    set reset_query := CONCAT(\'SET \', user_defined_variable_name, \' := @_query_script_input_col\', variable_index);\n    call exec_single(reset_query);\n    \n    set variable_index := variable_index + 1;\n  end while;\nend'),('common_schema','_consume_if_exists','PROCEDURE','_consume_if_exists','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   inout  consumed_to_id int unsigned,\n   in   expected_token text charset utf8,\n   in   expected_states text charset utf8,\n   out  token_has_matched tinyint unsigned,\n   out  matched_token text charset utf8\n','','main_body: begin\n  call _skip_spaces(id_from, id_to);\n  set token_has_matched := FALSE;\n  SELECT token, ((token = expected_token) OR FIND_IN_SET(state, REPLACE(expected_states, \'|\', \',\'))) IS TRUE FROM _sql_tokens WHERE id = id_from INTO matched_token, token_has_matched;\n  if token_has_matched then\n    set consumed_to_id = id_from;\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Consumes token or state if indeed exists','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  call _skip_spaces(id_from, id_to);\n  set token_has_matched := FALSE;\n  SELECT token, ((token = expected_token) OR FIND_IN_SET(state, REPLACE(expected_states, \'|\', \',\'))) IS TRUE FROM _sql_tokens WHERE id = id_from INTO matched_token, token_has_matched;\n  if token_has_matched then\n    set consumed_to_id = id_from;\n  end if;\nend'),('common_schema','_resolve_and_consume_sql_or_script_statement','PROCEDURE','_resolve_and_consume_sql_or_script_statement','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   statement_id_from      int unsigned,\n   in   statement_id_to      int unsigned,\n   in   depth int unsigned,\n   in   statement_token text charset utf8,\n   in   should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare resolve_statement_type text charset utf8;\n  declare token_has_matched tinyint unsigned default FALSE;\n  \n  select statement_type from _script_statements where statement = statement_token into resolve_statement_type;\n  \n  case resolve_statement_type\n    when \'sql\' then begin\n	    call _consume_sql_statement(id_from, statement_id_to, should_execute_statement);\n	  end;\n    when \'script\' then begin\n	    call _consume_script_statement(id_from, id_to, statement_id_from, statement_id_to, depth, statement_token, should_execute_statement);\n	  end;\n    when \'script,sql\' then begin\n        if statement_token = \'start\' then\n          \n          call _consume_if_exists(statement_id_from, statement_id_to, @_common_schema_dummy, \'transaction\', NULL, token_has_matched, @_common_schema_dummy);\n          if token_has_matched then\n            call _consume_script_statement(id_from, id_to, statement_id_from, statement_id_to, depth, statement_token, should_execute_statement);\n          else\n            call _consume_sql_statement(id_from, statement_id_to, should_execute_statement);\n          end if;\n        end if;\n	  end;\n  end case;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads script statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare resolve_statement_type text charset utf8;\n  declare token_has_matched tinyint unsigned default FALSE;\n  \n  select statement_type from _script_statements where statement = statement_token into resolve_statement_type;\n  \n  case resolve_statement_type\n    when \'sql\' then begin\n	    call _consume_sql_statement(id_from, statement_id_to, should_execute_statement);\n	  end;\n    when \'script\' then begin\n	    call _consume_script_statement(id_from, id_to, statement_id_from, statement_id_to, depth, statement_token, should_execute_statement);\n	  end;\n    when \'script,sql\' then begin\n        if statement_token = \'start\' then\n          \n          call _consume_if_exists(statement_id_from, statement_id_to, @_common_schema_dummy, \'transaction\', NULL, token_has_matched, @_common_schema_dummy);\n          if token_has_matched then\n            call _consume_script_statement(id_from, id_to, statement_id_from, statement_id_to, depth, statement_token, should_execute_statement);\n          else\n            call _consume_sql_statement(id_from, statement_id_to, should_execute_statement);\n          end if;\n        end if;\n	  end;\n  end case;\nend'),('common_schema','_declare_local_variables','PROCEDURE','_declare_local_variables','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   statement_id_to      int unsigned,\n   in   depth int unsigned,\n   variables_array_id int unsigned\n','','main_body: begin\n  declare num_variables int unsigned;\n  declare variable_index int unsigned default 0;\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare declaration_is_new tinyint unsigned default 0;\n  \n  SELECT (COUNT(*) = 0) FROM _qs_variables WHERE declaration_id = id_from INTO declaration_is_new;\n  if not declaration_is_new then\n    \n    \n    leave main_body;\n  end if;\n  \n  \n  call _get_array_size(variables_array_id, num_variables);\n  set variable_index := 1;\n  while variable_index <= num_variables do\n    call _get_array_element(variables_array_id, variable_index, local_variable);\n    set user_defined_variable_name := CONCAT(\'@__qs_local_var_\', session_unique_id());\n    \n    call _declare_local_variable(id_from, statement_id_to, id_to, depth, local_variable, user_defined_variable_name, TRUE);\n    \n    set variable_index := variable_index + 1;\n  end while;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Declares local variables','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare num_variables int unsigned;\n  declare variable_index int unsigned default 0;\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare declaration_is_new tinyint unsigned default 0;\n  \n  SELECT (COUNT(*) = 0) FROM _qs_variables WHERE declaration_id = id_from INTO declaration_is_new;\n  if not declaration_is_new then\n    \n    \n    leave main_body;\n  end if;\n  \n  \n  call _get_array_size(variables_array_id, num_variables);\n  set variable_index := 1;\n  while variable_index <= num_variables do\n    call _get_array_element(variables_array_id, variable_index, local_variable);\n    set user_defined_variable_name := CONCAT(\'@__qs_local_var_\', session_unique_id());\n    \n    call _declare_local_variable(id_from, statement_id_to, id_to, depth, local_variable, user_defined_variable_name, TRUE);\n    \n    set variable_index := variable_index + 1;\n  end while;\nend'),('common_schema','_evaluate_expression','PROCEDURE','_evaluate_expression','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  expression text charset utf8,\n   in  expression_statement text charset utf8,\n   out expression_result tinyint unsigned\n','','main_body: begin\n  declare read_row_count tinyint unsigned default FALSE; \n  \n  case\n    when expression_statement IN (\'insert\', \'replace\', \'update\', \'delete\') then begin\n	    set read_row_count := TRUE;\n	  end;    \n    else begin\n	    set expression := CONCAT(\'SELECT ((\', expression, \') IS TRUE) INTO @_common_schema_script_expression_result\'); \n	  end;\n  end case;\n  call exec_single(expression);\n  set @query_script_rowcount := @common_schema_rowcount;\n  if read_row_count then\n    set expression_result := ((@query_script_rowcount > 0) IS TRUE);\n  else\n    set expression_result := @_common_schema_script_expression_result;\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Evaluates expression, returns boolean value','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare read_row_count tinyint unsigned default FALSE; \n  \n  case\n    when expression_statement IN (\'insert\', \'replace\', \'update\', \'delete\') then begin\n	    set read_row_count := TRUE;\n	  end;    \n    else begin\n	    set expression := CONCAT(\'SELECT ((\', expression, \') IS TRUE) INTO @_common_schema_script_expression_result\'); \n	  end;\n  end case;\n  call exec_single(expression);\n  set @query_script_rowcount := @common_schema_rowcount;\n  if read_row_count then\n    set expression_result := ((@query_script_rowcount > 0) IS TRUE);\n  else\n    set expression_result := @_common_schema_script_expression_result;\n  end if;\nend'),('common_schema','_expect_dynamic_states_list','PROCEDURE','_expect_dynamic_states_list','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expected_states text charset utf8,\n   out  tokens_array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  call _match_states(id_from, id_to, expected_states, false, false, 0, \'comma\', true, true, @_common_schema_dummy, tokens_array_id, @_common_schema_dummy, @_common_schema_dummy);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expects a state or raises error','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  call _match_states(id_from, id_to, expected_states, false, false, 0, \'comma\', true, true, @_common_schema_dummy, tokens_array_id, @_common_schema_dummy, @_common_schema_dummy);\nend'),('common_schema','_expect_exact_states_list','PROCEDURE','_expect_exact_states_list','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expected_states_list text charset utf8,\n   out  tokens_array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  call _match_states(id_from, id_to, expected_states_list, false, false, 1, null, true, true, @_common_schema_dummy, tokens_array_id, @_common_schema_dummy, @_common_schema_dummy);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expects states or raises error','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  call _match_states(id_from, id_to, expected_states_list, false, false, 1, null, true, true, @_common_schema_dummy, tokens_array_id, @_common_schema_dummy, @_common_schema_dummy);\nend'),('common_schema','_expect_nothing','PROCEDURE','_expect_nothing','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned\n','','main_body: begin\n  declare consumed_to_id int unsigned;\n  declare token_has_matched tinyint unsigned;\n\n  call _skip_spaces(id_from, id_to);\n  if id_from > id_to then\n    \n    leave main_body;\n  end if;\n  \n  call _consume_if_exists(id_from, id_to, consumed_to_id, NULL, \'statement delimiter|start\', token_has_matched, @_common_schema_dummy);\n  if not token_has_matched then\n    call _throw_script_error(id_from, \'Nothing more expected\');\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expect nothing or whitespace only','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare consumed_to_id int unsigned;\n  declare token_has_matched tinyint unsigned;\n\n  call _skip_spaces(id_from, id_to);\n  if id_from > id_to then\n    \n    leave main_body;\n  end if;\n  \n  call _consume_if_exists(id_from, id_to, consumed_to_id, NULL, \'statement delimiter|start\', token_has_matched, @_common_schema_dummy);\n  if not token_has_matched then\n    call _throw_script_error(id_from, \'Nothing more expected\');\n  end if;\nend'),('common_schema','_expect_states_list','PROCEDURE','_expect_states_list','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expected_states_list text charset utf8,\n   out  tokens_array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  declare num_states int unsigned default 0;\n  declare states_index int unsigned default 0;\n  declare expected_states text charset utf8;\n  declare matched_token text charset utf8;\n  declare consumed_to_id int unsigned default NULL;\n  \n  call _create_array(tokens_array_id);\n  \n  set num_states := get_num_tokens(expected_states_list, \',\');\n  set states_index := 1;\n  while states_index <= num_states do\n    set expected_states := split_token(expected_states_list, \',\', states_index);\n    call _expect_state(id_from, id_to, consumed_to_id, expected_states, matched_token);\n    call _push_array_element(tokens_array_id, matched_token);\n    set id_from := consumed_to_id + 1;\n    if states_index < num_states then\n      call _expect_state(id_from, id_to, consumed_to_id, \'comma\', @_common_schema_dummy);\n      set id_from := consumed_to_id + 1;\n    end if;\n    set states_index := states_index + 1;\n  end while;\n  \n  call _expect_nothing(id_from, id_to);\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Expects a state or raises error','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  declare num_states int unsigned default 0;\n  declare states_index int unsigned default 0;\n  declare expected_states text charset utf8;\n  declare matched_token text charset utf8;\n  declare consumed_to_id int unsigned default NULL;\n  \n  call _create_array(tokens_array_id);\n  \n  set num_states := get_num_tokens(expected_states_list, \',\');\n  set states_index := 1;\n  while states_index <= num_states do\n    set expected_states := split_token(expected_states_list, \',\', states_index);\n    call _expect_state(id_from, id_to, consumed_to_id, expected_states, matched_token);\n    call _push_array_element(tokens_array_id, matched_token);\n    set id_from := consumed_to_id + 1;\n    if states_index < num_states then\n      call _expect_state(id_from, id_to, consumed_to_id, \'comma\', @_common_schema_dummy);\n      set id_from := consumed_to_id + 1;\n    end if;\n    set states_index := states_index + 1;\n  end while;\n  \n  call _expect_nothing(id_from, id_to);\nend'),('common_schema','_skip_spaces','PROCEDURE','_skip_spaces','SQL','READS_SQL_DATA','YES','INVOKER','\n   inout   id_from      int unsigned,\n   in   id_to      int unsigned\n','','main_body: begin\n    call _skip_tokens_and_spaces(id_from, id_to, null);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Skips whitespace tokens','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    call _skip_tokens_and_spaces(id_from, id_to, null);\nend'),('common_schema','_take_local_variables_snapshot','PROCEDURE','_take_local_variables_snapshot','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   expanded_variables text charset utf8\n','','main_body: begin\n  declare num_variables int unsigned;\n  declare variable_index int unsigned default 0;\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare snapshot_query text charset ascii;\n  \n  set num_variables := get_num_tokens(expanded_variables, \',\');\n  set variable_index := 1;\n  while variable_index <= num_variables do\n    set local_variable := split_token(expanded_variables, \',\', variable_index);\n    SELECT mapped_user_defined_variable_name FROM _qs_variables WHERE variable_name = local_variable INTO user_defined_variable_name;\n    \n    set snapshot_query := CONCAT(\'UPDATE _qs_variables SET value_snapshot = \', user_defined_variable_name, \' WHERE variable_name = \', QUOTE(local_variable));\n    call exec_single(snapshot_query);\n    \n    set variable_index := variable_index + 1;\n  end while;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Declares local variables','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare num_variables int unsigned;\n  declare variable_index int unsigned default 0;\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare snapshot_query text charset ascii;\n  \n  set num_variables := get_num_tokens(expanded_variables, \',\');\n  set variable_index := 1;\n  while variable_index <= num_variables do\n    set local_variable := split_token(expanded_variables, \',\', variable_index);\n    SELECT mapped_user_defined_variable_name FROM _qs_variables WHERE variable_name = local_variable INTO user_defined_variable_name;\n    \n    set snapshot_query := CONCAT(\'UPDATE _qs_variables SET value_snapshot = \', user_defined_variable_name, \' WHERE variable_name = \', QUOTE(local_variable));\n    call exec_single(snapshot_query);\n    \n    set variable_index := variable_index + 1;\n  end while;\nend'),('common_schema','_throttle_script','PROCEDURE','_throttle_script','SQL','READS_SQL_DATA','YES','INVOKER','throttle_ratio DOUBLE','','begin\n  set @_common_schema_script_throttle_sysdate := SYSDATE();\n  \n  set @_common_schema_script_throttle_chunk_start := IFNULL(@_common_schema_script_throttle_chunk_start, @_common_schema_script_start_timestamp);\n  set @_common_schema_script_throttle_timediff := TIMESTAMPDIFF(SECOND, @_common_schema_script_throttle_chunk_start, @_common_schema_script_throttle_sysdate);\n  set @_common_schema_script_throttle_sleep_time := @_common_schema_script_throttle_timediff * throttle_ratio;\n  \n  if @_common_schema_script_throttle_sleep_time > 0 then\n    DO SLEEP(@_common_schema_script_throttle_sleep_time);\n    set @_common_schema_script_throttle_chunk_start := SYSDATE();\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  set @_common_schema_script_throttle_sysdate := SYSDATE();\n  \n  set @_common_schema_script_throttle_chunk_start := IFNULL(@_common_schema_script_throttle_chunk_start, @_common_schema_script_start_timestamp);\n  set @_common_schema_script_throttle_timediff := TIMESTAMPDIFF(SECOND, @_common_schema_script_throttle_chunk_start, @_common_schema_script_throttle_sysdate);\n  set @_common_schema_script_throttle_sleep_time := @_common_schema_script_throttle_timediff * throttle_ratio;\n  \n  if @_common_schema_script_throttle_sleep_time > 0 then\n    DO SLEEP(@_common_schema_script_throttle_sleep_time);\n    set @_common_schema_script_throttle_chunk_start := SYSDATE();\n  end if;\nend'),('common_schema','_throw_script_error','PROCEDURE','_throw_script_error','SQL','READS_SQL_DATA','YES','INVOKER','\n   in id_from      int unsigned,\n   in message varchar(1024) charset utf8\n','','main_body: begin\n    declare full_message varchar(2048);\n    declare error_pos int unsigned;\n\n    SELECT LEFT(GROUP_CONCAT(token ORDER BY id SEPARATOR \'\'), 80), SUBSTRING_INDEX(GROUP_CONCAT(start ORDER BY id), \',\', 1) FROM _sql_tokens WHERE id >= id_from INTO full_message, error_pos;\n    \n    set full_message := CONCAT(\'QueryScript error: [\', message, \'] at \', error_pos, \': \"\', full_message, \'\"\');\n    call throw(full_message);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Raises error and quites from script','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare full_message varchar(2048);\n    declare error_pos int unsigned;\n\n    SELECT LEFT(GROUP_CONCAT(token ORDER BY id SEPARATOR \'\'), 80), SUBSTRING_INDEX(GROUP_CONCAT(start ORDER BY id), \',\', 1) FROM _sql_tokens WHERE id >= id_from INTO full_message, error_pos;\n    \n    set full_message := CONCAT(\'QueryScript error: [\', message, \'] at \', error_pos, \': \"\', full_message, \'\"\');\n    call throw(full_message);\nend'),('common_schema','run_file','PROCEDURE','run_file','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n  in query_script_file_name text\n','','main_body: begin\n  call run(LOAD_FILE(query_script_file_name));\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Run given QueryScript file','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  call run(LOAD_FILE(query_script_file_name));\nend'),('common_schema','script_runtime','FUNCTION','script_runtime','SQL','READS_SQL_DATA','YES','INVOKER','','double','BEGIN\n  return TIMESTAMPDIFF(MICROSECOND, @_common_schema_script_start_timestamp, SYSDATE()) / 1000000.0;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return current script runtime seconds','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  return TIMESTAMPDIFF(MICROSECOND, @_common_schema_script_start_timestamp, SYSDATE()) / 1000000.0;\nEND'),('common_schema','_concatenate_array_elements','PROCEDURE','_concatenate_array_elements','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii,\n   in   delimiter text charset utf8,\n   out   result text charset utf8\n','','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set @_common_schema_get_array_element_value := NULL;\n  set exec_statement := CONCAT(\n    \'SELECT GROUP_CONCAT(value ORDER BY array_key SEPARATOR \'\'\', delimiter ,\'\'\') FROM \', _get_array_name(array_id), \n       \' INTO @_common_schema_concatenate_array_elements_value\');\n\n  call exec_single(exec_statement);\n  set result := @_common_schema_concatenate_array_elements_value;  \nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Creates a populated array, returning its ID','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set @_common_schema_get_array_element_value := NULL;\n  set exec_statement := CONCAT(\n    \'SELECT GROUP_CONCAT(value ORDER BY array_key SEPARATOR \'\', delimiter ,\'\') FROM \', _get_array_name(array_id), \n       \' INTO @_common_schema_concatenate_array_elements_value\');\n\n  call exec_single(exec_statement);\n  set result := @_common_schema_concatenate_array_elements_value;  \nend'),('common_schema','_create_array','PROCEDURE','_create_array','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   out  array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  select _create_mxarray() into array_id;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Creates an array, returning its ID','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  select _create_mxarray() into array_id;\nend'),('common_schema','_get_mxarray_element','FUNCTION','_get_mxarray_element','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned,\n   array_key varchar(127) charset utf8\n','text CHARSET utf8','main_body: begin\n  declare xpath varchar(64) charset utf8;\n  if _mxarray_key_exists(array_id, array_key) then\n    set xpath := CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]/e[@key=\"\', encode_xml(array_key), \'\"][1]\');\n    return decode_xml(ExtractValue(@_common_schema_mx_array, xpath));\n  end if;\n  return null;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Get an element by array id and key','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare xpath varchar(64) charset utf8;\n  if _mxarray_key_exists(array_id, array_key) then\n    set xpath := CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]/e[@key=\"\', encode_xml(array_key), \'\"][1]\');\n    return decode_xml(ExtractValue(@_common_schema_mx_array, xpath));\n  end if;\n  return null;\nend'),('common_schema','_create_array_from_tokens','PROCEDURE','_create_array_from_tokens','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   tokens text charset utf8,\n   in   delimiter text charset utf8,\n   out  array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  \n  declare num_tokens int unsigned;\n  declare token_index int unsigned default 1;\n\n  call _create_array(array_id);\n  set num_tokens := get_num_tokens(tokens, delimiter);\n  while token_index <= num_tokens do\n    call _push_array_element(array_id, split_token(tokens, delimiter, token_index));\n    set token_index := token_index + 1;\n  end while;\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Creates a populated array, returning its ID','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  \n  declare num_tokens int unsigned;\n  declare token_index int unsigned default 1;\n\n  call _create_array(array_id);\n  set num_tokens := get_num_tokens(tokens, delimiter);\n  while token_index <= num_tokens do\n    call _push_array_element(array_id, split_token(tokens, delimiter, token_index));\n    set token_index := token_index + 1;\n  end while;\nend'),('common_schema','_drop_array','PROCEDURE','_drop_array','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id int unsigned\n','','main_body: begin\n  select _drop_mxarray(array_id) into @_common_schema_dummy;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Drops an array','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  select _drop_mxarray(array_id) into @_common_schema_dummy;\nend'),('common_schema','_dump_array','PROCEDURE','_dump_array','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set exec_statement := CONCAT(\n    \'SELECT * FROM \', _get_array_name(array_id), \'\');\n\n  call exec_single(exec_statement);\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Dumps elements of array','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set exec_statement := CONCAT(\n    \'SELECT * FROM \', _get_array_name(array_id), \'\');\n\n  call exec_single(exec_statement);\nend'),('common_schema','_get_array_element','PROCEDURE','_get_array_element','SQL','READS_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii,\n   in array_key varchar(127) charset utf8,\n   out element text charset utf8\n','','main_body: begin\n  select _get_mxarray_element(array_id, array_key) into element;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Creates an array, returning its ID','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  select _get_mxarray_element(array_id, array_key) into element;\nend'),('common_schema','_drop_mxarray','FUNCTION','_drop_mxarray','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned\n','int(10) unsigned','main_body: begin\n  declare xpath varchar(64) charset utf8;\n  if array_id is null then\n    return null;\n  end if;\n  set xpath := CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]\');\n  set @_common_schema_mx_array := UpdateXML(@_common_schema_mx_array, xpath, \'\');\n  return array_id;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Drops an array','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare xpath varchar(64) charset utf8;\n  if array_id is null then\n    return null;\n  end if;\n  set xpath := CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]\');\n  set @_common_schema_mx_array := UpdateXML(@_common_schema_mx_array, xpath, \'\');\n  return array_id;\nend'),('common_schema','_get_array_name','FUNCTION','_get_array_name','SQL','NO_SQL','YES','INVOKER','\n   array_id VARCHAR(16) charset ascii\n','varchar(64) CHARSET utf8','begin\n  return CONCAT(\'_qs_array_\', array_id);\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Returning internal array name by id','utf8','utf8_general_ci','latin1_swedish_ci','begin\n  return CONCAT(\'_qs_array_\', array_id);\nend'),('common_schema','_get_array_size','PROCEDURE','_get_array_size','SQL','READS_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii,\n   out array_size int unsigned\n','','main_body: begin\n  select _get_mxarray_size(array_id) into array_size;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Creates an array, returning its ID','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  select _get_mxarray_size(array_id) into array_size;\nend'),('common_schema','_create_mxarray','FUNCTION','_create_mxarray','SQL','NO_SQL','YES','INVOKER','','int(10) unsigned','main_body: begin\n  if @_common_schema_mx_array IS NULL then\n    set @_common_schema_mx_array := \'<ma></ma>\';\n  end if;\n  \n  set @_common_schema_create_mxarray_id := session_unique_id();\n  set @_common_schema_mx_array := REPLACE(@_common_schema_mx_array, \'</ma>\', CONCAT(\'<a id=\"\', @_common_schema_create_mxarray_id, \'\"><maxkey aid=\"\', @_common_schema_create_mxarray_id, \'\">0</maxkey></a></ma>\'));\n  return @_common_schema_create_mxarray_id;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Creates an array, returning its ID','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  if @_common_schema_mx_array IS NULL then\n    set @_common_schema_mx_array := \'<ma></ma>\';\n  end if;\n  \n  set @_common_schema_create_mxarray_id := session_unique_id();\n  set @_common_schema_mx_array := REPLACE(@_common_schema_mx_array, \'</ma>\', CONCAT(\'<a id=\"\', @_common_schema_create_mxarray_id, \'\"><maxkey aid=\"\', @_common_schema_create_mxarray_id, \'\">0</maxkey></a></ma>\'));\n  return @_common_schema_create_mxarray_id;\nend'),('common_schema','_push_array_element','PROCEDURE','_push_array_element','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii,\n   in  element text charset utf8\n','','main_body: begin\n  do _push_mxarray_element(array_id, element);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Pushes new element, key becomes incrementing number','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  do _push_mxarray_element(array_id, element);\nend'),('common_schema','_remove_array_element','PROCEDURE','_remove_array_element','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii,\n   in array_key varchar(127) charset utf8\n','','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set @_common_schema_get_array_element_value := NULL;\n  set exec_statement := CONCAT(\n    \'DELETE FROM \', _get_array_name(array_id), \' \n       WHERE array_key = \', IFNULL(QUOTE(array_key), \'NULL\'), \'\');\n\n  call exec_single(exec_statement);\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Creates an array, returning its ID','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set @_common_schema_get_array_element_value := NULL;\n  set exec_statement := CONCAT(\n    \'DELETE FROM \', _get_array_name(array_id), \' \n       WHERE array_key = \', IFNULL(QUOTE(array_key), \'NULL\'), \'\');\n\n  call exec_single(exec_statement);\nend'),('common_schema','_set_array_element','PROCEDURE','_set_array_element','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii,\n   in array_key varchar(127) charset utf8,\n   in element text charset utf8\n','','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set exec_statement := CONCAT(\n    \'INSERT INTO \', _get_array_name(array_id), \' \n       (array_key, value) \n     VALUES \n       (\', QUOTE(array_key), \',\', QUOTE(element), \')\n     ON DUPLICATE KEY UPDATE value = VALUES(value)\n  \');\n\n  call exec_single(exec_statement);\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Sets an element based on key','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set exec_statement := CONCAT(\n    \'INSERT INTO \', _get_array_name(array_id), \' \n       (array_key, value) \n     VALUES \n       (\', QUOTE(array_key), \',\', QUOTE(element), \')\n     ON DUPLICATE KEY UPDATE value = VALUES(value)\n  \');\n\n  call exec_single(exec_statement);\nend'),('common_schema','_truncate_array','PROCEDURE','_truncate_array','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in  array_id VARCHAR(16) charset ascii\n','','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set exec_statement := CONCAT(\n    \'TRUNCATE \', _get_array_name(array_id), \'\');\n\n  call exec_single(exec_statement);\nend','root@%','2012-04-12 12:37:15','2012-04-12 12:37:15','','Truncates an array','utf8','utf8_general_ci','latin1_swedish_ci','main_body: begin\n  declare exec_statement text default \'\';\n  \n  set exec_statement := CONCAT(\n    \'TRUNCATE \', _get_array_name(array_id), \'\');\n\n  call exec_single(exec_statement);\nend'),('common_schema','get_num_tokens','FUNCTION','get_num_tokens','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8, delimiter VARCHAR(255) CHARSET utf8','int(10) unsigned','begin\n  if CHAR_LENGTH(txt) = 0 then\n    return 0;\n  end if;\n  if CHAR_LENGTH(delimiter) = 0 then\n    return CHAR_LENGTH(txt);\n  else\n    return (CHAR_LENGTH(txt) - CHAR_LENGTH(REPLACE(txt, delimiter, \'\')))/CHAR_LENGTH(delimiter) + 1;\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return number of tokens in delimited text','utf8','utf8_general_ci','utf8_general_ci','begin\n  if CHAR_LENGTH(txt) = 0 then\n    return 0;\n  end if;\n  if CHAR_LENGTH(delimiter) = 0 then\n    return CHAR_LENGTH(txt);\n  else\n    return (CHAR_LENGTH(txt) - CHAR_LENGTH(REPLACE(txt, delimiter, \'\')))/CHAR_LENGTH(delimiter) + 1;\n  end if;\nend'),('common_schema','json_to_xml','FUNCTION','json_to_xml','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n    json_text text charset utf8\n','text CHARSET utf8','begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text;\n    declare v_level int;\n    declare v_state, expect_state varchar(255);\n    declare _json_tokens_id int unsigned default 0;\n    declare is_lvalue, is_rvalue tinyint unsigned;\n    declare scope_stack text charset ascii;\n    declare xml text charset utf8;\n    declare xml_nodes, xml_node text charset utf8;\n    \n    set json_text := trim_wspace(json_text);\n    \n    set expect_state := \'object_begin\';\n    set is_lvalue := true;\n    set is_rvalue := false;\n    set scope_stack := \'\';\n    set xml_nodes := \'\';\n    set xml_node := \'\';\n    set xml := \'\';\n    get_token_loop: repeat \n        set v_old_from = v_from;\n        call _get_json_token(json_text, v_from, v_level, v_token, 1, v_state);\n        set _json_tokens_id := _json_tokens_id + 1;\n        if v_state = \'whitespace\' then\n          iterate get_token_loop;\n        end if;\n        if v_level < 0 then\n          return null;\n          \n        end if;\n        if v_state = \'start\' and scope_stack = \'\' then\n          leave get_token_loop;\n        end if;\n        if FIND_IN_SET(v_state, expect_state) = 0 then\n          return null;\n          \n        end if;\n        if v_state = \'array_end\' and left(scope_stack, 1) = \'o\' then\n          return null;\n          \n        end if;\n        if v_state = \'object_end\' and left(scope_stack, 1) = \'a\' then\n          return null;\n          \n        end if;\n        if v_state = \'alpha\' and lower(v_token) not in (\'true\', \'false\', \'null\') then\n          return null;\n          \n        end if;\n        set is_rvalue := false;\n        case \n          when v_state = \'object_begin\' then set expect_state := \'string\', scope_stack := concat(\'o\', scope_stack), is_lvalue := true;\n          when v_state = \'array_begin\' then set expect_state := \'string,object_begin\', scope_stack := concat(\'a\', scope_stack), is_lvalue := false;\n          when v_state = \'string\' and is_lvalue then set expect_state := \'colon\', xml_node := v_token;\n          when v_state = \'colon\' then set expect_state := \'string,number,alpha,object_begin,array_begin\', is_lvalue := false;\n          when FIND_IN_SET(v_state, \'string,number,alpha\') and not is_lvalue then set expect_state := \'comma,object_end,array_end\', is_rvalue := true;\n          when v_state = \'object_end\' then set expect_state := \'comma,object_end,array_end\', scope_stack := substring(scope_stack, 2);\n          when v_state = \'array_end\' then set expect_state := \'comma,object_end,array_end\', scope_stack := substring(scope_stack, 2);\n          when v_state = \'comma\' and left(scope_stack, 1) = \'o\' then set expect_state := \'string\', is_lvalue := true;\n          when v_state = \'comma\' and left(scope_stack, 1) = \'a\' then set expect_state := \'string,object_begin\', is_lvalue := false;\n        end case;\n        set xml_node := unquote(xml_node);\n        if v_state = \'object_begin\' then \n          if substring_index(xml_nodes, \',\', 1) != \'\' then\n            set xml := concat(xml, \'<\', substring_index(xml_nodes, \',\', 1), \'>\');\n          end if;\n          set xml_nodes := concat(\',\', xml_nodes);\n        end if;\n        if v_state = \'string\' and is_lvalue then\n          if left(xml_nodes, 1) = \',\' then\n            set xml_nodes := concat(xml_node, xml_nodes);\n          else\n            set xml_nodes := concat(xml_node, substring(xml_nodes, locate(\',\', xml_nodes)));\n          end if;\n        end if;\n        if is_rvalue then\n          set xml := concat(xml, \'<\', xml_node, \'>\', encode_xml(unquote(v_token)), \'</\', xml_node, \'>\');\n        end if;\n        if v_state = \'object_end\' then \n          set xml_nodes := substring(xml_nodes, locate(\',\', xml_nodes) + 1);\n          if substring_index(xml_nodes, \',\', 1) != \'\' then\n            set xml := concat(xml, \'</\', substring_index(xml_nodes, \',\', 1), \'>\');\n          end if;\n        end if;\n    until \n        v_old_from = v_from\n    end repeat;\n    return xml;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Transforms JSON to XML','utf8','utf8_general_ci','utf8_general_ci','begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text;\n    declare v_level int;\n    declare v_state, expect_state varchar(255);\n    declare _json_tokens_id int unsigned default 0;\n    declare is_lvalue, is_rvalue tinyint unsigned;\n    declare scope_stack text charset ascii;\n    declare xml text charset utf8;\n    declare xml_nodes, xml_node text charset utf8;\n    \n    set json_text := trim_wspace(json_text);\n    \n    set expect_state := \'object_begin\';\n    set is_lvalue := true;\n    set is_rvalue := false;\n    set scope_stack := \'\';\n    set xml_nodes := \'\';\n    set xml_node := \'\';\n    set xml := \'\';\n    get_token_loop: repeat \n        set v_old_from = v_from;\n        call _get_json_token(json_text, v_from, v_level, v_token, 1, v_state);\n        set _json_tokens_id := _json_tokens_id + 1;\n        if v_state = \'whitespace\' then\n          iterate get_token_loop;\n        end if;\n        if v_level < 0 then\n          return null;\n          \n        end if;\n        if v_state = \'start\' and scope_stack = \'\' then\n          leave get_token_loop;\n        end if;\n        if FIND_IN_SET(v_state, expect_state) = 0 then\n          return null;\n          \n        end if;\n        if v_state = \'array_end\' and left(scope_stack, 1) = \'o\' then\n          return null;\n          \n        end if;\n        if v_state = \'object_end\' and left(scope_stack, 1) = \'a\' then\n          return null;\n          \n        end if;\n        if v_state = \'alpha\' and lower(v_token) not in (\'true\', \'false\', \'null\') then\n          return null;\n          \n        end if;\n        set is_rvalue := false;\n        case \n          when v_state = \'object_begin\' then set expect_state := \'string\', scope_stack := concat(\'o\', scope_stack), is_lvalue := true;\n          when v_state = \'array_begin\' then set expect_state := \'string,object_begin\', scope_stack := concat(\'a\', scope_stack), is_lvalue := false;\n          when v_state = \'string\' and is_lvalue then set expect_state := \'colon\', xml_node := v_token;\n          when v_state = \'colon\' then set expect_state := \'string,number,alpha,object_begin,array_begin\', is_lvalue := false;\n          when FIND_IN_SET(v_state, \'string,number,alpha\') and not is_lvalue then set expect_state := \'comma,object_end,array_end\', is_rvalue := true;\n          when v_state = \'object_end\' then set expect_state := \'comma,object_end,array_end\', scope_stack := substring(scope_stack, 2);\n          when v_state = \'array_end\' then set expect_state := \'comma,object_end,array_end\', scope_stack := substring(scope_stack, 2);\n          when v_state = \'comma\' and left(scope_stack, 1) = \'o\' then set expect_state := \'string\', is_lvalue := true;\n          when v_state = \'comma\' and left(scope_stack, 1) = \'a\' then set expect_state := \'string,object_begin\', is_lvalue := false;\n        end case;\n        set xml_node := unquote(xml_node);\n        if v_state = \'object_begin\' then \n          if substring_index(xml_nodes, \',\', 1) != \'\' then\n            set xml := concat(xml, \'<\', substring_index(xml_nodes, \',\', 1), \'>\');\n          end if;\n          set xml_nodes := concat(\',\', xml_nodes);\n        end if;\n        if v_state = \'string\' and is_lvalue then\n          if left(xml_nodes, 1) = \',\' then\n            set xml_nodes := concat(xml_node, xml_nodes);\n          else\n            set xml_nodes := concat(xml_node, substring(xml_nodes, locate(\',\', xml_nodes)));\n          end if;\n        end if;\n        if is_rvalue then\n          set xml := concat(xml, \'<\', xml_node, \'>\', encode_xml(unquote(v_token)), \'</\', xml_node, \'>\');\n        end if;\n        if v_state = \'object_end\' then \n          set xml_nodes := substring(xml_nodes, locate(\',\', xml_nodes) + 1);\n          if substring_index(xml_nodes, \',\', 1) != \'\' then\n            set xml := concat(xml, \'</\', substring_index(xml_nodes, \',\', 1), \'>\');\n          end if;\n        end if;\n    until \n        v_old_from = v_from\n    end repeat;\n    return xml;\nend'),('common_schema','like_to_rlike','FUNCTION','like_to_rlike','SQL','NO_SQL','YES','INVOKER','expression TEXT CHARSET utf8','text CHARSET utf8','begin\n  set expression := REPLACE(expression, \'.\', \'[.]\');\n  set expression := REPLACE(expression, \'*\', \'[*]\');\n  set expression := REPLACE(expression, \'_\', \'.\');\n  set expression := REPLACE(expression, \'%\', \'.*\');\n  set expression := CONCAT(\'^\', expression, \'$\');\n  return expression;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Convert a LIKE expression to an RLIKE expression','utf8','utf8_general_ci','utf8_general_ci','begin\n  set expression := REPLACE(expression, \'.\', \'[.]\');\n  set expression := REPLACE(expression, \'*\', \'[*]\');\n  set expression := REPLACE(expression, \'_\', \'.\');\n  set expression := REPLACE(expression, \'%\', \'.*\');\n  set expression := CONCAT(\'^\', expression, \'$\');\n  return expression;\nend'),('common_schema','mysql_qualify','FUNCTION','mysql_qualify','SQL','NO_SQL','YES','INVOKER','name TINYTEXT CHARSET utf8','tinytext CHARSET utf8','begin\n  if name RLIKE \'^`[^`]*`$\' then\n    return name;\n  end if;\n  return CONCAT(\'`\', REPLACE(name, \'`\', \'``\'), \'`\');\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return a qualified MySQL name from given text','utf8','utf8_general_ci','utf8_general_ci','begin\n  if name RLIKE \'^`[^`]*`$\' then\n    return name;\n  end if;\n  return CONCAT(\'`\', REPLACE(name, \'`\', \'``\'), \'`\');\nend'),('common_schema','split_token','FUNCTION','split_token','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8, delimiter VARCHAR(255) CHARSET utf8, token_index INT UNSIGNED','text CHARSET utf8','begin\n  if CHAR_LENGTH(delimiter) = \'\' then\n    return SUBSTRING(txt, token_index, 1);\n  else\n    return SUBSTRING_INDEX(SUBSTRING_INDEX(txt, delimiter, token_index), delimiter, -1);\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return substring by index in delimited text','utf8','utf8_general_ci','utf8_general_ci','begin\n  if CHAR_LENGTH(delimiter) = \'\' then\n    return SUBSTRING(txt, token_index, 1);\n  else\n    return SUBSTRING_INDEX(SUBSTRING_INDEX(txt, delimiter, token_index), delimiter, -1);\n  end if;\nend'),('common_schema','tokenize','PROCEDURE','tokenize','SQL','READS_SQL_DATA','NO','INVOKER','txt TEXT CHARSET utf8, delimiter VARCHAR(255) CHARSET utf8','','begin\n  declare num_tokens INT UNSIGNED DEFAULT get_num_tokens(txt, delimiter);  \n  SELECT n, split_token(txt, delimiter, n) AS token FROM numbers WHERE n BETWEEN 1 AND num_tokens;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare num_tokens INT UNSIGNED DEFAULT get_num_tokens(txt, delimiter);  \n  SELECT n, split_token(txt, delimiter, n) AS token FROM numbers WHERE n BETWEEN 1 AND num_tokens;\nend'),('common_schema','trim_wspace','FUNCTION','trim_wspace','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8','text CHARSET utf8','begin\n  declare len INT UNSIGNED DEFAULT 0;\n  declare done TINYINT UNSIGNED DEFAULT 0;\n  if txt IS NULL then\n    return txt;\n  end if;\n  while not done do\n    set len := CHAR_LENGTH(txt);\n    set txt = trim(\' \' FROM txt);\n    set txt = trim(\'\\r\' FROM txt);\n    set txt = trim(\'\\n\' FROM txt);\n    set txt = trim(\'\\t\' FROM txt);\n    set txt = trim(\'\\b\' FROM txt);\n    if CHAR_LENGTH(txt) = len then\n      set done := 1;\n    end if;\n  end while;\n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Trim whitespace characters on both sides','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare len INT UNSIGNED DEFAULT 0;\n  declare done TINYINT UNSIGNED DEFAULT 0;\n  if txt IS NULL then\n    return txt;\n  end if;\n  while not done do\n    set len := CHAR_LENGTH(txt);\n    set txt = trim(\' \' FROM txt);\n    set txt = trim(\'\r\' FROM txt);\n    set txt = trim(\'\n\' FROM txt);\n    set txt = trim(\'	\' FROM txt);\n    set txt = trim(\'\' FROM txt);\n    if CHAR_LENGTH(txt) = len then\n      set done := 1;\n    end if;\n  end while;\n  return txt;\nend'),('common_schema','unquote','FUNCTION','unquote','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8','text CHARSET utf8','begin\n  declare quoting_char VARCHAR(1) CHARSET utf8;\n  declare terminating_quote_escape_char VARCHAR(1) CHARSET utf8;\n  declare current_pos INT UNSIGNED;\n  declare end_quote_pos INT UNSIGNED;\n\n  if CHAR_LENGTH(txt) < 2 then\n    return txt;\n  end if;\n  \n  set quoting_char := LEFT(txt, 1);\n  if not quoting_char in (\'\'\'\', \'\"\', \'`\', \'/\') then\n    return txt;\n  end if;\n  if txt in (\'\'\'\'\'\', \'\"\"\', \'``\', \'//\') then\n    return \'\';\n  end if;\n  \n  set current_pos := 1;\n  terminating_quote_loop: while current_pos > 0 do\n    set current_pos := LOCATE(quoting_char, txt, current_pos + 1);\n    if current_pos = 0 then\n      \n      return txt;\n    end if;\n    if SUBSTRING(txt, current_pos, 2) = REPEAT(quoting_char, 2) then\n      set current_pos := current_pos + 1;\n      iterate terminating_quote_loop;\n    end if;\n    set terminating_quote_escape_char := SUBSTRING(txt, current_pos - 1, 1);\n    if (terminating_quote_escape_char = quoting_char) or (terminating_quote_escape_char = \'\\\\\') then\n      \n      \n      iterate terminating_quote_loop;\n    end if;\n    \n    leave terminating_quote_loop;\n  end while;\n  if current_pos = CHAR_LENGTH(txt) then\n      return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n    end if;\n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Unquotes a given text','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare quoting_char VARCHAR(1) CHARSET utf8;\n  declare terminating_quote_escape_char VARCHAR(1) CHARSET utf8;\n  declare current_pos INT UNSIGNED;\n  declare end_quote_pos INT UNSIGNED;\n\n  if CHAR_LENGTH(txt) < 2 then\n    return txt;\n  end if;\n  \n  set quoting_char := LEFT(txt, 1);\n  if not quoting_char in (\'\'\', \'\"\', \'`\', \'/\') then\n    return txt;\n  end if;\n  if txt in (\'\'\'\', \'\"\"\', \'``\', \'//\') then\n    return \'\';\n  end if;\n  \n  set current_pos := 1;\n  terminating_quote_loop: while current_pos > 0 do\n    set current_pos := LOCATE(quoting_char, txt, current_pos + 1);\n    if current_pos = 0 then\n      \n      return txt;\n    end if;\n    if SUBSTRING(txt, current_pos, 2) = REPEAT(quoting_char, 2) then\n      set current_pos := current_pos + 1;\n      iterate terminating_quote_loop;\n    end if;\n    set terminating_quote_escape_char := SUBSTRING(txt, current_pos - 1, 1);\n    if (terminating_quote_escape_char = quoting_char) or (terminating_quote_escape_char = \'\\\') then\n      \n      \n      iterate terminating_quote_loop;\n    end if;\n    \n    leave terminating_quote_loop;\n  end while;\n  if current_pos = CHAR_LENGTH(txt) then\n      return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n    end if;\n  return txt;\nend'),('common_schema','unwrap','FUNCTION','unwrap','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8','text CHARSET utf8','begin\n  if CHAR_LENGTH(txt) < 2 then\n    return txt;\n  end if;\n  if LEFT(txt, 1) = \'{\' AND RIGHT(txt, 1) = \'}\' then\n    return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n  end if;\n  if LEFT(txt, 1) = \'[\' AND RIGHT(txt, 1) = \']\' then\n    return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n  end if;\n  if LEFT(txt, 1) = \'(\' AND RIGHT(txt, 1) = \')\' then\n    return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n  end if;\n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Unwraps a given text from braces','utf8','utf8_general_ci','utf8_general_ci','begin\n  if CHAR_LENGTH(txt) < 2 then\n    return txt;\n  end if;\n  if LEFT(txt, 1) = \'{\' AND RIGHT(txt, 1) = \'}\' then\n    return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n  end if;\n  if LEFT(txt, 1) = \'[\' AND RIGHT(txt, 1) = \']\' then\n    return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n  end if;\n  if LEFT(txt, 1) = \'(\' AND RIGHT(txt, 1) = \')\' then\n    return SUBSTRING(txt, 2, CHAR_LENGTH(txt) - 2);\n  end if;\n  return txt;\nend'),('common_schema','easter_day','FUNCTION','easter_day','SQL','NO_SQL','YES','INVOKER','dt DATETIME','date','BEGIN\n    DECLARE p_year    SMALLINT DEFAULT YEAR(dt);\n    DECLARE a    SMALLINT DEFAULT p_year % 19;\n    DECLARE b    SMALLINT DEFAULT p_year DIV 100;\n    DECLARE c    SMALLINT DEFAULT p_year % 100;\n    DECLARE d    SMALLINT DEFAULT b DIV 4;\n    DECLARE e    SMALLINT DEFAULT b % 4;\n    DECLARE f    SMALLINT DEFAULT (b + 8) DIV 25;\n    DECLARE g    SMALLINT DEFAULT (b - f + 1) DIV 3;\n    DECLARE h    SMALLINT DEFAULT (19*a + b - d - g + 15) % 30;\n    DECLARE i    SMALLINT DEFAULT c DIV 4;\n    DECLARE k    SMALLINT DEFAULT c % 4;\n    DECLARE L    SMALLINT DEFAULT (32 + 2*e + 2*i - h - k) % 7;\n    DECLARE m    SMALLINT DEFAULT (a + 11*h + 22*L) DIV 451;\n    DECLARE v100 SMALLINT DEFAULT h + L - 7*m + 114;\n        \n    RETURN STR_TO_DATE(\n                CONCAT(\n                    p_year\n                ,   \'-\'\n                ,    v100 DIV 31\n                ,   \'-\'\n                ,   (v100 % 31) + 1\n                )\n            ,   \'%Y-%c-%e\'\n            );\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns date of easter day for given year','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n    DECLARE p_year    SMALLINT DEFAULT YEAR(dt);\n    DECLARE a    SMALLINT DEFAULT p_year % 19;\n    DECLARE b    SMALLINT DEFAULT p_year DIV 100;\n    DECLARE c    SMALLINT DEFAULT p_year % 100;\n    DECLARE d    SMALLINT DEFAULT b DIV 4;\n    DECLARE e    SMALLINT DEFAULT b % 4;\n    DECLARE f    SMALLINT DEFAULT (b + 8) DIV 25;\n    DECLARE g    SMALLINT DEFAULT (b - f + 1) DIV 3;\n    DECLARE h    SMALLINT DEFAULT (19*a + b - d - g + 15) % 30;\n    DECLARE i    SMALLINT DEFAULT c DIV 4;\n    DECLARE k    SMALLINT DEFAULT c % 4;\n    DECLARE L    SMALLINT DEFAULT (32 + 2*e + 2*i - h - k) % 7;\n    DECLARE m    SMALLINT DEFAULT (a + 11*h + 22*L) DIV 451;\n    DECLARE v100 SMALLINT DEFAULT h + L - 7*m + 114;\n        \n    RETURN STR_TO_DATE(\n                CONCAT(\n                    p_year\n                ,   \'-\'\n                ,    v100 DIV 31\n                ,   \'-\'\n                ,   (v100 % 31) + 1\n                )\n            ,   \'%Y-%c-%e\'\n            );\nEND'),('common_schema','start_of_hour','FUNCTION','start_of_hour','SQL','NO_SQL','YES','INVOKER','dt DATETIME','datetime','BEGIN\n  RETURN DATE(dt) + INTERVAL HOUR(dt) HOUR;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns DATETIME of beginning of round hour of given DATETIME.','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN DATE(dt) + INTERVAL HOUR(dt) HOUR;\nEND'),('common_schema','start_of_month','FUNCTION','start_of_month','SQL','NO_SQL','YES','INVOKER','dt DATETIME','date','BEGIN\n  RETURN DATE(dt) - INTERVAL (DAYOFMONTH(dt) - 1) DAY;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns first day of month of given datetime, as DATE object','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN DATE(dt) - INTERVAL (DAYOFMONTH(dt) - 1) DAY;\nEND'),('common_schema','start_of_quarter','FUNCTION','start_of_quarter','SQL','NO_SQL','YES','INVOKER','dt DATETIME','date','BEGIN\n  RETURN DATE(dt) - INTERVAL (MONTH(dt) -1) MONTH - INTERVAL (DAYOFMONTH(dt) - 1) DAY + INTERVAL (QUARTER(dt) - 1) QUARTER;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns first day of quarter of given datetime, as DATE object','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN DATE(dt) - INTERVAL (MONTH(dt) -1) MONTH - INTERVAL (DAYOFMONTH(dt) - 1) DAY + INTERVAL (QUARTER(dt) - 1) QUARTER;\nEND'),('common_schema','start_of_week','FUNCTION','start_of_week','SQL','NO_SQL','YES','INVOKER','dt DATETIME','date','BEGIN\n  RETURN DATE(dt) - INTERVAL WEEKDAY(dt) DAY;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns Monday-based first day of week of given datetime','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN DATE(dt) - INTERVAL WEEKDAY(dt) DAY;\nEND'),('common_schema','start_of_week_sunday','FUNCTION','start_of_week_sunday','SQL','NO_SQL','YES','INVOKER','dt DATETIME','date','BEGIN\n  RETURN DATE(dt) - INTERVAL (WEEKDAY(dt) + 1) DAY;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns Sunday-based first day of week of given datetime','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN DATE(dt) - INTERVAL (WEEKDAY(dt) + 1) DAY;\nEND'),('common_schema','start_of_year','FUNCTION','start_of_year','SQL','NO_SQL','YES','INVOKER','dt DATETIME','date','BEGIN\n  RETURN DATE(dt) - INTERVAL (MONTH(dt) -1) MONTH - INTERVAL (DAYOFMONTH(dt) - 1) DAY;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns first day of month of given datetime, as DATE object','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN DATE(dt) - INTERVAL (MONTH(dt) -1) MONTH - INTERVAL (DAYOFMONTH(dt) - 1) DAY;\nEND'),('test','p_mean','PROCEDURE','p_mean','SQL','CONTAINS_SQL','NO','DEFINER','\n    data   text\n,   p      tinyint\n','','begin\n    \n    declare n int default 1 + length(data) - length(replace(data, \',\', \'\'));\n    \n    declare m int default n * p / 2 / 100;\n    \n    declare t text default substring_index(substring_index(data, \',\', n-m), \',\', -(n-m-m));\n    \n    declare c varchar(1);\n    \n    declare x, y varchar(32);\n    \n    declare z int unsigned default 0;\n    \n    declare l int unsigned default length(t);\n    \n    declare i, j int unsigned default 1;\n    \n    declare v int default 0;\n    \n    declare d, s int unsigned default 0;\n    select n, m, t;\n    repeat\n        \n        set c = substring(t, i, 1);\n        \n        if substring(t, i, 1) in (\',\', \'\') then\n            \n            set x = substring(t, j, i - j),\n                j = i + 1,\n                d = instr(x, \'.\')\n            ;\n            select x;\n            \n            if d = 0 then\n                set v = v + cast(x as signed);\n            else\n            \n            \n            \n                set v = v + cast(substring_index(x, \'.\', 1) as signed)\n                ,   y = substring_index(x, \'.\', -1)\n                ,   z = greatest(z, length(y))\n                ,   d = cast(rpad(cast(d as char), \'0\', z + 1) as unsigned) + cast(rpad(concat(\'1\', y), \'0\', z + 1) as unsigned)\n                ;\n            end if;\n        end if;\n        set i = i + 1;\n    until c = \'\' end repeat;\n    set s = cast(rpad(\'1\', \'0\', z + 1) as unsigned)\n    ,   n = (n - 2 * m)\n    ;\n    select s, n, v, d;\n    select (v + case d when 0 then 0 else (d - n * s) / s end) / n;\nend','root@%','2013-02-14 22:22:08','2013-02-14 22:22:08','','','utf8','utf8_general_ci','latin1_swedish_ci','begin\n    \n    declare n int default 1 + length(data) - length(replace(data, \',\', \'\'));\n    \n    declare m int default n * p / 2 / 100;\n    \n    declare t text default substring_index(substring_index(data, \',\', n-m), \',\', -(n-m-m));\n    \n    declare c varchar(1);\n    \n    declare x, y varchar(32);\n    \n    declare z int unsigned default 0;\n    \n    declare l int unsigned default length(t);\n    \n    declare i, j int unsigned default 1;\n    \n    declare v int default 0;\n    \n    declare d, s int unsigned default 0;\n    select n, m, t;\n    repeat\n        \n        set c = substring(t, i, 1);\n        \n        if substring(t, i, 1) in (\',\', \'\') then\n            \n            set x = substring(t, j, i - j),\n                j = i + 1,\n                d = instr(x, \'.\')\n            ;\n            select x;\n            \n            if d = 0 then\n                set v = v + cast(x as signed);\n            else\n            \n            \n            \n                set v = v + cast(substring_index(x, \'.\', 1) as signed)\n                ,   y = substring_index(x, \'.\', -1)\n                ,   z = greatest(z, length(y))\n                ,   d = cast(rpad(cast(d as char), \'0\', z + 1) as unsigned) + cast(rpad(concat(\'1\', y), \'0\', z + 1) as unsigned)\n                ;\n            end if;\n        end if;\n        set i = i + 1;\n    until c = \'\' end repeat;\n    set s = cast(rpad(\'1\', \'0\', z + 1) as unsigned)\n    ,   n = (n - 2 * m)\n    ;\n    select s, n, v, d;\n    select (v + case d when 0 then 0 else (d - n * s) / s end) / n;\nend'),('test','t_mean','FUNCTION','t_mean','SQL','CONTAINS_SQL','NO','DEFINER','\n    \n    \n    data   text\n    \n,   p      tinyint\n','double','begin\n    \n    declare n int default 1 + length(data) - length(replace(data, \',\', \'\'));\n    \n    declare m int default n * p / 2 / 100;\n    \n    declare t text default substring_index(substring_index(data, \',\', n-m), \',\', -(n-m-m));\n    \n    declare c varchar(1);\n    \n    declare x, y varchar(32);\n    \n    declare z int unsigned default 0;\n    \n    declare l int unsigned default length(t);\n    \n    declare i, j int unsigned default 1;\n    \n    declare v int default 0;\n    \n    declare d, s int unsigned default 0;\n    repeat\n        \n        set c = substring(t, i, 1);\n        \n        if substring(t, i, 1) in (\',\', \'\') then\n            \n            set x = substring(t, j, i - j),\n                j = i + 1,\n                d = instr(x, \'.\')\n            ;\n            \n            if d = 0 then\n                set v = v + cast(x as signed);\n            else\n            \n            \n            \n                set v = v + cast(substring_index(x, \'.\', 1) as signed)\n                ,   y = substring_index(x, \'.\', -1)\n                ,   z = greatest(z, length(y))\n                ,   d = cast(rpad(cast(d as char), \'0\', z + 1) as unsigned) + cast(rpad(concat(\'1\', y), \'0\', z + 1) as unsigned)\n                ;\n            end if;\n        end if;\n        \n        set i = i + 1;\n    \n    until c = \'\' end repeat;\n    \n    \n    set s = cast(rpad(\'1\', \'0\', z + 1) as unsigned)\n    ,   n = (n - 2 * m)\n    ;\n    \n    return (v + case d when 0 then 0 else (d - n * s) / s end) / n;\nend','root@%','2013-02-14 22:22:08','2013-02-14 22:22:08','','','utf8','utf8_general_ci','latin1_swedish_ci','begin\n    \n    declare n int default 1 + length(data) - length(replace(data, \',\', \'\'));\n    \n    declare m int default n * p / 2 / 100;\n    \n    declare t text default substring_index(substring_index(data, \',\', n-m), \',\', -(n-m-m));\n    \n    declare c varchar(1);\n    \n    declare x, y varchar(32);\n    \n    declare z int unsigned default 0;\n    \n    declare l int unsigned default length(t);\n    \n    declare i, j int unsigned default 1;\n    \n    declare v int default 0;\n    \n    declare d, s int unsigned default 0;\n    repeat\n        \n        set c = substring(t, i, 1);\n        \n        if substring(t, i, 1) in (\',\', \'\') then\n            \n            set x = substring(t, j, i - j),\n                j = i + 1,\n                d = instr(x, \'.\')\n            ;\n            \n            if d = 0 then\n                set v = v + cast(x as signed);\n            else\n            \n            \n            \n                set v = v + cast(substring_index(x, \'.\', 1) as signed)\n                ,   y = substring_index(x, \'.\', -1)\n                ,   z = greatest(z, length(y))\n                ,   d = cast(rpad(cast(d as char), \'0\', z + 1) as unsigned) + cast(rpad(concat(\'1\', y), \'0\', z + 1) as unsigned)\n                ;\n            end if;\n        end if;\n        \n        set i = i + 1;\n    \n    until c = \'\' end repeat;\n    \n    \n    set s = cast(rpad(\'1\', \'0\', z + 1) as unsigned)\n    ,   n = (n - 2 * m)\n    ;\n    \n    return (v + case d when 0 then 0 else (d - n * s) / s end) / n;\nend'),('test','f','FUNCTION','f','SQL','CONTAINS_SQL','NO','DEFINER','','int(11)','begin\n   declare v int;\n   set v = (select count(*) from dual);\n   return v;\nend','root@%','2013-02-14 22:22:08','2013-02-14 22:22:08','','','utf8','utf8_general_ci','latin1_swedish_ci','begin\n   declare v int;\n   set v = (select count(*) from dual);\n   return v;\nend'),('common_schema','_parse_sql','PROCEDURE','_parse_sql','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n    in p_text text\n','','begin\n    declare v_from, v_old_from, v_id, v_left_id, v_right_id, v_prec, v_prev_prec, v_prev_id int unsigned;\n    declare v_token, v_prev_token text;\n    declare v_level int;\n    declare v_state, v_prev_state varchar(32);\n\n    drop temporary table if exists _sql_parse_tree_token;\n    create temporary table _sql_parse_tree_token(\n        id int unsigned auto_increment primary key\n    ,   start int unsigned  not null\n    ,   level int not null\n    ,   token text\n    ,   state text           not null\n    ,   prev      int unsigned\n    ,   prec      int unsigned not null\n    ) engine=MyISAM;\n\n    drop temporary table if exists _sql_parse_tree_node;\n    create temporary table _sql_parse_tree_node (\n        id int unsigned\n    ,   left_id int unsigned\n    ,   right_id int unsigned\n    ) engine=MyISAM;\n\n    my_loop: repeat\n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, 1, v_state);\n        \n        \n        if v_state in (\n            \'whitespace\'\n        ,   \'multi line comment\'\n        ,   \'single line comment\'\n        ,   \'conditional comment\'\n        ) then\n          iterate my_loop;\n        end if;\n\n        set v_prec = case v_state\n            when \'and\' then 10\n            when \'assign\' then 10\n            when \'bitwise and\' then 10\n            when \'bitwise or\' then 10\n            when \'bitwise not\' then 10\n            when \'bitwise xor\' then 10\n            when \'comma\' then 1000\n            when \'divide\' then 10\n            when \'dot\' then 10\n            when \'equals\' then 10\n            when \'greater than\' then 10\n            when \'greater than or equals\' then 10\n            when \'left parenthesis\' then 10\n            when \'left shift\' then 10\n            when \'less than\' then 10\n            when \'less than or equals\' then 10\n            when \'minus\' then 10\n            when \'modulo\' then 10\n            when \'multiply\' then 10\n            when \'negate\' then 10\n            when \'not equals\' then 10\n            when \'null safe equals\' then 10\n            when \'or\' then 10\n            when \'plus\' then 10\n            when \'right parenthesis\' then 10\n            when \'right shift\' then 10\n            when \'start\' then 1\n            when \'statement delimiter\' then 2\n            when \'not\' then 10\n            when \'alpha\' then\n                case v_token\n                  \n                  when \'ADD\' then 10\n                  when \'ALL\' then 10\n                  when \'ALTER\' then 10\n                  when \'ANALYZE\' then 10\n                  when \'AND\' then 10\n                  when \'AS\'  then 10\n                  when \'ASC\'  then 10\n                  when \'ASENSITIVE\'  then 10\n                  when \'BEFORE\'  then 10\n                  when \'BEGIN\'  then 10\n                  when \'BETWEEN\'  then 10\n                  when \'BIGINT\'  then 10\n                  when \'BINARY\'  then 10\n                  when \'BLOB\'  then 10\n                  when \'BOTH\'  then 10\n                  when \'BY\'  then 10\n                  when \'CALL\'  then 10\n                  when \'CASCADE\'  then 10\n                  when \'CASE\'  then 10\n                  when \'CHANGE\'  then 10\n                  when \'CHAR\'  then 10\n                  when \'CHARACTER\'  then 10\n                  when \'CHECK\'  then 10\n                  when \'COLLATE\'  then 10\n                  when \'COLUMN\'  then 10\n                  when \'CONDITION\'  then 10\n                  when \'CONSTRAINT\'  then 10\n                  when \'CONTINUE\'  then 10\n                  when \'CONVERT\'  then 10\n                  when \'CREATE\'  then 10\n                  when \'CROSS\'  then 10\n                  when \'CURRENT_DATE\'  then 10\n                  when \'CURRENT_TIME\'  then 10\n                  when \'CURRENT_TIMESTAMP\'  then 10\n                  when \'CURRENT_USER\'  then 10\n                  when \'CURSOR\'  then 10\n                  when \'DATABASE\'  then 10\n                  when \'DATABASES\'  then 10\n                  when \'DAY_HOUR\'  then 10\n                  when \'DAY_MICROSECOND\'  then 10\n                  when \'DAY_MINUTE\'  then 10\n                  when \'DAY_SECOND\'  then 10\n                  when \'DEC\'  then 10\n                  when \'DECIMAL\'  then 10\n                  when \'DECLARE\'  then 10\n                  when \'DEFAULT\'  then 10\n                  when \'DELAYED\'  then 10\n                  when \'DELETE\'  then 10\n                  when \'DESC\'  then 10\n                  when \'DESCRIBE\'  then 10\n                  when \'DETERMINISTIC\'  then 10\n                  when \'DISTINCT\'  then 10\n                  when \'DISTINCTROW\'  then 10\n                  when \'DIV\'  then 10\n                  when \'DOUBLE\'  then 10\n                  when \'DROP\'  then 10\n                  when \'DUAL\'  then 10\n                  when \'EACH\'  then 10\n                  when \'ELSE\'  then 10\n                  when \'ELSEIF\'  then 10\n                  when \'END\'  then 10\n                  when \'ENCLOSED\'  then 10\n                  when \'ESCAPED\'  then 10\n                  when \'EXISTS\'  then 10\n                  when \'EXIT\'  then 10\n                  when \'EXPLAIN\'  then 10\n                  when \'FALSE\'  then 10\n                  when \'FETCH\'  then 10\n                  when \'FLOAT\'  then 10\n                  when \'FLOAT4\'  then 10\n                  when \'FLOAT8\'  then 10\n                  when \'FOR\'  then 10\n                  when \'FORCE\'  then 10\n                  when \'FOREIGN\'  then 10\n                  when \'FROM\'  then 10\n                  when \'FULLTEXT\'  then 10\n                  when \'GRANT\'  then 10\n                  when \'GROUP\'  then 10\n                  when \'HAVING\'  then 10\n                  when \'HIGH_PRIORITY\'  then 10\n                  when \'HOUR_MICROSECOND\'  then 10\n                  when \'HOUR_MINUTE\'  then 10\n                  when \'HOUR_SECOND\'  then 10\n                  when \'IF\'  then 10\n                  when \'IGNORE\'  then 10\n                  when \'IN\'  then 10\n                  when \'INDEX\'  then 10\n                  when \'INFILE\'  then 10\n                  when \'INNER\'  then 10\n                  when \'INOUT\'  then 10\n                  when \'INSENSITIVE\'  then 10\n                  when \'INSERT\'  then 10\n                  when \'INT\'  then 10\n                  when \'INT1\'  then 10\n                  when \'INT2\'  then 10\n                  when \'INT3\'  then 10\n                  when \'INT4\'  then 10\n                  when \'INT8\'  then 10\n                  when \'INTEGER\'  then 10\n                  when \'INTERVAL\'  then 10\n                  when \'INTO\'  then 10\n                  when \'IS\'  then 10\n                  when \'ITERATE\'  then 10\n                  when \'JOIN\'  then 10\n                  when \'KEY\'  then 10\n                  when \'KEYS\'  then 10\n                  when \'KILL\'  then 10\n                  when \'LEADING\'  then 10\n                  when \'LEAVE\'  then 10\n                  when \'LEFT\'  then 10\n                  when \'LIKE\'  then 10\n                  when \'LIMIT\'  then 10\n                  when \'LINEAR\'  then 10\n                  when \'LINES\'  then 10\n                  when \'LOAD\'  then 10\n                  when \'LOCALTIME\'  then 10\n                  when \'LOCALTIMESTAMP\'  then 10\n                  when \'LOCK\'  then 10\n                  when \'LONG\'  then 10\n                  when \'LONGBLOB\'  then 10\n                  when \'LONGTEXT\' then 10\n                  when \'LOOP\'  then 10\n                  when \'LOW_PRIORITY\'  then 10\n                  when \'MASTER_SSL_VERIFY_SERVER_CERT\'  then 10\n                  when \'MATCH\'  then 10\n                  when \'MAXVALUE\'  then 10\n                  when \'MEDIUMBLOB\'  then 10\n                  when \'MEDIUMINT\'  then 10\n                  when \'MEDIUMTEXT\'  then 10\n                  when \'MIDDLEINT\'  then 10\n                  when \'MINUTE_MICROSECOND\'  then 10\n                  when \'MINUTE_SECOND\'  then 10\n                  when \'MOD\'  then 10\n                  when \'MODIFIES\'  then 10\n                  when \'NATURAL\'  then 10\n                  when \'NOT\'  then 10\n                  when \'NO_WRITE_TO_BINLOG\'  then 10\n                  when \'NULL\'  then 10\n                  when \'NUMERIC\'  then 10\n                  when \'ON\'  then 10\n                  when \'OPTIMIZE\'  then 10\n                  when \'OPTION\'  then 10\n                  when \'OPTIONALLY\'  then 10\n                  when \'OR\'  then 10\n                  when \'ORDER\'  then 10\n                  when \'OUT\'  then 10\n                  when \'OUTER\'  then 10\n                  when \'OUTFILE\'  then 10\n                  when \'PRECISION\'  then 10\n                  when \'PRIMARY\'  then 10\n                  when \'PROCEDURE\'  then 10\n                  when \'PURGE\'  then 10\n                  when \'RANGE\'  then 10\n                  when \'READ\'  then 10\n                  when \'READS\'  then 10\n                  when \'READ_WRITE\'  then 10\n                  when \'REAL\'  then 10\n                  when \'REFERENCES\'  then 10\n                  when \'REGEXP\'  then 10\n                  when \'RELEASE\'  then 10\n                  when \'RENAME\'  then 10\n                  when \'REPEAT\'  then 10\n                  when \'REPLACE\'  then 10\n                  when \'REQUIRE\'  then 10\n                  when \'RESIGNAL\'  then 10\n                  when \'RESTRICT\'  then 10\n                  when \'RETURN\'  then 10\n                  when \'REVOKE\'  then 10\n                  when \'RIGHT\'  then 10\n                  when \'RLIKE\'  then 10\n                  when \'SCHEMA\'  then 10\n                  when \'SCHEMAS\'  then 10\n                  when \'SECOND_MICROSECOND\'  then 10\n                  when \'SELECT\'  then 10\n                  when \'SENSITIVE\'  then 10\n                  when \'SEPARATOR\'  then 10\n                  when \'SET\'  then 10\n                  when \'SHOW\'  then 10\n                  when \'SIGNAL\'  then 10\n                  when \'SMALLINT\'  then 10\n                  when \'SPATIAL\'  then 10\n                  when \'SLOW\'  then 10\n                  when \'SPECIFIC\'  then 10\n                  when \'SQL SQLEXCEPTION\'  then 10\n                  when \'SQLSTATE\'  then 10\n                  when \'SQLWARNING\'  then 10\n                  when \'SQL_BIG_RESULT\'  then 10\n                  when \'SQL_CALC_FOUND_ROWS\'  then 10\n                  when \'SQL_SMALL_RESULT\'  then 10\n                  when \'SSL\'  then 10\n                  when \'STARTING\'  then 10\n                  when \'STRAIGHT_JOIN\'  then 10\n                  when \'TABLE\'  then 10\n                  when \'TERMINATED\'  then 10\n                  when \'THEN\'  then 10\n                  when \'TINYBLOB\'  then 10\n                  when \'TINYINT\'  then 10\n                  when \'TINYTEXT\'  then 10\n                  when \'TO\'  then 10\n                  when \'TRAILING\'  then 10\n                  when \'TRIGGER\'  then 10\n                  when \'TRUE\'  then 10\n                  when \'UNDO\'  then 10\n                  when \'UNION\'  then 10\n                  when \'UNIQUE\'  then 10\n                  when \'UNLOCK\'  then 10\n                  when \'UPDATE\'  then 10\n                  when \'USAGE\'  then 10\n                  when \'USE\'  then 10\n                  when \'USING\'  then 10\n                  when \'UTC_DATE\'  then 10\n                  when \'UTC_TIME\'  then 10\n                  when \'UTC_TIMESTAMP\'  then 10\n                  when \'VALUES\'  then 10\n                  when \'VARBINARY\'  then 10\n                  when \'VARCHAR\'  then 10\n                  when \'VARCHARACTER\'  then 10\n                  when \'VARYING\'  then 10\n                  when \'WHEN\'  then 10\n                  when \'WHERE\'  then 10\n                  when \'WHILE\'  then 10\n                  when \'WITH\'  then 10\n                  when \'WRITE\'  then 10\n                  when \'XOR\'  then 10\n                  when \'YEAR_MONTH\'  then 10\n                  when \'ZEROFILL\'  then 10\n                  when \'GENERAL\'  then 10\n                  when \'IGNORE_SERVER_IDS\'  then 10\n                  when \'MASTER_HEARTBEAT_PERIOD\'  then 10\n                  when \'MAXVALUE\'  then 10\n                  when \'RESIGNAL\'  then 10\n                  when \'SIGNAL\'  then 10\n                  else 0\n                end\n            else 0\n        end;\n        insert into _sql_parse_tree_token(start, level, token, state, prec, prev)\n        values (v_from, v_level, v_token, v_state, v_prec, if(v_prec, v_prev_id, null));\n\n        if v_prec then\n\n            set @guard = 0;\n            while_reduce: while v_prev_prec > v_prec and @guard < 5 do\n\n                select    SQL_CALC_FOUND_ROWS\n                          id, token, state, prev\n                into      v_id, v_token, v_state, v_prev_id\n                from      _sql_parse_tree_token\n                where     id    = v_prev_id\n                limit     1\n                ;\n\n                if found_rows() = 0 then\n                    select \'No previous operator found, leaving.\';\n                    leave while_reduce;\n                end if;\n\n                select    prec, prev\n                into      v_prev_prec, v_prev_id\n                from      _sql_parse_tree_token\n                where     id = v_prev_id\n                ;\nselect @guard:=@guard+1, v_id, v_token, v_state, v_prev_id, v_prev_prec, v_prec;\n                case\n                  when v_state in (\n                      \'and\', \'assign\'\n                  ,   \'bitwise and\', \'bitwise or\', \'bitwise not\', \'bitwise xor\'\n                  ,   \'comma\'\n                  ,   \'divide\', \'dot\'\n                  ,   \'equals\'\n                  ,   \'greater than\'\n                  ,   \'greater than or equals\'\n                  ,   \'left shift\', \'less than\', \'less than or equals\'\n                  ,   \'modulo\', \'multiply\'\n                  ,   \'not equals\'\n                  ,   \'null safe equals\'\n                  ,   \'or\'\n                  ,   \'right shift\'\n                  ) then\nselect \'reducing binary operator \' + v_id;\n                      select  id\n                      into    v_left_id\n                      from    _sql_parse_tree_node\n                      where   right_id = v_id - 1\n                      ;\n                      select  id\n                      into    v_right_id\n                      from    _sql_parse_tree_node\n                      where   left_id = v_id + 1\n                      ;\n\n                      insert into _sql_parse_tree_node(id, left_id, right_id)\n                      values (v_id, v_left_id, v_right_id)\n                      ;\n\nselect \'before\', t.* from _sql_parse_tree_token t;\n\n                      update _sql_parse_tree_token\n                      set    prev = case\n                                        when id   = v_id then NULL\n                                        when prev = v_id then v_prev_id\n                                        else null\n                                    end\n                      where  prev = v_id\n                      or     id   = v_id\n                      ;\n\nselect \'after\', t.* from _sql_parse_tree_token t;\n\n                  else do null;\n                end case;\n            end while;\n            set v_prev_id = last_insert_id()\n            ,   v_prev_prec = v_prec\n            ;\n        else\n            insert into _sql_parse_tree_node(id, left_id, right_id)\n            values (last_insert_id(), last_insert_id(), last_insert_id());\n        end if;\n    until\n        v_old_from = v_from\n    end repeat;\n\nend','root@%','2012-08-20 19:06:23','2012-08-20 19:06:23','','Parses SQL','utf8','utf8_general_ci','latin1_swedish_ci','begin\n    declare v_from, v_old_from, v_id, v_left_id, v_right_id, v_prec, v_prev_prec, v_prev_id int unsigned;\n    declare v_token, v_prev_token text;\n    declare v_level int;\n    declare v_state, v_prev_state varchar(32);\n\n    drop temporary table if exists _sql_parse_tree_token;\n    create temporary table _sql_parse_tree_token(\n        id int unsigned auto_increment primary key\n    ,   start int unsigned  not null\n    ,   level int not null\n    ,   token text\n    ,   state text           not null\n    ,   prev      int unsigned\n    ,   prec      int unsigned not null\n    ) engine=MyISAM;\n\n    drop temporary table if exists _sql_parse_tree_node;\n    create temporary table _sql_parse_tree_node (\n        id int unsigned\n    ,   left_id int unsigned\n    ,   right_id int unsigned\n    ) engine=MyISAM;\n\n    my_loop: repeat\n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, 1, v_state);\n        \n        \n        if v_state in (\n            \'whitespace\'\n        ,   \'multi line comment\'\n        ,   \'single line comment\'\n        ,   \'conditional comment\'\n        ) then\n          iterate my_loop;\n        end if;\n\n        set v_prec = case v_state\n            when \'and\' then 10\n            when \'assign\' then 10\n            when \'bitwise and\' then 10\n            when \'bitwise or\' then 10\n            when \'bitwise not\' then 10\n            when \'bitwise xor\' then 10\n            when \'comma\' then 1000\n            when \'divide\' then 10\n            when \'dot\' then 10\n            when \'equals\' then 10\n            when \'greater than\' then 10\n            when \'greater than or equals\' then 10\n            when \'left parenthesis\' then 10\n            when \'left shift\' then 10\n            when \'less than\' then 10\n            when \'less than or equals\' then 10\n            when \'minus\' then 10\n            when \'modulo\' then 10\n            when \'multiply\' then 10\n            when \'negate\' then 10\n            when \'not equals\' then 10\n            when \'null safe equals\' then 10\n            when \'or\' then 10\n            when \'plus\' then 10\n            when \'right parenthesis\' then 10\n            when \'right shift\' then 10\n            when \'start\' then 1\n            when \'statement delimiter\' then 2\n            when \'not\' then 10\n            when \'alpha\' then\n                case v_token\n                  \n                  when \'ADD\' then 10\n                  when \'ALL\' then 10\n                  when \'ALTER\' then 10\n                  when \'ANALYZE\' then 10\n                  when \'AND\' then 10\n                  when \'AS\'  then 10\n                  when \'ASC\'  then 10\n                  when \'ASENSITIVE\'  then 10\n                  when \'BEFORE\'  then 10\n                  when \'BEGIN\'  then 10\n                  when \'BETWEEN\'  then 10\n                  when \'BIGINT\'  then 10\n                  when \'BINARY\'  then 10\n                  when \'BLOB\'  then 10\n                  when \'BOTH\'  then 10\n                  when \'BY\'  then 10\n                  when \'CALL\'  then 10\n                  when \'CASCADE\'  then 10\n                  when \'CASE\'  then 10\n                  when \'CHANGE\'  then 10\n                  when \'CHAR\'  then 10\n                  when \'CHARACTER\'  then 10\n                  when \'CHECK\'  then 10\n                  when \'COLLATE\'  then 10\n                  when \'COLUMN\'  then 10\n                  when \'CONDITION\'  then 10\n                  when \'CONSTRAINT\'  then 10\n                  when \'CONTINUE\'  then 10\n                  when \'CONVERT\'  then 10\n                  when \'CREATE\'  then 10\n                  when \'CROSS\'  then 10\n                  when \'CURRENT_DATE\'  then 10\n                  when \'CURRENT_TIME\'  then 10\n                  when \'CURRENT_TIMESTAMP\'  then 10\n                  when \'CURRENT_USER\'  then 10\n                  when \'CURSOR\'  then 10\n                  when \'DATABASE\'  then 10\n                  when \'DATABASES\'  then 10\n                  when \'DAY_HOUR\'  then 10\n                  when \'DAY_MICROSECOND\'  then 10\n                  when \'DAY_MINUTE\'  then 10\n                  when \'DAY_SECOND\'  then 10\n                  when \'DEC\'  then 10\n                  when \'DECIMAL\'  then 10\n                  when \'DECLARE\'  then 10\n                  when \'DEFAULT\'  then 10\n                  when \'DELAYED\'  then 10\n                  when \'DELETE\'  then 10\n                  when \'DESC\'  then 10\n                  when \'DESCRIBE\'  then 10\n                  when \'DETERMINISTIC\'  then 10\n                  when \'DISTINCT\'  then 10\n                  when \'DISTINCTROW\'  then 10\n                  when \'DIV\'  then 10\n                  when \'DOUBLE\'  then 10\n                  when \'DROP\'  then 10\n                  when \'DUAL\'  then 10\n                  when \'EACH\'  then 10\n                  when \'ELSE\'  then 10\n                  when \'ELSEIF\'  then 10\n                  when \'END\'  then 10\n                  when \'ENCLOSED\'  then 10\n                  when \'ESCAPED\'  then 10\n                  when \'EXISTS\'  then 10\n                  when \'EXIT\'  then 10\n                  when \'EXPLAIN\'  then 10\n                  when \'FALSE\'  then 10\n                  when \'FETCH\'  then 10\n                  when \'FLOAT\'  then 10\n                  when \'FLOAT4\'  then 10\n                  when \'FLOAT8\'  then 10\n                  when \'FOR\'  then 10\n                  when \'FORCE\'  then 10\n                  when \'FOREIGN\'  then 10\n                  when \'FROM\'  then 10\n                  when \'FULLTEXT\'  then 10\n                  when \'GRANT\'  then 10\n                  when \'GROUP\'  then 10\n                  when \'HAVING\'  then 10\n                  when \'HIGH_PRIORITY\'  then 10\n                  when \'HOUR_MICROSECOND\'  then 10\n                  when \'HOUR_MINUTE\'  then 10\n                  when \'HOUR_SECOND\'  then 10\n                  when \'IF\'  then 10\n                  when \'IGNORE\'  then 10\n                  when \'IN\'  then 10\n                  when \'INDEX\'  then 10\n                  when \'INFILE\'  then 10\n                  when \'INNER\'  then 10\n                  when \'INOUT\'  then 10\n                  when \'INSENSITIVE\'  then 10\n                  when \'INSERT\'  then 10\n                  when \'INT\'  then 10\n                  when \'INT1\'  then 10\n                  when \'INT2\'  then 10\n                  when \'INT3\'  then 10\n                  when \'INT4\'  then 10\n                  when \'INT8\'  then 10\n                  when \'INTEGER\'  then 10\n                  when \'INTERVAL\'  then 10\n                  when \'INTO\'  then 10\n                  when \'IS\'  then 10\n                  when \'ITERATE\'  then 10\n                  when \'JOIN\'  then 10\n                  when \'KEY\'  then 10\n                  when \'KEYS\'  then 10\n                  when \'KILL\'  then 10\n                  when \'LEADING\'  then 10\n                  when \'LEAVE\'  then 10\n                  when \'LEFT\'  then 10\n                  when \'LIKE\'  then 10\n                  when \'LIMIT\'  then 10\n                  when \'LINEAR\'  then 10\n                  when \'LINES\'  then 10\n                  when \'LOAD\'  then 10\n                  when \'LOCALTIME\'  then 10\n                  when \'LOCALTIMESTAMP\'  then 10\n                  when \'LOCK\'  then 10\n                  when \'LONG\'  then 10\n                  when \'LONGBLOB\'  then 10\n                  when \'LONGTEXT\' then 10\n                  when \'LOOP\'  then 10\n                  when \'LOW_PRIORITY\'  then 10\n                  when \'MASTER_SSL_VERIFY_SERVER_CERT\'  then 10\n                  when \'MATCH\'  then 10\n                  when \'MAXVALUE\'  then 10\n                  when \'MEDIUMBLOB\'  then 10\n                  when \'MEDIUMINT\'  then 10\n                  when \'MEDIUMTEXT\'  then 10\n                  when \'MIDDLEINT\'  then 10\n                  when \'MINUTE_MICROSECOND\'  then 10\n                  when \'MINUTE_SECOND\'  then 10\n                  when \'MOD\'  then 10\n                  when \'MODIFIES\'  then 10\n                  when \'NATURAL\'  then 10\n                  when \'NOT\'  then 10\n                  when \'NO_WRITE_TO_BINLOG\'  then 10\n                  when \'NULL\'  then 10\n                  when \'NUMERIC\'  then 10\n                  when \'ON\'  then 10\n                  when \'OPTIMIZE\'  then 10\n                  when \'OPTION\'  then 10\n                  when \'OPTIONALLY\'  then 10\n                  when \'OR\'  then 10\n                  when \'ORDER\'  then 10\n                  when \'OUT\'  then 10\n                  when \'OUTER\'  then 10\n                  when \'OUTFILE\'  then 10\n                  when \'PRECISION\'  then 10\n                  when \'PRIMARY\'  then 10\n                  when \'PROCEDURE\'  then 10\n                  when \'PURGE\'  then 10\n                  when \'RANGE\'  then 10\n                  when \'READ\'  then 10\n                  when \'READS\'  then 10\n                  when \'READ_WRITE\'  then 10\n                  when \'REAL\'  then 10\n                  when \'REFERENCES\'  then 10\n                  when \'REGEXP\'  then 10\n                  when \'RELEASE\'  then 10\n                  when \'RENAME\'  then 10\n                  when \'REPEAT\'  then 10\n                  when \'REPLACE\'  then 10\n                  when \'REQUIRE\'  then 10\n                  when \'RESIGNAL\'  then 10\n                  when \'RESTRICT\'  then 10\n                  when \'RETURN\'  then 10\n                  when \'REVOKE\'  then 10\n                  when \'RIGHT\'  then 10\n                  when \'RLIKE\'  then 10\n                  when \'SCHEMA\'  then 10\n                  when \'SCHEMAS\'  then 10\n                  when \'SECOND_MICROSECOND\'  then 10\n                  when \'SELECT\'  then 10\n                  when \'SENSITIVE\'  then 10\n                  when \'SEPARATOR\'  then 10\n                  when \'SET\'  then 10\n                  when \'SHOW\'  then 10\n                  when \'SIGNAL\'  then 10\n                  when \'SMALLINT\'  then 10\n                  when \'SPATIAL\'  then 10\n                  when \'SLOW\'  then 10\n                  when \'SPECIFIC\'  then 10\n                  when \'SQL SQLEXCEPTION\'  then 10\n                  when \'SQLSTATE\'  then 10\n                  when \'SQLWARNING\'  then 10\n                  when \'SQL_BIG_RESULT\'  then 10\n                  when \'SQL_CALC_FOUND_ROWS\'  then 10\n                  when \'SQL_SMALL_RESULT\'  then 10\n                  when \'SSL\'  then 10\n                  when \'STARTING\'  then 10\n                  when \'STRAIGHT_JOIN\'  then 10\n                  when \'TABLE\'  then 10\n                  when \'TERMINATED\'  then 10\n                  when \'THEN\'  then 10\n                  when \'TINYBLOB\'  then 10\n                  when \'TINYINT\'  then 10\n                  when \'TINYTEXT\'  then 10\n                  when \'TO\'  then 10\n                  when \'TRAILING\'  then 10\n                  when \'TRIGGER\'  then 10\n                  when \'TRUE\'  then 10\n                  when \'UNDO\'  then 10\n                  when \'UNION\'  then 10\n                  when \'UNIQUE\'  then 10\n                  when \'UNLOCK\'  then 10\n                  when \'UPDATE\'  then 10\n                  when \'USAGE\'  then 10\n                  when \'USE\'  then 10\n                  when \'USING\'  then 10\n                  when \'UTC_DATE\'  then 10\n                  when \'UTC_TIME\'  then 10\n                  when \'UTC_TIMESTAMP\'  then 10\n                  when \'VALUES\'  then 10\n                  when \'VARBINARY\'  then 10\n                  when \'VARCHAR\'  then 10\n                  when \'VARCHARACTER\'  then 10\n                  when \'VARYING\'  then 10\n                  when \'WHEN\'  then 10\n                  when \'WHERE\'  then 10\n                  when \'WHILE\'  then 10\n                  when \'WITH\'  then 10\n                  when \'WRITE\'  then 10\n                  when \'XOR\'  then 10\n                  when \'YEAR_MONTH\'  then 10\n                  when \'ZEROFILL\'  then 10\n                  when \'GENERAL\'  then 10\n                  when \'IGNORE_SERVER_IDS\'  then 10\n                  when \'MASTER_HEARTBEAT_PERIOD\'  then 10\n                  when \'MAXVALUE\'  then 10\n                  when \'RESIGNAL\'  then 10\n                  when \'SIGNAL\'  then 10\n                  else 0\n                end\n            else 0\n        end;\n        insert into _sql_parse_tree_token(start, level, token, state, prec, prev)\n        values (v_from, v_level, v_token, v_state, v_prec, if(v_prec, v_prev_id, null));\n\n        if v_prec then\n\n            set @guard = 0;\n            while_reduce: while v_prev_prec > v_prec and @guard < 5 do\n\n                select    SQL_CALC_FOUND_ROWS\n                          id, token, state, prev\n                into      v_id, v_token, v_state, v_prev_id\n                from      _sql_parse_tree_token\n                where     id    = v_prev_id\n                limit     1\n                ;\n\n                if found_rows() = 0 then\n                    select \'No previous operator found, leaving.\';\n                    leave while_reduce;\n                end if;\n\n                select    prec, prev\n                into      v_prev_prec, v_prev_id\n                from      _sql_parse_tree_token\n                where     id = v_prev_id\n                ;\nselect @guard:=@guard+1, v_id, v_token, v_state, v_prev_id, v_prev_prec, v_prec;\n                case\n                  when v_state in (\n                      \'and\', \'assign\'\n                  ,   \'bitwise and\', \'bitwise or\', \'bitwise not\', \'bitwise xor\'\n                  ,   \'comma\'\n                  ,   \'divide\', \'dot\'\n                  ,   \'equals\'\n                  ,   \'greater than\'\n                  ,   \'greater than or equals\'\n                  ,   \'left shift\', \'less than\', \'less than or equals\'\n                  ,   \'modulo\', \'multiply\'\n                  ,   \'not equals\'\n                  ,   \'null safe equals\'\n                  ,   \'or\'\n                  ,   \'right shift\'\n                  ) then\nselect \'reducing binary operator \' + v_id;\n                      select  id\n                      into    v_left_id\n                      from    _sql_parse_tree_node\n                      where   right_id = v_id - 1\n                      ;\n                      select  id\n                      into    v_right_id\n                      from    _sql_parse_tree_node\n                      where   left_id = v_id + 1\n                      ;\n\n                      insert into _sql_parse_tree_node(id, left_id, right_id)\n                      values (v_id, v_left_id, v_right_id)\n                      ;\n\nselect \'before\', t.* from _sql_parse_tree_token t;\n\n                      update _sql_parse_tree_token\n                      set    prev = case\n                                        when id   = v_id then NULL\n                                        when prev = v_id then v_prev_id\n                                        else null\n                                    end\n                      where  prev = v_id\n                      or     id   = v_id\n                      ;\n\nselect \'after\', t.* from _sql_parse_tree_token t;\n\n                  else do null;\n                end case;\n            end while;\n            set v_prev_id = last_insert_id()\n            ,   v_prev_prec = v_prec\n            ;\n        else\n            insert into _sql_parse_tree_node(id, left_id, right_id)\n            values (last_insert_id(), last_insert_id(), last_insert_id());\n        end if;\n    until\n        v_old_from = v_from\n    end repeat;\n\nend'),('qwz','qwz','PROCEDURE','qwz','SQL','CONTAINS_SQL','NO','INVOKER','\n    p_choice varchar(64)\n','','_main: begin\n    declare v_menu_groups text;\n    declare v_menu_group enum(\n        \'choose columns\'\n    ,   \'choose custom join\'\n    ,   \'choose execute sql\'\n    ,   \'choose explain sql\'\n    ,   \'choose group by columns\'\n    ,   \'choose help\'\n    ,   \'choose show sql\'\n    ,   \'choose schema\'\n    ,   \'choose related tables\'\n    ,   \'choose tables\'\n    ,   \'columns\'\n    ,   \'edit join condition\'\n    ,   \'execute sql\'\n    ,   \'explain sql\'\n    ,   \'help\'\n    ,   \'new query\'\n    ,   \'related tables\'\n    ,   \'schemata\'\n    ,   \'set schema\'\n    ,   \'show sql\'\n    ,   \'start\'\n    ,   \'tables\'\n    );\n    declare v_states set(\n        \'columns\'\n    ,   \'custom join\'\n    ,   \'group by columns\'\n    ,   \'help\'\n    ,   \'edit join condition\'\n    ,   \'execute sql\'\n    ,   \'explain sql\'\n    ,   \'order by columns\'\n    ,   \'related tables\'\n    ,   \'schemata\'\n    ,   \'set column\'\n    ,   \'set group by column\'\n    ,   \'set join condition\'\n    ,   \'set order by column\'\n    ,   \'set related table\'\n    ,   \'set schema\'\n    ,   \'set table\'\n    ,   \'show sql\'\n    ,   \'start\'\n    ,   \'tables\'\n    ,   \'unset related table\'\n    );\n\n    declare v_bell                 char(1)\n        default char(7);\n    declare v_label_alias          varchar(255)\n        default \'The command line Query Wizard for MySQL\';\n\n    declare v_id                   int unsigned;\n    declare v_left_id              int unsigned;\n    declare v_right_id             int unsigned;\n\n    declare v_schema_name          varchar(64);\n    declare v_table_name           varchar(64);\n    declare v_included             enum(\'YES\',\'NO\');\n\n    declare v_join_type            enum(\'CROSS\', \'INNER\',\'LEFT\', \'RIGHT\');\n    declare v_choice               varchar(64);\n    declare v_value                varchar(64);\n    declare v_label                text;\n    declare v_count_states         int unsigned;\n    declare v_count_choices        int unsigned;\n    declare v_count_related_tables int unsigned;\n\n    declare v_done                 bool default FALSE;\n    declare csr_tables cursor for\n        select   id\n        ,        schema_name, table_name\n        ,        join_type, included\n        from     qwz_table\n        where    find_in_set(id,v_value)\n        order by if(included=\'YES\',1,2)\n        ,        if(included=\'YES\',right_id,left_id);\n\nselect @qwz_state;\n    _create_tables: begin\n    \n        \n        declare cond_table_exists condition for 1050;\n        \n        declare continue handler for cond_table_exists begin end;\n\n        \n        \n        \n        \n        \n        \n        \n        create temporary table if not exists qwz_menu(\n            id       int unsigned     not null auto_increment\n        ,   position varchar(10)      not null\n        ,   label    varchar(255)     not null\n        ,   state    varchar(64)      not null\n        ,   value    varchar(64)      not null default \'\'\n        ,   visible  enum(\'YES\',\'NO\') not null default \'YES\'\n        ,   primary key(id)\n        ) engine = memory;\n\n        \n        \n        \n        \n        \n        \n        \n        \n        \n        \n        \n        create temporary table if not exists qwz_table(\n            id                int unsigned          not null auto_increment\n        ,   left_id           int unsigned          not null\n        ,   right_id          int unsigned          not null\n        ,   schema_name       varchar(64)           not null\n        ,   table_name        varchar(64)           not null\n        ,   constraint_schema varchar(64)\n        ,   constraint_name   varchar(64)\n        ,   included          enum(\'YES\',\'NO\')      not null default \'NO\'\n        ,   join_type         enum(\'CROSS\'\n                              ,    \'INNER\'\n                              ,    \'LEFT\'\n                              ,    \'RIGHT\')         default null\n        ,   primary key(id)\n        ,   unique(left_id)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        \n        \n        create temporary table if not exists qwz_table_ancestor(\n            left_id         int unsigned          not null\n        ,   right_id        int unsigned          not null\n        ,   primary key(left_id)\n        ) engine = memory;\n\n        \n        create temporary table if not exists qwz_column(\n            id                   int unsigned auto_increment not null\n        ,   table_id             int unsigned                not null\n        ,   column_name          varchar(64)                 not null\n        ,   ordinal_position     int unsigned                not null\n        ,   position_in_select   int unsigned                         default null\n        ,   position_in_order_by int unsigned                         default null\n        ,   order_by_direction   enum(\'ASC\',\'DESC\')                   default null\n        ,   position_in_group_by int unsigned                         default null\n        ,   included             enum(\'YES\',\'NO\')            not null default \'NO\'\n        ,   primary key(id)\n        ,   key(position_in_select)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        create temporary table if not exists qwz_join_column(\n            id                 int unsigned\n        ,   table_left_id      int unsigned                not null\n        ,   column_name        varchar(64)                 not null\n        ,   primary key(id)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        create temporary table if not exists qwz_menu_column1(\n            position varchar(10)      not null\n        ,   value    varchar(64)      not null default \'\'\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        create temporary table if not exists qwz_menu_column2\n        like qwz_menu_column1;\n\n        create temporary table if not exists qwz_join_condition(\n            id                  int unsigned auto_increment not null\n        ,   column_id1          int unsigned                not null\n        ,   column_id2          int unsigned                not null\n        ,   comparison_operator enum(\n                                    \'=\'\n                                ,   \'>\'\n                                ,   \'<\'\n                                ,   \'>=\'\n                                ,   \'<=\'\n                                ,   \'!=\'\n                                ,   \'<=>\'\n                                )                           not null\n        ,   primary key(id)\n        ,   unique(column_id1,column_id2)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        \n        create temporary table if not exists qwz_sql(\n            id               int unsigned auto_increment not null\n        ,   sql_text         varchar(255)                not null\n        ,   position_in_select int unsigned                       default null\n        ,   left_id            int unsigned                       default null\n        ,   primary key(id)\n        )\n        charset utf8\n        engine = memory\n        ;\n    end;\n\n    _real: begin\n        _init: begin\n            declare cond_no_row condition for 1329;\n            declare cond_multiple_states condition for 1172;\n            declare cond_unknown_state condition for 1265;\n\n            declare continue handler for cond_no_row begin end;\n            declare exit handler for cond_unknown_state\n                begin\n                    select concat(group_concat(state),v_bell)  \'some unknown states\'\n                    from   qwz_menu\n                    where  find_in_set(position, p_choice);\n                end;\n\n            set @@group_concat_max_len := @@max_allowed_packet\n            ,   @qwz_pos := 0\n            ,   @qwz_id  := 0\n            ;\n            if @qwz_schema is null then\n                set @qwz_schema := schema();\n            end if;\n\n            if @qwz_state is null\n            or p_choice is null\n            or p_choice in (\'start\', \'reset\', \'new\', \'help\') then\n                set @qwz_state := if(p_choice = \'help\', \'help\', \'start\');\n                truncate table qwz_menu;\n                leave _init;\n            end if;\n\n            select    count(distinct state)\n            ,         count(distinct position)\n            ,         group_concat(distinct position order by find_in_set(position,p_choice), cast(position as unsigned))\n            ,         group_concat(distinct value order by find_in_set(position,p_choice), cast(position as unsigned))\n            ,         group_concat(distinct state order by find_in_set(position,p_choice), cast(position as unsigned))\n            ,         group_concat(distinct label order by find_in_set(position,p_choice), cast(position as unsigned))\n            into      v_count_states\n            ,         v_count_choices\n            ,         v_choice\n            ,         v_value\n            ,         v_states\n            ,         v_label\n            from      qwz_menu\n            where     find_in_set(position, p_choice)\n            or        find_in_set(label, p_choice)\n            or        label like concat(p_choice, \'%\')\n            ;\n            if v_count_states = 1 then\n                set @qwz_state := v_states;\n                truncate table qwz_menu;\n            else\n                if v_count_states = 0 then\n                    select   concat(\n                                 \'Your choice (\', coalesce(p_choice,\'NULL\'), \') is not applicable\'\n                             ,   \' in the current context.\'\n                             ,   v_bell\n                             )   \"Invalid selection\"\n                    union all\n                    select   \'Valid choices are limited to the numbers that appear left in the menu and the labels that appear right.\';\n                elseif v_count_states > 1 then\n                \n                \n                \n                \n                \n                    select   concat(\n                                 \'Multiple choices (\', coalesce(p_choice,\'NULL\') ,\')\'\n                             ,   \' from multiple menu groups (\', group_concat(state),\').\'\n                             ,   v_bell\n                             )   \"Invalid selection\"\n                    from     qwz_menu\n                    where    find_in_set(position, p_choice)\n                    union all\n                    select \'Multiple choices must be from the same menu group\';\n                end if;\n                leave _real;\n            end if;\n\n            if v_count_choices > 1 and @qwz_state in (\n                \'set schema\',\'set table\',\'custom join\'\n            ) then\n                set v_value := substring_index(v_value, \',\', 1)\n                ,   v_label := substring_index(v_label, \',\', 1)\n                ;\n                select concat(\n                           \'Your choice \"\', coalesce(p_choice,\'NULL\'), \'\" matches multiple items \'\n                       ,   \'(\', v_choice, \')\'\n                       ,   v_bell\n                       ) \"Invalid selection\"\n                union all\n                select  concat(\'This is not allowed in the current state (\', coalesce(@qwz_state,\'NULL\'),\').\')\n                union all\n                select concat(\'Ignoring all but the first choice (\', v_label,\').\');\n            elseif v_choice != p_choice then\n                select concat(\n                           \'Some unrecognized choices (\', coalesce(p_choice,\'NULL\'), \')\'\n                       ,   v_bell\n                       ) \"Invalid selection\"\n                union all\n                select concat(\'Using only recognized choices (\', v_choice,\') ...\');\n            end if;\n\n        end _init;\n\n        \n        if @qwz_state in (\'show sql\',\'execute sql\',\'explain sql\') then\n        \n            if coalesce(@qwz_dirty1,true) then\n                \n                \n                truncate table qwz_sql;\n\n                \n                insert\n                into        qwz_sql (sql_text, position_in_select)\n                select      concat(\n                                rpad(\n                                    if(\n                                        (@qwz_pos := @qwz_pos+1) = 1\n                                    ,   \'SELECT\'\n                                    ,   \',\'\n                                    )\n                                ,   8, \' \'\n                                )\n                            ,   \'t\', t.left_id, \'.\'\n                            ,   c.column_name\n                            )\n                ,           position_in_select\n                from        qwz_column  c\n                inner join  qwz_table   t\n                on          c.table_id = t.id\n                where       c.included = \'YES\'\n                order by    position_in_select\n                ;\n                \n                insert\n                into        qwz_sql (sql_text, left_id)\n                select      concat(\n                                if( t.left_id=1\n                                ,   \'FROM \'\n                                ,   concat(\n                                        t.join_type\n                                    ,   \' JOIN \'\n                                    )\n                                )\n                            ,   t.schema_name, \'.\',  t.table_name\n                            ,   \' AS t\', left_id\n                            ,   if(t.left_id=1,\'\'\n                                ,   concat(\n                                        \' ON (\'\n                                    ,   group_concat(\n                                              \'t\', t.joined_table_left_id, \'.\'\n                                        ,    kcu.column_name\n                                        order by ordinal_position\n                                        )\n                                    ,   \') = (\'\n                                    ,   group_concat(\n                                            \'t\', t.left_id, \'.\'\n                                        ,   kcu.referenced_column_name\n                                        order by ordinal_position\n                                        )\n                                    ,   \')\'\n                                    )\n                                )\n                            )\n                ,           t.left_id\n                from        (\n                            select     t.left_id\n                            ,          t.schema_name\n                            ,          t.table_name\n                            ,          t.constraint_schema\n                            ,          t.constraint_name\n                            ,          t.join_type\n                            ,          t.included\n                            ,          max(a.left_id)       joined_table_left_id\n                            from       qwz_table t\n                            left join  qwz_table_ancestor a\n                            on         t.left_id  > a.left_id\n                            and        t.right_id < a.right_id\n                            where      t.included = \'YES\'\n                            and        (t.left_id = 1 or t.constraint_name is not null)\n                            group by   t.left_id\n                            ) as t\n                left join   information_schema.key_column_usage kcu\n                on          t.constraint_schema = kcu.constraint_schema\n                and         t.constraint_name   = kcu.constraint_name\n                and         kcu.referenced_table_schema is not null\n                group by    t.left_id\n                ;\n                \n                truncate table qwz_join_column\n                ;\n                insert\n                into        qwz_join_column(id,table_left_id,column_name)\n                select      c.id,t.left_id,c.column_name\n                from        qwz_join_condition jc\n                inner join  qwz_column         c\n                on          jc.column_id1 = c.id\n                inner join  qwz_table          t\n                on          c.table_id = t.id\n                ;\n\n                insert\n                into        qwz_sql (sql_text, left_id)\n                select      concat(\n                                t.join_type, \' JOIN \'\n                            ,   t.schema_name, \'.\', t.table_name\n                            ,   \' AS t\', t.left_id\n                            ,   if(jcm.table_left_id is null, \'\', \'\\nON \')\n                            ,   coalesce(group_concat(\n                                    \'t\', jcm.table_left_id, \'.\'\n                                ,   jcm.column_name, \' \'\n                                ,   jc.comparison_operator\n                                , \' t\',t.left_id,\'.\',c.column_name\n                                separator \'\\nAND \'\n                                ),\'\')\n                            )\n                ,           t.left_id\n                from        qwz_table t\n                inner join  qwz_column c\n                on          t.id = c.table_id\n                left join   qwz_join_condition jc\n                on          c.id = jc.column_id2\n                left join   qwz_join_column jcm\n                on          jc.column_id1 = jcm.id\n                where       t.constraint_name is null\n                and         t.left_id > 1\n                group by    t.left_id\n                ;\n                \n                set @qwz_pos := 0;\n                insert\n                into        qwz_sql (sql_text)\n                select      concat(\n                                rpad(\n                                    if(\n                                        (@qwz_pos := @qwz_pos + 1) = 1\n                                    ,   \'ORDER BY\'\n                                    ,   \',\'\n                                    ),\n                                    9\n                                ,   \' \'\n                                )\n                            ,   \'t\', t.left_id, \'.\', c.column_name\n                            ,   \' \', c.order_by_direction)\n                from        qwz_column c\n                inner join  qwz_table t\n                on          c.table_id = t.id\n                where       position_in_order_by is not null\n                order by    position_in_order_by\n                ;\n                set @qwz_pos := 0\n                ,   @qwz_dirty2 := true   \n                ,   @qwz_dirty1 := false  \n                ;\n            end if;\n\n            if  @qwz_state in (\'execute sql\',\'explain sql\',\'show sql\')\n            and coalesce(@qwz_dirty2,true) then\n\n                \n                \n                \n                select  group_concat(\n                            sql_text\n                        order by case\n                                     when position_in_select is not null then 1\n                                     when left_id is not null then 2\n                                     else 1000\n                                 end\n                        ,        position_in_select\n                        ,        left_id\n                        ,        id\n                        separator \'\\n\'\n                        )\n                into    @qwz_sql\n                from    qwz_sql;\n\n                \n                set @qwz_dirty2 := false;\n            end if;\n        end if;\n\n        \n        \n        case @qwz_state\n            when \'columns\' then\n                set v_label_alias := \'Build SELECT list: + columns are added / - columns are removed\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,new query\'\n                ;\n            when \'custom join\' then\n                set v_label_alias := concat(\'Select a table to \',v_value)\n                ,   v_menu_groups := \'tables,choose schema,edit join condition,new query\'\n                ;\n            when \'group by columns\' then\n                set v_label_alias := \'Select GROUP BY Columns\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,choose order by,new query\'\n                ;\n            when \'help\' then\n                set v_label_alias := \'Command line Query Wizard from MySQL - Help\'\n                ,   v_menu_groups := \'help,new query\'\n                ;\n            when \'execute sql\' then\n                set v_menu_groups := \'choose related tables,choose custom join,choose columns,choose explain sql,choose show sql,new query\'\n                ;\n                prepare qwz_sql from @qwz_sql;\n                execute qwz_sql;\n                deallocate prepare qwz_sql;\n            when \'explain sql\' then\n                set v_menu_groups := \'choose related tables,choose custom join,choose columns,choose execute sql,choose show sql,new query\'\n                ,   @qwz_explain_sql := concat(\'EXPLAIN \',@qwz_sql)\n                ;\n                prepare qwz_explain_sql from @qwz_explain_sql;\n                execute qwz_explain_sql;\n                deallocate prepare qwz_explain_sql;\n            when \'order by columns\' then\n                set v_label_alias := \'Select ORDER BY Columns\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,new query\'\n                ;\n            when \'related tables\' then\n                set v_label_alias := \'Add a joined table\'\n                ,   v_menu_groups := \'related tables,choose custom join,edit join condition,choose columns,new query\'\n                ;\n            when \'start\' then\n                set v_label_alias := \'QWZ - a command line Query Wizard for MySQL!!! Type: CALL qwz(\'\'help\'\'); to get help.\'\n                ,   v_menu_groups := \'choose schema,choose tables,choose help\'\n                ;\n                truncate table qwz_column;\n                truncate table qwz_join_column;\n                truncate table qwz_table;\n                truncate table qwz_table_ancestor;\n                truncate table qwz_join_condition;\n                truncate table qwz_menu_column1;\n                truncate table qwz_menu_column2;\n                truncate table qwz_sql;\n            when \'schemata\' then\n                set v_label_alias := \'Set the default schema\'\n                ,   v_menu_groups := \'schemata\'\n                ;\n            when \'set column\' then\n                set @qwz_position_in_select := coalesce((\n                    select  max(position_in_select)\n                    from    qwz_column\n                ), 0);\n                set v_label_alias := \'Build SELECT list: + columns are added / - columns are removed\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,choose show sql,choose explain sql,choose execute sql,new query\'\n                ;\n                update qwz_column\n                set    position_in_select = if(\n                           included = \'YES\', null\n                       ,   find_in_set(id, v_choice) + @qwz_position_in_select\n                       )\n                ,      included = if(included = \'YES\', \'NO\', \'YES\')\n                where  find_in_set(id, v_choice)\n                ;\n                set @qwz_position_in_select := 0\n                ;\n                drop temporary table if exists qwz_column1\n                ;\n                create temporary table qwz_column1 (\n                    id                  int unsigned\n                ,   position_in_select  int unsigned\n                ,   primary key (id)\n                ,   key(position_in_select)\n                );\n\n                insert\n                into      qwz_column1\n                select    id, position_in_select\n                from      qwz_column\n                ;\n                update    qwz_column\n                set       position_in_select = (\n                              select  count(*)\n                              from    qwz_column1\n                              where   qwz_column1.position_in_select <= qwz_column.position_in_select\n                          )\n                where     included = \'YES\'\n                ;\n                set @qwz_dirty1 := true;\n            when \'set order by column\' then\n                set v_menu_groups := \'columns,choose related tables,choose custom join,choose show sql,choose explain sql,choose execute sql,new query\'\n                ;\n                update     qwz_column\n                set        position_in_order_by = find_in_set(id, v_value)\n                ,          order_by_direction   = substring_index(substring_index(v_label,\',\',find_in_set(id,v_value)),\',\',-1)\n                where      find_in_set(id, v_value)\n                ;\n            when \'set join condition\' then\n                select group_concat(column_id1,comparison_operator,column_id2)\n                into   v_label_alias\n                from   qwz_join_condition\n                where  find_in_set(concat(column_id1,comparison_operator,column_id2),p_choice)\n                or     find_in_set(concat(column_id2,comparison_operator,column_id1),p_choice)\n                ;\n\n                insert into qwz_join_condition(column_id1, column_id2, comparison_operator)\n                select      least(cast(mc1.value as unsigned), cast(mc2.value as unsigned))\n                ,           greatest(cast(mc1.value as unsigned), cast(mc2.value as unsigned))\n                ,           op.symbol\n                from        qwz_menu_column1 mc1\n                inner join  qwz_menu_column2 mc2\n                on          mc1.position != mc2.position\n                cross join (select \'=\' as symbol  union all\n                            select \'!=\'  union all\n                            select \'<=>\' union all\n                            select \'>\'   union all\n                            select \'<\'   union all\n                            select \'>=\'  union all\n                            select \'<=\'\n                           ) op\n                where       find_in_set(concat(mc1.value,op.symbol,mc2.value),p_choice)\n                on duplicate key update id = id, comparison_operator = op.symbol\n                ;\n\n                delete\n                from    qwz_join_condition\n                where   find_in_set(concat(column_id1,comparison_operator,column_id2),v_label_alias)\n                ;\n\n                set v_label_alias := \'Build SELECT list: + columns are added / - columns are removed\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,choose show sql,choose explain sql,choose execute sql,new query\'\n                ,   @qwz_dirty1   := true\n                ;\n\n            when \'set related table\' then\n                set v_label_alias := \'Join path: + tables are added / - tables are removed\'\n                ,   v_menu_groups := \'related tables,choose custom join,edit join condition,choose columns,new query\'\n                ;\n            when \'set schema\' then\n                set v_label_alias := \'Choose a table to start a join  path\'\n                ,   @qwz_schema := v_value\n                ;\n                if exists (\n                    select null\n                    from   qwz_table\n                    limit  1\n                ) then\n                    set @qwz_state := \'related tables\'\n                    ,   v_menu_groups := \'related tables,choose custom join,choose schema\'\n                    ;\n                else\n                    set @qwz_state := \'tables\'\n                    ,   v_menu_groups := \'choose schema,tables\'\n                    ;\n                end if;\n            when \'set table\' then\n                set v_label_alias := \'Join path: + tables are added / - tables are removed\';\n\n                select coalesce(max(right_id),0) + 1\n                into   v_left_id\n                from   qwz_table;\n\n                set v_right_id := v_left_id + 1\n                ,   v_schema_name := @qwz_schema\n                ,   v_table_name := v_label\n                ;\n\n                insert into\n                qwz_table (  schema_name,  table_name,  left_id,  right_id, included, join_type)\n                values    (v_schema_name,v_table_name,v_left_id,v_right_id,    \'NO\'\n                ,         if(v_value=\'\',NULL,substring_index(v_value,\' \',1)));\n\n                set v_menu_groups := \'related tables,choose custom join,choose columns,new query\'\n                ,   v_value := last_insert_id()\n                ;\n            when \'show sql\' then\n                set v_menu_groups := \'show sql,choose execute sql,choose explain sql,choose related tables,choose custom join,choose columns,new query\';\n            when \'tables\' then\n                set v_label_alias := \'Choose a table to start a join path.\'\n                ,   v_menu_groups := \'tables,choose schema,new query\'\n                ;\n            else select \'case not found1\', @qwz_state;\n        end case;\n\n        if @qwz_state in (\'set table\',\'set related table\') then\n            begin\n                declare continue handler for not found\n                    set v_done := TRUE;\n                insert into qwz_column(table_id, column_name\n                ,          ordinal_position, included)\n                select     t.id, column_name\n                ,          ordinal_position, \'NO\'\n                from       qwz_table                  t\n                inner join information_schema.columns c\n                on         t.schema_name = c.table_schema\n                and        t.table_name  = c.table_name\n                where      find_in_set(t.id,v_value)\n                and        t.included = \'NO\'\n                order by   c.ordinal_position;\n\n                open csr_tables;\n                _loop_tables: loop\n                    fetch csr_tables\n                    into  v_id\n                    ,     v_schema_name, v_table_name\n                    ,     v_join_type, v_included;\n                    if v_done then\n                        set v_done := FALSE;\n                        close csr_tables;\n                        leave _loop_tables;\n                    end if;\n\n                    select left_id, right_id\n                    into   v_left_id, v_right_id\n                    from   qwz_table\n                    where  id = v_id;\n\n                    if v_included = \'YES\' then\n\n                        delete     t.* , c.*, jc.*\n                        from       qwz_table t\n                        left join  qwz_column c\n                        on         t.id = c.table_id\n                        left join  qwz_join_condition jc\n                        on         c.id = jc.column_id1\n                        or         c.id = jc.column_id2\n                        where      t.left_id   > v_left_id\n                        and        t.right_id  < v_right_id;\n\n                        update     qwz_table\n                        set        included = if( left_id=v_left_id\n                                              ,   \'NO\'\n                                              ,   included)\n                        ,          right_id = right_id - (v_right_id - v_left_id -1)\n                        ,          left_id  = if( left_id > v_left_id\n                                              ,   left_id - (v_right_id - v_left_id -1)\n                                              ,   left_id)\n                        where      right_id >= v_right_id;\n\n                    else\n                        select     count(distinct constraint_name) * 2\n                        into       v_count_related_tables\n                        from       information_schema.key_column_usage kcu\n                        where      kcu.table_schema = v_schema_name\n                        and        kcu.table_name   = v_table_name\n                        and        kcu.referenced_table_schema is not null;\n\n                        update     qwz_table\n                        set        left_id   = if( left_id > v_left_id\n                                               ,   left_id + v_count_related_tables\n                                               ,   left_id)\n                        ,          right_id  = if( right_id >= v_right_id\n                                               ,   right_id + v_count_related_tables\n                                               ,   right_id)\n                        ,          included  = if(id=v_id, \'YES\', included)\n                        where      right_id >= v_right_id\n                        order by   left_id desc;\n\n                        set @qwz_left_id := v_left_id - 1;\n                        set @qwz_right_id := v_left_id;\n\n                        insert\n                        into qwz_table (\n                                   left_id, right_id\n                        ,          schema_name, table_name\n                        ,          constraint_schema, constraint_name\n                        ,          included, join_type\n                        )\n                        select     @qwz_left_id := @qwz_left_id + 2   left_id\n                        ,          @qwz_right_id := @qwz_right_id + 2 right_id\n                        ,          referenced_table_schema            schema_name\n                        ,          referenced_table_name              table_name\n                        ,          constraint_schema                  constraint_scema\n                        ,          constraint_name                    constraint_name\n                        ,          \'NO\'                               included\n                        ,          if( max(cms.is_nullable) = \'NO\'\n                                   ,   coalesce(v_join_type, \'INNER\')\n                                   ,   \'LEFT\'\n                                   ) join_type\n                        from       information_schema.key_column_usage kcu\n                        inner join information_schema.columns          cms\n                        on         kcu.table_schema = v_schema_name\n                        and        kcu.table_name   = v_table_name\n                        and        kcu.referenced_table_schema is not null\n                        and        kcu.table_schema = cms.table_schema\n                        and        kcu.table_name   = cms.table_name\n                        and        kcu.column_name  = cms.column_name\n                        group by   kcu.table_schema\n                        ,          kcu.table_name\n                        ,          kcu.constraint_name\n                        ;\n                    end if;\n\n                end loop _loop_tables;\n\n                truncate table qwz_table_ancestor\n                ;\n                insert into qwz_table_ancestor(left_id, right_id)\n                select left_id, right_id from qwz_table\n                ;\n                set @qwz_dirty1 := true;\n            end;\n            set @qwz_state := \'related tables\';\n        end if;\n        \n        _create_menu: begin\n            declare v_menu_group_separator varchar(255)\n                default repeat(\'-\', greatest(character_length(v_label_alias), 64));\n            declare v_add_menu_separator bool default false;\n            declare v_menu_group_index int unsigned\n                default 1;\n            declare v_num_menu_groups int unsigned\n                default character_length(v_menu_groups) - character_length(replace(v_menu_groups, \',\', \'\'));\n\n            while_menu_groups: while v_menu_group_index <= v_num_menu_groups+1 do\n\n                if v_add_menu_separator then\n                    \n                    insert into qwz_menu (id, position, label, state, value)\n                    values (@qwz_id := @qwz_id + 1, \'---\',v_menu_group_separator, \'\', \'\');\n                else\n                    set v_add_menu_separator := true;\n                end if;\n\n                \n                set v_menu_group  := substring_index(substring_index(v_menu_groups, \',\', v_menu_group_index), \',\', -1)\n                ,   v_menu_group_index := v_menu_group_index + 1\n                ;\n                \n                case v_menu_group\n                    when \'choose columns\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (\n                                @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      \'Choose columns\', \'columns\', \'\'\n                        );\n                    when \'choose custom join\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to CROSS JOIN\', \'custom join\', \'cross join\')\n                        ,      (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to INNER JOIN\', \'custom join\', \'inner join\')\n                        ,      (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to LEFT JOIN\', \'custom join\', \'left join\')\n                        ,      (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to RIGHT JOIN\', \'custom join\', \'right join\');\n                    when \'choose help\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Help\', \'help\', \'\'\n                        );\n                    when \'choose execute sql\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Execute SQL\', \'execute sql\', \'\'\n                        );\n                    when \'choose explain sql\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Explain SQL\', \'explain sql\', \'\'\n                        );\n                    when \'choose related tables\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      \'Add another table\', \'related tables\', \'\'\n                        );\n                    when \'choose schema\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      concat(\'Set the schema (current: \', @qwz_schema, \')\')\n                        ,      \'schemata\', \'\'\n                        );\n                    when \'choose show sql\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Show SQL\', \'show sql\', \'\'\n                        );\n                    when \'choose tables\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        select @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      \'Add a table\', \'tables\', \'\'\n                        from   information_schema.tables\n                        where  table_schema = @qwz_schema\n                        having count(*) > 0\n                        ;\n                    when \'columns\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        select     @qwz_id := @qwz_id + 1\n                        ,          if( value=\'\'\n                                   ,   \'\'\n                                   ,   @qwz_pos := @qwz_pos + 1)\n                        ,          label\n                        ,          state\n                        ,          value\n                        from       (\n                        select     concat(\n                                       repeat(\'  \', count(distinct a.left_id) - 1)\n                                   ,   case\n                                           when type = \'table\' then\n                                               concat(\n                                                   c.schema_name, \'.\', c.table_name, \'.*\'\n                                               ,   if(d.constraint_name is null\n                                                   ,   \'\'\n                                                   , concat(\' (\', d.constraint_name, \')\'))\n                                               )\n                                           when type in(\n                                               \'table-overline\'\n                                           ,   \'table-underline\'\n                                           ) then\n                                               repeat(\n                                                   \'-\'\n                                               ,   character_length(c.schema_name)\n                                               +   character_length(c.table_name)\n                                               +   if( d.constraint_name is null\n                                                   ,   0\n                                                   ,   character_length(d.constraint_name)\n                                                   +   3\n                                                   )\n                                               +   3\n                                               )\n                                           when type = \'column\' then\n                                               concat(\n                                                   if( c.included = \'YES\'\n                                                   ,   concat(lpad(c.position_in_select,3,\' \'),\'.\')\n                                                   ,   \'+   \')\n                                               ,   \' \'\n                                               ,   concat(\n                                                       rpad(c.column_name, 64, \' \')\n                                                   ,   coalesce(order_by_direction, \'   \')\n                                                   )\n                                               )\n                                       end\n                                   )   label\n                        ,          state\n                        ,          coalesce(c.id, \'\')         value\n                        from       qwz_table d\n                        inner join qwz_table_ancestor a\n                        on         d.left_id between a.left_id and a.right_id\n                        inner join (\n                                   select \'table-overline\'    type\n                                   ,      null                id\n                                   ,      null                table_id\n                                   ,      table_schema        schema_name\n                                   ,      table_name\n                                   ,      1000                ordinal_position\n                                   ,      \'\'                  column_name\n                                   ,      null                included\n                                   ,      \'\'                  state\n                                   ,      null                position_in_select\n                                   ,      null                order_by_direction\n                                   from   information_schema.tables\n                                   union all\n                                   select \'table\'\n                                   ,      null\n                                   ,      null\n                                   ,      table_schema\n                                   ,      table_name\n                                   ,      -1\n                                   ,      \'\'\n                                   ,      null\n                                   ,      \'\'\n                                   ,      null\n                                   ,      null\n                                   from   information_schema.tables\n                                   union all\n                                   select \'table-underline\'\n                                   ,      null\n                                   ,      null\n                                   ,      table_schema\n                                   ,      table_name\n                                   ,      0\n                                   ,      \'\'\n                                   ,      null\n                                   ,      \'\'\n                                   ,      null\n                                   ,      null\n                                   from   information_schema.tables\n                                   union all\n                                   select \'column\'\n                                   ,      id\n                                   ,      table_id\n                                   ,      null\n                                   ,      null\n                                   ,      ordinal_position\n                                   ,      column_name\n                                   ,      included\n                                   ,      \'set column\'\n                                   ,      position_in_select\n                                   ,      order_by_direction\n                                   from   qwz_column\n                                   ) as c\n                        on        (c.table_id is null\n                        and        d.schema_name = c.schema_name\n                        and        d.table_name  = c.table_name)\n                        or         d.id          = c.table_id\n                        where      d.included    = \'YES\'\n                        group by   d.left_id\n                        ,          ordinal_position\n                        ) as a\n                        ;\n                        \n                        delete from qwz_menu where id = @qwz_id\n                        ;\n                        \n                        truncate table qwz_menu_column1\n                        ;\n                        insert into qwz_menu_column1(position, value)\n                        select      m.position,m.value\n                        from        qwz_menu m\n                        inner join  qwz_column c\n                        on          m.state = \'set column\'\n                        and         m.value = c.id\n                        inner join  qwz_table t\n                        on          c.table_id = t.id\n                        and         t.included = \'YES\'\n                        ;\n                        \n                        insert\n                        into qwz_menu(id, position, label, state, value, visible)\n                        select     @qwz_id := @qwz_id + 1\n                        ,          concat(mc1.position, d.suffix)\n                        ,          d.label\n                        ,          \'set order by column\'\n                        ,          mc1.value\n                        ,          \'NO\'\n                        from       qwz_menu_column1 mc1\n                        cross join(select \'A\' as suffix, \'ASC\' as label\n                        union all  select \'D\' as suffix, \'DESC\' as label) d\n                        ;\n                        truncate table qwz_menu_column2\n                        ;\n                        insert into qwz_menu_column2\n                        select      cm.position,cm.value\n                        from        qwz_menu_column1 cm\n                        inner join  qwz_column       c\n                        on          cm.value = c.id\n                        inner join  qwz_table t\n                        on          c.table_id = t.id\n                        and         t.constraint_name is null\n                        and         t.join_type != \'CROSS\'\n                        ;\n                        \n                        insert\n                        into qwz_menu (id, position, label, state, value, visible)\n                        select      @qwz_id := @qwz_id + 1\n                        ,           concat(mc1.position,op.symbol,mc2.position)\n                        ,           op.symbol\n                        ,           \'set join condition\'\n                        ,           concat(\n                                      least(mc1.value, mc2.value), \',\', greatest(mc1.value,mc2.value)\n                                    )\n                        ,           \'NO\'\n                        from        qwz_menu_column1 mc1\n                        inner join  qwz_menu_column2 mc2\n                        on          mc1.position != mc2.position\n                        cross join  (select \'=\' as symbol\n                                    union all\n                                    select \'!=\'\n                                    union all\n                                    select \'<=>\'\n                                    union all\n                                    select \'>\'\n                                    union all\n                                    select \'<\'\n                                    union all\n                                    select \'>=\'\n                                    union all\n                                    select \'<=\'\n                                    ) op\n                        ;\n                    when \'edit join condition\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Edit join conditions\', \'edit join condition\', \'\'\n                        );\n                    when \'help\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, \'\', \'QWZ - A command-line query wizard for MySQL\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'-------------------------------------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Welcome to QWZ! QWZ is a query wizard designed to be used from within the MySQL monitor,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'also known as the MySQL command line client (the \"mysql\" executable.)\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'The query wizard is menu driven. Numbered choices appear as a list on screen. To select\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'an option, type:\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'CALL qwz(\'\'<option>\'\');\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'In some cases, multiple options are allowed. Separate multiple options with a comma:\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'CALL qwz(\'\'<option1>, <option2>,...,<optionN>\'\');\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Multiple options are allowed only if they are from the same menu group. A Menu group\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'is formed by a number of item appearing consecutively. Menu groups are separated from\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'one another by a horizontal \"line\" (that is, a stretch of dashes).\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Set the schema\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'-----------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'This option allows you to set the default schema. This schema is used to offer a choice\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'of tables to be added to the query\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Choose a table to start a join  path\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'------------------------------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Type any single number to select the table upon which the query is to be based.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Build join path\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'---------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'The list of query tables appears in the menu. If any of the query tables has\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'FOREIGN KEY constraints, then the tables referenced by the FOREIGN KEY constraint are\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'listed beneath that table. Related tables that have a + (plus sign) can be added to the\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'query, thereby lengthening or extending a join path. Once these tables are added,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'a - (minus sign) appears and by selecting the table again it is taken out of the query\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'(in which case it get a + again, remaining available to be included at a later time).\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'When adding related tables, qwz automatically maintains the proper join condition.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'If the referencing columns are nullable, an outer join is automatically chosen.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'If a new table related to an outer-joined table is added, then that table is outer joined\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'too, regardless of the particular nullability of referencing columns.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Multiple related tables can be added to and removed from the query by specifying\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'a comma-separated list of the relevant menu options.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Custom joins\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Tables that are not directly linked through a FOREIGN KEY constraint can also be added\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'by choosing one of the custom JOIN options (CROSS, INNER, LEFT, RIGHT). In this case,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'you will usually have to set the exact join condition yourself, which is done in the ,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Columns menu.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'In the Columns menu, join conditions are specified by typing: \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'<column-number> <join-operator> <column-number>\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'where <column-number> is the number of the menu option that lists the column and \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'<join-operator> is one of =, !=, >, <, >=, <= or <=>. Multiple join conditions may\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'thus be entered as a comma separated list.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Columns\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'-------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'All columns of all tables included in the query are automatically available in the \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Columns menu. The columns with a + (plus sign) can be added to the query. For the \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'columns that are already included in the query the ordinal position is listed instead.\', \'\', \'\')\n                        ;\n                        set @qwz_state := \'start\';\n                    when \'new query\' then\n                        insert\n                        into    qwz_menu (id, position, label, state, value)\n                        values  (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'New Query\', \'start\', \'\')\n                        ;\n                    when \'related tables\' then\n                        insert\n                        into     qwz_menu (id, position, label, state, value)\n                        select   @qwz_id := @qwz_id + 1\n                        ,           if(\n                                        value=1\n                                    ,   \'\'\n                                    ,   @qwz_pos := @qwz_pos + 1\n                                    )\n                        ,           label\n                        ,           state\n                        ,           value\n                        from        (\n                                    select     concat(\n                                                   repeat(\'  \', count(a.left_id) - 1)\n                                               ,   case\n                                                       when d.left_id  = 1    then \'  \'\n                                                       when d.included = \'YES\' then \'- \'\n                                                       when d.included = \'NO\'  then \'+ \'\n                                                   end\n                                               ,   d.schema_name\n                                               ,   \'.\'\n                                               ,   d.table_name\n                                               ,   if(d.join_type is null, \'\'\n                                                   ,   concat(\n                                                           \' (\'\n                                                       ,   d.join_type\n                                                       ,   if( d.constraint_name is null\n                                                           ,   \'\'\n                                                           ,   concat(\' using FOREIGN KEY \'\n                                                               ,   d.constraint_name)\n                                                           )\n                                                       ,   \')\'\n                                                       )\n                                                   )\n                                               )                   label\n                                    ,          \'set related table\' state\n                                    ,          d.id                value\n                                    from       qwz_table d\n                                    inner join qwz_table_ancestor a\n                                    on         d.left_id between a.left_id and a.right_id\n                                    group by   d.left_id\n                        ) as a;\n                    when \'schemata\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        select    @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,         concat(schema_name, if(schema_name = @qwz_schema, \' (current)\', \'\'))\n                        ,         \'set schema\', schema_name\n                        from      information_schema.schemata s\n                        ;\n                    when \'show sql\' then\n                        select @qwz_sql as \"SQL\";\n                        set v_add_menu_separator:=false;\n                    when \'tables\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        select @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      table_name\n                        ,      \'set table\'\n                        ,      if(@qwz_state=\'custom join\',v_value,\'\')\n                        from   information_schema.tables\n                        where  table_schema = @qwz_schema;\n\n                    else\n                        select \'case not found2\', v_menu_group;\n                        leave _main;\n                end case;\n            end while while_menu_groups;\n        end;\n\n    end _real;\n    \n    \n    set @qwz_menu_stmt := concat(\n                                  \'select position as \"\", label as \"\'\n                             ,    v_label_alias\n                             ,    \'\" from qwz_menu \'\n                             ,    \'where visible = \'\'YES\'\' \'\n                             ,    \'order by id\'\n                             );\n    prepare qwz_menu_stmt from @qwz_menu_stmt;\n    execute qwz_menu_stmt;\n    deallocate prepare qwz_menu_stmt;\nselect @qwz_state;\nend','root@%','2013-02-14 22:21:25','2013-02-14 22:21:25','PIPES_AS_CONCAT,ANSI_QUOTES,IGNORE_SPACE,NO_AUTO_VALUE_ON_ZERO,STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION','Interactive Query Wizard for the MySQL command line','utf8','utf8_general_ci','latin1_swedish_ci','_main: begin\n    declare v_menu_groups text;\n    declare v_menu_group enum(\n        \'choose columns\'\n    ,   \'choose custom join\'\n    ,   \'choose execute sql\'\n    ,   \'choose explain sql\'\n    ,   \'choose group by columns\'\n    ,   \'choose help\'\n    ,   \'choose show sql\'\n    ,   \'choose schema\'\n    ,   \'choose related tables\'\n    ,   \'choose tables\'\n    ,   \'columns\'\n    ,   \'edit join condition\'\n    ,   \'execute sql\'\n    ,   \'explain sql\'\n    ,   \'help\'\n    ,   \'new query\'\n    ,   \'related tables\'\n    ,   \'schemata\'\n    ,   \'set schema\'\n    ,   \'show sql\'\n    ,   \'start\'\n    ,   \'tables\'\n    );\n    declare v_states set(\n        \'columns\'\n    ,   \'custom join\'\n    ,   \'group by columns\'\n    ,   \'help\'\n    ,   \'edit join condition\'\n    ,   \'execute sql\'\n    ,   \'explain sql\'\n    ,   \'order by columns\'\n    ,   \'related tables\'\n    ,   \'schemata\'\n    ,   \'set column\'\n    ,   \'set group by column\'\n    ,   \'set join condition\'\n    ,   \'set order by column\'\n    ,   \'set related table\'\n    ,   \'set schema\'\n    ,   \'set table\'\n    ,   \'show sql\'\n    ,   \'start\'\n    ,   \'tables\'\n    ,   \'unset related table\'\n    );\n\n    declare v_bell                 char(1)\n        default char(7);\n    declare v_label_alias          varchar(255)\n        default \'The command line Query Wizard for MySQL\';\n\n    declare v_id                   int unsigned;\n    declare v_left_id              int unsigned;\n    declare v_right_id             int unsigned;\n\n    declare v_schema_name          varchar(64);\n    declare v_table_name           varchar(64);\n    declare v_included             enum(\'YES\',\'NO\');\n\n    declare v_join_type            enum(\'CROSS\', \'INNER\',\'LEFT\', \'RIGHT\');\n    declare v_choice               varchar(64);\n    declare v_value                varchar(64);\n    declare v_label                text;\n    declare v_count_states         int unsigned;\n    declare v_count_choices        int unsigned;\n    declare v_count_related_tables int unsigned;\n\n    declare v_done                 bool default FALSE;\n    declare csr_tables cursor for\n        select   id\n        ,        schema_name, table_name\n        ,        join_type, included\n        from     qwz_table\n        where    find_in_set(id,v_value)\n        order by if(included=\'YES\',1,2)\n        ,        if(included=\'YES\',right_id,left_id);\n\nselect @qwz_state;\n    _create_tables: begin\n    \n        \n        declare cond_table_exists condition for 1050;\n        \n        declare continue handler for cond_table_exists begin end;\n\n        \n        \n        \n        \n        \n        \n        \n        create temporary table if not exists qwz_menu(\n            id       int unsigned     not null auto_increment\n        ,   position varchar(10)      not null\n        ,   label    varchar(255)     not null\n        ,   state    varchar(64)      not null\n        ,   value    varchar(64)      not null default \'\'\n        ,   visible  enum(\'YES\',\'NO\') not null default \'YES\'\n        ,   primary key(id)\n        ) engine = memory;\n\n        \n        \n        \n        \n        \n        \n        \n        \n        \n        \n        \n        create temporary table if not exists qwz_table(\n            id                int unsigned          not null auto_increment\n        ,   left_id           int unsigned          not null\n        ,   right_id          int unsigned          not null\n        ,   schema_name       varchar(64)           not null\n        ,   table_name        varchar(64)           not null\n        ,   constraint_schema varchar(64)\n        ,   constraint_name   varchar(64)\n        ,   included          enum(\'YES\',\'NO\')      not null default \'NO\'\n        ,   join_type         enum(\'CROSS\'\n                              ,    \'INNER\'\n                              ,    \'LEFT\'\n                              ,    \'RIGHT\')         default null\n        ,   primary key(id)\n        ,   unique(left_id)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        \n        \n        create temporary table if not exists qwz_table_ancestor(\n            left_id         int unsigned          not null\n        ,   right_id        int unsigned          not null\n        ,   primary key(left_id)\n        ) engine = memory;\n\n        \n        create temporary table if not exists qwz_column(\n            id                   int unsigned auto_increment not null\n        ,   table_id             int unsigned                not null\n        ,   column_name          varchar(64)                 not null\n        ,   ordinal_position     int unsigned                not null\n        ,   position_in_select   int unsigned                         default null\n        ,   position_in_order_by int unsigned                         default null\n        ,   order_by_direction   enum(\'ASC\',\'DESC\')                   default null\n        ,   position_in_group_by int unsigned                         default null\n        ,   included             enum(\'YES\',\'NO\')            not null default \'NO\'\n        ,   primary key(id)\n        ,   key(position_in_select)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        create temporary table if not exists qwz_join_column(\n            id                 int unsigned\n        ,   table_left_id      int unsigned                not null\n        ,   column_name        varchar(64)                 not null\n        ,   primary key(id)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        create temporary table if not exists qwz_menu_column1(\n            position varchar(10)      not null\n        ,   value    varchar(64)      not null default \'\'\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        create temporary table if not exists qwz_menu_column2\n        like qwz_menu_column1;\n\n        create temporary table if not exists qwz_join_condition(\n            id                  int unsigned auto_increment not null\n        ,   column_id1          int unsigned                not null\n        ,   column_id2          int unsigned                not null\n        ,   comparison_operator enum(\n                                    \'=\'\n                                ,   \'>\'\n                                ,   \'<\'\n                                ,   \'>=\'\n                                ,   \'<=\'\n                                ,   \'!=\'\n                                ,   \'<=>\'\n                                )                           not null\n        ,   primary key(id)\n        ,   unique(column_id1,column_id2)\n        )\n        charset utf8\n        engine = memory\n        ;\n\n        \n        create temporary table if not exists qwz_sql(\n            id               int unsigned auto_increment not null\n        ,   sql_text         varchar(255)                not null\n        ,   position_in_select int unsigned                       default null\n        ,   left_id            int unsigned                       default null\n        ,   primary key(id)\n        )\n        charset utf8\n        engine = memory\n        ;\n    end;\n\n    _real: begin\n        _init: begin\n            declare cond_no_row condition for 1329;\n            declare cond_multiple_states condition for 1172;\n            declare cond_unknown_state condition for 1265;\n\n            declare continue handler for cond_no_row begin end;\n            declare exit handler for cond_unknown_state\n                begin\n                    select concat(group_concat(state),v_bell)  \'some unknown states\'\n                    from   qwz_menu\n                    where  find_in_set(position, p_choice);\n                end;\n\n            set @@group_concat_max_len := @@max_allowed_packet\n            ,   @qwz_pos := 0\n            ,   @qwz_id  := 0\n            ;\n            if @qwz_schema is null then\n                set @qwz_schema := schema();\n            end if;\n\n            if @qwz_state is null\n            or p_choice is null\n            or p_choice in (\'start\', \'reset\', \'new\', \'help\') then\n                set @qwz_state := if(p_choice = \'help\', \'help\', \'start\');\n                truncate table qwz_menu;\n                leave _init;\n            end if;\n\n            select    count(distinct state)\n            ,         count(distinct position)\n            ,         group_concat(distinct position order by find_in_set(position,p_choice), cast(position as unsigned))\n            ,         group_concat(distinct value order by find_in_set(position,p_choice), cast(position as unsigned))\n            ,         group_concat(distinct state order by find_in_set(position,p_choice), cast(position as unsigned))\n            ,         group_concat(distinct label order by find_in_set(position,p_choice), cast(position as unsigned))\n            into      v_count_states\n            ,         v_count_choices\n            ,         v_choice\n            ,         v_value\n            ,         v_states\n            ,         v_label\n            from      qwz_menu\n            where     find_in_set(position, p_choice)\n            or        find_in_set(label, p_choice)\n            or        label like concat(p_choice, \'%\')\n            ;\n            if v_count_states = 1 then\n                set @qwz_state := v_states;\n                truncate table qwz_menu;\n            else\n                if v_count_states = 0 then\n                    select   concat(\n                                 \'Your choice (\', coalesce(p_choice,\'NULL\'), \') is not applicable\'\n                             ,   \' in the current context.\'\n                             ,   v_bell\n                             )   \"Invalid selection\"\n                    union all\n                    select   \'Valid choices are limited to the numbers that appear left in the menu and the labels that appear right.\';\n                elseif v_count_states > 1 then\n                \n                \n                \n                \n                \n                    select   concat(\n                                 \'Multiple choices (\', coalesce(p_choice,\'NULL\') ,\')\'\n                             ,   \' from multiple menu groups (\', group_concat(state),\').\'\n                             ,   v_bell\n                             )   \"Invalid selection\"\n                    from     qwz_menu\n                    where    find_in_set(position, p_choice)\n                    union all\n                    select \'Multiple choices must be from the same menu group\';\n                end if;\n                leave _real;\n            end if;\n\n            if v_count_choices > 1 and @qwz_state in (\n                \'set schema\',\'set table\',\'custom join\'\n            ) then\n                set v_value := substring_index(v_value, \',\', 1)\n                ,   v_label := substring_index(v_label, \',\', 1)\n                ;\n                select concat(\n                           \'Your choice \"\', coalesce(p_choice,\'NULL\'), \'\" matches multiple items \'\n                       ,   \'(\', v_choice, \')\'\n                       ,   v_bell\n                       ) \"Invalid selection\"\n                union all\n                select  concat(\'This is not allowed in the current state (\', coalesce(@qwz_state,\'NULL\'),\').\')\n                union all\n                select concat(\'Ignoring all but the first choice (\', v_label,\').\');\n            elseif v_choice != p_choice then\n                select concat(\n                           \'Some unrecognized choices (\', coalesce(p_choice,\'NULL\'), \')\'\n                       ,   v_bell\n                       ) \"Invalid selection\"\n                union all\n                select concat(\'Using only recognized choices (\', v_choice,\') ...\');\n            end if;\n\n        end _init;\n\n        \n        if @qwz_state in (\'show sql\',\'execute sql\',\'explain sql\') then\n        \n            if coalesce(@qwz_dirty1,true) then\n                \n                \n                truncate table qwz_sql;\n\n                \n                insert\n                into        qwz_sql (sql_text, position_in_select)\n                select      concat(\n                                rpad(\n                                    if(\n                                        (@qwz_pos := @qwz_pos+1) = 1\n                                    ,   \'SELECT\'\n                                    ,   \',\'\n                                    )\n                                ,   8, \' \'\n                                )\n                            ,   \'t\', t.left_id, \'.\'\n                            ,   c.column_name\n                            )\n                ,           position_in_select\n                from        qwz_column  c\n                inner join  qwz_table   t\n                on          c.table_id = t.id\n                where       c.included = \'YES\'\n                order by    position_in_select\n                ;\n                \n                insert\n                into        qwz_sql (sql_text, left_id)\n                select      concat(\n                                if( t.left_id=1\n                                ,   \'FROM \'\n                                ,   concat(\n                                        t.join_type\n                                    ,   \' JOIN \'\n                                    )\n                                )\n                            ,   t.schema_name, \'.\',  t.table_name\n                            ,   \' AS t\', left_id\n                            ,   if(t.left_id=1,\'\'\n                                ,   concat(\n                                        \' ON (\'\n                                    ,   group_concat(\n                                              \'t\', t.joined_table_left_id, \'.\'\n                                        ,    kcu.column_name\n                                        order by ordinal_position\n                                        )\n                                    ,   \') = (\'\n                                    ,   group_concat(\n                                            \'t\', t.left_id, \'.\'\n                                        ,   kcu.referenced_column_name\n                                        order by ordinal_position\n                                        )\n                                    ,   \')\'\n                                    )\n                                )\n                            )\n                ,           t.left_id\n                from        (\n                            select     t.left_id\n                            ,          t.schema_name\n                            ,          t.table_name\n                            ,          t.constraint_schema\n                            ,          t.constraint_name\n                            ,          t.join_type\n                            ,          t.included\n                            ,          max(a.left_id)       joined_table_left_id\n                            from       qwz_table t\n                            left join  qwz_table_ancestor a\n                            on         t.left_id  > a.left_id\n                            and        t.right_id < a.right_id\n                            where      t.included = \'YES\'\n                            and        (t.left_id = 1 or t.constraint_name is not null)\n                            group by   t.left_id\n                            ) as t\n                left join   information_schema.key_column_usage kcu\n                on          t.constraint_schema = kcu.constraint_schema\n                and         t.constraint_name   = kcu.constraint_name\n                and         kcu.referenced_table_schema is not null\n                group by    t.left_id\n                ;\n                \n                truncate table qwz_join_column\n                ;\n                insert\n                into        qwz_join_column(id,table_left_id,column_name)\n                select      c.id,t.left_id,c.column_name\n                from        qwz_join_condition jc\n                inner join  qwz_column         c\n                on          jc.column_id1 = c.id\n                inner join  qwz_table          t\n                on          c.table_id = t.id\n                ;\n\n                insert\n                into        qwz_sql (sql_text, left_id)\n                select      concat(\n                                t.join_type, \' JOIN \'\n                            ,   t.schema_name, \'.\', t.table_name\n                            ,   \' AS t\', t.left_id\n                            ,   if(jcm.table_left_id is null, \'\', \'\nON \')\n                            ,   coalesce(group_concat(\n                                    \'t\', jcm.table_left_id, \'.\'\n                                ,   jcm.column_name, \' \'\n                                ,   jc.comparison_operator\n                                , \' t\',t.left_id,\'.\',c.column_name\n                                separator \'\nAND \'\n                                ),\'\')\n                            )\n                ,           t.left_id\n                from        qwz_table t\n                inner join  qwz_column c\n                on          t.id = c.table_id\n                left join   qwz_join_condition jc\n                on          c.id = jc.column_id2\n                left join   qwz_join_column jcm\n                on          jc.column_id1 = jcm.id\n                where       t.constraint_name is null\n                and         t.left_id > 1\n                group by    t.left_id\n                ;\n                \n                set @qwz_pos := 0;\n                insert\n                into        qwz_sql (sql_text)\n                select      concat(\n                                rpad(\n                                    if(\n                                        (@qwz_pos := @qwz_pos + 1) = 1\n                                    ,   \'ORDER BY\'\n                                    ,   \',\'\n                                    ),\n                                    9\n                                ,   \' \'\n                                )\n                            ,   \'t\', t.left_id, \'.\', c.column_name\n                            ,   \' \', c.order_by_direction)\n                from        qwz_column c\n                inner join  qwz_table t\n                on          c.table_id = t.id\n                where       position_in_order_by is not null\n                order by    position_in_order_by\n                ;\n                set @qwz_pos := 0\n                ,   @qwz_dirty2 := true   \n                ,   @qwz_dirty1 := false  \n                ;\n            end if;\n\n            if  @qwz_state in (\'execute sql\',\'explain sql\',\'show sql\')\n            and coalesce(@qwz_dirty2,true) then\n\n                \n                \n                \n                select  group_concat(\n                            sql_text\n                        order by case\n                                     when position_in_select is not null then 1\n                                     when left_id is not null then 2\n                                     else 1000\n                                 end\n                        ,        position_in_select\n                        ,        left_id\n                        ,        id\n                        separator \'\n\'\n                        )\n                into    @qwz_sql\n                from    qwz_sql;\n\n                \n                set @qwz_dirty2 := false;\n            end if;\n        end if;\n\n        \n        \n        case @qwz_state\n            when \'columns\' then\n                set v_label_alias := \'Build SELECT list: + columns are added / - columns are removed\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,new query\'\n                ;\n            when \'custom join\' then\n                set v_label_alias := concat(\'Select a table to \',v_value)\n                ,   v_menu_groups := \'tables,choose schema,edit join condition,new query\'\n                ;\n            when \'group by columns\' then\n                set v_label_alias := \'Select GROUP BY Columns\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,choose order by,new query\'\n                ;\n            when \'help\' then\n                set v_label_alias := \'Command line Query Wizard from MySQL - Help\'\n                ,   v_menu_groups := \'help,new query\'\n                ;\n            when \'execute sql\' then\n                set v_menu_groups := \'choose related tables,choose custom join,choose columns,choose explain sql,choose show sql,new query\'\n                ;\n                prepare qwz_sql from @qwz_sql;\n                execute qwz_sql;\n                deallocate prepare qwz_sql;\n            when \'explain sql\' then\n                set v_menu_groups := \'choose related tables,choose custom join,choose columns,choose execute sql,choose show sql,new query\'\n                ,   @qwz_explain_sql := concat(\'EXPLAIN \',@qwz_sql)\n                ;\n                prepare qwz_explain_sql from @qwz_explain_sql;\n                execute qwz_explain_sql;\n                deallocate prepare qwz_explain_sql;\n            when \'order by columns\' then\n                set v_label_alias := \'Select ORDER BY Columns\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,new query\'\n                ;\n            when \'related tables\' then\n                set v_label_alias := \'Add a joined table\'\n                ,   v_menu_groups := \'related tables,choose custom join,edit join condition,choose columns,new query\'\n                ;\n            when \'start\' then\n                set v_label_alias := \'QWZ - a command line Query Wizard for MySQL!!! Type: CALL qwz(\'help\'); to get help.\'\n                ,   v_menu_groups := \'choose schema,choose tables,choose help\'\n                ;\n                truncate table qwz_column;\n                truncate table qwz_join_column;\n                truncate table qwz_table;\n                truncate table qwz_table_ancestor;\n                truncate table qwz_join_condition;\n                truncate table qwz_menu_column1;\n                truncate table qwz_menu_column2;\n                truncate table qwz_sql;\n            when \'schemata\' then\n                set v_label_alias := \'Set the default schema\'\n                ,   v_menu_groups := \'schemata\'\n                ;\n            when \'set column\' then\n                set @qwz_position_in_select := coalesce((\n                    select  max(position_in_select)\n                    from    qwz_column\n                ), 0);\n                set v_label_alias := \'Build SELECT list: + columns are added / - columns are removed\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,choose show sql,choose explain sql,choose execute sql,new query\'\n                ;\n                update qwz_column\n                set    position_in_select = if(\n                           included = \'YES\', null\n                       ,   find_in_set(id, v_choice) + @qwz_position_in_select\n                       )\n                ,      included = if(included = \'YES\', \'NO\', \'YES\')\n                where  find_in_set(id, v_choice)\n                ;\n                set @qwz_position_in_select := 0\n                ;\n                drop temporary table if exists qwz_column1\n                ;\n                create temporary table qwz_column1 (\n                    id                  int unsigned\n                ,   position_in_select  int unsigned\n                ,   primary key (id)\n                ,   key(position_in_select)\n                );\n\n                insert\n                into      qwz_column1\n                select    id, position_in_select\n                from      qwz_column\n                ;\n                update    qwz_column\n                set       position_in_select = (\n                              select  count(*)\n                              from    qwz_column1\n                              where   qwz_column1.position_in_select <= qwz_column.position_in_select\n                          )\n                where     included = \'YES\'\n                ;\n                set @qwz_dirty1 := true;\n            when \'set order by column\' then\n                set v_menu_groups := \'columns,choose related tables,choose custom join,choose show sql,choose explain sql,choose execute sql,new query\'\n                ;\n                update     qwz_column\n                set        position_in_order_by = find_in_set(id, v_value)\n                ,          order_by_direction   = substring_index(substring_index(v_label,\',\',find_in_set(id,v_value)),\',\',-1)\n                where      find_in_set(id, v_value)\n                ;\n            when \'set join condition\' then\n                select group_concat(column_id1,comparison_operator,column_id2)\n                into   v_label_alias\n                from   qwz_join_condition\n                where  find_in_set(concat(column_id1,comparison_operator,column_id2),p_choice)\n                or     find_in_set(concat(column_id2,comparison_operator,column_id1),p_choice)\n                ;\n\n                insert into qwz_join_condition(column_id1, column_id2, comparison_operator)\n                select      least(cast(mc1.value as unsigned), cast(mc2.value as unsigned))\n                ,           greatest(cast(mc1.value as unsigned), cast(mc2.value as unsigned))\n                ,           op.symbol\n                from        qwz_menu_column1 mc1\n                inner join  qwz_menu_column2 mc2\n                on          mc1.position != mc2.position\n                cross join (select \'=\' as symbol  union all\n                            select \'!=\'  union all\n                            select \'<=>\' union all\n                            select \'>\'   union all\n                            select \'<\'   union all\n                            select \'>=\'  union all\n                            select \'<=\'\n                           ) op\n                where       find_in_set(concat(mc1.value,op.symbol,mc2.value),p_choice)\n                on duplicate key update id = id, comparison_operator = op.symbol\n                ;\n\n                delete\n                from    qwz_join_condition\n                where   find_in_set(concat(column_id1,comparison_operator,column_id2),v_label_alias)\n                ;\n\n                set v_label_alias := \'Build SELECT list: + columns are added / - columns are removed\'\n                ,   v_menu_groups := \'columns,choose related tables,choose custom join,choose show sql,choose explain sql,choose execute sql,new query\'\n                ,   @qwz_dirty1   := true\n                ;\n\n            when \'set related table\' then\n                set v_label_alias := \'Join path: + tables are added / - tables are removed\'\n                ,   v_menu_groups := \'related tables,choose custom join,edit join condition,choose columns,new query\'\n                ;\n            when \'set schema\' then\n                set v_label_alias := \'Choose a table to start a join  path\'\n                ,   @qwz_schema := v_value\n                ;\n                if exists (\n                    select null\n                    from   qwz_table\n                    limit  1\n                ) then\n                    set @qwz_state := \'related tables\'\n                    ,   v_menu_groups := \'related tables,choose custom join,choose schema\'\n                    ;\n                else\n                    set @qwz_state := \'tables\'\n                    ,   v_menu_groups := \'choose schema,tables\'\n                    ;\n                end if;\n            when \'set table\' then\n                set v_label_alias := \'Join path: + tables are added / - tables are removed\';\n\n                select coalesce(max(right_id),0) + 1\n                into   v_left_id\n                from   qwz_table;\n\n                set v_right_id := v_left_id + 1\n                ,   v_schema_name := @qwz_schema\n                ,   v_table_name := v_label\n                ;\n\n                insert into\n                qwz_table (  schema_name,  table_name,  left_id,  right_id, included, join_type)\n                values    (v_schema_name,v_table_name,v_left_id,v_right_id,    \'NO\'\n                ,         if(v_value=\'\',NULL,substring_index(v_value,\' \',1)));\n\n                set v_menu_groups := \'related tables,choose custom join,choose columns,new query\'\n                ,   v_value := last_insert_id()\n                ;\n            when \'show sql\' then\n                set v_menu_groups := \'show sql,choose execute sql,choose explain sql,choose related tables,choose custom join,choose columns,new query\';\n            when \'tables\' then\n                set v_label_alias := \'Choose a table to start a join path.\'\n                ,   v_menu_groups := \'tables,choose schema,new query\'\n                ;\n            else select \'case not found1\', @qwz_state;\n        end case;\n\n        if @qwz_state in (\'set table\',\'set related table\') then\n            begin\n                declare continue handler for not found\n                    set v_done := TRUE;\n                insert into qwz_column(table_id, column_name\n                ,          ordinal_position, included)\n                select     t.id, column_name\n                ,          ordinal_position, \'NO\'\n                from       qwz_table                  t\n                inner join information_schema.columns c\n                on         t.schema_name = c.table_schema\n                and        t.table_name  = c.table_name\n                where      find_in_set(t.id,v_value)\n                and        t.included = \'NO\'\n                order by   c.ordinal_position;\n\n                open csr_tables;\n                _loop_tables: loop\n                    fetch csr_tables\n                    into  v_id\n                    ,     v_schema_name, v_table_name\n                    ,     v_join_type, v_included;\n                    if v_done then\n                        set v_done := FALSE;\n                        close csr_tables;\n                        leave _loop_tables;\n                    end if;\n\n                    select left_id, right_id\n                    into   v_left_id, v_right_id\n                    from   qwz_table\n                    where  id = v_id;\n\n                    if v_included = \'YES\' then\n\n                        delete     t.* , c.*, jc.*\n                        from       qwz_table t\n                        left join  qwz_column c\n                        on         t.id = c.table_id\n                        left join  qwz_join_condition jc\n                        on         c.id = jc.column_id1\n                        or         c.id = jc.column_id2\n                        where      t.left_id   > v_left_id\n                        and        t.right_id  < v_right_id;\n\n                        update     qwz_table\n                        set        included = if( left_id=v_left_id\n                                              ,   \'NO\'\n                                              ,   included)\n                        ,          right_id = right_id - (v_right_id - v_left_id -1)\n                        ,          left_id  = if( left_id > v_left_id\n                                              ,   left_id - (v_right_id - v_left_id -1)\n                                              ,   left_id)\n                        where      right_id >= v_right_id;\n\n                    else\n                        select     count(distinct constraint_name) * 2\n                        into       v_count_related_tables\n                        from       information_schema.key_column_usage kcu\n                        where      kcu.table_schema = v_schema_name\n                        and        kcu.table_name   = v_table_name\n                        and        kcu.referenced_table_schema is not null;\n\n                        update     qwz_table\n                        set        left_id   = if( left_id > v_left_id\n                                               ,   left_id + v_count_related_tables\n                                               ,   left_id)\n                        ,          right_id  = if( right_id >= v_right_id\n                                               ,   right_id + v_count_related_tables\n                                               ,   right_id)\n                        ,          included  = if(id=v_id, \'YES\', included)\n                        where      right_id >= v_right_id\n                        order by   left_id desc;\n\n                        set @qwz_left_id := v_left_id - 1;\n                        set @qwz_right_id := v_left_id;\n\n                        insert\n                        into qwz_table (\n                                   left_id, right_id\n                        ,          schema_name, table_name\n                        ,          constraint_schema, constraint_name\n                        ,          included, join_type\n                        )\n                        select     @qwz_left_id := @qwz_left_id + 2   left_id\n                        ,          @qwz_right_id := @qwz_right_id + 2 right_id\n                        ,          referenced_table_schema            schema_name\n                        ,          referenced_table_name              table_name\n                        ,          constraint_schema                  constraint_scema\n                        ,          constraint_name                    constraint_name\n                        ,          \'NO\'                               included\n                        ,          if( max(cms.is_nullable) = \'NO\'\n                                   ,   coalesce(v_join_type, \'INNER\')\n                                   ,   \'LEFT\'\n                                   ) join_type\n                        from       information_schema.key_column_usage kcu\n                        inner join information_schema.columns          cms\n                        on         kcu.table_schema = v_schema_name\n                        and        kcu.table_name   = v_table_name\n                        and        kcu.referenced_table_schema is not null\n                        and        kcu.table_schema = cms.table_schema\n                        and        kcu.table_name   = cms.table_name\n                        and        kcu.column_name  = cms.column_name\n                        group by   kcu.table_schema\n                        ,          kcu.table_name\n                        ,          kcu.constraint_name\n                        ;\n                    end if;\n\n                end loop _loop_tables;\n\n                truncate table qwz_table_ancestor\n                ;\n                insert into qwz_table_ancestor(left_id, right_id)\n                select left_id, right_id from qwz_table\n                ;\n                set @qwz_dirty1 := true;\n            end;\n            set @qwz_state := \'related tables\';\n        end if;\n        \n        _create_menu: begin\n            declare v_menu_group_separator varchar(255)\n                default repeat(\'-\', greatest(character_length(v_label_alias), 64));\n            declare v_add_menu_separator bool default false;\n            declare v_menu_group_index int unsigned\n                default 1;\n            declare v_num_menu_groups int unsigned\n                default character_length(v_menu_groups) - character_length(replace(v_menu_groups, \',\', \'\'));\n\n            while_menu_groups: while v_menu_group_index <= v_num_menu_groups+1 do\n\n                if v_add_menu_separator then\n                    \n                    insert into qwz_menu (id, position, label, state, value)\n                    values (@qwz_id := @qwz_id + 1, \'---\',v_menu_group_separator, \'\', \'\');\n                else\n                    set v_add_menu_separator := true;\n                end if;\n\n                \n                set v_menu_group  := substring_index(substring_index(v_menu_groups, \',\', v_menu_group_index), \',\', -1)\n                ,   v_menu_group_index := v_menu_group_index + 1\n                ;\n                \n                case v_menu_group\n                    when \'choose columns\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (\n                                @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      \'Choose columns\', \'columns\', \'\'\n                        );\n                    when \'choose custom join\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to CROSS JOIN\', \'custom join\', \'cross join\')\n                        ,      (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to INNER JOIN\', \'custom join\', \'inner join\')\n                        ,      (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to LEFT JOIN\', \'custom join\', \'left join\')\n                        ,      (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                               ,\'Add a table to RIGHT JOIN\', \'custom join\', \'right join\');\n                    when \'choose help\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Help\', \'help\', \'\'\n                        );\n                    when \'choose execute sql\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Execute SQL\', \'execute sql\', \'\'\n                        );\n                    when \'choose explain sql\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Explain SQL\', \'explain sql\', \'\'\n                        );\n                    when \'choose related tables\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      \'Add another table\', \'related tables\', \'\'\n                        );\n                    when \'choose schema\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      concat(\'Set the schema (current: \', @qwz_schema, \')\')\n                        ,      \'schemata\', \'\'\n                        );\n                    when \'choose show sql\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Show SQL\', \'show sql\', \'\'\n                        );\n                    when \'choose tables\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        select @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      \'Add a table\', \'tables\', \'\'\n                        from   information_schema.tables\n                        where  table_schema = @qwz_schema\n                        having count(*) > 0\n                        ;\n                    when \'columns\' then\n                        insert\n                        into qwz_menu (id, position, label, state, value)\n                        select     @qwz_id := @qwz_id + 1\n                        ,          if( value=\'\'\n                                   ,   \'\'\n                                   ,   @qwz_pos := @qwz_pos + 1)\n                        ,          label\n                        ,          state\n                        ,          value\n                        from       (\n                        select     concat(\n                                       repeat(\'  \', count(distinct a.left_id) - 1)\n                                   ,   case\n                                           when type = \'table\' then\n                                               concat(\n                                                   c.schema_name, \'.\', c.table_name, \'.*\'\n                                               ,   if(d.constraint_name is null\n                                                   ,   \'\'\n                                                   , concat(\' (\', d.constraint_name, \')\'))\n                                               )\n                                           when type in(\n                                               \'table-overline\'\n                                           ,   \'table-underline\'\n                                           ) then\n                                               repeat(\n                                                   \'-\'\n                                               ,   character_length(c.schema_name)\n                                               +   character_length(c.table_name)\n                                               +   if( d.constraint_name is null\n                                                   ,   0\n                                                   ,   character_length(d.constraint_name)\n                                                   +   3\n                                                   )\n                                               +   3\n                                               )\n                                           when type = \'column\' then\n                                               concat(\n                                                   if( c.included = \'YES\'\n                                                   ,   concat(lpad(c.position_in_select,3,\' \'),\'.\')\n                                                   ,   \'+   \')\n                                               ,   \' \'\n                                               ,   concat(\n                                                       rpad(c.column_name, 64, \' \')\n                                                   ,   coalesce(order_by_direction, \'   \')\n                                                   )\n                                               )\n                                       end\n                                   )   label\n                        ,          state\n                        ,          coalesce(c.id, \'\')         value\n                        from       qwz_table d\n                        inner join qwz_table_ancestor a\n                        on         d.left_id between a.left_id and a.right_id\n                        inner join (\n                                   select \'table-overline\'    type\n                                   ,      null                id\n                                   ,      null                table_id\n                                   ,      table_schema        schema_name\n                                   ,      table_name\n                                   ,      1000                ordinal_position\n                                   ,      \'\'                  column_name\n                                   ,      null                included\n                                   ,      \'\'                  state\n                                   ,      null                position_in_select\n                                   ,      null                order_by_direction\n                                   from   information_schema.tables\n                                   union all\n                                   select \'table\'\n                                   ,      null\n                                   ,      null\n                                   ,      table_schema\n                                   ,      table_name\n                                   ,      -1\n                                   ,      \'\'\n                                   ,      null\n                                   ,      \'\'\n                                   ,      null\n                                   ,      null\n                                   from   information_schema.tables\n                                   union all\n                                   select \'table-underline\'\n                                   ,      null\n                                   ,      null\n                                   ,      table_schema\n                                   ,      table_name\n                                   ,      0\n                                   ,      \'\'\n                                   ,      null\n                                   ,      \'\'\n                                   ,      null\n                                   ,      null\n                                   from   information_schema.tables\n                                   union all\n                                   select \'column\'\n                                   ,      id\n                                   ,      table_id\n                                   ,      null\n                                   ,      null\n                                   ,      ordinal_position\n                                   ,      column_name\n                                   ,      included\n                                   ,      \'set column\'\n                                   ,      position_in_select\n                                   ,      order_by_direction\n                                   from   qwz_column\n                                   ) as c\n                        on        (c.table_id is null\n                        and        d.schema_name = c.schema_name\n                        and        d.table_name  = c.table_name)\n                        or         d.id          = c.table_id\n                        where      d.included    = \'YES\'\n                        group by   d.left_id\n                        ,          ordinal_position\n                        ) as a\n                        ;\n                        \n                        delete from qwz_menu where id = @qwz_id\n                        ;\n                        \n                        truncate table qwz_menu_column1\n                        ;\n                        insert into qwz_menu_column1(position, value)\n                        select      m.position,m.value\n                        from        qwz_menu m\n                        inner join  qwz_column c\n                        on          m.state = \'set column\'\n                        and         m.value = c.id\n                        inner join  qwz_table t\n                        on          c.table_id = t.id\n                        and         t.included = \'YES\'\n                        ;\n                        \n                        insert\n                        into qwz_menu(id, position, label, state, value, visible)\n                        select     @qwz_id := @qwz_id + 1\n                        ,          concat(mc1.position, d.suffix)\n                        ,          d.label\n                        ,          \'set order by column\'\n                        ,          mc1.value\n                        ,          \'NO\'\n                        from       qwz_menu_column1 mc1\n                        cross join(select \'A\' as suffix, \'ASC\' as label\n                        union all  select \'D\' as suffix, \'DESC\' as label) d\n                        ;\n                        truncate table qwz_menu_column2\n                        ;\n                        insert into qwz_menu_column2\n                        select      cm.position,cm.value\n                        from        qwz_menu_column1 cm\n                        inner join  qwz_column       c\n                        on          cm.value = c.id\n                        inner join  qwz_table t\n                        on          c.table_id = t.id\n                        and         t.constraint_name is null\n                        and         t.join_type != \'CROSS\'\n                        ;\n                        \n                        insert\n                        into qwz_menu (id, position, label, state, value, visible)\n                        select      @qwz_id := @qwz_id + 1\n                        ,           concat(mc1.position,op.symbol,mc2.position)\n                        ,           op.symbol\n                        ,           \'set join condition\'\n                        ,           concat(\n                                      least(mc1.value, mc2.value), \',\', greatest(mc1.value,mc2.value)\n                                    )\n                        ,           \'NO\'\n                        from        qwz_menu_column1 mc1\n                        inner join  qwz_menu_column2 mc2\n                        on          mc1.position != mc2.position\n                        cross join  (select \'=\' as symbol\n                                    union all\n                                    select \'!=\'\n                                    union all\n                                    select \'<=>\'\n                                    union all\n                                    select \'>\'\n                                    union all\n                                    select \'<\'\n                                    union all\n                                    select \'>=\'\n                                    union all\n                                    select \'<=\'\n                                    ) op\n                        ;\n                    when \'edit join condition\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'Edit join conditions\', \'edit join condition\', \'\'\n                        );\n                    when \'help\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        values (@qwz_id := @qwz_id + 1, \'\', \'QWZ - A command-line query wizard for MySQL\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'-------------------------------------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Welcome to QWZ! QWZ is a query wizard designed to be used from within the MySQL monitor,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'also known as the MySQL command line client (the \"mysql\" executable.)\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'The query wizard is menu driven. Numbered choices appear as a list on screen. To select\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'an option, type:\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'CALL qwz(\'<option>\');\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'In some cases, multiple options are allowed. Separate multiple options with a comma:\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'CALL qwz(\'<option1>, <option2>,...,<optionN>\');\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Multiple options are allowed only if they are from the same menu group. A Menu group\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'is formed by a number of item appearing consecutively. Menu groups are separated from\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'one another by a horizontal \"line\" (that is, a stretch of dashes).\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Set the schema\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'-----------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'This option allows you to set the default schema. This schema is used to offer a choice\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'of tables to be added to the query\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Choose a table to start a join  path\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'------------------------------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Type any single number to select the table upon which the query is to be based.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Build join path\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'---------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'The list of query tables appears in the menu. If any of the query tables has\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'FOREIGN KEY constraints, then the tables referenced by the FOREIGN KEY constraint are\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'listed beneath that table. Related tables that have a + (plus sign) can be added to the\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'query, thereby lengthening or extending a join path. Once these tables are added,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'a - (minus sign) appears and by selecting the table again it is taken out of the query\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'(in which case it get a + again, remaining available to be included at a later time).\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'When adding related tables, qwz automatically maintains the proper join condition.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'If the referencing columns are nullable, an outer join is automatically chosen.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'If a new table related to an outer-joined table is added, then that table is outer joined\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'too, regardless of the particular nullability of referencing columns.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Multiple related tables can be added to and removed from the query by specifying\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'a comma-separated list of the relevant menu options.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Custom joins\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'------------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Tables that are not directly linked through a FOREIGN KEY constraint can also be added\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'by choosing one of the custom JOIN options (CROSS, INNER, LEFT, RIGHT). In this case,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'you will usually have to set the exact join condition yourself, which is done in the ,\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Columns menu.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'In the Columns menu, join conditions are specified by typing: \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'<column-number> <join-operator> <column-number>\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'where <column-number> is the number of the menu option that lists the column and \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'<join-operator> is one of =, !=, >, <, >=, <= or <=>. Multiple join conditions may\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'thus be entered as a comma separated list.\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Columns\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'-------\', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'All columns of all tables included in the query are automatically available in the \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'Columns menu. The columns with a + (plus sign) can be added to the query. For the \', \'\', \'\')\n                        ,      (@qwz_id := @qwz_id + 1, \'\', \'columns that are already included in the query the ordinal position is listed instead.\', \'\', \'\')\n                        ;\n                        set @qwz_state := \'start\';\n                    when \'new query\' then\n                        insert\n                        into    qwz_menu (id, position, label, state, value)\n                        values  (@qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,       \'New Query\', \'start\', \'\')\n                        ;\n                    when \'related tables\' then\n                        insert\n                        into     qwz_menu (id, position, label, state, value)\n                        select   @qwz_id := @qwz_id + 1\n                        ,           if(\n                                        value=1\n                                    ,   \'\'\n                                    ,   @qwz_pos := @qwz_pos + 1\n                                    )\n                        ,           label\n                        ,           state\n                        ,           value\n                        from        (\n                                    select     concat(\n                                                   repeat(\'  \', count(a.left_id) - 1)\n                                               ,   case\n                                                       when d.left_id  = 1    then \'  \'\n                                                       when d.included = \'YES\' then \'- \'\n                                                       when d.included = \'NO\'  then \'+ \'\n                                                   end\n                                               ,   d.schema_name\n                                               ,   \'.\'\n                                               ,   d.table_name\n                                               ,   if(d.join_type is null, \'\'\n                                                   ,   concat(\n                                                           \' (\'\n                                                       ,   d.join_type\n                                                       ,   if( d.constraint_name is null\n                                                           ,   \'\'\n                                                           ,   concat(\' using FOREIGN KEY \'\n                                                               ,   d.constraint_name)\n                                                           )\n                                                       ,   \')\'\n                                                       )\n                                                   )\n                                               )                   label\n                                    ,          \'set related table\' state\n                                    ,          d.id                value\n                                    from       qwz_table d\n                                    inner join qwz_table_ancestor a\n                                    on         d.left_id between a.left_id and a.right_id\n                                    group by   d.left_id\n                        ) as a;\n                    when \'schemata\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        select    @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,         concat(schema_name, if(schema_name = @qwz_schema, \' (current)\', \'\'))\n                        ,         \'set schema\', schema_name\n                        from      information_schema.schemata s\n                        ;\n                    when \'show sql\' then\n                        select @qwz_sql as \"SQL\";\n                        set v_add_menu_separator:=false;\n                    when \'tables\' then\n                        insert into qwz_menu (id, position, label, state, value)\n                        select @qwz_id := @qwz_id + 1, @qwz_pos := @qwz_pos + 1\n                        ,      table_name\n                        ,      \'set table\'\n                        ,      if(@qwz_state=\'custom join\',v_value,\'\')\n                        from   information_schema.tables\n                        where  table_schema = @qwz_schema;\n\n                    else\n                        select \'case not found2\', v_menu_group;\n                        leave _main;\n                end case;\n            end while while_menu_groups;\n        end;\n\n    end _real;\n    \n    \n    set @qwz_menu_stmt := concat(\n                                  \'select position as \"\", label as \"\'\n                             ,    v_label_alias\n                             ,    \'\" from qwz_menu \'\n                             ,    \'where visible = \'YES\' \'\n                             ,    \'order by id\'\n                             );\n    prepare qwz_menu_stmt from @qwz_menu_stmt;\n    execute qwz_menu_stmt;\n    deallocate prepare qwz_menu_stmt;\nselect @qwz_state;\nend'),('sp500','f','FUNCTION','f','SQL','CONTAINS_SQL','NO','DEFINER','','double','return 1','root@%','2013-02-14 22:22:01','2013-02-14 22:22:01','','','utf8','utf8_general_ci','latin1_swedish_ci','return 1'),('common_schema','_get_sql_dependencies_internal','PROCEDURE','_get_sql_dependencies_internal','SQL','CONTAINS_SQL','YES','DEFINER','\n    IN p_sql               TEXT charset utf8\n,   IN p_default_schema    VARCHAR(64) charset utf8\n,   IN return_result_set   TINYINT UNSIGNED\n,   OUT result_success      TINYINT UNSIGNED\n','','my_main: begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text charset utf8;\n    declare v_level int unsigned default 0;\n    declare v_state varchar(32) charset utf8;\n    declare v_scan_state varchar(32) charset utf8 default \'start\';\n    declare v_schema_name, v_object_name, v_object_type, v_definer, v_action varchar(64) charset utf8 default null;\n    declare v_error_message text charset utf8 default \'\';\n\n    set @old_autocommit = @@autocommit\n    ,   autocommit = off\n    ;\n  my_error: begin\n    \n    declare exit handler for 1339\n        set v_error_message = concat(\'case not defined for state: \"\', v_scan_state, \'\" (\"\', v_state, \'\")\');\n    declare exit handler for 1265\n        set v_error_message = concat(\'not valid for enum \', v_token);\n\n    set result_success := 1;\n        \n    drop temporary table if exists _sql_dependencies;\n    create temporary table if not exists _sql_dependencies(\n        id              int unsigned auto_increment primary key\n    ,   start           int unsigned\n    ,   action          enum(\'alter\', \'call\', \'create\', \'delete\', \'drop\', \'insert\', \'replace\', \'select\', \'truncate\', \'update\')\n    ,   object_type     enum(\'event\', \'function\', \'index\', \'procedure\', \'table\', \'trigger\', \'view\')\n    ,   schema_name     varchar(64)\n    ,   object_name     varchar(64)\n    );\n    \n    my_loop: repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n        set v_token = v_token collate utf8_general_ci;\n        if v_state in (\'whitespace\', \'single line comment\', \'multi line comment\') then\n            iterate my_loop;\n        elseif v_state = \'statement delimiter\' then\n            if v_scan_state = \'expect dot\' then\n                insert \n                into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                values (v_from, v_schema_name, v_object_name, v_object_type, v_action);\n            end if;\n            set v_scan_state = \'start\'\n            ,   v_action = null;\n        end if;\n        if @debug_get_sql_dependencies then\n            select v_scan_state, v_from, v_token, v_state;\n        end if;\n\n        case v_scan_state\n            when \'start\' then\n                set v_schema_name = p_default_schema, v_object_name = null, v_object_type = null, v_definer = null;\n                if v_state = \'alpha\' then\n                    if v_token in (\'alter\', \'call\', \'create\', \'delete\', \'drop\', \'insert\', \'replace\', \'select\', \'truncate\', \'update\') then\n                        set v_action = lower(v_token) collate utf8_general_ci\n                        ,   v_scan_state = v_action\n                        ;\n                    elseif v_token in (\'join\', \'from\') then\n                        set v_scan_state = \'expect table\';\n                    end if;\n                end if;\n            when \'select\' then\n                set v_scan_state = \'expect from\';\n                set v_action = \'select\';\n            when \'insert\' then\n                set v_scan_state = \'expect table\';\n            when \'update\' then\n                set v_scan_state = \'expect table\';\n            when \'delete\' then\n                set v_scan_state = \'expect table\';\n            when \'expect from\' then\n                if v_state = \'alpha\' and v_token = \'from\' then\n                    set v_scan_state = \'expect table\';\n                end if;\n            when \'call\' then\n                set v_object_type = \'procedure\'\n                ,   v_object_name = v_token\n                ,   v_scan_state = \'expect dot\'\n                ;\n            when \'alter\' then\n                if v_state = \'alpha\' then\n                    if v_token in (\'database\', \'event\', \'function\', \'procedure\', \'schema\', \'server\', \'table\', \'tablespace\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\';\n                    elseif v_token = \'logfile\' then\n                        set v_scan_state = \'expect logfile group\';\n                    elseif v_token in (\'online\', \'offline\', \'ignore\') then\n                        set v_scan_state = \'expect object type\';\n                    elseif v_token = \'definer\' then\n                        set v_scan_state = \'definer\';\n                    else \n                        set v_error_message = concat(\'\"\', v_token, \'\" is not a valid object type for alter \', v_scan_state);\n                        leave my_error;\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'create\' then\n                if v_state = \'alpha\' then\n					if v_token in (\'database\', \'event\', \'function\', \'procedure\', \'schema\', \'server\', \'table\', \'tablespace\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'drop\' then\n                if v_state = \'alpha\' then\n                    if v_token in (\'database\', \'event\', \'function\', \'procedure\', \'schema\', \'server\', \'table\', \'tablespace\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect logfile group\' then\n                if v_state = \'alpha\' and v_token = \'group\' then\n                    set v_object_type = \'logfile group\'\n                    ,   v_scan_state = \'expect identifier2\';\n                else \n                    set v_error_message = concat(\'expected group keyword\');\n                    leave my_error;\n                end if;\n            when \'expect definer user\' then\n                if v_state in (\'alpha\') and v_token = \'CURRENT_USER\' then \n                    set v_scan_state = \'expect object type\';\n                elseif v_state = \'string\'  then\n                    set v_scan_state = \'expect definer host\';\n                else\n                    set v_error_message = concat(\'expected alpha or alphanum\', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect definer host\' then\n                if v_state = \'user-defined variable\' then\n                    set v_scan_state = \'expect object type\';\n                else\n                    set v_error_message = concat(\'expected hostname, not \', v_state);\n                    leave my_error;\n                end if;\n            when \'definer\' then\n                if v_state = \'equals\' then\n                    set v_scan_state = \'expect definer user\';\n                else\n                    set v_error_message = concat(\'expected equals in state\', v_scan_state);\n                    leave my_error;\n                end if;            \n            when \'expect create or replace\' then\n                if v_state = \'alpha\' and v_token = \'replace\' then\n                    set v_scan_state = \'expect object type\';\n                else\n                    set v_error_message = concat(\'expected replace in state\', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect object type\' then\n                if  v_state = \'alpha\' then\n                    if v_token in (\'event\', \'function\', \'index\', \'procedure\', \'schema\', \'table\', \'trigger\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\'\n                        ;                    \n                    elseif v_token = \'definer\' then\n                        set v_scan_state = \'definer\';\n                    elseif v_token = \'or\' then\n                        set v_scan_state = \'expect create or replace\';\n                    elseif v_token = \'temporary\' then\n                        set v_scan_state = \'expect object type\';\n                    else\n                        set v_error_message = concat(\'invalid object type \', v_token);\n                        leave my_error;\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha in state \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect identifier1\' then\n                if v_state = \'quoted identifier\' then\n                    set v_object_name = substr(v_token, 2, character_length(v_token) - 2);                    \n                elseif v_state in (\'alpha\', \'alphanum\') then\n                    if v_token not in (\'if\', \'not\', \'exists\') then\n                        set v_object_name = v_token;\n                        set v_scan_state = \'expect dot\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected identifier \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect identifier2\' then\n                if v_state in (\'quoted identifier\', \'alpha\', \'alphanum\') then\n                    set v_schema_name = v_object_name;\n                    if v_state = \'quoted identifier\' then\n                        set v_object_name = substr(v_token, 2, character_length(v_token) - 2)\n                        ;\n                    elseif v_state in (\'alpha\', \'alphanum\') then\n                        set v_object_name = v_token;\n                    end if;\n                    \n                    insert \n                    into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                    values (v_from, v_schema_name, v_object_name, v_object_type, v_action);\n\n                    if v_object_type = \'table\' or v_object_type = \'view\' then \n                        set v_scan_state = \'expect join\';\n                    else \n                        set v_scan_state = \'start\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected identifier \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect dot\' then\n                if v_state = \'dot\' then\n                    set v_scan_state = \'expect identifier2\';\n                else\n                    insert \n                    into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                    values (v_from,v_schema_name, v_object_name, v_object_type, v_action);\n                    \n                    if v_object_type = \'table\' or v_object_type = \'view\' then \n                        if  (v_state = \'alpha\' and v_token in (\'into\', \'where\', \'group\', \'having\', \'order\', \'limit\'))\n                        or  v_action != \'select\'\n                        then\n                            set v_scan_state = \'start\';\n                        elseif v_state = \'comma\' then\n                            set v_scan_state = \'expect table\';\n                        else\n                            set v_scan_state = \'expect join\';\n                        end if;\n                    else \n                        set v_scan_state = \'start\';\n                    end if;\n                end if;\n            when \'expect join\' then\n                if v_state = \'alpha\' then\n                    if v_token = \'join\' then\n                        set v_scan_state = \'expect table\';\n                    elseif v_token = \'on\' then\n                        set v_scan_state = \'expect join\';\n                    elseif v_token = \'select\' then\n                        set v_scan_state = \'select\';\n                    elseif v_token in (\'into\', \'where\', \'group\', \'having\', \'order\', \'limit\') then\n                        set v_scan_state = \'start\';\n                    end if;\n                elseif v_state = \'comma\' then \n                    set v_scan_state = \'expect table\';\n                end if;\n            when \'expect table\' then\n                set v_object_type = \'table\';\n                case \n                    when v_state = \'quoted identifier\' then\n                        set v_object_name = substr(v_token, 2, character_length(v_token) - 2)\n                        ,   v_scan_state = \'expect dot\'\n                        ;\n                    when v_state = \'alpha\' and v_token in (\'low_priority\', \'delayed\', \'high_priority\', \'ignore\', \'into\') \n                    or   v_token = \'(\' \n                    then\n                        do null;\n                    when v_state = \'alpha\' and v_token = \'select\' then \n                        set v_scan_state = \'select\';\n                    when v_state in (\'alpha\', \'alphanum\') then\n                        set v_object_name = v_token\n                        ,   v_scan_state = \'expect dot\'\n                        ;\n                    else\n                        set v_error_message = concat(\'unexpected state \', v_scan_state, \' (\', v_state,\')\');\n                        do null;\n                end case;\n            when \'expect identifier\' then\n                if v_state in (\'quoted identifier\', \'alpha\', \'alphanum\') then\n                    set v_schema_name = v_object_name;\n                    if v_state = \'quoted identifier\' then\n                        set v_object_name = substr(v_token, 2, character_length(v_token) - 2);\n                    else\n                        set v_object_name = v_token;\n                    end if;\n                    insert \n                    into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                    values (v_from, v_schema_name, v_object_name, v_object_type, v_action) \n                    ;\n                end if;\n                set v_scan_state = \'start\';\n            else \n                set v_error_message = concat(\'unexpected state \', v_scan_state);\n                leave my_error;\n        end case;\n    until \n        v_old_from = v_from\n    end repeat;\n\n    commit;\n    set autocommit = @old_autocommit;\n    \n    if return_result_set then\n      select distinct schema_name, object_name, object_type, action\n      from _sql_dependencies\n      order by schema_name, object_name, object_type, action\n      ;\n    end if;\n    leave my_main;\n  end;\n  set result_success := 0;\n  if return_result_set then\n    select concat(\'Error: \', v_error_message) error;\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','my_main: begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text charset utf8;\n    declare v_level int unsigned default 0;\n    declare v_state varchar(32) charset utf8;\n    declare v_scan_state varchar(32) charset utf8 default \'start\';\n    declare v_schema_name, v_object_name, v_object_type, v_definer, v_action varchar(64) charset utf8 default null;\n    declare v_error_message text charset utf8 default \'\';\n\n    set @old_autocommit = @@autocommit\n    ,   autocommit = off\n    ;\n  my_error: begin\n    \n    declare exit handler for 1339\n        set v_error_message = concat(\'case not defined for state: \"\', v_scan_state, \'\" (\"\', v_state, \'\")\');\n    declare exit handler for 1265\n        set v_error_message = concat(\'not valid for enum \', v_token);\n\n    set result_success := 1;\n        \n    drop temporary table if exists _sql_dependencies;\n    create temporary table if not exists _sql_dependencies(\n        id              int unsigned auto_increment primary key\n    ,   start           int unsigned\n    ,   action          enum(\'alter\', \'call\', \'create\', \'delete\', \'drop\', \'insert\', \'replace\', \'select\', \'truncate\', \'update\')\n    ,   object_type     enum(\'event\', \'function\', \'index\', \'procedure\', \'table\', \'trigger\', \'view\')\n    ,   schema_name     varchar(64)\n    ,   object_name     varchar(64)\n    );\n    \n    my_loop: repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n        set v_token = v_token collate utf8_general_ci;\n        if v_state in (\'whitespace\', \'single line comment\', \'multi line comment\') then\n            iterate my_loop;\n        elseif v_state = \'statement delimiter\' then\n            if v_scan_state = \'expect dot\' then\n                insert \n                into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                values (v_from, v_schema_name, v_object_name, v_object_type, v_action);\n            end if;\n            set v_scan_state = \'start\'\n            ,   v_action = null;\n        end if;\n        if @debug_get_sql_dependencies then\n            select v_scan_state, v_from, v_token, v_state;\n        end if;\n\n        case v_scan_state\n            when \'start\' then\n                set v_schema_name = p_default_schema, v_object_name = null, v_object_type = null, v_definer = null;\n                if v_state = \'alpha\' then\n                    if v_token in (\'alter\', \'call\', \'create\', \'delete\', \'drop\', \'insert\', \'replace\', \'select\', \'truncate\', \'update\') then\n                        set v_action = lower(v_token) collate utf8_general_ci\n                        ,   v_scan_state = v_action\n                        ;\n                    elseif v_token in (\'join\', \'from\') then\n                        set v_scan_state = \'expect table\';\n                    end if;\n                end if;\n            when \'select\' then\n                set v_scan_state = \'expect from\';\n                set v_action = \'select\';\n            when \'insert\' then\n                set v_scan_state = \'expect table\';\n            when \'update\' then\n                set v_scan_state = \'expect table\';\n            when \'delete\' then\n                set v_scan_state = \'expect table\';\n            when \'expect from\' then\n                if v_state = \'alpha\' and v_token = \'from\' then\n                    set v_scan_state = \'expect table\';\n                end if;\n            when \'call\' then\n                set v_object_type = \'procedure\'\n                ,   v_object_name = v_token\n                ,   v_scan_state = \'expect dot\'\n                ;\n            when \'alter\' then\n                if v_state = \'alpha\' then\n                    if v_token in (\'database\', \'event\', \'function\', \'procedure\', \'schema\', \'server\', \'table\', \'tablespace\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\';\n                    elseif v_token = \'logfile\' then\n                        set v_scan_state = \'expect logfile group\';\n                    elseif v_token in (\'online\', \'offline\', \'ignore\') then\n                        set v_scan_state = \'expect object type\';\n                    elseif v_token = \'definer\' then\n                        set v_scan_state = \'definer\';\n                    else \n                        set v_error_message = concat(\'\"\', v_token, \'\" is not a valid object type for alter \', v_scan_state);\n                        leave my_error;\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'create\' then\n                if v_state = \'alpha\' then\n					if v_token in (\'database\', \'event\', \'function\', \'procedure\', \'schema\', \'server\', \'table\', \'tablespace\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'drop\' then\n                if v_state = \'alpha\' then\n                    if v_token in (\'database\', \'event\', \'function\', \'procedure\', \'schema\', \'server\', \'table\', \'tablespace\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect logfile group\' then\n                if v_state = \'alpha\' and v_token = \'group\' then\n                    set v_object_type = \'logfile group\'\n                    ,   v_scan_state = \'expect identifier2\';\n                else \n                    set v_error_message = concat(\'expected group keyword\');\n                    leave my_error;\n                end if;\n            when \'expect definer user\' then\n                if v_state in (\'alpha\') and v_token = \'CURRENT_USER\' then \n                    set v_scan_state = \'expect object type\';\n                elseif v_state = \'string\'  then\n                    set v_scan_state = \'expect definer host\';\n                else\n                    set v_error_message = concat(\'expected alpha or alphanum\', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect definer host\' then\n                if v_state = \'user-defined variable\' then\n                    set v_scan_state = \'expect object type\';\n                else\n                    set v_error_message = concat(\'expected hostname, not \', v_state);\n                    leave my_error;\n                end if;\n            when \'definer\' then\n                if v_state = \'equals\' then\n                    set v_scan_state = \'expect definer user\';\n                else\n                    set v_error_message = concat(\'expected equals in state\', v_scan_state);\n                    leave my_error;\n                end if;            \n            when \'expect create or replace\' then\n                if v_state = \'alpha\' and v_token = \'replace\' then\n                    set v_scan_state = \'expect object type\';\n                else\n                    set v_error_message = concat(\'expected replace in state\', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect object type\' then\n                if  v_state = \'alpha\' then\n                    if v_token in (\'event\', \'function\', \'index\', \'procedure\', \'schema\', \'table\', \'trigger\', \'view\') then\n                        set v_object_type = v_token\n                        ,   v_scan_state = \'expect identifier1\'\n                        ;                    \n                    elseif v_token = \'definer\' then\n                        set v_scan_state = \'definer\';\n                    elseif v_token = \'or\' then\n                        set v_scan_state = \'expect create or replace\';\n                    elseif v_token = \'temporary\' then\n                        set v_scan_state = \'expect object type\';\n                    else\n                        set v_error_message = concat(\'invalid object type \', v_token);\n                        leave my_error;\n                    end if;\n                else\n                    set v_error_message = concat(\'expected alpha in state \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect identifier1\' then\n                if v_state = \'quoted identifier\' then\n                    set v_object_name = substr(v_token, 2, character_length(v_token) - 2);                    \n                elseif v_state in (\'alpha\', \'alphanum\') then\n                    if v_token not in (\'if\', \'not\', \'exists\') then\n                        set v_object_name = v_token;\n                        set v_scan_state = \'expect dot\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected identifier \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect identifier2\' then\n                if v_state in (\'quoted identifier\', \'alpha\', \'alphanum\') then\n                    set v_schema_name = v_object_name;\n                    if v_state = \'quoted identifier\' then\n                        set v_object_name = substr(v_token, 2, character_length(v_token) - 2)\n                        ;\n                    elseif v_state in (\'alpha\', \'alphanum\') then\n                        set v_object_name = v_token;\n                    end if;\n                    \n                    insert \n                    into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                    values (v_from, v_schema_name, v_object_name, v_object_type, v_action);\n\n                    if v_object_type = \'table\' or v_object_type = \'view\' then \n                        set v_scan_state = \'expect join\';\n                    else \n                        set v_scan_state = \'start\';\n                    end if;\n                else\n                    set v_error_message = concat(\'expected identifier \', v_scan_state);\n                    leave my_error;\n                end if;\n            when \'expect dot\' then\n                if v_state = \'dot\' then\n                    set v_scan_state = \'expect identifier2\';\n                else\n                    insert \n                    into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                    values (v_from,v_schema_name, v_object_name, v_object_type, v_action);\n                    \n                    if v_object_type = \'table\' or v_object_type = \'view\' then \n                        if  (v_state = \'alpha\' and v_token in (\'into\', \'where\', \'group\', \'having\', \'order\', \'limit\'))\n                        or  v_action != \'select\'\n                        then\n                            set v_scan_state = \'start\';\n                        elseif v_state = \'comma\' then\n                            set v_scan_state = \'expect table\';\n                        else\n                            set v_scan_state = \'expect join\';\n                        end if;\n                    else \n                        set v_scan_state = \'start\';\n                    end if;\n                end if;\n            when \'expect join\' then\n                if v_state = \'alpha\' then\n                    if v_token = \'join\' then\n                        set v_scan_state = \'expect table\';\n                    elseif v_token = \'on\' then\n                        set v_scan_state = \'expect join\';\n                    elseif v_token = \'select\' then\n                        set v_scan_state = \'select\';\n                    elseif v_token in (\'into\', \'where\', \'group\', \'having\', \'order\', \'limit\') then\n                        set v_scan_state = \'start\';\n                    end if;\n                elseif v_state = \'comma\' then \n                    set v_scan_state = \'expect table\';\n                end if;\n            when \'expect table\' then\n                set v_object_type = \'table\';\n                case \n                    when v_state = \'quoted identifier\' then\n                        set v_object_name = substr(v_token, 2, character_length(v_token) - 2)\n                        ,   v_scan_state = \'expect dot\'\n                        ;\n                    when v_state = \'alpha\' and v_token in (\'low_priority\', \'delayed\', \'high_priority\', \'ignore\', \'into\') \n                    or   v_token = \'(\' \n                    then\n                        do null;\n                    when v_state = \'alpha\' and v_token = \'select\' then \n                        set v_scan_state = \'select\';\n                    when v_state in (\'alpha\', \'alphanum\') then\n                        set v_object_name = v_token\n                        ,   v_scan_state = \'expect dot\'\n                        ;\n                    else\n                        set v_error_message = concat(\'unexpected state \', v_scan_state, \' (\', v_state,\')\');\n                        do null;\n                end case;\n            when \'expect identifier\' then\n                if v_state in (\'quoted identifier\', \'alpha\', \'alphanum\') then\n                    set v_schema_name = v_object_name;\n                    if v_state = \'quoted identifier\' then\n                        set v_object_name = substr(v_token, 2, character_length(v_token) - 2);\n                    else\n                        set v_object_name = v_token;\n                    end if;\n                    insert \n                    into _sql_dependencies (start, schema_name, object_name, object_type, action) \n                    values (v_from, v_schema_name, v_object_name, v_object_type, v_action) \n                    ;\n                end if;\n                set v_scan_state = \'start\';\n            else \n                set v_error_message = concat(\'unexpected state \', v_scan_state);\n                leave my_error;\n        end case;\n    until \n        v_old_from = v_from\n    end repeat;\n\n    commit;\n    set autocommit = @old_autocommit;\n    \n    if return_result_set then\n      select distinct schema_name, object_name, object_type, action\n      from _sql_dependencies\n      order by schema_name, object_name, object_type, action\n      ;\n    end if;\n    leave my_main;\n  end;\n  set result_success := 0;\n  if return_result_set then\n    select concat(\'Error: \', v_error_message) error;\n  end if;\nend'),('common_schema','_consume_statement','PROCEDURE','_consume_statement','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expect_single tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   in depth int unsigned,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n    declare first_token text;\n    declare first_state text;\n    declare statement_level int unsigned;\n    declare id_end_statement int unsigned; \n    \n    declare statement_delimiter_found tinyint unsigned;\n    \n    declare expression text charset utf8;\n    declare expression_statement text charset utf8;\n    declare expression_result tinyint unsigned;\n    \n    declare peek_match tinyint unsigned;\n    declare matched_token text charset utf8;\n    \n    declare loop_iteration_count bigint unsigned;\n    \n    declare while_statement_id_from int unsigned;\n    declare while_statement_id_to int unsigned;\n    declare while_otherwise_statement_id_from int unsigned;\n    declare while_otherwise_statement_id_to int unsigned;\n    \n    declare foreach_statement_id_from int unsigned;\n    declare foreach_statement_id_to int unsigned;\n    declare foreach_otherwise_statement_id_from int unsigned;\n    declare foreach_otherwise_statement_id_to int unsigned;\n    \n    declare split_statement_id_from int unsigned;\n    declare split_statement_id_to int unsigned;\n    declare split_options varchar(2048) charset utf8;\n\n    declare if_statement_id_from int unsigned;\n    declare if_statement_id_to int unsigned;\n    declare else_statement_id_from int unsigned;\n    declare else_statement_id_to int unsigned;\n\n    declare try_statement_error_found tinyint unsigned;\n    declare try_statement_id_from int unsigned;\n    declare try_statement_id_to int unsigned;\n    declare catch_statement_id_from int unsigned;\n    declare catch_statement_id_to int unsigned;\n\n    declare foreach_variables_statement text charset utf8;\n    declare foreach_collection text charset utf8;\n    declare foreach_variables_array_id int unsigned;\n    declare foreach_variables_delaration_id int unsigned;\n    \n    declare split_table_schema tinytext charset utf8;\n    declare split_table_name tinytext charset utf8;\n    declare split_injected_action_statement text charset utf8;\n    declare split_injected_text text charset utf8;\n    \n    declare reset_query text charset utf8;\n\n    statement_loop: while id_from <= id_to do\n      if @_common_schema_script_break_type IS NOT NULL then\n         set consumed_to_id := id_to;\n         leave statement_loop;\n      end if;\n\n      SELECT level, token, state FROM _sql_tokens WHERE id = id_from INTO statement_level, first_token, first_state;\n      \n      case\n        when first_state in (\'whitespace\', \'single line comment\', \'multi line comment\') then begin\n	        \n	        set id_from := id_from + 1;\n	        iterate statement_loop;\n	      end;\n        when first_state = \'left braces\' then begin\n	        \n            SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right braces\' AND level = statement_level INTO id_end_statement;\n  	        if id_end_statement IS NULL then\n	          call _throw_script_error(id_from, \'Unmatched \"{\" brace\');\n	        end if;\n	        call _consume_statement(id_from+1, id_end_statement-1, FALSE, @_common_schema_dummy, depth+1, should_execute_statement);\n	        set consumed_to_id := id_end_statement;\n          end;\n        when first_state = \'alpha\' AND (SELECT COUNT(*) = 1 FROM _script_statements WHERE _script_statements.statement = first_token) then begin\n	        \n	        call _validate_statement_end(id_from, id_to, id_end_statement, statement_delimiter_found);\n	        call _resolve_and_consume_sql_or_script_statement(id_from, id_to, id_from + 1, id_end_statement - IF(statement_delimiter_found, 1, 0), depth, first_token, should_execute_statement);\n  	        set consumed_to_id := id_end_statement;\n          end;\n        when first_state = \'alpha\' AND first_token = \'while\' then begin\n	        call _consume_expression(id_from + 1, id_to, TRUE, consumed_to_id, expression, expression_statement, should_execute_statement);\n	        set id_from := consumed_to_id + 1;\n	        \n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set while_statement_id_from := id_from;\n	        set while_statement_id_to := consumed_to_id;\n	        \n	        set while_otherwise_statement_id_from := NULL;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'otherwise\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	          set while_otherwise_statement_id_from := id_from;\n              set while_otherwise_statement_id_to := consumed_to_id;\n	        end if;\n            if should_execute_statement then\n              \n              set loop_iteration_count := 0;\n              interpret_while_loop: while TRUE do\n                \n                if @_common_schema_script_break_type IS NOT NULL then\n                  if @_common_schema_script_break_type = \'break\' then\n                    set @_common_schema_script_break_type := NULL;\n                  end if;\n                  leave interpret_while_loop;\n                end if;\n                \n                call _evaluate_expression(expression, expression_statement, expression_result);\n                if NOT expression_result then\n                  leave interpret_while_loop;\n                end if;\n                \n                set loop_iteration_count := loop_iteration_count + 1;\n                call _consume_statement(while_statement_id_from, while_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n              end while;\n              if loop_iteration_count = 0 then\n                \n                \n                if while_otherwise_statement_id_from IS NOT NULL then\n                  call _consume_statement(while_otherwise_statement_id_from, while_otherwise_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                end if;\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'loop\' then begin\n	        \n	        set id_from := id_from + 1;\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set while_statement_id_from := id_from;\n	        set while_statement_id_to := consumed_to_id;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'while\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          call _consume_expression(consumed_to_id + 1, id_to, TRUE, consumed_to_id, expression, expression_statement, should_execute_statement);\n	          set id_from := consumed_to_id + 1;\n            else\n              call _throw_script_error(id_from, CONCAT(\'Expcted \"while\" on loop-while expression\'));\n	        end if;\n	        call _expect_statement_delimiter(consumed_to_id + 1, id_to, consumed_to_id);\n            set id_from := consumed_to_id + 1;\n\n            if should_execute_statement then\n              interpret_while_loop: while TRUE do\n                \n                if @_common_schema_script_break_type IS NOT NULL then\n                  if @_common_schema_script_break_type = \'break\' then\n                    set @_common_schema_script_break_type := NULL;\n                  end if;\n                  leave interpret_while_loop;\n                end if;\n                \n                call _consume_statement(while_statement_id_from, while_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                \n                call _evaluate_expression(expression, expression_statement, expression_result);\n                if NOT expression_result then\n                  leave interpret_while_loop;\n                end if;\n              end while;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'foreach\' then begin\n	        call _consume_foreach_expression(id_from + 1, id_to, consumed_to_id, depth, foreach_collection, foreach_variables_array_id, foreach_variables_delaration_id, should_execute_statement);\n\n	        set id_from := consumed_to_id + 1;\n	        \n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set foreach_statement_id_from := id_from;\n	        set foreach_statement_id_to := consumed_to_id;\n	        update _qs_variables set scope_end_id = foreach_statement_id_to where declaration_id = foreach_variables_delaration_id;\n	        \n	        set foreach_otherwise_statement_id_from := NULL;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'otherwise\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	          set foreach_otherwise_statement_id_from := id_from;\n              set foreach_otherwise_statement_id_to := consumed_to_id;\n	        end if;\n            if should_execute_statement then\n              call _foreach(foreach_collection, NULL, foreach_statement_id_from, foreach_statement_id_to, TRUE, @_common_schema_dummy, foreach_variables_array_id, depth+1, TRUE, loop_iteration_count);\n              if loop_iteration_count = 0 then\n                \n                \n                if foreach_otherwise_statement_id_from IS NOT NULL then\n                  call _consume_statement(foreach_otherwise_statement_id_from, foreach_otherwise_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                end if;\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'split\' then begin\n	        call _consume_split_statement(id_from + 1, id_to, consumed_to_id, depth, split_table_schema, split_table_name, split_injected_action_statement, split_injected_text, split_options, should_execute_statement);\n\n	        set id_from := consumed_to_id + 1;\n	        \n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set split_statement_id_from := id_from;\n	        set split_statement_id_to := consumed_to_id;\n            if should_execute_statement then\n             begin end;\n               \n               call _split(split_table_schema, split_table_name, split_options, split_injected_action_statement, split_injected_text, split_statement_id_from, split_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'if\' then begin\n	        call _consume_expression(id_from + 1, id_to, TRUE, consumed_to_id, expression, expression_statement, should_execute_statement);\n	        set id_from := consumed_to_id + 1;\n	        \n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	        set if_statement_id_from := id_from;\n	        set if_statement_id_to := consumed_to_id;\n	        \n	        set else_statement_id_from := NULL;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'else\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	          set else_statement_id_from := id_from;\n              set else_statement_id_to := consumed_to_id;\n	        end if;\n            if should_execute_statement then\n              \n              call _evaluate_expression(expression, expression_statement, expression_result);\n              if expression_result then\n                \n                call _consume_statement(if_statement_id_from, if_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n              else\n                \n                if else_statement_id_from IS NOT NULL then\n                  call _consume_statement(else_statement_id_from, else_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                end if;\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'try\' then begin\n	        \n            set id_from := id_from + 1;\n            call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set try_statement_id_from := id_from;\n            set try_statement_id_to := consumed_to_id;\n            \n            call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'catch\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n              set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n              set catch_statement_id_from := id_from;\n              set catch_statement_id_to := consumed_to_id;\n            else\n              call _throw_script_error(id_from, CONCAT(\'Expected \"catch\" on try-catch block\'));\n            end if;\n            \n            if should_execute_statement then\n              call _consume_try_statement(try_statement_id_from, try_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE, try_statement_error_found);\n              if try_statement_error_found then\n                call _consume_statement(catch_statement_id_from, catch_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token in (\'break\', \'return\') then begin\n	        call _expect_statement_delimiter(id_from + 1, id_to, consumed_to_id);\n	        if should_execute_statement then\n	          set @_common_schema_script_break_type := first_token;\n	        end if;\n	      end;\n        when first_state = \'statement delimiter\' then begin\n            call _throw_script_error(id_from, CONCAT(\'Empty statement not allowed. Use {} instead\'));\n	      end;\n        when first_state = \'start\' then begin\n            if expect_single then\n              call _throw_script_error(id_from, CONCAT(\'Unexpected end of script. Expected statement\'));\n            end if;\n	        set consumed_to_id := id_from;\n	      end;\n	    else begin \n		    call _throw_script_error(id_from, CONCAT(\'Unsupported token: \"\', first_token, \'\"\'));\n		  end;\n      end case;\n      if expect_single then\n         leave statement_loop;\n      end if;\n      set id_from := consumed_to_id + 1;\n    end while;\n    set id_from := consumed_to_id + 1;\n\n    \n    \n    SELECT GROUP_CONCAT(\'SET \', mapped_user_defined_variable_name, \' := NULL \' SEPARATOR \';\') FROM _qs_variables WHERE declaration_depth = depth INTO reset_query;\n    call exec(reset_query);\n    UPDATE _qs_variables SET value_snapshot = NULL WHERE declaration_depth = depth;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads (possibly nested) statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare first_token text;\n    declare first_state text;\n    declare statement_level int unsigned;\n    declare id_end_statement int unsigned; \n    \n    declare statement_delimiter_found tinyint unsigned;\n    \n    declare expression text charset utf8;\n    declare expression_statement text charset utf8;\n    declare expression_result tinyint unsigned;\n    \n    declare peek_match tinyint unsigned;\n    declare matched_token text charset utf8;\n    \n    declare loop_iteration_count bigint unsigned;\n    \n    declare while_statement_id_from int unsigned;\n    declare while_statement_id_to int unsigned;\n    declare while_otherwise_statement_id_from int unsigned;\n    declare while_otherwise_statement_id_to int unsigned;\n    \n    declare foreach_statement_id_from int unsigned;\n    declare foreach_statement_id_to int unsigned;\n    declare foreach_otherwise_statement_id_from int unsigned;\n    declare foreach_otherwise_statement_id_to int unsigned;\n    \n    declare split_statement_id_from int unsigned;\n    declare split_statement_id_to int unsigned;\n    declare split_options varchar(2048) charset utf8;\n\n    declare if_statement_id_from int unsigned;\n    declare if_statement_id_to int unsigned;\n    declare else_statement_id_from int unsigned;\n    declare else_statement_id_to int unsigned;\n\n    declare try_statement_error_found tinyint unsigned;\n    declare try_statement_id_from int unsigned;\n    declare try_statement_id_to int unsigned;\n    declare catch_statement_id_from int unsigned;\n    declare catch_statement_id_to int unsigned;\n\n    declare foreach_variables_statement text charset utf8;\n    declare foreach_collection text charset utf8;\n    declare foreach_variables_array_id int unsigned;\n    declare foreach_variables_delaration_id int unsigned;\n    \n    declare split_table_schema tinytext charset utf8;\n    declare split_table_name tinytext charset utf8;\n    declare split_injected_action_statement text charset utf8;\n    declare split_injected_text text charset utf8;\n    \n    declare reset_query text charset utf8;\n\n    statement_loop: while id_from <= id_to do\n      if @_common_schema_script_break_type IS NOT NULL then\n         set consumed_to_id := id_to;\n         leave statement_loop;\n      end if;\n\n      SELECT level, token, state FROM _sql_tokens WHERE id = id_from INTO statement_level, first_token, first_state;\n      \n      case\n        when first_state in (\'whitespace\', \'single line comment\', \'multi line comment\') then begin\n	        \n	        set id_from := id_from + 1;\n	        iterate statement_loop;\n	      end;\n        when first_state = \'left braces\' then begin\n	        \n            SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND state = \'right braces\' AND level = statement_level INTO id_end_statement;\n  	        if id_end_statement IS NULL then\n	          call _throw_script_error(id_from, \'Unmatched \"{\" brace\');\n	        end if;\n	        call _consume_statement(id_from+1, id_end_statement-1, FALSE, @_common_schema_dummy, depth+1, should_execute_statement);\n	        set consumed_to_id := id_end_statement;\n          end;\n        when first_state = \'alpha\' AND (SELECT COUNT(*) = 1 FROM _script_statements WHERE _script_statements.statement = first_token) then begin\n	        \n	        call _validate_statement_end(id_from, id_to, id_end_statement, statement_delimiter_found);\n	        call _resolve_and_consume_sql_or_script_statement(id_from, id_to, id_from + 1, id_end_statement - IF(statement_delimiter_found, 1, 0), depth, first_token, should_execute_statement);\n  	        set consumed_to_id := id_end_statement;\n          end;\n        when first_state = \'alpha\' AND first_token = \'while\' then begin\n	        call _consume_expression(id_from + 1, id_to, TRUE, consumed_to_id, expression, expression_statement, should_execute_statement);\n	        set id_from := consumed_to_id + 1;\n	        \n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set while_statement_id_from := id_from;\n	        set while_statement_id_to := consumed_to_id;\n	        \n	        set while_otherwise_statement_id_from := NULL;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'otherwise\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	          set while_otherwise_statement_id_from := id_from;\n              set while_otherwise_statement_id_to := consumed_to_id;\n	        end if;\n            if should_execute_statement then\n              \n              set loop_iteration_count := 0;\n              interpret_while_loop: while TRUE do\n                \n                if @_common_schema_script_break_type IS NOT NULL then\n                  if @_common_schema_script_break_type = \'break\' then\n                    set @_common_schema_script_break_type := NULL;\n                  end if;\n                  leave interpret_while_loop;\n                end if;\n                \n                call _evaluate_expression(expression, expression_statement, expression_result);\n                if NOT expression_result then\n                  leave interpret_while_loop;\n                end if;\n                \n                set loop_iteration_count := loop_iteration_count + 1;\n                call _consume_statement(while_statement_id_from, while_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n              end while;\n              if loop_iteration_count = 0 then\n                \n                \n                if while_otherwise_statement_id_from IS NOT NULL then\n                  call _consume_statement(while_otherwise_statement_id_from, while_otherwise_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                end if;\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'loop\' then begin\n	        \n	        set id_from := id_from + 1;\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set while_statement_id_from := id_from;\n	        set while_statement_id_to := consumed_to_id;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'while\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          call _consume_expression(consumed_to_id + 1, id_to, TRUE, consumed_to_id, expression, expression_statement, should_execute_statement);\n	          set id_from := consumed_to_id + 1;\n            else\n              call _throw_script_error(id_from, CONCAT(\'Expcted \"while\" on loop-while expression\'));\n	        end if;\n	        call _expect_statement_delimiter(consumed_to_id + 1, id_to, consumed_to_id);\n            set id_from := consumed_to_id + 1;\n\n            if should_execute_statement then\n              interpret_while_loop: while TRUE do\n                \n                if @_common_schema_script_break_type IS NOT NULL then\n                  if @_common_schema_script_break_type = \'break\' then\n                    set @_common_schema_script_break_type := NULL;\n                  end if;\n                  leave interpret_while_loop;\n                end if;\n                \n                call _consume_statement(while_statement_id_from, while_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                \n                call _evaluate_expression(expression, expression_statement, expression_result);\n                if NOT expression_result then\n                  leave interpret_while_loop;\n                end if;\n              end while;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'foreach\' then begin\n	        call _consume_foreach_expression(id_from + 1, id_to, consumed_to_id, depth, foreach_collection, foreach_variables_array_id, foreach_variables_delaration_id, should_execute_statement);\n\n	        set id_from := consumed_to_id + 1;\n	        \n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set foreach_statement_id_from := id_from;\n	        set foreach_statement_id_to := consumed_to_id;\n	        update _qs_variables set scope_end_id = foreach_statement_id_to where declaration_id = foreach_variables_delaration_id;\n	        \n	        set foreach_otherwise_statement_id_from := NULL;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'otherwise\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	          set foreach_otherwise_statement_id_from := id_from;\n              set foreach_otherwise_statement_id_to := consumed_to_id;\n	        end if;\n            if should_execute_statement then\n              call _foreach(foreach_collection, NULL, foreach_statement_id_from, foreach_statement_id_to, TRUE, @_common_schema_dummy, foreach_variables_array_id, depth+1, TRUE, loop_iteration_count);\n              if loop_iteration_count = 0 then\n                \n                \n                if foreach_otherwise_statement_id_from IS NOT NULL then\n                  call _consume_statement(foreach_otherwise_statement_id_from, foreach_otherwise_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                end if;\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'split\' then begin\n	        call _consume_split_statement(id_from + 1, id_to, consumed_to_id, depth, split_table_schema, split_table_name, split_injected_action_statement, split_injected_text, split_options, should_execute_statement);\n\n	        set id_from := consumed_to_id + 1;\n	        \n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level + 1;\n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set @_common_schema_script_loop_nesting_level := @_common_schema_script_loop_nesting_level - 1;\n	        set split_statement_id_from := id_from;\n	        set split_statement_id_to := consumed_to_id;\n            if should_execute_statement then\n             begin end;\n               \n               call _split(split_table_schema, split_table_name, split_options, split_injected_action_statement, split_injected_text, split_statement_id_from, split_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'if\' then begin\n	        call _consume_expression(id_from + 1, id_to, TRUE, consumed_to_id, expression, expression_statement, should_execute_statement);\n	        set id_from := consumed_to_id + 1;\n	        \n	        call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	        set if_statement_id_from := id_from;\n	        set if_statement_id_to := consumed_to_id;\n	        \n	        set else_statement_id_from := NULL;\n	        call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'else\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n	          set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n	          set else_statement_id_from := id_from;\n              set else_statement_id_to := consumed_to_id;\n	        end if;\n            if should_execute_statement then\n              \n              call _evaluate_expression(expression, expression_statement, expression_result);\n              if expression_result then\n                \n                call _consume_statement(if_statement_id_from, if_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n              else\n                \n                if else_statement_id_from IS NOT NULL then\n                  call _consume_statement(else_statement_id_from, else_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n                end if;\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token = \'try\' then begin\n	        \n            set id_from := id_from + 1;\n            call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n            set try_statement_id_from := id_from;\n            set try_statement_id_to := consumed_to_id;\n            \n            call _consume_if_exists(consumed_to_id + 1, id_to, consumed_to_id, \'catch\', NULL, peek_match, @_common_schema_dummy);\n	        if peek_match then\n              set id_from := consumed_to_id + 1;\n              call _consume_statement(id_from, id_to, TRUE, consumed_to_id, depth+1, FALSE);\n              set catch_statement_id_from := id_from;\n              set catch_statement_id_to := consumed_to_id;\n            else\n              call _throw_script_error(id_from, CONCAT(\'Expected \"catch\" on try-catch block\'));\n            end if;\n            \n            if should_execute_statement then\n              call _consume_try_statement(try_statement_id_from, try_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE, try_statement_error_found);\n              if try_statement_error_found then\n                call _consume_statement(catch_statement_id_from, catch_statement_id_to, TRUE, @_common_schema_dummy, depth+1, TRUE);\n              end if;\n            end if;\n	      end;\n        when first_state = \'alpha\' AND first_token in (\'break\', \'return\') then begin\n	        call _expect_statement_delimiter(id_from + 1, id_to, consumed_to_id);\n	        if should_execute_statement then\n	          set @_common_schema_script_break_type := first_token;\n	        end if;\n	      end;\n        when first_state = \'statement delimiter\' then begin\n            call _throw_script_error(id_from, CONCAT(\'Empty statement not allowed. Use {} instead\'));\n	      end;\n        when first_state = \'start\' then begin\n            if expect_single then\n              call _throw_script_error(id_from, CONCAT(\'Unexpected end of script. Expected statement\'));\n            end if;\n	        set consumed_to_id := id_from;\n	      end;\n	    else begin \n		    call _throw_script_error(id_from, CONCAT(\'Unsupported token: \"\', first_token, \'\"\'));\n		  end;\n      end case;\n      if expect_single then\n         leave statement_loop;\n      end if;\n      set id_from := consumed_to_id + 1;\n    end while;\n    set id_from := consumed_to_id + 1;\n\n    \n    \n    SELECT GROUP_CONCAT(\'SET \', mapped_user_defined_variable_name, \' := NULL \' SEPARATOR \';\') FROM _qs_variables WHERE declaration_depth = depth INTO reset_query;\n    call exec(reset_query);\n    UPDATE _qs_variables SET value_snapshot = NULL WHERE declaration_depth = depth;\nend'),('common_schema','_consume_try_statement','PROCEDURE','_consume_try_statement','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expect_single tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   in depth int unsigned,\n   in should_execute_statement tinyint unsigned,\n   out try_statement_error_found int unsigned\n','','main_body: begin\n  \n  \n  declare continue handler for SQLEXCEPTION set try_statement_error_found = true;\n  \n  set try_statement_error_found := false;\n  call _consume_statement(id_from, id_to, expect_single, consumed_to_id, depth, should_execute_statement);\n  \nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Invokes statement in try{} block','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  \n  \n  declare continue handler for SQLEXCEPTION set try_statement_error_found = true;\n  \n  set try_statement_error_found := false;\n  call _consume_statement(id_from, id_to, expect_single, consumed_to_id, depth, should_execute_statement);\n  \nend'),('common_schema','_get_sql_tokens','PROCEDURE','_get_sql_tokens','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n    in p_text text\n','','begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text;\n    declare v_level int;\n    declare v_state varchar(32);\n    declare _sql_tokens_id int unsigned default 0;\n    \n    drop temporary table if exists _sql_tokens;\n    create temporary table _sql_tokens(\n        id int unsigned primary key\n    ,   start int unsigned  not null\n    ,   level int not null\n    ,   token text          \n    ,   state text           not null\n    ) engine=MyISAM;\n    \n    repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, 1, v_state);\n        set _sql_tokens_id := _sql_tokens_id + 1;\n        insert into _sql_tokens(id,start,level,token,state) \n        values (_sql_tokens_id, v_from, v_level, v_token, v_state);\n    until \n        v_old_from = v_from\n    end repeat;\n    \n    if @common_schema_debug then\n      select * \n      from _sql_tokens\n      order by id;\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads tokens according to lexical rules for SQL','utf8','utf8_general_ci','utf8_general_ci','begin\n    declare v_from, v_old_from int unsigned;\n    declare v_token text;\n    declare v_level int;\n    declare v_state varchar(32);\n    declare _sql_tokens_id int unsigned default 0;\n    \n    drop temporary table if exists _sql_tokens;\n    create temporary table _sql_tokens(\n        id int unsigned primary key\n    ,   start int unsigned  not null\n    ,   level int not null\n    ,   token text          \n    ,   state text           not null\n    ) engine=MyISAM;\n    \n    repeat \n        set v_old_from = v_from;\n        call _get_sql_token(p_text, v_from, v_level, v_token, 1, v_state);\n        set _sql_tokens_id := _sql_tokens_id + 1;\n        insert into _sql_tokens(id,start,level,token,state) \n        values (_sql_tokens_id, v_from, v_level, v_token, v_state);\n    until \n        v_old_from = v_from\n    end repeat;\n    \n    if @common_schema_debug then\n      select * \n      from _sql_tokens\n      order by id;\n    end if;\nend'),('common_schema','_interpret','PROCEDURE','_interpret','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n  in query_script text,\n  in should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare id_from int unsigned;\n  declare id_to int unsigned;\n  declare end_level int;\n  declare negative_level_id int unsigned;\n  declare expanded_variables_ids text charset ascii;\n  declare num_expanded_variables_ids int unsigned;\n  declare expanded_variable_index int unsigned;\n  declare current_expanded_variable_id int unsigned;\n  \n  set @@max_sp_recursion_depth := 127;\n  set @__script_group_concat_max_len := @@group_concat_max_len;\n  set @@group_concat_max_len := GREATEST(@@group_concat_max_len, 32 * 1024 * 1024);\n  \n  call _get_sql_tokens(query_script);\n  SELECT MIN(id), MAX(id) FROM _sql_tokens INTO id_from, id_to;\n  SELECT MIN(id) FROM _sql_tokens WHERE level < 0 INTO negative_level_id;\n  if negative_level_id IS NOT NULL then\n    call throw(CONCAT(\'Negative nesting level detected at id \', negative_level_id));\n  end if;\n  SELECT level FROM _sql_tokens WHERE id = id_to INTO end_level;\n  if end_level != 0 then\n    call throw(\'Invalid nesting level detected at end of script\');\n  end if;\n\n  drop temporary table if exists _qs_variables;\n  create temporary table _qs_variables(\n      variable_name VARCHAR(65) CHARSET ascii NOT NULL,\n      mapped_user_defined_variable_name  VARCHAR(65) CHARSET ascii NOT NULL,\n      declaration_depth INT UNSIGNED NOT NULL,\n      declaration_id INT UNSIGNED NOT NULL,\n      scope_end_id INT UNSIGNED NOT NULL,\n      value_snapshot TEXT DEFAULT NULL,\n      PRIMARY KEY(variable_name),\n      KEY(declaration_depth),\n      KEY(declaration_id),\n      KEY(scope_end_id)\n  ) engine=MyISAM;\n\n\n\n\n\n\n\n\n\n\n\n\n\n  \n  \n  \n  \n  select group_concat(id order by id) from _sql_tokens where state=\'expanded query_script variable\' and token=\':$\' into expanded_variables_ids;\n  if expanded_variables_ids then\n    set num_expanded_variables_ids := get_num_tokens(expanded_variables_ids, \',\');\n    set expanded_variable_index := 1;\n    while expanded_variable_index <= num_expanded_variables_ids do\n      set current_expanded_variable_id := split_token(expanded_variables_ids, \',\', expanded_variable_index);\n      select \n          GROUP_CONCAT(token ORDER BY id SEPARATOR \'\') AS expanded_variable_tokens, \n          (\n            GROUP_CONCAT(state ORDER BY id) = \'left braces,alpha,right braces\' OR\n            GROUP_CONCAT(state ORDER BY id) = \'left braces,alphanum,right braces\' \n          ) AS expanded_variable_match\n        from _sql_tokens where id between current_expanded_variable_id+1 and current_expanded_variable_id+3\n        into @_expanded_variable_tokens, @_expanded_variable_match;\n\n      if @_expanded_variable_match then\n        \n        \n        update _sql_tokens set token = CONCAT(\':$\', @_expanded_variable_tokens) where id = current_expanded_variable_id;\n        update _sql_tokens set token = \'\', state = \'whitespace\', level = level - 1 where id between current_expanded_variable_id+1 and current_expanded_variable_id+3;\n      end if;\n      \n      set expanded_variable_index := expanded_variable_index + 1;\n    end while;    \n  end if;\n  \n  set @_common_schema_script_break_type := NULL;\n  set @_common_schema_script_loop_nesting_level := 0;\n  set @_common_schema_script_throttle_chunk_start := NULL;\n  set @_common_schema_script_start_timestamp := NOW();\n  set @_common_schema_script_report_used := false;\n  set @_common_schema_script_report_delimiter := \'\';\n\n  \n  \n  call _declare_local_variable(0, 0, id_to, 0, \'$rowcount\', \'@query_script_rowcount\', FALSE);\n  call _declare_local_variable(0, 0, id_to, 0, \'$found_rows\', \'@query_script_found_rows\', FALSE);\n  \n  \n  call _consume_statement(id_from, id_to, FALSE, id_to, 0, FALSE);\n  \n  if should_execute_statement then\n    \n    call _consume_statement(id_from, id_to, FALSE, id_to, 0, TRUE);\n  end if;\n  \n  if @_common_schema_script_report_used then\n    call _script_report_finalize();\n  end if;\n  \n  set @@group_concat_max_len := @__script_group_concat_max_len;  \nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','...','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare id_from int unsigned;\n  declare id_to int unsigned;\n  declare end_level int;\n  declare negative_level_id int unsigned;\n  declare expanded_variables_ids text charset ascii;\n  declare num_expanded_variables_ids int unsigned;\n  declare expanded_variable_index int unsigned;\n  declare current_expanded_variable_id int unsigned;\n  \n  set @@max_sp_recursion_depth := 127;\n  set @__script_group_concat_max_len := @@group_concat_max_len;\n  set @@group_concat_max_len := GREATEST(@@group_concat_max_len, 32 * 1024 * 1024);\n  \n  call _get_sql_tokens(query_script);\n  SELECT MIN(id), MAX(id) FROM _sql_tokens INTO id_from, id_to;\n  SELECT MIN(id) FROM _sql_tokens WHERE level < 0 INTO negative_level_id;\n  if negative_level_id IS NOT NULL then\n    call throw(CONCAT(\'Negative nesting level detected at id \', negative_level_id));\n  end if;\n  SELECT level FROM _sql_tokens WHERE id = id_to INTO end_level;\n  if end_level != 0 then\n    call throw(\'Invalid nesting level detected at end of script\');\n  end if;\n\n  drop temporary table if exists _qs_variables;\n  create temporary table _qs_variables(\n      variable_name VARCHAR(65) CHARSET ascii NOT NULL,\n      mapped_user_defined_variable_name  VARCHAR(65) CHARSET ascii NOT NULL,\n      declaration_depth INT UNSIGNED NOT NULL,\n      declaration_id INT UNSIGNED NOT NULL,\n      scope_end_id INT UNSIGNED NOT NULL,\n      value_snapshot TEXT DEFAULT NULL,\n      PRIMARY KEY(variable_name),\n      KEY(declaration_depth),\n      KEY(declaration_id),\n      KEY(scope_end_id)\n  ) engine=MyISAM;\n\n\n\n\n\n\n\n\n\n\n\n\n\n  \n  \n  \n  \n  select group_concat(id order by id) from _sql_tokens where state=\'expanded query_script variable\' and token=\':$\' into expanded_variables_ids;\n  if expanded_variables_ids then\n    set num_expanded_variables_ids := get_num_tokens(expanded_variables_ids, \',\');\n    set expanded_variable_index := 1;\n    while expanded_variable_index <= num_expanded_variables_ids do\n      set current_expanded_variable_id := split_token(expanded_variables_ids, \',\', expanded_variable_index);\n      select \n          GROUP_CONCAT(token ORDER BY id SEPARATOR \'\') AS expanded_variable_tokens, \n          (\n            GROUP_CONCAT(state ORDER BY id) = \'left braces,alpha,right braces\' OR\n            GROUP_CONCAT(state ORDER BY id) = \'left braces,alphanum,right braces\' \n          ) AS expanded_variable_match\n        from _sql_tokens where id between current_expanded_variable_id+1 and current_expanded_variable_id+3\n        into @_expanded_variable_tokens, @_expanded_variable_match;\n\n      if @_expanded_variable_match then\n        \n        \n        update _sql_tokens set token = CONCAT(\':$\', @_expanded_variable_tokens) where id = current_expanded_variable_id;\n        update _sql_tokens set token = \'\', state = \'whitespace\', level = level - 1 where id between current_expanded_variable_id+1 and current_expanded_variable_id+3;\n      end if;\n      \n      set expanded_variable_index := expanded_variable_index + 1;\n    end while;    \n  end if;\n  \n  set @_common_schema_script_break_type := NULL;\n  set @_common_schema_script_loop_nesting_level := 0;\n  set @_common_schema_script_throttle_chunk_start := NULL;\n  set @_common_schema_script_start_timestamp := NOW();\n  set @_common_schema_script_report_used := false;\n  set @_common_schema_script_report_delimiter := \'\';\n\n  \n  \n  call _declare_local_variable(0, 0, id_to, 0, \'$rowcount\', \'@query_script_rowcount\', FALSE);\n  call _declare_local_variable(0, 0, id_to, 0, \'$found_rows\', \'@query_script_found_rows\', FALSE);\n  \n  \n  call _consume_statement(id_from, id_to, FALSE, id_to, 0, FALSE);\n  \n  if should_execute_statement then\n    \n    call _consume_statement(id_from, id_to, FALSE, id_to, 0, TRUE);\n  end if;\n  \n  if @_common_schema_script_report_used then\n    call _script_report_finalize();\n  end if;\n  \n  set @@group_concat_max_len := @__script_group_concat_max_len;  \nend'),('common_schema','_run_named_script','PROCEDURE','_run_named_script','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n  named_script_name varchar(64) CHARACTER SET ascii\n','','main_body: begin\n  declare query_script text charset utf8;\n  \n  select script_text from _named_scripts where script_name = named_script_name into query_script;\n  if query_script is null then\n    call throw(CONCAT(\'Unknown script: \', named_script_name));\n  end if;\n  call run(query_script);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Run script from _named_scripts table','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare query_script text charset utf8;\n  \n  select script_text from _named_scripts where script_name = named_script_name into query_script;\n  if query_script is null then\n    call throw(CONCAT(\'Unknown script: \', named_script_name));\n  end if;\n  call run(query_script);\nend'),('common_schema','_script_report','PROCEDURE','_script_report','SQL','MODIFIES_SQL_DATA','YES','INVOKER','report_params TEXT CHARSET utf8','','begin\n  declare report_query text charset utf8;\n  \n  declare is_header tinyint unsigned default 0;\n  declare is_paragraph tinyint unsigned default 0;\n  declare is_bullet tinyint unsigned default 0;\n  declare is_code tinyint unsigned default 0;\n  declare is_horizontal_ruler tinyint unsigned default 0;\n  \n  if not @_common_schema_script_report_used then\n    drop temporary table if exists _script_report_data;\n    create temporary table _script_report_data (\n      id int unsigned AUTO_INCREMENT,\n      info text charset utf8,\n      PRIMARY KEY (id)\n    ) engine=MyISAM;\n    set @_common_schema_script_report_used := true;\n  end if;\n  \n  set report_params := trim_wspace(report_params);\n  set @_common_schema_script_report_prefix_len := 0;\n  if (@_common_schema_script_report_prefix_len := starts_with(report_params, \'h1 \')) then\n    set is_header := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'p \')) then\n    set is_paragraph := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'li \')) then\n    set is_bullet := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'code \')) then\n    set is_code := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'hr \')) then\n    set is_horizontal_ruler := 1;\n  end if;\n  set report_params := substring(report_params, @_common_schema_script_report_prefix_len + 1);\n  \n  set report_query := CONCAT(\'set @_query_script_report_line := CONCAT_WS(@_common_schema_script_report_delimiter, \', report_params, \')\');\n  call exec_single(report_query);\n  \n  set @_query_script_report_line := trim_wspace(@_query_script_report_line);\n\n\n  if is_header then\n    set @_query_script_report_line := CONCAT(\'\\n\', @_query_script_report_line,\n      \'\\n\', REPEAT(\'=\', CHAR_LENGTH(@_query_script_report_line)));\n  end if;\n  if is_bullet then\n    set @_query_script_report_line := CONCAT(\'- \', @_query_script_report_line);\n  end if;\n  if is_code then\n    set @_query_script_report_line := CONCAT(\'> \', @_query_script_report_line);\n  end if;\n  if is_paragraph then\n    set @_query_script_report_line := CONCAT(\'\\n\', @_query_script_report_line);\n  end if;\n  if is_horizontal_ruler then\n    set @_query_script_report_line := CONCAT(\'---\\n\', @_query_script_report_line);\n  end if;\n  \n  insert into \n    _script_report_data (info) \n  SELECT \n    split_token(@_query_script_report_line, \'\\n\', n)\n  FROM\n    numbers\n  WHERE \n    numbers.n BETWEEN 1 AND get_num_tokens(@_query_script_report_line, \'\\n\')\n  ORDER BY \n    n ASC;\n\n  set @_query_script_report_line := NULL;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare report_query text charset utf8;\n  \n  declare is_header tinyint unsigned default 0;\n  declare is_paragraph tinyint unsigned default 0;\n  declare is_bullet tinyint unsigned default 0;\n  declare is_code tinyint unsigned default 0;\n  declare is_horizontal_ruler tinyint unsigned default 0;\n  \n  if not @_common_schema_script_report_used then\n    drop temporary table if exists _script_report_data;\n    create temporary table _script_report_data (\n      id int unsigned AUTO_INCREMENT,\n      info text charset utf8,\n      PRIMARY KEY (id)\n    ) engine=MyISAM;\n    set @_common_schema_script_report_used := true;\n  end if;\n  \n  set report_params := trim_wspace(report_params);\n  set @_common_schema_script_report_prefix_len := 0;\n  if (@_common_schema_script_report_prefix_len := starts_with(report_params, \'h1 \')) then\n    set is_header := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'p \')) then\n    set is_paragraph := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'li \')) then\n    set is_bullet := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'code \')) then\n    set is_code := 1;\n  elseif (@_common_schema_script_report_prefix_len := starts_with(report_params, \'hr \')) then\n    set is_horizontal_ruler := 1;\n  end if;\n  set report_params := substring(report_params, @_common_schema_script_report_prefix_len + 1);\n  \n  set report_query := CONCAT(\'set @_query_script_report_line := CONCAT_WS(@_common_schema_script_report_delimiter, \', report_params, \')\');\n  call exec_single(report_query);\n  \n  set @_query_script_report_line := trim_wspace(@_query_script_report_line);\n\n\n  if is_header then\n    set @_query_script_report_line := CONCAT(\'\n\', @_query_script_report_line,\n      \'\n\', REPEAT(\'=\', CHAR_LENGTH(@_query_script_report_line)));\n  end if;\n  if is_bullet then\n    set @_query_script_report_line := CONCAT(\'- \', @_query_script_report_line);\n  end if;\n  if is_code then\n    set @_query_script_report_line := CONCAT(\'> \', @_query_script_report_line);\n  end if;\n  if is_paragraph then\n    set @_query_script_report_line := CONCAT(\'\n\', @_query_script_report_line);\n  end if;\n  if is_horizontal_ruler then\n    set @_query_script_report_line := CONCAT(\'---\n\', @_query_script_report_line);\n  end if;\n  \n  insert into \n    _script_report_data (info) \n  SELECT \n    split_token(@_query_script_report_line, \'\n\', n)\n  FROM\n    numbers\n  WHERE \n    numbers.n BETWEEN 1 AND get_num_tokens(@_query_script_report_line, \'\n\')\n  ORDER BY \n    n ASC;\n\n  set @_query_script_report_line := NULL;\nend'),('common_schema','_script_report_finalize','PROCEDURE','_script_report_finalize','SQL','MODIFIES_SQL_DATA','YES','INVOKER','','','begin\n  call _script_report(\n    CONCAT(\'hr \', QUOTE(\'Report generated on \'), QUOTE(NOW()))\n  );\n\n  select info as `report` from _script_report_data order by id;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  call _script_report(\n    CONCAT(\'hr \', QUOTE(\'Report generated on \'), QUOTE(NOW()))\n  );\n\n  select info as `report` from _script_report_data order by id;\nend'),('common_schema','run','PROCEDURE','run','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n  in query_script text\n','','main_body: begin\n  if (LEFT(query_script, 1) in (\'/\', \'\\\\\')) and (LEFT(query_script, 2) != \'/*\') then\n    begin\n	  declare query_script_file_name text;  \n      \n      set query_script_file_name := query_script;\n      set query_script := LOAD_FILE(query_script_file_name);\n      if query_script is null then\n        call throw(CONCAT(\'Cannot load script file: \', query_script_file_name));\n      end if;\n    end;\n  end if;\n  call _interpret(query_script, TRUE);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Run given QueryScript text','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  if (LEFT(query_script, 1) in (\'/\', \'\\\')) and (LEFT(query_script, 2) != \'/*\') then\n    begin\n	  declare query_script_file_name text;  \n      \n      set query_script_file_name := query_script;\n      set query_script := LOAD_FILE(query_script_file_name);\n      if query_script is null then\n        call throw(CONCAT(\'Cannot load script file: \', query_script_file_name));\n      end if;\n    end;\n  end if;\n  call _interpret(query_script, TRUE);\nend'),('common_schema','_expect_state','PROCEDURE','_expect_state','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expected_states text charset utf8,\n   in   allow_trailing_states tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   out  matched_token text charset utf8\n','','main_body: begin\n  declare state_has_matched tinyint unsigned default FALSE;\n\n  call _consume_if_exists(id_from, id_to, consumed_to_id, NULL, expected_states, state_has_matched, matched_token);\n  if not state_has_matched then\n    call _throw_script_error(id_from, CONCAT(\'Expected \', REPLACE(expected_states, \'|\', \'/\')));\n  end if;\n  if not allow_trailing_states then\n    set id_from := consumed_to_id + 1;\n    call _expect_nothing(id_from, id_to);\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expects a state or raises error','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare state_has_matched tinyint unsigned default FALSE;\n\n  call _consume_if_exists(id_from, id_to, consumed_to_id, NULL, expected_states, state_has_matched, matched_token);\n  if not state_has_matched then\n    call _throw_script_error(id_from, CONCAT(\'Expected \', REPLACE(expected_states, \'|\', \'/\')));\n  end if;\n  if not allow_trailing_states then\n    set id_from := consumed_to_id + 1;\n    call _expect_nothing(id_from, id_to);\n  end if;\nend'),('common_schema','_expect_statement_delimiter','PROCEDURE','_expect_statement_delimiter','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   out  consumed_to_id int unsigned\n','','main_body: begin\n  call _expect_state(id_from, id_to, \'statement delimiter\', true, consumed_to_id, @_common_schema_dummy);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expects \";\" or raises error','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  call _expect_state(id_from, id_to, \'statement delimiter\', true, consumed_to_id, @_common_schema_dummy);\nend'),('common_schema','_expect_token','PROCEDURE','_expect_token','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expected_tokens text charset utf8,\n   in   allow_trailing tinyint unsigned,\n   out  consumed_to_id int unsigned,\n   out  matched_token text charset utf8\n','','main_body: begin\n  declare token_has_matched tinyint unsigned default FALSE;\n\n  call _consume_if_exists(id_from, id_to, consumed_to_id, expected_tokens, NULL, token_has_matched, matched_token);\n  if not token_has_matched then\n    call _throw_script_error(id_from, CONCAT(\'Expected \"\', REPLACE(expected_tokens, \'|\', \'/\'), \'\"\'));\n  end if;\n  if not allow_trailing then\n    set id_from := consumed_to_id + 1;\n    call _expect_nothing(id_from, id_to);\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expects a token or raises error','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare token_has_matched tinyint unsigned default FALSE;\n\n  call _consume_if_exists(id_from, id_to, consumed_to_id, expected_tokens, NULL, token_has_matched, matched_token);\n  if not token_has_matched then\n    call _throw_script_error(id_from, CONCAT(\'Expected \"\', REPLACE(expected_tokens, \'|\', \'/\'), \'\"\'));\n  end if;\n  if not allow_trailing then\n    set id_from := consumed_to_id + 1;\n    call _expect_nothing(id_from, id_to);\n  end if;\nend'),('common_schema','_match_states','PROCEDURE','_match_states','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   expected_states_list text charset utf8,\n   in	allow_spaces_between_states tinyint unsigned,\n   in	allow_trailing_states tinyint unsigned,\n   in   repeat_count int unsigned,\n   in   repeat_delimiter_state text charset utf8,\n   in	return_tokens_array_id tinyint unsigned,\n   in   throw_on_mismatch tinyint unsigned,\n   out  states_have_matched tinyint unsigned,\n   out  tokens_array_id VARCHAR(16) charset ascii,\n   out  single_matched_token text charset utf8,\n   out	consumed_to_id int unsigned\n','','main_body: begin\n  declare state_has_matched tinyint unsigned default FALSE;\n  declare num_states int unsigned default 0;\n  declare states_index int unsigned;\n  declare repeat_index int unsigned;\n  declare expected_states text charset utf8;\n  \n  if return_tokens_array_id then\n    call _create_array(tokens_array_id);\n  end if;\n\n  set num_states := get_num_tokens(expected_states_list, \',\');\n  if num_states = 0 then\n    call _throw_script_error(id_from, \'Internal error: num_states = 0 in _match_states\');\n  end if;\n  \n  \n  set states_have_matched := true;\n  set repeat_index := 1;\n  repeat_loop: while (repeat_index <= repeat_count) or (repeat_count = 0) do\n    call _skip_spaces(id_from, id_to);\n    set states_index := 1;\n\n    while states_index <= num_states do\n      \n      if allow_spaces_between_states then\n        call _skip_spaces(id_from, id_to);\n      else\n        \n        \n        call _skip_empty_spaces(id_from, id_to);\n      end if;\n      set expected_states := split_token(expected_states_list, \',\', states_index);\n\n      select token, FIND_IN_SET(state, REPLACE(expected_states, \'|\', \',\')) is true from _sql_tokens where id = id_from into single_matched_token, state_has_matched;\n      if state_has_matched then\n        set consumed_to_id := id_from;\n        if return_tokens_array_id then\n          call _push_array_element(tokens_array_id, single_matched_token);\n        end if;\n      else\n        set states_have_matched := false;\n        leave repeat_loop;\n      end if;\n      set id_from := id_from + 1;\n      \n      set states_index := states_index + 1;\n    end while;\n    \n    \n    if repeat_delimiter_state != \'whitespace\' then\n      \n      \n      call _skip_spaces(id_from, id_to);\n    end if;\n    if repeat_delimiter_state is not null then\n      select token, (state = repeat_delimiter_state) from _sql_tokens where id = id_from into @_common_schema_dummy, state_has_matched;\n      if not state_has_matched then\n        \n        \n        \n        \n        if (repeat_index < repeat_count) then\n          set states_have_matched := false;\n        end if;\n        leave repeat_loop;\n      end if;\n      set id_from := id_from + 1;\n    end if;\n    \n    set repeat_index := repeat_index + 1; \n  end while;\n\n  if states_have_matched then\n    \n    if allow_trailing_states then\n      \n      leave main_body;\n    end if;\n \n    \n    call _skip_spaces(id_from, id_to);\n    call _skip_end_of_statement(id_from, id_to);\n    if id_from <= id_to then\n      set states_have_matched := false;\n    end if;\n  end if;\n  \n  if not states_have_matched then\n    \n    if throw_on_mismatch then\n      call _throw_script_error(id_from, CONCAT(\'Expected \', REPLACE(expected_states, \'|\', \'/\')));\n    else\n      leave main_body;\n    end if;\n  end if;\n\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Expects a state or raises error','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare state_has_matched tinyint unsigned default FALSE;\n  declare num_states int unsigned default 0;\n  declare states_index int unsigned;\n  declare repeat_index int unsigned;\n  declare expected_states text charset utf8;\n  \n  if return_tokens_array_id then\n    call _create_array(tokens_array_id);\n  end if;\n\n  set num_states := get_num_tokens(expected_states_list, \',\');\n  if num_states = 0 then\n    call _throw_script_error(id_from, \'Internal error: num_states = 0 in _match_states\');\n  end if;\n  \n  \n  set states_have_matched := true;\n  set repeat_index := 1;\n  repeat_loop: while (repeat_index <= repeat_count) or (repeat_count = 0) do\n    call _skip_spaces(id_from, id_to);\n    set states_index := 1;\n\n    while states_index <= num_states do\n      \n      if allow_spaces_between_states then\n        call _skip_spaces(id_from, id_to);\n      else\n        \n        \n        call _skip_empty_spaces(id_from, id_to);\n      end if;\n      set expected_states := split_token(expected_states_list, \',\', states_index);\n\n      select token, FIND_IN_SET(state, REPLACE(expected_states, \'|\', \',\')) is true from _sql_tokens where id = id_from into single_matched_token, state_has_matched;\n      if state_has_matched then\n        set consumed_to_id := id_from;\n        if return_tokens_array_id then\n          call _push_array_element(tokens_array_id, single_matched_token);\n        end if;\n      else\n        set states_have_matched := false;\n        leave repeat_loop;\n      end if;\n      set id_from := id_from + 1;\n      \n      set states_index := states_index + 1;\n    end while;\n    \n    \n    if repeat_delimiter_state != \'whitespace\' then\n      \n      \n      call _skip_spaces(id_from, id_to);\n    end if;\n    if repeat_delimiter_state is not null then\n      select token, (state = repeat_delimiter_state) from _sql_tokens where id = id_from into @_common_schema_dummy, state_has_matched;\n      if not state_has_matched then\n        \n        \n        \n        \n        if (repeat_index < repeat_count) then\n          set states_have_matched := false;\n        end if;\n        leave repeat_loop;\n      end if;\n      set id_from := id_from + 1;\n    end if;\n    \n    set repeat_index := repeat_index + 1; \n  end while;\n\n  if states_have_matched then\n    \n    if allow_trailing_states then\n      \n      leave main_body;\n    end if;\n \n    \n    call _skip_spaces(id_from, id_to);\n    call _skip_end_of_statement(id_from, id_to);\n    if id_from <= id_to then\n      set states_have_matched := false;\n    end if;\n  end if;\n  \n  if not states_have_matched then\n    \n    if throw_on_mismatch then\n      call _throw_script_error(id_from, CONCAT(\'Expected \', REPLACE(expected_states, \'|\', \'/\')));\n    else\n      leave main_body;\n    end if;\n  end if;\n\nend'),('common_schema','_peek_states_list','PROCEDURE','_peek_states_list','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from					int unsigned,\n   in   id_to					int unsigned,\n   in   expected_states_list	text charset utf8,\n   in	allow_spaces			tinyint unsigned,\n   in	allow_trailing_states	tinyint unsigned,\n   in	return_tokens_array_id	tinyint unsigned,\n   out  tokens_array_id			varchar(16) charset ascii,\n   out	tokens_matched_to		int unsigned\n','','main_body: begin\n  declare states_have_matched tinyint unsigned default false;\n\n  call _match_states(id_from, id_to, expected_states_list, allow_spaces, allow_trailing_states, 1, null, return_tokens_array_id, false, states_have_matched, tokens_array_id, @_common_schema_dummy, tokens_matched_to);\n  if not states_have_matched then\n    set tokens_matched_to := 0;\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Check if given states list apply','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare states_have_matched tinyint unsigned default false;\n\n  call _match_states(id_from, id_to, expected_states_list, allow_spaces, allow_trailing_states, 1, null, return_tokens_array_id, false, states_have_matched, tokens_array_id, @_common_schema_dummy, tokens_matched_to);\n  if not states_have_matched then\n    set tokens_matched_to := 0;\n  end if;\nend'),('common_schema','_skip_end_of_statement','PROCEDURE','_skip_end_of_statement','SQL','READS_SQL_DATA','YES','INVOKER','\n   inout   id_from      int unsigned,\n   in   id_to      int unsigned\n','','main_body: begin\n	call _skip_states(id_from, id_to, \'statement delimiter,start\', null);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Skips enf of statement state','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n	call _skip_states(id_from, id_to, \'statement delimiter,start\', null);\nend'),('common_schema','_skip_states','PROCEDURE','_skip_states','SQL','READS_SQL_DATA','YES','INVOKER','\n   inout   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in	states_list text charset utf8,\n   in	tokens_list text charset utf8\n','','main_body: begin\n	set states_list := IFNULL(states_list, \'\');\n	set tokens_list := LOWER(IFNULL(tokens_list, \'\'));\n    select min(id) from _sql_tokens \n      where id >= id_from and id <= id_to \n      and FIND_IN_SET(state, states_list) = 0 \n      and FIND_IN_SET(LOWER(token), tokens_list) = 0 \n    into id_from;\n    if id_from is null then\n      set id_from := id_to + 1;\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Skips given states','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n	set states_list := IFNULL(states_list, \'\');\n	set tokens_list := LOWER(IFNULL(tokens_list, \'\'));\n    select min(id) from _sql_tokens \n      where id >= id_from and id <= id_to \n      and FIND_IN_SET(state, states_list) = 0 \n      and FIND_IN_SET(LOWER(token), tokens_list) = 0 \n    into id_from;\n    if id_from is null then\n      set id_from := id_to + 1;\n    end if;\nend'),('common_schema','_skip_tokens_and_spaces','PROCEDURE','_skip_tokens_and_spaces','SQL','READS_SQL_DATA','YES','INVOKER','\n   inout   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in	tokens_list text charset utf8\n','','main_body: begin\n    call _skip_states(id_from, id_to, \'whitespace,single line comment,multi line comment,start\', tokens_list);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Skips whitespace and given tokens','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    call _skip_states(id_from, id_to, \'whitespace,single line comment,multi line comment,start\', tokens_list);\nend'),('common_schema','_validate_statement_end','PROCEDURE','_validate_statement_end','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   out  id_end_statement int unsigned,\n   out	statement_delimiter_found tinyint unsigned\n','','main_body: begin\n  declare state_end_statement text charset utf8 default NULL;\n  \n  set id_end_statement := NULL;\n  \n  \n  SELECT id, state FROM _sql_tokens WHERE id > id_from AND id <= id_to AND state IN (\'statement delimiter\', \'left braces\') ORDER BY id ASC LIMIT 1 INTO id_end_statement, state_end_statement;\n  if state_end_statement = \'left braces\' then\n    call _throw_script_error(id_from, \'Missing \'\';\'\' statement delimiter\');\n  end if; \n  if id_end_statement IS NULL then\n    \n    set id_end_statement := id_to;\n  end if;\n  set statement_delimiter_found := (state_end_statement = \'statement delimiter\');\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Validates delimiter or end of block','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare state_end_statement text charset utf8 default NULL;\n  \n  set id_end_statement := NULL;\n  \n  \n  SELECT id, state FROM _sql_tokens WHERE id > id_from AND id <= id_to AND state IN (\'statement delimiter\', \'left braces\') ORDER BY id ASC LIMIT 1 INTO id_end_statement, state_end_statement;\n  if state_end_statement = \'left braces\' then\n    call _throw_script_error(id_from, \'Missing \';\' statement delimiter\');\n  end if; \n  if id_end_statement IS NULL then\n    \n    set id_end_statement := id_to;\n  end if;\n  set statement_delimiter_found := (state_end_statement = \'statement delimiter\');\nend'),('common_schema','_declare_and_assign_local_variable','PROCEDURE','_declare_and_assign_local_variable','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to        int unsigned,\n   in   statement_id_from      int unsigned,\n   in   assign_id    int unsigned,\n   in   statement_id_to      int unsigned,\n   in   depth int unsigned,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare set_expression text charset utf8;\n  declare set_statement text charset utf8;\n  declare declaration_is_new tinyint unsigned default 0;\n    \n  call _expect_state(statement_id_from, id_to, \'query_script variable\', true, @_common_schema_dummy, local_variable);\n\n  SELECT (COUNT(*) = 0) FROM _qs_variables WHERE declaration_id = id_from INTO declaration_is_new;\n  if declaration_is_new then\n    set user_defined_variable_name := CONCAT(\'@__qs_local_var_\', session_unique_id());\n    call _declare_local_variable(id_from, statement_id_to, id_to, depth, local_variable, user_defined_variable_name, TRUE);\n  end if;\n  \n  if should_execute_statement then\n    call _expand_statement_variables(assign_id+1, statement_id_to, set_expression, @_common_schema_dummy, should_execute_statement);\n  \n    \n    select CONCAT(\'SET \', mapped_user_defined_variable_name, \' := \', set_expression) from _qs_variables where variable_name = local_variable and declaration_depth = depth into set_statement;\n    call exec(set_statement);\n    \n    \n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Declares local variables','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare local_variable varchar(65) charset ascii;\n  declare user_defined_variable_name varchar(65) charset ascii;\n  declare set_expression text charset utf8;\n  declare set_statement text charset utf8;\n  declare declaration_is_new tinyint unsigned default 0;\n    \n  call _expect_state(statement_id_from, id_to, \'query_script variable\', true, @_common_schema_dummy, local_variable);\n\n  SELECT (COUNT(*) = 0) FROM _qs_variables WHERE declaration_id = id_from INTO declaration_is_new;\n  if declaration_is_new then\n    set user_defined_variable_name := CONCAT(\'@__qs_local_var_\', session_unique_id());\n    call _declare_local_variable(id_from, statement_id_to, id_to, depth, local_variable, user_defined_variable_name, TRUE);\n  end if;\n  \n  if should_execute_statement then\n    call _expand_statement_variables(assign_id+1, statement_id_to, set_expression, @_common_schema_dummy, should_execute_statement);\n  \n    \n    select CONCAT(\'SET \', mapped_user_defined_variable_name, \' := \', set_expression) from _qs_variables where variable_name = local_variable and declaration_depth = depth into set_statement;\n    call exec(set_statement);\n    \n    \n  end if;\nend'),('common_schema','_declare_local_variable','PROCEDURE','_declare_local_variable','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_variable_declaration      int unsigned,\n   in   id_from    int unsigned,\n   in   id_to      int unsigned,\n   in   depth int unsigned,\n   in	local_variable varchar(65) charset ascii,\n   in	user_defined_variable_name varchar(65) charset ascii,\n   in	throw_when_exists tinyint unsigned\n','','main_body: begin\n  \n  delete from _qs_variables WHERE variable_name = local_variable and ((scope_end_id < id_variable_declaration) or (declaration_id >= id_variable_declaration));\n\n  \n  \n  \n  \n  \n   \n  INSERT IGNORE INTO _qs_variables (variable_name, mapped_user_defined_variable_name, declaration_depth, declaration_id, scope_end_id) VALUES (local_variable, user_defined_variable_name, depth, id_variable_declaration, id_to);\n  if ROW_COUNT() = 0 and throw_when_exists then\n    call _throw_script_error(id_variable_declaration, CONCAT(\'Duplicate local variable: \', local_variable));\n  end if;\n  \n  \n\n  \n  \n  \nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Declare a local variable','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  \n  delete from _qs_variables WHERE variable_name = local_variable and ((scope_end_id < id_variable_declaration) or (declaration_id >= id_variable_declaration));\n\n  \n  \n  \n  \n  \n   \n  INSERT IGNORE INTO _qs_variables (variable_name, mapped_user_defined_variable_name, declaration_depth, declaration_id, scope_end_id) VALUES (local_variable, user_defined_variable_name, depth, id_variable_declaration, id_to);\n  if ROW_COUNT() = 0 and throw_when_exists then\n    call _throw_script_error(id_variable_declaration, CONCAT(\'Duplicate local variable: \', local_variable));\n  end if;\n  \n  \n\n  \n  \n  \nend'),('common_schema','_expand_statement_variables','PROCEDURE','_expand_statement_variables','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   out  expanded_statement text charset utf8,\n   out  expanded_variables_found tinyint unsigned,\n   in should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare expanded_variables TEXT CHARSET utf8;\n  \n  SELECT GROUP_CONCAT(DISTINCT _extract_expanded_query_script_variable_name(token)) from _sql_tokens where (id between id_from and id_to) and (state = \'expanded query_script variable\') INTO expanded_variables;\n  set expanded_variables_found := (expanded_variables IS NOT NULL); \n  if expanded_variables_found and should_execute_statement then\n    call _take_local_variables_snapshot(expanded_variables);\n  end if;\n  SELECT \n    GROUP_CONCAT(\n      case\n        when _qs_variables.mapped_user_defined_variable_name IS NOT NULL then\n          case\n            when state = \'expanded query_script variable\' then _qs_variables.value_snapshot  \n            else _qs_variables.mapped_user_defined_variable_name \n          end\n        else token \n      end \n      ORDER BY id SEPARATOR \'\'\n    ) \n  FROM \n    _sql_tokens \n    LEFT JOIN _qs_variables ON (\n      \n      (\n        (state = \'expanded query_script variable\' AND _extract_expanded_query_script_variable_name(token) = _qs_variables.variable_name)  \n        or (state = \'query_script variable\' AND token = _qs_variables.variable_name) \n      )\n      and (id_from between _qs_variables.declaration_id and _qs_variables.scope_end_id)\n    )\n  where \n    (id between id_from and id_to) \n  INTO \n    expanded_statement;\n  set expanded_statement := trim_wspace(expanded_statement);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns an expanded script statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare expanded_variables TEXT CHARSET utf8;\n  \n  SELECT GROUP_CONCAT(DISTINCT _extract_expanded_query_script_variable_name(token)) from _sql_tokens where (id between id_from and id_to) and (state = \'expanded query_script variable\') INTO expanded_variables;\n  set expanded_variables_found := (expanded_variables IS NOT NULL); \n  if expanded_variables_found and should_execute_statement then\n    call _take_local_variables_snapshot(expanded_variables);\n  end if;\n  SELECT \n    GROUP_CONCAT(\n      case\n        when _qs_variables.mapped_user_defined_variable_name IS NOT NULL then\n          case\n            when state = \'expanded query_script variable\' then _qs_variables.value_snapshot  \n            else _qs_variables.mapped_user_defined_variable_name \n          end\n        else token \n      end \n      ORDER BY id SEPARATOR \'\'\n    ) \n  FROM \n    _sql_tokens \n    LEFT JOIN _qs_variables ON (\n      \n      (\n        (state = \'expanded query_script variable\' AND _extract_expanded_query_script_variable_name(token) = _qs_variables.variable_name)  \n        or (state = \'query_script variable\' AND token = _qs_variables.variable_name) \n      )\n      and (id_from between _qs_variables.declaration_id and _qs_variables.scope_end_id)\n    )\n  where \n    (id between id_from and id_to) \n  INTO \n    expanded_statement;\n  set expanded_statement := trim_wspace(expanded_statement);\nend'),('common_schema','_extract_expanded_query_script_variable_name','FUNCTION','_extract_expanded_query_script_variable_name','SQL','NO_SQL','YES','INVOKER','\n	expanded_query_script_variable TEXT CHARSET ascii','text CHARSET ascii','begin\n  \n  if expanded_query_script_variable LIKE \':${%}\' then\n    return CONCAT(\'$\', SUBSTRING(expanded_query_script_variable, 4, CHAR_LENGTH(expanded_query_script_variable) - 4));\n  end if;\n  \n  if expanded_query_script_variable LIKE \':$%\' then\n    return SUBSTRING(expanded_query_script_variable, 2);\n  end if;\n  return NULL;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Get name of qs variable from expanded format','utf8','utf8_general_ci','utf8_general_ci','begin\n  \n  if expanded_query_script_variable LIKE \':${%}\' then\n    return CONCAT(\'$\', SUBSTRING(expanded_query_script_variable, 4, CHAR_LENGTH(expanded_query_script_variable) - 4));\n  end if;\n  \n  if expanded_query_script_variable LIKE \':$%\' then\n    return SUBSTRING(expanded_query_script_variable, 2);\n  end if;\n  return NULL;\nend'),('common_schema','_get_mxarray_max_key','FUNCTION','_get_mxarray_max_key','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned\n','int(10) unsigned','main_body: begin\n  return CAST(ExtractValue(@_common_schema_mx_array, CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]/maxkey\')) AS UNSIGNED);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','(internal) get array\'s current max key','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  return CAST(ExtractValue(@_common_schema_mx_array, CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]/maxkey\')) AS UNSIGNED);\nend'),('common_schema','_get_mxarray_size','FUNCTION','_get_mxarray_size','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned\n','int(10) unsigned','main_body: begin\n  return CAST(IFNULL(ExtractValue(@_common_schema_mx_array, CONCAT(\'count(/ma/a[@id=\"\', array_id, \'\"]/e)\')), 0) AS UNSIGNED);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return number of elements in indicated array','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  return CAST(IFNULL(ExtractValue(@_common_schema_mx_array, CONCAT(\'count(/ma/a[@id=\"\', array_id, \'\"]/e)\')), 0) AS UNSIGNED);\nend'),('common_schema','_mxarray_key_exists','FUNCTION','_mxarray_key_exists','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned,\n   array_key varchar(127) charset utf8\n','tinyint(3) unsigned','main_body: begin\n  declare xpath varchar(64) charset utf8;\n  set xpath := CONCAT(\'count(/ma/a[@id=\"\', array_id, \'\"]/e[@key=\"\', encode_xml(array_key), \'\"][1])\');\n  return (IFNULL(ExtractValue(@_common_schema_mx_array, xpath), 0) > 0);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Check whether key exists within array','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare xpath varchar(64) charset utf8;\n  set xpath := CONCAT(\'count(/ma/a[@id=\"\', array_id, \'\"]/e[@key=\"\', encode_xml(array_key), \'\"][1])\');\n  return (IFNULL(ExtractValue(@_common_schema_mx_array, xpath), 0) > 0);\nend'),('common_schema','_push_mxarray_element','FUNCTION','_push_mxarray_element','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned,\n   element text charset utf8\n','int(10) unsigned','main_body: begin\n  declare array_max_key int unsigned;\n  \n  if array_id is null then\n    return null;\n  end if;\n  \n  set array_max_key := _get_mxarray_max_key(array_id);\n  set @_common_schema_mx_array := REPLACE(@_common_schema_mx_array, CONCAT(\'<maxkey aid=\"\', array_id, \'\">\'), CONCAT(\'<e key=\"\', (array_max_key+1), \'\">\', encode_xml(element), \'</e><maxkey aid=\"\', array_id, \'\">\'));\n  do _update_mxarray_max_key(array_id, (array_max_key+1));\n  return (array_max_key+1);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Pushes new element into array','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare array_max_key int unsigned;\n  \n  if array_id is null then\n    return null;\n  end if;\n  \n  set array_max_key := _get_mxarray_max_key(array_id);\n  set @_common_schema_mx_array := REPLACE(@_common_schema_mx_array, CONCAT(\'<maxkey aid=\"\', array_id, \'\">\'), CONCAT(\'<e key=\"\', (array_max_key+1), \'\">\', encode_xml(element), \'</e><maxkey aid=\"\', array_id, \'\">\'));\n  do _update_mxarray_max_key(array_id, (array_max_key+1));\n  return (array_max_key+1);\nend'),('common_schema','_update_mxarray_max_key','FUNCTION','_update_mxarray_max_key','SQL','NO_SQL','YES','INVOKER','\n   array_id int unsigned,\n   array_max_key int unsigned\n','int(10) unsigned','main_body: begin\n  set @_common_schema_mx_array := UpdateXML(@_common_schema_mx_array, CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]/maxkey\'), CONCAT(\'<maxkey aid=\"\', array_id, \'\">\', array_max_key, \'</maxkey>\'));\n  return array_id;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','(internal) updated max-key indicator','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  set @_common_schema_mx_array := UpdateXML(@_common_schema_mx_array, CONCAT(\'/ma/a[@id=\"\', array_id, \'\"]/maxkey\'), CONCAT(\'<maxkey aid=\"\', array_id, \'\">\', array_max_key, \'</maxkey>\'));\n  return array_id;\nend'),('common_schema','_split','PROCEDURE','_split','SQL','MODIFIES_SQL_DATA','NO','INVOKER','\n  split_table_schema varchar(128), \n  split_table_name varchar(128),\n  split_options varchar(2048) charset utf8,\n  split_injected_action_statement TEXT CHARSET utf8, \n  split_injected_text TEXT CHARSET utf8,\n  in   id_from      int unsigned,\n  in   id_to      int unsigned,\n  in   expect_single tinyint unsigned,\n  out  consumed_to_id int unsigned,\n  in depth int unsigned,\n  in should_execute_statement tinyint unsigned\n  ','','main_body: begin\n  declare is_overflow tinyint unsigned;\n  declare is_empty_range tinyint unsigned;\n  declare deadlock_detected tinyint unsigned;\n  declare split_range_size int unsigned;\n  declare comparison_clause text charset utf8;\n  declare action_statement text charset utf8;\n  declare continue handler for 1205 SET deadlock_detected = TRUE;\n\n  set @_split_is_first_step_flag := true;\n  \n  call _split_generate_dependency_tables(split_table_schema, split_table_name);\n  call _split_deduce_columns(split_table_schema, split_table_name);\n  call _split_init_variables();\n  call _split_assign_min_max_variables(id_from, split_table_schema, split_table_name, split_options, is_empty_range);\n  \n  if is_empty_range then\n    leave main_body;\n  end if;\n  \n  call _split_assign_initial_range_start_variables();\n  \n  set @_query_script_split_step_index := 0;\n  set @_query_script_split_total_rowcount := 0;\n  set @query_script_split_start_time := SYSDATE();\n  \n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_columns\', \'@query_script_split_columns\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_min\', \'@query_script_split_min\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_max\', \'@query_script_split_max\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_clause\', \'@query_script_split_comparison_clause\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_step\', \'@query_script_split_step_index\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_range_start\', \'@query_script_split_range_start_snapshot\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_range_end\', \'@query_script_split_range_end_snapshot\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_rowcount\', \'@query_script_split_rowcount\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_total_rowcount\', \'@query_script_split_total_rowcount\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_total_elapsed_time\', \'@query_script_split_total_elapsed_time\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_table_schema\', \'@query_script_split_table_schema\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_table_name\', \'@query_script_split_table_name\', FALSE);\n  \n  set split_range_size := least(10000, greatest(100, floor(ifnull(get_option(split_options, \'size\'), 1000))));\n  _split_step_loop: loop\n    call _split_is_range_start_overflow(is_overflow);\n    if is_overflow and not @_split_is_first_step_flag then\n      leave _split_step_loop;\n    end if;\n    call _split_assign_range_end_variables(split_table_schema, split_table_name, split_range_size);\n    \n    \n    call _split_get_step_comparison_clause(comparison_clause);\n\n    set action_statement := REPLACE(split_injected_action_statement, split_injected_text, comparison_clause);\n\n    repeat\n      set deadlock_detected := false;\n      call exec_single(action_statement);\n      if deadlock_detected then\n        select \'deadlock detected...\' as msg;\n      end if;\n\n      set @_query_script_split_step_index := @_query_script_split_step_index + 1;\n      set @query_script_split_step_index := @_query_script_split_step_index;\n      set @query_script_split_rowcount := @common_schema_rowcount;\n      set @_query_script_split_total_rowcount := @_query_script_split_total_rowcount + GREATEST(@query_script_split_rowcount, 0);\n      set @query_script_split_total_rowcount := @_query_script_split_total_rowcount;\n      set @query_script_split_total_elapsed_time := TIMESTAMPDIFF(MICROSECOND, @query_script_split_start_time, SYSDATE())/1000000.0;\n      set @query_script_split_table_schema := split_table_schema;\n      set @query_script_split_table_name := split_table_name;\n      set @query_script_split_min := @_query_script_split_min;\n      set @query_script_split_max := @_query_script_split_max;\n      set @query_script_split_columns := @_query_script_split_columns;\n      call _split_set_step_clause_and_ranges_local_variables(comparison_clause);\n    \n      call _consume_statement(id_from, id_to, expect_single, consumed_to_id, depth, should_execute_statement);\n\n      if @_common_schema_script_break_type IS NOT NULL then\n        if @_common_schema_script_break_type = \'break\' then\n          set @_common_schema_script_break_type := NULL;\n        end if;\n        leave _split_step_loop;\n      end if;\n    until deadlock_detected = false\n    end repeat;\n\n    call _split_assign_next_range_start_variables();\n    set @_split_is_first_step_flag := false;\n  end loop;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','split values by columns...','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare is_overflow tinyint unsigned;\n  declare is_empty_range tinyint unsigned;\n  declare deadlock_detected tinyint unsigned;\n  declare split_range_size int unsigned;\n  declare comparison_clause text charset utf8;\n  declare action_statement text charset utf8;\n  declare continue handler for 1205 SET deadlock_detected = TRUE;\n\n  set @_split_is_first_step_flag := true;\n  \n  call _split_generate_dependency_tables(split_table_schema, split_table_name);\n  call _split_deduce_columns(split_table_schema, split_table_name);\n  call _split_init_variables();\n  call _split_assign_min_max_variables(id_from, split_table_schema, split_table_name, split_options, is_empty_range);\n  \n  if is_empty_range then\n    leave main_body;\n  end if;\n  \n  call _split_assign_initial_range_start_variables();\n  \n  set @_query_script_split_step_index := 0;\n  set @_query_script_split_total_rowcount := 0;\n  set @query_script_split_start_time := SYSDATE();\n  \n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_columns\', \'@query_script_split_columns\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_min\', \'@query_script_split_min\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_max\', \'@query_script_split_max\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_clause\', \'@query_script_split_comparison_clause\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_step\', \'@query_script_split_step_index\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_range_start\', \'@query_script_split_range_start_snapshot\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_range_end\', \'@query_script_split_range_end_snapshot\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_rowcount\', \'@query_script_split_rowcount\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_total_rowcount\', \'@query_script_split_total_rowcount\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_total_elapsed_time\', \'@query_script_split_total_elapsed_time\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_table_schema\', \'@query_script_split_table_schema\', FALSE);\n  call _declare_local_variable(id_from, id_from, id_to, depth, \'$split_table_name\', \'@query_script_split_table_name\', FALSE);\n  \n  set split_range_size := least(10000, greatest(100, floor(ifnull(get_option(split_options, \'size\'), 1000))));\n  _split_step_loop: loop\n    call _split_is_range_start_overflow(is_overflow);\n    if is_overflow and not @_split_is_first_step_flag then\n      leave _split_step_loop;\n    end if;\n    call _split_assign_range_end_variables(split_table_schema, split_table_name, split_range_size);\n    \n    \n    call _split_get_step_comparison_clause(comparison_clause);\n\n    set action_statement := REPLACE(split_injected_action_statement, split_injected_text, comparison_clause);\n\n    repeat\n      set deadlock_detected := false;\n      call exec_single(action_statement);\n      if deadlock_detected then\n        select \'deadlock detected...\' as msg;\n      end if;\n\n      set @_query_script_split_step_index := @_query_script_split_step_index + 1;\n      set @query_script_split_step_index := @_query_script_split_step_index;\n      set @query_script_split_rowcount := @common_schema_rowcount;\n      set @_query_script_split_total_rowcount := @_query_script_split_total_rowcount + GREATEST(@query_script_split_rowcount, 0);\n      set @query_script_split_total_rowcount := @_query_script_split_total_rowcount;\n      set @query_script_split_total_elapsed_time := TIMESTAMPDIFF(MICROSECOND, @query_script_split_start_time, SYSDATE())/1000000.0;\n      set @query_script_split_table_schema := split_table_schema;\n      set @query_script_split_table_name := split_table_name;\n      set @query_script_split_min := @_query_script_split_min;\n      set @query_script_split_max := @_query_script_split_max;\n      set @query_script_split_columns := @_query_script_split_columns;\n      call _split_set_step_clause_and_ranges_local_variables(comparison_clause);\n    \n      call _consume_statement(id_from, id_to, expect_single, consumed_to_id, depth, should_execute_statement);\n\n      if @_common_schema_script_break_type IS NOT NULL then\n        if @_common_schema_script_break_type = \'break\' then\n          set @_common_schema_script_break_type := NULL;\n        end if;\n        leave _split_step_loop;\n      end if;\n    until deadlock_detected = false\n    end repeat;\n\n    call _split_assign_next_range_start_variables();\n    set @_split_is_first_step_flag := false;\n  end loop;\nend'),('common_schema','_split_assign_initial_range_start_variables','PROCEDURE','_split_assign_initial_range_start_variables','SQL','READS_SQL_DATA','NO','INVOKER','','','begin\n  declare queries text default NULL;\n\n  select \n    GROUP_CONCAT(\n      \'set \', range_start_variable_name, \' := \', min_variable_name, \';\'\n      separator \'\'\n    )\n    from _split_column_names_table\n    into queries;\n    \n  call exec(queries);\n  \n  set @_split_column_variable_range_end_1 := NULL;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare queries text default NULL;\n\n  select \n    GROUP_CONCAT(\n      \'set \', range_start_variable_name, \' := \', min_variable_name, \';\'\n      separator \'\'\n    )\n    from _split_column_names_table\n    into queries;\n    \n  call exec(queries);\n  \n  set @_split_column_variable_range_end_1 := NULL;\nend'),('common_schema','_split_assign_min_max_variables','PROCEDURE','_split_assign_min_max_variables','SQL','READS_SQL_DATA','NO','INVOKER','\n  id_from      int unsigned,\n  split_table_schema varchar(128), \n  split_table_name varchar(128),\n  split_options varchar(2048) charset utf8,\n  out is_empty_range tinyint unsigned\n  ','','begin\n  declare query text default NULL;\n  declare manual_min_max_params_used tinyint unsigned default false;\n  declare column_names text default _split_get_columns_names();\n  declare columns_order_ascending_clause text default _split_get_columns_order_ascending_clause();\n  declare min_variables_names text default _split_get_min_variables_names();\n  declare columns_order_descending_clause text default _split_get_columns_order_descending_clause();\n  declare max_variables_names text default _split_get_max_variables_names();\n  declare columns_count tinyint unsigned default _split_get_columns_count();\n  \n  set is_empty_range := false;\n\n  set query := CONCAT(\n    \'select \', column_names, \' from \',\n    mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \n    \' order by \', columns_order_ascending_clause,\n    \' limit 1 \',\n    \' into \', min_variables_names\n  );\n  call exec_single(query);\n\n  set query := CONCAT(\n    \'select \', column_names, \' from \',\n    mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \n    \' order by \', columns_order_descending_clause,\n    \' limit 1 \',\n    \' into \', max_variables_names\n  );\n  call exec_single(query);\n  \n  if get_option(split_options, \'start\') is not null then\n    if columns_count = 1 then\n      set query := CONCAT(\n        \'set \', min_variables_names, \' := GREATEST(\', min_variables_names, \', \', QUOTE(get_option(split_options, \'start\')), \')\'\n      );\n      call exec_single(query);\n      set manual_min_max_params_used := true;\n    else\n      call _throw_script_error(id_from, \'Found \'\'start\'\' option, but this split uses multiple columns\');\n    end if;\n  end if;\n  if get_option(split_options, \'stop\') is not null then\n    if columns_count = 1 then\n      set query := CONCAT(\n        \'set \', max_variables_names, \' := LEAST(\', max_variables_names, \', \', QUOTE(get_option(split_options, \'stop\')), \')\'\n      );\n      call exec_single(query);\n      set manual_min_max_params_used := true;\n    else\n      call _throw_script_error(id_from, \'Found \'\'stop\'\' option, but this split uses multiple columns\');\n    end if;\n  end if;\n  if manual_min_max_params_used then\n    \n    \n    select \n      CONCAT(\n        \'SELECT (\',\n          min_variable_name, \' > \', max_variable_name,\n        \') INTO @_split_is_empty_range_result\'\n        )\n      from _split_column_names_table\n      into query;\n\n    call exec_single(query);\n    if @_split_is_empty_range_result then\n      set is_empty_range := true;\n    end if;\n    \n  end if;\n\n  \n  select \n    CONCAT(\n      \'SELECT (\',\n      GROUP_CONCAT(\n        min_variable_name, \' IS NULL\'\n        separator \' AND \'\n      ),\n      \') INTO @_split_is_empty_range_result\'\n      )\n    from _split_column_names_table\n    into query;\n\n  call exec_single(query);\n  if @_split_is_empty_range_result then\n    set is_empty_range := true;\n  end if;\n\n  \n  set @_query_script_split_min := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_min_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_min_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_min_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_min_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_min_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_min_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_min_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_min_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_min_9)), \'\')\n  ));\n  set @_query_script_split_max := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_max_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_max_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_max_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_max_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_max_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_max_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_max_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_max_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_max_9)), \'\')\n  ));\n  \nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare query text default NULL;\n  declare manual_min_max_params_used tinyint unsigned default false;\n  declare column_names text default _split_get_columns_names();\n  declare columns_order_ascending_clause text default _split_get_columns_order_ascending_clause();\n  declare min_variables_names text default _split_get_min_variables_names();\n  declare columns_order_descending_clause text default _split_get_columns_order_descending_clause();\n  declare max_variables_names text default _split_get_max_variables_names();\n  declare columns_count tinyint unsigned default _split_get_columns_count();\n  \n  set is_empty_range := false;\n\n  set query := CONCAT(\n    \'select \', column_names, \' from \',\n    mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \n    \' order by \', columns_order_ascending_clause,\n    \' limit 1 \',\n    \' into \', min_variables_names\n  );\n  call exec_single(query);\n\n  set query := CONCAT(\n    \'select \', column_names, \' from \',\n    mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \n    \' order by \', columns_order_descending_clause,\n    \' limit 1 \',\n    \' into \', max_variables_names\n  );\n  call exec_single(query);\n  \n  if get_option(split_options, \'start\') is not null then\n    if columns_count = 1 then\n      set query := CONCAT(\n        \'set \', min_variables_names, \' := GREATEST(\', min_variables_names, \', \', QUOTE(get_option(split_options, \'start\')), \')\'\n      );\n      call exec_single(query);\n      set manual_min_max_params_used := true;\n    else\n      call _throw_script_error(id_from, \'Found \'start\' option, but this split uses multiple columns\');\n    end if;\n  end if;\n  if get_option(split_options, \'stop\') is not null then\n    if columns_count = 1 then\n      set query := CONCAT(\n        \'set \', max_variables_names, \' := LEAST(\', max_variables_names, \', \', QUOTE(get_option(split_options, \'stop\')), \')\'\n      );\n      call exec_single(query);\n      set manual_min_max_params_used := true;\n    else\n      call _throw_script_error(id_from, \'Found \'stop\' option, but this split uses multiple columns\');\n    end if;\n  end if;\n  if manual_min_max_params_used then\n    \n    \n    select \n      CONCAT(\n        \'SELECT (\',\n          min_variable_name, \' > \', max_variable_name,\n        \') INTO @_split_is_empty_range_result\'\n        )\n      from _split_column_names_table\n      into query;\n\n    call exec_single(query);\n    if @_split_is_empty_range_result then\n      set is_empty_range := true;\n    end if;\n    \n  end if;\n\n  \n  select \n    CONCAT(\n      \'SELECT (\',\n      GROUP_CONCAT(\n        min_variable_name, \' IS NULL\'\n        separator \' AND \'\n      ),\n      \') INTO @_split_is_empty_range_result\'\n      )\n    from _split_column_names_table\n    into query;\n\n  call exec_single(query);\n  if @_split_is_empty_range_result then\n    set is_empty_range := true;\n  end if;\n\n  \n  set @_query_script_split_min := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_min_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_min_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_min_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_min_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_min_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_min_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_min_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_min_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_min_9)), \'\')\n  ));\n  set @_query_script_split_max := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_max_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_max_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_max_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_max_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_max_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_max_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_max_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_max_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_max_9)), \'\')\n  ));\n  \nend'),('common_schema','_split_assign_next_range_start_variables','PROCEDURE','_split_assign_next_range_start_variables','SQL','READS_SQL_DATA','NO','INVOKER','','','begin\n  declare queries text default NULL;\n\n  select \n    GROUP_CONCAT(\n      \'set \', range_start_variable_name, \' := \', range_end_variable_name, \';\'\n      separator \'\'\n    )\n    from _split_column_names_table\n    into queries;\n    \n  call exec(queries);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare queries text default NULL;\n\n  select \n    GROUP_CONCAT(\n      \'set \', range_start_variable_name, \' := \', range_end_variable_name, \';\'\n      separator \'\'\n    )\n    from _split_column_names_table\n    into queries;\n    \n  call exec(queries);\nend'),('common_schema','_split_assign_range_end_variables','PROCEDURE','_split_assign_range_end_variables','SQL','READS_SQL_DATA','NO','INVOKER','\n  split_table_schema varchar(128),\n  split_table_name varchar(128),\n  split_range_size int unsigned\n  ','','begin\n  declare query text default NULL;\n  declare column_names text default _split_get_columns_names();\n  \n  declare columns_order_ascending_clause text default _split_get_columns_order_ascending_clause();\n  declare range_end_variables_names text default _split_get_range_end_variables_names();\n  \n  declare columns_order_descending_clause text default _split_get_columns_order_descending_clause();\n  declare max_variables_names text default _split_get_max_variables_names();\n  \n  declare columns_count tinyint unsigned default _split_get_columns_count();\n  \n  declare as_of_range_start_comparison_clause text default _split_get_columns_comparison_clause(\'>\', \'range_start\', _split_is_first_step(), columns_count);\n  declare limit_by_max_comparison_clause text default _split_get_columns_comparison_clause(\'<\', \'max\', true, columns_count);\n\n  set query := CONCAT(\n    \'select \', column_names, \' from (\',\n      \'select \', column_names, \' from \',\n      mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \n      \' where \', as_of_range_start_comparison_clause,\n      \' and \', limit_by_max_comparison_clause,\n      \' order by \', columns_order_ascending_clause,\n      \' limit \', split_range_size,\n    \') sel_split_range \',\n    \' order by \', columns_order_descending_clause,\n    \' limit 1 \',\n    \' into \', range_end_variables_names\n  );\n  call exec_single(query);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare query text default NULL;\n  declare column_names text default _split_get_columns_names();\n  \n  declare columns_order_ascending_clause text default _split_get_columns_order_ascending_clause();\n  declare range_end_variables_names text default _split_get_range_end_variables_names();\n  \n  declare columns_order_descending_clause text default _split_get_columns_order_descending_clause();\n  declare max_variables_names text default _split_get_max_variables_names();\n  \n  declare columns_count tinyint unsigned default _split_get_columns_count();\n  \n  declare as_of_range_start_comparison_clause text default _split_get_columns_comparison_clause(\'>\', \'range_start\', _split_is_first_step(), columns_count);\n  declare limit_by_max_comparison_clause text default _split_get_columns_comparison_clause(\'<\', \'max\', true, columns_count);\n\n  set query := CONCAT(\n    \'select \', column_names, \' from (\',\n      \'select \', column_names, \' from \',\n      mysql_qualify(split_table_schema), \'.\', mysql_qualify(split_table_name), \n      \' where \', as_of_range_start_comparison_clause,\n      \' and \', limit_by_max_comparison_clause,\n      \' order by \', columns_order_ascending_clause,\n      \' limit \', split_range_size,\n    \') sel_split_range \',\n    \' order by \', columns_order_descending_clause,\n    \' limit 1 \',\n    \' into \', range_end_variables_names\n  );\n  call exec_single(query);\nend'),('common_schema','_split_deduce_columns','PROCEDURE','_split_deduce_columns','SQL','MODIFIES_SQL_DATA','NO','INVOKER','split_table_schema varchar(128), split_table_name varchar(128)','','begin\n  declare split_column_names varchar(2048) default NULL;\n  declare split_num_column tinyint unsigned;\n  \n  SELECT \n      column_names, count_column_in_index\n    FROM \n      _split_candidate_keys_recommended \n    WHERE \n      table_schema = split_table_schema AND table_name = split_table_name \n    INTO split_column_names, split_num_column;\n  if split_column_names is null then\n    call throw(CONCAT(\'split: no key or definition found for: \', split_table_schema, \'.\', split_table_name));\n  end if;\n  \n  drop temporary table if exists _split_column_names_table;\n  create temporary table _split_column_names_table (\n    column_order TINYINT UNSIGNED,\n    split_table_name varchar(128) charset utf8,\n    column_name VARCHAR(128) charset utf8,\n    min_variable_name VARCHAR(128) charset utf8,\n    max_variable_name VARCHAR(128) charset utf8,\n    range_start_variable_name VARCHAR(128) charset utf8,\n    range_end_variable_name VARCHAR(128) charset utf8\n  );\n  insert into _split_column_names_table\n    select\n      n,\n      split_table_name,\n      split_token(split_column_names, \',\', n),\n      CONCAT(\'@_split_column_variable_min_\', n),\n      CONCAT(\'@_split_column_variable_max_\', n),\n      CONCAT(\'@_split_column_variable_range_start_\', n),\n      CONCAT(\'@_split_column_variable_range_end_\', n)\n    from\n      numbers\n    where \n      n between 1 and split_num_column;\n  select\n    group_concat(mysql_qualify(column_name) order by column_order)\n  from\n    _split_column_names_table\n  into\n    @_query_script_split_columns;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','split values by columns...','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare split_column_names varchar(2048) default NULL;\n  declare split_num_column tinyint unsigned;\n  \n  SELECT \n      column_names, count_column_in_index\n    FROM \n      _split_candidate_keys_recommended \n    WHERE \n      table_schema = split_table_schema AND table_name = split_table_name \n    INTO split_column_names, split_num_column;\n  if split_column_names is null then\n    call throw(CONCAT(\'split: no key or definition found for: \', split_table_schema, \'.\', split_table_name));\n  end if;\n  \n  drop temporary table if exists _split_column_names_table;\n  create temporary table _split_column_names_table (\n    column_order TINYINT UNSIGNED,\n    split_table_name varchar(128) charset utf8,\n    column_name VARCHAR(128) charset utf8,\n    min_variable_name VARCHAR(128) charset utf8,\n    max_variable_name VARCHAR(128) charset utf8,\n    range_start_variable_name VARCHAR(128) charset utf8,\n    range_end_variable_name VARCHAR(128) charset utf8\n  );\n  insert into _split_column_names_table\n    select\n      n,\n      split_table_name,\n      split_token(split_column_names, \',\', n),\n      CONCAT(\'@_split_column_variable_min_\', n),\n      CONCAT(\'@_split_column_variable_max_\', n),\n      CONCAT(\'@_split_column_variable_range_start_\', n),\n      CONCAT(\'@_split_column_variable_range_end_\', n)\n    from\n      numbers\n    where \n      n between 1 and split_num_column;\n  select\n    group_concat(mysql_qualify(column_name) order by column_order)\n  from\n    _split_column_names_table\n  into\n    @_query_script_split_columns;\nend'),('common_schema','_split_generate_dependency_tables','PROCEDURE','_split_generate_dependency_tables','SQL','MODIFIES_SQL_DATA','NO','INVOKER','split_table_schema varchar(128), split_table_name varchar(128)','','begin\n  declare split_column_names varchar(2048) default NULL;\n  declare split_num_column tinyint unsigned;\n  \n  drop temporary table if exists _split_unique_keys;\n  create temporary table _split_unique_keys\n   SELECT\n      TABLE_SCHEMA,\n      TABLE_NAME,\n      INDEX_NAME,\n      COUNT(*) AS COUNT_COLUMN_IN_INDEX,\n      IF(SUM(NULLABLE = \'YES\') > 0, 1, 0) AS has_nullable,\n      IF(INDEX_NAME = \'PRIMARY\', 1, 0) AS is_primary,\n      GROUP_CONCAT(COLUMN_NAME ORDER BY SEQ_IN_INDEX ASC) AS COLUMN_NAMES,\n      SUBSTRING_INDEX(GROUP_CONCAT(COLUMN_NAME ORDER BY SEQ_IN_INDEX ASC), \',\', 1) AS FIRST_COLUMN_NAME\n    FROM INFORMATION_SCHEMA.STATISTICS\n    WHERE\n      TABLE_SCHEMA = split_table_schema\n      AND TABLE_NAME = split_table_name\n      AND NON_UNIQUE=0\n    GROUP BY TABLE_SCHEMA, TABLE_NAME, INDEX_NAME\n  ;\n  \n  drop temporary table if exists _split_i_s_columns;\n  create temporary table _split_i_s_columns\n   SELECT\n      TABLE_SCHEMA,\n      TABLE_NAME,\n      COLUMN_NAME,\n      DATA_TYPE,\n      CHARACTER_SET_NAME\n    FROM INFORMATION_SCHEMA.COLUMNS\n    WHERE\n      TABLE_SCHEMA = split_table_schema\n      AND TABLE_NAME = split_table_name\n  ;\n  \n  drop temporary table if exists _split_candidate_keys;\n  create temporary table _split_candidate_keys\n    SELECT\n      _split_i_s_columns.TABLE_SCHEMA AS table_schema,\n      _split_i_s_columns.TABLE_NAME AS table_name,\n      _split_unique_keys.INDEX_NAME AS index_name,\n      _split_unique_keys.has_nullable AS has_nullable,\n      _split_unique_keys.is_primary AS is_primary,\n      _split_unique_keys.COLUMN_NAMES AS column_names,\n      _split_unique_keys.COUNT_COLUMN_IN_INDEX AS count_column_in_index,\n      _split_i_s_columns.DATA_TYPE AS data_type,\n      _split_i_s_columns.CHARACTER_SET_NAME AS character_set_name,\n      (CASE IFNULL(CHARACTER_SET_NAME, \'\')\n          WHEN \'\' THEN 0\n          ELSE 1\n      END << 20\n      )\n      + (CASE LOWER(DATA_TYPE)\n        WHEN \'tinyint\' THEN 0\n        WHEN \'smallint\' THEN 1\n        WHEN \'int\' THEN 2\n        WHEN \'timestamp\' THEN 3\n        WHEN \'bigint\' THEN 4\n        WHEN \'datetime\' THEN 5\n        ELSE 9\n      END << 16\n      ) + (COUNT_COLUMN_IN_INDEX << 0\n      ) AS candidate_key_rank_in_table  \n    FROM \n      _split_i_s_columns\n      INNER JOIN _split_unique_keys ON (\n        _split_i_s_columns.TABLE_SCHEMA = _split_unique_keys.TABLE_SCHEMA AND\n        _split_i_s_columns.TABLE_NAME = _split_unique_keys.TABLE_NAME AND\n        _split_i_s_columns.COLUMN_NAME = _split_unique_keys.FIRST_COLUMN_NAME\n      )\n    ORDER BY   \n      _split_i_s_columns.TABLE_SCHEMA, _split_i_s_columns.TABLE_NAME, candidate_key_rank_in_table\n  ;\n  \n  drop temporary table if exists _split_candidate_keys_recommended;\n  create temporary table _split_candidate_keys_recommended\n    SELECT\n      table_schema,\n      table_name,	\n      SUBSTRING_INDEX(GROUP_CONCAT(index_name ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS recommended_index_name,\n      CAST(SUBSTRING_INDEX(GROUP_CONCAT(has_nullable ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS UNSIGNED INTEGER) AS has_nullable,\n      CAST(SUBSTRING_INDEX(GROUP_CONCAT(is_primary ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS UNSIGNED INTEGER) AS is_primary,\n      CAST(SUBSTRING_INDEX(GROUP_CONCAT(count_column_in_index ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS UNSIGNED INTEGER) AS count_column_in_index,\n      SUBSTRING_INDEX(GROUP_CONCAT(column_names ORDER BY candidate_key_rank_in_table ASC SEPARATOR \'\\n\'), \'\\n\', 1) AS column_names\n    FROM \n      _split_candidate_keys\n    GROUP BY\n      table_schema, table_name\n    ORDER BY   \n      table_schema, table_name\n    ;\n  \nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','split values by columns...','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare split_column_names varchar(2048) default NULL;\n  declare split_num_column tinyint unsigned;\n  \n  drop temporary table if exists _split_unique_keys;\n  create temporary table _split_unique_keys\n   SELECT\n      TABLE_SCHEMA,\n      TABLE_NAME,\n      INDEX_NAME,\n      COUNT(*) AS COUNT_COLUMN_IN_INDEX,\n      IF(SUM(NULLABLE = \'YES\') > 0, 1, 0) AS has_nullable,\n      IF(INDEX_NAME = \'PRIMARY\', 1, 0) AS is_primary,\n      GROUP_CONCAT(COLUMN_NAME ORDER BY SEQ_IN_INDEX ASC) AS COLUMN_NAMES,\n      SUBSTRING_INDEX(GROUP_CONCAT(COLUMN_NAME ORDER BY SEQ_IN_INDEX ASC), \',\', 1) AS FIRST_COLUMN_NAME\n    FROM INFORMATION_SCHEMA.STATISTICS\n    WHERE\n      TABLE_SCHEMA = split_table_schema\n      AND TABLE_NAME = split_table_name\n      AND NON_UNIQUE=0\n    GROUP BY TABLE_SCHEMA, TABLE_NAME, INDEX_NAME\n  ;\n  \n  drop temporary table if exists _split_i_s_columns;\n  create temporary table _split_i_s_columns\n   SELECT\n      TABLE_SCHEMA,\n      TABLE_NAME,\n      COLUMN_NAME,\n      DATA_TYPE,\n      CHARACTER_SET_NAME\n    FROM INFORMATION_SCHEMA.COLUMNS\n    WHERE\n      TABLE_SCHEMA = split_table_schema\n      AND TABLE_NAME = split_table_name\n  ;\n  \n  drop temporary table if exists _split_candidate_keys;\n  create temporary table _split_candidate_keys\n    SELECT\n      _split_i_s_columns.TABLE_SCHEMA AS table_schema,\n      _split_i_s_columns.TABLE_NAME AS table_name,\n      _split_unique_keys.INDEX_NAME AS index_name,\n      _split_unique_keys.has_nullable AS has_nullable,\n      _split_unique_keys.is_primary AS is_primary,\n      _split_unique_keys.COLUMN_NAMES AS column_names,\n      _split_unique_keys.COUNT_COLUMN_IN_INDEX AS count_column_in_index,\n      _split_i_s_columns.DATA_TYPE AS data_type,\n      _split_i_s_columns.CHARACTER_SET_NAME AS character_set_name,\n      (CASE IFNULL(CHARACTER_SET_NAME, \'\')\n          WHEN \'\' THEN 0\n          ELSE 1\n      END << 20\n      )\n      + (CASE LOWER(DATA_TYPE)\n        WHEN \'tinyint\' THEN 0\n        WHEN \'smallint\' THEN 1\n        WHEN \'int\' THEN 2\n        WHEN \'timestamp\' THEN 3\n        WHEN \'bigint\' THEN 4\n        WHEN \'datetime\' THEN 5\n        ELSE 9\n      END << 16\n      ) + (COUNT_COLUMN_IN_INDEX << 0\n      ) AS candidate_key_rank_in_table  \n    FROM \n      _split_i_s_columns\n      INNER JOIN _split_unique_keys ON (\n        _split_i_s_columns.TABLE_SCHEMA = _split_unique_keys.TABLE_SCHEMA AND\n        _split_i_s_columns.TABLE_NAME = _split_unique_keys.TABLE_NAME AND\n        _split_i_s_columns.COLUMN_NAME = _split_unique_keys.FIRST_COLUMN_NAME\n      )\n    ORDER BY   \n      _split_i_s_columns.TABLE_SCHEMA, _split_i_s_columns.TABLE_NAME, candidate_key_rank_in_table\n  ;\n  \n  drop temporary table if exists _split_candidate_keys_recommended;\n  create temporary table _split_candidate_keys_recommended\n    SELECT\n      table_schema,\n      table_name,	\n      SUBSTRING_INDEX(GROUP_CONCAT(index_name ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS recommended_index_name,\n      CAST(SUBSTRING_INDEX(GROUP_CONCAT(has_nullable ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS UNSIGNED INTEGER) AS has_nullable,\n      CAST(SUBSTRING_INDEX(GROUP_CONCAT(is_primary ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS UNSIGNED INTEGER) AS is_primary,\n      CAST(SUBSTRING_INDEX(GROUP_CONCAT(count_column_in_index ORDER BY candidate_key_rank_in_table ASC), \',\', 1) AS UNSIGNED INTEGER) AS count_column_in_index,\n      SUBSTRING_INDEX(GROUP_CONCAT(column_names ORDER BY candidate_key_rank_in_table ASC SEPARATOR \'\n\'), \'\n\', 1) AS column_names\n    FROM \n      _split_candidate_keys\n    GROUP BY\n      table_schema, table_name\n    ORDER BY   \n      table_schema, table_name\n    ;\n  \nend'),('common_schema','_split_get_columns_comparison_clause','FUNCTION','_split_get_columns_comparison_clause','SQL','READS_SQL_DATA','YES','INVOKER','\n    comparison_operator VARCHAR(3), \n    split_variable_type enum(\'range_start\', \'range_end\', \'max\'), \n    comparison_includes_equals TINYINT UNSIGNED,\n    num_split_columns TINYINT UNSIGNED','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select\n    group_concat(\'(\', partial_comparison, \')\' order by n separator \' OR \') as comparison\n  from (\n    select \n      n,\n      group_concat(\'(\', column_name, \' \', if(is_last, comparison_operator, \'=\'), \' \', variable_name, \')\' order by column_order separator \' AND \') as partial_comparison\n    from (\n      select \n        n, CONCAT(mysql_qualify(split_table_name), \'.\', mysql_qualify(column_name)) AS column_name,\n        case split_variable_type\n          when \'range_start\' then range_start_variable_name\n          when \'range_end\' then range_end_variable_name\n          when \'max\' then max_variable_name\n        end as variable_name,\n        _split_column_names_table.column_order, _split_column_names_table.column_order = n as is_last \n      from \n        numbers, _split_column_names_table \n      where \n        n between _split_column_names_table.column_order and num_split_columns \n      order by n, _split_column_names_table.column_order\n    ) s1\n    group by n\n  ) s2\n  into return_value\n  ;\n  \n  if comparison_includes_equals then\n    select\n      CONCAT(\n        return_value, \' OR (\',\n        GROUP_CONCAT(\n          \'(\', CONCAT(mysql_qualify(split_table_name), \'.\', mysql_qualify(column_name)), \' = \', \n          case split_variable_type\n            when \'range_start\' then range_start_variable_name\n            when \'range_end\' then range_end_variable_name\n            when \'max\' then max_variable_name\n          end,\n          \')\' order by column_order separator \' AND \'),\n        \')\'\n      )\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  end if;\n  set return_value := CONCAT(\'(\', return_value, \')\');\n\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select\n    group_concat(\'(\', partial_comparison, \')\' order by n separator \' OR \') as comparison\n  from (\n    select \n      n,\n      group_concat(\'(\', column_name, \' \', if(is_last, comparison_operator, \'=\'), \' \', variable_name, \')\' order by column_order separator \' AND \') as partial_comparison\n    from (\n      select \n        n, CONCAT(mysql_qualify(split_table_name), \'.\', mysql_qualify(column_name)) AS column_name,\n        case split_variable_type\n          when \'range_start\' then range_start_variable_name\n          when \'range_end\' then range_end_variable_name\n          when \'max\' then max_variable_name\n        end as variable_name,\n        _split_column_names_table.column_order, _split_column_names_table.column_order = n as is_last \n      from \n        numbers, _split_column_names_table \n      where \n        n between _split_column_names_table.column_order and num_split_columns \n      order by n, _split_column_names_table.column_order\n    ) s1\n    group by n\n  ) s2\n  into return_value\n  ;\n  \n  if comparison_includes_equals then\n    select\n      CONCAT(\n        return_value, \' OR (\',\n        GROUP_CONCAT(\n          \'(\', CONCAT(mysql_qualify(split_table_name), \'.\', mysql_qualify(column_name)), \' = \', \n          case split_variable_type\n            when \'range_start\' then range_start_variable_name\n            when \'range_end\' then range_end_variable_name\n            when \'max\' then max_variable_name\n          end,\n          \')\' order by column_order separator \' AND \'),\n        \')\'\n      )\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  end if;\n  set return_value := CONCAT(\'(\', return_value, \')\');\n\n  return return_value;\nEND'),('common_schema','_split_get_columns_count','FUNCTION','_split_get_columns_count','SQL','READS_SQL_DATA','YES','INVOKER','','tinyint(3) unsigned','BEGIN	\n  declare return_value TINYINT UNSIGNED;\n  \n  select \n      count(*)\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TINYINT UNSIGNED;\n  \n  select \n      count(*)\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_columns_names','FUNCTION','_split_get_columns_names','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(column_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(column_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_columns_order_ascending_clause','FUNCTION','_split_get_columns_order_ascending_clause','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(column_name, \' ASC\' order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(column_name, \' ASC\' order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_columns_order_descending_clause','FUNCTION','_split_get_columns_order_descending_clause','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(column_name, \' DESC\' order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(column_name, \' DESC\' order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_max_variables_names','FUNCTION','_split_get_max_variables_names','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(max_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(max_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_min_variables_names','FUNCTION','_split_get_min_variables_names','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(min_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(min_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_range_end_variables_names','FUNCTION','_split_get_range_end_variables_names','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(range_end_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(range_end_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_range_start_variables_names','FUNCTION','_split_get_range_start_variables_names','SQL','READS_SQL_DATA','YES','INVOKER','','text CHARSET utf8','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(range_start_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare return_value TEXT CHARSET utf8;\n  \n  select \n      group_concat(range_start_variable_name order by column_order separator \', \')\n    from\n      _split_column_names_table\n    into return_value\n    ;\n  return return_value;\nEND'),('common_schema','_split_get_step_comparison_clause','PROCEDURE','_split_get_step_comparison_clause','SQL','READS_SQL_DATA','YES','INVOKER','\n    out comparison_clause text charset utf8\n  ','','BEGIN	\n  declare columns_count tinyint unsigned default _split_get_columns_count();\n  declare range_start_comparison_clause text default _split_get_columns_comparison_clause(\'>\', \'range_start\', @_split_is_first_step_flag, columns_count);\n  declare range_end_comparison_clause text default _split_get_columns_comparison_clause(\'<\', \'range_end\', true, columns_count);\n\n  set comparison_clause := CONCAT(\n  	\'(\', range_start_comparison_clause, \' AND \', range_end_comparison_clause, \')\'\n  );\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  declare columns_count tinyint unsigned default _split_get_columns_count();\n  declare range_start_comparison_clause text default _split_get_columns_comparison_clause(\'>\', \'range_start\', @_split_is_first_step_flag, columns_count);\n  declare range_end_comparison_clause text default _split_get_columns_comparison_clause(\'<\', \'range_end\', true, columns_count);\n\n  set comparison_clause := CONCAT(\n  	\'(\', range_start_comparison_clause, \' AND \', range_end_comparison_clause, \')\'\n  );\nEND'),('common_schema','_split_init_variables','PROCEDURE','_split_init_variables','SQL','READS_SQL_DATA','NO','INVOKER','','','begin\n  declare queries text default NULL;\n\n  select \n    GROUP_CONCAT(\n      \'set \', min_variable_name, \' := NULL; \',\n      \'set \', max_variable_name, \' := NULL; \',\n      \'set \', range_start_variable_name, \' := NULL; \',\n      \'set \', range_end_variable_name, \' := NULL; \'\n      separator \'\'\n    )\n    from _split_column_names_table\n    into queries;\n    \n  call exec(queries);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare queries text default NULL;\n\n  select \n    GROUP_CONCAT(\n      \'set \', min_variable_name, \' := NULL; \',\n      \'set \', max_variable_name, \' := NULL; \',\n      \'set \', range_start_variable_name, \' := NULL; \',\n      \'set \', range_end_variable_name, \' := NULL; \'\n      separator \'\'\n    )\n    from _split_column_names_table\n    into queries;\n    \n  call exec(queries);\nend'),('common_schema','_split_is_empty_table','PROCEDURE','_split_is_empty_table','SQL','READS_SQL_DATA','NO','INVOKER','out is_empty_table tinyint unsigned','','begin\n  declare query text default NULL;\n\n  select \n    CONCAT(\n      \'SELECT (\',\n      GROUP_CONCAT(\n        min_variable_name, \' IS NULL\'\n        separator \' AND \'\n      ),\n      \') INTO @_split_is_empty_table_result\'\n      )\n    from _split_column_names_table\n    into query;\n\n  call exec_single(query);\n  set is_empty_table := @_split_is_empty_table_result;\nend','root@%','2012-11-28 18:22:30','2012-11-28 18:22:30','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare query text default NULL;\n\n  select \n    CONCAT(\n      \'SELECT (\',\n      GROUP_CONCAT(\n        min_variable_name, \' IS NULL\'\n        separator \' AND \'\n      ),\n      \') INTO @_split_is_empty_table_result\'\n      )\n    from _split_column_names_table\n    into query;\n\n  call exec_single(query);\n  set is_empty_table := @_split_is_empty_table_result;\nend'),('common_schema','_split_is_first_step','FUNCTION','_split_is_first_step','SQL','NO_SQL','NO','INVOKER','','tinyint(3) unsigned','begin\n  return @_split_is_first_step_flag;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  return @_split_is_first_step_flag;\nend'),('common_schema','_split_is_range_start_overflow','PROCEDURE','_split_is_range_start_overflow','SQL','READS_SQL_DATA','NO','INVOKER','out is_overflow tinyint unsigned','','begin\n  declare query text default NULL;\n\n  declare range_start_variables_names text default _split_get_range_start_variables_names();\n  declare max_variables_names text default _split_get_max_variables_names();\n\n  set query := CONCAT(\n    \'select (\', range_start_variables_names, \') >= (\', max_variables_names, \') into @_split_is_overflow\'\n  );\n  call exec_single(query);\n  set is_overflow := @_split_is_overflow;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare query text default NULL;\n\n  declare range_start_variables_names text default _split_get_range_start_variables_names();\n  declare max_variables_names text default _split_get_max_variables_names();\n\n  set query := CONCAT(\n    \'select (\', range_start_variables_names, \') >= (\', max_variables_names, \') into @_split_is_overflow\'\n  );\n  call exec_single(query);\n  set is_overflow := @_split_is_overflow;\nend'),('common_schema','_split_set_local_variable_step_comparison_clause','PROCEDURE','_split_set_local_variable_step_comparison_clause','SQL','READS_SQL_DATA','YES','INVOKER','\n    in comparison_clause text charset utf8\n  ','','BEGIN	\n  set @query_script_split_comparison_clause := comparison_clause;\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_1\', QUOTE((SELECT @_split_column_variable_range_start_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_2\', QUOTE((SELECT @_split_column_variable_range_start_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_3\', QUOTE((SELECT @_split_column_variable_range_start_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_4\', QUOTE((SELECT @_split_column_variable_range_start_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_5\', QUOTE((SELECT @_split_column_variable_range_start_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_6\', QUOTE((SELECT @_split_column_variable_range_start_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_7\', QUOTE((SELECT @_split_column_variable_range_start_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_8\', QUOTE((SELECT @_split_column_variable_range_start_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_9\', QUOTE((SELECT @_split_column_variable_range_start_9)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_1\', QUOTE((SELECT @_split_column_variable_range_end_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_2\', QUOTE((SELECT @_split_column_variable_range_end_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_3\', QUOTE((SELECT @_split_column_variable_range_end_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_4\', QUOTE((SELECT @_split_column_variable_range_end_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_5\', QUOTE((SELECT @_split_column_variable_range_end_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_6\', QUOTE((SELECT @_split_column_variable_range_end_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_7\', QUOTE((SELECT @_split_column_variable_range_end_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_8\', QUOTE((SELECT @_split_column_variable_range_end_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_9\', QUOTE((SELECT @_split_column_variable_range_end_9)));\nEND','root@%','2012-11-28 18:22:30','2012-11-28 18:22:30','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN	\n  set @query_script_split_comparison_clause := comparison_clause;\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_1\', QUOTE((SELECT @_split_column_variable_range_start_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_2\', QUOTE((SELECT @_split_column_variable_range_start_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_3\', QUOTE((SELECT @_split_column_variable_range_start_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_4\', QUOTE((SELECT @_split_column_variable_range_start_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_5\', QUOTE((SELECT @_split_column_variable_range_start_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_6\', QUOTE((SELECT @_split_column_variable_range_start_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_7\', QUOTE((SELECT @_split_column_variable_range_start_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_8\', QUOTE((SELECT @_split_column_variable_range_start_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_9\', QUOTE((SELECT @_split_column_variable_range_start_9)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_1\', QUOTE((SELECT @_split_column_variable_range_end_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_2\', QUOTE((SELECT @_split_column_variable_range_end_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_3\', QUOTE((SELECT @_split_column_variable_range_end_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_4\', QUOTE((SELECT @_split_column_variable_range_end_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_5\', QUOTE((SELECT @_split_column_variable_range_end_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_6\', QUOTE((SELECT @_split_column_variable_range_end_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_7\', QUOTE((SELECT @_split_column_variable_range_end_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_8\', QUOTE((SELECT @_split_column_variable_range_end_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_9\', QUOTE((SELECT @_split_column_variable_range_end_9)));\nEND'),('common_schema','_get_split_query_single_table','PROCEDURE','_get_split_query_single_table','SQL','READS_SQL_DATA','YES','INVOKER','\n   in  id_from      int unsigned,\n   in  id_to      int unsigned,\n   out query_type_supported tinyint unsigned,\n   out tables_found enum (\'none\', \'single\', \'multi\'),\n   out table_schema varchar(80) charset utf8, \n   out table_name varchar(80) charset utf8\n','','main_body: begin\n	declare split_query_type varchar(32) charset ascii;\n    declare table_definitions_found tinyint unsigned;\n    declare table_definitions_id_from int unsigned;\n    declare table_definitions_id_to int unsigned;\n    \n    set table_schema := null;\n    set table_name := null;\n\n    \n    call _get_split_query_type(id_from, id_to, split_query_type, @_common_schema_dummy, @_common_schema_dummy);\n    if split_query_type = \'unsupported\' then\n      set query_type_supported := false;\n      leave main_body;\n    end if;\n    set query_type_supported := true;\n\n    \n    call _get_split_query_table_definitions_clause(id_from, id_to, split_query_type, \n      table_definitions_found, table_definitions_id_from, table_definitions_id_to);\n    if not table_definitions_found then\n      set tables_found := \'none\';\n      leave main_body;\n    end if;\n    \n    \n    call _get_split_single_table_from_table_definitions(\n      table_definitions_id_from,\n      table_definitions_id_to,\n      tables_found,\n      table_schema,\n      table_name\n      );\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n	declare split_query_type varchar(32) charset ascii;\n    declare table_definitions_found tinyint unsigned;\n    declare table_definitions_id_from int unsigned;\n    declare table_definitions_id_to int unsigned;\n    \n    set table_schema := null;\n    set table_name := null;\n\n    \n    call _get_split_query_type(id_from, id_to, split_query_type, @_common_schema_dummy, @_common_schema_dummy);\n    if split_query_type = \'unsupported\' then\n      set query_type_supported := false;\n      leave main_body;\n    end if;\n    set query_type_supported := true;\n\n    \n    call _get_split_query_table_definitions_clause(id_from, id_to, split_query_type, \n      table_definitions_found, table_definitions_id_from, table_definitions_id_to);\n    if not table_definitions_found then\n      set tables_found := \'none\';\n      leave main_body;\n    end if;\n    \n    \n    call _get_split_single_table_from_table_definitions(\n      table_definitions_id_from,\n      table_definitions_id_to,\n      tables_found,\n      table_schema,\n      table_name\n      );\nend'),('common_schema','_get_split_query_table_definitions_clause','PROCEDURE','_get_split_query_table_definitions_clause','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   split_query_type enum (\n     \'unsupported\', \'delete\', \'update\', \'select\', \'insert_select\', \'replace_select\'),\n   out	table_definitions_found tinyint unsigned,\n   out	table_definitions_id_from int unsigned,\n   out	table_definitions_id_to   int unsigned\n','','main_body: begin\n    declare statement_level int unsigned;\n\n    declare starting_id int unsigned;\n    declare terminating_id int unsigned;\n    declare following_select_id int unsigned;\n    \n    set table_definitions_found := false;\n    set table_definitions_id_from := null;\n    set table_definitions_id_to := null;\n    \n    if split_query_type = \'unsupported\' then\n      leave main_body;\n    end if;\n    \n    select level from _sql_tokens where id = id_from into statement_level;\n\n    if split_query_type = \'update\' then\n      select MIN(id) from _sql_tokens where (id between id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'set\' into terminating_id;\n      if terminating_id is not null then\n        set table_definitions_found := true;\n        set table_definitions_id_from := id_from + 1;\n        set table_definitions_id_to := terminating_id - 1;\n      end if;\n      leave main_body;    \n    end if;\n\n    if split_query_type = \'delete\' then\n      \n      select MIN(id) from _sql_tokens where (id between id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'from\' into starting_id;\n      if starting_id is not null then\n        set table_definitions_found := true;\n        set table_definitions_id_from := starting_id + 1;\n        \n        select MIN(id) from _sql_tokens where (id between table_definitions_id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'using\' into starting_id;\n        if starting_id is not null then\n          set table_definitions_id_from := starting_id + 1;\n        end if;\n        \n        select MIN(id) from _sql_tokens where (id between table_definitions_id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) in (\'where\', \'order\', \'limit\') into terminating_id;\n        if terminating_id is not null then\n          set table_definitions_id_to := terminating_id - 1;\n        else\n          set table_definitions_id_to := id_to;\n        end if;\n      end if;\n      leave main_body;    \n    end if;\n\n    if split_query_type in (\'insert_select\', \'replace_select\') then\n      \n      \n      \n      set split_query_type := \'select\';\n    end if;\n\n    if split_query_type = \'select\' then\n      \n      select MIN(id) from _sql_tokens where (id between id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'from\' into starting_id;\n      if starting_id is not null then\n        set table_definitions_found := true;\n        set table_definitions_id_from := starting_id + 1;\n        \n        select MIN(id) from _sql_tokens where (id between table_definitions_id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) in (\'where\', \'group\', \'having\', \'order\', \'limit\', \'procedure\', \'into\', \'for\', \'lock\') into terminating_id;\n        if terminating_id is not null then\n          set table_definitions_id_to := terminating_id - 1;\n        else\n          set table_definitions_id_to := id_to;\n        end if;\n      end if;\n      leave main_body;    \n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Get type of query supported by split() statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare statement_level int unsigned;\n\n    declare starting_id int unsigned;\n    declare terminating_id int unsigned;\n    declare following_select_id int unsigned;\n    \n    set table_definitions_found := false;\n    set table_definitions_id_from := null;\n    set table_definitions_id_to := null;\n    \n    if split_query_type = \'unsupported\' then\n      leave main_body;\n    end if;\n    \n    select level from _sql_tokens where id = id_from into statement_level;\n\n    if split_query_type = \'update\' then\n      select MIN(id) from _sql_tokens where (id between id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'set\' into terminating_id;\n      if terminating_id is not null then\n        set table_definitions_found := true;\n        set table_definitions_id_from := id_from + 1;\n        set table_definitions_id_to := terminating_id - 1;\n      end if;\n      leave main_body;    \n    end if;\n\n    if split_query_type = \'delete\' then\n      \n      select MIN(id) from _sql_tokens where (id between id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'from\' into starting_id;\n      if starting_id is not null then\n        set table_definitions_found := true;\n        set table_definitions_id_from := starting_id + 1;\n        \n        select MIN(id) from _sql_tokens where (id between table_definitions_id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'using\' into starting_id;\n        if starting_id is not null then\n          set table_definitions_id_from := starting_id + 1;\n        end if;\n        \n        select MIN(id) from _sql_tokens where (id between table_definitions_id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) in (\'where\', \'order\', \'limit\') into terminating_id;\n        if terminating_id is not null then\n          set table_definitions_id_to := terminating_id - 1;\n        else\n          set table_definitions_id_to := id_to;\n        end if;\n      end if;\n      leave main_body;    \n    end if;\n\n    if split_query_type in (\'insert_select\', \'replace_select\') then\n      \n      \n      \n      set split_query_type := \'select\';\n    end if;\n\n    if split_query_type = \'select\' then\n      \n      select MIN(id) from _sql_tokens where (id between id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) = \'from\' into starting_id;\n      if starting_id is not null then\n        set table_definitions_found := true;\n        set table_definitions_id_from := starting_id + 1;\n        \n        select MIN(id) from _sql_tokens where (id between table_definitions_id_from and id_to) and level = statement_level and state = \'alpha\' and LOWER(token) in (\'where\', \'group\', \'having\', \'order\', \'limit\', \'procedure\', \'into\', \'for\', \'lock\') into terminating_id;\n        if terminating_id is not null then\n          set table_definitions_id_to := terminating_id - 1;\n        else\n          set table_definitions_id_to := id_to;\n        end if;\n      end if;\n      leave main_body;    \n    end if;\nend'),('common_schema','_get_split_query_type','PROCEDURE','_get_split_query_type','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   out  split_query_type enum (\n     \'unsupported\', \'delete\', \'update\', \'select\', \'insert_select\', \'replace_select\'),\n   out  split_query_id_from int unsigned,\n   out  split_query_following_select_id int unsigned\n','','main_body: begin\n    declare statement_level int unsigned;\n    declare statement_type tinytext charset utf8 default null;\n    \n    set split_query_type := \'unsupported\';\n    set split_query_following_select_id := null;\n    \n    call _skip_spaces(id_from, id_to);\n    SELECT id, level, LOWER(token) FROM _sql_tokens WHERE id = id_from AND state = \'alpha\' INTO split_query_id_from, statement_level, statement_type;\n    \n	if statement_type in (\'insert\', \'replace\') then\n      SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND id <= id_to AND level = statement_level AND state = \'alpha\' AND LOWER(token) = \'select\' INTO split_query_following_select_id;\n    end if;\n    \n    if statement_type = \'delete\' then\n      set split_query_type := \'delete\';\n    elseif statement_type = \'update\' then\n      set split_query_type := \'update\';\n    elseif statement_type = \'select\' then\n      set split_query_type := \'select\';\n    elseif statement_type = \'insert\' and split_query_following_select_id is not null then\n      set split_query_type := \'insert_select\';\n    elseif statement_type = \'replace\' and split_query_following_select_id is not null then\n      set split_query_type := \'replace_select\';\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Get type of query supported by split() statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare statement_level int unsigned;\n    declare statement_type tinytext charset utf8 default null;\n    \n    set split_query_type := \'unsupported\';\n    set split_query_following_select_id := null;\n    \n    call _skip_spaces(id_from, id_to);\n    SELECT id, level, LOWER(token) FROM _sql_tokens WHERE id = id_from AND state = \'alpha\' INTO split_query_id_from, statement_level, statement_type;\n    \n	if statement_type in (\'insert\', \'replace\') then\n      SELECT MIN(id) FROM _sql_tokens WHERE id > id_from AND id <= id_to AND level = statement_level AND state = \'alpha\' AND LOWER(token) = \'select\' INTO split_query_following_select_id;\n    end if;\n    \n    if statement_type = \'delete\' then\n      set split_query_type := \'delete\';\n    elseif statement_type = \'update\' then\n      set split_query_type := \'update\';\n    elseif statement_type = \'select\' then\n      set split_query_type := \'select\';\n    elseif statement_type = \'insert\' and split_query_following_select_id is not null then\n      set split_query_type := \'insert_select\';\n    elseif statement_type = \'replace\' and split_query_following_select_id is not null then\n      set split_query_type := \'replace_select\';\n    end if;\nend'),('common_schema','_get_split_single_table_from_table_definitions','PROCEDURE','_get_split_single_table_from_table_definitions','SQL','READS_SQL_DATA','YES','INVOKER','\n   in  id_from      int unsigned,\n   in  id_to      int unsigned,\n   out tables_found enum (\'none\', \'single\', \'multi\'),\n   out table_schema varchar(80) charset utf8, \n   out table_name varchar(80) charset utf8\n','','main_body: begin\n    declare statement_level int unsigned;\n	declare multi_table_indicator_id int unsigned;\n    declare tokens_array_id int unsigned;\n    declare peek_match_to int unsigned;\n     \n    set table_schema := null;\n    set table_name := null;\n    set tables_found := \'none\';\n    \n    select level from _sql_tokens where id = id_from into statement_level;\n    \n    \n    \n    select MIN(id) from _sql_tokens where \n      (id between id_from and id_to) \n      and (\n        ((state = \'comma\') and (level = statement_level))\n        or \n        ((state = \'alpha\') and (LOWER(token) in (\'join\', \'straight_join\')) and (level = statement_level))\n        or \n        ((state = \'left parenthesis\') and (level = statement_level + 1))\n      )\n      into multi_table_indicator_id;\n      \n    if multi_table_indicator_id is not null then\n       set tables_found := \'multi\';\n       leave main_body;\n    end if;\n    \n    \n    \n    \n    \n    \n    \n\n    call _skip_tokens_and_spaces(id_from, id_to, \'ignore,low_priority\');\n    call _peek_states_list(id_from, id_to, \'alpha|alphanum|quoted identifier|expanded query_script variable,dot,alpha|alphanum|quoted identifier|expanded query_script variable\', false, false, true, tokens_array_id, peek_match_to);\n    if peek_match_to > 0 then\n      call _get_array_element(tokens_array_id, \'1\', table_schema);		\n      call _get_array_element(tokens_array_id, \'3\', table_name);\n      set table_schema := unquote(table_schema);\n      set table_name := unquote(table_name);\n      set tables_found := \'single\';\n    end if;\n    call _drop_array(tokens_array_id);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Get table_schema, table_name from table definitions clause','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare statement_level int unsigned;\n	declare multi_table_indicator_id int unsigned;\n    declare tokens_array_id int unsigned;\n    declare peek_match_to int unsigned;\n     \n    set table_schema := null;\n    set table_name := null;\n    set tables_found := \'none\';\n    \n    select level from _sql_tokens where id = id_from into statement_level;\n    \n    \n    \n    select MIN(id) from _sql_tokens where \n      (id between id_from and id_to) \n      and (\n        ((state = \'comma\') and (level = statement_level))\n        or \n        ((state = \'alpha\') and (LOWER(token) in (\'join\', \'straight_join\')) and (level = statement_level))\n        or \n        ((state = \'left parenthesis\') and (level = statement_level + 1))\n      )\n      into multi_table_indicator_id;\n      \n    if multi_table_indicator_id is not null then\n       set tables_found := \'multi\';\n       leave main_body;\n    end if;\n    \n    \n    \n    \n    \n    \n    \n\n    call _skip_tokens_and_spaces(id_from, id_to, \'ignore,low_priority\');\n    call _peek_states_list(id_from, id_to, \'alpha|alphanum|quoted identifier|expanded query_script variable,dot,alpha|alphanum|quoted identifier|expanded query_script variable\', false, false, true, tokens_array_id, peek_match_to);\n    if peek_match_to > 0 then\n      call _get_array_element(tokens_array_id, \'1\', table_schema);		\n      call _get_array_element(tokens_array_id, \'3\', table_name);\n      set table_schema := unquote(table_schema);\n      set table_name := unquote(table_name);\n      set tables_found := \'single\';\n    end if;\n    call _drop_array(tokens_array_id);\nend'),('common_schema','_inject_split_where_token','PROCEDURE','_inject_split_where_token','SQL','READS_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   id_to      int unsigned,\n   in   split_injected_text tinytext charset utf8,\n   in   should_execute_statement tinyint unsigned,\n   out  split_injected_action_statement text charset utf8\n','','main_body: begin\n    declare statement_level int unsigned;\n    declare id_where_clause int unsigned default NULL; \n    declare id_where_clause_end int unsigned default NULL; \n    declare id_end_split_table_declaration int unsigned default NULL;\n    declare query_part_prefix text charset utf8 default \'\';\n    declare query_part_where_clause text charset utf8 default \'\';\n    declare query_part_suffix text charset utf8 default \'\';\n 	declare split_query_type varchar(32) charset ascii;\n 	declare split_query_id_from int unsigned;\n    declare split_query_following_select_id int unsigned;\n   \n    call _skip_spaces(id_from, id_to);\n    SELECT level FROM _sql_tokens WHERE id = id_from INTO statement_level;\n    \n    \n    call _get_split_query_type(id_from, id_to, split_query_type, split_query_id_from, split_query_following_select_id);\n    \n    if split_query_type = \'unsupported\' then\n      call _throw_script_error(id_from, \'split(): unsupported query type\');\n    end if;\n\n    SELECT \n      MIN(id) FROM _sql_tokens \n      WHERE \n        level = statement_level AND state = \'alpha\' and LOWER(token) = \'where\' \n        AND id between id_from and id_to\n      INTO id_where_clause;\n    if id_where_clause is NULL then\n      \n      \n\n      \n      \n      \n      SELECT \n        MIN(id) FROM _sql_tokens \n        WHERE \n          level = statement_level \n          AND state = \'alpha\' and LOWER(token) IN (\'group\', \'having\', \'order\', \'limit\', \'into\') \n          AND id between GREATEST(id_from, split_query_id_from, IFNULL(split_query_following_select_id, split_query_id_from)) and id_to\n        INTO id_where_clause_end;\n      if id_where_clause_end is NULL then\n        \n        call _expand_statement_variables(id_from, id_to, query_part_prefix, @common_schema_dummy, should_execute_statement);\n      else\n        \n        \n        call _expand_statement_variables(id_from, id_where_clause_end - 1, query_part_prefix, @common_schema_dummy, should_execute_statement);\n        call _expand_statement_variables(id_where_clause_end, id_to, query_part_suffix, @common_schema_dummy, should_execute_statement);\n      end if;\n      \n      set split_injected_action_statement := CONCAT(\n          query_part_prefix, \' WHERE \', split_injected_text, \' \', query_part_suffix\n        );\n    else\n      \n      call _expand_statement_variables(id_from, id_where_clause, query_part_prefix, @common_schema_dummy, should_execute_statement);\n      \n      SELECT \n        MIN(id) FROM _sql_tokens \n        WHERE \n          level = statement_level \n          AND state = \'alpha\' and LOWER(token) IN (\'group\', \'having\', \'order\', \'limit\', \'into\') \n          AND id between id_from and id_to\n          AND id > id_where_clause\n        INTO id_where_clause_end;\n      if id_where_clause_end is NULL then\n        \n        \n        call _expand_statement_variables(id_where_clause + 1, id_to, query_part_where_clause, @common_schema_dummy, should_execute_statement);\n      else\n        call _expand_statement_variables(id_where_clause + 1, id_where_clause_end - 1, query_part_where_clause, @common_schema_dummy, should_execute_statement);\n        call _expand_statement_variables(id_where_clause_end, id_to, query_part_suffix, @common_schema_dummy, should_execute_statement);\n      end if;\n      \n      set split_injected_action_statement := CONCAT(\n          query_part_prefix, \' (\', query_part_where_clause, \') AND \', split_injected_text, \' \', query_part_suffix\n        );\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Injects a magical token into the WHERE statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    declare statement_level int unsigned;\n    declare id_where_clause int unsigned default NULL; \n    declare id_where_clause_end int unsigned default NULL; \n    declare id_end_split_table_declaration int unsigned default NULL;\n    declare query_part_prefix text charset utf8 default \'\';\n    declare query_part_where_clause text charset utf8 default \'\';\n    declare query_part_suffix text charset utf8 default \'\';\n 	declare split_query_type varchar(32) charset ascii;\n 	declare split_query_id_from int unsigned;\n    declare split_query_following_select_id int unsigned;\n   \n    call _skip_spaces(id_from, id_to);\n    SELECT level FROM _sql_tokens WHERE id = id_from INTO statement_level;\n    \n    \n    call _get_split_query_type(id_from, id_to, split_query_type, split_query_id_from, split_query_following_select_id);\n    \n    if split_query_type = \'unsupported\' then\n      call _throw_script_error(id_from, \'split(): unsupported query type\');\n    end if;\n\n    SELECT \n      MIN(id) FROM _sql_tokens \n      WHERE \n        level = statement_level AND state = \'alpha\' and LOWER(token) = \'where\' \n        AND id between id_from and id_to\n      INTO id_where_clause;\n    if id_where_clause is NULL then\n      \n      \n\n      \n      \n      \n      SELECT \n        MIN(id) FROM _sql_tokens \n        WHERE \n          level = statement_level \n          AND state = \'alpha\' and LOWER(token) IN (\'group\', \'having\', \'order\', \'limit\', \'into\') \n          AND id between GREATEST(id_from, split_query_id_from, IFNULL(split_query_following_select_id, split_query_id_from)) and id_to\n        INTO id_where_clause_end;\n      if id_where_clause_end is NULL then\n        \n        call _expand_statement_variables(id_from, id_to, query_part_prefix, @common_schema_dummy, should_execute_statement);\n      else\n        \n        \n        call _expand_statement_variables(id_from, id_where_clause_end - 1, query_part_prefix, @common_schema_dummy, should_execute_statement);\n        call _expand_statement_variables(id_where_clause_end, id_to, query_part_suffix, @common_schema_dummy, should_execute_statement);\n      end if;\n      \n      set split_injected_action_statement := CONCAT(\n          query_part_prefix, \' WHERE \', split_injected_text, \' \', query_part_suffix\n        );\n    else\n      \n      call _expand_statement_variables(id_from, id_where_clause, query_part_prefix, @common_schema_dummy, should_execute_statement);\n      \n      SELECT \n        MIN(id) FROM _sql_tokens \n        WHERE \n          level = statement_level \n          AND state = \'alpha\' and LOWER(token) IN (\'group\', \'having\', \'order\', \'limit\', \'into\') \n          AND id between id_from and id_to\n          AND id > id_where_clause\n        INTO id_where_clause_end;\n      if id_where_clause_end is NULL then\n        \n        \n        call _expand_statement_variables(id_where_clause + 1, id_to, query_part_where_clause, @common_schema_dummy, should_execute_statement);\n      else\n        call _expand_statement_variables(id_where_clause + 1, id_where_clause_end - 1, query_part_where_clause, @common_schema_dummy, should_execute_statement);\n        call _expand_statement_variables(id_where_clause_end, id_to, query_part_suffix, @common_schema_dummy, should_execute_statement);\n      end if;\n      \n      set split_injected_action_statement := CONCAT(\n          query_part_prefix, \' (\', query_part_where_clause, \') AND \', split_injected_text, \' \', query_part_suffix\n        );\n    end if;\nend'),('common_schema','_is_options_format','FUNCTION','_is_options_format','SQL','NO_SQL','YES','INVOKER','options TEXT CHARSET utf8','tinyint(3) unsigned','begin\n  if options is null then\n    return false;\n  end if;\n  return (trim_wspace(options) RLIKE \'^{.*}$\') is true;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return value of option in JS options format','utf8','utf8_general_ci','utf8_general_ci','begin\n  if options is null then\n    return false;\n  end if;\n  return (trim_wspace(options) RLIKE \'^{.*}$\') is true;\nend'),('common_schema','extract_json_value','FUNCTION','extract_json_value','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n    json_text text charset utf8,\n    xpath text charset utf8\n','text CHARSET utf8','begin\n  return ExtractValue(json_to_xml(json_text), xpath);	\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Extracts JSON value via XPath','utf8','utf8_general_ci','utf8_general_ci','begin\n  return ExtractValue(json_to_xml(json_text), xpath);	\nend'),('common_schema','decode_xml','FUNCTION','decode_xml','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8','text CHARSET utf8','begin\n  set txt := REPLACE(txt, \'&apos;\', \'\'\'\');\n  set txt := REPLACE(txt, \'&quot;\', \'\"\');\n  set txt := REPLACE(txt, \'&gt;\', \'>\');\n  set txt := REPLACE(txt, \'&lt;\', \'<\');\n  set txt := REPLACE(txt, \'&amp;\', \'&\');\n  \n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Decode escaped XML','utf8','utf8_general_ci','utf8_general_ci','begin\n  set txt := REPLACE(txt, \'&apos;\', \'\'\');\n  set txt := REPLACE(txt, \'&quot;\', \'\"\');\n  set txt := REPLACE(txt, \'&gt;\', \'>\');\n  set txt := REPLACE(txt, \'&lt;\', \'<\');\n  set txt := REPLACE(txt, \'&amp;\', \'&\');\n  \n  return txt;\nend'),('common_schema','encode_xml','FUNCTION','encode_xml','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8','text CHARSET utf8','begin\n  set txt := REPLACE(txt, \'&\', \'&amp;\');\n  set txt := REPLACE(txt, \'<\', \'&lt;\');\n  set txt := REPLACE(txt, \'>\', \'&gt;\');\n  set txt := REPLACE(txt, \'\"\', \'&quot;\');\n  set txt := REPLACE(txt, \'\'\'\', \'&apos;\');\n  \n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Encode (escape) given text for XML','utf8','utf8_general_ci','utf8_general_ci','begin\n  set txt := REPLACE(txt, \'&\', \'&amp;\');\n  set txt := REPLACE(txt, \'<\', \'&lt;\');\n  set txt := REPLACE(txt, \'>\', \'&gt;\');\n  set txt := REPLACE(txt, \'\"\', \'&quot;\');\n  set txt := REPLACE(txt, \'\'\', \'&apos;\');\n  \n  return txt;\nend'),('common_schema','get_option','FUNCTION','get_option','SQL','NO_SQL','YES','INVOKER','options TEXT CHARSET utf8, key_name VARCHAR(255) CHARSET utf8','text CHARSET utf8','begin\n  declare options_delimiter VARCHAR(64) CHARSET ascii DEFAULT NULL;\n  declare num_options INT UNSIGNED DEFAULT 0;\n  declare options_counter INT UNSIGNED DEFAULT 0;\n  declare current_option TEXT CHARSET utf8 DEFAULT \'\'; \n  declare current_option_delimiter VARCHAR(64) CHARSET ascii DEFAULT NULL;\n  declare current_key TEXT CHARSET utf8 DEFAULT \'\'; \n  declare current_value TEXT CHARSET utf8 DEFAULT \'\'; \n  \n  if not _is_options_format(options) then\n    return null;\n  end if;\n  \n  set key_name := unquote(key_name);\n\n  \n  set options := _retokenized_text(unwrap(trim_wspace(options)), \',\', \'\"\'\'`\', TRUE, \'error\');\n  set options_delimiter := @common_schema_retokenized_delimiter;\n  set num_options := @common_schema_retokenized_count;\n  set options_counter := 1;\n  while options_counter <= num_options do\n    \n    set current_option := split_token(options, options_delimiter, options_counter);\n    set current_option = _retokenized_text(current_option, \':\', \'\"\'\'`\', TRUE, \'error\');\n\n    set current_option_delimiter := @common_schema_retokenized_delimiter;\n    if (@common_schema_retokenized_count != 2) then\n      return NULL;\n    end if;\n    set current_key := split_token(current_option, current_option_delimiter, 1);\n    set current_key := unquote(current_key);\n    if current_key = key_name then\n      set current_value := split_token(current_option, current_option_delimiter, 2);\n      if current_value = \'NULL\' then\n        return NULL;\n      end if;\n      set current_value := unquote(current_value);\n      return current_value;\n    end if;\n    set options_counter := options_counter + 1;\n  end while;    \n  return NULL;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return value of option in JS options format','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare options_delimiter VARCHAR(64) CHARSET ascii DEFAULT NULL;\n  declare num_options INT UNSIGNED DEFAULT 0;\n  declare options_counter INT UNSIGNED DEFAULT 0;\n  declare current_option TEXT CHARSET utf8 DEFAULT \'\'; \n  declare current_option_delimiter VARCHAR(64) CHARSET ascii DEFAULT NULL;\n  declare current_key TEXT CHARSET utf8 DEFAULT \'\'; \n  declare current_value TEXT CHARSET utf8 DEFAULT \'\'; \n  \n  if not _is_options_format(options) then\n    return null;\n  end if;\n  \n  set key_name := unquote(key_name);\n\n  \n  set options := _retokenized_text(unwrap(trim_wspace(options)), \',\', \'\"\'`\', TRUE, \'error\');\n  set options_delimiter := @common_schema_retokenized_delimiter;\n  set num_options := @common_schema_retokenized_count;\n  set options_counter := 1;\n  while options_counter <= num_options do\n    \n    set current_option := split_token(options, options_delimiter, options_counter);\n    set current_option = _retokenized_text(current_option, \':\', \'\"\'`\', TRUE, \'error\');\n\n    set current_option_delimiter := @common_schema_retokenized_delimiter;\n    if (@common_schema_retokenized_count != 2) then\n      return NULL;\n    end if;\n    set current_key := split_token(current_option, current_option_delimiter, 1);\n    set current_key := unquote(current_key);\n    if current_key = key_name then\n      set current_value := split_token(current_option, current_option_delimiter, 2);\n      if current_value = \'NULL\' then\n        return NULL;\n      end if;\n      set current_value := unquote(current_value);\n      return current_value;\n    end if;\n    set options_counter := options_counter + 1;\n  end while;    \n  return NULL;\nend'),('common_schema','prettify_message','PROCEDURE','prettify_message','SQL','NO_SQL','NO','INVOKER','title TINYTEXT CHARSET utf8, msg MEDIUMTEXT CHARSET utf8','','main_body: begin\n  declare query text charset utf8;\n  \n  if msg is null or msg = \'\' then\n    leave main_body;\n  end if;\n  \n  set @_prettify_message_text := msg;\n  set @_prettify_message_num_rows := get_num_tokens(msg, \'\\n\');\n  set query := CONCAT(\'\n    SELECT \n        split_token(@_prettify_message_text, \\\'\\\\n\\\', n) AS \', mysql_qualify(title), \'\n      FROM \n        numbers\n      WHERE \n        numbers.n BETWEEN 1 AND @_prettify_message_num_rows\n      ORDER BY n ASC;\n    \');\n  call exec_single(query);\n  set @_prettify_message_text := NULL;\n  set @_prettify_message_num_rows := NULL;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Outputs a prettified text message, one row per line in text','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare query text charset utf8;\n  \n  if msg is null or msg = \'\' then\n    leave main_body;\n  end if;\n  \n  set @_prettify_message_text := msg;\n  set @_prettify_message_num_rows := get_num_tokens(msg, \'\n\');\n  set query := CONCAT(\'\n    SELECT \n        split_token(@_prettify_message_text, \'\\n\', n) AS \', mysql_qualify(title), \'\n      FROM \n        numbers\n      WHERE \n        numbers.n BETWEEN 1 AND @_prettify_message_num_rows\n      ORDER BY n ASC;\n    \');\n  call exec_single(query);\n  set @_prettify_message_text := NULL;\n  set @_prettify_message_num_rows := NULL;\nend'),('common_schema','replace_all','FUNCTION','replace_all','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8, from_characters VARCHAR(1024) CHARSET utf8, to_str TEXT CHARSET utf8','text CHARSET utf8','begin\n  declare counter SMALLINT UNSIGNED DEFAULT 1;\n\n  while counter <= CHAR_LENGTH(from_characters) do\n    set txt := REPLACE(txt, SUBSTRING(from_characters, counter, 1), to_str);\n    set counter := counter + 1;\n  end while;\n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Replace any char in from_characters with to_str ','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare counter SMALLINT UNSIGNED DEFAULT 1;\n\n  while counter <= CHAR_LENGTH(from_characters) do\n    set txt := REPLACE(txt, SUBSTRING(from_characters, counter, 1), to_str);\n    set counter := counter + 1;\n  end while;\n  return txt;\nend'),('common_schema','starts_with','FUNCTION','starts_with','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8, prefix TEXT CHARSET utf8','int(10) unsigned','begin\n  if left(txt, CHAR_LENGTH(prefix)) = prefix then\n    return CHAR_LENGTH(prefix);\n  end if;\n  return 0;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Return substring by index in delimited text','utf8','utf8_general_ci','utf8_general_ci','begin\n  if left(txt, CHAR_LENGTH(prefix)) = prefix then\n    return CHAR_LENGTH(prefix);\n  end if;\n  return 0;\nend'),('common_schema','strip_urls','FUNCTION','strip_urls','SQL','NO_SQL','YES','INVOKER','txt TEXT CHARSET utf8','text CHARSET utf8','begin\n  declare end_pos INT UNSIGNED DEFAULT 0;\n  declare done TINYINT UNSIGNED DEFAULT 0;\n  \n  while ((@_strip_urls_url_pos := LOCATE(\'http://\', txt)) > 0) do\n    set end_pos := @_strip_urls_url_pos;\n    while (SUBSTRING(txt, end_pos, 1) not in (\' \', \'\\n\', \'\\r\', \'<\', \'\')) do\n      set end_pos := end_pos + 1;\n    end while;\n    set txt := CONCAT(LEFT(txt, @_strip_urls_url_pos - 1), SUBSTRING(txt, end_pos));\n  end while;\n  while ((@_strip_urls_url_pos := LOCATE(\'https://\', txt)) > 0) do\n    set end_pos := @_strip_urls_url_pos;\n    while (SUBSTRING(txt, end_pos, 1) not in (\' \', \'\\n\', \'\\r\', \'<\', \'\')) do\n      set end_pos := end_pos + 1;\n    end while;\n    set txt := CONCAT(LEFT(txt, @_strip_urls_url_pos - 1), SUBSTRING(txt, end_pos));\n  end while;\n  return txt;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Strips URLs from given text','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare end_pos INT UNSIGNED DEFAULT 0;\n  declare done TINYINT UNSIGNED DEFAULT 0;\n  \n  while ((@_strip_urls_url_pos := LOCATE(\'http://\', txt)) > 0) do\n    set end_pos := @_strip_urls_url_pos;\n    while (SUBSTRING(txt, end_pos, 1) not in (\' \', \'\n\', \'\r\', \'<\', \'\')) do\n      set end_pos := end_pos + 1;\n    end while;\n    set txt := CONCAT(LEFT(txt, @_strip_urls_url_pos - 1), SUBSTRING(txt, end_pos));\n  end while;\n  while ((@_strip_urls_url_pos := LOCATE(\'https://\', txt)) > 0) do\n    set end_pos := @_strip_urls_url_pos;\n    while (SUBSTRING(txt, end_pos, 1) not in (\' \', \'\n\', \'\r\', \'<\', \'\')) do\n      set end_pos := end_pos + 1;\n    end while;\n    set txt := CONCAT(LEFT(txt, @_strip_urls_url_pos - 1), SUBSTRING(txt, end_pos));\n  end while;\n  return txt;\nend'),('common_schema','is_datetime','FUNCTION','is_datetime','SQL','NO_SQL','YES','INVOKER','txt TINYTEXT','tinyint(3) unsigned','BEGIN\n  RETURN (txt + interval 0 second is not null);\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns DATETIME of beginning of round hour of given DATETIME.','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  RETURN (txt + interval 0 second is not null);\nEND'),('common_schema','pearson_samp','PROCEDURE','pearson_samp','SQL','READS_SQL_DATA','NO','INVOKER','\n  in p_sql    text    \n, in p_pairs  text    \n, in p_silent bool    \n','','pearson_samp: begin\n  declare v_from, v_old_from int unsigned;\n  declare v_token text charset utf8;\n  declare v_level int unsigned;\n  declare v_state varchar(32);\n  declare v_expression_start, v_expression_end int unsigned;\n  declare v_sql text;\n  declare v_from_clause_index int unsigned;\n  declare v_colcount int unsigned;\n  declare v_parse_expression bool;\n  declare v_alias varchar(255);\n  declare v_pairs text default trim(p_pairs);\n  declare v_pair_state enum(\'start\', \'x\', \'comma\', \'y\');\n  declare v_paircount, v_x, v_y int unsigned;\n\n  \n  find_select: repeat\n    set v_old_from = v_from;\n    call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n    case\n      when v_state in (\n          \'whitespace\'\n        , \'single line comment\'\n        , \'multi line comment\'\n        , \'conditional comment\'\n        ) then iterate find_select;\n      when  v_state = \'alpha\'\n        and v_token = \'select\'\n        then leave find_select;\n      else\n        select \'No token select found\';\n        leave pearson_samp;\n    end case;\n  until\n    v_old_from = v_from\n  end repeat find_select;\n\n  drop temporary table if exists t_columns;\n\n  create temporary table t_columns (\n    position    int unsigned  not null\n  , expression  text          not null\n  , alias       varchar(255)\n  );\n\n  set v_expression_start  = v_from\n  ,   v_colcount          = 1\n  ,   v_parse_expression  = FALSE\n  ,   v_alias             = NULL\n  ;\n\n  \n  analyze_columns: repeat\n    set v_old_from = v_from;\n    call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n    if v_level > 0 then\n      iterate analyze_columns;\n    end if;\n    case v_state\n      when \'comma\' then\n        set v_parse_expression = TRUE;\n      when \'alpha\' then\n        case v_token\n          when \'AS\' then\n            set v_expression_end = v_old_from;\n            parse_alias: repeat\n              set v_old_from = v_from;\n              call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n              if v_state in (\'alpha\', \'alphanum\', \'quoted identifier\', \'string\') then\n                set v_alias = v_token;\n                leave  parse_alias;\n              end if;\n            until\n              v_old_from = v_from\n            end repeat parse_alias;\n          when \'FROM\' then\n            set v_parse_expression = TRUE\n            ,   v_from_clause_index = v_old_from\n            ;\n          else\n            do null;\n        end case;\n      else\n        do null;\n    end case;\n\n    if v_parse_expression then\n      insert into\n      t_columns (\n        position\n      , expression\n      , alias\n      )\n      values   (\n        v_colcount\n      , substr(p_sql, v_expression_start,\n          if(v_alias is null, v_old_from, v_expression_end) - v_expression_start\n        )\n      , v_alias\n      );\n      set v_expression_start  = v_from\n      ,   v_parse_expression  = FALSE\n      ,   v_colcount          = v_colcount + 1\n      ,   v_alias             = NULL\n      ;\n    end if;\n  until\n    v_old_from = v_from\n  end repeat analyze_columns;\n\n  set v_colcount = v_colcount - 1;\n\n  \n  drop temporary table if exists t_pairs;\n\n  create temporary table t_pairs (\n    position    int unsigned  not null\n  , x           int unsigned  not null\n  , y           int unsigned  not null\n  );\n\n  set v_from = null\n  ,   v_level = 0\n  ,   v_paircount = 0\n  ,   v_pair_state = \'start\'\n  ;\n\n  parse_pairs: repeat\n    set v_old_from = v_from;\n    call _get_sql_token(p_pairs, v_from, v_level, v_token, FALSE, v_state);\n    case\n      when v_state in (\n          \'whitespace\'\n        , \'single line comment\'\n        , \'multi line comment\'\n        , \'conditional comment\'\n        ) then iterate parse_pairs;\n      when v_state = \'start\' then\n        leave parse_pairs;\n      else\n        case v_pair_state\n          when \'start\' then\n            set v_x = null\n            ,   v_y = null\n            ;\n            if v_state = \'integer\' then\n              set v_x = cast(v_token as unsigned)\n              ,   v_pair_state = \'x\'\n              ;\n              if v_x > v_colcount then\n                leave pearson_samp;\n              end if;\n            else\n              leave pearson_samp;\n            end if;\n          when \'x\' then\n            if v_state = \'comma\' then\n              set v_pair_state = \'comma\';\n            else\n              leave pearson_samp;\n            end if;\n          when \'comma\' then\n            if v_state = \'integer\' then\n              set v_y = cast(v_token as unsigned)\n              ,   v_pair_state = \'y\'\n              ,   v_paircount = v_paircount + 1\n              ;\n              if v_y > v_colcount then\n                leave pearson_samp;\n              end if;\n              insert into\n              t_pairs (position, x, y)\n              values (v_paircount, v_x, v_y)\n              ;\n            else\n              leave pearson_samp;\n            end if;\n          when \'y\' then\n            if v_state = \'statement delimiter\' then\n              set v_pair_state = \'start\';\n            else\n              leave pearson_samp;\n            end if;\n          else\n              leave pearson_samp;\n        end case;\n    end case;\n  until\n    v_old_from = v_from\n  end repeat parse_pairs;\n\n  \n  generate_sql: begin\n    declare v_select1, v_select2 text;\n    declare v_into text default \'\';\n    declare v_expression1, v_expression2 text;\n    declare v_position1, v_position2, v_position int unsigned;\n    declare v_done bool default false;\n    declare csr_pairs cursor for\n      select      *\n      from        t_pairs\n    ;\n    declare csr_columns cursor for\n      select      distinct\n                   t_columns.position\n      ,            t_columns.expression\n      from         t_columns\n      inner join  t_pairs\n      on           t_columns.position = t_pairs.x\n      or           t_columns.position = t_pairs.y\n      ;\n    declare continue handler for not found\n      set v_done = true;\n\n    open csr_columns;\n    csr_columns: loop\n      fetch csr_columns\n      into v_position, v_expression1\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_columns;\n        leave csr_columns;\n      end if;\n\n      set     v_select1 = concat(\n                if (v_select1 is null, \'\', concat(v_select1, \'\\n,\'))\n              ,  \'avg(\', v_expression1, \') AS avg\', v_position\n              , \',stddev_samp(\', v_expression1, \') AS stddev_samp\', v_position\n              )\n      ;\n    end loop csr_columns;\n\n    open csr_pairs;\n    csr_pairs: loop\n      fetch csr_pairs\n      into  v_position\n      ,     v_position1\n      ,     v_position2\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_pairs;\n        leave csr_pairs;\n      end if;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression1\n      from    t_columns\n      where   position = v_position1;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression2\n      from    t_columns\n      where   position = v_position2;\n\n      set     v_select1 = concat(\n                v_select1\n              , \'\\n,sum(\'\n              ,    v_expression1, \' is not null\'\n              ,    \' and \'\n              ,    v_expression2, \' is not null\'\n              , \') AS count\', v_position\n              , \',sum(\'\n              ,    v_expression1\n              ,    \' * \'\n              ,    v_expression2\n              , \') AS sum\', v_position\n              )\n      ,       v_select2 = concat(\n                if (v_select2 is null, \'\', concat(v_select2, \'\\n,\'))\n              , \'(sum\', v_position, \' - count\', v_position, \' * avg\', v_position1, \' * avg\', v_position2, \')\'\n              , \'/\'\n              , \'((count\', v_position, \' - 1) * stddev_samp\', v_position1, \' * stddev_samp\', v_position2, \')\'\n              , \' AS pearson_samp\', v_position\n              )\n      ;\n      if p_silent then\n        set v_into =  concat(\n          \'\\n\', if (v_into = \'\', \'INTO \', concat(v_into, \',\'))\n        , \'@pearson_samp\', v_position\n        );\n      end if;\n    end loop csr_pairs;\n\n    set v_sql = concat(\n      \'SELECT \', v_select2\n    , v_into\n    , \'\\nFROM (\'\n    , \'\\nSELECT \', v_select1\n    , \'\\n\', substr(p_sql, v_from_clause_index)\n    , \') as pearson_samp\'\n    );\n  end generate_sql;\n\n  \n  call exec(v_sql);\n\nend pearson_samp','root@%','2012-11-29 21:23:34','2012-11-29 21:23:34','','Calculate Pearson\'s product-moment correlation coefficient (sample).','utf8','utf8_general_ci','utf8_general_ci','pearson_samp: begin\n  declare v_from, v_old_from int unsigned;\n  declare v_token text charset utf8;\n  declare v_level int unsigned;\n  declare v_state varchar(32);\n  declare v_expression_start, v_expression_end int unsigned;\n  declare v_sql text;\n  declare v_from_clause_index int unsigned;\n  declare v_colcount int unsigned;\n  declare v_parse_expression bool;\n  declare v_alias varchar(255);\n  declare v_pairs text default trim(p_pairs);\n  declare v_pair_state enum(\'start\', \'x\', \'comma\', \'y\');\n  declare v_paircount, v_x, v_y int unsigned;\n\n  \n  find_select: repeat\n    set v_old_from = v_from;\n    call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n    case\n      when v_state in (\n          \'whitespace\'\n        , \'single line comment\'\n        , \'multi line comment\'\n        , \'conditional comment\'\n        ) then iterate find_select;\n      when  v_state = \'alpha\'\n        and v_token = \'select\'\n        then leave find_select;\n      else\n        select \'No token select found\';\n        leave pearson_samp;\n    end case;\n  until\n    v_old_from = v_from\n  end repeat find_select;\n\n  drop temporary table if exists t_columns;\n\n  create temporary table t_columns (\n    position    int unsigned  not null\n  , expression  text          not null\n  , alias       varchar(255)\n  );\n\n  set v_expression_start  = v_from\n  ,   v_colcount          = 1\n  ,   v_parse_expression  = FALSE\n  ,   v_alias             = NULL\n  ;\n\n  \n  analyze_columns: repeat\n    set v_old_from = v_from;\n    call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n    if v_level > 0 then\n      iterate analyze_columns;\n    end if;\n    case v_state\n      when \'comma\' then\n        set v_parse_expression = TRUE;\n      when \'alpha\' then\n        case v_token\n          when \'AS\' then\n            set v_expression_end = v_old_from;\n            parse_alias: repeat\n              set v_old_from = v_from;\n              call _get_sql_token(p_sql, v_from, v_level, v_token, FALSE, v_state);\n              if v_state in (\'alpha\', \'alphanum\', \'quoted identifier\', \'string\') then\n                set v_alias = v_token;\n                leave  parse_alias;\n              end if;\n            until\n              v_old_from = v_from\n            end repeat parse_alias;\n          when \'FROM\' then\n            set v_parse_expression = TRUE\n            ,   v_from_clause_index = v_old_from\n            ;\n          else\n            do null;\n        end case;\n      else\n        do null;\n    end case;\n\n    if v_parse_expression then\n      insert into\n      t_columns (\n        position\n      , expression\n      , alias\n      )\n      values   (\n        v_colcount\n      , substr(p_sql, v_expression_start,\n          if(v_alias is null, v_old_from, v_expression_end) - v_expression_start\n        )\n      , v_alias\n      );\n      set v_expression_start  = v_from\n      ,   v_parse_expression  = FALSE\n      ,   v_colcount          = v_colcount + 1\n      ,   v_alias             = NULL\n      ;\n    end if;\n  until\n    v_old_from = v_from\n  end repeat analyze_columns;\n\n  set v_colcount = v_colcount - 1;\n\n  \n  drop temporary table if exists t_pairs;\n\n  create temporary table t_pairs (\n    position    int unsigned  not null\n  , x           int unsigned  not null\n  , y           int unsigned  not null\n  );\n\n  set v_from = null\n  ,   v_level = 0\n  ,   v_paircount = 0\n  ,   v_pair_state = \'start\'\n  ;\n\n  parse_pairs: repeat\n    set v_old_from = v_from;\n    call _get_sql_token(p_pairs, v_from, v_level, v_token, FALSE, v_state);\n    case\n      when v_state in (\n          \'whitespace\'\n        , \'single line comment\'\n        , \'multi line comment\'\n        , \'conditional comment\'\n        ) then iterate parse_pairs;\n      when v_state = \'start\' then\n        leave parse_pairs;\n      else\n        case v_pair_state\n          when \'start\' then\n            set v_x = null\n            ,   v_y = null\n            ;\n            if v_state = \'integer\' then\n              set v_x = cast(v_token as unsigned)\n              ,   v_pair_state = \'x\'\n              ;\n              if v_x > v_colcount then\n                leave pearson_samp;\n              end if;\n            else\n              leave pearson_samp;\n            end if;\n          when \'x\' then\n            if v_state = \'comma\' then\n              set v_pair_state = \'comma\';\n            else\n              leave pearson_samp;\n            end if;\n          when \'comma\' then\n            if v_state = \'integer\' then\n              set v_y = cast(v_token as unsigned)\n              ,   v_pair_state = \'y\'\n              ,   v_paircount = v_paircount + 1\n              ;\n              if v_y > v_colcount then\n                leave pearson_samp;\n              end if;\n              insert into\n              t_pairs (position, x, y)\n              values (v_paircount, v_x, v_y)\n              ;\n            else\n              leave pearson_samp;\n            end if;\n          when \'y\' then\n            if v_state = \'statement delimiter\' then\n              set v_pair_state = \'start\';\n            else\n              leave pearson_samp;\n            end if;\n          else\n              leave pearson_samp;\n        end case;\n    end case;\n  until\n    v_old_from = v_from\n  end repeat parse_pairs;\n\n  \n  generate_sql: begin\n    declare v_select1, v_select2 text;\n    declare v_into text default \'\';\n    declare v_expression1, v_expression2 text;\n    declare v_position1, v_position2, v_position int unsigned;\n    declare v_done bool default false;\n    declare csr_pairs cursor for\n      select      *\n      from        t_pairs\n    ;\n    declare csr_columns cursor for\n      select      distinct\n                   t_columns.position\n      ,            t_columns.expression\n      from         t_columns\n      inner join  t_pairs\n      on           t_columns.position = t_pairs.x\n      or           t_columns.position = t_pairs.y\n      ;\n    declare continue handler for not found\n      set v_done = true;\n\n    open csr_columns;\n    csr_columns: loop\n      fetch csr_columns\n      into v_position, v_expression1\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_columns;\n        leave csr_columns;\n      end if;\n\n      set     v_select1 = concat(\n                if (v_select1 is null, \'\', concat(v_select1, \'\n,\'))\n              ,  \'avg(\', v_expression1, \') AS avg\', v_position\n              , \',stddev_samp(\', v_expression1, \') AS stddev_samp\', v_position\n              )\n      ;\n    end loop csr_columns;\n\n    open csr_pairs;\n    csr_pairs: loop\n      fetch csr_pairs\n      into  v_position\n      ,     v_position1\n      ,     v_position2\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_pairs;\n        leave csr_pairs;\n      end if;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression1\n      from    t_columns\n      where   position = v_position1;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression2\n      from    t_columns\n      where   position = v_position2;\n\n      set     v_select1 = concat(\n                v_select1\n              , \'\n,sum(\'\n              ,    v_expression1, \' is not null\'\n              ,    \' and \'\n              ,    v_expression2, \' is not null\'\n              , \') AS count\', v_position\n              , \',sum(\'\n              ,    v_expression1\n              ,    \' * \'\n              ,    v_expression2\n              , \') AS sum\', v_position\n              )\n      ,       v_select2 = concat(\n                if (v_select2 is null, \'\', concat(v_select2, \'\n,\'))\n              , \'(sum\', v_position, \' - count\', v_position, \' * avg\', v_position1, \' * avg\', v_position2, \')\'\n              , \'/\'\n              , \'((count\', v_position, \' - 1) * stddev_samp\', v_position1, \' * stddev_samp\', v_position2, \')\'\n              , \' AS pearson_samp\', v_position\n              )\n      ;\n      if p_silent then\n        set v_into =  concat(\n          \'\n\', if (v_into = \'\', \'INTO \', concat(v_into, \',\'))\n        , \'@pearson_samp\', v_position\n        );\n      end if;\n    end loop csr_pairs;\n\n    set v_sql = concat(\n      \'SELECT \', v_select2\n    , v_into\n    , \'\nFROM (\'\n    , \'\nSELECT \', v_select1\n    , \'\n\', substr(p_sql, v_from_clause_index)\n    , \') as pearson_samp\'\n    );\n  end generate_sql;\n\n  \n  call exec(v_sql);\n\nend pearson_samp'),('common_schema','query_checksum','PROCEDURE','query_checksum','SQL','READS_SQL_DATA','NO','INVOKER','in query TEXT CHARSET utf8','','begin\n  \n  declare sql_query_num_columns TINYINT UNSIGNED DEFAULT 9;\n  declare result_checksum CHAR(40) CHARSET ascii DEFAULT \'\';\n  \n  set @query_checksum_result := NULL;\n  if not _is_select_query(query) then\n    call throw(\'query_checksum input must be SELECT query\');\n  end if;\n\n  DROP TEMPORARY TABLE IF EXISTS _tmp_query_checksum;\n    \n  call _wrap_select_list_columns(query, sql_query_num_columns, @common_schema_error);\n  set @_common_schema_checkum_temporary_query := CONCAT(\'CREATE TEMPORARY TABLE _tmp_query_checksum \', query);\n\n  PREPARE st FROM @_common_schema_checkum_temporary_query;\n  EXECUTE st;\n  DEALLOCATE PREPARE st;\n    \n  \n  begin	\n    declare col1, col2, col3, col4, col5, col6, col7, col8, col9 VARCHAR(4096) CHARSET utf8;\n    declare done INT DEFAULT 0;\n    declare query_cursor cursor for SELECT * FROM _tmp_query_checksum;\n    declare continue handler for NOT FOUND set done = 1;\n          \n    open query_cursor;\n    read_loop: loop\n      fetch query_cursor into col1, col2, col3, col4, col5, col6, col7, col8, col9;\n      if done then\n        leave read_loop;\n      end if;\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col1, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col2, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col3, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col4, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col5, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col6, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col7, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col8, \'\\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\\0\', IFNULL(col9, \'\\0\')));\n    end loop;\n    close query_cursor;\n  end; \n    \n  DROP TEMPORARY TABLE IF EXISTS _tmp_query_checksum;\n  \n  SELECT (@query_checksum_result := result_checksum) AS `checksum`;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Checksum resultset of given query (max 9 columns)','utf8','utf8_general_ci','utf8_general_ci','begin\n  \n  declare sql_query_num_columns TINYINT UNSIGNED DEFAULT 9;\n  declare result_checksum CHAR(40) CHARSET ascii DEFAULT \'\';\n  \n  set @query_checksum_result := NULL;\n  if not _is_select_query(query) then\n    call throw(\'query_checksum input must be SELECT query\');\n  end if;\n\n  DROP TEMPORARY TABLE IF EXISTS _tmp_query_checksum;\n    \n  call _wrap_select_list_columns(query, sql_query_num_columns, @common_schema_error);\n  set @_common_schema_checkum_temporary_query := CONCAT(\'CREATE TEMPORARY TABLE _tmp_query_checksum \', query);\n\n  PREPARE st FROM @_common_schema_checkum_temporary_query;\n  EXECUTE st;\n  DEALLOCATE PREPARE st;\n    \n  \n  begin	\n    declare col1, col2, col3, col4, col5, col6, col7, col8, col9 VARCHAR(4096) CHARSET utf8;\n    declare done INT DEFAULT 0;\n    declare query_cursor cursor for SELECT * FROM _tmp_query_checksum;\n    declare continue handler for NOT FOUND set done = 1;\n          \n    open query_cursor;\n    read_loop: loop\n      fetch query_cursor into col1, col2, col3, col4, col5, col6, col7, col8, col9;\n      if done then\n        leave read_loop;\n      end if;\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col1, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col2, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col3, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col4, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col5, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col6, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col7, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col8, \'\0\')));\n      set result_checksum := MD5(CONCAT(result_checksum, \'\0\', IFNULL(col9, \'\0\')));\n    end loop;\n    close query_cursor;\n  end; \n    \n  DROP TEMPORARY TABLE IF EXISTS _tmp_query_checksum;\n  \n  SELECT (@query_checksum_result := result_checksum) AS `checksum`;\nend'),('common_schema','random_hash','FUNCTION','random_hash','SQL','NO_SQL','YES','INVOKER','','char(40) CHARSET ascii','begin\n	declare result CHAR(40) CHARSET ascii;\n	select \n	  SHA1(\n	    CONCAT_WS(\',\', @@server_id, SYSDATE(), RAND(), GROUP_CONCAT(VARIABLE_VALUE))\n	  )\n	from\n	  INFORMATION_SCHEMA.GLOBAL_STATUS\n	into result;\n	return result;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Generate random hash string','utf8','utf8_general_ci','utf8_general_ci','begin\n	declare result CHAR(40) CHARSET ascii;\n	select \n	  SHA1(\n	    CONCAT_WS(\',\', @@server_id, SYSDATE(), RAND(), GROUP_CONCAT(VARIABLE_VALUE))\n	  )\n	from\n	  INFORMATION_SCHEMA.GLOBAL_STATUS\n	into result;\n	return result;\nend'),('common_schema','_get_json_token','PROCEDURE','_get_json_token','SQL','NO_SQL','YES','INVOKER','\n    in      p_text      text charset utf8\n,   inout   p_from      int unsigned\n,   inout   p_level     int\n,   out     p_token     text charset utf8\n,   in      allow_script_tokens int\n,   inout   p_state     enum(\n                            \'alpha\'\n                        ,   \'alphanum\'\n                        ,   \'colon\'\n                        ,   \'comma\'                        \n                        ,   \'decimal\'\n                        ,   \'error\'\n                        ,   \'integer\'\n                        ,   \'number\'\n                        ,   \'object_begin\'\n                        ,   \'object_end\'\n                        ,   \'array_begin\'\n                        ,   \'array_end\'\n                        ,   \'start\'\n                        ,   \'string\'\n                        ,   \'whitespace\'\n                        )               \n','','begin    \n    declare v_length int unsigned default character_length(p_text);\n    declare v_char, v_lookahead, v_quote_char    varchar(1) charset utf8;\n    declare v_from int unsigned;\n\n    if p_from is null then\n        set p_from = 1;\n    end if;\n    if p_level is null then\n        set p_level = 0;\n    end if;\n    if p_state = \'object_end\' then\n        set p_level = p_level - 1;\n    end if;\n    if p_state = \'array_end\' and allow_script_tokens then\n        set p_level = p_level - 1;\n    end if;\n    set v_from = p_from;\n    \n    set p_token = \'\'\n    ,   p_state = \'start\';\n    my_loop: while v_from <= v_length do\n        set v_char = substr(p_text, v_from, 1)\n        ,   v_lookahead = substr(p_text, v_from+1, 1)\n        ;\n        state_case: begin case p_state\n            when \'error\' then \n                set p_from = v_length;\n                leave state_case;            \n            when \'start\' then\n                case\n                    when v_char between \'0\' and \'9\' then \n                        set p_state = \'integer\';\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        set p_state = \'alpha\';                        \n                    when v_char = \' \' then \n                        set p_state = \'whitespace\'\n                        ,   v_from = v_length - character_length(ltrim(substring(p_text, v_from)))\n                        ;\n                        leave state_case;\n                    when v_char in (\'\\t\', \'\\n\', \'\\r\') then \n                        set p_state = \'whitespace\';\n                    when v_char = \'\"\' then\n                        set p_state = \'string\', v_quote_char = v_char;\n                    when v_char = \'.\' then\n                        if substr(p_text, v_from + 1, 1) between \'0\' and \'9\' then\n                            set p_state = \'decimal\', v_from = v_from + 1;\n                        else\n                            set p_state = \'error\';\n                            leave my_loop;\n                        end if;\n                    when v_char = \',\' then\n                        set p_state = \'comma\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \':\' then \n                        set p_state = \'colon\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'{\' then \n                        set p_state = \'object_begin\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \'}\' then\n                        set p_state = \'object_end\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'[\' then \n                        set p_state = \'array_begin\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \']\' then \n                        set p_state = \'array_end\', v_from = v_from + 1;\n                        leave my_loop;\n                    else \n                        set p_state = \'error\';\n                end case;\n            when \'alpha\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        leave state_case;\n                    when v_char between \'0\' and \'9\' then \n                        set p_state = \'alphanum\';\n                    else\n                        leave my_loop;\n                end case;\n            when \'alphanum\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\'\n                    or   v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'integer\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    when v_char = \'.\' then \n                        set p_state = \'decimal\';\n                    else\n                        leave my_loop;                        \n                end case;\n            when \'decimal\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'whitespace\' then\n                if v_char not in (\'\\t\', \'\\n\', \'\\r\') then\n                    leave my_loop;                        \n                end if;\n            when \'string\' then\n                set v_from = locate(v_quote_char, p_text, v_from);\n                if v_from then\n                    if substr(p_text, v_from + 1, 1) = v_quote_char then\n                        set v_from = v_from + 1;\n                    elseif substr(p_text, v_from - 1, 1) != \'\\\\\' then\n                        set v_from = v_from + 1;\n                        leave my_loop;\n                    end if;\n                else\n                    set p_state = \'error\';\n                    leave my_loop;\n                end if;\n            else\n                leave my_loop;            \n        end case; end state_case;\n        set v_from = v_from + 1;\n    end while my_loop;\n    set p_token = substr(p_text, p_from, v_from - p_from) collate utf8_general_ci;\n    set p_from = v_from;\n    if p_state in (\'decimal\', \'integer\') then\n      set p_state := \'number\';\n    end if;\n    if p_state = \'alphanum\' then\n      set p_state := \'alpha\';\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Reads a token according to lexical rules for JSON','utf8','utf8_general_ci','utf8_general_ci','begin    \n    declare v_length int unsigned default character_length(p_text);\n    declare v_char, v_lookahead, v_quote_char    varchar(1) charset utf8;\n    declare v_from int unsigned;\n\n    if p_from is null then\n        set p_from = 1;\n    end if;\n    if p_level is null then\n        set p_level = 0;\n    end if;\n    if p_state = \'object_end\' then\n        set p_level = p_level - 1;\n    end if;\n    if p_state = \'array_end\' and allow_script_tokens then\n        set p_level = p_level - 1;\n    end if;\n    set v_from = p_from;\n    \n    set p_token = \'\'\n    ,   p_state = \'start\';\n    my_loop: while v_from <= v_length do\n        set v_char = substr(p_text, v_from, 1)\n        ,   v_lookahead = substr(p_text, v_from+1, 1)\n        ;\n        state_case: begin case p_state\n            when \'error\' then \n                set p_from = v_length;\n                leave state_case;            \n            when \'start\' then\n                case\n                    when v_char between \'0\' and \'9\' then \n                        set p_state = \'integer\';\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        set p_state = \'alpha\';                        \n                    when v_char = \' \' then \n                        set p_state = \'whitespace\'\n                        ,   v_from = v_length - character_length(ltrim(substring(p_text, v_from)))\n                        ;\n                        leave state_case;\n                    when v_char in (\'	\', \'\n\', \'\r\') then \n                        set p_state = \'whitespace\';\n                    when v_char = \'\"\' then\n                        set p_state = \'string\', v_quote_char = v_char;\n                    when v_char = \'.\' then\n                        if substr(p_text, v_from + 1, 1) between \'0\' and \'9\' then\n                            set p_state = \'decimal\', v_from = v_from + 1;\n                        else\n                            set p_state = \'error\';\n                            leave my_loop;\n                        end if;\n                    when v_char = \',\' then\n                        set p_state = \'comma\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \':\' then \n                        set p_state = \'colon\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'{\' then \n                        set p_state = \'object_begin\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \'}\' then\n                        set p_state = \'object_end\', v_from = v_from + 1;\n                        leave my_loop;\n                    when v_char = \'[\' then \n                        set p_state = \'array_begin\', v_from = v_from + 1, p_level = p_level + 1;\n                        leave my_loop;\n                    when v_char = \']\' then \n                        set p_state = \'array_end\', v_from = v_from + 1;\n                        leave my_loop;\n                    else \n                        set p_state = \'error\';\n                end case;\n            when \'alpha\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\' then\n                        leave state_case;\n                    when v_char between \'0\' and \'9\' then \n                        set p_state = \'alphanum\';\n                    else\n                        leave my_loop;\n                end case;\n            when \'alphanum\' then \n                case\n                    when v_char between \'A\' and \'Z\' \n                    or   v_char between \'a\' and \'z\' \n                    or   v_char = \'_\'\n                    or   v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'integer\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    when v_char = \'.\' then \n                        set p_state = \'decimal\';\n                    else\n                        leave my_loop;                        \n                end case;\n            when \'decimal\' then\n                case \n                    when v_char between \'0\' and \'9\' then \n                        leave state_case;\n                    else\n                        leave my_loop;\n                end case;\n            when \'whitespace\' then\n                if v_char not in (\'	\', \'\n\', \'\r\') then\n                    leave my_loop;                        \n                end if;\n            when \'string\' then\n                set v_from = locate(v_quote_char, p_text, v_from);\n                if v_from then\n                    if substr(p_text, v_from + 1, 1) = v_quote_char then\n                        set v_from = v_from + 1;\n                    elseif substr(p_text, v_from - 1, 1) != \'\\\' then\n                        set v_from = v_from + 1;\n                        leave my_loop;\n                    end if;\n                else\n                    set p_state = \'error\';\n                    leave my_loop;\n                end if;\n            else\n                leave my_loop;            \n        end case; end state_case;\n        set v_from = v_from + 1;\n    end while my_loop;\n    set p_token = substr(p_text, p_from, v_from - p_from) collate utf8_general_ci;\n    set p_from = v_from;\n    if p_state in (\'decimal\', \'integer\') then\n      set p_state := \'number\';\n    end if;\n    if p_state = \'alphanum\' then\n      set p_state := \'alpha\';\n    end if;\nend'),('common_schema','duplicate_grantee','PROCEDURE','duplicate_grantee','SQL','MODIFIES_SQL_DATA','NO','INVOKER','\n    IN existing_grantee TINYTEXT CHARSET utf8,\n    IN new_grantee TINYTEXT CHARSET utf8\n  ','','begin\n  declare sql_grants_statement TEXT charset utf8 default null;\n    \n  SELECT \n    MIN(REPLACE(sql_grants, _requalify_grantee_term(existing_grantee), _requalify_grantee_term(new_grantee)))\n  FROM \n    sql_show_grants \n  WHERE \n    grantee = _requalify_grantee_term(existing_grantee)\n  INTO\n    sql_grants_statement;\n  \n  if sql_grants_statement is null then\n    call throw(CONCAT(\'duplicate_grantee(): unknown grantee \', existing_grantee));\n  end if;\n  \n  call exec(sql_grants_statement);\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Duplicate grantee\'s privileges into new account','utf8','utf8_general_ci','utf8_general_ci','begin\n  declare sql_grants_statement TEXT charset utf8 default null;\n    \n  SELECT \n    MIN(REPLACE(sql_grants, _requalify_grantee_term(existing_grantee), _requalify_grantee_term(new_grantee)))\n  FROM \n    sql_show_grants \n  WHERE \n    grantee = _requalify_grantee_term(existing_grantee)\n  INTO\n    sql_grants_statement;\n  \n  if sql_grants_statement is null then\n    call throw(CONCAT(\'duplicate_grantee(): unknown grantee \', existing_grantee));\n  end if;\n  \n  call exec(sql_grants_statement);\nend'),('common_schema','_consume_sql_statement','PROCEDURE','_consume_sql_statement','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from      int unsigned,\n   in   statement_id_to      int unsigned,\n   in   should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare mysql_statement TEXT CHARSET utf8;\n  \n  \n  call _expand_statement_variables(id_from, statement_id_to, mysql_statement, @_common_schema_dummy, should_execute_statement);\n  if should_execute_statement then\n    call exec_single(mysql_statement);\n    set @query_script_rowcount := @common_schema_rowcount;\n    set @query_script_found_rows := @common_schema_found_rows;\n  end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Consumes & executes SQL statement','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare mysql_statement TEXT CHARSET utf8;\n  \n  \n  call _expand_statement_variables(id_from, statement_id_to, mysql_statement, @_common_schema_dummy, should_execute_statement);\n  if should_execute_statement then\n    call exec_single(mysql_statement);\n    set @query_script_rowcount := @common_schema_rowcount;\n    set @query_script_found_rows := @common_schema_found_rows;\n  end if;\nend'),('common_schema','_skip_empty_spaces','PROCEDURE','_skip_empty_spaces','SQL','READS_SQL_DATA','YES','INVOKER','\n   inout   id_from      int unsigned,\n   in   id_to      int unsigned\n','','main_body: begin\n    select min(id) from _sql_tokens \n      where id >= id_from and id <= id_to \n      and (state, CHAR_LENGTH(token)) != (\'whitespace\', 0) \n    into id_from;\n    if id_from is null then\n      set id_from := id_to + 1;\n    end if;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Skips empty whitespace tokens','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n    select min(id) from _sql_tokens \n      where id >= id_from and id <= id_to \n      and (state, CHAR_LENGTH(token)) != (\'whitespace\', 0) \n    into id_from;\n    if id_from is null then\n      set id_from := id_to + 1;\n    end if;\nend'),('common_schema','_expand_single_variable','PROCEDURE','_expand_single_variable','SQL','MODIFIES_SQL_DATA','YES','INVOKER','\n   in   id_from            int unsigned,\n   in   id_to              int unsigned,\n   inout   variable_token     text charset utf8,\n   in   should_execute_statement tinyint unsigned\n','','main_body: begin\n  declare expanded_variable_name TEXT CHARSET utf8;\n  \n  set expanded_variable_name := _extract_expanded_query_script_variable_name(variable_token);\n  if expanded_variable_name is null then\n    \n    leave main_body;\n  end if;\n  \n  \n  if not should_execute_statement then\n    leave main_body;\n  end if;\n  \n  call _take_local_variables_snapshot(expanded_variable_name);\n \n  SELECT \n    MIN(_qs_variables.value_snapshot)\n  FROM \n    _sql_tokens \n    LEFT JOIN _qs_variables ON (\n      \n      (state = \'expanded query_script variable\' AND _extract_expanded_query_script_variable_name(token) = _qs_variables.variable_name AND _qs_variables.variable_name  = expanded_variable_name)  \n      and (id_from between _qs_variables.declaration_id and _qs_variables.scope_end_id)\n    )\n  where \n    (id between id_from and id_to) \n  INTO \n    variable_token;\nend','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Returns an expanded value','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare expanded_variable_name TEXT CHARSET utf8;\n  \n  set expanded_variable_name := _extract_expanded_query_script_variable_name(variable_token);\n  if expanded_variable_name is null then\n    \n    leave main_body;\n  end if;\n  \n  \n  if not should_execute_statement then\n    leave main_body;\n  end if;\n  \n  call _take_local_variables_snapshot(expanded_variable_name);\n \n  SELECT \n    MIN(_qs_variables.value_snapshot)\n  FROM \n    _sql_tokens \n    LEFT JOIN _qs_variables ON (\n      \n      (state = \'expanded query_script variable\' AND _extract_expanded_query_script_variable_name(token) = _qs_variables.variable_name AND _qs_variables.variable_name  = expanded_variable_name)  \n      and (id_from between _qs_variables.declaration_id and _qs_variables.scope_end_id)\n    )\n  where \n    (id between id_from and id_to) \n  INTO \n    variable_token;\nend'),('common_schema','_split_set_step_clause_and_ranges_local_variables','PROCEDURE','_split_set_step_clause_and_ranges_local_variables','SQL','READS_SQL_DATA','YES','INVOKER','\n    in comparison_clause text charset utf8\n  ','','BEGIN\n  declare columns_count tinyint unsigned default _split_get_columns_count();\n\n  set @query_script_split_comparison_clause := comparison_clause;\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_1\', QUOTE((SELECT @_split_column_variable_range_start_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_2\', QUOTE((SELECT @_split_column_variable_range_start_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_3\', QUOTE((SELECT @_split_column_variable_range_start_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_4\', QUOTE((SELECT @_split_column_variable_range_start_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_5\', QUOTE((SELECT @_split_column_variable_range_start_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_6\', QUOTE((SELECT @_split_column_variable_range_start_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_7\', QUOTE((SELECT @_split_column_variable_range_start_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_8\', QUOTE((SELECT @_split_column_variable_range_start_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_9\', QUOTE((SELECT @_split_column_variable_range_start_9)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_1\', QUOTE((SELECT @_split_column_variable_range_end_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_2\', QUOTE((SELECT @_split_column_variable_range_end_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_3\', QUOTE((SELECT @_split_column_variable_range_end_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_4\', QUOTE((SELECT @_split_column_variable_range_end_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_5\', QUOTE((SELECT @_split_column_variable_range_end_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_6\', QUOTE((SELECT @_split_column_variable_range_end_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_7\', QUOTE((SELECT @_split_column_variable_range_end_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_8\', QUOTE((SELECT @_split_column_variable_range_end_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_9\', QUOTE((SELECT @_split_column_variable_range_end_9)));\n  \n  set @query_script_split_range_start_snapshot := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_range_start_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_range_start_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_range_start_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_range_start_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_range_start_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_range_start_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_range_start_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_range_start_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_range_start_9)), \'\')\n  ));\n  set @query_script_split_range_end_snapshot := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_range_end_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_range_end_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_range_end_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_range_end_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_range_end_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_range_end_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_range_end_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_range_end_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_range_end_9)), \'\')\n  ));\nEND','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','','utf8','utf8_general_ci','utf8_general_ci','BEGIN\n  declare columns_count tinyint unsigned default _split_get_columns_count();\n\n  set @query_script_split_comparison_clause := comparison_clause;\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_1\', QUOTE((SELECT @_split_column_variable_range_start_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_2\', QUOTE((SELECT @_split_column_variable_range_start_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_3\', QUOTE((SELECT @_split_column_variable_range_start_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_4\', QUOTE((SELECT @_split_column_variable_range_start_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_5\', QUOTE((SELECT @_split_column_variable_range_start_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_6\', QUOTE((SELECT @_split_column_variable_range_start_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_7\', QUOTE((SELECT @_split_column_variable_range_start_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_8\', QUOTE((SELECT @_split_column_variable_range_start_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_start_9\', QUOTE((SELECT @_split_column_variable_range_start_9)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_1\', QUOTE((SELECT @_split_column_variable_range_end_1)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_2\', QUOTE((SELECT @_split_column_variable_range_end_2)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_3\', QUOTE((SELECT @_split_column_variable_range_end_3)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_4\', QUOTE((SELECT @_split_column_variable_range_end_4)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_5\', QUOTE((SELECT @_split_column_variable_range_end_5)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_6\', QUOTE((SELECT @_split_column_variable_range_end_6)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_7\', QUOTE((SELECT @_split_column_variable_range_end_7)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_8\', QUOTE((SELECT @_split_column_variable_range_end_8)));\n  set @query_script_split_comparison_clause := REPLACE(@query_script_split_comparison_clause, \'@_split_column_variable_range_end_9\', QUOTE((SELECT @_split_column_variable_range_end_9)));\n  \n  set @query_script_split_range_start_snapshot := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_range_start_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_range_start_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_range_start_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_range_start_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_range_start_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_range_start_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_range_start_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_range_start_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_range_start_9)), \'\')\n  ));\n  set @query_script_split_range_end_snapshot := TRIM(TRAILING \',\' FROM CONCAT_WS(\',\',\n  	IF(columns_count >= 1, QUOTE((SELECT @_split_column_variable_range_end_1)), \'\'),\n  	IF(columns_count >= 2, QUOTE((SELECT @_split_column_variable_range_end_2)), \'\'),\n  	IF(columns_count >= 3, QUOTE((SELECT @_split_column_variable_range_end_3)), \'\'),\n  	IF(columns_count >= 4, QUOTE((SELECT @_split_column_variable_range_end_4)), \'\'),\n  	IF(columns_count >= 5, QUOTE((SELECT @_split_column_variable_range_end_5)), \'\'),\n  	IF(columns_count >= 6, QUOTE((SELECT @_split_column_variable_range_end_6)), \'\'),\n  	IF(columns_count >= 7, QUOTE((SELECT @_split_column_variable_range_end_7)), \'\'),\n  	IF(columns_count >= 8, QUOTE((SELECT @_split_column_variable_range_end_8)), \'\'),\n  	IF(columns_count >= 9, QUOTE((SELECT @_split_column_variable_range_end_9)), \'\')\n  ));\nEND'),('common_schema','benford_correlation','PROCEDURE','benford_correlation','SQL','READS_SQL_DATA','NO','INVOKER','\n  in p_sql    text    \n, in p_silent bool    \n','','main_body: begin\n  declare benford_query text;\n  declare v_colcount int unsigned;\n  declare v_pair text;\n  declare v_pair_count, v_x, v_y int unsigned;\n  declare v_pair_counter int unsigned;\n  \n  \n  call _wrap_select_list_columns(p_sql, 0, @common_schema_error);\n  if @common_schema_error is not null then\n    call throw(\'benford_correlation cannot parse SELECT query\');\n  end if;\n  set v_colcount := @_wrap_select_num_original_columns;\n\n  set benford_query := CONCAT(\'\n    SELECT \n      leading_digits, IFNULL(cnt, 0), probability \n    FROM \n      benford_values\n      LEFT JOIN (\n        SELECT \n          LEFT(col1, 2) as data_digits, COUNT(*) AS cnt \n        FROM (\',\n          p_sql, \'\n          ) data_query \n        WHERE \n          LEFT(col1, 2) >= 10 \n        GROUP BY 1\n      ) data_aggregated ON (leading_digits = data_digits)\n    ORDER BY \n      leading_digits\'\n  );\n  call pearson_r(benford_query, \'2,3\', p_silent);\nend main_body','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Calculate data correlation by Benford\'s law','utf8','utf8_general_ci','utf8_general_ci','main_body: begin\n  declare benford_query text;\n  declare v_colcount int unsigned;\n  declare v_pair text;\n  declare v_pair_count, v_x, v_y int unsigned;\n  declare v_pair_counter int unsigned;\n  \n  \n  call _wrap_select_list_columns(p_sql, 0, @common_schema_error);\n  if @common_schema_error is not null then\n    call throw(\'benford_correlation cannot parse SELECT query\');\n  end if;\n  set v_colcount := @_wrap_select_num_original_columns;\n\n  set benford_query := CONCAT(\'\n    SELECT \n      leading_digits, IFNULL(cnt, 0), probability \n    FROM \n      benford_values\n      LEFT JOIN (\n        SELECT \n          LEFT(col1, 2) as data_digits, COUNT(*) AS cnt \n        FROM (\',\n          p_sql, \'\n          ) data_query \n        WHERE \n          LEFT(col1, 2) >= 10 \n        GROUP BY 1\n      ) data_aggregated ON (leading_digits = data_digits)\n    ORDER BY \n      leading_digits\'\n  );\n  call pearson_r(benford_query, \'2,3\', p_silent);\nend main_body'),('common_schema','pearson_r','PROCEDURE','pearson_r','SQL','READS_SQL_DATA','NO','INVOKER','\n  in p_sql    text    \n, in p_pairs  text    \n, in p_silent bool    \n','','pearson_samp: begin\n  declare v_sql text;\n  declare v_colcount int unsigned;\n  declare v_pair text;\n  declare v_pair_count, v_x, v_y int unsigned;\n  declare v_pair_counter int unsigned;\n  \n  \n  call _wrap_select_list_columns(p_sql, 0, @common_schema_error);\n  if @common_schema_error is not null then\n    call throw(\'pearson_r cannot parse SELECT query\');\n  end if;\n  set v_colcount := @_wrap_select_num_original_columns;\n  \n  if IFNULL(p_pairs, \'\') = \'\' and v_colcount = 2 then\n  	set p_pairs := \'1,2\';\n  end if;\n\n  \n  drop temporary table if exists _pearson_r_columns;\n  create temporary table _pearson_r_columns (\n    position    int unsigned  not null\n  , expression  text          not null\n  , alias       varchar(255)\n  );\n  insert into\n    _pearson_r_columns (\n      position\n    , expression\n    , alias\n    )\n    select\n      n, CONCAT(\'col\', n), NULL\n    from \n      numbers\n    where \n      n between 1 and v_colcount\n    ;\n\n  \n  drop temporary table if exists _pearson_r_pairs;\n  create temporary table _pearson_r_pairs (\n    position    int unsigned  not null\n  , x           int unsigned  not null\n  , y           int unsigned  not null\n  );\n\n  \n  set p_pairs := TRIM(trailing \';\' from p_pairs);\n  if not p_pairs rlike \'^[0-9]+,[0-9]+(;[0-9]+,[0-9]+)*$\' then\n    call throw(\'p_pairs input invalid format\');\n  end if;\n  set v_pair_count := get_num_tokens(p_pairs, \';\');\n  set v_pair_counter := 1;\n  while (v_pair_counter <= v_pair_count) do\n    set v_pair := split_token(p_pairs, \';\', v_pair_counter);\n    set v_x := cast(substring_index(v_pair, \',\', 1) as unsigned);\n    if v_x not between 1 and v_colcount then\n      call throw(concat(\'pearson_r X column overflow: \', v_x, \'. Range is 1-\', v_colcount));\n    end if;\n\n    set v_y := cast(substring_index(v_pair, \',\', -1) as unsigned);\n    if v_y not between 1 and v_colcount then\n      call throw(concat(\'pearson_r Y column overflow: \', v_y, \'. Range is 1-\', v_colcount));\n    end if;\n\n    insert \n      into _pearson_r_pairs (position, x, y)\n      values (v_pair_counter, v_x, v_y)\n    ;\n    set v_pair_counter := v_pair_counter + 1;\n  end while;\n\n  \n  begin\n    declare v_select1, v_select2 text;\n    declare v_into text default \'\';\n    declare v_expression1, v_expression2 text;\n    declare v_position1, v_position2, v_position int unsigned;\n    declare v_done bool default false;\n    declare csr_pairs cursor for\n      select      *\n      from        _pearson_r_pairs\n    ;\n    declare csr_columns cursor for\n      select      distinct\n                  _pearson_r_columns.position\n      ,            _pearson_r_columns.expression\n      from         _pearson_r_columns\n      inner join  _pearson_r_pairs\n      on          _pearson_r_columns.position = _pearson_r_pairs.x\n      or          _pearson_r_columns.position = _pearson_r_pairs.y\n      ;\n    declare continue handler for not found\n      set v_done = true;\n\n    open csr_columns;\n    csr_columns: loop\n      fetch csr_columns\n      into v_position, v_expression1\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_columns;\n        leave csr_columns;\n      end if;\n\n      set     v_select1 = concat(\n                if (v_select1 is null, \'\', concat(v_select1, \'\\n,\'))\n              ,  \'avg(\', v_expression1, \') AS avg\', v_position\n              , \',stddev_samp(\', v_expression1, \') AS stddev_samp\', v_position\n              )\n      ;\n    end loop;\n\n    open csr_pairs;\n    csr_pairs: loop\n      fetch csr_pairs\n      into  v_position\n      ,     v_position1\n      ,     v_position2\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_pairs;\n        leave csr_pairs;\n      end if;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression1\n      from    _pearson_r_columns\n      where   position = v_position1;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression2\n      from    _pearson_r_columns\n      where   position = v_position2;\n\n      set     v_select1 = concat(\n                v_select1\n              , \'\\n,sum(\'\n              ,    v_expression1, \' is not null\'\n              ,    \' and \'\n              ,    v_expression2, \' is not null\'\n              , \') AS count\', v_position\n              , \',sum(\'\n              ,    v_expression1\n              ,    \' * \'\n              ,    v_expression2\n              , \') AS sum\', v_position\n              )\n      ,       v_select2 = concat(\n                if (v_select2 is null, \'\', concat(v_select2, \'\\n,\'))\n              , \'(@pearson_r_\', v_position,\' := \' \n              , \'(sum\', v_position, \' - count\', v_position, \' * avg\', v_position1, \' * avg\', v_position2, \')\'\n              , \'/\'\n              , \'((count\', v_position, \' - 1) * stddev_samp\', v_position1, \' * stddev_samp\', v_position2, \')\'\n              , \') AS pearson_r_\', v_position\n              )\n      ;\n      if p_silent then\n        set v_into =  concat(\n          \'\\n\', if (v_into = \'\', \'INTO \', concat(v_into, \',\'))\n        , \'@pearson_r_\', v_position\n        );\n      end if;\n    end loop;\n\n    set v_sql = concat(\n      \'SELECT \', v_select2\n    , v_into\n    , \'\\n FROM (\'\n    , \'\\n SELECT \', v_select1\n    , \'\\n FROM (\', p_sql, \') as original_query\'\n    , \') as pearson_r\'\n    );\n  end;\n  \n  call exec(v_sql);\n\nend pearson_samp','root@%','2013-01-10 03:06:14','2013-01-10 03:06:14','','Calculate Pearson\'s product-moment correlation coefficient','utf8','utf8_general_ci','utf8_general_ci','pearson_samp: begin\n  declare v_sql text;\n  declare v_colcount int unsigned;\n  declare v_pair text;\n  declare v_pair_count, v_x, v_y int unsigned;\n  declare v_pair_counter int unsigned;\n  \n  \n  call _wrap_select_list_columns(p_sql, 0, @common_schema_error);\n  if @common_schema_error is not null then\n    call throw(\'pearson_r cannot parse SELECT query\');\n  end if;\n  set v_colcount := @_wrap_select_num_original_columns;\n  \n  if IFNULL(p_pairs, \'\') = \'\' and v_colcount = 2 then\n  	set p_pairs := \'1,2\';\n  end if;\n\n  \n  drop temporary table if exists _pearson_r_columns;\n  create temporary table _pearson_r_columns (\n    position    int unsigned  not null\n  , expression  text          not null\n  , alias       varchar(255)\n  );\n  insert into\n    _pearson_r_columns (\n      position\n    , expression\n    , alias\n    )\n    select\n      n, CONCAT(\'col\', n), NULL\n    from \n      numbers\n    where \n      n between 1 and v_colcount\n    ;\n\n  \n  drop temporary table if exists _pearson_r_pairs;\n  create temporary table _pearson_r_pairs (\n    position    int unsigned  not null\n  , x           int unsigned  not null\n  , y           int unsigned  not null\n  );\n\n  \n  set p_pairs := TRIM(trailing \';\' from p_pairs);\n  if not p_pairs rlike \'^[0-9]+,[0-9]+(;[0-9]+,[0-9]+)*$\' then\n    call throw(\'p_pairs input invalid format\');\n  end if;\n  set v_pair_count := get_num_tokens(p_pairs, \';\');\n  set v_pair_counter := 1;\n  while (v_pair_counter <= v_pair_count) do\n    set v_pair := split_token(p_pairs, \';\', v_pair_counter);\n    set v_x := cast(substring_index(v_pair, \',\', 1) as unsigned);\n    if v_x not between 1 and v_colcount then\n      call throw(concat(\'pearson_r X column overflow: \', v_x, \'. Range is 1-\', v_colcount));\n    end if;\n\n    set v_y := cast(substring_index(v_pair, \',\', -1) as unsigned);\n    if v_y not between 1 and v_colcount then\n      call throw(concat(\'pearson_r Y column overflow: \', v_y, \'. Range is 1-\', v_colcount));\n    end if;\n\n    insert \n      into _pearson_r_pairs (position, x, y)\n      values (v_pair_counter, v_x, v_y)\n    ;\n    set v_pair_counter := v_pair_counter + 1;\n  end while;\n\n  \n  begin\n    declare v_select1, v_select2 text;\n    declare v_into text default \'\';\n    declare v_expression1, v_expression2 text;\n    declare v_position1, v_position2, v_position int unsigned;\n    declare v_done bool default false;\n    declare csr_pairs cursor for\n      select      *\n      from        _pearson_r_pairs\n    ;\n    declare csr_columns cursor for\n      select      distinct\n                  _pearson_r_columns.position\n      ,            _pearson_r_columns.expression\n      from         _pearson_r_columns\n      inner join  _pearson_r_pairs\n      on          _pearson_r_columns.position = _pearson_r_pairs.x\n      or          _pearson_r_columns.position = _pearson_r_pairs.y\n      ;\n    declare continue handler for not found\n      set v_done = true;\n\n    open csr_columns;\n    csr_columns: loop\n      fetch csr_columns\n      into v_position, v_expression1\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_columns;\n        leave csr_columns;\n      end if;\n\n      set     v_select1 = concat(\n                if (v_select1 is null, \'\', concat(v_select1, \'\n,\'))\n              ,  \'avg(\', v_expression1, \') AS avg\', v_position\n              , \',stddev_samp(\', v_expression1, \') AS stddev_samp\', v_position\n              )\n      ;\n    end loop;\n\n    open csr_pairs;\n    csr_pairs: loop\n      fetch csr_pairs\n      into  v_position\n      ,     v_position1\n      ,     v_position2\n      ;\n      if v_done then\n        set v_done = false;\n        close csr_pairs;\n        leave csr_pairs;\n      end if;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression1\n      from    _pearson_r_columns\n      where   position = v_position1;\n\n      select  concat(\'(\', expression, \')\')\n      into    v_expression2\n      from    _pearson_r_columns\n      where   position = v_position2;\n\n      set     v_select1 = concat(\n                v_select1\n              , \'\n,sum(\'\n              ,    v_expression1, \' is not null\'\n              ,    \' and \'\n              ,    v_expression2, \' is not null\'\n              , \') AS count\', v_position\n              , \',sum(\'\n              ,    v_expression1\n              ,    \' * \'\n              ,    v_expression2\n              , \') AS sum\', v_position\n              )\n      ,       v_select2 = concat(\n                if (v_select2 is null, \'\', concat(v_select2, \'\n,\'))\n              , \'(@pearson_r_\', v_position,\' := \' \n              , \'(sum\', v_position, \' - count\', v_position, \' * avg\', v_position1, \' * avg\', v_position2, \')\'\n              , \'/\'\n              , \'((count\', v_position, \' - 1) * stddev_samp\', v_position1, \' * stddev_samp\', v_position2, \')\'\n              , \') AS pearson_r_\', v_position\n              )\n      ;\n      if p_silent then\n        set v_into =  concat(\n          \'\n\', if (v_into = \'\', \'INTO \', concat(v_into, \',\'))\n        , \'@pearson_r_\', v_position\n        );\n      end if;\n    end loop;\n\n    set v_sql = concat(\n      \'SELECT \', v_select2\n    , v_into\n    , \'\n FROM (\'\n    , \'\n SELECT \', v_select1\n    , \'\n FROM (\', p_sql, \') as original_query\'\n    , \') as pearson_r\'\n    );\n  end;\n  \n  call exec(v_sql);\n\nend pearson_samp');
/*!40000 ALTER TABLE `proc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `procs_priv`
--

DROP TABLE IF EXISTS `procs_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `procs_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Routine_name` char(64) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Routine_type` enum('FUNCTION','PROCEDURE') COLLATE utf8_bin NOT NULL,
  `Grantor` char(77) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proc_priv` set('Execute','Alter Routine','Grant') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Host`,`Db`,`User`,`Routine_name`,`Routine_type`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Procedure privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `procs_priv`
--

LOCK TABLES `procs_priv` WRITE;
/*!40000 ALTER TABLE `procs_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `procs_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proxies_priv`
--

DROP TABLE IF EXISTS `proxies_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proxies_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proxied_host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proxied_user` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `With_grant` tinyint(1) NOT NULL DEFAULT '0',
  `Grantor` char(77) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Host`,`User`,`Proxied_host`,`Proxied_user`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='User proxy privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proxies_priv`
--

LOCK TABLES `proxies_priv` WRITE;
/*!40000 ALTER TABLE `proxies_priv` DISABLE KEYS */;
INSERT INTO `proxies_priv` VALUES ('localhost','root','','',1,'','2012-01-31 08:29:30'),('36QV4R1','root','','',1,'','2012-01-31 08:29:30');
/*!40000 ALTER TABLE `proxies_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `servers`
--

DROP TABLE IF EXISTS `servers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `servers` (
  `Server_name` char(64) NOT NULL DEFAULT '',
  `Host` char(64) NOT NULL DEFAULT '',
  `Db` char(64) NOT NULL DEFAULT '',
  `Username` char(64) NOT NULL DEFAULT '',
  `Password` char(64) NOT NULL DEFAULT '',
  `Port` int(4) NOT NULL DEFAULT '0',
  `Socket` char(64) NOT NULL DEFAULT '',
  `Wrapper` char(64) NOT NULL DEFAULT '',
  `Owner` char(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`Server_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='MySQL Foreign Servers table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `servers`
--

LOCK TABLES `servers` WRITE;
/*!40000 ALTER TABLE `servers` DISABLE KEYS */;
/*!40000 ALTER TABLE `servers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slave_master_info`
--

DROP TABLE IF EXISTS `slave_master_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slave_master_info` (
  `Number_of_lines` int(10) unsigned NOT NULL COMMENT 'Number of lines in the file.',
  `Master_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The name of the master binary log currently being read from the master.',
  `Master_log_pos` bigint(20) unsigned NOT NULL COMMENT 'The master log position of the last read event.',
  `Host` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'The host name of the master.',
  `User_name` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The user name used to connect to the master.',
  `User_password` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The password used to connect to the master.',
  `Port` int(10) unsigned NOT NULL COMMENT 'The network port used to connect to the master.',
  `Connect_retry` int(10) unsigned NOT NULL COMMENT 'The period (in seconds) that the slave will wait before trying to reconnect to the master.',
  `Enabled_ssl` tinyint(1) NOT NULL COMMENT 'Indicates whether the server supports SSL connections.',
  `Ssl_ca` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file used for the Certificate Authority (CA) certificate.',
  `Ssl_capath` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The path to the Certificate Authority (CA) certificates.',
  `Ssl_cert` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The name of the SSL certificate file.',
  `Ssl_cipher` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The name of the cipher in use for the SSL connection.',
  `Ssl_key` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The name of the SSL key file.',
  `Ssl_verify_server_cert` tinyint(1) NOT NULL COMMENT 'Whether to verify the server certificate.',
  `Heartbeat` float NOT NULL,
  `Bind` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'Displays which interface is employed when connecting to the MySQL server',
  `Ignored_server_ids` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The number of server IDs to be ignored, followed by the actual server IDs',
  `Uuid` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The master server uuid.',
  `Retry_count` bigint(20) unsigned NOT NULL COMMENT 'Number of reconnect attempts, to the master, before giving up.',
  `Ssl_crl` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The file used for the Certificate Revocation List (CRL)',
  `Ssl_crlpath` text CHARACTER SET utf8 COLLATE utf8_bin COMMENT 'The path used for Certificate Revocation List (CRL) files',
  `Enabled_auto_position` tinyint(1) NOT NULL COMMENT 'Indicates whether GTIDs will be used to retrieve events from the master.',
  PRIMARY KEY (`Host`,`Port`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 STATS_PERSISTENT=0 COMMENT='Master Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slave_master_info`
--

LOCK TABLES `slave_master_info` WRITE;
/*!40000 ALTER TABLE `slave_master_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `slave_master_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slave_relay_log_info`
--

DROP TABLE IF EXISTS `slave_relay_log_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slave_relay_log_info` (
  `Number_of_lines` int(10) unsigned NOT NULL COMMENT 'Number of lines in the file or rows in the table. Used to version table definitions.',
  `Relay_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The name of the current relay log file.',
  `Relay_log_pos` bigint(20) unsigned NOT NULL COMMENT 'The relay log position of the last executed event.',
  `Master_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The name of the master binary log file from which the events in the relay log file were read.',
  `Master_log_pos` bigint(20) unsigned NOT NULL COMMENT 'The master log position of the last executed event.',
  `Sql_delay` int(11) NOT NULL COMMENT 'The number of seconds that the slave must lag behind the master.',
  `Number_of_workers` int(10) unsigned NOT NULL,
  `Id` int(10) unsigned NOT NULL COMMENT 'Internal Id that uniquely identifies this record.',
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 STATS_PERSISTENT=0 COMMENT='Relay Log Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slave_relay_log_info`
--

LOCK TABLES `slave_relay_log_info` WRITE;
/*!40000 ALTER TABLE `slave_relay_log_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `slave_relay_log_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slave_worker_info`
--

DROP TABLE IF EXISTS `slave_worker_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slave_worker_info` (
  `Id` int(10) unsigned NOT NULL,
  `Relay_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `Relay_log_pos` bigint(20) unsigned NOT NULL,
  `Master_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `Master_log_pos` bigint(20) unsigned NOT NULL,
  `Checkpoint_relay_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `Checkpoint_relay_log_pos` bigint(20) unsigned NOT NULL,
  `Checkpoint_master_log_name` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `Checkpoint_master_log_pos` bigint(20) unsigned NOT NULL,
  `Checkpoint_seqno` int(10) unsigned NOT NULL,
  `Checkpoint_group_size` int(10) unsigned NOT NULL,
  `Checkpoint_group_bitmap` blob NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 STATS_PERSISTENT=0 COMMENT='Worker Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slave_worker_info`
--

LOCK TABLES `slave_worker_info` WRITE;
/*!40000 ALTER TABLE `slave_worker_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `slave_worker_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tables_priv`
--

DROP TABLE IF EXISTS `tables_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tables_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Grantor` char(77) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Table_priv` set('Select','Insert','Update','Delete','Create','Drop','Grant','References','Index','Alter','Create View','Show view','Trigger') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`Db`,`User`,`Table_name`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Table privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tables_priv`
--

LOCK TABLES `tables_priv` WRITE;
/*!40000 ALTER TABLE `tables_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `tables_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone`
--

DROP TABLE IF EXISTS `time_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone` (
  `Time_zone_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `Use_leap_seconds` enum('Y','N') NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Time_zone_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone`
--

LOCK TABLES `time_zone` WRITE;
/*!40000 ALTER TABLE `time_zone` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_leap_second`
--

DROP TABLE IF EXISTS `time_zone_leap_second`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_leap_second` (
  `Transition_time` bigint(20) NOT NULL,
  `Correction` int(11) NOT NULL,
  PRIMARY KEY (`Transition_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Leap seconds information for time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_leap_second`
--

LOCK TABLES `time_zone_leap_second` WRITE;
/*!40000 ALTER TABLE `time_zone_leap_second` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_leap_second` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_name`
--

DROP TABLE IF EXISTS `time_zone_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_name` (
  `Name` char(64) NOT NULL,
  `Time_zone_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone names';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_name`
--

LOCK TABLES `time_zone_name` WRITE;
/*!40000 ALTER TABLE `time_zone_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition`
--

DROP TABLE IF EXISTS `time_zone_transition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_transition` (
  `Time_zone_id` int(10) unsigned NOT NULL,
  `Transition_time` bigint(20) NOT NULL,
  `Transition_type_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`Time_zone_id`,`Transition_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone transitions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition`
--

LOCK TABLES `time_zone_transition` WRITE;
/*!40000 ALTER TABLE `time_zone_transition` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_transition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition_type`
--

DROP TABLE IF EXISTS `time_zone_transition_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_transition_type` (
  `Time_zone_id` int(10) unsigned NOT NULL,
  `Transition_type_id` int(10) unsigned NOT NULL,
  `Offset` int(11) NOT NULL DEFAULT '0',
  `Is_DST` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Abbreviation` char(8) NOT NULL DEFAULT '',
  PRIMARY KEY (`Time_zone_id`,`Transition_type_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone transition types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition_type`
--

LOCK TABLES `time_zone_transition_type` WRITE;
/*!40000 ALTER TABLE `time_zone_transition_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_transition_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Password` char(41) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Reload_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Shutdown_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Process_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `File_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_db_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Super_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Repl_slave_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Repl_client_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_user_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tablespace_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `ssl_type` enum('','ANY','X509','SPECIFIED') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `ssl_cipher` blob NOT NULL,
  `x509_issuer` blob NOT NULL,
  `x509_subject` blob NOT NULL,
  `max_questions` int(11) unsigned NOT NULL DEFAULT '0',
  `max_updates` int(11) unsigned NOT NULL DEFAULT '0',
  `max_connections` int(11) unsigned NOT NULL DEFAULT '0',
  `max_user_connections` int(11) unsigned NOT NULL DEFAULT '0',
  `plugin` char(64) COLLATE utf8_bin DEFAULT '',
  `authentication_string` text COLLATE utf8_bin,
  PRIMARY KEY (`Host`,`User`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Users and global privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES ('%','root','*E74858DB86EBA20BC33D0AECAE8A8108C56B17FA','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0,'',''),('localhost','pentaho_user','*2470C0C06DEE42FD1618BB99005ADCA2EC9D1E19','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','pentaho_user','*2470C0C06DEE42FD1618BB99005ADCA2EC9D1E19','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','hibuser','*2470C0C06DEE42FD1618BB99005ADCA2EC9D1E19','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('localhost','hibuser','*2470C0C06DEE42FD1618BB99005ADCA2EC9D1E19','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','foodmart','*3C97190CFF7603229BDADEFD28A9692B770953FA','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','sakila','*FDAF706717E70DB8DDAD0C5214B13770E1A80B0E','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','sakila_dwh','*21E25F94BF8090DB0D04FB8C00604EA966FF5A5E','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','pgn','*E1EAC76287D0F6CDF9C47EA1EC8A68FA1A367C07','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','chess','*DDFADF85C777373B77E61EE12066EEB7A8274ED8','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL),('%','chess_dwh','*0F9751BD9362B8B5B685EBF17D06630B6A3EDECB','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'',NULL);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping events for database 'mysql'
--

--
-- Dumping routines for database 'mysql'
--
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-02-14 23:32:02
